/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "Oberon.h"
#include "PanelElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"




export void AreaButtonElems_DrawPanel (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER color, BOOLEAN pressed, Display_Frame f);
export void AreaButtonElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void AreaButtonElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void AreaButtonElems_Init (PanelElems_Panel p);
export void AreaButtonElems_Insert (void);
export void AreaButtonElems_New (void);


void AreaButtonElems_DrawPanel (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER color, BOOLEAN pressed, Display_Frame f)
{
	INTEGER h = 0, w = 0, X = 0, Y = 0, W = 0, H = 0;
	h = GUtils_Unit(p->H, 1);
	w = GUtils_Unit(p->W, 1);
	GUtils_Area(f, color, 12, x, y, w, h, GUtils_Unit(p->border, 0), 1, pressed);
	if (f != NIL) {
		PanelElems_TruncateFrame(__GUARDP(f, PanelElems_FrameDesc, 1), &X, &Y, &W, &H);
	}
	PanelElems_DrawContents(p, f, x, y);
	if (f != NIL) {
		PanelElems_SetFrameCoords(__GUARDP(f, PanelElems_FrameDesc, 1), X, Y, W, H);
	}
}

void AreaButtonElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	SET keysum = 0;
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	Elems_ExecMsg exec = {0};
	BOOLEAN pressed = 0;
	INTEGER X = 0, Y = 0;
	if (__ISP(f, PanelElems_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*(PanelElems_Frame*)&f)->p->locked) {
				if ((*msg__).id == 1 && (*msg__).keys == 0x02) {
					pressed = 0;
					keysum = (*msg__).keys;
					Elems_GetLook((void*)(*(PanelElems_Frame*)&f)->p, &fnt, &col);
					do {
						Input_Mouse(&(*msg__).keys, &X, &Y);
						keysum = keysum | (*msg__).keys;
						Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
						if (((X < (*(PanelElems_Frame*)&f)->X || X > (*(PanelElems_Frame*)&f)->X + (*(PanelElems_Frame*)&f)->W) || Y < (*(PanelElems_Frame*)&f)->Y) || Y > (*(PanelElems_Frame*)&f)->Y + (*(PanelElems_Frame*)&f)->H) {
							if (pressed) {
								pressed = 0;
								AreaButtonElems_DrawPanel((*(PanelElems_Frame*)&f)->p, (*(PanelElems_Frame*)&f)->x, (*(PanelElems_Frame*)&f)->y, col, 0, (void*)(*(PanelElems_Frame*)&f));
							}
						} else if (!pressed) {
							pressed = 1;
							AreaButtonElems_DrawPanel((*(PanelElems_Frame*)&f)->p, (*(PanelElems_Frame*)&f)->x, (*(PanelElems_Frame*)&f)->y, col, 1, (void*)(*(PanelElems_Frame*)&f));
						}
					} while (!((*msg__).keys == 0x0));
					AreaButtonElems_DrawPanel((*(PanelElems_Frame*)&f)->p, (*(PanelElems_Frame*)&f)->x, (*(PanelElems_Frame*)&f)->y, col, 0, (void*)(*(PanelElems_Frame*)&f));
					if (pressed && !__IN(0, keysum)) {
						exec.e = (Elems_Elem)(*(PanelElems_Frame*)&f)->p;
						exec.x = (*msg__).X;
						exec.y = (*msg__).Y;
						exec.unload = __IN(2, keysum);
						exec.f = (Display_Frame)(*(PanelElems_Frame*)&f);
						(*(*(PanelElems_Frame*)&f)->p->handle)((void*)(*(PanelElems_Frame*)&f)->p, (void*)&exec, Elems_ExecMsg__typ);
					}
				} else {
					PanelElems_FrameHandle((void*)(*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
				}
			} else {
				PanelElems_FrameHandle((void*)(*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else {
			PanelElems_FrameHandle((void*)(*(PanelElems_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void AreaButtonElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	Elems_ExecMsg exec = {0};
	if (__ISP(p, PanelElems_PanelDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				(*(PanelElems_Panel*)&p)->sel = NIL;
				(*msg__).elemFrame = PanelElems_OpenFrame((*(PanelElems_Panel*)&p), (*msg__).frame, AreaButtonElems_FrameHandle, (*msg__).X0, (*msg__).Y0, (int)__DIV((*(PanelElems_Panel*)&p)->W, (LONGINT)TextFrames_Unit), (int)__DIV((*(PanelElems_Panel*)&p)->H, (LONGINT)TextFrames_Unit));
				AreaButtonElems_DrawPanel((*(PanelElems_Panel*)&p), (*msg__).X0, (*msg__).Y0, (*msg__).col, 0, (*msg__).elemFrame);
			}
		} else if (__IS(msg__typ, Elems_ExecMsg, 1)) {
			Elems_ExecMsg *msg__ = (void*)msg;
			if ((*msg__).x >= 0) {
				Elems_Handle((void*)(*(PanelElems_Panel*)&p), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("AreaButtonElems", (*msg__).mod, 16);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			if ((*msg__).frame == NIL) {
				exec.e = (Elems_Elem)(*(PanelElems_Panel*)&p);
				exec.x = (*msg__).X;
				exec.y = (*msg__).Y;
				exec.unload = __IN(2, (*msg__).keys);
				exec.f = NIL;
				(*(*(PanelElems_Panel*)&p)->handle)((void*)(*(PanelElems_Panel*)&p), (void*)&exec, Elems_ExecMsg__typ);
			} else {
				PanelElems_Handle((void*)(*(PanelElems_Panel*)&p), (void*)&*msg__, msg__typ);
			}
		} else {
			PanelElems_Handle((void*)(*(PanelElems_Panel*)&p), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void AreaButtonElems_Init (PanelElems_Panel p)
{
	p->handle = AreaButtonElems_Handle;
	p->border = 1;
	p->W = 100 * TextFrames_Unit;
	p->H = 50 * TextFrames_Unit;
}

void AreaButtonElems_New (void)
{
	PanelElems_New();
	AreaButtonElems_Init(__GUARDP(Texts_new, PanelElems_PanelDesc, 3));
}

void AreaButtonElems_Insert (void)
{
	TextFrames_InsertElemMsg m = {0};
	LONGINT pos = 0;
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	AreaButtonElems_New();
	Elems_GetPar(__GUARDP(Texts_new, Elems_ElemDesc, 2), &s, Texts_Scanner__typ);
	m.e = Texts_new;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
	t = Texts_ElemBase(Texts_new);
	if (t != NIL) {
		pos = Texts_ElemPos(m.e);
		Texts_ChangeLooks(t, pos, pos + 1, 0x02, Fonts_Default, 13, 0);
	}
}


export void *AreaButtonElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(PanelElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(AreaButtonElems, 0);
	__REGCMD("Insert", AreaButtonElems_Insert);
	__REGCMD("New", AreaButtonElems_New);
/* BEGIN */
	__ENDMOD;
}
