/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct AsciiCoder_NameDesc *AsciiCoder_NameList;

typedef
	struct AsciiCoder_NameDesc {
		AsciiCoder_NameList next;
		CHAR (*name)[64];
	} AsciiCoder_NameDesc;


static Texts_Writer AsciiCoder_w;
static CHAR AsciiCoder_table[16384];

export LONGINT *AsciiCoder_NameDesc__typ;

export void AsciiCoder_Code (Files_File from, Texts_Text to);
export void AsciiCoder_CodeFiles (void);
export void AsciiCoder_CodeText (void);
export void AsciiCoder_Compress (Files_File src, Files_File dest);
export void AsciiCoder_Decode (Texts_Text from, LONGINT *pos, Files_File to, BOOLEAN *ok);
export void AsciiCoder_DecodeFiles (void);
export void AsciiCoder_DecodeText (void);
export void AsciiCoder_Expand (Files_File src, Files_File dest);
static void AsciiCoder_OpenViewer (CHAR *name, LONGINT name__len, Texts_Text text);
static void AsciiCoder_ReadFileNames (Texts_Text t, LONGINT beg, LONGINT end, AsciiCoder_NameList *names, LONGINT *pos);


void AsciiCoder_Compress (Files_File src, Files_File dest)
{
	Files_Rider from = {0}, to = {0};
	LONGINT hash = 0, byte = 0, bit = 0, i = 0;
	CHAR ch = 0;
	i = 0;
	do {
		AsciiCoder_table[__X(i, 16384)] = 0x00;
		i += 1;
	} while (!(i == 16384));
	Files_Set(&from, Files_Rider__typ, src, 0);
	Files_Set(&to, Files_Rider__typ, dest, 0);
	i = Files_Length(src);
	Files_WriteNum(&to, Files_Rider__typ, i);
	hash = 0;
	bit = 0;
	byte = 0;
	do {
		Files_Read(&from, Files_Rider__typ, (void*)&ch);
		if (AsciiCoder_table[__X(hash, 16384)] == ch) {
			bit += 1;
			if (bit == 8) {
				Files_Write(&to, Files_Rider__typ, (CHAR)byte);
				byte = 0;
				bit = 0;
			}
		} else {
			AsciiCoder_table[__X(hash, 16384)] = ch;
			byte += __ASH(1, bit);
			bit += 1;
			if (bit == 8) {
				Files_Write(&to, Files_Rider__typ, (CHAR)byte);
				Files_Write(&to, Files_Rider__typ, ch);
				byte = 0;
				bit = 0;
			} else {
				Files_Write(&to, Files_Rider__typ, (CHAR)(byte + __MASK(__ASH((LONGINT)ch, bit), -256)));
				byte = __ASHR(__ASH((LONGINT)ch, bit), 8);
			}
		}
		i -= 1;
		hash = __MASK(__ASHL(hash, 4) + (LONGINT)ch, -16384);
	} while (!(i == 0));
	if (bit != 0) {
		Files_Write(&to, Files_Rider__typ, (CHAR)byte);
	}
}

void AsciiCoder_Expand (Files_File src, Files_File dest)
{
	Files_Rider from = {0}, to = {0};
	LONGINT hash = 0, val = 0, byte = 0, bit = 0, i = 0;
	CHAR ch = 0;
	i = 0;
	do {
		AsciiCoder_table[__X(i, 16384)] = 0x00;
		i += 1;
	} while (!(i == 16384));
	Files_Set(&from, Files_Rider__typ, src, 0);
	Files_Set(&to, Files_Rider__typ, dest, 0);
	Files_ReadNum(&from, Files_Rider__typ, &i);
	Files_Read(&from, Files_Rider__typ, (void*)&ch);
	val = (int)ch;
	bit = 0;
	hash = 0;
	do {
		bit += 1;
		if (__ODD(val)) {
			Files_Read(&from, Files_Rider__typ, (void*)&ch);
			if (bit == 8) {
				byte = (int)ch;
			} else {
				byte = __ASHR(val, 1) + __MASK(__ASH((LONGINT)ch, 8 - bit), -256);
				val = __ASH((LONGINT)ch, -bit);
			}
			AsciiCoder_table[__X(hash, 16384)] = (CHAR)byte;
		} else {
			byte = (int)AsciiCoder_table[__X(hash, 16384)];
			val = __ASHR(val, 1);
		}
		hash = __MASK(__ASHL(hash, 4) + byte, -16384);
		Files_Write(&to, Files_Rider__typ, (CHAR)byte);
		i -= 1;
		if (bit == 8) {
			Files_Read(&from, Files_Rider__typ, (void*)&ch);
			val = (int)ch;
			bit = 0;
		}
	} while (!(i == 0));
}

void AsciiCoder_Code (Files_File from, Texts_Text to)
{
	Files_Rider r = {0};
	CHAR ch = 0;
	INTEGER byte = 0, rest = 0, div = 0, factor = 0, packs = 0;
	Files_Set(&r, Files_Rider__typ, from, 0);
	Files_Read(&r, Files_Rider__typ, (void*)&ch);
	byte = (int)ch;
	rest = 0;
	div = 64;
	factor = 1;
	packs = 0;
	while (!r.eof) {
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, (CHAR)((48 + rest) + (int)__MOD(byte, div) * factor));
		rest = __DIV(byte, div);
		if (div == 4) {
			Texts_Write(&AsciiCoder_w, Texts_Writer__typ, (CHAR)(48 + rest));
			rest = 0;
			div = 64;
			factor = 1;
			packs += 1;
			if (packs == 19) {
				Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
				packs = 0;
			}
		} else {
			factor = __ASHL(factor, 2);
			div = __ASHR(div, 2);
		}
		Files_Read(&r, Files_Rider__typ, (void*)&ch);
		byte = (int)ch;
	}
	if (div == 64) {
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, '#');
	} else if (div == 16) {
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, (CHAR)(48 + rest));
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, '$');
	} else if (div == 4) {
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, (CHAR)(48 + rest));
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, '%');
	}
	Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
	Texts_Append(to, AsciiCoder_w.buf);
}

void AsciiCoder_Decode (Texts_Text from, LONGINT *pos, Files_File to, BOOLEAN *ok)
{
	Texts_Reader r = {0};
	Files_Rider w = {0};
	INTEGER rest = 0, div = 0, factor = 0, byte = 0;
	CHAR ch = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, from, *pos);
	Files_Set(&w, Files_Rider__typ, to, 0);
	factor = 1;
	div = 256;
	do {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	} while (!(ch > ' ' || r.eot));
	while ((!r.eot && ch >= '0') && ch < 'p') {
		byte = (int)ch - 48;
		if (factor != 1) {
			Files_Write(&w, Files_Rider__typ, (CHAR)(rest + (int)__MOD(byte, div) * factor));
			rest = __DIV(byte, div);
			div = __ASHL(div, 2);
			factor = __ASHR(factor, 2);
		} else {
			rest = byte;
			div = 4;
			factor = 64;
		}
		do {
			Texts_Read(&r, Texts_Reader__typ, &ch);
		} while (!(ch > ' ' || r.eot));
	}
	byte = (int)ch - 35;
	*ok = (byte == 0 && div == 256 || byte == 1 && div == 16) || (byte == 2 && div == 64) && rest == 0;
	*pos = Texts_Pos(&r, Texts_Reader__typ);
}

static void AsciiCoder_OpenViewer (CHAR *name, LONGINT name__len, Texts_Text text)
{
	Viewers_Viewer v = NIL;
	Display_Frame f = NIL;
	INTEGER x = 0, y = 0;
	TextFrames_Frame m = NIL;
	Texts_Text mtext = NIL;
	Texts_Buffer buf = NIL;
	__DUP(name, name__len, CHAR);
	Oberon_AllocateUserViewer(Oberon_Par->vwr->X, &x, &y);
	f = (Display_Frame)TextFrames_NewText(text, 0);
	if (Files_Old((CHAR*)"Edit.Menu.Text", (LONGINT)15) == NIL) {
		m = TextFrames_NewMenu(name, name__len, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Search  Edit.Replace  Edit.Parcs  Edit.Store ", (LONGINT)91);
	} else {
		m = TextFrames_NewMenu(name, name__len, (CHAR*)"", (LONGINT)1);
		__NEW(mtext, Texts_TextDesc);
		Texts_Open(mtext, (CHAR*)"Edit.Menu.Text", (LONGINT)15);
		__NEW(buf, Texts_BufDesc);
		Texts_OpenBuf(buf);
		Texts_Save(mtext, 0, mtext->len, buf);
		Texts_Append(m->text, buf);
	}
	v = (Viewers_Viewer)MenuViewers_New((void*)m, f, TextFrames_menuH, x, y);
	__DEL(name);
}

static void AsciiCoder_ReadFileNames (Texts_Text t, LONGINT beg, LONGINT end, AsciiCoder_NameList *names, LONGINT *pos)
{
	AsciiCoder_NameList last = NIL, n = NIL;
	Texts_Scanner s = {0};
	__NEW(*names, AsciiCoder_NameDesc);
	last = *names;
	Texts_OpenScanner(&s, Texts_Scanner__typ, t, beg);
	*pos = beg;
	Texts_Scan(&s, Texts_Scanner__typ);
	while (*pos < end && (s.class == 2 || s.class == 1)) {
		__NEW(n, AsciiCoder_NameDesc);
		last->next = n;
		last = n;
		n->name = __NEWARR(NIL, 1, 1, 1, 0, 64);
		__COPY(s.s, *n->name, 64);
		*pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	last->next = NIL;
	*names = (*names)->next;
	*pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
}

void AsciiCoder_CodeFiles (void)
{
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	BOOLEAN compress = 0;
	AsciiCoder_NameList names = NIL, n = NIL;
	Files_File f = NIL, f1 = NIL;
	Texts_Text text = NIL;
	Texts_Scanner s = {0};
	pos = Oberon_Par->pos;
	compress = 0;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if ((s.line == 0 && s.class == 6) && s.c == '%') {
		compress = 1;
		pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	if ((s.line == 0 && s.class == 6) && s.c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			AsciiCoder_ReadFileNames(text, beg, end, &names, &time);
		} else {
			names = NIL;
		}
	} else {
		AsciiCoder_ReadFileNames(Oberon_Par->text, pos, Oberon_Par->text->len, &names, &time);
	}
	if (names != NIL) {
		n = names;
		text = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"AsciiCoder.CodeFiles", (LONGINT)21);
		Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
		do {
			f = Files_Old(*n->name, 64);
			Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, *n->name, 64);
			if (f == NIL) {
				Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
				n->name = NIL;
			} else {
				Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" coding", (LONGINT)8);
				Texts_Append(Oberon_Log, AsciiCoder_w.buf);
				if (compress) {
					f1 = Files_New((CHAR*)"", (LONGINT)1);
					AsciiCoder_Compress(f, f1);
					f = f1;
				}
				AsciiCoder_Code(f, text);
			}
			Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
			Texts_Append(Oberon_Log, AsciiCoder_w.buf);
			n = n->next;
		} while (!(n == NIL));
		Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"AsciiCoder.DecodeFiles ", (LONGINT)24);
		if (compress) {
			Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"% ", (LONGINT)3);
		}
		do {
			if (names->name != NIL) {
				Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, *names->name, 64);
				Texts_Write(&AsciiCoder_w, Texts_Writer__typ, ' ');
			}
			names = names->next;
		} while (!(names == NIL));
		Texts_Write(&AsciiCoder_w, Texts_Writer__typ, '~');
		Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
		Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
		Texts_Insert(text, 0, AsciiCoder_w.buf);
		Texts_WriteInt(&AsciiCoder_w, Texts_Writer__typ, text->len, 0);
		Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" characters", (LONGINT)12);
		Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
		Texts_Append(Oberon_Log, AsciiCoder_w.buf);
		AsciiCoder_OpenViewer((CHAR*)"AsciiCoder.CodeFiles", (LONGINT)21, text);
	}
}

void AsciiCoder_DecodeFiles (void)
{
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	INTEGER i = 0, res = 0;
	CHAR ch = 0;
	BOOLEAN ok = 0, compress = 0;
	Files_File f = NIL, f1 = NIL;
	Texts_Text text = NIL;
	Texts_Scanner s = {0};
	AsciiCoder_NameList names = NIL;
	CHAR bakname[256];
	text = Oberon_Par->text;
	pos = Oberon_Par->pos;
	compress = 0;
	Texts_OpenScanner(&s, Texts_Scanner__typ, text, pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if ((s.line == 0 && s.class == 6) && s.c == '%') {
		compress = 1;
		pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	if ((s.line == 0 && s.class == 6) && s.c == '@') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			AsciiCoder_ReadFileNames(text, beg, end, &names, &pos);
		} else {
			names = NIL;
		}
	} else {
		AsciiCoder_ReadFileNames(text, pos, text->len, &names, &pos);
	}
	Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"AsciiCoder.DecodeFiles", (LONGINT)23);
	Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
	ok = 1;
	while (names != NIL && ok) {
		f = Files_New(*names->name, 64);
		Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, *names->name, 64);
		Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" decoding", (LONGINT)10);
		Texts_Append(Oberon_Log, AsciiCoder_w.buf);
		i = 0;
		ch = (*names->name)[0];
		while (ch != 0x00) {
			bakname[__X(i, 256)] = ch;
			i += 1;
			ch = (*names->name)[__X(i, 64)];
		}
		bakname[__X(i, 256)] = '.';
		bakname[__X(i + 1, 256)] = 'B';
		bakname[__X(i + 2, 256)] = 'a';
		bakname[__X(i + 3, 256)] = 'k';
		bakname[__X(i + 4, 256)] = 0x00;
		Files_Rename(*names->name, 64, bakname, 256, &res);
		AsciiCoder_Decode(text, &pos, f, &ok);
		if (ok) {
			if (compress) {
				f1 = Files_New(*names->name, 64);
				AsciiCoder_Expand(f, f1);
				f = f1;
			}
			Files_Register(f);
		} else {
			Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" error.", (LONGINT)8);
		}
		Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
		Texts_Append(Oberon_Log, AsciiCoder_w.buf);
		names = names->next;
	}
}

void AsciiCoder_CodeText (void)
{
	LONGINT beg = 0, end = 0, time = 0;
	BOOLEAN compress = 0;
	Viewers_Viewer v = NIL;
	Files_File f = NIL, f1 = NIL;
	Files_Rider r = {0};
	Texts_Text t = NIL, text = NIL;
	Texts_Scanner s = {0};
	compress = 0;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if ((s.line == 0 && s.class == 6) && s.c == '%') {
		compress = 1;
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	if (s.line == 0 && s.class == 6) {
		t = NIL;
		if (s.c == '*') {
			v = Oberon_MarkedViewer();
			if (__ISP(v, MenuViewers_ViewerDesc, 2) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
				t = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1)->text;
			}
		} else if (s.c == '@') {
			Oberon_GetSelection(&text, &beg, &end, &time);
			if (time >= 0) {
				t = TextFrames_Text((CHAR*)"", (LONGINT)1);
				Texts_Save(text, beg, end, AsciiCoder_w.buf);
				Texts_Append(t, AsciiCoder_w.buf);
			}
		}
		if (t != NIL) {
			f = Files_New((CHAR*)"", (LONGINT)1);
			Files_Set(&r, Files_Rider__typ, f, 0);
			Files_Write(&r, Files_Rider__typ, 0xf0);
			Files_Write(&r, Files_Rider__typ, 0x01);
			Texts_Store(&r, Files_Rider__typ, t);
			text = TextFrames_Text((CHAR*)"", (LONGINT)1);
			Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"AsciiCoder.DecodeText", (LONGINT)22);
			if (compress) {
				Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" %", (LONGINT)3);
			}
			Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
			Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
			Texts_Append(text, AsciiCoder_w.buf);
			if (compress) {
				f1 = Files_New((CHAR*)"", (LONGINT)1);
				AsciiCoder_Compress(f, f1);
				f = f1;
			}
			AsciiCoder_Code(f, text);
			AsciiCoder_OpenViewer((CHAR*)"AsciiCoder.CodeText", (LONGINT)20, text);
			Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"AsciiCoder.CodeText ", (LONGINT)21);
			Texts_WriteInt(&AsciiCoder_w, Texts_Writer__typ, text->len, 0);
			Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)" characters", (LONGINT)12);
			Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
			Texts_Append(Oberon_Log, AsciiCoder_w.buf);
		}
	}
}

void AsciiCoder_DecodeText (void)
{
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	BOOLEAN ok = 0, compress = 0;
	Files_File f = NIL, f1 = NIL;
	Files_Rider r = {0};
	Texts_Text text = NIL;
	Texts_Scanner s = {0};
	compress = 0;
	pos = Oberon_Par->pos;
	f = Files_New((CHAR*)"", (LONGINT)1);
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if ((s.line == 0 && s.class == 6) && s.c == '%') {
		compress = 1;
		pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	if ((s.line == 0 && s.class == 6) && s.c == '@') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			AsciiCoder_Decode(text, &beg, f, &ok);
		} else {
			ok = 0;
		}
	} else {
		AsciiCoder_Decode(Oberon_Par->text, &pos, f, &ok);
	}
	if (ok) {
		if (compress) {
			f1 = Files_New((CHAR*)"", (LONGINT)1);
			AsciiCoder_Expand(f, f1);
			f = f1;
		}
		text = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Files_Set(&r, Files_Rider__typ, f, 2);
		Texts_Load(&r, Files_Rider__typ, text);
		AsciiCoder_OpenViewer((CHAR*)"AsciiCoder.DecodeText", (LONGINT)22, text);
	} else {
		Texts_WriteString(&AsciiCoder_w, Texts_Writer__typ, (CHAR*)"AsciiCoder.DecodeText error.", (LONGINT)29);
		Texts_WriteLn(&AsciiCoder_w, Texts_Writer__typ);
		Texts_Append(Oberon_Log, AsciiCoder_w.buf);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&AsciiCoder_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(AsciiCoder_NameDesc, 1, 2) = {__TDFLDS("NameDesc", 8), {0, 4, -12}};

export void *AsciiCoder__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(AsciiCoder, EnumPtrs);
	__REGCMD("CodeFiles", AsciiCoder_CodeFiles);
	__REGCMD("CodeText", AsciiCoder_CodeText);
	__REGCMD("DecodeFiles", AsciiCoder_DecodeFiles);
	__REGCMD("DecodeText", AsciiCoder_DecodeText);
	__INITYP(AsciiCoder_NameDesc, AsciiCoder_NameDesc, 0);
/* BEGIN */
	Texts_OpenWriter(&AsciiCoder_w, Texts_Writer__typ);
	__ENDMOD;
}
