/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Oberon.h"
#include "Printer.h"
#include "Texts.h"
#include "Viewers.h"
#include "TextFrames.h"
#include "TextPrinter.h"

typedef
	struct ChartElems_ElemDesc *ChartElems_Elem;

typedef
	struct ChartElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT w, h;
	} ChartElems_ElemDesc;


static Texts_Writer ChartElems_W;

export LONGINT *ChartElems_ElemDesc__typ;

export void ChartElems_Alloc (void);
static void ChartElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void ChartElems_Insert (void);
static void ChartElems_ReadInt (Files_Rider *r, LONGINT *r__typ, LONGINT *i);
static void ChartElems_Str (Files_Rider *r, LONGINT *r__typ, CHAR *s, LONGINT s__len);
static void ChartElems_WriteInt (Files_Rider *r, LONGINT *r__typ, LONGINT i);


static void ChartElems_Str (Files_Rider *r, LONGINT *r__typ, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		i += 1;
	}
	Files_WriteBytes(&*r, r__typ, (void*)s, s__len * 1, i + 1);
	__DEL(s);
}

static void ChartElems_ReadInt (Files_Rider *r, LONGINT *r__typ, LONGINT *i)
{
	LONGINT n = 0;
	SHORTINT s = 0;
	CHAR x = 0;
	s = 0;
	n = 0;
	Files_Read(&*r, r__typ, (void*)&x);
	while ((int)x >= 128) {
		n += __ASH((LONGINT)((int)x - 128), s);
		s += 7;
		Files_Read(&*r, r__typ, (void*)&x);
	}
	*i = n + __ASH((LONGINT)(__MASK((int)x, -64) - __ASHL(__ASHR((int)x, 6), 6)), s);
}

static void ChartElems_WriteInt (Files_Rider *r, LONGINT *r__typ, LONGINT i)
{
	while (i < -64 || i > 63) {
		Files_Write(&*r, r__typ, (CHAR)(__MASK(i, -128) + 128));
		i = __ASHR(i, 7);
	}
	Files_Write(&*r, r__typ, (CHAR)__MASK(i, -128));
}

static void ChartElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	ChartElems_Elem elem = NIL;
	if (__ISP(e, ChartElems_ElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				x = (*msg__).X0;
				y = (*msg__).Y0;
				w = (int)__DIV((*(ChartElems_Elem*)&e)->w, Display_Unit);
				h = (int)__DIV((*(ChartElems_Elem*)&e)->h, Display_Unit);
				if (!(*msg__).prepare) {
					Display_ReplConst((*msg__).col, x, y, w, 1, 0);
					Display_ReplConst((*msg__).col, x, (y + h) - 1, w, 1, 0);
					Display_ReplConst((*msg__).col, x, y, 1, h, 0);
					Display_ReplConst((*msg__).col, (x + w) - 1, y, 1, h, 0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				x = (*msg__).X0;
				y = (*msg__).Y0;
				w = (int)__DIV((*(ChartElems_Elem*)&e)->w, Display_Unit);
				h = (int)__DIV((*(ChartElems_Elem*)&e)->h, Display_Unit);
				if (!(*msg__).prepare) {
					Printer_ReplConst(x, y, w, 1);
					Printer_ReplConst(x, (y + h) - 1, w, 1);
					Printer_ReplConst(x, y, 1, h);
					Printer_ReplConst((x + w) - 1, y, 1, h);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					ChartElems_ReadInt(&(*msg__).r, Files_Rider__typ, &(*(ChartElems_Elem*)&e)->w);
					ChartElems_ReadInt(&(*msg__).r, Files_Rider__typ, &(*(ChartElems_Elem*)&e)->h);
				} else if ((*msg__).id == 1) {
					ChartElems_WriteInt(&(*msg__).r, Files_Rider__typ, (*(ChartElems_Elem*)&e)->w);
					ChartElems_WriteInt(&(*msg__).r, Files_Rider__typ, (*(ChartElems_Elem*)&e)->h);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("ChartElems", (*msg__).mod, 11);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			if (__IS(msg__typ, Texts_CopyMsg, 1)) {
				Texts_CopyMsg *msg__ = (void*)msg;
				__NEW(elem, ChartElems_ElemDesc);
				Texts_CopyElem((void*)(*(ChartElems_Elem*)&e), (void*)elem);
				(*msg__).e = (Texts_Elem)elem;
				elem->w = (*(ChartElems_Elem*)&e)->w;
				elem->h = (*(ChartElems_Elem*)&e)->h;
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void ChartElems_Alloc (void)
{
	ChartElems_Elem e = NIL;
	__NEW(e, ChartElems_ElemDesc);
	e->handle = ChartElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void ChartElems_Insert (void)
{
	Texts_Text sel = NIL;
	LONGINT beg = 0, end = 0, time = 0, size = 0, max = 0, val = 0, w = 0, h = 0;
	BOOLEAN hor = 0;
	Texts_Scanner s = {0};
	ChartElems_Elem e = NIL;
	INTEGER tos = 0;
	LONGINT Beg[60], End[60], Val[60];
	Oberon_GetSelection(&sel, &beg, &end, &time);
	if (time >= 0) {
		if (1) {
			Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
			Texts_Scan(&s, Texts_Scanner__typ);
			if (s.class == 1) {
				if (__STRCMP(s.s, "width") == 0) {
					hor = 1;
				} else if (__STRCMP(s.s, "height") == 0) {
					hor = 0;
				} else {
					return;
				}
			} else {
				return;
			}
			Texts_Scan(&s, Texts_Scanner__typ);
			if (s.class == 3) {
				size = s.i * 3600;
			} else {
				return;
			}
			Texts_OpenScanner(&s, Texts_Scanner__typ, sel, beg);
			Texts_Scan(&s, Texts_Scanner__typ);
			tos = 0;
			max = 0;
			while (s.class != 6 || s.c != '~') {
				if (s.class == 6 && s.c == '\\') {
					Beg[__X(tos, 60)] = Texts_Pos((void*)&s, Texts_Scanner__typ) - 2;
					Texts_Scan(&s, Texts_Scanner__typ);
					if (s.class == 3) {
						Val[__X(tos, 60)] = s.i;
						if (s.i > max) {
							max = s.i;
						} else if (s.i < 0) {
							return;
						}
					} else {
						return;
					}
					End[__X(tos, 60)] = Texts_Pos((void*)&s, Texts_Scanner__typ) - 1;
					tos += 1;
					if (tos == 60) {
						return;
					}
				}
				Texts_Scan(&s, Texts_Scanner__typ);
			}
			if (hor) {
				w = size;
				h = 80000;
			} else {
				w = 80000;
				h = size;
			}
			while (tos > 0) {
				tos -= 1;
				__NEW(e, ChartElems_ElemDesc);
				e->handle = ChartElems_Handle;
				val = __DIV(size, max) * Val[__X(tos, 60)];
				if (hor) {
					e->w = val;
					e->h = 80000;
				} else {
					e->w = 80000;
					e->h = val;
				}
				Texts_Delete(sel, Beg[__X(tos, 60)], End[__X(tos, 60)]);
				Texts_WriteElem(&ChartElems_W, Texts_Writer__typ, (void*)e);
				Texts_Insert(sel, Beg[__X(tos, 60)], ChartElems_W.buf);
			}
		} else __WITHCHK;
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&ChartElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(ChartElems_ElemDesc, 1, 4) = {__TDFLDS("ElemDesc", 44), {0, 4, 12, 32, -20}};

export void *ChartElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__REGMOD(ChartElems, EnumPtrs);
	__REGCMD("Alloc", ChartElems_Alloc);
	__REGCMD("Insert", ChartElems_Insert);
	__INITYP(ChartElems_ElemDesc, Texts_ElemDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&ChartElems_W, Texts_Writer__typ);
	__ENDMOD;
}
