/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "Files.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogCheckBoxes_ItemDesc *DialogCheckBoxes_Item;

typedef
	struct DialogCheckBoxes_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
		BOOLEAN on;
	} DialogCheckBoxes_ItemDesc;

export void DialogCheckBoxes_Item_ChangeValue (DialogCheckBoxes_Item b, BOOLEAN value);
export void DialogCheckBoxes_Item_Copy (DialogCheckBoxes_Item b, Dialogs_Object *dup);
export void DialogCheckBoxes_Item_Draw (DialogCheckBoxes_Item b, INTEGER x, INTEGER y, Display_Frame f);
export void DialogCheckBoxes_Item_Handle (DialogCheckBoxes_Item b, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogCheckBoxes_Item_Print (DialogCheckBoxes_Item b, INTEGER x, INTEGER y);
static void DialogCheckBoxes_Item_Track (DialogCheckBoxes_Item b, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogCheckBoxes_Item_ChangeValue(b, value) __SEND(__TYPEOF(b), 24, void(*)(DialogCheckBoxes_Item, BOOLEAN), (b, value))
#define __DialogCheckBoxes_Item_Track(b, x, y, keys, f, p) __SEND(__TYPEOF(b), 25, void(*)(DialogCheckBoxes_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (b, x, y, keys, f, p))



export LONGINT *DialogCheckBoxes_ItemDesc__typ;

export void DialogCheckBoxes_Insert (void);


void DialogCheckBoxes_Item_Draw (DialogCheckBoxes_Item b, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, bx = 0, by = 0;
	__Dialogs_Object_GetDim((void*)b, &bx, &by, &w, &h);
	w -= 1;
	h -= 1;
	if (b->selected) {
		mode = 2;
	} else {
		mode = 0;
	}
	Display1_Line(f, 0, x, y, x + w, y, mode);
	Display1_Line(f, 15, x, y, x, y + h, mode);
	Display1_Line(f, 0, x + w, y, x + w, y + h, mode);
	Display1_Line(f, 15, x, y + h, x + w, y + h, mode);
	if ((b->on && w > 8) && h > 8) {
		Display1_Line(f, 15, x + 4, y + 4, (x + w) - 4, (y + h) - 4, mode);
		Display1_Line(f, 15, x + 4, (y + h) - 4, (x + w) - 4, y + 4, mode);
		Display1_Line(f, 15, x + 5, y + 4, (x + w) - 4, (y + h) - 5, mode);
		Display1_Line(f, 15, x + 4, y + 5, (x + w) - 5, (y + h) - 4, mode);
		Display1_Line(f, 15, x + 5, (y + h) - 4, (x + w) - 4, y + 5, mode);
		Display1_Line(f, 15, x + 4, (y + h) - 5, (x + w) - 5, y + 4, mode);
	}
}

void DialogCheckBoxes_Item_Print (DialogCheckBoxes_Item b, INTEGER x, INTEGER y)
{
	INTEGER h = 0, w = 0, ox = 0, oy = 0;
	__Dialogs_Object_GetPDim((void*)b, &ox, &oy, &w, &h);
	Printer_Line(x, y, x + w, y);
	Printer_Line(x, y, x, y + h);
	Printer_Line(x + w, y, x + w, y + h);
	Printer_Line(x, y + h, x + w, y + h);
	if (b->on) {
		Printer_Line(x, y, x + w, y + h);
		Printer_Line(x, y + h, x + w, y);
	}
}

void DialogCheckBoxes_Item_ChangeValue (DialogCheckBoxes_Item b, BOOLEAN value)
{
	if (b->on && !value) {
		__Dialogs_Object_Hide((void*)b);
	}
	b->on = value;
	__Dialogs_Object_Restore((void*)b);
}

void DialogCheckBoxes_Item_Copy (DialogCheckBoxes_Item b, Dialogs_Object *dup)
{
	DialogCheckBoxes_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogCheckBoxes_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogCheckBoxes_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)b, &*dup);
	x->on = b->on;
}

static void DialogCheckBoxes_Item_Track (DialogCheckBoxes_Item b, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	Texts_Text t = NIL;
	if ((keys == 0x02 || keys == 0x01) || keys == 0x04) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		if ((keysum == 0x02 || keysum == 0x01) || keysum == 0x04) {
			__DialogCheckBoxes_Item_ChangeValue(b, !b->on);
			(*DialogTexts_GetParText)(b->par, 32, b->panel, &t);
			__Dialogs_Object_CallCmd((void*)b, f, Viewers_This(x, y), t);
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogCheckBoxes_Item_Handle (DialogCheckBoxes_Item b, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)b, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogCheckBoxes_Item_Track(b, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		}
	}
}

void DialogCheckBoxes_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogCheckBoxes_Item b = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(b, DialogCheckBoxes_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)b);
		b->on = 0;
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)b, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 20;
			h = 20;
		} else {
			if (w < 0) {
				w = 20;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)b, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)b, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogCheckBoxes", (LONGINT)17);
	}
}

__TDESC(DialogCheckBoxes_ItemDesc, 27, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};

export void *DialogCheckBoxes__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Files);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogCheckBoxes, 0);
	__REGCMD("Insert", DialogCheckBoxes_Insert);
	__INITYP(DialogCheckBoxes_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogCheckBoxes_ItemDesc, DialogCheckBoxes_Item_ChangeValue, 24);
	__INITBP(DialogCheckBoxes_ItemDesc, DialogCheckBoxes_Item_Copy, 1);
	__INITBP(DialogCheckBoxes_ItemDesc, DialogCheckBoxes_Item_Draw, 2);
	__INITBP(DialogCheckBoxes_ItemDesc, DialogCheckBoxes_Item_Handle, 6);
	__INITBP(DialogCheckBoxes_ItemDesc, DialogCheckBoxes_Item_Print, 14);
	__INITBP(DialogCheckBoxes_ItemDesc, DialogCheckBoxes_Item_Track, 25);
/* BEGIN */
	__ENDMOD;
}
