/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Bitmaps.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogColorPickers_ItemDesc *DialogColorPickers_Item;

typedef
	struct DialogColorPickers_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[2];
		INTEGER col;
	} DialogColorPickers_ItemDesc;

export void DialogColorPickers_Item_Copy (DialogColorPickers_Item c, Dialogs_Object *dup);
export void DialogColorPickers_Item_Draw (DialogColorPickers_Item c, INTEGER x, INTEGER y, Display_Frame f);
export void DialogColorPickers_Item_Handle (DialogColorPickers_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogColorPickers_Item_Print (DialogColorPickers_Item c, INTEGER x, INTEGER y);
static void DialogColorPickers_Item_Show (DialogColorPickers_Item c, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER *col, SET *keysum);
static void DialogColorPickers_Item_Track (DialogColorPickers_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogColorPickers_Item_Show(c, x, y, w, h, col, keysum) __SEND(__TYPEOF(c), 24, void(*)(DialogColorPickers_Item, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER*, SET*), (c, x, y, w, h, col, keysum))
#define __DialogColorPickers_Item_Track(c, x, y, keys, f, p) __SEND(__TYPEOF(c), 25, void(*)(DialogColorPickers_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (c, x, y, keys, f, p))



export LONGINT *DialogColorPickers_ItemDesc__typ;

static void DialogColorPickers_Box (INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void DialogColorPickers_Insert (void);


static void DialogColorPickers_Box (INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	INTEGER i = 0, _for__13 = 0, _for__12 = 0;
	_for__13 = w;
	i = 0;
	while (i <= _for__13) {
		Display_Dot(15, x + i, y, 2);
		Display_Dot(15, x + i, y + h, 2);
		i += 1;
	}
	_for__12 = h - 1;
	i = 1;
	while (i <= _for__12) {
		Display_Dot(15, x, y + i, 2);
		Display_Dot(15, x + w, y + i, 2);
		i += 1;
	}
}

void DialogColorPickers_Item_Draw (DialogColorPickers_Item c, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER x0 = 0, y0 = 0, w = 0, h = 0, mode = 0;
	__Dialogs_Object_GetDim((void*)c, &x0, &y0, &w, &h);
	w -= 1;
	h -= 1;
	if (c->selected) {
		mode = 2;
	} else {
		mode = 1;
	}
	Display1_Line(f, 15, x, y, x + w, y, mode);
	Display1_Line(f, 15, x + w, y, x + w, y + h, mode);
	Display1_Line(f, 15, x, y, x, y + h, mode);
	Display1_Line(f, 15, x, y + h, x + w, y + h, mode);
	Display_ReplConstC(f, c->col, x + 1, y + 1, w - 1, h - 1, mode);
}

void DialogColorPickers_Item_Print (DialogColorPickers_Item c, INTEGER x, INTEGER y)
{
	INTEGER x0 = 0, y0 = 0, w = 0, h = 0;
	__Dialogs_Object_GetPDim((void*)c, &x0, &y0, &w, &h);
	GraphicUtils_PrintBox(x, y, w, h);
}

void DialogColorPickers_Item_Copy (DialogColorPickers_Item c, Dialogs_Object *dup)
{
	DialogColorPickers_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogColorPickers_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogColorPickers_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)c, &*dup);
	x->col = c->col;
}

static struct Show__5 {
	INTEGER *x, *y, *w, *h;
	struct Show__5 *lnk;
} *Show__5_s;

static void DrawColors__6 (INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void Flip__8 (INTEGER col);

static void Flip__8 (INTEGER col)
{
	INTEGER x0 = 0, y0 = 0;
	if (col >= 0) {
		x0 = *Show__5_s->x + __MASK(col, -4) * __ASHR(*Show__5_s->w, 2);
		y0 = (*Show__5_s->y + *Show__5_s->h) - (__ASHR(col, 2) + 1) * __ASHR(*Show__5_s->h, 2);
		DialogColorPickers_Box(x0, y0, __ASHR(*Show__5_s->w, 2), __ASHR(*Show__5_s->h, 2));
	}
}

static void DrawColors__6 (INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	INTEGER c = 0, i = 0, j = 0;
	i = 0;
	while (i <= 3) {
		j = 0;
		while (j <= 3) {
			c = __ASHL(i, 2) + j;
			Display_ReplConst(c, x + __MASK(c, -4) * w, y + (3 - __ASHR(c, 2)) * h, w, h, 1);
			j += 1;
		}
		i += 1;
	}
}

static void DialogColorPickers_Item_Show (DialogColorPickers_Item c, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER *col, SET *keysum)
{
	INTEGER mx = 0, my = 0, top = 0, bot = 0, left = 0, right = 0, newcol = 0;
	Bitmaps_Bitmap b = NIL;
	SET keys = 0;
	struct Show__5 _s;
	_s.x = &x;
	_s.y = &y;
	_s.w = &w;
	_s.h = &h;
	_s.lnk = Show__5_s;
	Show__5_s = &_s;
	left = x + 1;
	right = (x + w) - 2;
	bot = y + 1;
	top = (y + h) - 2;
	*col = c->col;
	Oberon_RemoveMarks(x, y, w, h);
	Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
	b = Bitmaps_New(w + 1, h + 1);
	Bitmaps_CopyBlock(Bitmaps_Disp, b, x, y, w + 1, h + 1, 0, 0, 0);
	DrawColors__6(x, y, __ASHR(w, 2), __ASHR(h, 2));
	do {
		Input_Mouse(&keys, &mx, &my);
		*keysum = *keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
		if (*keysum == 0x07) {
			*col = -1;
		} else if (((mx >= left && mx <= right) && my >= bot) && my <= top) {
			newcol = __ASHL(__DIV(top - my, __ASHR(h, 2)), 2) + __DIV(mx - left, __ASHR(w, 2));
			if (newcol != *col) {
				Flip__8(*col);
				Flip__8(newcol);
				*col = newcol;
			}
		} else {
			Flip__8(*col);
			*col = -1;
		}
	} while (!(keys == 0x0));
	Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
	Bitmaps_CopyBlock(b, Bitmaps_Disp, 0, 0, w + 1, h + 1, x, y, 0);
	Show__5_s = _s.lnk;
}

static void DialogColorPickers_Item_Track (DialogColorPickers_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	Texts_Text t = NIL;
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0, col = 0;
	if ((keys == 0x02 || keys == 0x01) || keys == 0x04) {
		__Dialogs_Object_GetDim((void*)c, &ox, &oy, &ow, &oh);
		ox = f->X + ox;
		oy = (f->Y + f->H) + oy;
		ow = __ASHL(ow, 2);
		oh = __ASHL(oh, 2);
		oy = oy - oh;
		if (oy < 0) {
			oy = (oy + __ASHR(oh * 5, 2)) + 1;
		} else {
			oy -= 1;
		}
		if (ox + ow > Display_Width) {
			ox = (ox - ow) + __ASHR(ow, 2);
		}
		__DialogColorPickers_Item_Show(c, ox, oy, ow, oh, &col, &keys);
		if (col != c->col && col >= 0) {
			c->col = col;
			__Dialogs_Object_Restore((void*)c);
			if (c->cmd[0] != 0x00) {
				(*DialogTexts_GetParText)(c->par, 32, c->panel, &t);
				__Dialogs_Object_CallCmd((void*)c, f, Viewers_This(x, y), t);
			}
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogColorPickers_Item_Handle (DialogColorPickers_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)c, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogColorPickers_Item_Track(c, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		}
	}
}

void DialogColorPickers_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogColorPickers_Item c = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(c, DialogColorPickers_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)c);
		c->col = 15;
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)c, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 20;
			h = 20;
		} else {
			if (w < 0) {
				w = 20;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)c, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)c, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogColorPickers", (LONGINT)19);
	}
}

__TDESC(DialogColorPickers_ItemDesc, 27, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};

export void *DialogColorPickers__init(void)
{
	__DEFMOD;
	__IMPORT(Bitmaps);
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogColorPickers, 0);
	__REGCMD("Insert", DialogColorPickers_Insert);
	__INITYP(DialogColorPickers_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogColorPickers_ItemDesc, DialogColorPickers_Item_Copy, 1);
	__INITBP(DialogColorPickers_ItemDesc, DialogColorPickers_Item_Draw, 2);
	__INITBP(DialogColorPickers_ItemDesc, DialogColorPickers_Item_Handle, 6);
	__INITBP(DialogColorPickers_ItemDesc, DialogColorPickers_Item_Print, 14);
	__INITBP(DialogColorPickers_ItemDesc, DialogColorPickers_Item_Show, 24);
	__INITBP(DialogColorPickers_ItemDesc, DialogColorPickers_Item_Track, 25);
/* BEGIN */
	__ENDMOD;
}
