/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogDates_ItemDesc *DialogDates_Item;

typedef
	struct DialogDates_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} DialogDates_ItemDesc;

export void DialogDates_Item_Copy (DialogDates_Item c, Dialogs_Object *dup);
export void DialogDates_Item_Draw (DialogDates_Item c, INTEGER x, INTEGER y, Display_Frame f);
export void DialogDates_Item_Handle (DialogDates_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogDates_Item_Print (DialogDates_Item c, INTEGER x, INTEGER y);
static void DialogDates_Item_Track (DialogDates_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogDates_Item_Track(c, x, y, keys, f, p) __SEND(__TYPEOF(c), 24, void(*)(DialogDates_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (c, x, y, keys, f, p))

typedef
	struct DialogDates_Time {
		LONGINT timeStamp, dateStamp;
	} DialogDates_Time;

typedef
	struct DialogDates_NotifyMsg { /* Display_FrameMsg */
		DialogDates_Time new;
	} DialogDates_NotifyMsg;


static LONGINT DialogDates_wakeUp;
static DialogDates_Time DialogDates_old;
static Fonts_Font DialogDates_fnt;
static Oberon_Task DialogDates_Task;
static CHAR DialogDates_month[37];

export LONGINT *DialogDates_ItemDesc__typ;
export LONGINT *DialogDates_Time__typ;
export LONGINT *DialogDates_NotifyMsg__typ;

static void DialogDates_Clock (void);
static void DialogDates_Format (LONGINT date, CHAR *s, LONGINT s__len);
export void DialogDates_Insert (void);


static struct Format__7 {
	CHAR *s;
	LONGINT s__len;
	INTEGER *i;
	struct Format__7 *lnk;
} *Format__7_s;

static void Label__8 (LONGINT m);
static void Pair__10 (LONGINT x);

static void Pair__10 (LONGINT x)
{
	if (x >= 10) {
		Format__7_s->s[__X(*Format__7_s->i, Format__7_s->s__len)] = (CHAR)(__DIV(x, 10) + 48);
		*Format__7_s->i += 1;
	}
	Format__7_s->s[__X(*Format__7_s->i, Format__7_s->s__len)] = (CHAR)(__MOD(x, 10) + 48);
	*Format__7_s->i += 1;
}

static void Label__8 (LONGINT m)
{
	m = (m - 1) * 3;
	Format__7_s->s[__X(*Format__7_s->i, Format__7_s->s__len)] = DialogDates_month[__X(m, 37)];
	Format__7_s->s[__X(*Format__7_s->i + 1, Format__7_s->s__len)] = DialogDates_month[__X(m + 1, 37)];
	Format__7_s->s[__X(*Format__7_s->i + 2, Format__7_s->s__len)] = DialogDates_month[__X(m + 2, 37)];
	*Format__7_s->i += 3;
}

static void DialogDates_Format (LONGINT date, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	struct Format__7 _s;
	_s.s = (void*)s; _s.s__len = s__len;
	_s.i = &i;
	_s.lnk = Format__7_s;
	Format__7_s = &_s;
	i = 0;
	Pair__10(__MASK(date, -32));
	s[__X(i, s__len)] = ' ';
	i += 1;
	Label__8(__MASK(__ASHR(date, 5), -16));
	s[__X(i, s__len)] = ' ';
	i += 1;
	Pair__10(__MASK(__ASHR(date, 9), -128));
	s[__X(i, s__len)] = 0x00;
	Format__7_s = _s.lnk;
}

void DialogDates_Item_Draw (DialogDates_Item c, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, ox = 0, oy = 0, cx = 0, yh = 0;
	CHAR str[12];
	DialogDates_Time time = {0};
	__Dialogs_Object_GetDim((void*)c, &ox, &oy, &w, &h);
	if (c->selected) {
		mode = 2;
	} else {
		mode = 1;
	}
	yh = (y + __ASHR(h, 1)) - __ASHR(DialogDates_fnt->minY + DialogDates_fnt->maxY, 1);
	Oberon_GetClock(&time.timeStamp, &time.dateStamp);
	DialogDates_Format(time.dateStamp, (void*)str, 12);
	if (h - (yh - y) > DialogDates_fnt->maxY) {
		GraphicUtils_DrawString(f, str, 12, x + 3, yh, w - 4, DialogDates_fnt, mode, 1, &cx);
	}
}

void DialogDates_Item_Print (DialogDates_Item c, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, ox = 0, oy = 0, yh = 0;
	LONGINT fnth = 0;
	DialogDates_Time time = {0};
	CHAR str[12];
	__Dialogs_Object_GetPDim((void*)c, &ox, &oy, &w, &h);
	fnth = __ASHR(__DIV((LONGINT)(DialogDates_fnt->maxY - DialogDates_fnt->minY) * Dialogs_dUnit, Dialogs_pUnit), 1);
	yh = (y + __ASHR(h, 1)) - (int)fnth;
	Oberon_GetClock(&time.timeStamp, &time.dateStamp);
	DialogDates_Format(time.dateStamp, (void*)str, 12);
	if ((LONGINT)(h - (yh - y)) > __DIV((LONGINT)(DialogDates_fnt->maxY * (int)Dialogs_dUnit), Dialogs_pUnit)) {
		GraphicUtils_PrintString(str, 12, x + 3, yh, w - 4, DialogDates_fnt, 1, &ox);
	}
}

void DialogDates_Item_Copy (DialogDates_Item c, Dialogs_Object *dup)
{
	DialogDates_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogDates_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogDates_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)c, &*dup);
}

static void DialogDates_Item_Track (DialogDates_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	Texts_Text t = NIL;
	if (keys == 0x02) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		if (keysum == 0x02 && c->cmd[0] != 0x00) {
			(*DialogTexts_GetParText)(c->par, 32, c->panel, &t);
			__Dialogs_Object_CallCmd((void*)c, f, Viewers_This(x, y), t);
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogDates_Item_Handle (DialogDates_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)c, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogDates_Item_Track(c, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		} else if (__IS(m__typ, DialogDates_NotifyMsg, 1)) {
			DialogDates_NotifyMsg *m__ = (void*)m;
			__Dialogs_Object_Hide((void*)c);
			__Dialogs_Object_Restore((void*)c);
		}
	}
}

static void DialogDates_Clock (void)
{
	DialogDates_NotifyMsg msg = {0};
	if (Oberon_Time() >= DialogDates_wakeUp) {
		Oberon_GetClock(&msg.new.timeStamp, &msg.new.dateStamp);
		if (msg.new.dateStamp != DialogDates_old.dateStamp) {
			DialogDates_wakeUp = Oberon_Time() + 281;
			Viewers_Broadcast((void*)&msg, DialogDates_NotifyMsg__typ);
			DialogDates_old = msg.new;
		} else {
			DialogDates_wakeUp = Oberon_Time() + 18;
		}
	}
}

void DialogDates_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogDates_Item b = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(b, DialogDates_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)b);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)b, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 60;
			h = 20;
		} else {
			if (w < 0) {
				w = 60;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)b, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)b, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogDates", (LONGINT)12);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(DialogDates_fnt);
	P(DialogDates_Task);
}

__TDESC(DialogDates_ItemDesc, 26, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};
__TDESC(DialogDates_Time, 1, 0) = {__TDFLDS("Time", 8), {-4}};
__TDESC(DialogDates_NotifyMsg, 1, 0) = {__TDFLDS("NotifyMsg", 8), {-4}};

export void *DialogDates__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogDates, EnumPtrs);
	__REGCMD("Insert", DialogDates_Insert);
	__INITYP(DialogDates_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogDates_ItemDesc, DialogDates_Item_Copy, 1);
	__INITBP(DialogDates_ItemDesc, DialogDates_Item_Draw, 2);
	__INITBP(DialogDates_ItemDesc, DialogDates_Item_Handle, 6);
	__INITBP(DialogDates_ItemDesc, DialogDates_Item_Print, 14);
	__INITBP(DialogDates_ItemDesc, DialogDates_Item_Track, 24);
	__INITYP(DialogDates_Time, DialogDates_Time, 0);
	__INITYP(DialogDates_NotifyMsg, Display_FrameMsg, 1);
/* BEGIN */
	Oberon_GetClock(&DialogDates_old.timeStamp, &DialogDates_old.dateStamp);
	DialogDates_fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__NEW(DialogDates_Task, Oberon_TaskDesc);
	DialogDates_Task->safe = 0;
	DialogDates_Task->handle = DialogDates_Clock;
	Oberon_Install(DialogDates_Task);
	__MOVE("JanFebMarAprMayJunJulAugSepOctNovDec", DialogDates_month, 37);
	__ENDMOD;
}
