/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogStaticTexts.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "Files.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogGroupBoxes_ItemDesc *DialogGroupBoxes_Item;

typedef
	struct DialogGroupBoxes_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Fonts_Font fnt;
		CHAR s[64];
	} DialogGroupBoxes_ItemDesc;

export void DialogGroupBoxes_Item_Copy (DialogGroupBoxes_Item g, Dialogs_Object *dup);
export void DialogGroupBoxes_Item_Draw (DialogGroupBoxes_Item g, INTEGER x, INTEGER y, Display_Frame f);
export void DialogGroupBoxes_Item_Edit (DialogGroupBoxes_Item g);
export void DialogGroupBoxes_Item_GetObjects (DialogGroupBoxes_Item g, Dialogs_Object *obArray, LONGINT obArray__len, INTEGER *nofelems);
export void DialogGroupBoxes_Item_Handle (DialogGroupBoxes_Item g, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogGroupBoxes_Item_Load (DialogGroupBoxes_Item g, Files_Rider *r, LONGINT *r__typ);
export void DialogGroupBoxes_Item_Print (DialogGroupBoxes_Item g, INTEGER x, INTEGER y);
export void DialogGroupBoxes_Item_SetFont (DialogGroupBoxes_Item g, Fonts_Font fnt);
export void DialogGroupBoxes_Item_SetString (DialogGroupBoxes_Item g, CHAR *s, LONGINT s__len);
export void DialogGroupBoxes_Item_Store (DialogGroupBoxes_Item g, Files_Rider *r, LONGINT *r__typ);
export void DialogGroupBoxes_Item_Update (DialogGroupBoxes_Item g, Dialogs_Panel p);
#define __DialogGroupBoxes_Item_GetObjects(g, obArray, obArray__len, nofelems) __SEND(__TYPEOF(g), 24, void(*)(DialogGroupBoxes_Item, Dialogs_Object*, LONGINT , INTEGER*), (g, obArray, obArray__len, nofelems))
#define __DialogGroupBoxes_Item_SetFont(g, fnt) __SEND(__TYPEOF(g), 25, void(*)(DialogGroupBoxes_Item, Fonts_Font), (g, fnt))
#define __DialogGroupBoxes_Item_SetString(g, s, s__len) __SEND(__TYPEOF(g), 26, void(*)(DialogGroupBoxes_Item, CHAR*, LONGINT ), (g, s, s__len))


static Texts_Writer DialogGroupBoxes_w0;

export LONGINT *DialogGroupBoxes_ItemDesc__typ;

export void DialogGroupBoxes_GetString (void);
export void DialogGroupBoxes_Insert (void);
export void DialogGroupBoxes_SetString (void);
static void DialogGroupBoxes_WriteToObjectStr (DialogTexts_Item o, Dialogs_Panel *p, CHAR *n, LONGINT n__len);


static struct Draw__2 {
	struct Draw__2 *lnk;
} *Draw__2_s;

static INTEGER Max__3 (INTEGER x, INTEGER y);

static INTEGER Max__3 (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogGroupBoxes_Item_Draw (DialogGroupBoxes_Item g, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, gx = 0, gy = 0, cx = 0, yh = 0;
	struct Draw__2 _s;
	_s.lnk = Draw__2_s;
	Draw__2_s = &_s;
	__Dialogs_Object_GetDim((void*)g, &gx, &gy, &w, &h);
	y += 1;
	w -= 2;
	h -= 5;
	cx = 0;
	if (h < 0 || w < 0) {
		Display1_Line(f, 15, x, y, x + Max__3(w, 0), y + Max__3(h, 0), 1);
		Draw__2_s = _s.lnk;
		return;
	}
	if (g->selected) {
		mode = 2;
	} else {
		mode = 1;
	}
	yh = ((y + h) - g->fnt->maxY) - g->fnt->minY;
	if (g->s[0] == 0x00) {
		cx = w;
	} else if (yh > y) {
		GraphicUtils_DrawString(f, g->s, 64, x + 3, yh, w - 4, g->fnt, mode, 1, &cx);
	}
	Display1_Line(f, 15, x, y, x + w, y, mode);
	Display1_Line(f, 15, x, y, x, y + h, mode);
	Display1_Line(f, 15, x + w, y, x + w, y + h, mode);
	Display1_Line(f, 0, x, y - 1, x + w, y - 1, mode);
	Display1_Line(f, 0, x + 1, y + 1, x + 1, y + h, mode);
	Display1_Line(f, 0, (x + w) + 1, y, (x + w) + 1, y + h, mode);
	if (cx > 0) {
		Display1_Line(f, 15, x, y + h, x + cx, y + h, mode);
		Display1_Line(f, 15, (x + w) - cx, y + h, x + w, y + h, mode);
		Display1_Line(f, 0, x + 1, (y + h) - 1, x + cx, (y + h) - 1, mode);
		Display1_Line(f, 0, (x + w) - cx, (y + h) - 1, (x + w) - 1, (y + h) - 1, mode);
	}
	Draw__2_s = _s.lnk;
}

void DialogGroupBoxes_Item_Print (DialogGroupBoxes_Item g, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, gx = 0, gy = 0, yh = 0, cx = 0;
	LONGINT fnth = 0;
	__Dialogs_Object_GetPDim((void*)g, &gx, &gy, &w, &h);
	w -= 2;
	h -= 5;
	if (h < 0) {
		return;
	}
	Printer_Line(x, y, x + w, y);
	Printer_Line(x, y, x, y + h);
	Printer_Line(x + w, y, x + w, y + h);
	fnth = __DIV((LONGINT)(g->fnt->maxY + g->fnt->minY) * Dialogs_dUnit, Dialogs_pUnit);
	yh = (y + h) - (int)fnth;
	if (yh > y) {
		GraphicUtils_PrintString(g->s, 64, x + 3, yh, w - 4, g->fnt, 1, &cx);
	}
	if (cx > 0) {
		Printer_Line(x, y + h, x + cx, y + h);
		Printer_Line((x + w) - cx, y + h, x + w, y + h);
	}
}

void DialogGroupBoxes_Item_Copy (DialogGroupBoxes_Item g, Dialogs_Object *dup)
{
	DialogGroupBoxes_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogGroupBoxes_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogGroupBoxes_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)g, &*dup);
	x->fnt = g->fnt;
	__COPY(g->s, x->s, 64);
}

void DialogGroupBoxes_Item_Load (DialogGroupBoxes_Item g, Files_Rider *r, LONGINT *r__typ)
{
	CHAR fntname[32];
	Dialogs_Object_Load((void*)g, &*r, r__typ);
	Files_ReadString(&*r, r__typ, (void*)fntname, 32);
	g->fnt = Fonts_This(fntname, 32);
	Files_ReadString(&*r, r__typ, (void*)g->s, 64);
}

void DialogGroupBoxes_Item_Store (DialogGroupBoxes_Item g, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Store((void*)g, &*r, r__typ);
	Files_WriteString(&*r, r__typ, g->fnt->name, 32);
	Files_WriteString(&*r, r__typ, g->s, 64);
}

void DialogGroupBoxes_Item_SetFont (DialogGroupBoxes_Item g, Fonts_Font fnt)
{
	__Dialogs_Object_Hide((void*)g);
	g->fnt = fnt;
	__Dialogs_Object_Restore((void*)g);
	if (g->panel != NIL) {
		__Dialogs_Panel_MarkMenu(g->panel);
	}
}

void DialogGroupBoxes_Item_SetString (DialogGroupBoxes_Item g, CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	__Dialogs_Object_Hide((void*)g);
	__COPY(s, g->s, 64);
	__Dialogs_Object_Restore((void*)g);
	if (g->panel != NIL) {
		__Dialogs_Panel_MarkMenu(g->panel);
	}
	__DEL(s);
}

void DialogGroupBoxes_Item_Handle (DialogGroupBoxes_Item g, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Texts_Text t = NIL;
	Dialogs_Object_Handle((void*)g, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				if ((*m__).keys == 0x02 && g->cmd[0] != 0x00) {
					(*DialogTexts_GetParText)(g->par, 32, g->panel, &t);
					__Dialogs_Object_CallCmd((void*)g, (void*)(*(DialogFrames_Frame*)&f), Viewers_This((*m__).X, (*m__).Y), TextFrames_Text((CHAR*)"", (LONGINT)1));
				}
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*m__).X, (*m__).Y);
			}
		}
	}
}

static void DialogGroupBoxes_WriteToObjectStr (DialogTexts_Item o, Dialogs_Panel *p, CHAR *n, LONGINT n__len)
{
	Texts_Text t = NIL;
	__DUP(n, n__len, CHAR);
	t = __DialogTexts_Item_GetText(o);
	Texts_WriteString(&DialogGroupBoxes_w0, Texts_Writer__typ, n, n__len);
	Texts_Append(t, DialogGroupBoxes_w0.buf);
	__DEL(n);
}

void DialogGroupBoxes_Item_Edit (DialogGroupBoxes_Item g)
{
	Dialogs_Object on = NIL;
	DialogTexts_Item os = NIL, string = NIL;
	DialogStaticTexts_Item s = NIL;
	Dialogs_Panel p = NIL;
	Texts_Text t1 = NIL;
	Fonts_Font fnt = NIL;
	Dialogs_Object_Edit((void*)g);
	p = Dialogs_editPanel;
	__NEW(string, DialogTexts_ItemDesc);
	__Dialogs_Object_Init((void*)string);
	__Dialogs_Object_SetName((void*)string, (CHAR*)"string", (LONGINT)7);
	__Dialogs_Object_SetDim((void*)string, 245, -30, 140, 19, 0);
	__Dialogs_Panel_Insert(p, (void*)string, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 196, -30, 40, 20, 0);
	__DialogStaticTexts_Item_SetString(s, (CHAR*)"String", (LONGINT)7);
	fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__DialogStaticTexts_Item_SetFont(s, fnt);
	__Dialogs_Panel_Insert(p, (void*)s, 0);
	__ASSERT(Dialogs_res == 0, 0);
	DialogGroupBoxes_WriteToObjectStr(string, &p, g->s, 64);
	t1 = __DialogTexts_Item_GetText(string);
	Texts_ChangeLooks(t1, 0, t1->len, 0x01, g->fnt, 0, 0);
}

void DialogGroupBoxes_Item_Update (DialogGroupBoxes_Item g, Dialogs_Panel p)
{
	Dialogs_Object os = NIL;
	Texts_Text t1 = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	CHAR str[64];
	INTEGER i = 0;
	Dialogs_Object_Update((void*)g, p);
	os = __Dialogs_Panel_NamedObject(p, (CHAR*)"string", (LONGINT)7);
	t1 = __DialogTexts_Item_GetText(__GUARDP(os, DialogTexts_ItemDesc, 1));
	Texts_OpenReader(&r, Texts_Reader__typ, t1, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	i = 0;
	if (r.fnt != NIL && r.fnt != g->fnt) {
		__DialogGroupBoxes_Item_SetFont(g, r.fnt);
	}
	while (!r.eot) {
		str[__X(i, 64)] = ch;
		i += 1;
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	str[__X(i, 64)] = 0x00;
	if (__STRCMP(str, g->s) != 0) {
		__DialogGroupBoxes_Item_SetString(g, str, 64);
	}
}

void DialogGroupBoxes_Item_GetObjects (DialogGroupBoxes_Item g, Dialogs_Object *obArray, LONGINT obArray__len, INTEGER *nofelems)
{
	Dialogs_Panel p = NIL;
	INTEGER x = 0, y = 0, w = 0, h = 0;
	p = g->panel;
	__Dialogs_Object_GetDim((void*)g, &x, &y, &w, &h);
	__Dialogs_Panel_GetObjects(p, x, y, w, h, (void*)obArray, obArray__len, &*nofelems);
}

void DialogGroupBoxes_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogGroupBoxes_Item g = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	Texts_Reader r = {0};
	CHAR ch = 0;
	__NEW(g, DialogGroupBoxes_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)g);
		In_Open();
		Texts_OpenReader(&r, Texts_Reader__typ, Oberon_Par->text, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		} else {
			g->fnt = r.fnt;
		}
		__Dialogs_Object_SetName((void*)g, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 100;
			h = 100;
		} else {
			if (w < 0) {
				w = 100;
			}
			if (h < 0) {
				h = 100;
			}
		}
		__Dialogs_Object_SetDim((void*)g, x1, y1, w, h, 0);
		__DialogGroupBoxes_Item_SetString(g, name, 64);
		__DialogGroupBoxes_Item_SetFont(g, Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17));
		__Dialogs_Panel_Insert(p, (void*)g, 1);
	} else {
		Dialogs_res = 4;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogGroupBoxes", (LONGINT)17);
	}
}

void DialogGroupBoxes_SetString (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR str[64];
	CHAR ch = 0;
	INTEGER i = 0;
	In_Open();
	In_Char(&ch);
	i = 0;
	while (In_Done && ch == ' ') {
		In_Char(&ch);
	}
	if (!In_Done) {
		Dialogs_res = 4;
	} else {
		while (((In_Done && ch != 0x0d) && ch != '~') && i < 63) {
			str[__X(i, 64)] = ch;
			i += 1;
			In_Char(&ch);
		}
		str[__X(i, 64)] = 0x00;
		DialogFrames_FindObject(&o, &p);
		if (Dialogs_res == 0 && __ISP(o, DialogGroupBoxes_ItemDesc, 1)) {
			__DialogGroupBoxes_Item_SetString(__GUARDP(o, DialogGroupBoxes_ItemDesc, 1), str, 64);
			__DialogGroupBoxes_Item_SetFont(__GUARDP(o, DialogGroupBoxes_ItemDesc, 1), Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17));
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogGroupBoxes", (LONGINT)17);
	}
}

void DialogGroupBoxes_GetString (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR str[64];
	DialogFrames_FindObject(&o, &p);
	if (Dialogs_res == 0) {
		if (__ISP(o, DialogGroupBoxes_ItemDesc, 1)) {
			__COPY(__GUARDP(o, DialogGroupBoxes_ItemDesc, 1)->s, str, 64);
			Texts_WriteString(&DialogGroupBoxes_w0, Texts_Writer__typ, (CHAR*)"String:", (LONGINT)8);
			Texts_WriteString(&DialogGroupBoxes_w0, Texts_Writer__typ, str, 64);
			Texts_WriteLn(&DialogGroupBoxes_w0, Texts_Writer__typ);
			Texts_Append(Oberon_Log, DialogGroupBoxes_w0.buf);
		} else {
			Dialogs_res = 3;
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogStaticTexts", (LONGINT)18);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogGroupBoxes_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogGroupBoxes_ItemDesc, 28, 3) = {__TDFLDS("ItemDesc", 180), {0, 104, 112, -16}};

export void *DialogGroupBoxes__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogStaticTexts);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogGroupBoxes, EnumPtrs);
	__REGCMD("GetString", DialogGroupBoxes_GetString);
	__REGCMD("Insert", DialogGroupBoxes_Insert);
	__REGCMD("SetString", DialogGroupBoxes_SetString);
	__INITYP(DialogGroupBoxes_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Copy, 1);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Draw, 2);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Edit, 3);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_GetObjects, 24);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Handle, 6);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Load, 12);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Print, 14);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_SetFont, 25);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_SetString, 26);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Store, 21);
	__INITBP(DialogGroupBoxes_ItemDesc, DialogGroupBoxes_Item_Update, 23);
/* BEGIN */
	Texts_OpenWriter(&DialogGroupBoxes_w0, Texts_Writer__typ);
	__ENDMOD;
}
