/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogListBoxes.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogInsert_Item {
		CHAR name[32];
		CHAR cmd[48];
	} DialogInsert_Item;

typedef
	DialogInsert_Item DialogInsert_DlgItems[100];


static Texts_Writer DialogInsert_wr;
static INTEGER DialogInsert_nrOfItems;
static DialogInsert_DlgItems DialogInsert_dlgItems;

export LONGINT *DialogInsert_Item__typ;

export void DialogInsert_Do (void);
static void DialogInsert_Init (void);
export void DialogInsert_Open (void);
static void DialogInsert_ReadCmd (Dialogs_Object o, CHAR *string, LONGINT string__len);
static void DialogInsert_ReadInt (Dialogs_Object o, INTEGER *res);
static void DialogInsert_ReadName (Dialogs_Object o);
static void DialogInsert_ReadNameCmdPar (CHAR *cmd, LONGINT cmd__len, CHAR *par, LONGINT par__len);
static void DialogInsert_ReadPar (Dialogs_Object o, CHAR *string, LONGINT string__len);
static void DialogInsert_ReadXYWH (void);


void DialogInsert_Open (void)
{
	INTEGER i = 0, x = 0, y = 0;
	Dialogs_Panel panel = NIL;
	Texts_Writer w = {0};
	Texts_Text t = NIL;
	Dialogs_Object o = NIL;
	INTEGER _for__4 = 0;
	panel = Dialogs_cmdPanel;
	o = __Dialogs_Panel_NamedObject(panel, (CHAR*)"l", (LONGINT)2);
	if (__ISP(o, DialogListBoxes_ItemDesc, 1)) {
		Texts_OpenWriter(&w, Texts_Writer__typ);
		Texts_WriteString(&w, Texts_Writer__typ, DialogInsert_dlgItems[0].name, 32);
		_for__4 = DialogInsert_nrOfItems - 1;
		i = 1;
		while (i <= _for__4) {
			Texts_WriteLn(&w, Texts_Writer__typ);
			Texts_WriteString(&w, Texts_Writer__typ, DialogInsert_dlgItems[__X(i, 100)].name, 32);
			i += 1;
		}
		t = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Append(t, w.buf);
		__DialogListBoxes_Item_SetMenu((*(DialogListBoxes_Item*)&o), t);
	} else {
		__HALT(99);
	}
}

static void DialogInsert_ReadInt (Dialogs_Object o, INTEGER *res)
{
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		*res = 0;
		if (s.class == 3) {
			Texts_WriteInt(&DialogInsert_wr, Texts_Writer__typ, s.i, 0);
			Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
		} else {
			*res = 4;
		}
	} else {
		*res = 4;
	}
}

static void DialogInsert_ReadName (Dialogs_Object o)
{
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	CHAR string[32];
	INTEGER i = 0;
	CHAR ch = 0;
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		i = 0;
		while (!r.eot) {
			string[__X(i, 32)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		string[__X(i, 32)] = 0x00;
	}
	Texts_WriteString(&DialogInsert_wr, Texts_Writer__typ, string, 32);
	Texts_Delete(Oberon_Par->text, 0, Oberon_Par->text->len);
	Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
}

static void DialogInsert_ReadCmd (Dialogs_Object o, CHAR *string, LONGINT string__len)
{
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1) {
			__COPY(s.s, string, string__len);
		} else {
			__COPY("", string, string__len);
		}
	}
}

static void DialogInsert_ReadPar (Dialogs_Object o, CHAR *string, LONGINT string__len)
{
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	INTEGER i = 0;
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		i = 0;
		while (!r.eot) {
			string[__X(i, string__len)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		string[__X(i, string__len)] = 0x00;
	}
}

static void DialogInsert_ReadXYWH (void)
{
	Dialogs_Object ox = NIL, oy = NIL, ow = NIL, oh = NIL;
	INTEGER i = 0, res = 0, x = 0, y = 0;
	Dialogs_Panel panel = NIL, p = NIL;
	panel = Dialogs_cmdPanel;
	ox = __Dialogs_Panel_NamedObject(panel, (CHAR*)"x", (LONGINT)2);
	oy = __Dialogs_Panel_NamedObject(panel, (CHAR*)"y", (LONGINT)2);
	ow = __Dialogs_Panel_NamedObject(panel, (CHAR*)"w", (LONGINT)2);
	oh = __Dialogs_Panel_NamedObject(panel, (CHAR*)"h", (LONGINT)2);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	DialogInsert_ReadInt(ox, &res);
	if (res != 0) {
		Texts_WriteInt(&DialogInsert_wr, Texts_Writer__typ, x, 0);
		Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	}
	Texts_WriteString(&DialogInsert_wr, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
	Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	DialogInsert_ReadInt(oy, &res);
	if (res != 0) {
		Texts_WriteInt(&DialogInsert_wr, Texts_Writer__typ, y, 0);
		Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	}
	Texts_WriteString(&DialogInsert_wr, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
	Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	DialogInsert_ReadInt(ow, &res);
	if (res != 0) {
		Texts_WriteInt(&DialogInsert_wr, Texts_Writer__typ, -1, 0);
		Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	}
	Texts_WriteString(&DialogInsert_wr, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
	Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	DialogInsert_ReadInt(oh, &res);
	if (res != 0) {
		Texts_WriteInt(&DialogInsert_wr, Texts_Writer__typ, -1, 0);
		Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	}
}

static void DialogInsert_ReadNameCmdPar (CHAR *cmd, LONGINT cmd__len, CHAR *par, LONGINT par__len)
{
	Dialogs_Object on = NIL, op = NIL, oc = NIL;
	on = __Dialogs_Panel_NamedObject(Dialogs_cmdPanel, (CHAR*)"name", (LONGINT)5);
	oc = __Dialogs_Panel_NamedObject(Dialogs_cmdPanel, (CHAR*)"cmd", (LONGINT)4);
	op = __Dialogs_Panel_NamedObject(Dialogs_cmdPanel, (CHAR*)"par", (LONGINT)4);
	DialogInsert_ReadName(on);
	DialogInsert_ReadCmd(oc, (void*)cmd, cmd__len);
	DialogInsert_ReadPar(op, (void*)par, par__len);
}

void DialogInsert_Do (void)
{
	Dialogs_Object o = NIL, last = NIL;
	Dialogs_Panel p = NIL;
	Texts_Buffer name = NIL;
	CHAR cmd[64], par[64], insert[64];
	Texts_Text t = NIL;
	INTEGER res = 0;
	Texts_Reader r = {0};
	CHAR ch = 0;
	Viewers_Viewer v = NIL;
	last = Dialogs_lastin;
	v = Oberon_Par->vwr;
	Oberon_Par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_OpenWriter(&DialogInsert_wr, Texts_Writer__typ);
	DialogInsert_ReadNameCmdPar((void*)cmd, 64, (void*)par, 64);
	Texts_WriteString(&DialogInsert_wr, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
	Texts_Append(Oberon_Par->text, DialogInsert_wr.buf);
	DialogInsert_ReadXYWH();
	o = __Dialogs_Panel_NamedObject(Dialogs_cmdPanel, (CHAR*)"l", (LONGINT)2);
	if (__ISP(o, DialogListBoxes_ItemDesc, 1)) {
		if ((*(DialogListBoxes_Item*)&o)->selline >= 0 && (*(DialogListBoxes_Item*)&o)->selline < DialogInsert_nrOfItems) {
			__COPY(DialogInsert_dlgItems[__X((*(DialogListBoxes_Item*)&o)->selline, 100)].cmd, insert, 64);
		}
	} else __WITHCHK;
	Oberon_Call(insert, 64, Oberon_Par, 0, &res);
	if (Dialogs_lastin != last && par[0] != 0x00) {
		__Dialogs_Object_SetPar(Dialogs_lastin, par, 64);
	}
	if (Dialogs_lastin != last && cmd[0] != 0x00) {
		__Dialogs_Object_SetCmd(Dialogs_lastin, cmd, 64);
	}
	t = __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text;
	Texts_OpenReader(&r, Texts_Reader__typ, t, t->len - 1);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	if (ch == '!') {
		Texts_Delete(t, t->len - 1, t->len);
	}
}

static void DialogInsert_Init (void)
{
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	t = TextFrames_Text((CHAR*)"DlgItems.Ini", (LONGINT)13);
	Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	DialogInsert_nrOfItems = -1;
	while (!s.eot) {
		if (s.class == 1) {
			DialogInsert_nrOfItems += 1;
			__COPY(s.s, DialogInsert_dlgItems[__X(DialogInsert_nrOfItems, 100)].name, 32);
			Texts_Scan(&s, Texts_Scanner__typ);
			__COPY(s.s, DialogInsert_dlgItems[__X(DialogInsert_nrOfItems, 100)].cmd, 48);
		}
		Texts_Scan(&s, Texts_Scanner__typ);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogInsert_wr, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogInsert_Item, 1, 0) = {__TDFLDS("Item", 80), {-4}};

export void *DialogInsert__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogListBoxes);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogInsert, EnumPtrs);
	__REGCMD("Do", DialogInsert_Do);
	__REGCMD("Open", DialogInsert_Open);
	__INITYP(DialogInsert_Item, DialogInsert_Item, 0);
/* BEGIN */
	DialogInsert_Init();
	__ENDMOD;
}
