/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogSliders.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogIntSliders_ItemDesc *DialogIntSliders_Item;

typedef
	struct DialogIntSliders_ItemDesc { /* DialogSliders_ItemDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[2];
		INTEGER sliderdY, delta;
		INTEGER maxValue;
	} DialogIntSliders_ItemDesc;

export LONGINT DialogIntSliders_Item_Arrow (DialogIntSliders_Item s, BOOLEAN down);
export void DialogIntSliders_Item_CheckdY (DialogIntSliders_Item s, INTEGER *dY);
export void DialogIntSliders_Item_Copy (DialogIntSliders_Item s, Dialogs_Object *dup);
export void DialogIntSliders_Item_DrawSlider (DialogIntSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
export void DialogIntSliders_Item_Init (DialogIntSliders_Item s);
export INTEGER DialogIntSliders_Item_MaxValue (DialogIntSliders_Item s);
export void DialogIntSliders_Item_MoveSlider (DialogIntSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER dY);
export void DialogIntSliders_Item_PrintSlider (DialogIntSliders_Item s, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void DialogIntSliders_Item_TrackScrollBar (DialogIntSliders_Item s, Display_Frame f, INTEGER mx, INTEGER my, SET keys);


export LONGINT DialogIntSliders_minusArrow, DialogIntSliders_plusArrow;
static SET DialogIntSliders_minusArrowImage[10], DialogIntSliders_plusArrowImage[10];
static Fonts_Font DialogIntSliders_fnt;

export LONGINT *DialogIntSliders_ItemDesc__typ;

export void DialogIntSliders_Insert (void);
static void DialogIntSliders_IntToChar (INTEGER x0, CHAR *a, LONGINT a__len);
static INTEGER DialogIntSliders_Max (INTEGER x, INTEGER y);
static INTEGER DialogIntSliders_Min (INTEGER x, INTEGER y);


static INTEGER DialogIntSliders_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER DialogIntSliders_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogIntSliders_Item_Init (DialogIntSliders_Item s)
{
	DialogSliders_Item_Init((void*)s);
	s->maxValue = 32767;
}

void DialogIntSliders_Item_Copy (DialogIntSliders_Item s, Dialogs_Object *dup)
{
	DialogIntSliders_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogIntSliders_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogIntSliders_ItemDesc, 2);
	}
	DialogSliders_Item_Copy((void*)s, &*dup);
}

INTEGER DialogIntSliders_Item_MaxValue (DialogIntSliders_Item s)
{
	return s->maxValue;
}

static void DialogIntSliders_IntToChar (INTEGER x0, CHAR *a, LONGINT a__len)
{
	INTEGER i = 0, j = 0;
	CHAR b[11];
	INTEGER _for__12 = 0;
	i = 0;
	x0 = DialogIntSliders_Max(0, x0);
	do {
		b[__X(i, 11)] = (CHAR)((int)__MOD(x0, 10) + 48);
		x0 = __DIV(x0, 10);
		i += 1;
	} while (!(x0 == 0));
	_for__12 = i - 1;
	j = 0;
	while (j <= _for__12) {
		a[__X(j, a__len)] = b[__X((i - 1) - j, 11)];
		j += 1;
	}
	a[__X(i, a__len)] = 0x00;
}

LONGINT DialogIntSliders_Item_Arrow (DialogIntSliders_Item s, BOOLEAN down)
{
	if (down) {
		return DialogIntSliders_minusArrow;
	} else {
		return DialogIntSliders_plusArrow;
	}
	__RETCHK;
}

void DialogIntSliders_Item_DrawSlider (DialogIntSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode)
{
	INTEGER dummy = 0;
	CHAR arr[11];
	LONGINT bgPat = 0;
	Display_ReplConstC(f, 0, x, y, w, h, 0);
	DialogIntSliders_IntToChar(s->sliderdY, (void*)arr, 11);
	if (h > w) {
		bgPat = DialogSliders_vBgPat;
	} else {
		bgPat = DialogSliders_hBgPat;
	}
	Display_ReplPatternC(f, 0, bgPat, x, y, w, h, 0, 0, mode);
	y = (y + __ASHR(h, 1)) - __ASHR(DialogIntSliders_fnt->maxY, 1);
	GraphicUtils_DrawString(f, arr, 11, x, y, w, DialogIntSliders_fnt, mode, 1, &dummy);
}

void DialogIntSliders_Item_MoveSlider (DialogIntSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER dY)
{
	INTEGER dummy = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR arr[11];
	LONGINT bgPat = 0;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	x = x + f->X;
	y = (y + f->Y) + f->H;
	if (w > h) {
		x = x + h;
		w = w - __ASHL(h, 1);
	} else {
		y = y + w;
		h = h - __ASHL(w, 1);
	}
	Display_ReplConstC(f, 0, x, y, w, h, 0);
	DialogIntSliders_IntToChar(dY, (void*)arr, 11);
	if (h > w) {
		bgPat = DialogSliders_vBgPat;
	} else {
		bgPat = DialogSliders_hBgPat;
	}
	Display_ReplPatternC(f, 0, bgPat, x, y, w, h, 0, 0, 1);
	y = (y + __ASHR(h, 1)) - __ASHR(DialogIntSliders_fnt->maxY, 1);
	GraphicUtils_DrawString(f, arr, 11, x, y, w, DialogIntSliders_fnt, 1, 1, &dummy);
}

void DialogIntSliders_Item_PrintSlider (DialogIntSliders_Item s, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	INTEGER dummy = 0;
	CHAR arr[11];
	GraphicUtils_PrintBox(x, y, w, h);
	DialogIntSliders_IntToChar(s->sliderdY, (void*)arr, 11);
	y = (y + __ASHR(h, 1)) - __ASHR((int)__DIV((LONGINT)DialogIntSliders_fnt->maxY * Dialogs_dUnit, Dialogs_pUnit), 1);
	GraphicUtils_PrintString(arr, 11, x, y, w, DialogIntSliders_fnt, 1, &dummy);
}

void DialogIntSliders_Item_CheckdY (DialogIntSliders_Item s, INTEGER *dY)
{
	*dY = DialogIntSliders_Max(0, *dY);
}

void DialogIntSliders_Item_TrackScrollBar (DialogIntSliders_Item s, Display_Frame f, INTEGER mx, INTEGER my, SET keys)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	Texts_Text t1 = NIL;
	INTEGER olddY = 0;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	x = x + f->X;
	y = (y + f->Y) + f->H;
	olddY = s->sliderdY;
	if (((keys == 0x02 || keys == 0x01) || keys == 0x04) && DialogIntSliders_Max(w, h) >= __ASHL(DialogIntSliders_Min(w, h), 1)) {
		Oberon_RemoveMarks(x, y, w, h);
		if (w > h) {
			if (mx < x + h) {
				__DialogSliders_Item_TrackButton((void*)s, f, x, y, h, mx, my, &keys, 1);
			} else if (mx >= (x + w) - h) {
				__DialogSliders_Item_TrackButton((void*)s, f, (x + w) - h, y, h, mx, my, &keys, 0);
			}
		} else {
			if (my < y + w) {
				__DialogSliders_Item_TrackButton((void*)s, f, x, y, w, mx, my, &keys, 1);
			} else if (my >= (y + h) - w) {
				__DialogSliders_Item_TrackButton((void*)s, f, x, (y + h) - w, w, mx, my, &keys, 0);
			}
		}
		if ((((keys == 0x02 || keys == 0x01) || keys == 0x04) && s->cmd[0] != 0x00) && olddY != s->sliderdY) {
			(*DialogTexts_GetParText)(s->par, 32, s->panel, &t1);
			__Dialogs_Object_CallCmd((void*)s, f, Viewers_This(x, y), t1);
		}
	}
}

void DialogIntSliders_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	Dialogs_Panel p = NIL;
	DialogIntSliders_Item s = NIL;
	CHAR name[64];
	__NEW(s, DialogIntSliders_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)s);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)s, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 70;
			h = 20;
		} else {
			if (w < 0) {
				w = 70;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)s, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)s, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogIntSliders", (LONGINT)17);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(DialogIntSliders_fnt);
}

__TDESC(DialogIntSliders_ItemDesc, 39, 2) = {__TDFLDS("ItemDesc", 116), {0, 104, -12}};

export void *DialogIntSliders__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogSliders);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogIntSliders, EnumPtrs);
	__REGCMD("Insert", DialogIntSliders_Insert);
	__INITYP(DialogIntSliders_ItemDesc, DialogSliders_ItemDesc, 2);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_Arrow, 24);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_CheckdY, 27);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_Copy, 1);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_DrawSlider, 29);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_Init, 8);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_MaxValue, 30);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_MoveSlider, 31);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_PrintSlider, 33);
	__INITBP(DialogIntSliders_ItemDesc, DialogIntSliders_Item_TrackScrollBar, 36);
/* BEGIN */
	DialogIntSliders_minusArrowImage[0] = 0x0;
	DialogIntSliders_plusArrowImage[0] = 0x0;
	DialogIntSliders_minusArrowImage[1] = 0x0;
	DialogIntSliders_plusArrowImage[1] = 0x38;
	DialogIntSliders_minusArrowImage[2] = 0x0;
	DialogIntSliders_plusArrowImage[2] = 0x38;
	DialogIntSliders_minusArrowImage[3] = 0x0;
	DialogIntSliders_plusArrowImage[3] = 0x38;
	DialogIntSliders_minusArrowImage[4] = 0x01ff;
	DialogIntSliders_plusArrowImage[4] = 0x01ff;
	DialogIntSliders_minusArrowImage[5] = 0x01ff;
	DialogIntSliders_plusArrowImage[5] = 0x01ff;
	DialogIntSliders_minusArrowImage[6] = 0x01ff;
	DialogIntSliders_plusArrowImage[6] = 0x01ff;
	DialogIntSliders_minusArrowImage[7] = 0x0;
	DialogIntSliders_plusArrowImage[7] = 0x38;
	DialogIntSliders_minusArrowImage[8] = 0x0;
	DialogIntSliders_plusArrowImage[8] = 0x38;
	DialogIntSliders_minusArrowImage[9] = 0x0;
	DialogIntSliders_plusArrowImage[9] = 0x38;
	DialogIntSliders_minusArrow = Display_NewPattern((void*)DialogIntSliders_minusArrowImage, 10, 9, 9);
	DialogIntSliders_plusArrow = Display_NewPattern((void*)DialogIntSliders_plusArrowImage, 10, 9, 9);
	DialogIntSliders_fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__ENDMOD;
}
