/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogGroupBoxes.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogRadioButtons_ItemDesc *DialogRadioButtons_Item;

typedef
	struct DialogRadioButtons_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
		BOOLEAN on;
	} DialogRadioButtons_ItemDesc;

export void DialogRadioButtons_Item_ChangeValue (DialogRadioButtons_Item r, BOOLEAN value);
export void DialogRadioButtons_Item_Copy (DialogRadioButtons_Item r, Dialogs_Object *dup);
export void DialogRadioButtons_Item_Draw (DialogRadioButtons_Item r, INTEGER x, INTEGER y, Display_Frame f);
export void DialogRadioButtons_Item_Handle (DialogRadioButtons_Item r, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogRadioButtons_Item_Print (DialogRadioButtons_Item r, INTEGER x, INTEGER y);
static void DialogRadioButtons_Item_Track (DialogRadioButtons_Item r, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogRadioButtons_Item_ChangeValue(r, value) __SEND(__TYPEOF(r), 24, void(*)(DialogRadioButtons_Item, BOOLEAN), (r, value))
#define __DialogRadioButtons_Item_Track(r, x, y, keys, f, p) __SEND(__TYPEOF(r), 25, void(*)(DialogRadioButtons_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (r, x, y, keys, f, p))


static Texts_Writer DialogRadioButtons_w;

export LONGINT *DialogRadioButtons_ItemDesc__typ;

export void DialogRadioButtons_Insert (void);
static INTEGER DialogRadioButtons_Min (INTEGER x, INTEGER y);


static INTEGER DialogRadioButtons_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogRadioButtons_Item_Draw (DialogRadioButtons_Item r, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, rx = 0, ry = 0, i = 0, y1 = 0, w2 = 0, _for__5 = 0;
	__Dialogs_Object_GetDim((void*)r, &rx, &ry, &w, &h);
	w -= 1;
	h -= 1;
	w = DialogRadioButtons_Min(w, h);
	if (r->selected) {
		mode = 2;
	} else {
		mode = 0;
	}
	w2 = __ASHR(w, 1);
	w = __ASHL(w2, 1);
	if (r->on) {
		Display1_Line(f, 15, x, y + w2, x + w2, y + w, mode);
		Display1_Line(f, 15, x + w, y + w2, x + w2, y + w, mode);
		Display1_Line(f, 0, x, y + w2, x + w2, y, mode);
		Display1_Line(f, 0, x + w, y + w2, x + w2, y, mode);
		i = -__DIV(w * 5, 20);
		while (i <= 0) {
			y1 = ((y + w2) + __DIV(w * 5, 20)) + i;
			Display1_Line(f, 15, (x + w2) + i, y1, (x + w2) - i, y1, mode);
			i += 1;
		}
		_for__5 = __DIV(w * 5, 20);
		i = 0;
		while (i <= _for__5) {
			y1 = (y + w2) - i;
			Display1_Line(f, 15, ((x + w2) - __DIV(w * 5, 20)) + i, y1, ((x + w2) + __DIV(w * 5, 20)) - i, y1, mode);
			i += 1;
		}
	} else {
		Display1_Line(f, 0, x, y + w2, x + w2, y + w, mode);
		Display1_Line(f, 0, x + w, y + w2, x + w2, y + w, mode);
		Display1_Line(f, 15, x, y + w2, x + w2, y, mode);
		Display1_Line(f, 15, x + w, y + w2, x + w2, y, mode);
	}
}

void DialogRadioButtons_Item_Print (DialogRadioButtons_Item r, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, rx = 0, ry = 0, i = 0, y1 = 0, _for__8 = 0;
	__Dialogs_Object_GetPDim((void*)r, &rx, &ry, &w, &h);
	w -= 1;
	h -= 1;
	w = DialogRadioButtons_Min(w, h);
	Printer_Line(x + w, y + __ASHR(w, 1), x + __ASHR(w, 1), y + w);
	Printer_Line(x + w, y + __ASHR(w, 1), x + __ASHR(w, 1), y);
	Printer_Line(x, y + __ASHR(w, 1), x + __ASHR(w, 1), y + w);
	Printer_Line(x, y + __ASHR(w, 1), x + __ASHR(w, 1), y);
	if (r->on) {
		i = -__DIV(w * 5, 20);
		while (i <= 0) {
			y1 = ((y + __ASHR(w, 1)) + __DIV(w * 5, 20)) + i;
			Printer_Line((x + __ASHR(w, 1)) + i, y1, (x + __ASHR(w, 1)) - i, y1);
			i += 1;
		}
		_for__8 = __DIV(w * 5, 20);
		i = 0;
		while (i <= _for__8) {
			y1 = (y + __ASHR(w, 1)) - i;
			Printer_Line(((x + __ASHR(w, 1)) - __DIV(w * 5, 20)) + i, y1, ((x + __ASHR(w, 1)) + __DIV(w * 5, 20)) - i, y1);
			i += 1;
		}
	}
}

void DialogRadioButtons_Item_Copy (DialogRadioButtons_Item r, Dialogs_Object *dup)
{
	DialogRadioButtons_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogRadioButtons_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogRadioButtons_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)r, &*dup);
	x->on = r->on;
}

void DialogRadioButtons_Item_ChangeValue (DialogRadioButtons_Item r, BOOLEAN value)
{
	Dialogs_Object g = NIL, o = NIL;
	Dialogs_Object obArray[50];
	INTEGER nofelems = 0, i = 0, _for__2 = 0;
	if (r->on == value) {
		return;
	}
	__Dialogs_Object_Hide((void*)r);
	r->on = value;
	__Dialogs_Object_Restore((void*)r);
	if (value == 0) {
		return;
	}
	g = __Dialogs_Object_OverlappingObject((void*)r);
	if (g == NIL) {
		return;
	}
	if (__ISP(g, DialogGroupBoxes_ItemDesc, 1)) {
		__DialogGroupBoxes_Item_GetObjects((*(DialogGroupBoxes_Item*)&g), (void*)obArray, 50, &nofelems);
		_for__2 = nofelems - 1;
		i = 0;
		while (i <= _for__2) {
			o = obArray[__X(i, 50)];
			if (o != (void *) r) {
				if (__ISP(o, DialogRadioButtons_ItemDesc, 1)) {
					if ((*(DialogRadioButtons_Item*)&o)->on) {
						__Dialogs_Object_Hide((void*)(*(DialogRadioButtons_Item*)&o));
						(*(DialogRadioButtons_Item*)&o)->on = 0;
						__Dialogs_Object_Restore((void*)(*(DialogRadioButtons_Item*)&o));
					}
				}
			}
			i += 1;
		}
	}
}

static void DialogRadioButtons_Item_Track (DialogRadioButtons_Item r, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	CHAR name[64];
	CHAR dummy[6];
	Texts_Text t = NIL;
	if ((keys == 0x01 || keys == 0x02) || keys == 0x04) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		if ((keysum == 0x01 || keysum == 0x02) || keysum == 0x04 && !r->on) {
			__DialogRadioButtons_Item_ChangeValue(r, 1);
			if (r->cmd[0] != 0x00) {
				(*DialogTexts_GetParText)(r->par, 32, r->panel, &t);
				__Dialogs_Object_CallCmd((void*)r, f, Viewers_This(x, y), t);
			}
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogRadioButtons_Item_Handle (DialogRadioButtons_Item r, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)r, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogRadioButtons_Item_Track(r, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		}
	}
}

void DialogRadioButtons_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogRadioButtons_Item r = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(r, DialogRadioButtons_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)r);
		r->on = 0;
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)r, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 20;
			h = 20;
		} else {
			if (w < 0) {
				w = 20;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)r, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)r, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogRadioButtons", (LONGINT)19);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogRadioButtons_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogRadioButtons_ItemDesc, 27, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};

export void *DialogRadioButtons__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogGroupBoxes);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogRadioButtons, EnumPtrs);
	__REGCMD("Insert", DialogRadioButtons_Insert);
	__INITYP(DialogRadioButtons_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogRadioButtons_ItemDesc, DialogRadioButtons_Item_ChangeValue, 24);
	__INITBP(DialogRadioButtons_ItemDesc, DialogRadioButtons_Item_Copy, 1);
	__INITBP(DialogRadioButtons_ItemDesc, DialogRadioButtons_Item_Draw, 2);
	__INITBP(DialogRadioButtons_ItemDesc, DialogRadioButtons_Item_Handle, 6);
	__INITBP(DialogRadioButtons_ItemDesc, DialogRadioButtons_Item_Print, 14);
	__INITBP(DialogRadioButtons_ItemDesc, DialogRadioButtons_Item_Track, 25);
/* BEGIN */
	Texts_OpenWriter(&DialogRadioButtons_w, Texts_Writer__typ);
	__ENDMOD;
}
