/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogRectangles_ItemDesc *DialogRectangles_Item;

typedef
	struct DialogRectangles_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} DialogRectangles_ItemDesc;

export void DialogRectangles_Item_Copy (DialogRectangles_Item r, Dialogs_Object *dup);
export void DialogRectangles_Item_Draw (DialogRectangles_Item r, INTEGER x, INTEGER y, Display_Frame f);
export void DialogRectangles_Item_Handle (DialogRectangles_Item r, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogRectangles_Item_Print (DialogRectangles_Item r, INTEGER x, INTEGER y);
static void DialogRectangles_Item_Track (DialogRectangles_Item r, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogRectangles_Item_Track(r, x, y, keys, f, p) __SEND(__TYPEOF(r), 24, void(*)(DialogRectangles_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (r, x, y, keys, f, p))



export LONGINT *DialogRectangles_ItemDesc__typ;

export void DialogRectangles_Insert (void);


void DialogRectangles_Item_Draw (DialogRectangles_Item r, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, bx = 0, by = 0;
	__Dialogs_Object_GetDim((void*)r, &bx, &by, &w, &h);
	w -= 1;
	h -= 1;
	if (r->selected) {
		mode = 2;
	} else {
		mode = 0;
	}
	Display1_Line(f, 15, x, y, x + w, y, mode);
	Display1_Line(f, 15, x, y, x, y + h, mode);
	Display1_Line(f, 15, x + w, y, x + w, y + h, mode);
	Display1_Line(f, 15, x, y + h, x + w, y + h, mode);
}

void DialogRectangles_Item_Print (DialogRectangles_Item r, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, bx = 0, by = 0;
	__Dialogs_Object_GetPDim((void*)r, &bx, &by, &w, &h);
	GraphicUtils_PrintBox(x, y, w, h);
}

void DialogRectangles_Item_Copy (DialogRectangles_Item r, Dialogs_Object *dup)
{
	DialogRectangles_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogRectangles_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogRectangles_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)r, &*dup);
}

static void DialogRectangles_Item_Track (DialogRectangles_Item r, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	Texts_Text t = NIL;
	if (keys == 0x02) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		if (keysum == 0x02) {
			if (r->cmd[0] != 0x00) {
				(*DialogTexts_GetParText)(r->par, 32, r->panel, &t);
				__Dialogs_Object_CallCmd((void*)r, f, Viewers_This(x, y), t);
			}
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogRectangles_Item_Handle (DialogRectangles_Item r, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)r, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogRectangles_Item_Track(r, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		}
	}
}

void DialogRectangles_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogRectangles_Item l = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(l, DialogRectangles_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)l);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)l, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 30;
			h = 20;
		} else {
			if (w < 0) {
				w = 30;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)l, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)l, 1);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogRectangles", (LONGINT)17);
	}
}

__TDESC(DialogRectangles_ItemDesc, 26, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};

export void *DialogRectangles__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogRectangles, 0);
	__REGCMD("Insert", DialogRectangles_Insert);
	__INITYP(DialogRectangles_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogRectangles_ItemDesc, DialogRectangles_Item_Copy, 1);
	__INITBP(DialogRectangles_ItemDesc, DialogRectangles_Item_Draw, 2);
	__INITBP(DialogRectangles_ItemDesc, DialogRectangles_Item_Handle, 6);
	__INITBP(DialogRectangles_ItemDesc, DialogRectangles_Item_Print, 14);
	__INITBP(DialogRectangles_ItemDesc, DialogRectangles_Item_Track, 24);
/* BEGIN */
	__ENDMOD;
}
