/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogStaticTexts.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogSliders_ItemDesc *DialogSliders_Item;

typedef
	struct DialogSliders_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[2];
		INTEGER sliderdY, delta;
	} DialogSliders_ItemDesc;

export LONGINT DialogSliders_Item_Arrow (DialogSliders_Item s, BOOLEAN down);
static INTEGER DialogSliders_Item_CalculatesH (DialogSliders_Item s);
static void DialogSliders_Item_Change (DialogSliders_Item s, INTEGER delta, BOOLEAN pressed, INTEGER x, INTEGER y);
export void DialogSliders_Item_CheckdY (DialogSliders_Item s, INTEGER *dY);
export void DialogSliders_Item_Copy (DialogSliders_Item s, Dialogs_Object *dup);
export void DialogSliders_Item_Draw (DialogSliders_Item s, INTEGER x, INTEGER y, Display_Frame f);
static void DialogSliders_Item_DrawButton (DialogSliders_Item s, Display_Frame f, BOOLEAN pr, LONGINT but, INTEGER x, INTEGER y, INTEGER w, INTEGER mode);
export void DialogSliders_Item_DrawSlider (DialogSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
export void DialogSliders_Item_Edit (DialogSliders_Item t);
export void DialogSliders_Item_Handle (DialogSliders_Item s, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void DialogSliders_Item_Init (DialogSliders_Item s);
export void DialogSliders_Item_Load (DialogSliders_Item s, Files_Rider *r, LONGINT *r__typ);
export INTEGER DialogSliders_Item_MaxValue (DialogSliders_Item s);
export void DialogSliders_Item_MoveSlider (DialogSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER dY);
export void DialogSliders_Item_Print (DialogSliders_Item s, INTEGER x, INTEGER y);
static void DialogSliders_Item_PrintButton (DialogSliders_Item s, LONGINT but, INTEGER x, INTEGER y, INTEGER w);
export void DialogSliders_Item_PrintSlider (DialogSliders_Item s, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void DialogSliders_Item_SetdY (DialogSliders_Item s, INTEGER dY);
export void DialogSliders_Item_Store (DialogSliders_Item s, Files_Rider *r, LONGINT *r__typ);
export void DialogSliders_Item_TrackButton (DialogSliders_Item s, Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER mx, INTEGER my, SET *keysum, BOOLEAN down);
export void DialogSliders_Item_TrackScrollBar (DialogSliders_Item s, Display_Frame f, INTEGER mx, INTEGER my, SET keys);
static void DialogSliders_Item_TrackSlider (DialogSliders_Item s, Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mx, INTEGER my, SET *keysum);
export void DialogSliders_Item_Update (DialogSliders_Item t, Dialogs_Panel p);
#define __DialogSliders_Item_Arrow(s, down) __SEND(__TYPEOF(s), 24, LONGINT(*)(DialogSliders_Item, BOOLEAN), (s, down))
#define __DialogSliders_Item_CalculatesH(s) __SEND(__TYPEOF(s), 25, INTEGER(*)(DialogSliders_Item), (s))
#define __DialogSliders_Item_Change(s, delta, pressed, x, y) __SEND(__TYPEOF(s), 26, void(*)(DialogSliders_Item, INTEGER, BOOLEAN, INTEGER, INTEGER), (s, delta, pressed, x, y))
#define __DialogSliders_Item_CheckdY(s, dY) __SEND(__TYPEOF(s), 27, void(*)(DialogSliders_Item, INTEGER*), (s, dY))
#define __DialogSliders_Item_DrawButton(s, f, pr, but, x, y, w, mode) __SEND(__TYPEOF(s), 28, void(*)(DialogSliders_Item, Display_Frame, BOOLEAN, LONGINT, INTEGER, INTEGER, INTEGER, INTEGER), (s, f, pr, but, x, y, w, mode))
#define __DialogSliders_Item_DrawSlider(s, f, pressed, x, y, w, h, mode) __SEND(__TYPEOF(s), 29, void(*)(DialogSliders_Item, Display_Frame, BOOLEAN, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (s, f, pressed, x, y, w, h, mode))
#define __DialogSliders_Item_MaxValue(s) __SEND(__TYPEOF(s), 30, INTEGER(*)(DialogSliders_Item), (s))
#define __DialogSliders_Item_MoveSlider(s, f, pressed, dY) __SEND(__TYPEOF(s), 31, void(*)(DialogSliders_Item, Display_Frame, BOOLEAN, INTEGER), (s, f, pressed, dY))
#define __DialogSliders_Item_PrintButton(s, but, x, y, w) __SEND(__TYPEOF(s), 32, void(*)(DialogSliders_Item, LONGINT, INTEGER, INTEGER, INTEGER), (s, but, x, y, w))
#define __DialogSliders_Item_PrintSlider(s, x, y, w, h) __SEND(__TYPEOF(s), 33, void(*)(DialogSliders_Item, INTEGER, INTEGER, INTEGER, INTEGER), (s, x, y, w, h))
#define __DialogSliders_Item_SetdY(s, dY) __SEND(__TYPEOF(s), 34, void(*)(DialogSliders_Item, INTEGER), (s, dY))
#define __DialogSliders_Item_TrackButton(s, f, x, y, w, mx, my, keysum, down) __SEND(__TYPEOF(s), 35, void(*)(DialogSliders_Item, Display_Frame, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, SET*, BOOLEAN), (s, f, x, y, w, mx, my, keysum, down))
#define __DialogSliders_Item_TrackScrollBar(s, f, mx, my, keys) __SEND(__TYPEOF(s), 36, void(*)(DialogSliders_Item, Display_Frame, INTEGER, INTEGER, SET), (s, f, mx, my, keys))
#define __DialogSliders_Item_TrackSlider(s, f, x, y, w, h, mx, my, keysum) __SEND(__TYPEOF(s), 37, void(*)(DialogSliders_Item, Display_Frame, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, SET*), (s, f, x, y, w, h, mx, my, keysum))

typedef
	struct DialogSliders_MoveSliderMsg { /* Display_FrameMsg */
		DialogSliders_Item s;
		INTEGER x, y, dY;
		BOOLEAN pressed;
	} DialogSliders_MoveSliderMsg;


export LONGINT DialogSliders_hBgPat, DialogSliders_vBgPat, DialogSliders_downArrow, DialogSliders_upArrow, DialogSliders_leftArrow, DialogSliders_rightArrow;
static SET DialogSliders_downArrowImage[9], DialogSliders_upArrowImage[9], DialogSliders_Hpat[9], DialogSliders_Vpat[9];
static SET DialogSliders_leftArrowImage[20], DialogSliders_rightArrowImage[20];
static Texts_Writer DialogSliders_w0;

export LONGINT *DialogSliders_ItemDesc__typ;
export LONGINT *DialogSliders_MoveSliderMsg__typ;

export void DialogSliders_Insert (void);
static INTEGER DialogSliders_Max (INTEGER x, INTEGER y);
static INTEGER DialogSliders_Min (INTEGER x, INTEGER y);
static void DialogSliders_WriteToObjectInt (DialogTexts_Item o, INTEGER n);


static INTEGER DialogSliders_Min (INTEGER x, INTEGER y)
{
	if (x > y) {
		return y;
	} else {
		return x;
	}
	__RETCHK;
}

static INTEGER DialogSliders_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogSliders_Item_Copy (DialogSliders_Item s, Dialogs_Object *dup)
{
	DialogSliders_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogSliders_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogSliders_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)s, &*dup);
	x->delta = s->delta;
}

void DialogSliders_Item_Load (DialogSliders_Item s, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Load((void*)s, &*r, r__typ);
	Files_ReadInt(&*r, r__typ, &s->delta);
	s->sliderdY = 0;
}

void DialogSliders_Item_Store (DialogSliders_Item s, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Store((void*)s, &*r, r__typ);
	Files_WriteInt(&*r, r__typ, s->delta);
}

void DialogSliders_Item_Init (DialogSliders_Item s)
{
	Dialogs_Object_Init((void*)s);
	s->delta = 1;
}

static void DialogSliders_Item_DrawButton (DialogSliders_Item s, Display_Frame f, BOOLEAN pr, LONGINT but, INTEGER x, INTEGER y, INTEGER w, INTEGER mode)
{
	INTEGER i = 0;
	i = __ASHR(w - 9, 1);
	GraphicUtils_DrawPatternBox(f, pr, but, x, y, w, w, i, i, mode);
}

static void DialogSliders_Item_PrintButton (DialogSliders_Item s, LONGINT but, INTEGER x, INTEGER y, INTEGER w)
{
	INTEGER i = 0;
	i = __ASHR(w - 9, 1);
	i = (int)__DIV((LONGINT)i * Dialogs_dUnit, Dialogs_pUnit);
	GraphicUtils_PrintPatternBox(but, x, y, w, w, i, i);
}

static INTEGER DialogSliders_Item_CalculatesH (DialogSliders_Item s)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	return DialogSliders_Min(w, h) + __ASHR(DialogSliders_Min(w, h), 1);
}

INTEGER DialogSliders_Item_MaxValue (DialogSliders_Item s)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	x = DialogSliders_Max(w, h) - __ASHL(DialogSliders_Min(w, h), 1);
	return DialogSliders_Max(x, 0);
}

LONGINT DialogSliders_Item_Arrow (DialogSliders_Item s, BOOLEAN down)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	if (w > h) {
		if (down) {
			return DialogSliders_rightArrow;
		} else {
			return DialogSliders_leftArrow;
		}
	} else {
		if (down) {
			return DialogSliders_downArrow;
		} else {
			return DialogSliders_upArrow;
		}
	}
	__RETCHK;
}

void DialogSliders_Item_DrawSlider (DialogSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode)
{
	INTEGER sdY = 0, sH = 0;
	sdY = s->sliderdY;
	sH = __DialogSliders_Item_CalculatesH(s);
	Display_ReplConstC(f, 0, x, y, w, h, 0);
	if (h > w) {
		Display_ReplPatternC(f, 14, DialogSliders_vBgPat, x, y, w, h, 0, 0, mode);
		if (sH <= h) {
			GraphicUtils_DrawBox(f, pressed, x, y + sdY, w, sH, mode);
		}
	} else {
		Display_ReplPatternC(f, 14, DialogSliders_hBgPat, x, y, w, h, 0, 0, mode);
		if (sH <= w) {
			GraphicUtils_DrawBox(f, pressed, x + sdY, y, sH, h, mode);
		}
	}
}

void DialogSliders_Item_PrintSlider (DialogSliders_Item s, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	INTEGER sdY = 0, sH = 0;
	sdY = (int)__DIV((LONGINT)s->sliderdY * Dialogs_dUnit, Dialogs_pUnit);
	sH = (int)__DIVF((LONGINT)__DialogSliders_Item_CalculatesH(s) * Dialogs_dUnit, Dialogs_pUnit);
	GraphicUtils_PrintBox(x, y, w, h);
	if (h > w) {
		if (sH <= h) {
			GraphicUtils_PrintBox(x, y + sdY, w, sH);
		}
	} else {
		if (sH <= w) {
			GraphicUtils_PrintBox(x + sdY, y, sH, h);
		}
	}
}

void DialogSliders_Item_CheckdY (DialogSliders_Item s, INTEGER *dY)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, sH = 0;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	sH = __DialogSliders_Item_CalculatesH(s);
	if (w > h) {
		w = w - __ASHL(h, 1);
		*dY = DialogSliders_Max(0, *dY);
		*dY = DialogSliders_Min(*dY, w - sH);
	} else {
		h = h - __ASHL(w, 1);
		*dY = DialogSliders_Max(0, *dY);
		*dY = DialogSliders_Min(*dY, h - sH);
	}
}

static void DialogSliders_Item_Change (DialogSliders_Item s, INTEGER delta, BOOLEAN pressed, INTEGER x, INTEGER y)
{
	DialogSliders_MoveSliderMsg msg = {0};
	INTEGER dY = 0;
	dY = s->sliderdY + delta;
	__DialogSliders_Item_CheckdY(s, &dY);
	msg.s = s;
	msg.dY = dY;
	msg.x = x;
	msg.y = y;
	msg.pressed = pressed;
	Viewers_Broadcast((void*)&msg, DialogSliders_MoveSliderMsg__typ);
	s->sliderdY = dY;
}

void DialogSliders_Item_TrackButton (DialogSliders_Item s, Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER mx, INTEGER my, SET *keysum, BOOLEAN down)
{
	BOOLEAN pressed = 0, oldpressed = 0, first = 0;
	SET keys = 0;
	LONGINT arrow = 0, i = 0;
	pressed = 0;
	first = 1;
	do {
		oldpressed = pressed;
		pressed = ((x <= mx && mx <= x + w) && y <= my) && my <= y + w;
		arrow = __DialogSliders_Item_Arrow(s, down);
		if (oldpressed != pressed) {
			__DialogSliders_Item_DrawButton(s, f, pressed, arrow, x, y, w, 1);
		}
		if (pressed && ((*keysum == 0x02 || *keysum == 0x01) || *keysum == 0x04)) {
			i = Oberon_Time();
			while (Oberon_Time() - i < 300) {
			}
			first = 0;
			if (down) {
				__DialogSliders_Item_Change(s, -s->delta, 0, 0, 0);
			} else {
				__DialogSliders_Item_Change(s, s->delta, 0, 0, 0);
			}
		}
		Input_Mouse(&keys, &mx, &my);
		*keysum = *keysum | keys;
	} while (!(keys == 0x0));
	if (pressed) {
		__DialogSliders_Item_DrawButton(s, f, 0, arrow, x, y, w, 1);
	}
}

void DialogSliders_Item_MoveSlider (DialogSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER dY)
{
	INTEGER i = 0, sdY = 0, x = 0, y = 0, w = 0, h = 0, sH = 0;
	sdY = s->sliderdY;
	sH = __DialogSliders_Item_CalculatesH(s);
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	x = x + f->X;
	y = (y + f->Y) + f->H;
	if (w > h) {
		x = x + h;
		w = w - __ASHL(h, 1);
	} else {
		y = y + w;
		h = h - __ASHL(w, 1);
	}
	if (sH > DialogSliders_Max(w, h)) {
		return;
	}
	if (w > h) {
		if (dY > sdY) {
			i = x + sdY;
		} else {
			i = (x + dY) + sH;
		}
		Display_ReplConstC(f, 0, i, y, __ABS(dY - sdY), h, 0);
		Display_ReplPatternC(f, 14, DialogSliders_hBgPat, i, y, __ABS(dY - sdY), h, 0, 0, 1);
		GraphicUtils_DrawBox(f, pressed, x + dY, y, sH, h, 1);
	} else {
		if (dY > sdY) {
			i = y + sdY;
		} else {
			i = (y + dY) + sH;
		}
		Display_ReplConstC(f, 0, x, i, w, __ABS(dY - sdY), 0);
		Display_ReplPatternC(f, 14, DialogSliders_vBgPat, x, i, w, __ABS(dY - sdY), 0, 0, 1);
		GraphicUtils_DrawBox(f, pressed, x, y + dY, w, sH, 1);
	}
}

static void DialogSliders_Item_TrackSlider (DialogSliders_Item s, Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mx, INTEGER my, SET *keysum)
{
	BOOLEAN pressed = 0, oldPressed = 0;
	SET keys = 0;
	INTEGER sH = 0, dY = 0, dYOld = 0, x0 = 0, y0 = 0, w0 = 0, h0 = 0;
	sH = __DialogSliders_Item_CalculatesH(s);
	dYOld = s->sliderdY;
	pressed = 0;
	__Dialogs_Object_GetDim((void*)s, &x0, &y0, &w0, &h0);
	do {
		if (h0 > w0) {
			dY = (my - y) - sH;
		} else {
			dY = (mx - x) - sH;
		}
		__DialogSliders_Item_CheckdY(s, &dY);
		oldPressed = pressed;
		pressed = ((x <= mx && mx <= x + w) && y <= my) && my <= y + h;
		if (oldPressed != pressed) {
			if (h > w) {
				GraphicUtils_DrawBox(f, pressed, x, y + s->sliderdY, w, sH, 1);
			} else {
				GraphicUtils_DrawBox(f, pressed, x + s->sliderdY, y, sH, h, 1);
			}
		} else if (dY != s->sliderdY) {
			__DialogSliders_Item_Change(s, dY - s->sliderdY, pressed, x, y);
		}
		Input_Mouse(&keys, &mx, &my);
		*keysum = *keysum | keys;
	} while (!(keys == 0x0));
	if (((*keysum == 0x02 || *keysum == 0x04) || *keysum == 0x01) || dYOld == s->sliderdY) {
		if (pressed) {
			__Dialogs_Object_Restore((void*)s);
		}
	} else {
		__DialogSliders_Item_Change(s, dYOld - s->sliderdY, 0, 0, 0);
	}
}

void DialogSliders_Item_TrackScrollBar (DialogSliders_Item s, Display_Frame f, INTEGER mx, INTEGER my, SET keys)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	Texts_Text t1 = NIL;
	__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
	x = x + f->X;
	y = (y + f->Y) + f->H;
	if (((keys == 0x02 || keys == 0x01) || keys == 0x04) && DialogSliders_Max(w, h) >= __ASHL(DialogSliders_Min(w, h), 1)) {
		Oberon_RemoveMarks(x, y, w, h);
		if (w > h) {
			if (mx < x + h) {
				__DialogSliders_Item_TrackButton(s, f, x, y, h, mx, my, &keys, 1);
			} else if (mx >= (x + w) - h) {
				__DialogSliders_Item_TrackButton(s, f, (x + w) - h, y, h, mx, my, &keys, 0);
			} else if (w >= __ASHL(DialogSliders_Min(w, h), 1) + __DialogSliders_Item_CalculatesH(s)) {
				__DialogSliders_Item_TrackSlider(s, f, x + h, y, w - __ASHL(h, 1), h, mx, my, &keys);
			}
		} else {
			if (my < y + w) {
				__DialogSliders_Item_TrackButton(s, f, x, y, w, mx, my, &keys, 1);
			} else if (my >= (y + h) - w) {
				__DialogSliders_Item_TrackButton(s, f, x, (y + h) - w, w, mx, my, &keys, 0);
			} else if (h >= __ASHL(DialogSliders_Min(w, h), 1) + __DialogSliders_Item_CalculatesH(s)) {
				__DialogSliders_Item_TrackSlider(s, f, x, y + w, w, h - __ASHL(w, 1), mx, my, &keys);
			}
		}
		if ((keys == 0x02 || keys == 0x01) || keys == 0x04 && s->cmd[0] != 0x00) {
			(*DialogTexts_GetParText)(s->par, 32, s->panel, &t1);
			__Dialogs_Object_CallCmd((void*)s, f, Viewers_This(x, y), t1);
		}
	}
}

void DialogSliders_Item_Handle (DialogSliders_Item s, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	BOOLEAN pressed = 0;
	Dialogs_Object_Handle((void*)s, f, &*msg, msg__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 1) {
				__DialogSliders_Item_TrackScrollBar(s, (void*)(*(DialogFrames_Frame*)&f), (*msg__).X, (*msg__).Y, (*msg__).keys);
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*msg__).X, (*msg__).Y);
			}
		} else if (__IS(msg__typ, DialogSliders_MoveSliderMsg, 1)) {
			DialogSliders_MoveSliderMsg *msg__ = (void*)msg;
			if ((*msg__).s == s) {
				__Dialogs_Object_GetDim((void*)s, &x, &y, &w, &h);
				x = x + (*(DialogFrames_Frame*)&f)->X;
				y = (y + (*(DialogFrames_Frame*)&f)->Y) + (*(DialogFrames_Frame*)&f)->H;
				pressed = ((h > w && x == (*msg__).x) && y + w == (*msg__).y || (w > h && x + h == (*msg__).x) && y == (*msg__).y) && (*msg__).pressed;
				__DialogSliders_Item_MoveSlider(s, (void*)(*(DialogFrames_Frame*)&f), pressed, (*msg__).dY);
			}
		}
	}
}

void DialogSliders_Item_Draw (DialogSliders_Item s, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER x0 = 0, y0 = 0, w = 0, h = 0, mode = 0;
	LONGINT bgPat = 0, up = 0, down = 0;
	if (s->selected) {
		mode = 2;
	} else {
		mode = 1;
	}
	__Dialogs_Object_GetDim((void*)s, &x0, &y0, &w, &h);
	up = __DialogSliders_Item_Arrow(s, 0);
	down = __DialogSliders_Item_Arrow(s, 1);
	if (w > h) {
		bgPat = DialogSliders_hBgPat;
	} else {
		bgPat = DialogSliders_vBgPat;
	}
	if (DialogSliders_Max(w, h) >= __ASHL(DialogSliders_Min(w, h), 1) && DialogSliders_Min(w, h) >= 14) {
		if (w > h) {
			__DialogSliders_Item_DrawButton(s, f, 0, down, x, y, h, mode);
			__DialogSliders_Item_DrawSlider(s, f, 0, x + h, y, w - __ASHL(h, 1), h, mode);
			__DialogSliders_Item_DrawButton(s, f, 0, up, (x + w) - h, y, h, mode);
		} else {
			__DialogSliders_Item_DrawButton(s, f, 0, up, x, (y + h) - w, w, mode);
			__DialogSliders_Item_DrawSlider(s, f, 0, x, y + w, w, h - __ASHL(w, 1), mode);
			__DialogSliders_Item_DrawButton(s, f, 0, down, x, y, w, mode);
		}
	} else {
		Display_ReplConstC(f, 0, x, y, w, h, 0);
		Display_ReplPatternC(f, 14, bgPat, x, y, w, h, 0, 0, mode);
	}
}

void DialogSliders_Item_Print (DialogSliders_Item s, INTEGER x, INTEGER y)
{
	INTEGER x0 = 0, y0 = 0, w = 0, h = 0;
	LONGINT up = 0, down = 0;
	__Dialogs_Object_GetPDim((void*)s, &x0, &y0, &w, &h);
	up = __DialogSliders_Item_Arrow(s, 0);
	down = __DialogSliders_Item_Arrow(s, 1);
	if (DialogSliders_Max(w, h) >= __ASHL(DialogSliders_Min(w, h), 1) && DialogSliders_Min(w, h) >= 14) {
		if (w > h) {
			__DialogSliders_Item_PrintButton(s, down, x, y, h);
			__DialogSliders_Item_PrintSlider(s, x + h, y, w - __ASHL(h, 1), h);
			__DialogSliders_Item_PrintButton(s, up, (x + w) - h, y, h);
		} else {
			__DialogSliders_Item_PrintButton(s, up, x, (y + h) - w, w);
			__DialogSliders_Item_PrintSlider(s, x, y + w, w, h - __ASHL(w, 1));
			__DialogSliders_Item_PrintButton(s, down, x, y, w);
		}
	} else {
		GraphicUtils_PrintBox(x, y, w, h);
	}
}

void DialogSliders_Item_SetdY (DialogSliders_Item s, INTEGER dY)
{
	__DialogSliders_Item_CheckdY(s, &dY);
	s->sliderdY = dY;
	__Dialogs_Object_Hide((void*)s);
	__Dialogs_Object_Restore((void*)s);
}

static void DialogSliders_WriteToObjectInt (DialogTexts_Item o, INTEGER n)
{
	Texts_Text t = NIL;
	t = __DialogTexts_Item_GetText(o);
	Texts_WriteInt(&DialogSliders_w0, Texts_Writer__typ, n, 0);
	Texts_Append(t, DialogSliders_w0.buf);
}

void DialogSliders_Item_Edit (DialogSliders_Item t)
{
	DialogTexts_Item delta = NIL;
	DialogStaticTexts_Item s = NIL;
	Dialogs_Panel p = NIL;
	Fonts_Font fnt = NIL;
	Dialogs_Object_Edit((void*)t);
	p = Dialogs_editPanel;
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 2, -176, 35, 20, 0);
	__DialogStaticTexts_Item_SetString(s, (CHAR*)"delta", (LONGINT)6);
	fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__DialogStaticTexts_Item_SetFont(s, fnt);
	__Dialogs_Panel_Insert(p, (void*)s, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__NEW(delta, DialogTexts_ItemDesc);
	__Dialogs_Object_Init((void*)delta);
	__Dialogs_Object_SetName((void*)delta, (CHAR*)"delta", (LONGINT)6);
	__Dialogs_Object_SetDim((void*)delta, 38, -176, 40, 19, 0);
	__Dialogs_Panel_Insert(p, (void*)delta, 0);
	__ASSERT(Dialogs_res == 0, 0);
	DialogSliders_WriteToObjectInt(delta, t->delta);
}

void DialogSliders_Item_Update (DialogSliders_Item t, Dialogs_Panel p)
{
	Dialogs_Object os = NIL;
	Texts_Text t1 = NIL;
	Texts_Scanner s = {0};
	Dialogs_Object_Update((void*)t, p);
	os = __Dialogs_Panel_NamedObject(p, (CHAR*)"delta", (LONGINT)6);
	t1 = __DialogTexts_Item_GetText(__GUARDP(os, DialogTexts_ItemDesc, 1));
	Texts_OpenScanner(&s, Texts_Scanner__typ, t1, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 3 && (LONGINT)t->delta != s.i) {
		t->delta = (int)s.i;
		if (t->panel != NIL) {
			__Dialogs_Panel_MarkMenu(t->panel);
		}
	}
}

void DialogSliders_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	Dialogs_Panel p = NIL;
	DialogSliders_Item s = NIL;
	CHAR name[64];
	__NEW(s, DialogSliders_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)s);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)s, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 20;
			h = 70;
		} else {
			if (w < 0) {
				w = 20;
			}
			if (h < 0) {
				h = 70;
			}
		}
		__Dialogs_Object_SetDim((void*)s, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)s, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogSliders", (LONGINT)14);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogSliders_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogSliders_ItemDesc, 39, 2) = {__TDFLDS("ItemDesc", 116), {0, 104, -12}};
__TDESC(DialogSliders_MoveSliderMsg, 1, 1) = {__TDFLDS("MoveSliderMsg", 12), {0, -8}};

export void *DialogSliders__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogStaticTexts);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogSliders, EnumPtrs);
	__REGCMD("Insert", DialogSliders_Insert);
	__INITYP(DialogSliders_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Arrow, 24);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_CalculatesH, 25);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Change, 26);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_CheckdY, 27);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Copy, 1);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Draw, 2);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_DrawButton, 28);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_DrawSlider, 29);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Edit, 3);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Handle, 6);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Init, 8);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Load, 12);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_MaxValue, 30);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_MoveSlider, 31);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Print, 14);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_PrintButton, 32);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_PrintSlider, 33);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_SetdY, 34);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Store, 21);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_TrackButton, 35);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_TrackScrollBar, 36);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_TrackSlider, 37);
	__INITBP(DialogSliders_ItemDesc, DialogSliders_Item_Update, 23);
	__INITYP(DialogSliders_MoveSliderMsg, Display_FrameMsg, 1);
/* BEGIN */
	Texts_OpenWriter(&DialogSliders_w0, Texts_Writer__typ);
	DialogSliders_Vpat[0] = 0x0;
	DialogSliders_Hpat[0] = 0x0;
	DialogSliders_Vpat[1] = 0x9999;
	DialogSliders_Hpat[1] = 0x1111;
	DialogSliders_Vpat[2] = 0x0;
	DialogSliders_Hpat[2] = 0x4444;
	DialogSliders_Vpat[3] = 0x6666;
	DialogSliders_Hpat[3] = 0x4444;
	DialogSliders_Vpat[4] = 0x0;
	DialogSliders_Hpat[4] = 0x1111;
	DialogSliders_Vpat[5] = 0x9999;
	DialogSliders_Hpat[5] = 0x1111;
	DialogSliders_Vpat[6] = 0x0;
	DialogSliders_Hpat[6] = 0x4444;
	DialogSliders_Vpat[7] = 0x6666;
	DialogSliders_Hpat[7] = 0x4444;
	DialogSliders_Vpat[8] = 0x0;
	DialogSliders_Hpat[8] = 0x1111;
	DialogSliders_vBgPat = Display_NewPattern((void*)DialogSliders_Vpat, 9, 16, 8);
	DialogSliders_hBgPat = Display_NewPattern((void*)DialogSliders_Hpat, 9, 16, 8);
	DialogSliders_upArrowImage[0] = 0x0;
	DialogSliders_downArrowImage[0] = 0x0;
	DialogSliders_upArrowImage[1] = 0x7c;
	DialogSliders_downArrowImage[8] = 0x7c;
	DialogSliders_upArrowImage[2] = 0x7c;
	DialogSliders_downArrowImage[7] = 0x7c;
	DialogSliders_upArrowImage[3] = 0x7c;
	DialogSliders_downArrowImage[6] = 0x7c;
	DialogSliders_upArrowImage[4] = 0x01ff;
	DialogSliders_downArrowImage[5] = 0x01ff;
	DialogSliders_upArrowImage[5] = 0xfe;
	DialogSliders_downArrowImage[4] = 0xfe;
	DialogSliders_upArrowImage[6] = 0x7c;
	DialogSliders_downArrowImage[3] = 0x7c;
	DialogSliders_upArrowImage[7] = 0x38;
	DialogSliders_downArrowImage[2] = 0x38;
	DialogSliders_upArrowImage[8] = 0x10;
	DialogSliders_downArrowImage[1] = 0x10;
	DialogSliders_upArrow = Display_NewPattern((void*)DialogSliders_upArrowImage, 9, 9, 8);
	DialogSliders_downArrow = Display_NewPattern((void*)DialogSliders_downArrowImage, 9, 9, 8);
	DialogSliders_leftArrowImage[0] = 0x0;
	DialogSliders_rightArrowImage[0] = 0x0;
	DialogSliders_leftArrowImage[1] = 0x08;
	DialogSliders_rightArrowImage[9] = 0x10;
	DialogSliders_leftArrowImage[2] = 0x18;
	DialogSliders_rightArrowImage[8] = 0x18;
	DialogSliders_leftArrowImage[3] = 0x3f;
	DialogSliders_rightArrowImage[7] = 0xfc;
	DialogSliders_leftArrowImage[4] = 0x7f;
	DialogSliders_rightArrowImage[6] = 0xfe;
	DialogSliders_leftArrowImage[5] = 0xff;
	DialogSliders_rightArrowImage[5] = 0xff;
	DialogSliders_leftArrowImage[6] = 0x7f;
	DialogSliders_rightArrowImage[4] = 0xfe;
	DialogSliders_leftArrowImage[7] = 0x3f;
	DialogSliders_rightArrowImage[3] = 0xfc;
	DialogSliders_leftArrowImage[8] = 0x18;
	DialogSliders_rightArrowImage[2] = 0x18;
	DialogSliders_leftArrowImage[9] = 0x08;
	DialogSliders_rightArrowImage[1] = 0x10;
	DialogSliders_leftArrow = Display_NewPattern((void*)DialogSliders_leftArrowImage, 20, 8, 9);
	DialogSliders_rightArrow = Display_NewPattern((void*)DialogSliders_rightArrowImage, 20, 8, 9);
	__ENDMOD;
}
