/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "Files.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogStaticTexts_ItemDesc *DialogStaticTexts_Item;

typedef
	struct DialogStaticTexts_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Fonts_Font fnt;
		CHAR s[64];
		INTEGER a;
	} DialogStaticTexts_ItemDesc;

export void DialogStaticTexts_Item_Copy (DialogStaticTexts_Item t, Dialogs_Object *dup);
export void DialogStaticTexts_Item_Draw (DialogStaticTexts_Item t, INTEGER x, INTEGER y, Display_Frame f);
export void DialogStaticTexts_Item_Edit (DialogStaticTexts_Item t);
export void DialogStaticTexts_Item_Handle (DialogStaticTexts_Item t, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogStaticTexts_Item_Load (DialogStaticTexts_Item t, Files_Rider *r, LONGINT *r__typ);
export void DialogStaticTexts_Item_Print (DialogStaticTexts_Item t, INTEGER x, INTEGER y);
export void DialogStaticTexts_Item_SetAlign (DialogStaticTexts_Item t, INTEGER a);
export void DialogStaticTexts_Item_SetFont (DialogStaticTexts_Item t, Fonts_Font fnt);
export void DialogStaticTexts_Item_SetString (DialogStaticTexts_Item t, CHAR *s, LONGINT s__len);
export void DialogStaticTexts_Item_Store (DialogStaticTexts_Item t, Files_Rider *r, LONGINT *r__typ);
export void DialogStaticTexts_Item_Update (DialogStaticTexts_Item t, Dialogs_Panel p);
#define __DialogStaticTexts_Item_SetAlign(t, a) __SEND(__TYPEOF(t), 24, void(*)(DialogStaticTexts_Item, INTEGER), (t, a))
#define __DialogStaticTexts_Item_SetFont(t, fnt) __SEND(__TYPEOF(t), 25, void(*)(DialogStaticTexts_Item, Fonts_Font), (t, fnt))
#define __DialogStaticTexts_Item_SetString(t, s, s__len) __SEND(__TYPEOF(t), 26, void(*)(DialogStaticTexts_Item, CHAR*, LONGINT ), (t, s, s__len))


static Texts_Writer DialogStaticTexts_w0;

export LONGINT *DialogStaticTexts_ItemDesc__typ;

export void DialogStaticTexts_GetString (void);
export void DialogStaticTexts_Insert (void);
export void DialogStaticTexts_SetString (void);
static void DialogStaticTexts_WriteToObjectInt (DialogTexts_Item o, INTEGER n);
static void DialogStaticTexts_WriteToObjectStr (DialogTexts_Item o, CHAR *n, LONGINT n__len);


void DialogStaticTexts_Item_Draw (DialogStaticTexts_Item t, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER ox = 0, oy = 0, w = 0, h = 0, yh = 0, cx = 0, mode = 0;
	__Dialogs_Object_GetDim((void*)t, &ox, &oy, &w, &h);
	if (t->selected) {
		mode = 2;
		Display1_Line(f, 15, x, y, x, (y + h) - 1, mode);
		Display1_Line(f, 15, x, y, (x + w) - 1, y, mode);
		Display1_Line(f, 15, (x + w) - 1, y, (x + w) - 1, (y + h) - 1, mode);
		Display1_Line(f, 15, x, (y + h) - 1, (x + w) - 1, (y + h) - 1, mode);
	} else {
		mode = 1;
	}
	yh = (y + __ASHR(h, 1)) - __ASHR(t->fnt->minY + t->fnt->maxY, 1);
	if (h - (yh - y) > t->fnt->maxY) {
		GraphicUtils_DrawString(f, t->s, 64, x + 3, yh, w - 4, t->fnt, mode, t->a, &cx);
	}
}

void DialogStaticTexts_Item_Copy (DialogStaticTexts_Item t, Dialogs_Object *dup)
{
	DialogStaticTexts_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogStaticTexts_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogStaticTexts_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)t, &*dup);
	x->fnt = t->fnt;
	__COPY(t->s, x->s, 64);
	x->a = t->a;
}

void DialogStaticTexts_Item_Load (DialogStaticTexts_Item t, Files_Rider *r, LONGINT *r__typ)
{
	CHAR fntname[32];
	CHAR ch = 0;
	LONGINT pos = 0;
	Dialogs_Object_Load((void*)t, &*r, r__typ);
	pos = Files_Pos(&*r, r__typ);
	Files_Read(&*r, r__typ, (void*)&ch);
	if (ch == 0x01) {
		Files_ReadInt(&*r, r__typ, &t->a);
	} else {
		Files_Set(&*r, r__typ, Files_Base(&*r, r__typ), pos);
		t->a = 1;
	}
	Files_ReadString(&*r, r__typ, (void*)fntname, 32);
	t->fnt = Fonts_This(fntname, 32);
	Files_ReadString(&*r, r__typ, (void*)t->s, 64);
}

void DialogStaticTexts_Item_Store (DialogStaticTexts_Item t, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Store((void*)t, &*r, r__typ);
	Files_Write(&*r, r__typ, 0x01);
	Files_WriteInt(&*r, r__typ, t->a);
	Files_WriteString(&*r, r__typ, t->fnt->name, 32);
	Files_WriteString(&*r, r__typ, t->s, 64);
}

void DialogStaticTexts_Item_Print (DialogStaticTexts_Item t, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, ox = 0, oy = 0, yh = 0, cx = 0;
	__Dialogs_Object_GetPDim((void*)t, &ox, &oy, &w, &h);
	cx = __ASHR(t->fnt->minY + t->fnt->maxY, 1);
	cx = (int)__DIV((LONGINT)cx * Dialogs_dUnit, Dialogs_pUnit);
	yh = (y + __ASHR(h, 1)) - cx;
	if (h - (yh - y) > t->fnt->maxY) {
		GraphicUtils_PrintString(t->s, 64, x + 3, yh, w - 4, t->fnt, t->a, &cx);
	}
}

void DialogStaticTexts_Item_SetFont (DialogStaticTexts_Item t, Fonts_Font fnt)
{
	__Dialogs_Object_Hide((void*)t);
	t->fnt = fnt;
	__Dialogs_Object_Restore((void*)t);
	if (t->panel != NIL) {
		__Dialogs_Panel_MarkMenu(t->panel);
	}
}

void DialogStaticTexts_Item_SetString (DialogStaticTexts_Item t, CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	__Dialogs_Object_Hide((void*)t);
	__COPY(s, t->s, 64);
	__Dialogs_Object_Restore((void*)t);
	if (t->panel != NIL) {
		__Dialogs_Panel_MarkMenu(t->panel);
	}
	__DEL(s);
}

void DialogStaticTexts_Item_SetAlign (DialogStaticTexts_Item t, INTEGER a)
{
	__Dialogs_Object_Hide((void*)t);
	t->a = a;
	__Dialogs_Object_Restore((void*)t);
	if (t->panel != NIL) {
		__Dialogs_Panel_MarkMenu(t->panel);
	}
}

void DialogStaticTexts_Item_Handle (DialogStaticTexts_Item t, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Texts_Text t1 = NIL;
	Dialogs_Object_Handle((void*)t, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				if ((*m__).keys == 0x02 && t->cmd[0] != 0x00) {
					(*DialogTexts_GetParText)(t->par, 32, t->panel, &t1);
					__Dialogs_Object_CallCmd((void*)t, (void*)(*(DialogFrames_Frame*)&f), Viewers_This((*m__).X, (*m__).Y), t1);
				} else {
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*m__).X, (*m__).Y);
				}
			}
		}
	}
}

static void DialogStaticTexts_WriteToObjectStr (DialogTexts_Item o, CHAR *n, LONGINT n__len)
{
	Texts_Text t = NIL;
	__DUP(n, n__len, CHAR);
	t = __DialogTexts_Item_GetText(o);
	Texts_WriteString(&DialogStaticTexts_w0, Texts_Writer__typ, n, n__len);
	Texts_Append(t, DialogStaticTexts_w0.buf);
	__DEL(n);
}

static void DialogStaticTexts_WriteToObjectInt (DialogTexts_Item o, INTEGER n)
{
	Texts_Text t = NIL;
	t = __DialogTexts_Item_GetText(o);
	Texts_WriteInt(&DialogStaticTexts_w0, Texts_Writer__typ, n, 0);
	Texts_Append(t, DialogStaticTexts_w0.buf);
}

void DialogStaticTexts_Item_Edit (DialogStaticTexts_Item t)
{
	Dialogs_Object on = NIL;
	DialogTexts_Item os = NIL, string = NIL, align = NIL;
	DialogStaticTexts_Item s = NIL;
	Dialogs_Panel p = NIL;
	Texts_Text t1 = NIL;
	Fonts_Font fnt = NIL;
	CHAR st[16];
	Dialogs_Object_Edit((void*)t);
	p = Dialogs_editPanel;
	__NEW(string, DialogTexts_ItemDesc);
	__Dialogs_Object_Init((void*)string);
	__Dialogs_Object_SetName((void*)string, (CHAR*)"string", (LONGINT)7);
	__Dialogs_Object_SetDim((void*)string, 245, -30, 140, 19, 0);
	__Dialogs_Panel_Insert(p, (void*)string, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 196, -30, 40, 20, 0);
	__DialogStaticTexts_Item_SetString(s, (CHAR*)"String", (LONGINT)7);
	fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__DialogStaticTexts_Item_SetFont(s, fnt);
	__Dialogs_Panel_Insert(p, (void*)s, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 2, -176, 35, 20, 0);
	__DialogStaticTexts_Item_SetString(s, (CHAR*)"Align", (LONGINT)6);
	__DialogStaticTexts_Item_SetFont(s, fnt);
	__Dialogs_Panel_Insert(p, (void*)s, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__NEW(align, DialogTexts_ItemDesc);
	__Dialogs_Object_Init((void*)align);
	__Dialogs_Object_SetName((void*)align, (CHAR*)"align", (LONGINT)6);
	__Dialogs_Object_SetDim((void*)align, 38, -176, 40, 19, 0);
	__Dialogs_Panel_Insert(p, (void*)align, 0);
	__ASSERT(Dialogs_res == 0, 0);
	DialogStaticTexts_WriteToObjectStr(string, t->s, 64);
	t1 = __DialogTexts_Item_GetText(string);
	Texts_ChangeLooks(t1, 0, t1->len, 0x01, t->fnt, 0, 0);
	if (t->a == 0) {
		__COPY("left", st, 16);
	} else if (t->a == 1) {
		__COPY("center", st, 16);
	} else {
		__COPY("right", st, 16);
	}
	DialogStaticTexts_WriteToObjectStr(align, st, 16);
}

void DialogStaticTexts_Item_Update (DialogStaticTexts_Item t, Dialogs_Panel p)
{
	Dialogs_Object os = NIL;
	Texts_Text t1 = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	CHAR str[64];
	INTEGER i = 0;
	Texts_Scanner s = {0};
	Dialogs_Object_Update((void*)t, p);
	os = __Dialogs_Panel_NamedObject(p, (CHAR*)"string", (LONGINT)7);
	t1 = __DialogTexts_Item_GetText(__GUARDP(os, DialogTexts_ItemDesc, 1));
	Texts_OpenReader(&r, Texts_Reader__typ, t1, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	i = 0;
	if (r.fnt != NIL && r.fnt != t->fnt) {
		__DialogStaticTexts_Item_SetFont(t, r.fnt);
	}
	while (!r.eot) {
		str[__X(i, 64)] = ch;
		i += 1;
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	str[__X(i, 64)] = 0x00;
	if (__STRCMP(str, t->s) != 0) {
		__DialogStaticTexts_Item_SetString(t, str, 64);
	}
	os = __Dialogs_Panel_NamedObject(p, (CHAR*)"align", (LONGINT)6);
	t1 = __DialogTexts_Item_GetText(__GUARDP(os, DialogTexts_ItemDesc, 1));
	Texts_OpenScanner(&s, Texts_Scanner__typ, t1, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 3) {
		i = (int)s.i;
	} else if (s.class == 1) {
		if (s.s[0] == 'l') {
			i = 0;
		} else if (s.s[0] == 'c') {
			i = 1;
		} else {
			i = 2;
		}
	} else {
		i = 1;
	}
	if (i != t->a) {
		__DialogStaticTexts_Item_SetAlign(t, i);
	}
}

void DialogStaticTexts_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogStaticTexts_Item t = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	Texts_Reader r = {0};
	CHAR ch = 0;
	__NEW(t, DialogStaticTexts_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)t);
		t->fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
		In_Open();
		Texts_OpenReader(&r, Texts_Reader__typ, Oberon_Par->text, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		} else {
			t->fnt = r.fnt;
		}
		__COPY(name, t->s, 64);
		__Dialogs_Object_SetName((void*)t, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 40;
			h = 20;
		} else {
			if (w < 0) {
				w = 40;
			}
			if (h < 0) {
				h = 20;
			}
		}
		y = GraphicUtils_GetStringLength(name, 64, t->fnt) + 5;
		if (y > w) {
			x = w;
			w = y;
		}
		__Dialogs_Object_SetDim((void*)t, x1, y1, w, h, 0);
		t->a = 1;
		__Dialogs_Panel_Insert(p, (void*)t, 0);
		if (Dialogs_res == 6) {
			__Dialogs_Object_SetDim((void*)t, x1, y1, y, h, 0);
			__Dialogs_Panel_Insert(p, (void*)t, 0);
		}
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogStaticTexts", (LONGINT)18);
	}
}

void DialogStaticTexts_SetString (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR str[64];
	CHAR ch = 0;
	INTEGER i = 0;
	In_Open();
	In_Char(&ch);
	i = 0;
	while (In_Done && ch == ' ') {
		In_Char(&ch);
	}
	if (!In_Done) {
		Dialogs_res = 4;
	} else {
		while (((In_Done && ch != 0x0d) && ch != '~') && i < 63) {
			str[__X(i, 64)] = ch;
			i += 1;
			In_Char(&ch);
		}
		str[__X(i, 64)] = 0x00;
		DialogFrames_FindObject(&o, &p);
		if (Dialogs_res == 0 && __ISP(o, DialogStaticTexts_ItemDesc, 1)) {
			__DialogStaticTexts_Item_SetString(__GUARDP(o, DialogStaticTexts_ItemDesc, 1), str, 64);
			__DialogStaticTexts_Item_SetFont(__GUARDP(o, DialogStaticTexts_ItemDesc, 1), Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17));
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogStaticTexts", (LONGINT)18);
	}
}

void DialogStaticTexts_GetString (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR str[64];
	DialogFrames_FindObject(&o, &p);
	if (Dialogs_res == 0) {
		if (__ISP(o, DialogStaticTexts_ItemDesc, 1)) {
			__COPY(__GUARDP(o, DialogStaticTexts_ItemDesc, 1)->s, str, 64);
			Texts_WriteString(&DialogStaticTexts_w0, Texts_Writer__typ, (CHAR*)"String:", (LONGINT)8);
			Texts_WriteString(&DialogStaticTexts_w0, Texts_Writer__typ, str, 64);
			Texts_WriteLn(&DialogStaticTexts_w0, Texts_Writer__typ);
			Texts_Append(Oberon_Log, DialogStaticTexts_w0.buf);
		} else {
			Dialogs_res = 3;
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogStaticTexts", (LONGINT)18);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogStaticTexts_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogStaticTexts_ItemDesc, 28, 3) = {__TDFLDS("ItemDesc", 184), {0, 104, 112, -16}};

export void *DialogStaticTexts__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogStaticTexts, EnumPtrs);
	__REGCMD("GetString", DialogStaticTexts_GetString);
	__REGCMD("Insert", DialogStaticTexts_Insert);
	__REGCMD("SetString", DialogStaticTexts_SetString);
	__INITYP(DialogStaticTexts_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Copy, 1);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Draw, 2);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Edit, 3);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Handle, 6);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Load, 12);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Print, 14);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_SetAlign, 24);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_SetFont, 25);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_SetString, 26);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Store, 21);
	__INITBP(DialogStaticTexts_ItemDesc, DialogStaticTexts_Item_Update, 23);
/* BEGIN */
	Texts_OpenWriter(&DialogStaticTexts_w0, Texts_Writer__typ);
	__ENDMOD;
}
