/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "GraphicUtils.h"
#include "In.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Types.h"
#include "Viewers.h"

typedef
	struct DialogTexts_ChangeMsg { /* Display_FrameMsg */
		LONGINT x, y;
	} DialogTexts_ChangeMsg;

typedef
	struct DialogTexts_ItemDesc *DialogTexts_Item;

typedef
	struct DialogTexts_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		TextFrames_Frame f;
	} DialogTexts_ItemDesc;

export void DialogTexts_Item_Copy (DialogTexts_Item t, Dialogs_Object *dup);
export void DialogTexts_Item_Draw (DialogTexts_Item t, INTEGER x, INTEGER y, Display_Frame f);
export Texts_Text DialogTexts_Item_GetText (DialogTexts_Item t);
export void DialogTexts_Item_Handle (DialogTexts_Item t, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void DialogTexts_Item_Init (DialogTexts_Item t);
export void DialogTexts_Item_Print (DialogTexts_Item t, INTEGER x, INTEGER y);
export void DialogTexts_Item_RemoveSelection (DialogTexts_Item t);
export void DialogTexts_Item_SetSelection (DialogTexts_Item t, LONGINT beg, LONGINT end);
#define __DialogTexts_Item_GetText(t) __SEND(__TYPEOF(t), 24, Texts_Text(*)(DialogTexts_Item), (t))
#define __DialogTexts_Item_RemoveSelection(t) __SEND(__TYPEOF(t), 25, void(*)(DialogTexts_Item), (t))
#define __DialogTexts_Item_SetSelection(t, beg, end) __SEND(__TYPEOF(t), 26, void(*)(DialogTexts_Item, LONGINT, LONGINT), (t, beg, end))


static Texts_Writer DialogTexts_w0;
export void (*DialogTexts_GetParText)(CHAR*, LONGINT , Dialogs_Panel, Texts_Text*);

export LONGINT *DialogTexts_ItemDesc__typ;
export LONGINT *DialogTexts_ChangeMsg__typ;

static void DialogTexts_Adjust (TextFrames_Frame f, INTEGER id, INTEGER dY, INTEGER y, INTEGER h);
static void DialogTexts_DrawFrame (Display_Frame f1, Display_Frame f, BOOLEAN m);
static void DialogTexts_Edit (Dialogs_Object o);
export void DialogTexts_Insert (void);
static void DialogTexts_ParText (CHAR *n, LONGINT n__len, Dialogs_Panel p, Texts_Text *t);
static void DialogTexts_Update (Dialogs_Object o, Dialogs_Panel deInit);
static void DialogTexts_WriteToObjectInt (Dialogs_Object o, Dialogs_Panel *p, INTEGER x);
static void DialogTexts_WriteToObjectStr (Dialogs_Object o, Dialogs_Panel *p, CHAR *n, LONGINT n__len);


void DialogTexts_Item_Copy (DialogTexts_Item t, Dialogs_Object *dup)
{
	DialogTexts_Item x = NIL;
	Texts_Text t0 = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogTexts_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogTexts_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)t, &*dup);
	__NEW(t0, Texts_TextDesc);
	t0 = TextFrames_Text((CHAR*)"", (LONGINT)1);
	x->f = TextFrames_NewText(t0, 0);
}

Texts_Text DialogTexts_Item_GetText (DialogTexts_Item t)
{
	return t->f->text;
}

void DialogTexts_Item_SetSelection (DialogTexts_Item t, LONGINT beg, LONGINT end)
{
	if (t->f != NIL) {
		TextFrames_SetSelection(t->f, beg, end);
	}
}

void DialogTexts_Item_RemoveSelection (DialogTexts_Item t)
{
	if (t->f != NIL) {
		TextFrames_RemoveSelection(t->f);
	}
}

static void DialogTexts_ParText (CHAR *n, LONGINT n__len, Dialogs_Panel p, Texts_Text *t)
{
	Texts_Text t0 = NIL, t1 = NIL;
	Texts_Scanner s = {0};
	Dialogs_Object o = NIL;
	__DUP(n, n__len, CHAR);
	*t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	t0 = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteString(&DialogTexts_w0, Texts_Writer__typ, n, n__len);
	Texts_Append(t0, DialogTexts_w0.buf);
	Texts_OpenScanner(&s, Texts_Scanner__typ, t0, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	while (s.class != 6 || s.c != 0x00) {
		if (s.class == 1) {
			o = __Dialogs_Panel_NamedObject(p, s.s, 256);
			if (o != NIL && __ISP(o, DialogTexts_ItemDesc, 1)) {
				t1 = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
				Texts_Save(t1, 0, t1->len, DialogTexts_w0.buf);
				Texts_WriteString(&DialogTexts_w0, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
				Texts_Append(*t, DialogTexts_w0.buf);
			}
		} else if (s.class == 2) {
			Texts_WriteString(&DialogTexts_w0, Texts_Writer__typ, s.s, 256);
			Texts_Append(*t, DialogTexts_w0.buf);
		}
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	__DEL(n);
}

static void DialogTexts_DrawFrame (Display_Frame f1, Display_Frame f, BOOLEAN m)
{
	INTEGER mode = 0;
	if (m) {
		mode = 2;
	} else {
		mode = 0;
	}
	Display_ReplConstC(f1, 15, f->X - 1, f->Y, 1, f->H + 1, mode);
	Display_ReplConstC(f1, 0, f->X + f->W, f->Y, 1, f->H + 1, mode);
	Display_ReplConstC(f1, 0, f->X, f->Y, f->W - 1, 1, mode);
	Display_ReplConstC(f1, 15, f->X, f->Y + f->H, f->W - 1, 1, mode);
}

static void DialogTexts_Adjust (TextFrames_Frame f, INTEGER id, INTEGER dY, INTEGER y, INTEGER h)
{
	MenuViewers_ModifyMsg m = {0};
	m.id = id;
	m.dY = dY;
	m.Y = y;
	m.H = 0;
	(*f->handle)((void*)f, (void*)&m, MenuViewers_ModifyMsg__typ);
	m.id = id;
	m.dY = dY;
	m.Y = y;
	m.H = h;
	(*f->handle)((void*)f, (void*)&m, MenuViewers_ModifyMsg__typ);
}

void DialogTexts_Item_Draw (DialogTexts_Item t, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER w = 0, h = 0, w1 = 0, h1 = 0, ox = 0, oy = 0;
	x += 1;
	__Dialogs_Object_GetDim((void*)t, &ox, &oy, &w, &h);
	w -= 2;
	h -= 1;
	if (((y + h <= f->Y || y >= f->Y + f->H) || x + w <= f->X) || x >= f->X + f->W) {
		return;
	}
	if (x < f->X && x + w > f->X) {
		w = w - (f->X - x);
		x = f->X;
	}
	if (y < f->Y && y + h > f->Y) {
		h = h - (f->Y - y);
		y = f->Y;
	}
	w1 = f->W - (x - f->X);
	h1 = f->H - (y - f->Y);
	if (w1 < t->f->left) {
		return;
	}
	if (w > w1) {
		w = w1;
	}
	if (h > h1) {
		h = h1;
	}
	if (w < 0) {
		w = 0;
	}
	if (h < 0) {
		h = 0;
	}
	t->f->X = x;
	t->f->Y = y;
	t->f->W = w;
	t->f->H = h;
	Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	DialogTexts_DrawFrame(f, (void*)t->f, t->selected);
	t->f->barW = 0;
	t->f->left = 3;
	t->f->right = 3;
	t->f->bot = 0;
	t->f->top = 2;
	DialogTexts_Adjust(t->f, 0, 0, t->f->Y + 1, t->f->H - 1);
}

void DialogTexts_Item_Print (DialogTexts_Item t, INTEGER x, INTEGER y)
{
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0;
	__Dialogs_Object_GetPDim((void*)t, &ox, &oy, &ow, &oh);
	GraphicUtils_PrintBox(x, y, ow, oh);
}

void DialogTexts_Item_Handle (DialogTexts_Item t, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, h1 = 0, xh = 0, yh = 0;
	Viewers_Viewer v = NIL;
	Oberon_CopyMsg msg1 = {0};
	Display_Frame f1 = NIL;
	BOOLEAN cond = 0;
	DialogTexts_ChangeMsg msg2 = {0};
	Texts_Text t1 = NIL;
	Dialogs_Object_Handle((void*)t, f, &*msg, msg__typ);
	__Dialogs_Object_GetDim((void*)t, &x, &y, &w, &h);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		yh = ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y;
		xh = (*(DialogFrames_Frame*)&f)->X + x;
		if (yh < (*(DialogFrames_Frame*)&f)->Y) {
			h1 = (h - (*(DialogFrames_Frame*)&f)->Y) + yh;
		} else {
			h1 = h;
		}
		if ((((yh + h <= (*(DialogFrames_Frame*)&f)->Y || yh >= (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) || xh + w <= (*(DialogFrames_Frame*)&f)->X) || xh >= (*(DialogFrames_Frame*)&f)->X + (*(DialogFrames_Frame*)&f)->W) || h1 < 16) {
			return;
		}
		if ((((*(DialogFrames_Frame*)&f)->X <= t->f->X && (*(DialogFrames_Frame*)&f)->X + (*(DialogFrames_Frame*)&f)->W >= t->f->X) && (*(DialogFrames_Frame*)&f)->Y <= t->f->Y) && (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H >= t->f->Y) {
			if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
				if (__GUARDR(msg, TextFrames_UpdateMsg, 1).text == t->f->text) {
					(*t->f->handle)((void*)t->f, &*msg, msg__typ);
					msg2.x = (*(DialogFrames_Frame*)&f)->X;
					msg2.y = (*(DialogFrames_Frame*)&f)->Y;
					Viewers_Broadcast((void*)&msg2, DialogTexts_ChangeMsg__typ);
					if ((((*(DialogFrames_Frame*)&f)->X > t->f->X || (*(DialogFrames_Frame*)&f)->X + (*(DialogFrames_Frame*)&f)->W < t->f->X) || (*(DialogFrames_Frame*)&f)->Y > t->f->Y) || (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H < t->f->Y) {
						__Dialogs_Object_Draw((void*)t, (*(DialogFrames_Frame*)&f)->X + x, ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y, (void*)(*(DialogFrames_Frame*)&f));
					}
					if (t->cmd[0] != 0x00) {
						(*DialogTexts_GetParText)(t->par, 32, t->panel, &t1);
						__Dialogs_Object_CallCmd((void*)t, (void*)(*(DialogFrames_Frame*)&f), Viewers_This(xh, yh), t1);
					}
				}
			} else if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
				if (__GUARDR(msg, MenuViewers_ModifyMsg, 1).id == 1) {
					__Dialogs_Object_Restore((void*)t);
				}
			} else {
				(*t->f->handle)((void*)t->f, &*msg, msg__typ);
			}
		} else {
			cond = 0;
			if (__IS(msg__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *msg__ = (void*)msg;
				if ((((((*msg__).id == 1 && (*msg__).X >= xh) && (*msg__).X <= xh + w) && (*msg__).Y >= yh) && (*msg__).Y <= yh + h) && (*msg__).keys != 0x0) {
					cond = 1;
				}
				if ((*msg__).id == 0) {
					cond = 1;
				}
			} else if (__IS(msg__typ, DialogTexts_ChangeMsg, 1)) {
				DialogTexts_ChangeMsg *msg__ = (void*)msg;
				__Dialogs_Object_Draw((void*)t, (*(DialogFrames_Frame*)&f)->X + x, ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y, (void*)(*(DialogFrames_Frame*)&f));
			}
			if (cond) {
				TextFrames_RemoveCaret(t->f);
				__Dialogs_Object_Draw((void*)t, (*(DialogFrames_Frame*)&f)->X + x, ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y, (void*)(*(DialogFrames_Frame*)&f));
				(*t->f->handle)((void*)t->f, &*msg, msg__typ);
			}
		}
	}
}

void DialogTexts_Item_Init (DialogTexts_Item t)
{
	Texts_Text h = NIL;
	Dialogs_Object_Init((void*)t);
	h = TextFrames_Text((CHAR*)"", (LONGINT)1);
	t->f = TextFrames_NewText(h, 0);
}

void DialogTexts_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogTexts_Item t = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(t, DialogTexts_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)t);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)t, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 70;
			h = 22;
		} else {
			if (w < 0) {
				w = 70;
			}
			if (h < 0) {
				h = 22;
			}
		}
		__Dialogs_Object_SetDim((void*)t, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)t, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogTexts", (LONGINT)12);
	}
}

static void DialogTexts_WriteToObjectInt (Dialogs_Object o, Dialogs_Panel *p, INTEGER x)
{
	Texts_Text t = NIL;
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_WriteInt(&DialogTexts_w0, Texts_Writer__typ, x, 1);
		Texts_Append(t, DialogTexts_w0.buf);
	} else __WITHCHK;
}

static void DialogTexts_WriteToObjectStr (Dialogs_Object o, Dialogs_Panel *p, CHAR *n, LONGINT n__len)
{
	Texts_Text t = NIL;
	CHAR ch = 0;
	__DUP(n, n__len, CHAR);
	if (n[0] == 0x00) {
		__DEL(n);
		return;
	}
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		ch = '\"';
		if ((int)__CAP(n[0]) < 65 || (int)__CAP(n[0]) > 90) {
			Texts_Write(&DialogTexts_w0, Texts_Writer__typ, ch);
		}
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_WriteString(&DialogTexts_w0, Texts_Writer__typ, n, n__len);
		if ((int)__CAP(n[0]) < 65 || (int)__CAP(n[0]) > 90) {
			Texts_Write(&DialogTexts_w0, Texts_Writer__typ, ch);
		}
		Texts_Append(t, DialogTexts_w0.buf);
	} else __WITHCHK;
	__DEL(n);
}

static void DialogTexts_Edit (Dialogs_Object o)
{
	INTEGER x = 0, y = 0, nx = 0, ny = 0, nw = 0, nh = 0;
	CHAR nn[64], nc[64], np[64];
	Dialogs_Object ox = NIL, oy = NIL, ow = NIL, oh = NIL, on = NIL, oc = NIL, op = NIL;
	Dialogs_Panel deInit = NIL;
	DialogFrames_GetFrameMsg msg = {0};
	Files_File file = NIL;
	Files_Rider r = {0};
	Texts_Scanner s = {0};
	Types_Type type = NIL;
	TextFrames_Frame m = NIL;
	Viewers_Viewer v = NIL;
	DialogFrames_Frame df = NIL;
	Texts_Text t = NIL;
	Oberon_AllocateSystemViewer(Oberon_Mouse.X, &x, &y);
	msg.p = Dialogs_editPanel;
	msg.f = NIL;
	Viewers_Broadcast((void*)&msg, DialogFrames_GetFrameMsg__typ);
	file = Files_Old((CHAR*)"DEInit.Dlg", (LONGINT)11);
	__ASSERT(file != NIL, 0);
	Files_Set(&r, Files_Rider__typ, file, 0);
	__NEW(deInit, Dialogs_PanelDesc);
	__Dialogs_Panel_Load(deInit, &r, Files_Rider__typ);
	type = Types_TypeOf((void*)o);
	if (msg.f == NIL) {
		__NEW(df, DialogFrames_FrameDesc);
		__DialogFrames_Frame_Open(df, DialogFrames_Handle, deInit);
		Oberon_AllocateSystemViewer(Oberon_Mouse.X, &x, &y);
		m = TextFrames_NewMenu(type->module->name, 20, (CHAR*)"System.Close System.Copy System.Grow ", (LONGINT)38);
		v = (Viewers_Viewer)MenuViewers_New((void*)m, (void*)df, TextFrames_menuH, x, y);
	} else {
		df = msg.f;
		df->panel = deInit;
		__Dialogs_Panel_Restore(deInit);
		v = Viewers_This(df->X, df->Y);
		if ((__ISP(v, MenuViewers_ViewerDesc, 2) && __ISP(v->dsc, TextFrames_FrameDesc, 1)) && df != (void *) v->dsc) {
			t = __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text;
			if (t->len > 0) {
				Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
				Texts_Scan(&s, Texts_Scanner__typ);
				if (s.class == 1) {
					Texts_Delete(t, 0, Texts_Pos((void*)&s, Texts_Scanner__typ) - 1);
					Texts_WriteString(&DialogTexts_w0, Texts_Writer__typ, type->module->name, 20);
					Texts_Insert(t, 0, DialogTexts_w0.buf);
				}
			}
		}
	}
	ox = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"x", (LONGINT)2);
	oy = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"y", (LONGINT)2);
	ow = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"w", (LONGINT)2);
	oh = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"h", (LONGINT)2);
	on = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"name", (LONGINT)5);
	oc = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"cmd", (LONGINT)4);
	op = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"par", (LONGINT)4);
	__Dialogs_Object_GetDim(o, &nx, &ny, &nw, &nh);
	__COPY(o->name, nn, 64);
	__COPY(o->cmd, nc, 64);
	__COPY(o->par, np, 64);
	DialogTexts_WriteToObjectInt(ox, &deInit, nx);
	DialogTexts_WriteToObjectInt(oy, &deInit, ny);
	DialogTexts_WriteToObjectInt(ow, &deInit, nw);
	DialogTexts_WriteToObjectInt(oh, &deInit, nh);
	DialogTexts_WriteToObjectStr(on, &deInit, nn, 64);
	DialogTexts_WriteToObjectStr(oc, &deInit, nc, 64);
	t = __DialogTexts_Item_GetText(__GUARDP(op, DialogTexts_ItemDesc, 1));
	Texts_WriteString(&DialogTexts_w0, Texts_Writer__typ, np, 64);
	Texts_Append(t, DialogTexts_w0.buf);
	Dialogs_editPanel = deInit;
	Dialogs_editObject = o;
}

static struct Update__14 {
	struct Update__14 *lnk;
} *Update__14_s;

static void ReadInt__15 (Dialogs_Object o, INTEGER *x, INTEGER *res);
static void ReadName__17 (Dialogs_Object o, CHAR *st, LONGINT st__len, INTEGER *res);
static void ReadPar__19 (Dialogs_Object o, CHAR *st, LONGINT st__len, INTEGER *res);

static void ReadInt__15 (Dialogs_Object o, INTEGER *x, INTEGER *res)
{
	Texts_Scanner s = {0};
	Texts_Text t = NIL;
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 3) {
			*x = (int)s.i;
			*res = 0;
		} else {
			*res = 4;
		}
	}
}

static void ReadName__17 (Dialogs_Object o, CHAR *st, LONGINT st__len, INTEGER *res)
{
	Texts_Scanner s = {0};
	Texts_Text t = NIL;
	INTEGER i = 0;
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1 || s.class == 2) {
			__COPY(s.s, st, st__len);
			*res = 0;
		} else {
			*res = 4;
		}
	}
}

static void ReadPar__19 (Dialogs_Object o, CHAR *st, LONGINT st__len, INTEGER *res)
{
	Texts_Reader r = {0};
	Texts_Text t = NIL;
	INTEGER i = 0;
	CHAR ch = 0;
	if (__ISP(o, DialogTexts_ItemDesc, 1)) {
		t = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&o));
		Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		i = 0;
		*res = 0;
		while (!r.eot) {
			st[__X(i, st__len)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		st[__X(i, st__len)] = 0x00;
	}
}

static void DialogTexts_Update (Dialogs_Object o, Dialogs_Panel deInit)
{
	Dialogs_Object o1 = NIL;
	CHAR st[64];
	INTEGER ax = 0, ay = 0, aw = 0, ah = 0, nx = 0, ny = 0, nw = 0, nh = 0, res = 0, res1 = 0, res2 = 0, res3 = 0, res4 = 0;
	struct Update__14 _s;
	_s.lnk = Update__14_s;
	Update__14_s = &_s;
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"name", (LONGINT)5);
	ReadName__17(o1, (void*)st, 64, &res1);
	if (res1 == 0) {
		__Dialogs_Object_SetName(o, st, 64);
	} else {
		__Dialogs_Object_SetName(o, (CHAR*)"", (LONGINT)1);
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"cmd", (LONGINT)4);
	ReadName__17(o1, (void*)st, 64, &res1);
	if (res1 == 0) {
		__Dialogs_Object_SetCmd(o, st, 64);
	} else {
		__Dialogs_Object_SetCmd(o, (CHAR*)"", (LONGINT)1);
	}
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"par", (LONGINT)4);
	ReadPar__19(o1, (void*)st, 64, &res1);
	if (res1 == 0) {
		__Dialogs_Object_SetPar(o, st, 64);
	} else {
		__Dialogs_Object_SetPar(o, (CHAR*)"", (LONGINT)1);
	}
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"x", (LONGINT)2);
	ReadInt__15(o1, &nx, &res1);
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"y", (LONGINT)2);
	ReadInt__15(o1, &ny, &res2);
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"w", (LONGINT)2);
	ReadInt__15(o1, &nw, &res3);
	o1 = __Dialogs_Panel_NamedObject(deInit, (CHAR*)"h", (LONGINT)2);
	ReadInt__15(o1, &nh, &res4);
	if (((res1 != 0 || res2 != 0) || res3 != 0) || res4 != 0) {
		Dialogs_res = 4;
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	} else {
		__Dialogs_Object_GetDim(o, &ax, &ay, &aw, &ah);
		if (((ax != nx || ay != ny) || aw != nw) || ah != nh) {
			__Dialogs_Object_SetDim(o, nx, ny, nw, nh, o->overlapping);
			if (Dialogs_res != 0) {
				Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
			}
		}
	}
	Update__14_s = _s.lnk;
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogTexts_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogTexts_ItemDesc, 28, 3) = {__TDFLDS("ItemDesc", 116), {0, 104, 112, -16}};
__TDESC(DialogTexts_ChangeMsg, 1, 0) = {__TDFLDS("ChangeMsg", 8), {-4}};

export void *DialogTexts__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Types);
	__IMPORT(Viewers);
	__REGMOD(DialogTexts, EnumPtrs);
	__REGCMD("Insert", DialogTexts_Insert);
	__INITYP(DialogTexts_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_Copy, 1);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_Draw, 2);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_GetText, 24);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_Handle, 6);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_Init, 8);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_Print, 14);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_RemoveSelection, 25);
	__INITBP(DialogTexts_ItemDesc, DialogTexts_Item_SetSelection, 26);
	__INITYP(DialogTexts_ChangeMsg, Display_FrameMsg, 1);
/* BEGIN */
	Texts_OpenWriter(&DialogTexts_w0, Texts_Writer__typ);
	Dialogs_Edit = DialogTexts_Edit;
	Dialogs_Update = DialogTexts_Update;
	DialogTexts_GetParText = DialogTexts_ParText;
	__ENDMOD;
}
