/* Ofront 1.4 -xtspkaG */

#ifndef Dialogs__h
#define Dialogs__h

#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct Dialogs_ObjectDesc *Dialogs_Object;

typedef
	struct Dialogs_PanelDesc *Dialogs_Panel;

typedef
	struct Dialogs_NotifyMsg { /* Display_FrameMsg */
		INTEGER id;
		Dialogs_Object obj;
		Dialogs_Panel p;
	} Dialogs_NotifyMsg;

typedef
	struct Dialogs_ObjectDesc {
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} Dialogs_ObjectDesc;

import void Dialogs_Object_CallCmd (Dialogs_Object o, Display_Frame f, Viewers_Viewer v, Texts_Text t);
import void Dialogs_Object_Copy (Dialogs_Object o, Dialogs_Object *dup);
import void Dialogs_Object_Draw (Dialogs_Object o, INTEGER x, INTEGER y, Display_Frame f);
import void Dialogs_Object_Edit (Dialogs_Object o);
import void Dialogs_Object_GetDim (Dialogs_Object o, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
import void Dialogs_Object_GetPDim (Dialogs_Object o, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
import void Dialogs_Object_Handle (Dialogs_Object o, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void Dialogs_Object_Hide (Dialogs_Object o);
import void Dialogs_Object_Init (Dialogs_Object o);
import void Dialogs_Object_Load (Dialogs_Object o, Files_Rider *r, LONGINT *r__typ);
import Dialogs_Object Dialogs_Object_OverlappingObject (Dialogs_Object o);
import void Dialogs_Object_Print (Dialogs_Object o, INTEGER x, INTEGER y);
import void Dialogs_Object_Restore (Dialogs_Object o);
import void Dialogs_Object_Select (Dialogs_Object o);
import void Dialogs_Object_SetCmd (Dialogs_Object o, CHAR *cmd, LONGINT cmd__len);
import void Dialogs_Object_SetDim (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h, BOOLEAN cond);
import void Dialogs_Object_SetName (Dialogs_Object o, CHAR *name, LONGINT name__len);
import void Dialogs_Object_SetPar (Dialogs_Object o, CHAR *par, LONGINT par__len);
import void Dialogs_Object_Store (Dialogs_Object o, Files_Rider *r, LONGINT *r__typ);
import void Dialogs_Object_UnSelect (Dialogs_Object o);
import void Dialogs_Object_Update (Dialogs_Object o, Dialogs_Panel p);
#define __Dialogs_Object_CallCmd(o, f, v, t) __SEND(__TYPEOF(o), 0, void(*)(Dialogs_Object, Display_Frame, Viewers_Viewer, Texts_Text), (o, f, v, t))
#define __Dialogs_Object_Copy(o, dup) __SEND(__TYPEOF(o), 1, void(*)(Dialogs_Object, Dialogs_Object*), (o, dup))
#define __Dialogs_Object_Draw(o, x, y, f) __SEND(__TYPEOF(o), 2, void(*)(Dialogs_Object, INTEGER, INTEGER, Display_Frame), (o, x, y, f))
#define __Dialogs_Object_Edit(o) __SEND(__TYPEOF(o), 3, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_GetDim(o, x, y, w, h) __SEND(__TYPEOF(o), 4, void(*)(Dialogs_Object, INTEGER*, INTEGER*, INTEGER*, INTEGER*), (o, x, y, w, h))
#define __Dialogs_Object_GetPDim(o, x, y, w, h) __SEND(__TYPEOF(o), 5, void(*)(Dialogs_Object, INTEGER*, INTEGER*, INTEGER*, INTEGER*), (o, x, y, w, h))
#define __Dialogs_Object_Handle(o, f, msg, msg__typ) __SEND(__TYPEOF(o), 6, void(*)(Dialogs_Object, Display_Frame, Display_FrameMsg*, LONGINT *), (o, f, msg, msg__typ))
#define __Dialogs_Object_Hide(o) __SEND(__TYPEOF(o), 7, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Init(o) __SEND(__TYPEOF(o), 8, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Load(o, r, r__typ) __SEND(__TYPEOF(o), 12, void(*)(Dialogs_Object, Files_Rider*, LONGINT *), (o, r, r__typ))
#define __Dialogs_Object_OverlappingObject(o) __SEND(__TYPEOF(o), 13, Dialogs_Object(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Print(o, x, y) __SEND(__TYPEOF(o), 14, void(*)(Dialogs_Object, INTEGER, INTEGER), (o, x, y))
#define __Dialogs_Object_Restore(o) __SEND(__TYPEOF(o), 15, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Select(o) __SEND(__TYPEOF(o), 16, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_SetCmd(o, cmd, cmd__len) __SEND(__TYPEOF(o), 17, void(*)(Dialogs_Object, CHAR*, LONGINT ), (o, cmd, cmd__len))
#define __Dialogs_Object_SetDim(o, x, y, w, h, cond) __SEND(__TYPEOF(o), 18, void(*)(Dialogs_Object, INTEGER, INTEGER, INTEGER, INTEGER, BOOLEAN), (o, x, y, w, h, cond))
#define __Dialogs_Object_SetName(o, name, name__len) __SEND(__TYPEOF(o), 19, void(*)(Dialogs_Object, CHAR*, LONGINT ), (o, name, name__len))
#define __Dialogs_Object_SetPar(o, par, par__len) __SEND(__TYPEOF(o), 20, void(*)(Dialogs_Object, CHAR*, LONGINT ), (o, par, par__len))
#define __Dialogs_Object_Store(o, r, r__typ) __SEND(__TYPEOF(o), 21, void(*)(Dialogs_Object, Files_Rider*, LONGINT *), (o, r, r__typ))
#define __Dialogs_Object_UnSelect(o) __SEND(__TYPEOF(o), 22, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Update(o, p) __SEND(__TYPEOF(o), 23, void(*)(Dialogs_Object, Dialogs_Panel), (o, p))

typedef
	struct Dialogs_PanelDesc {
		CHAR cmd[64];
		LONGINT _prvt0;
	} Dialogs_PanelDesc;

import void Dialogs_Panel_AlignSelected (Dialogs_Panel p, CHAR dir);
import void Dialogs_Panel_Broadcast (Dialogs_Panel p, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import BOOLEAN Dialogs_Panel_Contains (Dialogs_Panel p, Dialogs_Object o);
import Dialogs_Panel Dialogs_Panel_Copy (Dialogs_Panel p);
import void Dialogs_Panel_Draw (Dialogs_Panel p, INTEGER x, INTEGER y, Display_Frame f);
import void Dialogs_Panel_Enumerate (Dialogs_Panel p, void (*handle)(Dialogs_Object, BOOLEAN*));
import void Dialogs_Panel_GetObjects (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Dialogs_Object *obArray, LONGINT obArray__len, INTEGER *nofelems);
import void Dialogs_Panel_Insert (Dialogs_Panel p, Dialogs_Object o, BOOLEAN ov);
import void Dialogs_Panel_Load (Dialogs_Panel p, Files_Rider *r, LONGINT *r__typ);
import void Dialogs_Panel_MarkMenu (Dialogs_Panel p);
import void Dialogs_Panel_MoveSelected (Dialogs_Panel p, INTEGER dx, INTEGER dy);
import Dialogs_Object Dialogs_Panel_NamedObject (Dialogs_Panel p, CHAR *name, LONGINT name__len);
import INTEGER Dialogs_Panel_NofSelObjects (Dialogs_Panel p);
import void Dialogs_Panel_Print (Dialogs_Panel p, INTEGER x, INTEGER y);
import void Dialogs_Panel_RegulateDistance (Dialogs_Panel p, CHAR dir);
import void Dialogs_Panel_Remove (Dialogs_Panel p, Dialogs_Object o);
import void Dialogs_Panel_RemoveObjects (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void Dialogs_Panel_RemoveSelections (Dialogs_Panel p);
import void Dialogs_Panel_Restore (Dialogs_Panel p);
import void Dialogs_Panel_Select (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void Dialogs_Panel_SetCmd (Dialogs_Panel p, CHAR *cmd, LONGINT cmd__len);
import void Dialogs_Panel_Store (Dialogs_Panel p, Files_Rider *r, LONGINT *r__typ);
import Dialogs_Object Dialogs_Panel_ThisObject (Dialogs_Panel p, INTEGER x, INTEGER y);
#define __Dialogs_Panel_AlignSelected(p, dir) __SEND(__TYPEOF(p), 0, void(*)(Dialogs_Panel, CHAR), (p, dir))
#define __Dialogs_Panel_Broadcast(p, f, m, m__typ) __SEND(__TYPEOF(p), 2, void(*)(Dialogs_Panel, Display_Frame, Display_FrameMsg*, LONGINT *), (p, f, m, m__typ))
#define __Dialogs_Panel_Contains(p, o) __SEND(__TYPEOF(p), 4, BOOLEAN(*)(Dialogs_Panel, Dialogs_Object), (p, o))
#define __Dialogs_Panel_Copy(p) __SEND(__TYPEOF(p), 5, Dialogs_Panel(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Draw(p, x, y, f) __SEND(__TYPEOF(p), 6, void(*)(Dialogs_Panel, INTEGER, INTEGER, Display_Frame), (p, x, y, f))
#define __Dialogs_Panel_Enumerate(p, handle) __SEND(__TYPEOF(p), 7, void(*)(Dialogs_Panel, void(*)(Dialogs_Object, BOOLEAN*)), (p, handle))
#define __Dialogs_Panel_GetObjects(p, x, y, w, h, obArray, obArray__len, nofelems) __SEND(__TYPEOF(p), 8, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER, Dialogs_Object*, LONGINT , INTEGER*), (p, x, y, w, h, obArray, obArray__len, nofelems))
#define __Dialogs_Panel_Insert(p, o, ov) __SEND(__TYPEOF(p), 9, void(*)(Dialogs_Panel, Dialogs_Object, BOOLEAN), (p, o, ov))
#define __Dialogs_Panel_Load(p, r, r__typ) __SEND(__TYPEOF(p), 10, void(*)(Dialogs_Panel, Files_Rider*, LONGINT *), (p, r, r__typ))
#define __Dialogs_Panel_MarkMenu(p) __SEND(__TYPEOF(p), 11, void(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_MoveSelected(p, dx, dy) __SEND(__TYPEOF(p), 12, void(*)(Dialogs_Panel, INTEGER, INTEGER), (p, dx, dy))
#define __Dialogs_Panel_NamedObject(p, name, name__len) __SEND(__TYPEOF(p), 13, Dialogs_Object(*)(Dialogs_Panel, CHAR*, LONGINT ), (p, name, name__len))
#define __Dialogs_Panel_NofSelObjects(p) __SEND(__TYPEOF(p), 14, INTEGER(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Print(p, x, y) __SEND(__TYPEOF(p), 15, void(*)(Dialogs_Panel, INTEGER, INTEGER), (p, x, y))
#define __Dialogs_Panel_RegulateDistance(p, dir) __SEND(__TYPEOF(p), 16, void(*)(Dialogs_Panel, CHAR), (p, dir))
#define __Dialogs_Panel_Remove(p, o) __SEND(__TYPEOF(p), 18, void(*)(Dialogs_Panel, Dialogs_Object), (p, o))
#define __Dialogs_Panel_RemoveObjects(p, x, y, w, h) __SEND(__TYPEOF(p), 19, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER), (p, x, y, w, h))
#define __Dialogs_Panel_RemoveSelections(p) __SEND(__TYPEOF(p), 20, void(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Restore(p) __SEND(__TYPEOF(p), 21, void(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Select(p, x, y, w, h) __SEND(__TYPEOF(p), 23, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER), (p, x, y, w, h))
#define __Dialogs_Panel_SetCmd(p, cmd, cmd__len) __SEND(__TYPEOF(p), 24, void(*)(Dialogs_Panel, CHAR*, LONGINT ), (p, cmd, cmd__len))
#define __Dialogs_Panel_Store(p, r, r__typ) __SEND(__TYPEOF(p), 25, void(*)(Dialogs_Panel, Files_Rider*, LONGINT *), (p, r, r__typ))
#define __Dialogs_Panel_ThisObject(p, x, y) __SEND(__TYPEOF(p), 26, Dialogs_Object(*)(Dialogs_Panel, INTEGER, INTEGER), (p, x, y))


import LONGINT Dialogs_dUnit, Dialogs_pUnit;
import INTEGER Dialogs_res;
import void (*Dialogs_Edit)(Dialogs_Object);
import void (*Dialogs_Update)(Dialogs_Object, Dialogs_Panel);
import Dialogs_Panel Dialogs_cmdPanel, Dialogs_editPanel;
import Dialogs_Object Dialogs_editObject, Dialogs_lastin;

import LONGINT *Dialogs_ObjectDesc__typ;
import LONGINT *Dialogs_PanelDesc__typ;
import LONGINT *Dialogs_NotifyMsg__typ;

import void Dialogs_Error (CHAR *name, LONGINT name__len);
import void *Dialogs__init(void);


#endif
