/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Files.h"
#include "Kernel.h"

typedef
	struct Directories_DirectoryDesc *Directories_Directory;

typedef
	struct Directories_DirectoryDesc {
		CHAR path[128];
	} Directories_DirectoryDesc;

typedef
	void (*Directories_FileProc)(Directories_Directory, CHAR*, LONGINT , BOOLEAN, BOOLEAN*);

typedef
	void (*Directories_Notifier)(INTEGER, CHAR*, LONGINT , CHAR*, LONGINT );

typedef
	void (*Directories_PathProc)(CHAR*, LONGINT , BOOLEAN*);


export INTEGER Directories_res;
export Directories_Notifier Directories_notify;

export LONGINT *Directories_DirectoryDesc__typ;

export void Directories_Change (CHAR *path, LONGINT path__len);
export Directories_Directory Directories_Current (void);
export void Directories_Enumerate (Directories_Directory D, Directories_FileProc H);
export void Directories_LocalToURL (CHAR *name, LONGINT name__len);
static void Directories_NoNotify (INTEGER op, CHAR *path, LONGINT path__len, CHAR *name, LONGINT name__len);
export Directories_Directory Directories_Startup (void);
export Directories_Directory Directories_This (CHAR *path, LONGINT path__len);
export void Directories_URLToLocal (CHAR *name, LONGINT name__len);

#define Directories_EnumFiles(D, name, name__len, filter)	enumFiles(D, name, filter)
#define Directories_MapError(err)	mapError(err)
#include "Directories.c0"

void Directories_LocalToURL (CHAR *name, LONGINT name__len)
{
}

void Directories_URLToLocal (CHAR *name, LONGINT name__len)
{
}

Directories_Directory Directories_This (CHAR *path, LONGINT path__len)
{
	Directories_Directory D = NIL;
	LONGINT i = 0;
	CHAR absPathLocal[128], absPath[128];
	__DUP(path, path__len, CHAR);
	if (path[0] == 0x00 && Kernel_CWD[0] != 0x00) {
		__DEL(path);
		return Directories_This(Kernel_CWD, 256);
	} else {
		__NEW(D, Directories_DirectoryDesc);
		__COPY(path, D->path, 128);
		__DEL(path);
		return D;
	}
	__RETCHK;
}

void Directories_Enumerate (Directories_Directory D, Directories_FileProc H)
{
	Directories_res = Directories_EnumFiles(D, D->path, 128, H);
	if (Directories_res != 0) {
		Directories_res = Directories_MapError(Directories_res);
	}
}

Directories_Directory Directories_Current (void)
{
	return Directories_This(Kernel_CWD, 256);
}

void Directories_Change (CHAR *path, LONGINT path__len)
{
	__DUP(path, path__len, CHAR);
	Files_ChangeDirectory(path, path__len, &Directories_res);
	if (Directories_res == 0) {
		(*Directories_notify)(2, (CHAR*)"", (LONGINT)1, (CHAR*)"", (LONGINT)1);
	} else {
		Directories_res = Directories_MapError(Directories_res);
	}
	__DEL(path);
}

Directories_Directory Directories_Startup (void)
{
	return Directories_This(Kernel_CWD, 256);
}

static void Directories_NoNotify (INTEGER op, CHAR *path, LONGINT path__len, CHAR *name, LONGINT name__len)
{
	__DUP(path, path__len, CHAR);
	__DUP(name, name__len, CHAR);
	__DEL(path);
	__DEL(name);
}

__TDESC(Directories_DirectoryDesc, 1, 0) = {__TDFLDS("DirectoryDesc", 128), {-4}};

export void *Directories__init(void)
{
	__DEFMOD;
	__IMPORT(Files);
	__IMPORT(Kernel);
	__REGMOD(Directories, 0);
	__INITYP(Directories_DirectoryDesc, Directories_DirectoryDesc, 0);
/* BEGIN */
	Directories_notify = Directories_NoNotify;
	__ENDMOD;
}
