/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Oberon.h"
#include "Strings.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct Documents__1 *Documents_Opener;

struct Documents__1 {
	CHAR pattern[32], cmd[32];
	Documents_Opener next;
};


export Documents_Opener Documents_openers;
static Texts_Text Documents_scratch;
static Texts_Writer Documents_w;

export LONGINT *Documents__1__typ;

static void Documents_Init (void);
static void Documents_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
export void Documents_Open (void);
export void Documents_RegisterOpener (CHAR *pattern, LONGINT pattern__len, CHAR *command, LONGINT command__len);
export void Documents_RegisterOpeners (void);


static void Documents_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

void Documents_Open (void)
{
	Texts_Scanner s = {0};
	Texts_Reader r = {0};
	Documents_Opener o = NIL;
	INTEGER i = 0, res = 0;
	LONGINT pos = 0, end = 0, time = 0;
	Texts_Text text = NIL;
	CHAR str[256];
	CHAR ch = 0, quote = 0;
	str[0] = 0x00;
	text = Oberon_Par->text;
	pos = Oberon_Par->pos;
	Texts_OpenScanner(&s, Texts_Scanner__typ, text, pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 6 && s.c == '^') {
		Oberon_GetSelection(&text, &pos, &end, &time);
		if (time < 0) {
			return;
		}
	}
	Texts_OpenReader(&r, Texts_Reader__typ, text, pos);
	i = 0;
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && ((ch == ' ' || ch == 0x09) || ch == 0x0d)) {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (ch == '\'' || ch == '\"') {
		quote = ch;
		do {
			Texts_Read(&r, Texts_Reader__typ, &ch);
			str[__X(i, 256)] = ch;
			i += 1;
		} while (!(((r.eot || ch == quote) || ch == ' ') || i == 256));
		str[__X(i - 1, 256)] = 0x00;
	} else {
		while (!r.eot && !((((ch == ' ' || ch == 0x09) || ch == 0x0d) || ch == '\\') || i == 256)) {
			str[__X(i, 256)] = ch;
			Texts_Read(&r, Texts_Reader__typ, &ch);
			i += 1;
		}
		str[__X(i, 256)] = 0x00;
	}
	o = Documents_openers;
	while (!Strings_Match(str, 256, o->pattern, 32)) {
		o = o->next;
	}
	Oberon_Call(o->cmd, 32, Oberon_Par, 0, &res);
}

void Documents_RegisterOpener (CHAR *pattern, LONGINT pattern__len, CHAR *command, LONGINT command__len)
{
	Documents_Opener opener = NIL;
	__DUP(pattern, pattern__len, CHAR);
	__DUP(command, command__len, CHAR);
	__NEW(opener, Documents__1);
	__COPY(pattern, opener->pattern, 32);
	__COPY(command, opener->cmd, 32);
	opener->next = Documents_openers;
	Documents_openers = opener;
	__DEL(pattern);
	__DEL(command);
}

void Documents_RegisterOpeners (void)
{
	Texts_Scanner s = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Documents_Opener openers = NIL, opener = NIL;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 6 && s.c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&s, Texts_Scanner__typ, text, beg);
			Texts_Scan(&s, Texts_Scanner__typ);
		}
	}
	if (__IN(s.class, 0x06)) {
		__NEW(text, Texts_TextDesc);
		Texts_Open(text, s.s, 256);
		if (text->len != 0) {
			Texts_OpenScanner(&s, Texts_Scanner__typ, text, 0);
			Texts_Scan(&s, Texts_Scanner__typ);
			openers = NIL;
			while (__IN(s.class, 0x06)) {
				__NEW(opener, Documents__1);
				__COPY(s.s, opener->pattern, 32);
				Texts_Scan(&s, Texts_Scanner__typ);
				__COPY(s.s, opener->cmd, 32);
				Texts_Scan(&s, Texts_Scanner__typ);
				if (opener->pattern[0] != 0x00 && opener->cmd[0] != 0x00) {
					opener->next = openers;
					openers = opener;
				}
			}
			opener = openers;
			while (opener != NIL) {
				Documents_RegisterOpener(opener->pattern, 32, opener->cmd, 32);
				opener = opener->next;
			}
		}
	}
}

static void Documents_Init (void)
{
	Oberon_ParList par = NIL;
	INTEGER res = 0;
	Texts_OpenWriter(&Documents_w, Texts_Writer__typ);
	__NEW(Documents_scratch, Texts_TextDesc);
	Texts_Open(Documents_scratch, (CHAR*)"", (LONGINT)1);
	Documents_scratch->notify = Documents_NoNotify;
	Documents_openers = NIL;
	Documents_RegisterOpener((CHAR*)"*", (LONGINT)2, (CHAR*)"Edit.Open", (LONGINT)10);
	__NEW(par, Oberon_ParRec);
	par->text = Documents_scratch;
	par->pos = 0;
	par->vwr = Viewers_This(0, 0);
	par->frame = (Display_Frame)par->vwr;
	Texts_WriteString(&Documents_w, Texts_Writer__typ, (CHAR*)"Documents.Profile", (LONGINT)18);
	Texts_Append(Documents_scratch, Documents_w.buf);
	Oberon_Call((CHAR*)"Documents.RegisterOpeners", (LONGINT)26, par, 0, &res);
}

static void EnumPtrs(void (*P)(void*))
{
	P(Documents_openers);
	P(Documents_scratch);
	__ENUMR(&Documents_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(Documents__1, 1, 1) = {__TDFLDS("", 68), {64, -8}};

export void *Documents__init(void)
{
	__DEFMOD;
	__IMPORT(Oberon);
	__IMPORT(Strings);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Documents, EnumPtrs);
	__REGCMD("Open", Documents_Open);
	__REGCMD("RegisterOpeners", Documents_RegisterOpeners);
	__INITYP(Documents__1, Documents__1, 0);
/* BEGIN */
	Documents_Init();
	__ENDMOD;
}
