/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Files.h"
#include "Fonts.h"
#include "GraphicFrames.h"
#include "Graphics.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"


static Texts_Writer Draw_W;


static void Draw_Backup (CHAR *name, LONGINT name__len);
export void Draw_ChangeBackgroundColor (void);
export void Draw_ChangeColor (void);
export void Draw_ChangeFont (void);
export void Draw_ChangeWidth (void);
export void Draw_Delete (void);
static void Draw_GetArg (Texts_Scanner *S, LONGINT *S__typ);
export void Draw_LoadLibrary (void);
export void Draw_Macro (void);
export void Draw_MakeMacro (void);
export void Draw_Open (void);
export void Draw_OpenMacro (void);
export void Draw_Print (void);
export void Draw_SetWidth (void);
export void Draw_Store (void);
export void Draw_StoreLibrary (void);
export void Draw_ToggleTicks (void);


void Draw_Open (void)
{
	INTEGER X = 0, Y = 0;
	LONGINT beg = 0, end = 0, t = 0;
	Graphics_Graph G = NIL;
	GraphicFrames_Frame F = NIL;
	Viewers_Viewer V = NIL;
	Texts_Text text = NIL;
	Texts_Scanner S = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &t);
		if (t >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (__IN(S.class, 0x06)) {
		__NEW(G, Graphics_GraphDesc);
		Graphics_Open(G, S.s, 256);
		__NEW(F, GraphicFrames_FrameDesc);
		GraphicFrames_Open(F, G, -1, 0, 0, 1);
		Oberon_AllocateUserViewer(Oberon_Par->vwr->X, &X, &Y);
		V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu(S.s, 256, (CHAR*)"System.Close  System.Copy  System.Grow  Draw.Delete  Draw.Store", (LONGINT)64), (void*)F, TextFrames_menuH, X, Y);
	}
}

void Draw_Delete (void)
{
	GraphicFrames_Frame F = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		F = __GUARDP(Oberon_Par->vwr->dsc->next, GraphicFrames_FrameDesc, 1);
		GraphicFrames_Erase(F);
		Graphics_Delete(F->graph);
	}
}

static void Draw_GetArg (Texts_Scanner *S, LONGINT *S__typ)
{
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&*S, S__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '^') {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, T, beg);
			Texts_Scan(&*S, S__typ);
		}
	}
}

void Draw_SetWidth (void)
{
	Texts_Scanner S = {0};
	Draw_GetArg(&S, Texts_Scanner__typ);
	if ((S.class == 3 && S.i > 0) && S.i < 7) {
		Graphics_width = (int)S.i;
	}
}

void Draw_ChangeColor (void)
{
	Texts_Scanner S = {0};
	Graphics_ColorMsg CM = {0};
	Draw_GetArg(&S, Texts_Scanner__typ);
	if (S.class == 3) {
		CM.col = __MASK((int)S.i, -16);
		GraphicFrames_Change(GraphicFrames_Selected(), (void*)&CM, Graphics_ColorMsg__typ);
	}
}

void Draw_ChangeWidth (void)
{
	Texts_Scanner S = {0};
	Graphics_WidMsg WM = {0};
	Draw_GetArg(&S, Texts_Scanner__typ);
	if (S.class == 3) {
		WM.w = (int)S.i;
		GraphicFrames_Change(GraphicFrames_Selected(), (void*)&WM, Graphics_WidMsg__typ);
	}
}

void Draw_ChangeFont (void)
{
	Texts_Scanner S = {0};
	Graphics_FontMsg FM = {0};
	Draw_GetArg(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		FM.fnt = Fonts_This(S.s, 256);
		if (FM.fnt != NIL) {
			GraphicFrames_Change(GraphicFrames_Selected(), (void*)&FM, Graphics_FontMsg__typ);
		}
	}
}

void Draw_ChangeBackgroundColor (void)
{
	Texts_Scanner S = {0};
	Viewers_Viewer v = NIL;
	GraphicFrames_Frame G = NIL;
	v = Oberon_MarkedViewer();
	if (v->dsc != NIL && __ISP(v->dsc->next, GraphicFrames_FrameDesc, 1)) {
		Draw_GetArg(&S, Texts_Scanner__typ);
		G = __GUARDP(v->dsc->next, GraphicFrames_FrameDesc, 1);
		if (S.class == 3) {
			G->col = __MASK((int)S.i, -16);
			GraphicFrames_Restore(G);
		}
	}
}

void Draw_ToggleTicks (void)
{
	Viewers_Viewer v = NIL;
	GraphicFrames_Frame G = NIL;
	v = Oberon_MarkedViewer();
	if (v->dsc != NIL && __ISP(v->dsc->next, GraphicFrames_FrameDesc, 1)) {
		G = __GUARDP(v->dsc->next, GraphicFrames_FrameDesc, 1);
		G->ticked = !G->ticked;
		GraphicFrames_Restore(G);
	}
}

static void Draw_Backup (CHAR *name, LONGINT name__len)
{
	INTEGER res = 0, i = 0;
	CHAR ch = 0;
	CHAR bak[32];
	i = 0;
	ch = name[0];
	while (ch > 0x00) {
		bak[__X(i, 32)] = ch;
		i += 1;
		ch = name[__X(i, name__len)];
	}
	if (i < 28) {
		bak[__X(i, 32)] = '.';
		bak[__X(i + 1, 32)] = 'B';
		bak[__X(i + 2, 32)] = 'a';
		bak[__X(i + 3, 32)] = 'k';
		bak[__X(i + 4, 32)] = 0x00;
		Files_Rename(name, name__len, bak, 32, &res);
	}
}

void Draw_Store (void)
{
	Oberon_ParList par = NIL;
	Texts_Scanner S = {0};
	TextFrames_Frame Menu = NIL;
	GraphicFrames_Frame G = NIL;
	Viewers_Viewer v = NIL;
	par = Oberon_Par;
	if (par->frame == par->vwr->dsc) {
		Menu = __GUARDP(par->vwr->dsc, TextFrames_FrameDesc, 1);
		G = __GUARDP(Menu->next, GraphicFrames_FrameDesc, 1);
		Texts_OpenScanner(&S, Texts_Scanner__typ, Menu->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (S.class == 1) {
			Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
			Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" storing", (LONGINT)9);
			Texts_WriteLn(&Draw_W, Texts_Writer__typ);
			Texts_Append(Oberon_Log, Draw_W.buf);
			Draw_Backup((void*)S.s, 256);
			Graphics_WriteFile(G->graph, S.s, 256);
		}
	} else {
		Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (S.class == 1) {
			v = Oberon_MarkedViewer();
			if (v->dsc != NIL && __ISP(v->dsc->next, GraphicFrames_FrameDesc, 1)) {
				G = __GUARDP(v->dsc->next, GraphicFrames_FrameDesc, 1);
				Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
				Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" storing", (LONGINT)9);
				Texts_WriteLn(&Draw_W, Texts_Writer__typ);
				Texts_Append(Oberon_Log, Draw_W.buf);
				Draw_Backup((void*)S.s, 256);
				Graphics_WriteFile(G->graph, S.s, 256);
			}
		}
	}
}

static struct Print__15 {
	INTEGER *nofcopies;
	Texts_Scanner *S;
	struct Print__15 *lnk;
} *Print__15_s;

static void Copies__16 (void);

static void Copies__16 (void)
{
	CHAR ch = 0;
	*Print__15_s->nofcopies = 1;
	if ((*Print__15_s->S).nextCh == '/') {
		Texts_Read((void*)&*Print__15_s->S, Texts_Scanner__typ, &ch);
		if (ch >= '0' && ch <= '9') {
			*Print__15_s->nofcopies = (int)ch - 48;
		}
		while (ch > ' ') {
			Texts_Read((void*)&*Print__15_s->S, Texts_Scanner__typ, &ch);
		}
		(*Print__15_s->S).nextCh = ch;
	}
}

void Draw_Print (void)
{
	INTEGER nofcopies = 0;
	Texts_Scanner S = {0};
	Graphics_Graph G = NIL;
	Viewers_Viewer V = NIL;
	struct Print__15 _s;
	_s.nofcopies = &nofcopies;
	_s.S = &S;
	_s.lnk = Print__15_s;
	Print__15_s = &_s;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		Printer_Open((void*)S.s, 256, (void*)Oberon_User, 12, Oberon_Password);
		if (Printer_res == 0) {
			Texts_Scan(&S, Texts_Scanner__typ);
			while (S.class == 1) {
				Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
				Copies__16();
				__NEW(G, Graphics_GraphDesc);
				Graphics_Open(G, S.s, 256);
				if (Graphics_res == 0) {
					Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" printing", (LONGINT)10);
					Texts_WriteInt(&Draw_W, Texts_Writer__typ, nofcopies, 3);
					Texts_Append(Oberon_Log, Draw_W.buf);
					Graphics_Print(G, 0, Printer_PageHeight - 128);
					Printer_Page(nofcopies);
				} else {
					Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
				}
				Texts_WriteLn(&Draw_W, Texts_Writer__typ);
				Texts_Append(Oberon_Log, Draw_W.buf);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
			if (S.class == 6 && S.c == '*') {
				Copies__16();
				V = Oberon_MarkedViewer();
				if (V->dsc != NIL && __ISP(V->dsc->next, GraphicFrames_FrameDesc, 1)) {
					Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
					Texts_Scan(&S, Texts_Scanner__typ);
					if (S.class == 1) {
						Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
						Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" printing", (LONGINT)10);
						Texts_WriteInt(&Draw_W, Texts_Writer__typ, nofcopies, 3);
						Texts_Append(Oberon_Log, Draw_W.buf);
						Graphics_Print(__GUARDP(V->dsc->next, GraphicFrames_FrameDesc, 1)->graph, 0, Printer_PageHeight - 128);
						Printer_Page(nofcopies);
					}
				}
			}
			Printer_Close();
		} else if (Printer_res == 1) {
			Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" no printer", (LONGINT)12);
		} else if (Printer_res == 2) {
			Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" no link", (LONGINT)9);
		} else if (Printer_res == 3) {
			Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" bad response", (LONGINT)14);
		} else if (Printer_res == 4) {
			Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" no permission", (LONGINT)15);
		}
	}
	Texts_WriteLn(&Draw_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Draw_W.buf);
	Print__15_s = _s.lnk;
}

void Draw_Macro (void)
{
	Texts_Scanner S = {0};
	Texts_Text T = NIL;
	LONGINT time = 0, beg = 0, end = 0;
	CHAR Lname[32];
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		__COPY(S.s, Lname, 32);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (S.class == 6 && S.c == '^') {
			Oberon_GetSelection(&T, &beg, &end, &time);
			if (time >= 0) {
				Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
		}
		if (S.class == 1 || S.class == 2) {
			GraphicFrames_Macro((void*)Lname, 32, (void*)S.s, 256);
		}
	}
}

void Draw_OpenMacro (void)
{
	GraphicFrames_Frame F = NIL;
	Graphics_Object sel = NIL;
	F = GraphicFrames_Selected();
	if (F != NIL) {
		sel = F->graph->sel;
		if (sel != NIL && __ISP(sel, Graphics_MacroDesc, 1)) {
			GraphicFrames_Deselect(F);
			Graphics_OpenMac(__GUARDP(sel, Graphics_MacroDesc, 1)->mac, F->graph, F->mark.x - F->x, F->mark.y - F->y);
			GraphicFrames_Draw(F);
		}
	}
}

static struct MakeMacro__10 {
	BOOLEAN *new;
	GraphicFrames_Frame *F;
	Texts_Scanner *S;
	CHAR (*Lname)[32];
	struct MakeMacro__10 *lnk;
} *MakeMacro__10_s;

static void MakeMac__11 (void);

static void MakeMac__11 (void)
{
	INTEGER x0 = 0, y0 = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	Graphics_MacHead mh = NIL;
	Graphics_Library L = NIL;
	L = Graphics_ThisLib((void*)*MakeMacro__10_s->Lname, 32, 0);
	if (L == NIL) {
		L = Graphics_NewLib((void*)*MakeMacro__10_s->Lname, 32);
	}
	x0 = (*MakeMacro__10_s->F)->mark.x;
	y0 = (*MakeMacro__10_s->F)->mark.y;
	x1 = (*MakeMacro__10_s->F)->mark.next->x;
	y1 = (*MakeMacro__10_s->F)->mark.next->y;
	w = __ABS(x1 - x0);
	h = __ABS(y1 - y0);
	if (x0 < x1) {
		x0 = x0 - (*MakeMacro__10_s->F)->x;
	} else {
		x0 = x1 - (*MakeMacro__10_s->F)->x;
	}
	if (y0 < y1) {
		y0 = y0 - (*MakeMacro__10_s->F)->y;
	} else {
		y0 = y1 - (*MakeMacro__10_s->F)->y;
	}
	mh = Graphics_MakeMac((*MakeMacro__10_s->F)->graph, x0, y0, w, h, (void*)(*MakeMacro__10_s->S).s, 256);
	Graphics_InsertMac(mh, L, &*MakeMacro__10_s->new);
}

void Draw_MakeMacro (void)
{
	BOOLEAN new = 0;
	GraphicFrames_Frame F = NIL;
	Texts_Scanner S = {0};
	CHAR Lname[32];
	struct MakeMacro__10 _s;
	_s.new = &new;
	_s.F = &F;
	_s.S = &S;
	_s.Lname = (void*)Lname;
	_s.lnk = MakeMacro__10_s;
	MakeMacro__10_s = &_s;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		__COPY(S.s, Lname, 32);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (S.class == 1 || S.class == 2 && S.len <= 8) {
			F = GraphicFrames_Focus();
			if (F != NIL && F->graph->sel != NIL) {
				MakeMac__11();
				Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
				if (new) {
					Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" inserted in ", (LONGINT)14);
				} else {
					Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" replaced in ", (LONGINT)14);
				}
				Texts_WriteString(&Draw_W, Texts_Writer__typ, Lname, 32);
				Texts_WriteLn(&Draw_W, Texts_Writer__typ);
				Texts_Append(Oberon_Log, Draw_W.buf);
			}
		}
	}
	MakeMacro__10_s = _s.lnk;
}

void Draw_LoadLibrary (void)
{
	Texts_Scanner S = {0};
	Graphics_Library L = NIL;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		L = Graphics_ThisLib((void*)S.s, 256, 1);
		Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
		Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" loaded", (LONGINT)8);
		Texts_WriteLn(&Draw_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Draw_W.buf);
	}
}

void Draw_StoreLibrary (void)
{
	INTEGER i = 0;
	Texts_Scanner S = {0};
	Graphics_Library L = NIL;
	CHAR Lname[32];
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		i = 0;
		while (S.s[__X(i, 256)] >= '0') {
			Lname[__X(i, 32)] = S.s[__X(i, 256)];
			i += 1;
		}
		Lname[__X(i, 32)] = 0x00;
		L = Graphics_ThisLib((void*)Lname, 32, 0);
		if (L != NIL) {
			Texts_WriteString(&Draw_W, Texts_Writer__typ, S.s, 256);
			Texts_WriteString(&Draw_W, Texts_Writer__typ, (CHAR*)" storing", (LONGINT)9);
			Texts_WriteLn(&Draw_W, Texts_Writer__typ);
			Texts_Append(Oberon_Log, Draw_W.buf);
			Graphics_StoreLib(L, (void*)S.s, 256);
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Draw_W, Texts_Writer__typ, 36, 1, P);
}


export void *Draw__init(void)
{
	__DEFMOD;
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GraphicFrames);
	__IMPORT(Graphics);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Draw, EnumPtrs);
	__REGCMD("ChangeBackgroundColor", Draw_ChangeBackgroundColor);
	__REGCMD("ChangeColor", Draw_ChangeColor);
	__REGCMD("ChangeFont", Draw_ChangeFont);
	__REGCMD("ChangeWidth", Draw_ChangeWidth);
	__REGCMD("Delete", Draw_Delete);
	__REGCMD("LoadLibrary", Draw_LoadLibrary);
	__REGCMD("Macro", Draw_Macro);
	__REGCMD("MakeMacro", Draw_MakeMacro);
	__REGCMD("Open", Draw_Open);
	__REGCMD("OpenMacro", Draw_OpenMacro);
	__REGCMD("Print", Draw_Print);
	__REGCMD("SetWidth", Draw_SetWidth);
	__REGCMD("Store", Draw_Store);
	__REGCMD("StoreLibrary", Draw_StoreLibrary);
	__REGCMD("ToggleTicks", Draw_ToggleTicks);
/* BEGIN */
	Texts_OpenWriter(&Draw_W, Texts_Writer__typ);
	__ENDMOD;
}
