/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Unix.h"
#include "Viewers.h"

struct EdiT__1 {
	INTEGER len;
	CHAR buf[128];
	SHORTINT d[128];
};


static Texts_Writer EdiT_W;
static struct EdiT__1 EdiT_search;

export LONGINT *EdiT__1__typ;

static void EdiT_BackSpace (TextFrames_Frame f);
static LONGINT EdiT_BegOfLine (Texts_Text text, LONGINT pos);
static void EdiT_CompileDk (void);
export void EdiT_Grep (void);
export void EdiT_Handle (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
static LONGINT EdiT_KMPsearch (Texts_Text text, LONGINT beg);
export void EdiT_LocateLine (void);
export void EdiT_Match (void);
export void EdiT_Open (void);
export void EdiT_SearchDiff (void);
static void EdiT_SearchDiff0 (BOOLEAN precise);
export void EdiT_SearchDiffW (void);
static LONGINT EdiT_SearchStr (Texts_Text t, LONGINT pos, CHAR *s, LONGINT s__len, INTEGER at);
export void EdiT_Show (void);
static void EdiT_ShowPos (TextFrames_Frame f, LONGINT car);
export void EdiT_StoreAscii (void);
export void EdiT_StoreDosAscii (void);
export void EdiT_StoreMacAscii (void);
export void EdiT_UnmarkMenu (Viewers_Viewer V);


static LONGINT EdiT_BegOfLine (Texts_Text text, LONGINT pos)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	for (;;) {
		pos -= 1;
		if (pos < 0) {
			return 0;
		}
		Texts_OpenReader(&r, Texts_Reader__typ, text, pos);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		if (ch == 0x0d) {
			return pos + 1;
		}
	}
	__RETCHK;
}

static void EdiT_BackSpace (TextFrames_Frame f)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	LONGINT pos = 0;
	pos = f->carloc.org - 1;
	if (pos < 0) {
		pos = 0;
	}
	Texts_OpenReader(&r, Texts_Reader__typ, f->text, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && Texts_Pos(&r, Texts_Reader__typ) <= f->carloc.pos) {
		if (ch > ' ') {
			pos = Texts_Pos(&r, Texts_Reader__typ);
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (pos < f->carloc.pos) {
		Texts_Delete(f->text, pos, f->carloc.pos);
		TextFrames_SetCaret(f, pos);
	}
}

static void EdiT_ShowPos (TextFrames_Frame f, LONGINT car)
{
	INTEGER m = 0;
	if (f->hasCar) {
		TextFrames_RemoveCaret(f);
	}
	if (f->hasSel) {
		TextFrames_RemoveSelection(f);
	}
	Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	m = 200;
	while (car < f->org || TextFrames_Pos(f, f->X + f->W, f->Y) < car) {
		TextFrames_Show(f, EdiT_BegOfLine(f->text, car - (LONGINT)m));
		m -= 20;
	}
	TextFrames_SetCaret(f, car);
}

static void EdiT_CompileDk (void)
{
	SHORTINT d = 0, k = 0, l = 0;
	k = 1;
	d = 1;
	while ((int)k < EdiT_search.len) {
		l = 0;
		while ((int)(d + l) < EdiT_search.len && EdiT_search.buf[__X(l, 128)] == EdiT_search.buf[__X(d + l, 128)]) {
			l = l + 1;
		}
		while (k <= d + l) {
			EdiT_search.d[__X(k, 128)] = d;
			k = k + 1;
		}
		d = d + 1;
	}
}

static LONGINT EdiT_KMPsearch (Texts_Text text, LONGINT beg)
{
	Texts_Reader R = {0};
	CHAR ch = 0;
	SHORTINT k = 0;
	if (EdiT_search.len > 0) {
		Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		k = 0;
		while (!R.eot) {
			if (ch == EdiT_search.buf[__X(k, 128)]) {
				k = k + 1;
				if ((int)k == EdiT_search.len) {
					return (Texts_Pos(&R, Texts_Reader__typ) - (LONGINT)k) + (LONGINT)EdiT_search.len;
				} else {
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
			} else if (k == 0) {
				Texts_Read(&R, Texts_Reader__typ, &ch);
			} else {
				k = k - EdiT_search.d[__X(k, 128)];
			}
		}
	}
	return -1;
}

void EdiT_Handle (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	if (__ISP(F, TextFrames_FrameDesc, 1)) {
		if (__IS(M__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *M__ = (void*)M;
			if (((*M__).id == 0 && (*(TextFrames_Frame*)&F)->hasCar) && (*M__).ch == 0x08) {
				EdiT_BackSpace((*(TextFrames_Frame*)&F));
			} else {
				TextFrames_Handle((void*)(*(TextFrames_Frame*)&F), (void*)&*M__, M__typ);
			}
		} else {
			TextFrames_Handle((void*)(*(TextFrames_Frame*)&F), &*M, M__typ);
		}
	} else __WITHCHK;
}

void EdiT_Open (void)
{
	Oberon_ParList par = NIL;
	Texts_Text T = NIL;
	Texts_Scanner S = {0};
	Viewers_Viewer V = NIL;
	INTEGER X = 0, Y = 0;
	LONGINT beg = 0, end = 0, time = 0;
	par = Oberon_Par;
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^' || S.line != 0) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (__IN(S.class, 0x06)) {
		Oberon_AllocateUserViewer(par->vwr->X, &X, &Y);
		V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu(S.s, 256, (CHAR*)"^Edit.Menu.Text", (LONGINT)16), (void*)TextFrames_NewText(TextFrames_Text(S.s, 256), 0), TextFrames_menuH, X, Y);
		V->dsc->next->handle = EdiT_Handle;
	}
}

void EdiT_UnmarkMenu (Viewers_Viewer V)
{
	Texts_Reader R = {0};
	Texts_Text text = NIL;
	CHAR ch = 0;
	if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc, TextFrames_FrameDesc, 1)) {
		text = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
		if (text->len > 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, text, text->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			if (ch == '!') {
				Texts_Delete(text, text->len - 1, text->len);
			}
		}
	}
}

void EdiT_StoreAscii (void)
{
	Oberon_ParList par = NIL;
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	Texts_Scanner S = {0};
	TextFrames_Frame TF = NIL;
	CHAR ch = 0;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader R = {0};
	Files_File F = NIL, F0 = NIL;
	Files_Rider O = {0};
	Unix_Status stat = {0};
	LONGINT res = 0;
	Texts_WriteString(&EdiT_W, Texts_Writer__typ, (CHAR*)"EdiT.StoreAscii ", (LONGINT)17);
	par = Oberon_Par;
	if (par->frame == par->vwr->dsc) {
		V = par->vwr;
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
	} else {
		V = Oberon_MarkedViewer();
		Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	}
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^') {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	} else if (S.class == 6 && S.c == '*') {
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
	}
	if ((__IN(S.class, 0x06) && V->dsc != NIL) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		TF = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		TextFrames_Mark(TF, -1);
		Texts_WriteString(&EdiT_W, Texts_Writer__typ, S.s, 256);
		Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, EdiT_W.buf);
		Texts_OpenReader(&R, Texts_Reader__typ, TF->text, 0);
		F = Files_New(S.s, 256);
		Files_Set(&O, Files_Rider__typ, F, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			if (ch != 0x1c) {
				Files_Write(&O, Files_Rider__typ, ch);
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		F0 = Files_Old(S.s, 256);
		Files_Register(F);
		if (F0 != NIL) {
			res = Unix_Fstat(F0->fd, &stat, Unix_Status__typ);
			if (stat.uid == Unix_Getuid()) {
				res = Unix_Fchmod(F->fd, stat.mode);
			}
		}
		EdiT_UnmarkMenu(V);
		TextFrames_Mark(TF, 1);
	}
}

void EdiT_StoreMacAscii (void)
{
	Oberon_ParList par = NIL;
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	Texts_Scanner S = {0};
	TextFrames_Frame TF = NIL;
	CHAR ch = 0;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader R = {0};
	Files_File F = NIL, F0 = NIL;
	Files_Rider O = {0};
	Unix_Status stat = {0};
	LONGINT res = 0;
	Texts_WriteString(&EdiT_W, Texts_Writer__typ, (CHAR*)"EdiT.StoreMacAscii ", (LONGINT)20);
	par = Oberon_Par;
	if (par->frame == par->vwr->dsc) {
		V = par->vwr;
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
	} else {
		V = Oberon_MarkedViewer();
		Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	}
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^') {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	} else if (S.class == 6 && S.c == '*') {
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
	}
	if ((__IN(S.class, 0x06) && V->dsc != NIL) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		TF = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		TextFrames_Mark(TF, -1);
		Texts_WriteString(&EdiT_W, Texts_Writer__typ, S.s, 256);
		Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, EdiT_W.buf);
		Texts_OpenReader(&R, Texts_Reader__typ, TF->text, 0);
		F = Files_New(S.s, 256);
		Files_Set(&O, Files_Rider__typ, F, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot) {
			if (ch != 0x1c && ch != 0x0a) {
				Files_Write(&O, Files_Rider__typ, ch);
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		F0 = Files_Old(S.s, 256);
		Files_Register(F);
		if (F0 != NIL) {
			res = Unix_Fstat(F0->fd, &stat, Unix_Status__typ);
			if (stat.uid == Unix_Getuid()) {
				res = Unix_Fchmod(F->fd, stat.mode);
			}
		}
		TextFrames_Mark(TF, 1);
	}
}

void EdiT_StoreDosAscii (void)
{
	Oberon_ParList par = NIL;
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	Texts_Scanner S = {0};
	TextFrames_Frame TF = NIL;
	CHAR ch = 0;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader R = {0};
	Files_File F = NIL, F0 = NIL;
	Files_Rider O = {0};
	Unix_Status stat = {0};
	LONGINT res = 0;
	Texts_WriteString(&EdiT_W, Texts_Writer__typ, (CHAR*)"EdiT.StoreDosAscii ", (LONGINT)20);
	par = Oberon_Par;
	if (par->frame == par->vwr->dsc) {
		V = par->vwr;
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
	} else {
		V = Oberon_MarkedViewer();
		Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	}
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^') {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	} else if (S.class == 6 && S.c == '*') {
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
	}
	if ((__IN(S.class, 0x06) && V->dsc != NIL) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		TF = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		TextFrames_Mark(TF, -1);
		Texts_WriteString(&EdiT_W, Texts_Writer__typ, S.s, 256);
		Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, EdiT_W.buf);
		Texts_OpenReader(&R, Texts_Reader__typ, TF->text, 0);
		F = Files_New(S.s, 256);
		Files_Set(&O, Files_Rider__typ, F, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot) {
			if (ch == 0x0d) {
				Files_Write(&O, Files_Rider__typ, 0x0d);
				Files_Write(&O, Files_Rider__typ, 0x0a);
			} else if (ch != 0x0a) {
				Files_Write(&O, Files_Rider__typ, ch);
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		F0 = Files_Old(S.s, 256);
		Files_Register(F);
		if (F0 != NIL) {
			res = Unix_Fstat(F0->fd, &stat, Unix_Status__typ);
			if (stat.uid == Unix_Getuid()) {
				res = Unix_Fchmod(F->fd, stat.mode);
			}
		}
		TextFrames_Mark(TF, 1);
	}
}

void EdiT_LocateLine (void)
{
	Oberon_ParList par = NIL;
	Viewers_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	Texts_Text T = NIL;
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	LONGINT line = 0, beg = 0, end = 0, time = 0;
	CHAR ch = 0;
	par = Oberon_Par;
	V = Oberon_FocusViewer;
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^' || S.line != 0) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	while (S.class < 3 && S.line == 0) {
		Texts_Scan(&S, Texts_Scanner__typ);
	}
	if (((S.class == 3 && V->state > 1) && V->dsc != NIL) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		F = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, 0);
		line = 1;
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot && line < S.i) {
			if (ch == 0x0d) {
				line += 1;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		EdiT_ShowPos(F, Texts_Pos(&R, Texts_Reader__typ) - 1);
	}
}

void EdiT_Match (void)
{
	Texts_Reader R = {0};
	Viewers_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	LONGINT len = 0, i = 0, lev = 0;
	CHAR ch = 0;
	CHAR lpar[32], rpar[32], tx[32];
	V = Oberon_MarkedViewer();
	if (V->dsc != NIL && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		F = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		if (F->hasSel && F->selend.pos - F->selbeg.pos < 32) {
			i = 0;
			len = F->selend.pos - F->selbeg.pos;
			Texts_OpenReader(&R, Texts_Reader__typ, F->text, F->selbeg.pos);
			while (i < len) {
				Texts_Read(&R, Texts_Reader__typ, &ch);
				lpar[__X(i, 32)] = ch;
				if (ch == '(') {
					ch = ')';
				} else if (ch == '[') {
					ch = ']';
				} else if (ch == '{') {
					ch = '}';
				} else if (ch == '<') {
					ch = '>';
				}
				i += 1;
				rpar[__X(len - i, 32)] = ch;
			}
			lpar[__X(len, 32)] = 0x00;
			rpar[__X(len, 32)] = 0x00;
			tx[__X(len, 32)] = 0x00;
			lev = 1;
			for (;;) {
				i = 0;
				while (i < len && !R.eot) {
					Texts_Read(&R, Texts_Reader__typ, &tx[__X(i, 32)]);
					i += 1;
				}
				if (R.eot) {
					return;
				} else if (__STRCMP(tx, rpar) == 0) {
					lev -= 1;
					if (lev == 0) {
						break;
					}
				} else if (__STRCMP(tx, lpar) == 0) {
					lev += 1;
				} else {
					Texts_OpenReader(&R, Texts_Reader__typ, F->text, (Texts_Pos(&R, Texts_Reader__typ) - len) + 1);
				}
			}
			TextFrames_SetSelection(F, F->selbeg.pos, Texts_Pos(&R, Texts_Reader__typ));
		}
	}
}

static struct SearchDiff0__11 {
	BOOLEAN *precise;
	struct SearchDiff0__11 *lnk;
} *SearchDiff0__11_s;

static void GetSelection__12 (TextFrames_Frame *F, LONGINT *pos);
static void Read__14 (Texts_Reader *r, LONGINT *r__typ, CHAR *ch, LONGINT *p);
static void ShowSelection__16 (TextFrames_Frame f, LONGINT pos);

static void GetSelection__12 (TextFrames_Frame *F, LONGINT *pos)
{
	LONGINT time = 0;
	Viewers_Viewer v = NIL;
	INTEGER x = 0;
	TextFrames_Frame f = NIL;
	time = -1;
	x = 0;
	*F = NIL;
	while (x < Display_Width) {
		v = Viewers_This(x, 0);
		while (v->state > 1) {
			if (__ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
				f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
				if (f->hasSel && f->time > time) {
					*F = f;
					*pos = f->selbeg.pos;
					time = f->time;
				}
			}
			v = Viewers_Next(v);
		}
		x = x + v->W;
	}
	if (*F != NIL) {
		TextFrames_RemoveSelection(*F);
		TextFrames_RemoveCaret(*F);
	}
}

static void ShowSelection__16 (TextFrames_Frame f, LONGINT pos)
{
	LONGINT x = 0;
	if (pos > TextFrames_Pos(f, (f->X + f->W) - 1, f->Y)) {
		x = pos - 150;
		if (x < 0) {
			x = 0;
		}
		TextFrames_Show(f, x);
	}
	TextFrames_SetSelection(f, pos, pos + 1);
}

static void Read__14 (Texts_Reader *r, LONGINT *r__typ, CHAR *ch, LONGINT *p)
{
	Texts_Read(&*r, r__typ, &*ch);
	*p += 1;
	if ((!*SearchDiff0__11_s->precise && *ch <= ' ') && *ch != 0x00) {
		do {
			Texts_Read(&*r, r__typ, &*ch);
			*p += 1;
		} while (!(*ch > ' ' || *ch == 0x00));
	}
}

static void EdiT_SearchDiff0 (BOOLEAN precise)
{
	TextFrames_Frame f1 = NIL, f2 = NIL;
	LONGINT p1 = 0, p2 = 0;
	Texts_Reader r1 = {0}, r2 = {0};
	CHAR ch1 = 0, ch2 = 0;
	struct SearchDiff0__11 _s;
	_s.precise = &precise;
	_s.lnk = SearchDiff0__11_s;
	SearchDiff0__11_s = &_s;
	GetSelection__12(&f1, &p1);
	GetSelection__12(&f2, &p2);
	if (f1 != NIL && f2 != NIL) {
		Texts_OpenReader(&r1, Texts_Reader__typ, f1->text, p1);
		Texts_OpenReader(&r2, Texts_Reader__typ, f2->text, p2);
		do {
			Read__14(&r1, Texts_Reader__typ, &ch1, &p1);
			Read__14(&r2, Texts_Reader__typ, &ch2, &p2);
		} while (!(ch1 != ch2 || ch1 == 0x00));
		if (ch1 == 0x00 || ch2 == 0x00) {
			p1 -= 1;
			p2 -= 1;
		}
		ShowSelection__16(f1, p1 - 1);
		ShowSelection__16(f2, p2 - 1);
	}
	SearchDiff0__11_s = _s.lnk;
}

void EdiT_SearchDiff (void)
{
	EdiT_SearchDiff0(0);
}

void EdiT_SearchDiffW (void)
{
	EdiT_SearchDiff0(1);
}

static LONGINT EdiT_SearchStr (Texts_Text t, LONGINT pos, CHAR *s, LONGINT s__len, INTEGER at)
{
	INTEGER i = 0, j = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	j = at;
	while (i != 128 && s[__X(j, s__len)] != 0x00) {
		EdiT_search.buf[__X(i, 128)] = s[__X(j, s__len)];
		j = j + 1;
		i = i + 1;
	}
	EdiT_search.len = i;
	EdiT_CompileDk();
	__DEL(s);
	return EdiT_KMPsearch(t, pos);
}

void EdiT_Show (void)
{
	Texts_Text T = NIL;
	Texts_Scanner S = {0};
	Viewers_Viewer V = NIL;
	INTEGER X = 0, Y = 0, i = 0, j = 0;
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	CHAR name[64];
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^' || S.line != 0) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (__IN(S.class, 0x06)) {
		i = -1;
		j = 0;
		while (S.s[__X(j, 256)] != 0x00) {
			if (S.s[__X(j, 256)] == '.') {
				i = j;
			}
			name[__X(j, 64)] = S.s[__X(j, 256)];
			j = j + 1;
		}
		if (i < 0) {
			name[__X(j, 64)] = '.';
			i = j;
		}
		name[__X(i + 1, 64)] = 'M';
		name[__X(i + 2, 64)] = 'o';
		name[__X(i + 3, 64)] = 'd';
		name[__X(i + 4, 64)] = 0x00;
		T = TextFrames_Text(name, 64);
		pos = 0;
		if (j > i) {
			if (j == i + 1) {
				Texts_Scan(&S, Texts_Scanner__typ);
				if (S.class == 6 && S.c == '(') {
					Texts_Scan(&S, Texts_Scanner__typ);
					if (__IN(S.class, 0x06)) {
						pos = EdiT_SearchStr(T, 0, (CHAR*)"PROCEDURE", (LONGINT)10, 0);
						pos = EdiT_SearchStr(T, pos, S.s, 256, 0);
						Texts_Scan(&S, Texts_Scanner__typ);
						Texts_Scan(&S, Texts_Scanner__typ);
						if (__IN(S.class, 0x06)) {
							pos = EdiT_SearchStr(T, pos, S.s, 256, 0);
						} else {
							pos = 0;
						}
					}
				}
			} else {
				pos = EdiT_SearchStr(T, 0, S.s, 256, i + 1);
			}
		}
		Oberon_AllocateUserViewer(Oberon_Par->vwr->X, &X, &Y);
		V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu(S.s, 256, (CHAR*)"^Edit.Menu.Text", (LONGINT)16), (void*)TextFrames_NewText(T, pos - 200), TextFrames_menuH, X, Y);
		V->dsc->next->handle = EdiT_Handle;
		Oberon_PassFocus(V);
		TextFrames_SetCaret(__GUARDP(V->dsc->next, TextFrames_FrameDesc, 1), pos);
	}
}

void EdiT_Grep (void)
{
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	CHAR ch = 0;
	INTEGER n = 0;
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0, time = 0, pos = 0;
	EdiT_search.len = 0;
	if (Oberon_Par->vwr->dsc == Oberon_Par->frame) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			while (!R.eot && beg + (LONGINT)EdiT_search.len < end) {
				EdiT_search.buf[__X(EdiT_search.len, 128)] = ch;
				EdiT_search.len += 1;
				Texts_Read(&R, Texts_Reader__typ, &ch);
			}
			EdiT_search.buf[__X(EdiT_search.len, 128)] = 0x00;
			if (EdiT_search.len > 0) {
				if (__ISP(Oberon_Par->vwr->dsc->next, TextFrames_FrameDesc, 1)) {
					Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(Oberon_Par->vwr->dsc->next, TextFrames_FrameDesc, 1)->text, 0);
					Texts_Scan(&S, Texts_Scanner__typ);
				} else {
					Texts_WriteString(&EdiT_W, Texts_Writer__typ, (CHAR*)"not a text viewer", (LONGINT)18);
					Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
					Texts_Append(Oberon_Log, EdiT_W.buf);
				}
			} else {
				Texts_WriteString(&EdiT_W, Texts_Writer__typ, (CHAR*)"empty selection", (LONGINT)16);
				Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
				Texts_Append(Oberon_Log, EdiT_W.buf);
			}
		} else {
			Texts_WriteString(&EdiT_W, Texts_Writer__typ, (CHAR*)"no selection", (LONGINT)13);
			Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
			Texts_Append(Oberon_Log, EdiT_W.buf);
		}
	} else {
		Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (__IN(S.class, 0x06)) {
			__COPY(S.s, EdiT_search.buf, 128);
			EdiT_search.len = S.len;
			if (S.class == 2) {
				EdiT_search.len -= 1;
			}
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (EdiT_search.len > 0 && __IN(S.class, 0x06)) {
		EdiT_CompileDk();
		while (__IN(S.class, 0x06)) {
			T = TextFrames_Text(S.s, 256);
			n = 0;
			pos = EdiT_KMPsearch(T, 0);
			while (pos >= 0) {
				if (n == 0) {
					Texts_WriteString(&EdiT_W, Texts_Writer__typ, S.s, 256);
				}
				if (__MASK(n, -4) == 0) {
					Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
				}
				Texts_WriteInt(&EdiT_W, Texts_Writer__typ, pos, 10);
				n += 1;
				pos = EdiT_KMPsearch(T, pos);
			}
			if (n > 0) {
				Texts_WriteLn(&EdiT_W, Texts_Writer__typ);
				Texts_Append(Oberon_Log, EdiT_W.buf);
			}
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&EdiT_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(EdiT__1, 1, 0) = {__TDFLDS("", 258), {-4}};

export void *EdiT__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Unix);
	__IMPORT(Viewers);
	__REGMOD(EdiT, EnumPtrs);
	__REGCMD("Grep", EdiT_Grep);
	__REGCMD("LocateLine", EdiT_LocateLine);
	__REGCMD("Match", EdiT_Match);
	__REGCMD("Open", EdiT_Open);
	__REGCMD("SearchDiff", EdiT_SearchDiff);
	__REGCMD("SearchDiffW", EdiT_SearchDiffW);
	__REGCMD("Show", EdiT_Show);
	__REGCMD("StoreAscii", EdiT_StoreAscii);
	__REGCMD("StoreDosAscii", EdiT_StoreDosAscii);
	__REGCMD("StoreMacAscii", EdiT_StoreMacAscii);
	__INITYP(EdiT__1, EdiT__1, 0);
/* BEGIN */
	Texts_OpenWriter(&EdiT_W, Texts_Writer__typ);
	EdiT_search.len = 0;
	EdiT_search.buf[0] = 0x00;
	__ENDMOD;
}
