/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Fonts.h"
#include "In.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Out.h"
#include "PanelElems.h"
#include "Strings.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Types.h"
#include "Viewers.h"

typedef
	struct ElemTools_EditFrameDesc *ElemTools_EditFrame;

typedef
	struct ElemTools_EditFrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		Elems_Elem e;
	} ElemTools_EditFrameDesc;


export INTEGER ElemTools_defaultH, ElemTools_defaultW, ElemTools_maxW;
static INTEGER ElemTools_descW;
export Texts_Elem ElemTools_curElem;
export INTEGER ElemTools_y, ElemTools_x, ElemTools_step, ElemTools_top, ElemTools_left;
export BOOLEAN ElemTools_wasBool;
static PanelElems_Text ElemTools_context;
static Texts_Writer ElemTools_W;
export Texts_Text ElemTools_menuText;

export LONGINT *ElemTools_EditFrameDesc__typ;

export void ElemTools_AddAttr (void);
export void ElemTools_Align (void);
export void ElemTools_Apply (void);
export void ElemTools_ClearPanel (void);
export void ElemTools_CreateCheckBox (CHAR *name, LONGINT name__len, BOOLEAN val);
export void ElemTools_CreatePopupList (CHAR *name, LONGINT name__len, CHAR *default_, LONGINT default___len);
export void ElemTools_CreateStaticText (CHAR *value, LONGINT value__len, CHAR *align, LONGINT align__len, INTEGER w);
export void ElemTools_CreateTextButton (CHAR *name, LONGINT name__len, Texts_Text t);
export void ElemTools_CreateTextField (CHAR *name, LONGINT name__len, Elems_AttrMsg msg);
export void ElemTools_DelAttr (void);
export void ElemTools_EditText (void);
export void ElemTools_Enum (CHAR *name, LONGINT name__len, INTEGER class);
export void ElemTools_EnumProps (CHAR *name, LONGINT name__len, INTEGER class);
export void ElemTools_Get (void);
static void ElemTools_GetSelection (PanelElems_SelectionMsg *msg, LONGINT *msg__typ);
static void ElemTools_HandleEdit (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void ElemTools_Inspect (void);
export void ElemTools_InspectCurElem (CHAR *info, LONGINT info__len, Elems_AttrMsg *attr, LONGINT *attr__typ);
export void ElemTools_LogParam (void);
static void ElemTools_NoNotify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
export void ElemTools_ParamToCaret (void);
static void ElemTools_Set (Elems_Elem elem);
export void ElemTools_SetAttr (void);
export void ElemTools_SetSize (void);
export void ElemTools_SetTabPos (void);
export void ElemTools_ShowTabs (void);
export void ElemTools_Update (void);


static void ElemTools_NoNotify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void ElemTools_GetSelection (PanelElems_SelectionMsg *msg, LONGINT *msg__typ)
{
	(*msg).time = 0;
	(*msg).text = NIL;
	(*msg).p = NIL;
	(*msg).sel = NIL;
	Viewers_Broadcast((void*)&*msg, msg__typ);
}

void ElemTools_ClearPanel (void)
{
	Texts_Reader r = {0};
	Texts_OpenReader(&r, Texts_Reader__typ, (void*)ElemTools_context, 2);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (r.elem != NIL) {
		PanelElems_DeleteCase(ElemTools_context->base, PanelElems_MyCase(ElemTools_context->base, r.elem));
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
	ElemTools_context->base->W = (LONGINT)ElemTools_defaultW * (LONGINT)TextFrames_Unit;
	ElemTools_context->base->H = (LONGINT)ElemTools_defaultH * (LONGINT)TextFrames_Unit;
}

void ElemTools_CreateStaticText (CHAR *value, LONGINT value__len, CHAR *align, LONGINT align__len, INTEGER w)
{
	Elems_Elem e = NIL;
	__DUP(value, value__len, CHAR);
	__DUP(align, align__len, CHAR);
	e = Elems_CreateElem((CHAR*)"StaticTextElems.New", (LONGINT)20);
	Elems_SetBoolean((void*)e, (CHAR*)"Border", (LONGINT)7, 0);
	Elems_SetString((void*)e, (CHAR*)"Align", (LONGINT)6, align, align__len);
	Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, value, value__len);
	Elems_SetBoolean((void*)e, (CHAR*)"Locked", (LONGINT)7, 1);
	e->W = (LONGINT)w * (LONGINT)TextFrames_Unit;
	PanelElems_InsertElem(ElemTools_context->base, (void*)e, ElemTools_x, ElemTools_y, Fonts_Default, 15);
	__DEL(value);
	__DEL(align);
}

void ElemTools_CreateCheckBox (CHAR *name, LONGINT name__len, BOOLEAN val)
{
	Elems_Elem e = NIL;
	__DUP(name, name__len, CHAR);
	e = Elems_CreateElem((CHAR*)"CheckBoxElems.New", (LONGINT)18);
	Elems_SetString((void*)e, (CHAR*)"Name", (LONGINT)5, name, name__len);
	Elems_SetBoolean((void*)e, (CHAR*)"Value", (LONGINT)6, val);
	Elems_SetBoolean((void*)e, (CHAR*)"Locked", (LONGINT)7, 1);
	PanelElems_InsertElem(ElemTools_context->base, (void*)e, ElemTools_x, ElemTools_y - Elems_Scale(5), Fonts_Default, 15);
	__DEL(name);
}

void ElemTools_CreatePopupList (CHAR *name, LONGINT name__len, CHAR *default_, LONGINT default___len)
{
	Elems_Elem e = NIL;
	__DUP(name, name__len, CHAR);
	__DUP(default_, default___len, CHAR);
	e = Elems_CreateElem((CHAR*)"ListElems.New", (LONGINT)14);
	Elems_SetString((void*)e, (CHAR*)"Name", (LONGINT)5, name, name__len);
	Elems_SetText((void*)e, (CHAR*)"ValueT", (LONGINT)7, ElemTools_menuText);
	Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, default_, default___len);
	Elems_SetBoolean((void*)e, (CHAR*)"Popup", (LONGINT)6, 1);
	Elems_SetBoolean((void*)e, (CHAR*)"Combo", (LONGINT)6, 0);
	Elems_SetBoolean((void*)e, (CHAR*)"Locked", (LONGINT)7, 1);
	e->W = (LONGINT)Elems_Scale(200) * (LONGINT)TextFrames_Unit;
	e->H = (LONGINT)((Fonts_Default->maxY - Fonts_Default->minY) + Elems_Scale(6)) * (LONGINT)TextFrames_Unit;
	PanelElems_InsertElem(ElemTools_context->base, (void*)e, ElemTools_x, ElemTools_y, Fonts_Default, 15);
	__DEL(name);
	__DEL(default_);
}

void ElemTools_CreateTextField (CHAR *name, LONGINT name__len, Elems_AttrMsg msg)
{
	Elems_Elem e = NIL;
	__DUP(name, name__len, CHAR);
	e = Elems_CreateElem((CHAR*)"TextFieldElems.New", (LONGINT)19);
	e->W = (LONGINT)((ElemTools_maxW - ElemTools_descW) - Elems_Scale(50)) * (LONGINT)TextFrames_Unit;
	PanelElems_InsertElem(ElemTools_context->base, (void*)e, ElemTools_x, ElemTools_y, Fonts_Default, 15);
	Elems_SetString((void*)e, (CHAR*)"Name", (LONGINT)5, name, name__len);
	Elems_SetInteger((void*)e, (CHAR*)"MaxLen", (LONGINT)7, 0);
	Elems_SetBoolean((void*)e, (CHAR*)"Locked", (LONGINT)7, 1);
	if (msg.class == 3) {
		Elems_SetInteger((void*)e, (CHAR*)"Value", (LONGINT)6, msg.i);
	} else if (msg.class == 4) {
		Elems_SetReal((void*)e, (CHAR*)"Value", (LONGINT)6, msg.r);
	} else if (msg.class == 5) {
		Elems_SetLReal((void*)e, (CHAR*)"Value", (LONGINT)6, msg.lr);
	} else if (msg.class == 2) {
		Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, msg.s, 256);
	} else if (msg.class == 9) {
		Elems_SetText((void*)e, (CHAR*)"Value", (LONGINT)6, msg.t);
	}
	__DEL(name);
}

void ElemTools_CreateTextButton (CHAR *name, LONGINT name__len, Texts_Text t)
{
	Elems_Elem e = NIL;
	__DUP(name, name__len, CHAR);
	e = Elems_CreateElem((CHAR*)"ButtonElems.New", (LONGINT)16);
	e->W = (LONGINT)Elems_Scale(70) * (LONGINT)TextFrames_Unit;
	Elems_SetString((void*)e, (CHAR*)"Name", (LONGINT)5, name, name__len);
	Elems_SetString((void*)e, (CHAR*)"Caption", (LONGINT)8, (CHAR*)"Edit Text", (LONGINT)10);
	Elems_SetString((void*)e, (CHAR*)"Cmd", (LONGINT)4, (CHAR*)"ElemTools.EditText", (LONGINT)19);
	Elems_SetBoolean((void*)e, (CHAR*)"Locked", (LONGINT)7, 1);
	Elems_SetText((void*)e, (CHAR*)"Text", (LONGINT)5, t);
	PanelElems_InsertElem(ElemTools_context->base, (void*)e, ElemTools_x, ElemTools_y, Fonts_Default, 15);
	__DEL(name);
}

void ElemTools_EnumProps (CHAR *name, LONGINT name__len, INTEGER class)
{
	__DUP(name, name__len, CHAR);
	Texts_WriteString(&ElemTools_W, Texts_Writer__typ, name, name__len);
	Texts_WriteLn(&ElemTools_W, Texts_Writer__typ);
	__DEL(name);
}

void ElemTools_Enum (CHAR *name, LONGINT name__len, INTEGER class)
{
	Elems_AttrMsg msg = {0};
	CHAR v[256];
	__DUP(name, name__len, CHAR);
	if (ElemTools_wasBool && class == 7) {
		ElemTools_x += Elems_Scale(30);
		ElemTools_CreateStaticText(name, name__len, (CHAR*)"right", (LONGINT)6, ElemTools_descW);
		ElemTools_x += Elems_Scale(90);
	} else {
		ElemTools_y += ElemTools_step;
		ElemTools_x = ElemTools_left;
		ElemTools_CreateStaticText(name, name__len, (CHAR*)"left", (LONGINT)5, ElemTools_descW);
		ElemTools_x += ElemTools_descW + Elems_Scale(30);
	}
	msg.id = 1;
	msg.hasProps = 0;
	__COPY(name, msg.name, 64);
	(*ElemTools_curElem->handle)(ElemTools_curElem, (void*)&msg, Elems_AttrMsg__typ);
	if (msg.hasProps) {
		__COPY(msg.s, v, 256);
		msg.id = 4;
		msg.enum_ = ElemTools_EnumProps;
		(*ElemTools_curElem->handle)(ElemTools_curElem, (void*)&msg, Elems_AttrMsg__typ);
		ElemTools_menuText = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Append(ElemTools_menuText, ElemTools_W.buf);
		ElemTools_CreatePopupList(name, name__len, v, 256);
	} else {
		if (msg.class == 2) {
			ElemTools_CreateTextField(name, name__len, msg);
			ElemTools_wasBool = 0;
		} else if (msg.class == 7) {
			ElemTools_CreateCheckBox(name, name__len, msg.b);
			ElemTools_wasBool = !ElemTools_wasBool;
		} else if (__IN(msg.class, 0x38)) {
			ElemTools_CreateTextField(name, name__len, msg);
			ElemTools_wasBool = 0;
		} else if (msg.class == 9) {
			ElemTools_CreateTextButton(name, name__len, msg.t);
			ElemTools_wasBool = 0;
		}
	}
	__DEL(name);
}

void ElemTools_Get (void)
{
	PanelElems_SelectionMsg msg = {0};
	Texts_Reader r = {0};
	ElemTools_curElem = NIL;
	ElemTools_context = NIL;
	if (Elems_CmdContext != NIL && __ISP(Elems_CmdContext, PanelElems_TextDesc, 1)) {
		ElemTools_context = __GUARDP(Elems_CmdContext, PanelElems_TextDesc, 1);
	} else {
		ElemTools_context = NIL;
	}
	ElemTools_GetSelection(&msg, PanelElems_SelectionMsg__typ);
	if (msg.sel != NIL) {
		if (PanelElems_NextSel(msg.sel) != NIL) {
			Out_String((CHAR*)"-- more than one selection", (LONGINT)27);
			Out_Ln();
		} else {
			ElemTools_curElem = msg.sel->c->e;
		}
	} else if (msg.text != NIL) {
		Texts_OpenReader(&r, Texts_Reader__typ, msg.text, msg.beg);
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.elem != NIL && Texts_Pos(&r, Texts_Reader__typ) <= msg.end) {
			ElemTools_curElem = r.elem;
		}
	}
}

static void ElemTools_Set (Elems_Elem elem)
{
	INTEGER class = 0;
	CHAR name[256];
	BOOLEAN b = 0;
	CHAR s[256];
	SET set = 0;
	Texts_Text t = NIL;
	Texts_Scanner S = {0};
	Elems_GetString((void*)elem, (CHAR*)"Name", (LONGINT)5, (void*)name, 256);
	class = Elems_GetClass(ElemTools_curElem, name, 256);
	if (class == 7) {
		Elems_GetBoolean((void*)elem, (CHAR*)"Value", (LONGINT)6, &b);
		Elems_SetBoolean(ElemTools_curElem, name, 256, b);
	} else if (class == 8) {
		Elems_GetSet((void*)elem, (CHAR*)"Value", (LONGINT)6, &set);
		Elems_SetSet(ElemTools_curElem, name, 256, set);
	} else if (((class == 2 || __STRCMP(name, "Name") == 0) || __STRCMP(name, "Cmd") == 0) || __STRCMP(name, "Par") == 0) {
		Elems_GetString((void*)elem, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
		Elems_SetString(ElemTools_curElem, name, 256, s, 256);
	} else if (class == 9) {
		Elems_GetText((void*)elem, (CHAR*)"Text", (LONGINT)5, &t);
		Elems_SetText(ElemTools_curElem, name, 256, t);
	} else {
		Elems_GetText((void*)elem, (CHAR*)"ValueT", (LONGINT)7, &t);
		Texts_OpenScanner(&S, Texts_Scanner__typ, t, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (class == 3) {
			Elems_SetInteger(ElemTools_curElem, name, 256, S.i);
		} else if (class == 4) {
			Elems_SetReal(ElemTools_curElem, name, 256, S.x);
		} else if (class == 5) {
			Elems_SetLReal(ElemTools_curElem, name, 256, S.y);
		} else {
			__HALT(98);
		}
	}
}

void ElemTools_Align (void)
{
	BOOLEAN setL = 0, setC = 0, setR = 0, setU = 0, setV = 0, setD = 0;
	CHAR nn[2];
	PanelElems_SelectionMsg msg = {0};
	INTEGER x = 0, y = 0, pw = 0, ph = 0, ew = 0, eh = 0;
	PanelElems_Selection help = NIL;
	setL = 0;
	setC = 0;
	setR = 0;
	setU = 0;
	setV = 0;
	setD = 0;
	In_Open();
	In_Name((void*)nn, 2);
	while (In_Done) {
		if (__CAP(nn[0]) == 'L') {
			setL = 1;
		} else if (__CAP(nn[0]) == 'R') {
			setR = 1;
		} else if (__CAP(nn[0]) == 'U') {
			setU = 1;
		} else if (__CAP(nn[0]) == 'D') {
			setD = 1;
		} else if (__CAP(nn[0]) == 'C') {
			setC = 1;
		} else if (__CAP(nn[0]) == 'V') {
			setV = 1;
		}
		In_Name((void*)nn, 2);
	}
	ElemTools_GetSelection(&msg, PanelElems_SelectionMsg__typ);
	if (msg.p == NIL) {
		Out_String((CHAR*)"-- no panel selected", (LONGINT)21);
		Out_Ln();
	} else {
		if (setL) {
			x = msg.sel->c->x;
		} else if (setR) {
			x = msg.sel->c->x + (int)__DIV(msg.sel->c->e->W, (LONGINT)TextFrames_Unit);
		} else {
			x = msg.sel->c->x + __ASHR((int)__DIV(msg.sel->c->e->W, (LONGINT)TextFrames_Unit), 1);
		}
		if (setD) {
			y = msg.sel->c->y;
		} else if (setU) {
			y = msg.sel->c->y - (int)__DIV(msg.sel->c->e->H, (LONGINT)TextFrames_Unit);
		} else if (setV) {
			y = msg.sel->c->y - __ASHR((int)__DIV(msg.sel->c->e->H, (LONGINT)TextFrames_Unit), 1);
		}
		if (PanelElems_NextSel(msg.sel) == NIL) {
			ew = (int)__DIV(msg.sel->c->e->W, (LONGINT)TextFrames_Unit);
			eh = (int)__DIV(msg.sel->c->e->H, (LONGINT)TextFrames_Unit);
			pw = (int)__DIV(msg.p->W, (LONGINT)TextFrames_Unit);
			ph = (int)__DIV(msg.p->H, (LONGINT)TextFrames_Unit);
			if (setL) {
				msg.sel->c->x = msg.p->border;
			} else if (setR) {
				msg.sel->c->x = (pw - msg.p->border) - ew;
			} else if (setC) {
				msg.sel->c->x = __ASHR(pw - ew, 1);
			}
			if (setD) {
				msg.sel->c->y = ph - msg.p->border;
			} else if (setU) {
				msg.sel->c->y = msg.p->border + eh;
			} else if (setV) {
				msg.sel->c->y = __ASHR(ph - eh, 1) + eh;
			}
		} else {
			help = PanelElems_NextSel(msg.sel);
			while (help != NIL) {
				ew = (int)__DIV(help->c->e->W, (LONGINT)TextFrames_Unit);
				eh = (int)__DIV(help->c->e->H, (LONGINT)TextFrames_Unit);
				if (setL) {
					help->c->x = x;
				} else if (setR) {
					help->c->x = x - ew;
				} else if (setC) {
					help->c->x = x - __ASHR(ew, 1);
				}
				if (setD) {
					help->c->y = y;
				} else if (setU) {
					help->c->y = y + eh;
				} else if (setV) {
					help->c->y = y + __ASHR(eh, 1);
				}
				help = PanelElems_NextSel(help);
			}
		}
		Elems_UpdateElem((void*)msg.p);
	}
}

void ElemTools_SetSize (void)
{
	PanelElems_SelectionMsg msg = {0};
	LONGINT w = 0, h = 0;
	BOOLEAN setW = 0, setH = 0;
	Texts_Reader r = {0};
	CHAR nn[2];
	Texts_Notifier notify = NIL;
	PanelElems_Selection help = NIL;
	In_Open();
	In_Name((void*)nn, 2);
	if (In_Done) {
		setW = __CAP(nn[0]) == 'W';
		setH = __CAP(nn[0]) == 'H';
		In_Name((void*)nn, 2);
		if (In_Done) {
			setW = setW || __CAP(nn[0]) == 'W';
			setH = setH || __CAP(nn[0]) == 'H';
		}
	} else {
		Out_String((CHAR*)"-- ElemTools.SetSize w h", (LONGINT)25);
	}
	ElemTools_GetSelection(&msg, PanelElems_SelectionMsg__typ);
	if (msg.sel == NIL && msg.text != NIL) {
		notify = msg.text->notify;
		msg.text->notify = ElemTools_NoNotify;
		Texts_OpenReader(&r, Texts_Reader__typ, msg.text, msg.beg);
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.elem == NIL) {
			Out_String((CHAR*)"-- no Element selected", (LONGINT)23);
			return;
		}
		w = r.elem->W;
		h = r.elem->H;
		Texts_ReadElem(&r, Texts_Reader__typ);
		while (Texts_Pos(&r, Texts_Reader__typ) <= msg.end && r.elem != NIL) {
			if (setW) {
				r.elem->W = w;
			}
			if (setH) {
				r.elem->H = h;
			}
			Texts_ReadElem(&r, Texts_Reader__typ);
		}
		msg.text->notify = notify;
		if (notify != NIL) {
			(*notify)(msg.text, 0, msg.beg, msg.end);
		}
	} else if (msg.sel != NIL) {
		if (PanelElems_NextSel(msg.sel) == NIL) {
			if (setW) {
				msg.p->W = (LONGINT)(((int)__DIV(msg.sel->c->e->W, (LONGINT)TextFrames_Unit) + __ASHL(msg.p->border, 1)) + Elems_Scale(4)) * (LONGINT)TextFrames_Unit;
				msg.sel->c->x = msg.p->border + Elems_Scale(2);
			}
			if (setH) {
				msg.p->H = (LONGINT)(((int)__DIV(msg.sel->c->e->H, (LONGINT)TextFrames_Unit) + __ASHL(msg.p->border, 1)) + Elems_Scale(4)) * (LONGINT)TextFrames_Unit;
				msg.sel->c->y = (msg.p->border + Elems_Scale(2)) + (int)__DIV(msg.sel->c->e->H, (LONGINT)TextFrames_Unit);
			}
			Elems_UpdateElem((void*)msg.p);
		} else {
			help = PanelElems_NextSel(msg.sel);
			w = msg.sel->c->e->W;
			h = msg.sel->c->e->H;
			while (help != NIL) {
				if (setW) {
					help->c->e->W = w;
				}
				if (setH) {
					help->c->e->H = h;
				}
				Elems_UpdateElem(help->c->e);
				help = PanelElems_NextSel(help);
			}
		}
	}
}

void ElemTools_InspectCurElem (CHAR *info, LONGINT info__len, Elems_AttrMsg *attr, LONGINT *attr__typ)
{
	__DUP(info, info__len, CHAR);
	ElemTools_ClearPanel();
	if (ElemTools_curElem != NIL) {
		ElemTools_wasBool = 0;
		ElemTools_x = Elems_Scale(130);
		ElemTools_y = Elems_Scale(30);
		ElemTools_CreateStaticText(info, info__len, (CHAR*)"left", (LONGINT)5, Elems_Scale(180));
		ElemTools_context->base->W = (LONGINT)ElemTools_maxW * (LONGINT)TextFrames_Unit;
		if (__ISP(ElemTools_curElem, Elems_ElemDesc, 2)) {
			ElemTools_x = ElemTools_left;
			ElemTools_y = ElemTools_top;
			ElemTools_wasBool = 0;
			(*attr).id = 3;
			if ((*attr).enum_ == NIL) {
				(*attr).enum_ = ElemTools_Enum;
			}
			(*ElemTools_curElem->handle)(ElemTools_curElem, (void*)&*attr, attr__typ);
			ElemTools_context->base->H = (LONGINT)(ElemTools_y + Elems_Scale(5)) * (LONGINT)TextFrames_Unit;
		}
		if (Elems_CmdElem != NIL) {
			Elems_UpdateElem((void*)ElemTools_context->base);
		}
	} else if (ElemTools_context != NIL && Elems_CmdElem != NIL) {
		Elems_UpdateElem((void*)ElemTools_context->base);
	}
	__DEL(info);
}

void ElemTools_Inspect (void)
{
	Types_Type type = NIL;
	CHAR tname[65];
	Elems_AttrMsg attr = {0};
	ElemTools_Get();
	if (ElemTools_curElem != NIL) {
		type = Types_TypeOf((void*)ElemTools_curElem);
		__COPY(type->module->name, tname, 65);
		Strings_Append((CHAR*)".", (LONGINT)2, (void*)tname, 65);
		Strings_Append(type->name, 24, (void*)tname, 65);
	} else {
		tname[0] = 0x00;
	}
	attr.enum_ = ElemTools_Enum;
	ElemTools_InspectCurElem(tname, 65, &attr, Elems_AttrMsg__typ);
}

void ElemTools_Apply (void)
{
	Texts_Reader r = {0};
	if (!__ISP(Elems_CmdContext, PanelElems_TextDesc, 1)) {
		Out_String((CHAR*)"-- command not used within a panel", (LONGINT)35);
		Out_Ln();
		return;
	}
	ElemTools_Get();
	if (ElemTools_curElem != NIL && __ISP(ElemTools_curElem, Elems_ElemDesc, 2)) {
		Texts_OpenReader(&r, Texts_Reader__typ, (void*)ElemTools_context, 4);
		Texts_ReadElem(&r, Texts_Reader__typ);
		while (r.elem != NIL) {
			ElemTools_Set(__GUARDP(r.elem, Elems_ElemDesc, 2));
			Texts_ReadElem(&r, Texts_Reader__typ);
			Texts_ReadElem(&r, Texts_Reader__typ);
		}
		Elems_UpdateElem(ElemTools_curElem);
	}
}

void ElemTools_SetAttr (void)
{
	Texts_Scanner s = {0};
	CHAR name[32], attrname[32];
	Texts_Elem e = NIL;
	CHAR str[2];
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (__IN(s.class, 0x06)) {
		__COPY(s.s, name, 32);
	} else {
		Out_String((CHAR*)"-- wrong input", (LONGINT)15);
		Out_Ln();
		return;
	}
	if (Elems_CmdContext == NIL) {
		return;
	}
	e = (Texts_Elem)Elems_NamedElem(name, 32, Elems_CmdContext);
	if (e == NIL) {
		Out_String((CHAR*)"-- elem not found : ", (LONGINT)21);
		Out_String(s.s, 256);
		Out_Ln();
		return;
	}
	do {
		Texts_Scan(&s, Texts_Scanner__typ);
		if (__IN(s.class, 0x06)) {
			__COPY(s.s, attrname, 32);
		} else {
			Out_String((CHAR*)"-- wrong input", (LONGINT)15);
			Out_Ln();
			return;
		}
		Texts_Scan(&s, Texts_Scanner__typ);
		if (__IN(s.class, 0x06)) {
			Elems_SetString(e, attrname, 32, s.s, 256);
		} else if (s.class == 3) {
			Elems_SetInteger(e, attrname, 32, s.i);
		} else if (s.class == 4) {
			Elems_SetReal(e, attrname, 32, s.x);
		} else if (s.class == 5) {
			Elems_SetLReal(e, attrname, 32, s.y);
		} else if (s.class == 6) {
			str[0] = s.c;
			str[1] = 0x00;
			Elems_SetString(e, attrname, 32, str, 2);
		}
	} while (!s.eot);
	Elems_UpdateElem(e);
}

void ElemTools_AddAttr (void)
{
	CHAR name[64], type[64];
	Texts_Text t = NIL;
	ElemTools_Get();
	if (ElemTools_curElem == NIL) {
		Out_String((CHAR*)"-- no elem selected", (LONGINT)20);
		Out_Ln();
		return;
	}
	In_Open();
	In_String((void*)name, 64);
	In_String((void*)type, 64);
	if (name[0] != 0x00 && type[0] != 0x00) {
		if (__STRCMP(type, "Boolean") == 0) {
			Elems_SetBoolean(ElemTools_curElem, name, 64, 0);
		} else if (__STRCMP(type, "String") == 0) {
			Elems_SetString(ElemTools_curElem, name, 64, (CHAR*)"", (LONGINT)1);
		} else if (__STRCMP(type, "Integer") == 0) {
			Elems_SetInteger(ElemTools_curElem, name, 64, 0);
		} else if (__STRCMP(type, "Real") == 0) {
			Elems_SetReal(ElemTools_curElem, name, 64, (REAL)0);
		} else if (__STRCMP(type, "LongReal") == 0) {
			Elems_SetLReal(ElemTools_curElem, name, 64, (LONGREAL)0);
		} else if (__STRCMP(type, "Text") == 0) {
			t = TextFrames_Text((CHAR*)"", (LONGINT)1);
			Elems_SetText(ElemTools_curElem, name, 64, t);
		} else if (__STRCMP(type, "Set") == 0) {
			Elems_SetSet(ElemTools_curElem, name, 64, 0x0);
		}
	} else {
		Out_String((CHAR*)"-- Attribute must have a name", (LONGINT)30);
		Out_Ln();
	}
}

void ElemTools_DelAttr (void)
{
	Elems_AttrMsg msg = {0};
	ElemTools_Get();
	if (ElemTools_curElem == NIL) {
		Out_String((CHAR*)"-- no elem selected", (LONGINT)20);
		Out_Ln();
		return;
	}
	In_Open();
	In_String((void*)msg.name, 64);
	if (In_Done) {
		msg.id = 5;
		(*ElemTools_curElem->handle)(ElemTools_curElem, (void*)&msg, Elems_AttrMsg__typ);
		if (!Elems_Done) {
			Out_String((CHAR*)"-- attribute <", (LONGINT)15);
			Out_String(msg.name, 64);
			Out_String((CHAR*)"> doesn\'t exist", (LONGINT)16);
			Out_Ln();
		}
	} else {
		Out_String((CHAR*)"-- ElemTools.DelAttr attrName", (LONGINT)30);
		Out_Ln();
	}
}

static struct SetTabPos__25 {
	Texts_Text *t;
	struct SetTabPos__25 *lnk;
} *SetTabPos__25_s;

static void UpdateTabStopElems__26 (void);

static void UpdateTabStopElems__26 (void)
{
	Texts_Reader r = {0};
	Elems_TabStopMsg tab = {0};
	Texts_OpenReader(&r, Texts_Reader__typ, *SetTabPos__25_s->t, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!r.eot) {
		tab.accepted = 0;
		(*r.elem->handle)(r.elem, (void*)&tab, Elems_TabStopMsg__typ);
		if (tab.accepted) {
			Elems_UpdateElem(r.elem);
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
}

void ElemTools_SetTabPos (void)
{
	Texts_Text t = NIL;
	Texts_Notifier notifier = NIL;
	LONGINT pos = 0;
	Texts_Scanner s = {0};
	INTEGER i = 0;
	Elems_TabStopMsg tab = {0};
	Texts_Reader r = {0};
	struct SetTabPos__25 _s;
	_s.t = &t;
	_s.lnk = SetTabPos__25_s;
	SetTabPos__25_s = &_s;
	ElemTools_Get();
	if (ElemTools_curElem != NIL) {
		t = Texts_ElemBase(ElemTools_curElem);
		if (__ISP(t, PanelElems_TextDesc, 1)) {
			notifier = t->notify;
			t->notify = ElemTools_NoNotify;
			Texts_Delete(t, Texts_ElemPos(ElemTools_curElem), Texts_ElemPos(ElemTools_curElem) + 1);
			Texts_WriteElem(&ElemTools_W, Texts_Writer__typ, ElemTools_curElem);
			Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
			Texts_Scan(&s, Texts_Scanner__typ);
			if (__IN(s.class, 0x06)) {
				if (__STRCMP(s.s, "first") == 0) {
					pos = 0;
				} else if (__STRCMP(s.s, "last") == 0) {
					pos = t->len;
				}
			} else if (s.class == 3 && s.i > 0) {
				i = 0;
				Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
				do {
					Texts_ReadElem(&r, Texts_Reader__typ);
					if (!r.eot) {
						tab.accepted = 0;
						(*r.elem->handle)(r.elem, (void*)&tab, Elems_TabStopMsg__typ);
						if (tab.accepted) {
							i += 1;
						}
					}
				} while (!((LONGINT)i == s.i || r.eot));
				pos = Texts_Pos(&r, Texts_Reader__typ) - 1;
			} else {
				pos = 0;
			}
			Texts_Insert(t, pos, ElemTools_W.buf);
			t->notify = notifier;
			UpdateTabStopElems__26();
		} else {
			Out_String((CHAR*)"-- elem is not in a panel or wrong input ", (LONGINT)42);
			Out_Ln();
		}
	}
	SetTabPos__25_s = _s.lnk;
}

void ElemTools_ShowTabs (void)
{
	CHAR s[4];
	ElemTools_Get();
	if (ElemTools_curElem != NIL && __ISP(ElemTools_curElem, PanelElems_PanelDesc, 3)) {
		In_Open();
		In_Name((void*)s, 4);
		__GUARDP(ElemTools_curElem, PanelElems_PanelDesc, 3)->showTabs = In_Done && __STRCMP(s, "on") == 0;
		Elems_UpdateElem(ElemTools_curElem);
	} else {
		Out_String((CHAR*)"-- no panel selected", (LONGINT)21);
		Out_Ln();
	}
}

static void ElemTools_HandleEdit (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	ElemTools_EditFrame f1 = NIL;
	TextFrames_Handle(f, &*msg, msg__typ);
	if (__ISP(f, ElemTools_EditFrameDesc, 2)) {
		if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
			__NEW(f1, ElemTools_EditFrameDesc);
			TextFrames_Open((void*)f1, (*(ElemTools_EditFrame*)&f)->text, (*(ElemTools_EditFrame*)&f)->org);
			f1->handle = (*(ElemTools_EditFrame*)&f)->handle;
			f1->e = (*(ElemTools_EditFrame*)&f)->e;
			__GUARDR(msg, Oberon_CopyMsg, 1).F = (Display_Frame)f1;
		}
	} else __WITHCHK;
}

void ElemTools_EditText (void)
{
	Viewers_Viewer v = NIL;
	ElemTools_EditFrame f = NIL;
	INTEGER x = 0, y = 0;
	Texts_Text t = NIL;
	CHAR name[256];
	Elems_GetString((void*)Elems_CmdElem, (CHAR*)"Name", (LONGINT)5, (void*)name, 256);
	Elems_GetText((void*)Elems_CmdElem, (CHAR*)"Text", (LONGINT)5, &t);
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	__NEW(f, ElemTools_EditFrameDesc);
	f->e = Elems_CmdElem;
	TextFrames_Open((void*)f, Elems_CopyText(t), 0);
	f->handle = ElemTools_HandleEdit;
	v = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu(name, 256, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Parcs ElemTools.Update ", (LONGINT)69), (void*)f, TextFrames_menuH, x, y);
}

void ElemTools_Update (void)
{
	ElemTools_EditFrame f = NIL;
	Texts_Scanner S = {0};
	Texts_Text menuText = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		f = __GUARDP(Oberon_Par->frame->next, ElemTools_EditFrameDesc, 2);
		menuText = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
		Elems_SetText((void*)f->e, (CHAR*)"Text", (LONGINT)5, Elems_CopyText(f->text));
		Texts_OpenReader((void*)&S, Texts_Scanner__typ, menuText, menuText->len - 1);
		Texts_Read((void*)&S, Texts_Scanner__typ, &S.c);
		if (S.c == '!') {
			Texts_Delete(menuText, menuText->len - 1, menuText->len);
		}
	}
}

void ElemTools_LogParam (void)
{
	Texts_WriteString(&ElemTools_W, Texts_Writer__typ, (CHAR*)"----------------------------------", (LONGINT)35);
	Texts_WriteLn(&ElemTools_W, Texts_Writer__typ);
	Texts_Save(Oberon_Par->text, Oberon_Par->pos, Oberon_Par->text->len, ElemTools_W.buf);
	Texts_WriteLn(&ElemTools_W, Texts_Writer__typ);
	Texts_WriteString(&ElemTools_W, Texts_Writer__typ, (CHAR*)"----------------------------------", (LONGINT)35);
	Texts_WriteLn(&ElemTools_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, ElemTools_W.buf);
}

void ElemTools_ParamToCaret (void)
{
	Oberon_CopyOverMsg msg = {0};
	msg.text = Oberon_Par->text;
	msg.beg = 0;
	msg.end = msg.text->len;
	Viewers_Broadcast((void*)&msg, Oberon_CopyOverMsg__typ);
}

static void EnumPtrs(void (*P)(void*))
{
	P(ElemTools_curElem);
	P(ElemTools_context);
	__ENUMR(&ElemTools_W, Texts_Writer__typ, 36, 1, P);
	P(ElemTools_menuText);
}

__TDESC(ElemTools_EditFrameDesc, 1, 9) = {__TDFLDS("EditFrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};

export void *ElemTools__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Fonts);
	__IMPORT(In);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(PanelElems);
	__IMPORT(Strings);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Types);
	__IMPORT(Viewers);
	__REGMOD(ElemTools, EnumPtrs);
	__REGCMD("AddAttr", ElemTools_AddAttr);
	__REGCMD("Align", ElemTools_Align);
	__REGCMD("Apply", ElemTools_Apply);
	__REGCMD("ClearPanel", ElemTools_ClearPanel);
	__REGCMD("DelAttr", ElemTools_DelAttr);
	__REGCMD("EditText", ElemTools_EditText);
	__REGCMD("Get", ElemTools_Get);
	__REGCMD("Inspect", ElemTools_Inspect);
	__REGCMD("LogParam", ElemTools_LogParam);
	__REGCMD("ParamToCaret", ElemTools_ParamToCaret);
	__REGCMD("SetAttr", ElemTools_SetAttr);
	__REGCMD("SetSize", ElemTools_SetSize);
	__REGCMD("SetTabPos", ElemTools_SetTabPos);
	__REGCMD("ShowTabs", ElemTools_ShowTabs);
	__REGCMD("Update", ElemTools_Update);
	__INITYP(ElemTools_EditFrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&ElemTools_W, Texts_Writer__typ);
	ElemTools_top = Elems_Scale(40);
	ElemTools_left = Elems_Scale(10);
	ElemTools_step = (Fonts_Default->maxY - Fonts_Default->minY) + Elems_Scale(7);
	ElemTools_defaultW = Elems_Scale(120);
	ElemTools_defaultH = Elems_Scale(40);
	ElemTools_maxW = __ASHR(Display_Width, 3) * 3;
	ElemTools_descW = Elems_Scale(80);
	__ENDMOD;
}
