/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct ErrorElems_ElemDesc *ErrorElems_Elem;

typedef
	struct ErrorElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		INTEGER err;
		CHAR msg[128];
		BOOLEAN expanded;
	} ErrorElems_ElemDesc;


export Fonts_Font ErrorElems_font;
static Texts_Writer ErrorElems_W;
static LONGINT ErrorElems_lastTime;

export LONGINT *ErrorElems_ElemDesc__typ;

export void ErrorElems_Copy (ErrorElems_Elem SE, ErrorElems_Elem DE);
export void ErrorElems_Delete (ErrorElems_Elem E, LONGINT pos);
export void ErrorElems_Disp (ErrorElems_Elem E, Display_Frame F, SHORTINT col, Fonts_Font fnt, INTEGER x0, INTEGER y0);
export void ErrorElems_Edit (ErrorElems_Elem E, LONGINT pos, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, SET keysum);
export void ErrorElems_Expand (ErrorElems_Elem E, LONGINT pos);
export void ErrorElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void ErrorElems_InsertAt (Texts_Text T, LONGINT pos, INTEGER err);
static void ErrorElems_IntToStr (LONGINT x, CHAR *s, LONGINT s__len);
export void ErrorElems_LocateNext (void);
export void ErrorElems_Mark (void);
static TextFrames_Frame ErrorElems_MarkedFrame (void);
export void ErrorElems_Prepare (ErrorElems_Elem E, Fonts_Font fnt, INTEGER *voff);
export void ErrorElems_Print (ErrorElems_Elem E, INTEGER x0, INTEGER y0);
export void ErrorElems_Reduce (ErrorElems_Elem E, LONGINT pos);
static void ErrorElems_Show (TextFrames_Frame F, LONGINT pos);
export void ErrorElems_ShowErrMsg (ErrorElems_Elem E, Display_Frame F, SHORTINT col, INTEGER x0, INTEGER y0, INTEGER dw);
export void ErrorElems_Unmark (void);
static INTEGER ErrorElems_Width (ErrorElems_Elem E);


static TextFrames_Frame ErrorElems_MarkedFrame (void)
{
	Viewers_Viewer V = NIL;
	V = Oberon_MarkedViewer();
	if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		return __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static void ErrorElems_Show (TextFrames_Frame F, LONGINT pos)
{
	LONGINT beg = 0, end = 0, delta = 0;
	delta = 200;
	for (;;) {
		beg = F->org;
		end = TextFrames_Pos(F, F->X, F->Y);
		if (beg <= pos && pos < end || beg == end) {
			break;
		}
		TextFrames_Show(F, pos - delta);
		delta -= 20;
	}
}

static void ErrorElems_IntToStr (LONGINT x, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0, j = 0;
	CHAR str[10];
	i = 0;
	j = 0;
	do {
		str[__X(i, 10)] = (CHAR)(__MOD(x, 10) + 48);
		x = __DIV(x, 10);
		i += 1;
	} while (!(x == 0));
	do {
		i -= 1;
		s[__X(j, s__len)] = str[__X(i, 10)];
		j += 1;
	} while (!(i == 0));
	s[__X(j, s__len)] = 0x00;
}

static INTEGER ErrorElems_Width (ErrorElems_Elem E)
{
	Fonts_Font fnt = NIL;
	LONGINT pat = 0;
	INTEGER i = 0, px = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	fnt = Fonts_This((CHAR*)"Syntax8.Scn.Fnt", (LONGINT)16);
	i = 0;
	px = 0;
	while (E->msg[__X(i, 128)] != 0x00) {
		Display_GetChar(fnt->raster, E->msg[__X(i, 128)], &dx, &x, &y, &w, &h, &pat);
		px += dx;
		i += 1;
	}
	return px + 6;
}

void ErrorElems_ShowErrMsg (ErrorElems_Elem E, Display_Frame F, SHORTINT col, INTEGER x0, INTEGER y0, INTEGER dw)
{
	Fonts_Font fnt = NIL;
	LONGINT pat = 0;
	INTEGER i = 0, px = 0, rm = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR ch = 0;
	fnt = Fonts_This((CHAR*)"Syntax8.Scn.Fnt", (LONGINT)16);
	i = 0;
	px = x0 + 3;
	rm = (x0 + dw) - 3;
	for (;;) {
		ch = E->msg[__X(i, 128)];
		i += 1;
		if (ch == 0x00) {
			break;
		}
		Display_GetChar(fnt->raster, ch, &dx, &x, &y, &w, &h, &pat);
		if (px + dx > rm) {
			break;
		}
		Display_CopyPattern(col, pat, px + x, y0 + y, 2);
		px += dx;
	}
}

void ErrorElems_Expand (ErrorElems_Elem E, LONGINT pos)
{
	Texts_Scanner S = {0};
	Texts_Text T = NIL;
	INTEGER n = 0, m = 0;
	CHAR ch = 0;
	__NEW(T, Texts_TextDesc);
	Texts_Open(T, (CHAR*)"OfrontErrors.Text", (LONGINT)18);
	Texts_OpenScanner(&S, Texts_Scanner__typ, T, 0);
	do {
		S.line = 0;
		do {
			Texts_Scan(&S, Texts_Scanner__typ);
		} while (!(S.eot || S.line != 0));
	} while (!(S.eot || S.class == 3 && S.i == (LONGINT)E->err));
	if (!S.eot) {
		Texts_Read((void*)&S, Texts_Scanner__typ, &ch);
		n = 0;
		while ((!S.eot && ch != 0x0d) && n + 1 < 128) {
			E->msg[__X(n, 128)] = ch;
			n += 1;
			Texts_Read((void*)&S, Texts_Scanner__typ, &ch);
		}
		E->msg[__X(n, 128)] = 0x00;
		E->W = (LONGINT)ErrorElems_Width(E) * (LONGINT)TextFrames_Unit;
		TextFrames_NotifyDisplay(Texts_ElemBase((void*)E), 0, pos, pos + 1);
	}
	E->expanded = 1;
}

void ErrorElems_Reduce (ErrorElems_Elem E, LONGINT pos)
{
	E->W = 108000;
	ErrorElems_IntToStr(E->err, (void*)E->msg, 128);
	E->W = (LONGINT)ErrorElems_Width(E) * (LONGINT)TextFrames_Unit;
	TextFrames_NotifyDisplay(Texts_ElemBase((void*)E), 0, pos, pos + 1);
	E->expanded = 0;
}

void ErrorElems_Delete (ErrorElems_Elem E, LONGINT pos)
{
	Texts_Text T = NIL;
	T = Texts_ElemBase((void*)E);
	if (T != NIL) {
		Texts_Delete(T, pos, pos + 1);
	}
}

void ErrorElems_Copy (ErrorElems_Elem SE, ErrorElems_Elem DE)
{
	Texts_CopyElem((void*)SE, (void*)DE);
	DE->err = SE->err;
	__MOVE(SE->msg, DE->msg, 128);
	DE->expanded = SE->expanded;
}

void ErrorElems_Prepare (ErrorElems_Elem E, Fonts_Font fnt, INTEGER *voff)
{
	INTEGER max = 0;
	if (ErrorElems_font->height > fnt->height) {
		max = ErrorElems_font->height;
	} else {
		max = fnt->height;
	}
	E->H = (LONGINT)(max + 1) * (LONGINT)TextFrames_Unit;
	*voff = fnt->minY;
}

void ErrorElems_Disp (ErrorElems_Elem E, Display_Frame F, SHORTINT col, Fonts_Font fnt, INTEGER x0, INTEGER y0)
{
	INTEGER w = 0, h = 0;
	w = (int)__DIV(E->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(E->H, (LONGINT)TextFrames_Unit);
	Display_ReplConst(15, x0, y0, w, h, 0);
	if (E->msg[0] != 0x00) {
		ErrorElems_ShowErrMsg(E, F, col, x0, y0 - fnt->minY, w);
	}
}

void ErrorElems_Print (ErrorElems_Elem E, INTEGER x0, INTEGER y0)
{
	INTEGER w = 0, h = 0;
	w = (int)__DIV(E->W, 3048);
	h = (int)__DIV(E->H, 3048);
	Printer_ReplConst(x0 + 1, y0 + 2, w - 2, h);
}

void ErrorElems_Edit (ErrorElems_Elem E, LONGINT pos, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, SET keysum)
{
	INTEGER w = 0, h = 0;
	SET keys = 0;
	if (keysum == 0x02) {
		w = (int)__DIV(E->W, (LONGINT)TextFrames_Unit);
		h = (int)__DIV(E->H, (LONGINT)TextFrames_Unit);
		Oberon_RemoveMarks(x0, y0, w, h);
		Display_ReplConst(15, x0 + 2, y0 + 2, w - 4, h - 4, 2);
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		Display_ReplConst(15, x0 + 2, y0 + 2, w - 4, h - 4, 2);
		if (keysum == 0x02) {
			if (E->expanded) {
				ErrorElems_Reduce(E, pos);
			} else {
				ErrorElems_Expand(E, pos);
			}
		}
	}
}

void ErrorElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	ErrorElems_Elem e = NIL;
	LONGINT pos = 0;
	INTEGER w = 0, h = 0;
	SET keys = 0, keysum = 0;
	if (__ISP(E, ErrorElems_ElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if (!(*msg__).prepare) {
					ErrorElems_Disp((*(ErrorElems_Elem*)&E), (*msg__).frame, (*msg__).col, (*msg__).fnt, (*msg__).X0, (*msg__).Y0);
				} else {
					ErrorElems_Prepare((*(ErrorElems_Elem*)&E), (*msg__).fnt, &(*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				if (!(*msg__).prepare) {
					ErrorElems_Print((*(ErrorElems_Elem*)&E), (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			__NEW(e, ErrorElems_ElemDesc);
			ErrorElems_Copy((*(ErrorElems_Elem*)&E), e);
			__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)e;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				ErrorElems_Edit((*(ErrorElems_Elem*)&E), (*msg__).pos, (*msg__).X0, (*msg__).Y0, (*msg__).X, (*msg__).Y, (*msg__).keys);
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void ErrorElems_InsertAt (Texts_Text T, LONGINT pos, INTEGER err)
{
	ErrorElems_Elem e = NIL;
	__NEW(e, ErrorElems_ElemDesc);
	e->H = (LONGINT)(ErrorElems_font->height + 2) * (LONGINT)TextFrames_Unit;
	e->handle = ErrorElems_Handle;
	e->err = err;
	ErrorElems_IntToStr(err, (void*)e->msg, 128);
	e->W = (LONGINT)ErrorElems_Width(e) * (LONGINT)TextFrames_Unit;
	e->expanded = 0;
	Texts_WriteElem(&ErrorElems_W, Texts_Writer__typ, (void*)e);
	Texts_Insert(T, pos, ErrorElems_W.buf);
}

void ErrorElems_Unmark (void)
{
	TextFrames_Frame F = NIL;
	LONGINT pos = 0;
	Texts_Reader R = {0};
	F = ErrorElems_MarkedFrame();
	if (F != NIL) {
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, 0);
		Texts_ReadElem(&R, Texts_Reader__typ);
		while (!R.eot) {
			if (__ISP(R.elem, ErrorElems_ElemDesc, 2)) {
				pos = Texts_Pos(&R, Texts_Reader__typ);
				Texts_Delete(F->text, pos - 1, pos);
				Texts_OpenReader(&R, Texts_Reader__typ, F->text, pos - 1);
			}
			Texts_ReadElem(&R, Texts_Reader__typ);
		}
	}
}

void ErrorElems_Mark (void)
{
	TextFrames_Frame F = NIL;
	Texts_Scanner S = {0};
	Texts_Text T = NIL, text = NIL;
	LONGINT beg = 0, end = 0, time = 0, pos = 0, delta = 0;
	INTEGER err = 0;
	ErrorElems_Unmark();
	F = ErrorElems_MarkedFrame();
	Oberon_GetSelection(&text, &beg, &end, &time);
	delta = 0;
	if (F != NIL && time >= ErrorElems_lastTime) {
		ErrorElems_lastTime = time;
		T = F->text;
		Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
		for (;;) {
			S.line = 0;
			do {
				Texts_Scan(&S, Texts_Scanner__typ);
			} while (!((S.eot || S.line != 0) || S.class == 3));
			if (S.eot || S.line != 0) {
				break;
			}
			pos = S.i;
			do {
				Texts_Scan(&S, Texts_Scanner__typ);
			} while (!((S.eot || S.line != 0) || S.class == 3));
			if (S.eot || S.line != 0) {
				break;
			}
			err = (int)S.i;
			ErrorElems_InsertAt(T, pos + delta, err);
			delta += 1;
			do {
				Texts_Scan(&S, Texts_Scanner__typ);
			} while (!(S.eot || S.line != 0));
		}
	}
}

void ErrorElems_LocateNext (void)
{
	TextFrames_Frame F = NIL;
	LONGINT beg = 0, pos = 0;
	Texts_Reader R = {0};
	F = ErrorElems_MarkedFrame();
	if (F != NIL) {
		if (F->hasCar) {
			beg = F->carloc.pos;
		} else {
			beg = 0;
		}
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, beg);
		do {
			Texts_ReadElem(&R, Texts_Reader__typ);
		} while (!(R.eot || __ISP(R.elem, ErrorElems_ElemDesc, 2)));
		if (!R.eot && __ISP(R.elem, ErrorElems_ElemDesc, 2)) {
			Oberon_PassFocus(Viewers_This(F->X, F->Y));
			pos = Texts_Pos(&R, Texts_Reader__typ);
			ErrorElems_Show(F, pos - 1);
			TextFrames_SetCaret(F, pos);
		} else {
			TextFrames_RemoveCaret(F);
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(ErrorElems_font);
	__ENUMR(&ErrorElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(ErrorElems_ElemDesc, 1, 4) = {__TDFLDS("ElemDesc", 168), {0, 4, 12, 32, -20}};

export void *ErrorElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(ErrorElems, EnumPtrs);
	__REGCMD("LocateNext", ErrorElems_LocateNext);
	__REGCMD("Mark", ErrorElems_Mark);
	__REGCMD("Unmark", ErrorElems_Unmark);
	__INITYP(ErrorElems_ElemDesc, Texts_ElemDesc, 2);
/* BEGIN */
	ErrorElems_font = Fonts_This((CHAR*)"Syntax8.Scn.Fnt", (LONGINT)16);
	Texts_OpenWriter(&ErrorElems_W, Texts_Writer__typ);
	ErrorElems_lastTime = -1;
	__ENDMOD;
}
