/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Kernel.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	CHAR FKeys_Sequence[3];

typedef
	struct FKeys_KeyConv {
		FKeys_Sequence sequence;
		CHAR result;
	} FKeys_KeyConv;


static FKeys_KeyConv FKeys_convTable[128];
static INTEGER FKeys_tableCurs;
static Texts_Writer FKeys_w;

export LONGINT *FKeys_KeyConv__typ;

export void FKeys_Get (INTEGER n, Modules_Command *cmd);
static void FKeys_GetArg (Texts_Scanner *S, LONGINT *S__typ);
static void FKeys_InitConvTable (void);
static void FKeys_InsertKey (FKeys_Sequence seq, CHAR res);
export void FKeys_InternationalKey (void);
export void FKeys_Set (INTEGER n, Modules_Command cmd);
export void FKeys_SetCommand (void);


static void FKeys_InsertKey (FKeys_Sequence seq, CHAR res)
{
	FKeys_Sequence seq__copy;
	__DUPARR(seq, FKeys_Sequence);
	if (FKeys_tableCurs < 127) {
		__MOVE(seq, FKeys_convTable[__X(FKeys_tableCurs, 128)].sequence, 3);
		FKeys_convTable[__X(FKeys_tableCurs, 128)].result = res;
		FKeys_tableCurs += 1;
		FKeys_convTable[__X(FKeys_tableCurs, 128)].sequence[0] = FKeys_convTable[__X(FKeys_tableCurs - 1, 128)].sequence[1];
		FKeys_convTable[__X(FKeys_tableCurs, 128)].sequence[1] = FKeys_convTable[__X(FKeys_tableCurs - 1, 128)].sequence[0];
		FKeys_convTable[__X(FKeys_tableCurs, 128)].sequence[2] = 0x00;
		FKeys_convTable[__X(FKeys_tableCurs, 128)].result = FKeys_convTable[__X(FKeys_tableCurs - 1, 128)].result;
		FKeys_tableCurs += 1;
	}
}

void FKeys_InternationalKey (void)
{
	Viewers_Viewer v = NIL;
	Display_Frame f = NIL;
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	LONGINT pos = 0;
	CHAR sk[4];
	CHAR ch = 0;
	INTEGER i = 0;
	v = Oberon_FocusViewer;
	if (__ISP(v, MenuViewers_ViewerDesc, 2)) {
		f = v->dsc->next;
		if (__ISP(f, TextFrames_FrameDesc, 1)) {
			if (__ISP(f, TextFrames_FrameDesc, 1)) {
				if ((*(TextFrames_Frame*)&f)->hasCar) {
					t = (*(TextFrames_Frame*)&f)->text;
					pos = (*(TextFrames_Frame*)&f)->carloc.pos;
					if (pos >= 2) {
						Texts_OpenReader(&r, Texts_Reader__typ, t, pos - 2);
						Texts_Read(&r, Texts_Reader__typ, &sk[0]);
						Texts_Read(&r, Texts_Reader__typ, &sk[1]);
						sk[2] = 0x00;
						i = 0;
						while (i < FKeys_tableCurs && __STRCMP(FKeys_convTable[__X(i, 128)].sequence, sk) != 0) {
							i += 1;
						}
						if (__STRCMP(FKeys_convTable[__X(i, 128)].sequence, sk) == 0) {
							Texts_Write(&FKeys_w, Texts_Writer__typ, FKeys_convTable[__X(i, 128)].result);
							Texts_Delete(t, pos - 2, pos);
							Texts_Insert(t, pos - 2, FKeys_w.buf);
							TextFrames_SetCaret((*(TextFrames_Frame*)&f), pos - 1);
						}
					}
				}
			} else __WITHCHK;
		}
	}
}

static void FKeys_InitConvTable (void)
{
	FKeys_InsertKey((CHAR*)"a\'", 0x94);
	FKeys_InsertKey((CHAR*)"e\'", 0x90);
	FKeys_InsertKey((CHAR*)"a`", 0x8b);
	FKeys_InsertKey((CHAR*)"e`", 0x8c);
	FKeys_InsertKey((CHAR*)"i`", 0x8d);
	FKeys_InsertKey((CHAR*)"o`", 0x8e);
	FKeys_InsertKey((CHAR*)"u`", 0x8f);
	FKeys_InsertKey((CHAR*)"a^", 0x86);
	FKeys_InsertKey((CHAR*)"e^", 0x87);
	FKeys_InsertKey((CHAR*)"i^", 0x88);
	FKeys_InsertKey((CHAR*)"o^", 0x89);
	FKeys_InsertKey((CHAR*)"u^", 0x8a);
	FKeys_InsertKey((CHAR*)"a\"", 0x83);
	FKeys_InsertKey((CHAR*)"e\"", 0x91);
	FKeys_InsertKey((CHAR*)"i\"", 0x92);
	FKeys_InsertKey((CHAR*)"o\"", 0x84);
	FKeys_InsertKey((CHAR*)"u\"", 0x85);
	FKeys_InsertKey((CHAR*)"ae", 0x83);
	FKeys_InsertKey((CHAR*)"oe", 0x84);
	FKeys_InsertKey((CHAR*)"ue", 0x85);
	FKeys_InsertKey((CHAR*)"A\"", 0x80);
	FKeys_InsertKey((CHAR*)"O\"", 0x81);
	FKeys_InsertKey((CHAR*)"U\"", 0x82);
	FKeys_InsertKey((CHAR*)"Ae", 0x80);
	FKeys_InsertKey((CHAR*)"Oe", 0x81);
	FKeys_InsertKey((CHAR*)"Ue", 0x82);
	FKeys_InsertKey((CHAR*)"n~", 0x95);
	FKeys_InsertKey((CHAR*)"c,", 0x93);
	FKeys_InsertKey((CHAR*)"ss", 0xab);
}

static void FKeys_GetArg (Texts_Scanner *S, LONGINT *S__typ)
{
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&*S, S__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '^') {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, T, beg);
			Texts_Scan(&*S, S__typ);
		}
	}
}

static struct SetCommand__7 {
	struct SetCommand__7 *lnk;
} *SetCommand__7_s;

static void Split__8 (CHAR *command, LONGINT command__len, CHAR *modName, LONGINT modName__len, CHAR *procName, LONGINT procName__len);

static void Split__8 (CHAR *command, LONGINT command__len, CHAR *modName, LONGINT modName__len, CHAR *procName, LONGINT procName__len)
{
	INTEGER i = 0, j = 0;
	i = 0;
	while (command[__X(i, command__len)] != 0x00 && command[__X(i, command__len)] != '.') {
		modName[__X(i, modName__len)] = command[__X(i, command__len)];
		i += 1;
	}
	modName[__X(i, modName__len)] = 0x00;
	if (command[__X(i, command__len)] != 0x00) {
		i += 1;
	}
	j = 0;
	while (command[__X(i, command__len)] != 0x00 && command[__X(i, command__len)] != ' ') {
		procName[__X(j, procName__len)] = command[__X(i, command__len)];
		i += 1;
		j += 1;
	}
	procName[__X(j, procName__len)] = 0x00;
}

void FKeys_SetCommand (void)
{
	Modules_Module M = NIL;
	Kernel_KeyCmd P = NIL;
	LONGINT nr = 0;
	Texts_Scanner s = {0};
	CHAR command[128], modName[128], procName[128];
	struct SetCommand__7 _s;
	_s.lnk = SetCommand__7_s;
	SetCommand__7_s = &_s;
	FKeys_GetArg(&s, Texts_Scanner__typ);
	nr = s.i;
	if ((s.class == 3 && nr >= 0) && nr < 16) {
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1) {
			Split__8((void*)s.s, 256, (void*)modName, 128, (void*)procName, 128);
			M = Modules_ThisMod(modName, 128);
			if (M != NIL) {
				P = (Kernel_KeyCmd)Modules_ThisCommand(M, procName, 128);
				if (P != NIL) {
					Kernel_FKey[__X(nr, 16)] = P;
					Texts_WriteString(&FKeys_w, Texts_Writer__typ, (CHAR*)"Macro installed", (LONGINT)16);
					Texts_WriteLn(&FKeys_w, Texts_Writer__typ);
					Texts_Append(Oberon_Log, FKeys_w.buf);
				}
			}
		}
	}
	SetCommand__7_s = _s.lnk;
}

void FKeys_Set (INTEGER n, Modules_Command cmd)
{
	Kernel_FKey[__X(n, 16)] = (Kernel_KeyCmd)cmd;
}

void FKeys_Get (INTEGER n, Modules_Command *cmd)
{
	*cmd = (Modules_Command)Kernel_FKey[__X(n, 16)];
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&FKeys_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(FKeys_KeyConv, 1, 0) = {__TDFLDS("KeyConv", 4), {-4}};

export void *FKeys__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Kernel);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(FKeys, EnumPtrs);
	__REGCMD("InternationalKey", FKeys_InternationalKey);
	__REGCMD("SetCommand", FKeys_SetCommand);
	__INITYP(FKeys_KeyConv, FKeys_KeyConv, 0);
/* BEGIN */
	Texts_OpenWriter(&FKeys_w, Texts_Writer__typ);
	FKeys_tableCurs = 0;
	FKeys_InitConvTable();
	Kernel_FKey[12] = FKeys_InternationalKey;
	__ENDMOD;
}
