/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	BOOLEAN (*FoldElems_CheckProc)(Texts_Elem);

typedef
	struct FoldElems_ElemDesc *FoldElems_Elem;

typedef
	struct FoldElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		SHORTINT mode;
		Texts_Buffer hidden;
		BOOLEAN visible;
	} FoldElems_ElemDesc;

typedef
	struct FoldElems_FindInfo {
		BOOLEAN found;
		Texts_Text text;
		LONGINT pos;
		CHAR pat[128];
		INTEGER len;
	} FoldElems_FindInfo;

typedef
	struct FoldElems_MarkElemDesc *FoldElems_MarkElem;

typedef
	struct FoldElems_MarkElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
	} FoldElems_MarkElemDesc;

typedef
	struct FoldElems_PrepSwitchMsg { /* Texts_ElemMsg */
		char _prvt0[1];
	} FoldElems_PrepSwitchMsg;


export LONGINT FoldElems_elemW, FoldElems_elemH;
static Texts_Writer FoldElems_w;
static FoldElems_FindInfo FoldElems_inf;
static INTEGER FoldElems_x0, FoldElems_y0;
static LONGINT FoldElems_Pat[6];
static SET FoldElems_icl[4], FoldElems_icr[4], FoldElems_iel[4], FoldElems_ier[4];

export LONGINT *FoldElems_ElemDesc__typ;
export LONGINT *FoldElems_MarkElemDesc__typ;
export LONGINT *FoldElems_FindInfo__typ;
export LONGINT *FoldElems_PrepSwitchMsg__typ;

export void FoldElems_Collapse (void);
export void FoldElems_CollapseAll (Texts_Text t, SET modes);
export void FoldElems_Echo (Texts_Text t, BOOLEAN on);
export void FoldElems_Expand (void);
export void FoldElems_ExpandAll (Texts_Text t, LONGINT from, BOOLEAN temporal);
static BOOLEAN FoldElems_FindCheck (Texts_Elem e);
export void FoldElems_FindElem (Texts_Text t, LONGINT pos, FoldElems_CheckProc P, Texts_Elem *elem);
export void FoldElems_FoldHandler (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
static void FoldElems_Init (void);
export void FoldElems_Insert (void);
export void FoldElems_InsertCollapsed (void);
static void FoldElems_MarkHandler (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
export void FoldElems_Marks (void);
export void FoldElems_New (void);
static void FoldElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
export void FoldElems_Restore (void);
export void FoldElems_Search (void);
export void FoldElems_Switch (FoldElems_Elem e);
static Texts_Text FoldElems_TargetText (void);
export FoldElems_Elem FoldElems_Twin (FoldElems_Elem e);
static void FoldElems_Update (FoldElems_Elem e);


static void FoldElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

static BOOLEAN FoldElems_FindCheck (Texts_Elem e)
{
	return __ISP(e, FoldElems_MarkElemDesc, 2);
}

static Texts_Text FoldElems_TargetText (void)
{
	Display_Frame f = NIL;
	Viewers_Viewer v = NIL;
	f = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		f = Oberon_Par->frame->next;
	} else {
		v = Oberon_MarkedViewer();
		if (v != NIL && v->dsc != NIL) {
			f = v->dsc->next;
		}
	}
	if (f != NIL && __ISP(f, TextFrames_FrameDesc, 1)) {
		return __GUARDP(f, TextFrames_FrameDesc, 1)->text;
	} else {
		return NIL;
	}
	__RETCHK;
}

void FoldElems_Echo (Texts_Text t, BOOLEAN on)
{
	if (on) {
		t->notify = TextFrames_NotifyDisplay;
	} else {
		t->notify = FoldElems_NoNotify;
	}
}

static void FoldElems_Update (FoldElems_Elem e)
{
	Texts_Text t = NIL;
	LONGINT pos = 0;
	t = Texts_ElemBase((void*)e);
	pos = Texts_ElemPos((void*)e);
	(*t->notify)(t, 0, pos, pos + 1);
}

FoldElems_Elem FoldElems_Twin (FoldElems_Elem e)
{
	INTEGER level = 0, sp = 0;
	FoldElems_Elem stack[8];
	Texts_Reader r = {0};
	FoldElems_Elem E = NIL;
	E = NIL;
	level = 1;
	if (__IN(e->mode, 0x39)) {
		Texts_OpenReader(&r, Texts_Reader__typ, Texts_ElemBase((void*)e), Texts_ElemPos((void*)e) + 1);
		for (;;) {
			Texts_ReadElem(&r, Texts_Reader__typ);
			if (r.elem == NIL) {
				break;
			} else if (__ISP(r.elem, FoldElems_ElemDesc, 2)) {
				E = __GUARDP(r.elem, FoldElems_ElemDesc, 2);
				if (__IN(E->mode, 0x39)) {
					level += 1;
				} else {
					level -= 1;
				}
				if (level == 0) {
					break;
				}
			}
		}
	} else {
		Texts_OpenReader(&r, Texts_Reader__typ, Texts_ElemBase((void*)e), Texts_ElemPos((void*)e));
		for (;;) {
			Texts_ReadPrevElem(&r, Texts_Reader__typ);
			if (r.elem == NIL) {
				break;
			} else if (__ISP(r.elem, FoldElems_ElemDesc, 2)) {
				E = __GUARDP(r.elem, FoldElems_ElemDesc, 2);
				if (__IN(E->mode, 0x06)) {
					level += 1;
				} else {
					level -= 1;
				}
				if (level == 0) {
					break;
				}
			}
		}
	}
	return E;
}

void FoldElems_Switch (FoldElems_Elem e)
{
	FoldElems_Elem a = NIL, b = NIL;
	LONGINT apos = 0;
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	FoldElems_PrepSwitchMsg prepare = {0};
	if (__IN(e->mode, 0x39)) {
		a = e;
		b = FoldElems_Twin(a);
	} else {
		b = e;
		a = FoldElems_Twin(b);
	}
	if (__IN(a->mode, 0x30)) {
		a->mode = 3;
	}
	if (a != NIL && b != NIL) {
		(*a->handle)((void*)a, (void*)&prepare, FoldElems_PrepSwitchMsg__typ);
		t = Texts_ElemBase((void*)a);
		apos = Texts_ElemPos((void*)a);
		a->mode = 3 - a->mode;
		b->mode = 3 - b->mode;
		Texts_Delete(t, apos + 1, Texts_ElemPos((void*)b));
		Texts_Recall(&buf);
		Texts_Insert(t, apos + 1, a->hidden);
		a->hidden = buf;
		FoldElems_Update(a);
	}
}

void FoldElems_ExpandAll (Texts_Text t, LONGINT from, BOOLEAN temporal)
{
	Texts_Reader r = {0};
	FoldElems_Elem E = NIL;
	INTEGER res = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, from);
	for (;;) {
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.elem == NIL) {
			break;
		} else if (__ISP(r.elem, FoldElems_ElemDesc, 2)) {
			E = __GUARDP(r.elem, FoldElems_ElemDesc, 2);
			if (E->mode == 0) {
				FoldElems_Switch(E);
				if (temporal) {
					E->mode = 4;
				}
				Texts_OpenReader(&r, Texts_Reader__typ, t, Texts_ElemPos((void*)E) + 1);
			}
		}
	}
}

void FoldElems_CollapseAll (Texts_Text t, SET modes)
{
	Texts_Reader r = {0};
	Texts_OpenReader(&r, Texts_Reader__typ, t, t->len);
	for (;;) {
		Texts_ReadPrevElem(&r, Texts_Reader__typ);
		if (r.elem == NIL) {
			break;
		} else if (__ISP(r.elem, FoldElems_ElemDesc, 2) && __IN(__GUARDP(r.elem, FoldElems_ElemDesc, 2)->mode, modes)) {
			FoldElems_Switch(__GUARDP(r.elem, FoldElems_ElemDesc, 2));
		}
	}
}

static struct FindElem__7 {
	FoldElems_CheckProc *P;
	struct FindElem__7 *lnk;
} *FindElem__7_s;

static BOOLEAN Inside__8 (Texts_Buffer buf);

static BOOLEAN Inside__8 (Texts_Buffer buf)
{
	Texts_Reader r = {0};
	Texts_Text t0 = NIL;
	BOOLEAN found = 0;
	t0 = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Append(t0, buf);
	Texts_OpenReader(&r, Texts_Reader__typ, t0, 0);
	found = 0;
	for (;;) {
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.elem == NIL) {
			break;
		} else if ((**FindElem__7_s->P)(r.elem) || (__ISP(r.elem, FoldElems_ElemDesc, 2) && __GUARDP(r.elem, FoldElems_ElemDesc, 2)->mode == 0) && Inside__8(__GUARDP(r.elem, FoldElems_ElemDesc, 2)->hidden)) {
			found = 1;
			break;
		}
	}
	Texts_Save(t0, 0, t0->len, buf);
	return found;
}

void FoldElems_FindElem (Texts_Text t, LONGINT pos, FoldElems_CheckProc P, Texts_Elem *elem)
{
	Texts_Reader r = {0};
	FoldElems_Elem E = NIL;
	struct FindElem__7 _s;
	_s.P = &P;
	_s.lnk = FindElem__7_s;
	FindElem__7_s = &_s;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	for (;;) {
		Texts_ReadElem(&r, Texts_Reader__typ);
		pos = Texts_Pos(&r, Texts_Reader__typ);
		if (r.elem == NIL || (*P)(r.elem)) {
			*elem = r.elem;
			break;
		}
		if (__ISP(r.elem, FoldElems_ElemDesc, 2)) {
			E = __GUARDP(r.elem, FoldElems_ElemDesc, 2);
			if (E->mode == 0 && Inside__8(E->hidden)) {
				FoldElems_Switch(E);
				E->mode = 5;
				Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
			}
		}
	}
	FindElem__7_s = _s.lnk;
}

void FoldElems_FoldHandler (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	FoldElems_Elem a = NIL;
	SET keys = 0;
	INTEGER x = 0, y = 0;
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	SHORTINT k = 0, mode = 0;
	Oberon_ControlMsg neutralize = {0};
	if (__ISP(e, FoldElems_ElemDesc, 2)) {
		if (__IS(m__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *m__ = (void*)m;
			if ((*m__).id == 0) {
				Files_Read(&(*m__).r, Files_Rider__typ, (void*)&k);
				(*(FoldElems_Elem*)&e)->mode = __MASK(k, -4);
				(*(FoldElems_Elem*)&e)->visible = (*(FoldElems_Elem*)&e)->W > 10000;
				if (__IN((*(FoldElems_Elem*)&e)->mode, 0x39)) {
					__NEW((*(FoldElems_Elem*)&e)->hidden, Texts_BufDesc);
					Texts_OpenBuf((*(FoldElems_Elem*)&e)->hidden);
					if (k < 4) {
						t = TextFrames_Text((CHAR*)"", (LONGINT)1);
						Texts_Load(&(*m__).r, Files_Rider__typ, t);
						Texts_Save(t, 0, t->len, (*(FoldElems_Elem*)&e)->hidden);
					}
				}
			} else {
				mode = (*(FoldElems_Elem*)&e)->mode;
				if (__IN(mode, 0x30)) {
					mode = 3;
				}
				if (__IN(mode, 0x39) && (*(FoldElems_Elem*)&e)->hidden->len == 0) {
					k = mode + 4;
				} else {
					k = mode;
				}
				Files_Write(&(*m__).r, Files_Rider__typ, k);
				if (k < 4 && __IN(mode, 0x39)) {
					t = TextFrames_Text((CHAR*)"", (LONGINT)1);
					__NEW(buf, Texts_BufDesc);
					Texts_OpenBuf(buf);
					Texts_Copy((*(FoldElems_Elem*)&e)->hidden, buf);
					Texts_Append(t, buf);
					Texts_Store(&(*m__).r, Files_Rider__typ, t);
				}
			}
		} else if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			__NEW(a, FoldElems_ElemDesc);
			Texts_CopyElem((void*)(*(FoldElems_Elem*)&e), (void*)a);
			a->mode = (*(FoldElems_Elem*)&e)->mode;
			a->visible = (*(FoldElems_Elem*)&e)->visible;
			if (__IN((*(FoldElems_Elem*)&e)->mode, 0x39)) {
				__NEW(a->hidden, Texts_BufDesc);
				Texts_OpenBuf(a->hidden);
				Texts_Copy((*(FoldElems_Elem*)&e)->hidden, a->hidden);
			}
			(*m__).e = (Texts_Elem)a;
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("FoldElems", (*m__).mod, 10);
			__MOVE("New", (*m__).proc, 4);
		} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			if ((*m__).prepare) {
				if ((*(FoldElems_Elem*)&e)->visible) {
					(*(FoldElems_Elem*)&e)->W = FoldElems_elemW;
				} else {
					(*(FoldElems_Elem*)&e)->W = 10000;
				}
			} else if ((*(FoldElems_Elem*)&e)->visible) {
				Display_CopyPattern(15, FoldElems_Pat[__X((*(FoldElems_Elem*)&e)->mode, 6)], (*m__).X0 + FoldElems_x0, (*m__).Y0 + FoldElems_y0, 0);
			}
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if (__IN(1, (*m__).keys)) {
				neutralize.id = 1;
				(*(*m__).frame->handle)((*m__).frame, (void*)&neutralize, Oberon_ControlMsg__typ);
				if (__IN((*(FoldElems_Elem*)&e)->mode, 0x30)) {
					mode = 3;
				} else {
					mode = (*(FoldElems_Elem*)&e)->mode;
				}
				Display_CopyPattern(15, FoldElems_Pat[__X(mode, 6)], (*m__).X0 + FoldElems_x0, (*m__).Y0 + FoldElems_y0, 2);
				Display_CopyPattern(15, FoldElems_Pat[__X(3 - mode, 6)], (*m__).X0 + FoldElems_x0, (*m__).Y0 + FoldElems_y0, 2);
				do {
					Input_Mouse(&keys, &x, &y);
					(*m__).keys = (*m__).keys | keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
				} while (!(keys == 0x0));
				if ((*m__).keys == 0x02) {
					FoldElems_Switch((*(FoldElems_Elem*)&e));
				} else {
					Display_CopyPattern(15, FoldElems_Pat[__X(3 - mode, 6)], (*m__).X0 + FoldElems_x0, (*m__).Y0 + FoldElems_y0, 2);
					Display_CopyPattern(15, FoldElems_Pat[__X(mode, 6)], (*m__).X0 + FoldElems_x0, (*m__).Y0 + FoldElems_y0, 2);
				}
			}
		}
	} else __WITHCHK;
}

static void FoldElems_MarkHandler (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	FoldElems_MarkElem a = NIL;
	if (__IS(m__typ, Texts_CopyMsg, 1)) {
		__NEW(a, FoldElems_MarkElemDesc);
		Texts_CopyElem(e, (void*)a);
		__GUARDR(m, Texts_CopyMsg, 1).e = (Texts_Elem)a;
	}
}

void FoldElems_Insert (void)
{
	FoldElems_Elem e = NIL;
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		__NEW(e, FoldElems_ElemDesc);
		e->mode = 2;
		e->W = FoldElems_elemW;
		e->H = FoldElems_elemH;
		e->handle = FoldElems_FoldHandler;
		e->visible = 1;
		Texts_WriteElem(&FoldElems_w, Texts_Writer__typ, (void*)e);
		Texts_Insert(t, end, FoldElems_w.buf);
		__NEW(e, FoldElems_ElemDesc);
		e->mode = 3;
		e->W = FoldElems_elemW;
		e->H = FoldElems_elemH;
		e->handle = FoldElems_FoldHandler;
		__NEW(e->hidden, Texts_BufDesc);
		Texts_OpenBuf(e->hidden);
		e->visible = 1;
		Texts_WriteElem(&FoldElems_w, Texts_Writer__typ, (void*)e);
		Texts_Insert(t, beg, FoldElems_w.buf);
	}
}

void FoldElems_InsertCollapsed (void)
{
	FoldElems_Elem e = NIL;
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		__NEW(e, FoldElems_ElemDesc);
		e->mode = 1;
		e->W = FoldElems_elemW;
		e->H = FoldElems_elemH;
		e->handle = FoldElems_FoldHandler;
		e->visible = 1;
		Texts_WriteElem(&FoldElems_w, Texts_Writer__typ, (void*)e);
		Texts_Insert(t, end, FoldElems_w.buf);
		__NEW(e, FoldElems_ElemDesc);
		e->mode = 0;
		e->W = FoldElems_elemW;
		e->H = FoldElems_elemH;
		e->handle = FoldElems_FoldHandler;
		__NEW(e->hidden, Texts_BufDesc);
		Texts_OpenBuf(e->hidden);
		e->visible = 1;
		Texts_WriteElem(&FoldElems_w, Texts_Writer__typ, (void*)e);
		Texts_Insert(t, beg, FoldElems_w.buf);
	}
}

void FoldElems_Marks (void)
{
	Texts_Scanner s = {0};
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	BOOLEAN visible = 0;
	Texts_Text wt = NIL;
	Texts_Reader r = {0};
	wt = FoldElems_TargetText();
	if (wt != NIL) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
		Texts_Scan(&s, Texts_Scanner__typ);
		if ((s.class == 6 && s.c == '^') && s.line == 0) {
			Oberon_GetSelection(&t, &beg, &end, &time);
			if (time >= 0) {
				Texts_OpenScanner(&s, Texts_Scanner__typ, t, beg);
				Texts_Scan(&s, Texts_Scanner__typ);
			}
		}
		if (s.class == 1 && (__STRCMP(s.s, "on") == 0 || __STRCMP(s.s, "off") == 0)) {
			visible = __STRCMP(s.s, "on") == 0;
			Texts_OpenReader(&r, Texts_Reader__typ, wt, 0);
			for (;;) {
				Texts_ReadElem(&r, Texts_Reader__typ);
				if (r.elem == NIL) {
					break;
				} else if (__ISP(r.elem, FoldElems_ElemDesc, 2)) {
					__GUARDP(r.elem, FoldElems_ElemDesc, 2)->visible = visible;
					FoldElems_Update(__GUARDP(r.elem, FoldElems_ElemDesc, 2));
				}
			}
		}
	}
}

void FoldElems_Search (void)
{
	Viewers_Viewer v = NIL;
	TextFrames_Frame f = NIL;
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	LONGINT beg = 0, end = 0, time = 0, lim = 0;
	INTEGER i = 0;
	CHAR ch = 0;
	Texts_Elem e = NIL;
	Texts_Notifier ntfy = NIL;
	FoldElems_MarkElem E = NIL;
	Oberon_ControlMsg m = {0};
	v = Oberon_Par->vwr;
	if (Oberon_Par->frame != v->dsc) {
		v = Oberon_FocusViewer;
	}
	if ((v != NIL && __ISP(v, MenuViewers_ViewerDesc, 2)) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
		FoldElems_inf.text = f->text;
		if (f->hasCar) {
			FoldElems_inf.pos = f->carloc.pos;
			TextFrames_RemoveCaret(f);
		} else {
			FoldElems_inf.pos = 0;
		}
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
			FoldElems_inf.len = 0;
			while (beg < end) {
				Texts_Read(&r, Texts_Reader__typ, &FoldElems_inf.pat[__X(FoldElems_inf.len, 128)]);
				FoldElems_inf.len += 1;
				beg += 1;
			}
			FoldElems_inf.pat[__X(FoldElems_inf.len, 128)] = 0x00;
			m.id = 1;
			Viewers_Broadcast((void*)&m, Oberon_ControlMsg__typ);
		}
		if (FoldElems_inf.len > 0) {
			FoldElems_Echo(FoldElems_inf.text, 0);
			FoldElems_ExpandAll(FoldElems_inf.text, FoldElems_inf.pos, 1);
			FoldElems_inf.found = 0;
			lim = FoldElems_inf.text->len - (LONGINT)FoldElems_inf.len;
			Texts_OpenReader(&r, Texts_Reader__typ, FoldElems_inf.text, FoldElems_inf.pos);
			for (;;) {
				Texts_Read(&r, Texts_Reader__typ, &ch);
				if (FoldElems_inf.pos > lim) {
					break;
				} else if (ch == FoldElems_inf.pat[0]) {
					Texts_Read(&r, Texts_Reader__typ, &ch);
					i = 1;
					while (i < FoldElems_inf.len && ch == FoldElems_inf.pat[__X(i, 128)]) {
						Texts_Read(&r, Texts_Reader__typ, &ch);
						i += 1;
					}
					if (i == FoldElems_inf.len) {
						FoldElems_inf.pos = FoldElems_inf.pos + (LONGINT)FoldElems_inf.len;
						FoldElems_inf.found = 1;
						break;
					} else {
						FoldElems_inf.pos += 1;
						Texts_OpenReader(&r, Texts_Reader__typ, FoldElems_inf.text, FoldElems_inf.pos);
					}
				} else {
					FoldElems_inf.pos += 1;
				}
			}
			if (FoldElems_inf.found) {
				__NEW(E, FoldElems_MarkElemDesc);
				E->W = 0;
				E->H = 0;
				E->handle = FoldElems_MarkHandler;
				Texts_WriteElem(&FoldElems_w, Texts_Writer__typ, (void*)E);
				Texts_Insert(FoldElems_inf.text, FoldElems_inf.pos, FoldElems_w.buf);
				FoldElems_CollapseAll(FoldElems_inf.text, 0x10);
				FoldElems_Echo(FoldElems_inf.text, 1);
				FoldElems_FindElem(FoldElems_inf.text, 0, FoldElems_FindCheck, &e);
				FoldElems_inf.pos = Texts_ElemPos(e);
				if (E == (void *) e) {
					FoldElems_Echo(FoldElems_inf.text, 0);
				}
				Texts_Delete(FoldElems_inf.text, FoldElems_inf.pos, FoldElems_inf.pos + 1);
				FoldElems_Echo(FoldElems_inf.text, 1);
				end = TextFrames_Pos(f, f->X + f->W, f->Y);
				if (FoldElems_inf.pos < f->org || FoldElems_inf.pos >= end) {
					TextFrames_Show(f, FoldElems_inf.pos - 120);
				}
				TextFrames_SetCaret(f, FoldElems_inf.pos);
			} else {
				FoldElems_CollapseAll(FoldElems_inf.text, 0x10);
				FoldElems_Echo(FoldElems_inf.text, 1);
			}
		}
	}
}

void FoldElems_Restore (void)
{
	Texts_Text t = NIL;
	t = FoldElems_TargetText();
	if (t != NIL) {
		FoldElems_CollapseAll(t, 0x20);
	}
}

void FoldElems_Expand (void)
{
	Texts_Text t = NIL;
	t = FoldElems_TargetText();
	if (t != NIL) {
		FoldElems_ExpandAll(t, 0, 0);
	}
}

void FoldElems_Collapse (void)
{
	Texts_Text t = NIL;
	t = FoldElems_TargetText();
	if (t != NIL) {
		FoldElems_CollapseAll(t, 0x38);
	}
}

void FoldElems_New (void)
{
	FoldElems_Elem e = NIL;
	__NEW(e, FoldElems_ElemDesc);
	e->handle = FoldElems_FoldHandler;
	Texts_new = (Texts_Elem)e;
}

static void FoldElems_Init (void)
{
	SET img[10];
	img[1] = 0x04;
	img[2] = 0x0c;
	img[3] = 0x1c;
	img[4] = 0x3c;
	img[5] = 0x7c;
	img[6] = 0x3c;
	img[7] = 0x1c;
	img[8] = 0x0c;
	img[9] = 0x04;
	FoldElems_Pat[0] = Display_NewPattern((void*)img, 10, 8, 9);
	img[1] = 0x04;
	img[2] = 0x0c;
	img[3] = 0x14;
	img[4] = 0x24;
	img[5] = 0x44;
	img[6] = 0x24;
	img[7] = 0x14;
	img[8] = 0x0c;
	img[9] = 0x04;
	FoldElems_Pat[3] = Display_NewPattern((void*)img, 10, 8, 9);
	img[1] = 0x20;
	img[2] = 0x30;
	img[3] = 0x38;
	img[4] = 0x3c;
	img[5] = 0x3e;
	img[6] = 0x3c;
	img[7] = 0x38;
	img[8] = 0x30;
	img[9] = 0x20;
	FoldElems_Pat[1] = Display_NewPattern((void*)img, 10, 8, 9);
	img[1] = 0x20;
	img[2] = 0x30;
	img[3] = 0x28;
	img[4] = 0x24;
	img[5] = 0x22;
	img[6] = 0x24;
	img[7] = 0x28;
	img[8] = 0x30;
	img[9] = 0x20;
	FoldElems_Pat[2] = Display_NewPattern((void*)img, 10, 8, 9);
	FoldElems_Pat[4] = FoldElems_Pat[3];
	FoldElems_Pat[5] = FoldElems_Pat[3];
	FoldElems_inf.len = 0;
	FoldElems_elemW = 80000;
	FoldElems_elemH = 120000;
	FoldElems_x0 = 0;
	FoldElems_y0 = 3;
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&FoldElems_w, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&FoldElems_inf, FoldElems_FindInfo__typ, 144, 1, P);
}

__TDESC(FoldElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 48), {0, 4, 12, 32, 40, -24}};
__TDESC(FoldElems_MarkElemDesc, 1, 4) = {__TDFLDS("MarkElemDesc", 36), {0, 4, 12, 32, -20}};
__TDESC(FoldElems_FindInfo, 1, 1) = {__TDFLDS("FindInfo", 144), {4, -8}};
__TDESC(FoldElems_PrepSwitchMsg, 1, 0) = {__TDFLDS("PrepSwitchMsg", 1), {-4}};

export void *FoldElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(FoldElems, EnumPtrs);
	__REGCMD("Collapse", FoldElems_Collapse);
	__REGCMD("Expand", FoldElems_Expand);
	__REGCMD("Insert", FoldElems_Insert);
	__REGCMD("InsertCollapsed", FoldElems_InsertCollapsed);
	__REGCMD("Marks", FoldElems_Marks);
	__REGCMD("New", FoldElems_New);
	__REGCMD("Restore", FoldElems_Restore);
	__REGCMD("Search", FoldElems_Search);
	__INITYP(FoldElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(FoldElems_MarkElemDesc, Texts_ElemDesc, 2);
	__INITYP(FoldElems_FindInfo, FoldElems_FindInfo, 0);
	__INITYP(FoldElems_PrepSwitchMsg, Texts_ElemMsg, 1);
/* BEGIN */
	FoldElems_Init();
	Texts_OpenWriter(&FoldElems_w, Texts_Writer__typ);
	__ENDMOD;
}
