/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Display1.h"
#include "Fonts.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextPrinter.h"


static LONGINT GUtils_pUnit, GUtils_dUnit;
export INTEGER GUtils_device;


export void GUtils_Area (Display_Frame f, INTEGER col, INTEGER lightcol, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER fw, BOOLEAN filled, BOOLEAN deep);
static void GUtils_CheckString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER w, Fonts_Font fnt, INTEGER *ret, INTEGER *let);
export void GUtils_CopyPattern (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER mode);
static void GUtils_CopyPatternD (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER mode);
export void GUtils_Frame (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER fw, INTEGER mode);
export void GUtils_Frame3 (Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void GUtils_GetChar (Fonts_Font f, CHAR ch, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *p);
export INTEGER GUtils_GetStringLength (CHAR *s, LONGINT s__len, Fonts_Font fnt);
export void GUtils_Line (Display_Frame f, INTEGER col, INTEGER X0, INTEGER Y0, INTEGER X1, INTEGER Y1, INTEGER mode);
export void GUtils_ReplConst (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
static void GUtils_ReplConstD (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
static void GUtils_ReplConstP (INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void GUtils_ReplPattern (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER xp, INTEGER yp, INTEGER mode);
export void GUtils_SetDevice (INTEGER dev);
export void GUtils_String (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER col, INTEGER mode, INTEGER align);
static void GUtils_StringD (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER col, INTEGER mode, INTEGER align);
static void GUtils_StringP (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, INTEGER color, Fonts_Font fnt, INTEGER align);
export INTEGER GUtils_Unit (LONGINT val, BOOLEAN isDisplayUnit);


INTEGER GUtils_Unit (LONGINT val, BOOLEAN isDisplayUnit)
{
	if (GUtils_device == 1) {
		if (isDisplayUnit) {
			return (int)__DIV(val, GUtils_pUnit);
		} else {
			return (int)__DIV(val * GUtils_dUnit, GUtils_pUnit);
		}
	} else {
		if (isDisplayUnit) {
			return (int)__DIV(val, GUtils_dUnit);
		} else {
			return (int)val;
		}
	}
	__RETCHK;
}

static void GUtils_GetChar (Fonts_Font f, CHAR ch, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *p)
{
	SHORTINT fno = 0;
	LONGINT pdx = 0;
	if (GUtils_device == 2) {
		Display_GetChar(f->raster, ch, &*dx, &*x, &*y, &*w, &*h, &*p);
	} else {
		fno = TextPrinter_FontNo(f);
		TextPrinter_GetChar(fno, GUtils_pUnit, ch, &pdx, &*dx, &*x, &*y, &*w, &*h, &*p);
	}
}

void GUtils_SetDevice (INTEGER dev)
{
	GUtils_device = dev;
}

static void GUtils_ReplConstD (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode)
{
	if (f != NIL) {
		Display_ReplConstC(f, col, x, y, w, h, mode);
	} else {
		Display_ReplConst(col, x, y, w, h, mode);
	}
}

static void GUtils_ReplConstP (INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Printer_ReplConst(x, y, w, h);
}

void GUtils_ReplConst (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode)
{
	if (GUtils_device == 2) {
		GUtils_ReplConstD(f, col, x, y, w, h, mode);
	} else {
		GUtils_ReplConstP(col, x, y, w, h);
	}
}

void GUtils_Line (Display_Frame f, INTEGER col, INTEGER X0, INTEGER Y0, INTEGER X1, INTEGER Y1, INTEGER mode)
{
	if (GUtils_device == 1) {
		Printer_Line(X0, Y0, X1, Y1);
	} else {
		Display1_Line(f, col, X0, Y0, X1, Y1, mode);
	}
}

static void GUtils_CopyPatternD (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER mode)
{
	if (f != NIL) {
		Display_CopyPatternC(f, col, pat, x, y, mode);
	} else {
		Display_CopyPattern(col, pat, x, y, mode);
	}
}

void GUtils_CopyPattern (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER mode)
{
	if (GUtils_device == 2) {
		GUtils_CopyPatternD(f, col, pat, x, y, mode);
	}
}

static void GUtils_CheckString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER w, Fonts_Font fnt, INTEGER *ret, INTEGER *let)
{
	INTEGER i = 0, cx = 0, cy = 0, cw = 0, ch = 0, dx = 0, x0 = 0;
	LONGINT pat = 0;
	BOOLEAN cond = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	x0 = x;
	cond = 1;
	while (s[__X(i, s__len)] != 0x00 && cond) {
		GUtils_GetChar(fnt, s[__X(i, s__len)], &dx, &cx, &cy, &cw, &ch, &pat);
		if (x + dx <= x0 + w) {
			x += dx;
			i += 1;
		} else {
			cond = 0;
		}
	}
	*ret = w - (x - x0);
	*let = i;
	__DEL(s);
}

static void GUtils_StringD (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER col, INTEGER mode, INTEGER align)
{
	INTEGER i = 0, let = 0, cx = 0, cy = 0, cw = 0, ch = 0, dx = 0;
	LONGINT pat = 0;
	INTEGER _for__18 = 0;
	__DUP(s, s__len, CHAR);
	if (f != NIL) {
		Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	}
	GUtils_CheckString(s, s__len, x, w, fnt, &cx, &let);
	if (align == 0) {
		cx = 0;
	} else if (align == 1) {
		cx = __ASHR(cx, 1);
	}
	x += cx;
	_for__18 = let - 1;
	i = 0;
	while (i <= _for__18) {
		GUtils_GetChar(fnt, s[__X(i, s__len)], &dx, &cx, &cy, &cw, &ch, &pat);
		if (f == NIL) {
			Display_CopyPattern(col, pat, x + cx, y + cy, mode);
		} else {
			Display_CopyPatternC(f, col, pat, x + cx, y + cy, mode);
		}
		x += dx;
		i += 1;
	}
	__DEL(s);
}

static void GUtils_StringP (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, INTEGER color, Fonts_Font fnt, INTEGER align)
{
	INTEGER i = 0, let = 0, cx = 0;
	CHAR mystr[62];
	INTEGER _for__20 = 0;
	__DUP(s, s__len, CHAR);
	GUtils_CheckString(s, s__len, x, w, fnt, &cx, &let);
	if (align == 0) {
		cx = 0;
	} else if (align == 1) {
		cx = __ASHR(cx, 1);
	}
	x += cx;
	_for__20 = let - 1;
	i = 0;
	while (i <= _for__20) {
		mystr[__X(i, 62)] = s[__X(i, s__len)];
		i += 1;
	}
	mystr[__X(let, 62)] = 0x00;
	Printer_String(x, y, (void*)mystr, 62, (void*)fnt->name, 32);
	__DEL(s);
}

void GUtils_String (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER col, INTEGER mode, INTEGER align)
{
	__DUP(s, s__len, CHAR);
	if (GUtils_device == 2) {
		GUtils_StringD(f, s, s__len, x, y, w, fnt, col, mode, align);
	} else {
		GUtils_StringP(s, s__len, x, y, w, col, fnt, align);
	}
	__DEL(s);
}

INTEGER GUtils_GetStringLength (CHAR *s, LONGINT s__len, Fonts_Font fnt)
{
	INTEGER i = 0, x = 0, dx = 0, cx = 0, cy = 0, cw = 0, ch = 0;
	LONGINT pat = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	x = 0;
	while (s[__X(i, s__len)] != 0x00) {
		GUtils_GetChar(fnt, s[__X(i, s__len)], &dx, &cx, &cy, &cw, &ch, &pat);
		x += dx;
		i += 1;
	}
	__DEL(s);
	return x;
}

void GUtils_Frame (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER fw, INTEGER mode)
{
	if (w < 0) {
		x += w;
		w = __ABS(w);
	}
	if (h < 0) {
		y += h;
		h = __ABS(h);
	}
	if (__ASHL(fw, 1) < w) {
		GUtils_ReplConst(f, col, x, y, fw, h, mode);
		GUtils_ReplConst(f, col, (x + w) - fw, y, fw, h, mode);
		GUtils_ReplConst(f, col, x + fw, y, w - __ASHL(fw, 1), fw, mode);
		GUtils_ReplConst(f, col, x + fw, (y + h) - fw, w - __ASHL(fw, 1), fw, mode);
	} else {
		GUtils_ReplConst(f, col, x, y, w, h, mode);
	}
}

void GUtils_Frame3 (Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (w < 0) {
		x += w;
		w = __ABS(w);
	}
	if (h < 0) {
		y += h;
		h = __ABS(h);
	}
	if (w > 4 && h > 4) {
		GUtils_ReplConst(f, 15, x, y, 1, h, 1);
		GUtils_ReplConst(f, 15, x + 1, (y + h) - 1, w - 3, 1, 1);
		GUtils_ReplConst(f, 0, x + 1, y, 1, h - 1, 1);
		GUtils_ReplConst(f, 0, x + 1, (y + h) - 2, w - 4, 1, 1);
		GUtils_ReplConst(f, 0, x + 2, y, w - 3, 1, 1);
		GUtils_ReplConst(f, 0, (x + w) - 1, y, 1, h, 1);
		GUtils_ReplConst(f, 15, x + 2, y + 1, w - 4, 1, 1);
		GUtils_ReplConst(f, 15, (x + w) - 2, y + 2, 1, h - 2, 1);
	} else if (w > 1 && h > 1) {
		if (w > h) {
			GUtils_ReplConst(f, 15, x, y + 1, w - 1, 1, 1);
			GUtils_ReplConst(f, 0, x, y, w, 1, 1);
			GUtils_ReplConst(f, 0, (x + w) - 1, y + 1, 1, 1, 1);
		} else {
			GUtils_ReplConst(f, 15, x, y, 1, h - 1, 1);
			GUtils_ReplConst(f, 0, x + 1, y, 1, h, 1);
			GUtils_ReplConst(f, 0, x, y, 1, 1, 1);
		}
	}
}

void GUtils_ReplPattern (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER xp, INTEGER yp, INTEGER mode)
{
	if (f == NIL) {
		Display_ReplPattern(col, pat, x, y, w, h, mode);
	} else {
		Display_ReplPatternC(f, col, pat, x, y, w, h, xp, yp, mode);
	}
}

void GUtils_Area (Display_Frame f, INTEGER col, INTEGER lightcol, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER fw, BOOLEAN filled, BOOLEAN deep)
{
	INTEGER lt = 0, rb = 0, i = 0, _for__2 = 0;
	if (deep) {
		lt = 15;
		rb = lightcol;
	} else {
		lt = lightcol;
		rb = 15;
	}
	if (GUtils_device == 1) {
		GUtils_Frame(f, col, x, y, w, h, 2, 1);
	} else {
		if (filled && GUtils_device == 2) {
			GUtils_ReplConst(f, col, x, y, w, h, 1);
		}
		if (__ASHL(fw, 1) < w) {
			_for__2 = fw - 1;
			i = 0;
			while (i <= _for__2) {
				GUtils_ReplConst(f, lt, x + i, y + i, 1, h - i, 1);
				GUtils_ReplConst(f, lt, x + fw, ((y + h) - i) - 1, ((w - fw) - i) - 1, 1, 1);
				GUtils_ReplConst(f, rb, x + i, y + i, ((w - fw) - i) + 1, 1, 1);
				GUtils_ReplConst(f, rb, ((x + w) - i) - 1, y, 1, h - i, 1);
				i += 1;
			}
		}
	}
}


export void *GUtils__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Fonts);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextPrinter);
	__REGMOD(GUtils, 0);
/* BEGIN */
	GUtils_device = 2;
	GUtils_pUnit = 3048;
	GUtils_dUnit = Display_Unit;
	__ENDMOD;
}
