/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "GraphicFrames.h"
#include "Graphics.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct GraphicElems_ElemDesc *GraphicElems_Elem;

typedef
	struct GraphicElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT SW, SH, PW, PH;
		Graphics_Graph graph;
		INTEGER Xg, Yg;
		BOOLEAN empty;
	} GraphicElems_ElemDesc;

typedef
	struct GraphicElems_FrameDesc *GraphicElems_Frame;

typedef
	struct GraphicElems_FrameDesc { /* GraphicFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Graphics_Graph graph;
		INTEGER Xg, Yg, X1, Y1, x, y, col;
		BOOLEAN marked, ticked;
		GraphicFrames_LocDesc mark;
		GraphicElems_Elem elem;
	} GraphicElems_FrameDesc;


static INTEGER GraphicElems_x0, GraphicElems_x1, GraphicElems_y0, GraphicElems_y1;
static Texts_Writer GraphicElems_W;
static INTEGER GraphicElems_unit, GraphicElems_GripW, GraphicElems_GripH;

export LONGINT *GraphicElems_ElemDesc__typ;
export LONGINT *GraphicElems_FrameDesc__typ;

export void GraphicElems_Alloc (void);
export void GraphicElems_Changed (GraphicElems_Elem E);
export void GraphicElems_Copy (GraphicElems_Elem SE, GraphicElems_Elem DE);
export Graphics_Graph GraphicElems_CopyGraph (Graphics_Graph G);
static void GraphicElems_FlipGrip (INTEGER x0, INTEGER y0, INTEGER w, INTEGER h);
export void GraphicElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void GraphicElems_HandleFrame (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void GraphicElems_Insert (void);
static void GraphicElems_MarkMenu (GraphicElems_Frame F);
export void GraphicElems_Open (GraphicElems_Elem E, Graphics_Graph G, INTEGER Xg, INTEGER Yg, BOOLEAN adjust);
export void GraphicElems_OpenViewer (GraphicElems_Elem E);
export void GraphicElems_SetSize (GraphicElems_Elem E, LONGINT w, LONGINT h);
static void GraphicElems_Track (GraphicElems_Elem E, SET keys, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0);
export void GraphicElems_Update (void);
static void GraphicElems_box (Graphics_Object obj, BOOLEAN *done);


static void GraphicElems_MarkMenu (GraphicElems_Frame F)
{
	Texts_Reader R = {0};
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	CHAR ch = 0;
	V = Viewers_This(F->X, F->Y);
	if (__ISP(V, MenuViewers_ViewerDesc, 2)) {
		T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
		if (T->len > 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		} else {
			ch = 0x00;
		}
		if (ch != '!') {
			Texts_Write(&GraphicElems_W, Texts_Writer__typ, '!');
			Texts_Append(T, GraphicElems_W.buf);
		}
	}
}

void GraphicElems_Changed (GraphicElems_Elem E)
{
	Texts_Text T = NIL;
	LONGINT pos = 0;
	T = Texts_ElemBase((void*)E);
	pos = Texts_ElemPos((void*)E);
	(*T->notify)(T, 0, pos, pos + 1);
}

static void GraphicElems_FlipGrip (INTEGER x0, INTEGER y0, INTEGER w, INTEGER h)
{
	Display_ReplConst(15, (x0 + w) - GraphicElems_GripW, y0, GraphicElems_GripW, GraphicElems_GripH, 2);
}

void GraphicElems_SetSize (GraphicElems_Elem E, LONGINT w, LONGINT h)
{
	if (w < 108000) {
		w = 108000;
	}
	if (h < 108000) {
		h = 108000;
	}
	E->W = w;
	E->H = h;
	E->SW = w;
	E->SH = h;
	E->PW = __ASHL(__DIV(w, (LONGINT)GraphicElems_unit), 2) * 3048;
	E->PH = __ASHL(__DIV(h, (LONGINT)GraphicElems_unit), 2) * 3048;
}

static void GraphicElems_box (Graphics_Object obj, BOOLEAN *done)
{
	if (obj->x < GraphicElems_x0) {
		GraphicElems_x0 = obj->x;
	}
	if (GraphicElems_x1 < obj->x + obj->w) {
		GraphicElems_x1 = obj->x + obj->w;
	}
	if (obj->y < GraphicElems_y0) {
		GraphicElems_y0 = obj->y;
	}
	if (GraphicElems_y1 < obj->y + obj->h) {
		GraphicElems_y1 = obj->y + obj->h;
	}
}

void GraphicElems_Open (GraphicElems_Elem E, Graphics_Graph G, INTEGER Xg, INTEGER Yg, BOOLEAN adjust)
{
	E->graph = G;
	GraphicElems_x0 = 32767;
	GraphicElems_x1 = -32768;
	GraphicElems_y0 = 32767;
	GraphicElems_y1 = -32768;
	Graphics_Enumerate(G, GraphicElems_box);
	if (GraphicElems_x0 == 32767) {
		E->empty = 1;
		E->Xg = 0;
		E->Yg = 0;
		GraphicElems_SetSize(E, 0, 0);
	} else {
		E->empty = 0;
		if (adjust) {
			E->Xg = -GraphicElems_x0;
			E->Yg = -GraphicElems_y1;
			GraphicElems_SetSize(E, (LONGINT)(GraphicElems_x1 - GraphicElems_x0) * (LONGINT)GraphicElems_unit, (LONGINT)(GraphicElems_y1 - GraphicElems_y0) * (LONGINT)GraphicElems_unit);
		} else {
			E->Xg = Xg;
			E->Yg = Yg;
			GraphicElems_SetSize(E, E->W, E->H);
		}
	}
}

Graphics_Graph GraphicElems_CopyGraph (Graphics_Graph G)
{
	Graphics_Graph g = NIL;
	Graphics_SelectArea(G, -32768, -32768, 32767, 32767);
	__NEW(g, Graphics_GraphDesc);
	Graphics_Copy(G, g, 0, 0);
	Graphics_Deselect(g);
	return g;
}

void GraphicElems_Copy (GraphicElems_Elem SE, GraphicElems_Elem DE)
{
	SE->W = SE->SW;
	SE->H = SE->SH;
	Texts_CopyElem((void*)SE, (void*)DE);
	GraphicElems_Open(DE, GraphicElems_CopyGraph(SE->graph), SE->Xg, SE->Yg, 0);
}

static void GraphicElems_HandleFrame (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	GraphicElems_Frame F = NIL, F1 = NIL;
	F = __GUARDP(f, GraphicElems_FrameDesc, 2);
	if (__IS(msg__typ, Oberon_InputMsg, 1)) {
		GraphicFrames_Handle((void*)F, &*msg, msg__typ);
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0 || (*msg__).id == 1 && (*msg__).keys != 0x0) {
				GraphicElems_MarkMenu(F);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
		__NEW(F1, GraphicElems_FrameDesc);
		GraphicFrames_Open((void*)F1, F->graph, F->Xg, F->Yg, F->col, F->ticked);
		F1->handle = F->handle;
		F1->elem = F->elem;
		__GUARDR(msg, Oberon_CopyMsg, 1).F = (Display_Frame)F1;
	} else {
		GraphicFrames_Handle((void*)F, &*msg, msg__typ);
	}
}

void GraphicElems_OpenViewer (GraphicElems_Elem E)
{
	Viewers_Viewer v = NIL;
	GraphicElems_Frame f = NIL;
	INTEGER x = 0, y = 0;
	__NEW(f, GraphicElems_FrameDesc);
	GraphicFrames_Open((void*)f, GraphicElems_CopyGraph(E->graph), 0, 0, 0, 1);
	f->elem = E;
	f->handle = GraphicElems_HandleFrame;
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	v = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"GraphicElems.Graph", (LONGINT)19, (CHAR*)"System.Close  System.Copy  System.Grow  Draw.Delete  GraphicElems.Update ", (LONGINT)74), (void*)f, TextFrames_menuH, x, y);
}

static void GraphicElems_Track (GraphicElems_Elem E, SET keys, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0)
{
	SET keysum = 0;
	INTEGER x1 = 0, y1 = 0, w = 0, h = 0;
	BOOLEAN hit = 0;
	if (__IN(1, keys)) {
		x1 = x - x0;
		y1 = y - y0;
		keysum = keys;
		w = (int)__DIV(E->W, (LONGINT)GraphicElems_unit);
		h = (int)__DIV(E->H, (LONGINT)GraphicElems_unit);
		hit = ((!E->empty && x1 >= w - GraphicElems_GripW) && 0 <= y1) && y1 < GraphicElems_GripH;
		if (hit) {
			GraphicElems_FlipGrip(x0, y0, w, h);
		}
		do {
			Input_Mouse(&keys, &x, &y);
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
			keysum = keysum | keys;
			if (hit && __IN(0, keysum)) {
				hit = 0;
				GraphicElems_FlipGrip(x0, y0, w, h);
			}
		} while (!(keys == 0x0));
		if (hit) {
			GraphicElems_FlipGrip(x0, y0, w, h);
		}
		if (keysum == 0x02) {
			if (hit) {
				w += (x - x0) - x1;
				h -= (y - y0) - y1;
				GraphicElems_SetSize(E, (LONGINT)w * (LONGINT)GraphicElems_unit, (LONGINT)h * (LONGINT)GraphicElems_unit);
				GraphicElems_Changed(E);
			} else {
				GraphicElems_OpenViewer(E);
			}
		} else if (keysum == 0x06) {
			GraphicElems_Open(E, E->graph, 0, 0, 1);
			GraphicElems_Changed(E);
		}
	}
}

void GraphicElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	GraphicElems_Elem E = NIL, E1 = NIL;
	INTEGER x = 0, y = 0, w = 0, h = 0;
	GraphicFrames_Frame f = NIL;
	Graphics_Graph g = NIL;
	CHAR version = 0;
	E = __GUARDP(e, GraphicElems_ElemDesc, 2);
	if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if ((*msg__).prepare) {
				E->W = E->SW;
				E->H = E->SH;
			} else {
				x = (*msg__).X0;
				y = (*msg__).Y0;
				w = (int)__DIV(E->W, (LONGINT)GraphicElems_unit);
				h = (int)__DIV(E->H, (LONGINT)GraphicElems_unit);
				if (E->empty) {
					Display_ReplPattern(15, Display_grey1, x, y, w, h, 0);
				} else {
					__NEW(f, GraphicFrames_FrameDesc);
					GraphicFrames_Open(f, E->graph, E->Xg, E->Yg, 0, 0);
					f->X = x;
					f->Y = y;
					f->W = w;
					f->H = h;
					GraphicFrames_Restore(f);
					GraphicElems_FlipGrip(x, y, w, h);
					(*msg__).elemFrame = (Display_Frame)f;
				}
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
		if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if ((*msg__).prepare) {
				E->W = E->PW;
				E->H = E->PH;
			} else {
				Graphics_Print(E->graph, __ASHL(E->Xg, 2) + (*msg__).X0, (__ASHL(E->Yg, 2) + (*msg__).Y0) + (int)__DIV(E->PH, 3048));
				E->W = E->SW;
				E->H = E->SH;
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
		if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("GraphicElems", (*msg__).mod, 13);
			__MOVE("Alloc", (*msg__).proc, 6);
		} else __WITHCHK;
	} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
		if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&version);
				__NEW(g, Graphics_GraphDesc);
				Graphics_Load(g, &(*msg__).r, Files_Rider__typ);
				if (version == 0x01) {
					GraphicElems_Open(E, g, 0, 0, 1);
				} else {
					Files_ReadInt(&(*msg__).r, Files_Rider__typ, &E->Xg);
					Files_ReadInt(&(*msg__).r, Files_Rider__typ, &E->Yg);
					GraphicElems_Open(E, g, E->Xg, E->Yg, 0);
				}
			} else if ((*msg__).id == 1) {
				E->W = E->SW;
				E->H = E->SH;
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x02);
				Graphics_Store(E->graph, &(*msg__).r, Files_Rider__typ);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, E->Xg);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, E->Yg);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
		__NEW(E1, GraphicElems_ElemDesc);
		GraphicElems_Copy(E, E1);
		__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)E1;
	} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
		if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			GraphicElems_Track(E, (*msg__).keys, (*msg__).X, (*msg__).Y, (*msg__).X0, (*msg__).Y0);
		} else __WITHCHK;
	} else if (__IS(msg__typ, TextFrames_FocusMsg, 1)) {
		if (__IS(msg__typ, TextFrames_FocusMsg, 1)) {
			TextFrames_FocusMsg *msg__ = (void*)msg;
			f = __GUARDP((*msg__).elemFrame, GraphicFrames_FrameDesc, 1);
			f->ticked = (*msg__).focus;
			GraphicFrames_Restore(f);
			if (!(*msg__).focus) {
				GraphicElems_FlipGrip(f->X, f->Y, f->W, f->H);
			}
		} else __WITHCHK;
	}
}

void GraphicElems_Alloc (void)
{
	GraphicElems_Elem e = NIL;
	__NEW(e, GraphicElems_ElemDesc);
	e->handle = GraphicElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void GraphicElems_Insert (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Viewers_Viewer V = NIL;
	Graphics_Graph G = NIL, g = NIL;
	GraphicElems_Elem e = NIL;
	TextFrames_InsertElemMsg msg = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	__NEW(g, Graphics_GraphDesc);
	if (S.class == 6 && S.c == '*') {
		V = Oberon_MarkedViewer();
		if ((V->dsc != NIL && V->dsc->next != NIL) && __ISP(V->dsc->next, GraphicFrames_FrameDesc, 1)) {
			G = __GUARDP(V->dsc->next, GraphicFrames_FrameDesc, 1)->graph;
			if (G->sel == NIL) {
				g = GraphicElems_CopyGraph(G);
			} else {
				Graphics_Copy(G, g, 0, 0);
			}
		}
	} else if (S.class == 1) {
		Graphics_Open(g, S.s, 256);
	}
	__NEW(e, GraphicElems_ElemDesc);
	e->handle = GraphicElems_Handle;
	GraphicElems_Open(e, g, 0, 0, 1);
	msg.e = (Texts_Elem)e;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&msg, TextFrames_InsertElemMsg__typ);
}

void GraphicElems_Update (void)
{
	Viewers_Viewer V = NIL;
	GraphicElems_Frame F = NIL;
	Texts_Reader R = {0};
	Texts_Text T = NIL;
	CHAR ch = 0;
	V = Oberon_Par->vwr;
	F = __GUARDP(V->dsc->next, GraphicElems_FrameDesc, 2);
	T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
	GraphicFrames_Deselect((void*)F);
	GraphicElems_Open(F->elem, GraphicElems_CopyGraph(F->graph), 0, 0, 1);
	GraphicElems_Changed(F->elem);
	Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	if (ch == '!') {
		Texts_Delete(T, T->len - 1, T->len);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&GraphicElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(GraphicElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 64), {0, 4, 12, 32, 52, -24}};
__TDESC(GraphicElems_FrameDesc, 1, 5) = {__TDFLDS("FrameDesc", 52), {0, 4, 20, 44, 48, -24}};

export void *GraphicElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(GraphicFrames);
	__IMPORT(Graphics);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(GraphicElems, EnumPtrs);
	__REGCMD("Alloc", GraphicElems_Alloc);
	__REGCMD("Insert", GraphicElems_Insert);
	__REGCMD("Update", GraphicElems_Update);
	__INITYP(GraphicElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(GraphicElems_FrameDesc, GraphicFrames_FrameDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&GraphicElems_W, Texts_Writer__typ);
	GraphicElems_unit = TextFrames_Unit;
	GraphicElems_GripW = (int)__DIV(54000, (LONGINT)GraphicElems_unit);
	GraphicElems_GripH = GraphicElems_GripW;
	__ENDMOD;
}
