/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Display1.h"
#include "Fonts.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"


export LONGINT GraphicUtils_dUnit, GraphicUtils_pUnit;


static void GraphicUtils_CheckPString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER *ret, INTEGER *let);
static void GraphicUtils_CheckString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER *ret, INTEGER *let);
static void GraphicUtils_CopyPatternC (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER mode);
export void GraphicUtils_DrawBox (Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
static void GraphicUtils_DrawLine (Texts_Reader *r, LONGINT *r__typ, Display_Frame f, INTEGER x, INTEGER y, INTEGER w);
export void GraphicUtils_DrawMenu (Display_Frame f, Texts_Text menu, INTEGER sc, INTEGER cmd, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode, INTEGER *n, INTEGER *lsp, INTEGER *dsc);
export void GraphicUtils_DrawPatternBox (Display_Frame f, BOOLEAN pressed, LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER pX, INTEGER pY, INTEGER mode);
export void GraphicUtils_DrawString (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER mode, INTEGER align, INTEGER *ret);
static void GraphicUtils_Flip (Display_Frame f, Texts_Text menu, INTEGER lsp, INTEGER dsc, INTEGER x, INTEGER y, INTEGER w, INTEGER h, BOOLEAN in, INTEGER sc, INTEGER cmd);
export INTEGER GraphicUtils_GetStringLength (CHAR *s, LONGINT s__len, Fonts_Font fnt);
static INTEGER GraphicUtils_Max (INTEGER x, INTEGER y);
static INTEGER GraphicUtils_Min (INTEGER x, INTEGER y);
export void GraphicUtils_PrintBox (INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void GraphicUtils_PrintPatternBox (LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER pX, INTEGER pY);
export void GraphicUtils_PrintString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER align, INTEGER *ret);
static void GraphicUtils_ReplConstC (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
export void GraphicUtils_Set (Texts_Reader *r, LONGINT *r__typ, Texts_Text t, INTEGER *l);
export void GraphicUtils_TrackMenu (Display_Frame f, Texts_Text menu, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER n, INTEGER lsp, INTEGER dsc, INTEGER *sc, INTEGER *cmd);


static INTEGER GraphicUtils_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER GraphicUtils_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void GraphicUtils_ReplConstC (Display_Frame f, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode)
{
	if (f != NIL) {
		Display_ReplConstC(f, col, x, y, w, h, mode);
	} else {
		Display_ReplConst(col, x, y, w, h, mode);
	}
}

static void GraphicUtils_CopyPatternC (Display_Frame f, INTEGER col, LONGINT pat, INTEGER x, INTEGER y, INTEGER mode)
{
	if (f != NIL) {
		Display_CopyPatternC(f, col, pat, x, y, mode);
	} else {
		Display_CopyPattern(col, pat, x, y, mode);
	}
}

static void GraphicUtils_CheckString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER *ret, INTEGER *let)
{
	INTEGER i = 0, cx = 0, cy = 0, cw = 0, ch = 0, dx = 0, x0 = 0;
	LONGINT pat = 0;
	BOOLEAN cond = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	x0 = x;
	cond = 1;
	while (s[__X(i, s__len)] != 0x00 && cond) {
		Display_GetChar(fnt->raster, s[__X(i, s__len)], &dx, &cx, &cy, &cw, &ch, &pat);
		if (x + dx < x0 + w) {
			x += dx;
			i += 1;
		} else {
			cond = 0;
		}
	}
	*ret = w - (x - x0);
	*let = i;
	__DEL(s);
}

void GraphicUtils_DrawString (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER mode, INTEGER align, INTEGER *ret)
{
	INTEGER i = 0, let = 0, cx = 0, cy = 0, cw = 0, ch = 0, dx = 0;
	BOOLEAN cond = 0;
	LONGINT pat = 0;
	INTEGER _for__11 = 0;
	__DUP(s, s__len, CHAR);
	if (f != NIL) {
		Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	}
	GraphicUtils_CheckString(s, s__len, x, y, w, fnt, &cx, &let);
	*ret = __ASHR(cx, 1);
	if (align == 0) {
		cx = 0;
	} else if (align == 1) {
		cx = __ASHR(cx, 1);
	}
	x += cx;
	_for__11 = let - 1;
	i = 0;
	while (i <= _for__11) {
		Display_GetChar(fnt->raster, s[__X(i, s__len)], &dx, &cx, &cy, &cw, &ch, &pat);
		Display_CopyPatternC(f, 15, pat, x + cx, y + cy, mode);
		x += dx;
		i += 1;
	}
	__DEL(s);
}

INTEGER GraphicUtils_GetStringLength (CHAR *s, LONGINT s__len, Fonts_Font fnt)
{
	INTEGER i = 0, x = 0, dx = 0, cx = 0, cy = 0, cw = 0, ch = 0;
	LONGINT pat = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	x = 0;
	while (s[__X(i, s__len)] != 0x00) {
		Display_GetChar(fnt->raster, s[__X(i, s__len)], &dx, &cx, &cy, &cw, &ch, &pat);
		x += dx;
		i += 1;
	}
	__DEL(s);
	return x;
}

static void GraphicUtils_CheckPString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER *ret, INTEGER *let)
{
	SHORTINT fno = 0;
	INTEGER i = 0, cx = 0, cy = 0, cw = 0, ch = 0, dx = 0, x0 = 0;
	LONGINT pat = 0, pdx = 0;
	BOOLEAN cond = 0;
	__DUP(s, s__len, CHAR);
	fno = TextPrinter_FontNo(fnt);
	i = 0;
	x0 = x;
	cond = 1;
	while (s[__X(i, s__len)] != 0x00 && cond) {
		TextPrinter_GetChar(fno, GraphicUtils_pUnit, s[__X(i, s__len)], &pdx, &dx, &cx, &cy, &cw, &ch, &pat);
		if (x + dx < x0 + w) {
			x += dx;
			i += 1;
		} else {
			cond = 0;
		}
	}
	*ret = w - (x - x0);
	*let = i;
	__DEL(s);
}

void GraphicUtils_PrintString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER align, INTEGER *ret)
{
	INTEGER i = 0, let = 0, cx = 0;
	CHAR mystr[62];
	INTEGER _for__19 = 0;
	__DUP(s, s__len, CHAR);
	GraphicUtils_CheckPString(s, s__len, x, y, w, fnt, &cx, &let);
	*ret = __ASHR(cx, 1);
	if (align == 0) {
		cx = 0;
	} else if (align == 1) {
		cx = __ASHR(cx, 1);
	}
	x += cx;
	_for__19 = let - 1;
	i = 0;
	while (i <= _for__19) {
		mystr[__X(i, 62)] = s[__X(i, s__len)];
		i += 1;
	}
	mystr[__X(let, 62)] = 0x00;
	Printer_String(x, y, (void*)mystr, 62, (void*)fnt->name, 32);
	__DEL(s);
}

void GraphicUtils_DrawBox (Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode)
{
	if (f != NIL) {
		Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	}
	if (w <= 4 || h <= 4) {
		Display_ReplConstC(f, 14, x, y, w, GraphicUtils_Min(h, 2), mode);
	} else {
		if (pressed) {
			Display_ReplConstC(f, 12, x, y, w, h, mode);
			Display_ReplConstC(f, 14, x, y + 2, w - 2, h - 2, mode);
			Display_ReplConstC(f, 13, x + 2, y + 2, w - 4, h - 4, mode);
			Display_DotC(f, 14, x, y + 1, mode);
			Display_DotC(f, 14, (x + w) - 2, (y + h) - 1, mode);
		} else {
			Display_ReplConstC(f, 14, x, y, w, h, mode);
			Display_ReplConstC(f, 12, x, y + 2, w - 2, h - 2, mode);
			Display_ReplConstC(f, 13, x + 2, y + 2, w - 4, h - 4, mode);
			Display_DotC(f, 12, x, y + 1, mode);
			Display_DotC(f, 12, (x + w) - 2, (y + h) - 1, mode);
		}
	}
}

void GraphicUtils_PrintBox (INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Printer_ReplConst(x, y, w, 2);
	Printer_ReplConst((x + w) - 2, y + 2, 2, h - 2);
	Printer_ReplConst(x, y + 2, 2, h - 2);
	Printer_ReplConst(x + 2, (y + h) - 2, w - 4, 2);
	Printer_Circle(x, y + 1, 0);
	Printer_Circle((x + w) - 2, (y + h) - 1, 0);
}

void GraphicUtils_DrawPatternBox (Display_Frame f, BOOLEAN pressed, LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER pX, INTEGER pY, INTEGER mode)
{
	INTEGER lowerCol = 0, upperCol = 0;
	if (f != NIL) {
		Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	}
	if (pressed) {
		lowerCol = 12;
		upperCol = 14;
		pX += 1;
		pY -= 1;
	} else {
		lowerCol = 14;
		upperCol = 12;
	}
	Display_ReplConstC(f, lowerCol, x, y, w, 2, mode);
	Display_ReplConstC(f, lowerCol, (x + w) - 2, y + 2, 2, h - 2, mode);
	Display_ReplConstC(f, upperCol, x, y + 2, 2, h - 2, mode);
	Display_ReplConstC(f, upperCol, x + 2, (y + h) - 2, w - 4, 2, mode);
	Display_DotC(f, upperCol, x, y + 1, mode);
	Display_DotC(f, upperCol, (x + w) - 2, (y + h) - 1, mode);
	Display_ReplConstC(f, 13, x + 2, y + 2, w - 4, h - 4, mode);
	if (pat != 0) {
		Display_CopyPatternC(f, 15, pat, x + pX, y + pY, mode);
	}
}

void GraphicUtils_PrintPatternBox (LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER pX, INTEGER pY)
{
	GraphicUtils_PrintBox(x, y, w, h);
}

void GraphicUtils_Set (Texts_Reader *r, LONGINT *r__typ, Texts_Text t, INTEGER *l)
{
	INTEGER i = 0;
	CHAR ch = 0;
	Texts_OpenReader(&*r, r__typ, t, 0);
	i = 0;
	while (i <= *l - 1 && !(*r).eot) {
		do {
			Texts_Read(&*r, r__typ, &ch);
		} while (!(ch == 0x0d || (*r).eot));
		i += 1;
	}
	*l = i;
}

static void GraphicUtils_DrawLine (Texts_Reader *r, LONGINT *r__typ, Display_Frame f, INTEGER x, INTEGER y, INTEGER w)
{
	Texts_Elem e = NIL;
	CHAR ch = 0;
	INTEGER dx = 0, x0 = 0, y0 = 0, w0 = 0, h = 0;
	LONGINT pat = 0;
	TextFrames_DisplayMsg m = {0};
	Texts_Read(&*r, r__typ, &ch);
	while ((w > 0 && !(*r).eot) && ch != 0x0d) {
		if ((*r).elem != NIL) {
			e = (*r).elem;
			m.prepare = 1;
			m.fnt = (*r).fnt;
			m.col = (*r).col;
			m.pos = Texts_Pos(&*r, r__typ) - 1;
			(*e->handle)(e, (void*)&m, TextFrames_DisplayMsg__typ);
			w -= (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
			if (w > 3) {
				m.prepare = 0;
				m.fnt = (*r).fnt;
				m.col = (*r).col;
				m.pos = Texts_Pos(&*r, r__typ) - 1;
				m.frame = f;
				m.X0 = x;
				m.Y0 = y;
				m.elemFrame = NIL;
				(*e->handle)(e, (void*)&m, TextFrames_DisplayMsg__typ);
				x += (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
			}
		} else {
			Display_GetChar((*r).fnt->raster, ch, &dx, &x0, &y0, &w0, &h, &pat);
			w -= dx;
			if (w > 3) {
				GraphicUtils_CopyPatternC(f, (*r).col, pat, x + x0, y + y0, 1);
				x += dx;
			}
		}
		Texts_Read(&*r, r__typ, &ch);
	}
	while (!(*r).eot && ch != 0x0d) {
		Texts_Read(&*r, r__typ, &ch);
	}
}

static void GraphicUtils_Flip (Display_Frame f, Texts_Text menu, INTEGER lsp, INTEGER dsc, INTEGER x, INTEGER y, INTEGER w, INTEGER h, BOOLEAN in, INTEGER sc, INTEGER cmd)
{
	Texts_Reader r = {0};
	INTEGER itemH = 0, x1 = 0, y1 = 0;
	if (f != NIL) {
		Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	}
	if (cmd >= 0) {
		GraphicUtils_Set(&r, Texts_Reader__typ, menu, &cmd);
	}
	if (cmd >= 0 && cmd >= sc) {
		y1 = (((y + h) - lsp * ((cmd - sc) + 1)) - dsc) - 2;
		y = (y1 + dsc) - 1;
		x1 = x + 5;
		itemH = lsp + 1;
		w -= 4;
		x += 2;
		if (in) {
			GraphicUtils_ReplConstC(f, 15, x, y, w, 1, 0);
			GraphicUtils_ReplConstC(f, 15, (x + w) - 1, y, 1, itemH - 1, 0);
			GraphicUtils_ReplConstC(f, 0, x, y + 1, 1, itemH - 1, 0);
			GraphicUtils_ReplConstC(f, 0, x, (y + itemH) - 1, w, 1, 0);
			GraphicUtils_ReplConstC(f, 12, x + 1, y + 1, w - 2, itemH - 2, 0);
		} else {
			GraphicUtils_ReplConstC(f, 13, x, y, w, itemH, 0);
		}
		GraphicUtils_DrawLine(&r, Texts_Reader__typ, f, x1, y1, w);
	}
}

static struct DrawMenu__6 {
	Texts_Text *menu;
	INTEGER *n, *lsp, *dsc;
	INTEGER *def, *wid;
	struct DrawMenu__6 *lnk;
} *DrawMenu__6_s;

static void MeasureMenu__7 (void);

static void MeasureMenu__7 (void)
{
	Texts_Reader r = {0};
	CHAR ch = 0, oldCh = 0;
	INTEGER wid0 = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	LONGINT p = 0;
	*DrawMenu__6_s->wid = 0;
	*DrawMenu__6_s->n = 1;
	*DrawMenu__6_s->lsp = 0;
	*DrawMenu__6_s->dsc = 0;
	wid0 = 0;
	oldCh = 0x00;
	*DrawMenu__6_s->def = -1;
	Texts_OpenReader(&r, Texts_Reader__typ, *DrawMenu__6_s->menu, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot) {
		if (ch == 0x0d) {
			*DrawMenu__6_s->wid = GraphicUtils_Max(*DrawMenu__6_s->wid, wid0);
			wid0 = 0;
			*DrawMenu__6_s->n += 1;
		} else if (r.elem != NIL) {
			*DrawMenu__6_s->lsp = GraphicUtils_Max(*DrawMenu__6_s->lsp, (int)__DIV(r.elem->H, (LONGINT)TextFrames_Unit));
			*DrawMenu__6_s->wid += (int)__DIV(r.elem->W, (LONGINT)TextFrames_Unit);
		} else {
			*DrawMenu__6_s->lsp = GraphicUtils_Max(*DrawMenu__6_s->lsp, r.fnt->height);
			*DrawMenu__6_s->dsc = GraphicUtils_Min(*DrawMenu__6_s->dsc, r.fnt->minY);
			Display_GetChar(r.fnt->raster, ch, &dx, &x, &y, &w, &h, &p);
			*DrawMenu__6_s->wid += dx;
		}
		oldCh = ch;
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (oldCh == 0x0d) {
		*DrawMenu__6_s->n -= 1;
	}
	*DrawMenu__6_s->wid = GraphicUtils_Max(*DrawMenu__6_s->wid, wid0);
	*DrawMenu__6_s->lsp += 1;
}

void GraphicUtils_DrawMenu (Display_Frame f, Texts_Text menu, INTEGER sc, INTEGER cmd, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode, INTEGER *n, INTEGER *lsp, INTEGER *dsc)
{
	INTEGER def = 0, wid = 0, x0 = 0, y0 = 0, i = 0;
	Texts_Reader r = {0};
	struct DrawMenu__6 _s;
	_s.menu = &menu;
	_s.n = n;
	_s.lsp = lsp;
	_s.dsc = dsc;
	_s.def = &def;
	_s.wid = &wid;
	_s.lnk = DrawMenu__6_s;
	DrawMenu__6_s = &_s;
	if (f != NIL) {
		Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	}
	MeasureMenu__7();
	y0 = y;
	x0 = x;
	GraphicUtils_ReplConstC(f, 15, x0, y0, w, h, mode);
	GraphicUtils_ReplConstC(f, 13, x0 + 1, y0 + 1, w - 2, h - 2, 0);
	GraphicUtils_Set(&r, Texts_Reader__typ, menu, &sc);
	y = (((y + h) - 2) - *lsp) - *dsc;
	x = x + 5;
	while (y + *dsc >= (y0 + 2) + 1 && !r.eot) {
		GraphicUtils_DrawLine(&r, Texts_Reader__typ, f, x, y, w);
		y -= *lsp;
		i += 1;
	}
	GraphicUtils_Flip(f, menu, *lsp, *dsc, x0, y0, w, h, 1, sc, cmd);
	DrawMenu__6_s = _s.lnk;
}

void GraphicUtils_TrackMenu (Display_Frame f, Texts_Text menu, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER n, INTEGER lsp, INTEGER dsc, INTEGER *sc, INTEGER *cmd)
{
	INTEGER bot = 0, top = 0, dif = 0, newCmd = 0, mx = 0, my = 0;
	SET keys = 0, keysum = 0;
	LONGINT i = 0;
	bot = y + 2;
	top = (y + h) - 2;
	*sc = GraphicUtils_Max(*sc, 0);
	dif = __DIV((h - 4) - 1, lsp);
	Input_Mouse(&keys, &mx, &my);
	keysum = 0x0;
	*cmd = GraphicUtils_Max(0, *cmd);
	while (keys != 0x0) {
		keysum = keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
		newCmd = __DIV(top - my, lsp) + *sc;
		if (keysum == 0x07 || *cmd == -1) {
			GraphicUtils_Flip(f, menu, lsp, dsc, x, y, w, h, 0, *sc, *cmd);
			*cmd = -1;
		} else if (((mx >= x && mx <= x + w) && newCmd >= *sc) && newCmd <= (*sc + dif) - 1) {
			if (newCmd != *cmd && newCmd < n) {
				GraphicUtils_Flip(f, menu, lsp, dsc, x, y, w, h, 0, *sc, *cmd);
				GraphicUtils_Flip(f, menu, lsp, dsc, x, y, w, h, 1, *sc, newCmd);
				*cmd = newCmd;
			}
		} else if (((mx >= x && mx <= x + w) && my > top) && *sc > 0) {
			*sc -= 1;
			*cmd -= 1;
			GraphicUtils_DrawMenu(f, menu, *sc, *cmd, x, y, w, h, 0, &n, &lsp, &dsc);
			i = Oberon_Time();
			while (Oberon_Time() - i < 150) {
			}
		} else if (((mx >= x && mx <= x + w) && my < top - dif) && *cmd < n - 1) {
			*sc += 1;
			*cmd += 1;
			GraphicUtils_DrawMenu(f, menu, *sc, *cmd, x, y, w, h, 0, &n, &lsp, &dsc);
			i = Oberon_Time();
			while (Oberon_Time() - i < 150) {
			}
		}
		Input_Mouse(&keys, &mx, &my);
	}
}


export void *GraphicUtils__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__REGMOD(GraphicUtils, 0);
/* BEGIN */
	GraphicUtils_dUnit = Display_Unit;
	GraphicUtils_pUnit = 3048;
	Display_SetColor(11, 230, 230, 230);
	Display_SetColor(12, 210, 210, 210);
	Display_SetColor(13, 150, 150, 150);
	Display_SetColor(14, 100, 100, 100);
	__ENDMOD;
}
