/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Modules.h"
#include "Oberon.h"
#include "Printer.h"
#include "Texts.h"

typedef
	struct Graphics_CaptionDesc *Graphics_Caption;

typedef
	struct Graphics_MethodDesc *Graphics_Method;

typedef
	struct Graphics_ObjectDesc *Graphics_Object;

typedef
	struct Graphics_ObjectDesc {
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		Graphics_Object next, dmy;
	} Graphics_ObjectDesc;

typedef
	struct Graphics_CaptionDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		Graphics_Object next, dmy;
		INTEGER pos, len;
	} Graphics_CaptionDesc;

typedef
	struct Graphics_Msg {
		char _prvt0[1];
	} Graphics_Msg;

typedef
	struct Graphics_ColorMsg { /* Graphics_Msg */
		INTEGER col;
	} Graphics_ColorMsg;

typedef
	struct Graphics_LibraryDesc *Graphics_Library;

typedef
	struct Graphics_Context {
		INTEGER nofonts, noflibs, nofclasses;
		Fonts_Font font[10];
		Graphics_Library lib[4];
		Modules_Command class[10];
	} Graphics_Context;

typedef
	struct Graphics_FontMsg { /* Graphics_Msg */
		Fonts_Font fnt;
	} Graphics_FontMsg;

typedef
	struct Graphics_GraphDesc *Graphics_Graph;

typedef
	struct Graphics_GraphDesc {
		LONGINT time;
		Graphics_Object sel, first;
	} Graphics_GraphDesc;

typedef
	CHAR Graphics_Name[16];

typedef
	struct Graphics_MacHeadDesc *Graphics_MacHead;

typedef
	struct Graphics_LibraryDesc {
		Graphics_Name name;
		Graphics_MacHead first;
		Graphics_Library next;
	} Graphics_LibraryDesc;

typedef
	struct Graphics_LineDesc *Graphics_Line;

typedef
	struct Graphics_LineDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		Graphics_Object next, dmy;
	} Graphics_LineDesc;

typedef
	struct Graphics_MacExtDesc *Graphics_MacExt;

typedef
	struct Graphics_MacExtDesc {
		char _prvt0[1];
	} Graphics_MacExtDesc;

typedef
	struct Graphics_MacHeadDesc {
		Graphics_Name name;
		INTEGER w, h;
		Graphics_MacExt ext;
		Graphics_Library lib;
		Graphics_Object first;
		Graphics_MacHead next;
	} Graphics_MacHeadDesc;

typedef
	struct Graphics_MacroDesc *Graphics_Macro;

typedef
	struct Graphics_MacroDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		Graphics_Object next, dmy;
		Graphics_MacHead mac;
	} Graphics_MacroDesc;

typedef
	struct Graphics_MethodDesc {
		Graphics_Name module, allocator;
		Modules_Command new;
		void (*copy)(Graphics_Object, Graphics_Object);
		void (*draw)(Graphics_Object, Graphics_Msg*, LONGINT *), (*handle)(Graphics_Object, Graphics_Msg*, LONGINT *);
		BOOLEAN (*selectable)(Graphics_Object, INTEGER, INTEGER);
		void (*read)(Graphics_Object, Files_Rider*, LONGINT *, Graphics_Context*, LONGINT *);
		void (*write)(Graphics_Object, SHORTINT, Files_Rider*, LONGINT *, Graphics_Context*, LONGINT *);
		void (*print)(Graphics_Object, INTEGER, INTEGER);
	} Graphics_MethodDesc;

typedef
	struct Graphics_WidMsg { /* Graphics_Msg */
		INTEGER w;
	} Graphics_WidMsg;


export Graphics_Object Graphics_new;
export INTEGER Graphics_width, Graphics_res;
export Texts_Text Graphics_T;
export Graphics_Method Graphics_LineMethod, Graphics_CapMethod, Graphics_MacMethod;
static Graphics_Library Graphics_FirstLib;
static Texts_Writer Graphics_W, Graphics_TW;

export LONGINT *Graphics_ObjectDesc__typ;
export LONGINT *Graphics_Msg__typ;
export LONGINT *Graphics_WidMsg__typ;
export LONGINT *Graphics_ColorMsg__typ;
export LONGINT *Graphics_FontMsg__typ;
export LONGINT *Graphics_GraphDesc__typ;
export LONGINT *Graphics_MacHeadDesc__typ;
export LONGINT *Graphics_LibraryDesc__typ;
export LONGINT *Graphics_MacExtDesc__typ;
export LONGINT *Graphics_Context__typ;
export LONGINT *Graphics_MethodDesc__typ;
export LONGINT *Graphics_LineDesc__typ;
export LONGINT *Graphics_CaptionDesc__typ;
export LONGINT *Graphics_MacroDesc__typ;

export void Graphics_Add (Graphics_Graph G, Graphics_Object obj);
static BOOLEAN Graphics_CaptionSelectable (Graphics_Object obj, INTEGER x, INTEGER y);
export void Graphics_Copy (Graphics_Graph Gs, Graphics_Graph Gd, INTEGER dx, INTEGER dy);
static void Graphics_CopyCaption (Graphics_Object src, Graphics_Object dst);
static void Graphics_CopyLine (Graphics_Object src, Graphics_Object dst);
static void Graphics_CopyMacro (Graphics_Object src, Graphics_Object dst);
export void Graphics_Delete (Graphics_Graph G);
export void Graphics_Deselect (Graphics_Graph G);
export void Graphics_Draw (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ);
export void Graphics_DrawMac (Graphics_MacHead mh, Graphics_Msg *M, LONGINT *M__typ);
export void Graphics_DrawSel (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ);
export void Graphics_Enumerate (Graphics_Graph G, void (*handle)(Graphics_Object, BOOLEAN*));
export Fonts_Font Graphics_Font (Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
export SHORTINT Graphics_FontNo (Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ, Fonts_Font fnt);
export void Graphics_Handle (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ);
static void Graphics_HandleCaption (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
static void Graphics_HandleLine (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
static void Graphics_HandleMacro (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
static void Graphics_InitContext (Graphics_Context *C, LONGINT *C__typ);
export void Graphics_InsertMac (Graphics_MacHead mh, Graphics_Library L, BOOLEAN *new);
static BOOLEAN Graphics_LineSelectable (Graphics_Object obj, INTEGER x, INTEGER y);
export void Graphics_Load (Graphics_Graph G, Files_Rider *R, LONGINT *R__typ);
static void Graphics_LoadElems (Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ, Graphics_Object *obj);
static BOOLEAN Graphics_MacroSelectable (Graphics_Object obj, INTEGER x, INTEGER y);
export Graphics_MacHead Graphics_MakeMac (Graphics_Graph G, INTEGER x, INTEGER y, INTEGER w, INTEGER h, CHAR *Mname, LONGINT Mname__len);
export void Graphics_Move (Graphics_Graph G, INTEGER dx, INTEGER dy);
static void Graphics_NewCaption (void);
export Graphics_Library Graphics_NewLib (CHAR *Lname, LONGINT Lname__len);
static void Graphics_NewLine (void);
static void Graphics_NewMacro (void);
static void Graphics_Notify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
export void Graphics_Open (Graphics_Graph G, CHAR *name, LONGINT name__len);
export void Graphics_OpenMac (Graphics_MacHead mh, Graphics_Graph G, INTEGER x, INTEGER y);
export void Graphics_Print (Graphics_Graph G, INTEGER x0, INTEGER y0);
static void Graphics_PrintCaption (Graphics_Object obj, INTEGER x, INTEGER y);
static void Graphics_PrintLine (Graphics_Object obj, INTEGER x, INTEGER y);
static void Graphics_PrintMacro (Graphics_Object obj, INTEGER x, INTEGER y);
static void Graphics_ReadCaption (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
static void Graphics_ReadLine (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
static void Graphics_ReadMacro (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
static void Graphics_ReadObj (Files_Rider *R, LONGINT *R__typ, Graphics_Object obj);
export void Graphics_RemoveLibraries (void);
export void Graphics_SelectArea (Graphics_Graph G, INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1);
export void Graphics_SelectObj (Graphics_Graph G, Graphics_Object obj);
export void Graphics_Store (Graphics_Graph G, Files_Rider *W, LONGINT *W__typ);
static void Graphics_StoreElems (Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ, Graphics_Object obj);
export void Graphics_StoreLib (Graphics_Library L, CHAR *Fname, LONGINT Fname__len);
export Modules_Command Graphics_ThisClass (CHAR *module, LONGINT module__len, CHAR *allocator, LONGINT allocator__len);
export Graphics_Library Graphics_ThisLib (CHAR *name, LONGINT name__len, BOOLEAN replace);
export Graphics_MacHead Graphics_ThisMac (Graphics_Library L, CHAR *Mname, LONGINT Mname__len);
export Graphics_Object Graphics_ThisObj (Graphics_Graph G, INTEGER x, INTEGER y);
static void Graphics_WMsg (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len);
static void Graphics_WriteCaption (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ);
export void Graphics_WriteFile (Graphics_Graph G, CHAR *name, LONGINT name__len);
static void Graphics_WriteLine (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ);
static void Graphics_WriteMacro (Graphics_Object obj, SHORTINT cno, Files_Rider *W1, LONGINT *W1__typ, Graphics_Context *C, LONGINT *C__typ);
export void Graphics_WriteObj (Files_Rider *W, LONGINT *W__typ, SHORTINT cno, Graphics_Object obj);


void Graphics_Add (Graphics_Graph G, Graphics_Object obj)
{
	obj->marked = 0;
	obj->selected = 1;
	obj->next = G->first;
	G->first = obj;
	G->sel = obj;
	G->time = Oberon_Time();
}

void Graphics_Draw (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ)
{
	Graphics_Object obj = NIL;
	obj = G->first;
	while (obj != NIL) {
		(*obj->do_->draw)(obj, &*M, M__typ);
		obj = obj->next;
	}
}

Graphics_Object Graphics_ThisObj (Graphics_Graph G, INTEGER x, INTEGER y)
{
	Graphics_Object obj = NIL;
	obj = G->first;
	while (obj != NIL && !(*obj->do_->selectable)(obj, x, y)) {
		obj = obj->next;
	}
	return obj;
}

void Graphics_SelectObj (Graphics_Graph G, Graphics_Object obj)
{
	if (obj != NIL) {
		obj->selected = 1;
		G->sel = obj;
		G->time = Oberon_Time();
	}
}

void Graphics_SelectArea (Graphics_Graph G, INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1)
{
	Graphics_Object obj = NIL;
	INTEGER t = 0;
	obj = G->first;
	if (x1 < x0) {
		t = x0;
		x0 = x1;
		x1 = t;
	}
	if (y1 < y0) {
		t = y0;
		y0 = y1;
		y1 = t;
	}
	while (obj != NIL) {
		if (((x0 <= obj->x && obj->x + obj->w <= x1) && y0 <= obj->y) && obj->y + obj->h <= y1) {
			obj->selected = 1;
			G->sel = obj;
		}
		obj = obj->next;
	}
	if (G->sel != NIL) {
		G->time = Oberon_Time();
	}
}

void Graphics_Enumerate (Graphics_Graph G, void (*handle)(Graphics_Object, BOOLEAN*))
{
	Graphics_Object obj = NIL;
	BOOLEAN done = 0;
	done = 0;
	obj = G->first;
	while (obj != NIL && !done) {
		(*handle)(obj, &done);
		obj = obj->next;
	}
}

void Graphics_Deselect (Graphics_Graph G)
{
	Graphics_Object obj = NIL;
	obj = G->first;
	G->sel = NIL;
	G->time = 0;
	while (obj != NIL) {
		obj->selected = 0;
		obj = obj->next;
	}
}

void Graphics_DrawSel (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ)
{
	Graphics_Object obj = NIL;
	obj = G->first;
	while (obj != NIL) {
		if (obj->selected) {
			(*obj->do_->draw)(obj, &*M, M__typ);
		}
		obj = obj->next;
	}
}

void Graphics_Handle (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ)
{
	Graphics_Object obj = NIL;
	obj = G->first;
	while (obj != NIL) {
		if (obj->selected) {
			(*obj->do_->handle)(obj, &*M, M__typ);
		}
		obj = obj->next;
	}
}

void Graphics_Move (Graphics_Graph G, INTEGER dx, INTEGER dy)
{
	Graphics_Object obj = NIL, ob0 = NIL;
	INTEGER x0 = 0, x1 = 0, y0 = 0, y1 = 0;
	obj = G->first;
	while (obj != NIL) {
		if (obj->selected && !__ISP(obj, Graphics_CaptionDesc, 1)) {
			x0 = obj->x;
			x1 = obj->w + x0;
			y0 = obj->y;
			y1 = obj->h + y0;
			if (dx == 0) {
				ob0 = G->first;
				while (ob0 != NIL) {
					if ((((!ob0->selected && __ISP(ob0, Graphics_LineDesc, 1)) && x0 <= ob0->x) && ob0->x <= x1) && ob0->w < ob0->h) {
						if (y0 <= ob0->y && ob0->y <= y1) {
							ob0->y += dy;
							ob0->h -= dy;
							ob0->marked = 1;
						} else if (y0 <= ob0->y + ob0->h && ob0->y + ob0->h <= y1) {
							ob0->h += dy;
							ob0->marked = 1;
						}
					}
					ob0 = ob0->next;
				}
			} else if (dy == 0) {
				ob0 = G->first;
				while (ob0 != NIL) {
					if ((((!ob0->selected && __ISP(ob0, Graphics_LineDesc, 1)) && y0 <= ob0->y) && ob0->y <= y1) && ob0->h < ob0->w) {
						if (x0 <= ob0->x && ob0->x <= x1) {
							ob0->x += dx;
							ob0->w -= dx;
							ob0->marked = 1;
						} else if (x0 <= ob0->x + ob0->w && ob0->x + ob0->w <= x1) {
							ob0->w += dx;
							ob0->marked = 1;
						}
					}
					ob0 = ob0->next;
				}
			}
		}
		obj = obj->next;
	}
	obj = G->first;
	while (obj != NIL) {
		if (obj->selected) {
			obj->x += dx;
			obj->y += dy;
		}
		obj->marked = 0;
		obj = obj->next;
	}
}

void Graphics_Copy (Graphics_Graph Gs, Graphics_Graph Gd, INTEGER dx, INTEGER dy)
{
	Graphics_Object obj = NIL;
	obj = Gs->first;
	while (obj != NIL) {
		if (obj->selected) {
			(*obj->do_->new)();
			(*obj->do_->copy)(obj, Graphics_new);
			Graphics_new->x += dx;
			Graphics_new->y += dy;
			obj->selected = 0;
			Graphics_Add(Gd, Graphics_new);
		}
		obj = obj->next;
	}
	Graphics_new = NIL;
}

void Graphics_Delete (Graphics_Graph G)
{
	Graphics_Object obj = NIL, pred = NIL;
	G->sel = NIL;
	obj = G->first;
	while (obj != NIL && obj->selected) {
		obj = obj->next;
	}
	G->first = obj;
	if (obj != NIL) {
		pred = obj;
		obj = obj->next;
		while (obj != NIL) {
			if (obj->selected) {
				pred->next = obj->next;
			} else {
				pred = obj;
			}
			obj = obj->next;
		}
	}
}

static void Graphics_WMsg (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len)
{
	__DUP(s0, s0__len, CHAR);
	__DUP(s1, s1__len, CHAR);
	Texts_WriteString(&Graphics_W, Texts_Writer__typ, s0, s0__len);
	Texts_WriteString(&Graphics_W, Texts_Writer__typ, s1, s1__len);
	Texts_WriteLn(&Graphics_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Graphics_W.buf);
	__DEL(s0);
	__DEL(s1);
}

static void Graphics_InitContext (Graphics_Context *C, LONGINT *C__typ)
{
	(*C).nofonts = 0;
	(*C).noflibs = 0;
	(*C).nofclasses = 4;
	(*C).class[1] = Graphics_LineMethod->new;
	(*C).class[2] = Graphics_CapMethod->new;
	(*C).class[3] = Graphics_MacMethod->new;
}

SHORTINT Graphics_FontNo (Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ, Fonts_Font fnt)
{
	SHORTINT fno = 0;
	fno = 0;
	while ((int)fno < (*C).nofonts && (*C).font[__X(fno, 10)] != fnt) {
		fno += 1;
	}
	if ((int)fno == (*C).nofonts) {
		Files_Write(&*W, W__typ, 0);
		Files_Write(&*W, W__typ, 0);
		Files_Write(&*W, W__typ, fno);
		Files_WriteString(&*W, W__typ, fnt->name, 32);
		(*C).font[__X(fno, 10)] = fnt;
		(*C).nofonts += 1;
	}
	return fno;
}

static void Graphics_StoreElems (Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ, Graphics_Object obj)
{
	INTEGER cno = 0;
	while (obj != NIL) {
		cno = 1;
		while (cno < (*C).nofclasses && obj->do_->new != (*C).class[__X(cno, 10)]) {
			cno += 1;
		}
		if (cno == (*C).nofclasses) {
			Files_Write(&*W, W__typ, 0);
			Files_Write(&*W, W__typ, 2);
			Files_Write(&*W, W__typ, (int)cno);
			Files_WriteString(&*W, W__typ, obj->do_->module, 16);
			Files_WriteString(&*W, W__typ, obj->do_->allocator, 16);
			(*C).class[__X(cno, 10)] = obj->do_->new;
			(*C).nofclasses += 1;
		}
		(*obj->do_->write)(obj, (int)cno, &*W, W__typ, &*C, C__typ);
		obj = obj->next;
	}
	Files_Write(&*W, W__typ, -1);
}

void Graphics_Store (Graphics_Graph G, Files_Rider *W, LONGINT *W__typ)
{
	Graphics_Context C = {0};
	Graphics_InitContext(&C, Graphics_Context__typ);
	Graphics_StoreElems(&*W, W__typ, &C, Graphics_Context__typ, G->first);
}

void Graphics_WriteObj (Files_Rider *W, LONGINT *W__typ, SHORTINT cno, Graphics_Object obj)
{
	Files_Write(&*W, W__typ, cno);
	Files_WriteInt(&*W, W__typ, obj->x);
	Files_WriteInt(&*W, W__typ, obj->y);
	Files_WriteInt(&*W, W__typ, obj->w);
	Files_WriteInt(&*W, W__typ, obj->h);
	Files_WriteInt(&*W, W__typ, obj->col);
}

void Graphics_WriteFile (Graphics_Graph G, CHAR *name, LONGINT name__len)
{
	Files_File F = NIL;
	Files_Rider W = {0};
	Graphics_Context C = {0};
	__DUP(name, name__len, CHAR);
	F = Files_New(name, name__len);
	Files_Set(&W, Files_Rider__typ, F, 0);
	Files_Write(&W, Files_Rider__typ, 0xf9);
	Graphics_InitContext(&C, Graphics_Context__typ);
	Graphics_StoreElems(&W, Files_Rider__typ, &C, Graphics_Context__typ, G->first);
	Files_Register(F);
	__DEL(name);
}

void Graphics_Print (Graphics_Graph G, INTEGER x0, INTEGER y0)
{
	Graphics_Object obj = NIL;
	obj = G->first;
	while (obj != NIL) {
		(*obj->do_->print)(obj, x0, y0);
		obj = obj->next;
	}
}

Modules_Command Graphics_ThisClass (CHAR *module, LONGINT module__len, CHAR *allocator, LONGINT allocator__len)
{
	Modules_Module mod = NIL;
	Modules_Command com = NIL;
	mod = Modules_ThisMod(module, module__len);
	if (mod != NIL) {
		com = Modules_ThisCommand(mod, allocator, allocator__len);
		if (com == NIL) {
			Graphics_WMsg(allocator, allocator__len, (CHAR*)" unknown", (LONGINT)9);
		}
	} else {
		Graphics_WMsg(module, module__len, (CHAR*)" not available", (LONGINT)15);
		com = NIL;
	}
	return com;
}

Fonts_Font Graphics_Font (Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
	SHORTINT fno = 0;
	Files_Read(&*R, R__typ, (void*)&fno);
	return (*C).font[__X(fno, 10)];
}

static void Graphics_ReadObj (Files_Rider *R, LONGINT *R__typ, Graphics_Object obj)
{
	Files_ReadInt(&*R, R__typ, &obj->x);
	Files_ReadInt(&*R, R__typ, &obj->y);
	Files_ReadInt(&*R, R__typ, &obj->w);
	Files_ReadInt(&*R, R__typ, &obj->h);
	Files_ReadInt(&*R, R__typ, &obj->col);
}

static void Graphics_LoadElems (Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ, Graphics_Object *obj)
{
	SHORTINT cno = 0, k = 0;
	INTEGER len = 0;
	CHAR name[32], name1[32];
	*obj = NIL;
	Files_Read(&*R, R__typ, (void*)&cno);
	while (!(*R).eof && cno >= 0) {
		if (cno == 0) {
			Files_Read(&*R, R__typ, (void*)&cno);
			Files_Read(&*R, R__typ, (void*)&k);
			Files_ReadString(&*R, R__typ, (void*)name, 32);
			if (cno == 0) {
				(*C).font[__X(k, 10)] = Fonts_This(name, 32);
			} else if (cno == 1) {
				(*C).lib[__X(k, 4)] = Graphics_ThisLib((void*)name, 32, 0);
			} else {
				Files_ReadString(&*R, R__typ, (void*)name1, 32);
				(*C).class[__X(k, 10)] = Graphics_ThisClass((void*)name, 32, (void*)name1, 32);
			}
		} else if ((*C).class[__X(cno, 10)] != NIL) {
			(*(*C).class[__X(cno, 10)])();
			Graphics_ReadObj(&*R, R__typ, Graphics_new);
			Graphics_new->selected = 0;
			Graphics_new->marked = 0;
			Graphics_new->next = *obj;
			*obj = Graphics_new;
			(*Graphics_new->do_->read)(Graphics_new, &*R, R__typ, &*C, C__typ);
		} else {
			Files_Set(&*R, R__typ, Files_Base(&*R, R__typ), Files_Pos(&*R, R__typ) + 10);
			Files_ReadInt(&*R, R__typ, &len);
			Files_Set(&*R, R__typ, Files_Base(&*R, R__typ), Files_Pos(&*R, R__typ) + (LONGINT)len);
		}
		Files_Read(&*R, R__typ, (void*)&cno);
	}
	Graphics_new = NIL;
}

void Graphics_Load (Graphics_Graph G, Files_Rider *R, LONGINT *R__typ)
{
	Graphics_Context C = {0};
	G->sel = NIL;
	Graphics_InitContext(&C, Graphics_Context__typ);
	Graphics_LoadElems(&*R, R__typ, &C, Graphics_Context__typ, &G->first);
}

void Graphics_Open (Graphics_Graph G, CHAR *name, LONGINT name__len)
{
	CHAR tag = 0;
	Files_File F = NIL;
	Files_Rider R = {0};
	Graphics_Context C = {0};
	__DUP(name, name__len, CHAR);
	G->first = NIL;
	G->sel = NIL;
	G->time = 0;
	F = Files_Old(name, name__len);
	if (F != NIL) {
		Files_Set(&R, Files_Rider__typ, F, 0);
		Files_Read(&R, Files_Rider__typ, (void*)&tag);
		if (tag == 0xf9) {
			Graphics_InitContext(&C, Graphics_Context__typ);
			Graphics_LoadElems(&R, Files_Rider__typ, &C, Graphics_Context__typ, &G->first);
			Graphics_res = 0;
		} else {
			Graphics_res = 1;
		}
	} else {
		Graphics_res = 2;
	}
	__DEL(name);
}

Graphics_Library Graphics_ThisLib (CHAR *name, LONGINT name__len, BOOLEAN replace)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	Graphics_Library L = NIL;
	Graphics_MacHead mh = NIL;
	Graphics_Object obj = NIL;
	Files_File F = NIL;
	Files_Rider R = {0};
	Graphics_Context C = {0};
	CHAR Lname[32], Fname[32];
	L = Graphics_FirstLib;
	i = 0;
	while (name[__X(i, name__len)] >= '0') {
		Lname[__X(i, 32)] = name[__X(i, name__len)];
		i += 1;
	}
	Lname[__X(i, 32)] = 0x00;
	while (L != NIL && __STRCMP(L->name, Lname) != 0) {
		L = L->next;
	}
	if (L == NIL || replace) {
		j = 0;
		while (name[__X(j, name__len)] > 0x00) {
			Fname[__X(j, 32)] = name[__X(j, name__len)];
			j += 1;
		}
		if (i == j) {
			Fname[__X(j, 32)] = '.';
			Fname[__X(j + 1, 32)] = 'L';
			Fname[__X(j + 2, 32)] = 'i';
			Fname[__X(j + 3, 32)] = 'b';
			j += 4;
		}
		Fname[__X(j, 32)] = 0x00;
		F = Files_Old(Fname, 32);
		if (F != NIL) {
			Graphics_WMsg((CHAR*)"loading ", (LONGINT)9, name, name__len);
			Files_Set(&R, Files_Rider__typ, F, 0);
			Files_Read(&R, Files_Rider__typ, (void*)&ch);
			if (ch == 0xfd) {
				if (L == NIL) {
					__NEW(L, Graphics_LibraryDesc);
					__COPY(Lname, L->name, 16);
					L->next = Graphics_FirstLib;
					Graphics_FirstLib = L;
				}
				L->first = NIL;
				Graphics_InitContext(&C, Graphics_Context__typ);
				Graphics_LoadElems(&R, Files_Rider__typ, &C, Graphics_Context__typ, &obj);
				while (obj != NIL) {
					__NEW(mh, Graphics_MacHeadDesc);
					mh->first = obj;
					Files_ReadInt(&R, Files_Rider__typ, &mh->w);
					Files_ReadInt(&R, Files_Rider__typ, &mh->h);
					Files_ReadString(&R, Files_Rider__typ, (void*)mh->name, 16);
					mh->lib = L;
					mh->next = L->first;
					L->first = mh;
					Graphics_LoadElems(&R, Files_Rider__typ, &C, Graphics_Context__typ, &obj);
				}
			} else {
				L = NIL;
				Graphics_WMsg(name, name__len, (CHAR*)" bad library", (LONGINT)13);
			}
		} else {
			Graphics_WMsg(name, name__len, (CHAR*)" not found", (LONGINT)11);
		}
	}
	return L;
}

Graphics_Library Graphics_NewLib (CHAR *Lname, LONGINT Lname__len)
{
	Graphics_Library L = NIL;
	__NEW(L, Graphics_LibraryDesc);
	__COPY(Lname, L->name, 16);
	L->first = NIL;
	L->next = Graphics_FirstLib;
	Graphics_FirstLib = L;
	return L;
}

void Graphics_StoreLib (Graphics_Library L, CHAR *Fname, LONGINT Fname__len)
{
	Graphics_MacHead mh = NIL;
	Files_File F = NIL;
	Files_Rider W = {0};
	Graphics_Context C = {0};
	F = Files_New(Fname, Fname__len);
	Files_Set(&W, Files_Rider__typ, F, 0);
	Files_Write(&W, Files_Rider__typ, 0xfd);
	Graphics_InitContext(&C, Graphics_Context__typ);
	mh = L->first;
	while (mh != NIL) {
		Graphics_StoreElems(&W, Files_Rider__typ, &C, Graphics_Context__typ, mh->first);
		Files_WriteInt(&W, Files_Rider__typ, mh->w);
		Files_WriteInt(&W, Files_Rider__typ, mh->h);
		Files_WriteString(&W, Files_Rider__typ, mh->name, 16);
		mh = mh->next;
	}
	Files_Register(F);
}

void Graphics_RemoveLibraries (void)
{
	Graphics_FirstLib = NIL;
}

Graphics_MacHead Graphics_ThisMac (Graphics_Library L, CHAR *Mname, LONGINT Mname__len)
{
	Graphics_MacHead mh = NIL;
	mh = L->first;
	while (mh != NIL && __STRCMP(mh->name, Mname) != 0) {
		mh = mh->next;
	}
	return mh;
}

void Graphics_OpenMac (Graphics_MacHead mh, Graphics_Graph G, INTEGER x, INTEGER y)
{
	Graphics_Object obj = NIL;
	obj = mh->first;
	while (obj != NIL) {
		(*obj->do_->new)();
		(*obj->do_->copy)(obj, Graphics_new);
		Graphics_new->x += x;
		Graphics_new->y += y;
		Graphics_new->selected = 1;
		Graphics_Add(G, Graphics_new);
		obj = obj->next;
	}
	Graphics_new = NIL;
}

void Graphics_DrawMac (Graphics_MacHead mh, Graphics_Msg *M, LONGINT *M__typ)
{
	Graphics_Object elem = NIL;
	elem = mh->first;
	while (elem != NIL) {
		(*elem->do_->draw)(elem, &*M, M__typ);
		elem = elem->next;
	}
}

Graphics_MacHead Graphics_MakeMac (Graphics_Graph G, INTEGER x, INTEGER y, INTEGER w, INTEGER h, CHAR *Mname, LONGINT Mname__len)
{
	Graphics_Object obj = NIL, last = NIL;
	Graphics_MacHead mh = NIL;
	obj = G->first;
	last = NIL;
	while (obj != NIL) {
		if (obj->selected) {
			(*obj->do_->new)();
			(*obj->do_->copy)(obj, Graphics_new);
			Graphics_new->next = last;
			Graphics_new->selected = 0;
			Graphics_new->x -= x;
			Graphics_new->y -= y;
			last = Graphics_new;
		}
		obj = obj->next;
	}
	__NEW(mh, Graphics_MacHeadDesc);
	mh->w = w;
	mh->h = h;
	mh->first = last;
	mh->ext = NIL;
	__COPY(Mname, mh->name, 16);
	Graphics_new = NIL;
	return mh;
}

void Graphics_InsertMac (Graphics_MacHead mh, Graphics_Library L, BOOLEAN *new)
{
	Graphics_MacHead mh1 = NIL;
	mh->lib = L;
	mh1 = L->first;
	while (mh1 != NIL && __STRCMP(mh1->name, mh->name) != 0) {
		mh1 = mh1->next;
	}
	if (mh1 == NIL) {
		*new = 1;
		mh->next = L->first;
		L->first = mh;
	} else {
		*new = 0;
		mh1->w = mh->w;
		mh1->h = mh->h;
		mh1->first = mh->first;
	}
}

static void Graphics_NewLine (void)
{
	Graphics_Line line = NIL;
	__NEW(line, Graphics_LineDesc);
	Graphics_new = (Graphics_Object)line;
	line->do_ = Graphics_LineMethod;
}

static void Graphics_CopyLine (Graphics_Object src, Graphics_Object dst)
{
	dst->x = src->x;
	dst->y = src->y;
	dst->w = src->w;
	dst->h = src->h;
	dst->col = src->col;
}

static void Graphics_HandleLine (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	if (__IS(M__typ, Graphics_WidMsg, 1)) {
		if (obj->w < obj->h) {
			if (obj->w <= 7) {
				obj->w = __GUARDR(M, Graphics_WidMsg, 1).w;
			}
		} else if (obj->h <= 7) {
			obj->h = __GUARDR(M, Graphics_WidMsg, 1).w;
		}
	} else if (__IS(M__typ, Graphics_ColorMsg, 1)) {
		obj->col = __GUARDR(M, Graphics_ColorMsg, 1).col;
	}
}

static BOOLEAN Graphics_LineSelectable (Graphics_Object obj, INTEGER x, INTEGER y)
{
	return ((obj->x <= x && x < obj->x + obj->w) && obj->y <= y) && y < obj->y + obj->h;
}

static void Graphics_ReadLine (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
}

static void Graphics_WriteLine (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ)
{
	Graphics_WriteObj(&*W, W__typ, cno, obj);
}

static void Graphics_PrintLine (Graphics_Object obj, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0;
	w = __ASHL(obj->w, 1);
	h = __ASHL(obj->h, 1);
	if (w < h) {
		h = __ASHL(h, 1);
	} else {
		w = __ASHL(w, 1);
	}
	Printer_ReplConst(__ASHL(obj->x, 2) + x, __ASHL(obj->y, 2) + y, w, h);
}

static void Graphics_NewCaption (void)
{
	Graphics_Caption cap = NIL;
	__NEW(cap, Graphics_CaptionDesc);
	Graphics_new = (Graphics_Object)cap;
	cap->do_ = Graphics_CapMethod;
}

static void Graphics_CopyCaption (Graphics_Object src, Graphics_Object dst)
{
	CHAR ch = 0;
	Texts_Reader R = {0};
	if (__ISP(src, Graphics_CaptionDesc, 1)) {
		if (__ISP(dst, Graphics_CaptionDesc, 1)) {
			(*(Graphics_Caption*)&dst)->x = (*(Graphics_Caption*)&src)->x;
			(*(Graphics_Caption*)&dst)->y = (*(Graphics_Caption*)&src)->y;
			(*(Graphics_Caption*)&dst)->w = (*(Graphics_Caption*)&src)->w;
			(*(Graphics_Caption*)&dst)->h = (*(Graphics_Caption*)&src)->h;
			(*(Graphics_Caption*)&dst)->col = (*(Graphics_Caption*)&src)->col;
			(*(Graphics_Caption*)&dst)->pos = (int)(Graphics_T->len + 1);
			(*(Graphics_Caption*)&dst)->len = (*(Graphics_Caption*)&src)->len;
			Texts_Write(&Graphics_TW, Texts_Writer__typ, 0x0d);
			Texts_OpenReader(&R, Texts_Reader__typ, Graphics_T, (*(Graphics_Caption*)&src)->pos);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			Graphics_TW.fnt = R.fnt;
			while (ch > 0x0d) {
				Texts_Write(&Graphics_TW, Texts_Writer__typ, ch);
				Texts_Read(&R, Texts_Reader__typ, &ch);
			}
		} else __WITHCHK;
	} else __WITHCHK;
	Texts_Append(Graphics_T, Graphics_TW.buf);
}

static void Graphics_HandleCaption (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	INTEGER dx = 0, x1 = 0, dy = 0, y1 = 0, w = 0, w1 = 0, h1 = 0, len = 0;
	LONGINT pos = 0;
	CHAR ch = 0;
	LONGINT pat = 0;
	Fonts_Font fnt = NIL;
	Texts_Reader R = {0};
	if (__IS(M__typ, Graphics_FontMsg, 1)) {
		fnt = __GUARDR(M, Graphics_FontMsg, 1).fnt;
		w = 0;
		len = 0;
		pos = __GUARDP(obj, Graphics_CaptionDesc, 1)->pos;
		Texts_OpenReader(&R, Texts_Reader__typ, Graphics_T, pos);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		dy = R.fnt->minY;
		while (ch > 0x0d) {
			Display_GetChar(fnt->raster, ch, &dx, &x1, &y1, &w1, &h1, &pat);
			w += dx;
			len += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		obj->y += fnt->minY - dy;
		obj->w = w;
		obj->h = fnt->height;
		Texts_ChangeLooks(Graphics_T, pos, pos + (LONGINT)len, 0x01, fnt, 0, 0);
	} else if (__IS(M__typ, Graphics_ColorMsg, 1)) {
		obj->col = __GUARDR(M, Graphics_ColorMsg, 1).col;
	}
}

static BOOLEAN Graphics_CaptionSelectable (Graphics_Object obj, INTEGER x, INTEGER y)
{
	return ((obj->x <= x && x < obj->x + obj->w) && obj->y <= y) && y < obj->y + obj->h;
}

static void Graphics_ReadCaption (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
	CHAR ch = 0;
	SHORTINT fno = 0;
	INTEGER len = 0;
	__GUARDP(obj, Graphics_CaptionDesc, 1)->pos = (int)(Graphics_T->len + 1);
	Texts_Write(&Graphics_TW, Texts_Writer__typ, 0x0d);
	Files_Read(&*R, R__typ, (void*)&fno);
	Graphics_TW.fnt = (*C).font[__X(fno, 10)];
	len = 0;
	Files_Read(&*R, R__typ, (void*)&ch);
	while (ch > 0x0d) {
		Texts_Write(&Graphics_TW, Texts_Writer__typ, ch);
		len += 1;
		Files_Read(&*R, R__typ, (void*)&ch);
	}
	__GUARDP(obj, Graphics_CaptionDesc, 1)->len = len;
	Texts_Append(Graphics_T, Graphics_TW.buf);
}

static void Graphics_WriteCaption (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ)
{
	CHAR ch = 0;
	SHORTINT fno = 0;
	Texts_Reader TR = {0};
	if (__GUARDP(obj, Graphics_CaptionDesc, 1)->len > 0) {
		Texts_OpenReader(&TR, Texts_Reader__typ, Graphics_T, __GUARDP(obj, Graphics_CaptionDesc, 1)->pos);
		Texts_Read(&TR, Texts_Reader__typ, &ch);
		fno = Graphics_FontNo(&*W, W__typ, &*C, C__typ, TR.fnt);
		Graphics_WriteObj(&*W, W__typ, cno, obj);
		Files_Write(&*W, W__typ, fno);
		while (ch > 0x0d) {
			Files_Write(&*W, W__typ, ch);
			Texts_Read(&TR, Texts_Reader__typ, &ch);
		}
		Files_Write(&*W, W__typ, 0x00);
	}
}

static void Graphics_PrintCaption (Graphics_Object obj, INTEGER x, INTEGER y)
{
	Fonts_Font fnt = NIL;
	INTEGER i = 0;
	CHAR ch = 0;
	Texts_Reader R = {0};
	CHAR s[128];
	if (__GUARDP(obj, Graphics_CaptionDesc, 1)->len > 0) {
		Texts_OpenReader(&R, Texts_Reader__typ, Graphics_T, __GUARDP(obj, Graphics_CaptionDesc, 1)->pos);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		fnt = R.fnt;
		y -= __ASHL(fnt->minY, 2);
		i = 0;
		while (ch >= ' ') {
			s[__X(i, 128)] = ch;
			i += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		s[__X(i, 128)] = 0x00;
		if (i > 0) {
			Printer_String(__ASHL(obj->x, 2) + x, __ASHL(obj->y, 2) + y, (void*)s, 128, (void*)fnt->name, 32);
		}
	}
}

static void Graphics_NewMacro (void)
{
	Graphics_Macro mac = NIL;
	__NEW(mac, Graphics_MacroDesc);
	Graphics_new = (Graphics_Object)mac;
	mac->do_ = Graphics_MacMethod;
}

static void Graphics_CopyMacro (Graphics_Object src, Graphics_Object dst)
{
	dst->x = src->x;
	dst->y = src->y;
	dst->w = src->w;
	dst->h = src->h;
	dst->col = src->col;
	__GUARDP(dst, Graphics_MacroDesc, 1)->mac = __GUARDP(src, Graphics_MacroDesc, 1)->mac;
}

static void Graphics_HandleMacro (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	if (__IS(M__typ, Graphics_ColorMsg, 1)) {
		obj->col = __GUARDR(M, Graphics_ColorMsg, 1).col;
	}
}

static BOOLEAN Graphics_MacroSelectable (Graphics_Object obj, INTEGER x, INTEGER y)
{
	return ((obj->x <= x && x <= obj->x + 8) && obj->y <= y) && y <= obj->y + 8;
}

static void Graphics_ReadMacro (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
	SHORTINT lno = 0;
	CHAR name[32];
	Files_Read(&*R, R__typ, (void*)&lno);
	Files_ReadString(&*R, R__typ, (void*)name, 32);
	__GUARDP(obj, Graphics_MacroDesc, 1)->mac = Graphics_ThisMac((*C).lib[__X(lno, 4)], (void*)name, 32);
}

static void Graphics_WriteMacro (Graphics_Object obj, SHORTINT cno, Files_Rider *W1, LONGINT *W1__typ, Graphics_Context *C, LONGINT *C__typ)
{
	SHORTINT lno = 0;
	lno = 0;
	if (__ISP(obj, Graphics_MacroDesc, 1)) {
		while ((int)lno < (*C).noflibs && (*(Graphics_Macro*)&obj)->mac->lib != (*C).lib[__X(lno, 4)]) {
			lno += 1;
		}
		if ((int)lno == (*C).noflibs) {
			Files_Write(&*W1, W1__typ, 0);
			Files_Write(&*W1, W1__typ, 1);
			Files_Write(&*W1, W1__typ, lno);
			Files_WriteString(&*W1, W1__typ, (*(Graphics_Macro*)&obj)->mac->lib->name, 16);
			(*C).lib[__X(lno, 4)] = (*(Graphics_Macro*)&obj)->mac->lib;
			(*C).noflibs += 1;
		}
		Graphics_WriteObj(&*W1, W1__typ, cno, (void*)(*(Graphics_Macro*)&obj));
		Files_Write(&*W1, W1__typ, lno);
		Files_WriteString(&*W1, W1__typ, (*(Graphics_Macro*)&obj)->mac->name, 16);
	} else __WITHCHK;
}

static void Graphics_PrintMacro (Graphics_Object obj, INTEGER x, INTEGER y)
{
	Graphics_Object elem = NIL;
	Graphics_MacHead mh = NIL;
	mh = __GUARDP(obj, Graphics_MacroDesc, 1)->mac;
	if (mh != NIL) {
		elem = mh->first;
		while (elem != NIL) {
			(*elem->do_->print)(elem, __ASHL(obj->x, 2) + x, __ASHL(obj->y, 2) + y);
			elem = elem->next;
		}
	}
}

static void Graphics_Notify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void EnumPtrs(void (*P)(void*))
{
	P(Graphics_new);
	P(Graphics_T);
	P(Graphics_LineMethod);
	P(Graphics_CapMethod);
	P(Graphics_MacMethod);
	P(Graphics_FirstLib);
	__ENUMR(&Graphics_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&Graphics_TW, Texts_Writer__typ, 36, 1, P);
}

__TDESC(Graphics_ObjectDesc, 1, 3) = {__TDFLDS("ObjectDesc", 24), {12, 16, 20, -16}};
__TDESC(Graphics_Msg, 1, 0) = {__TDFLDS("Msg", 1), {-4}};
__TDESC(Graphics_WidMsg, 1, 0) = {__TDFLDS("WidMsg", 2), {-4}};
__TDESC(Graphics_ColorMsg, 1, 0) = {__TDFLDS("ColorMsg", 2), {-4}};
__TDESC(Graphics_FontMsg, 1, 1) = {__TDFLDS("FontMsg", 4), {0, -8}};
__TDESC(Graphics_GraphDesc, 1, 2) = {__TDFLDS("GraphDesc", 12), {4, 8, -12}};
__TDESC(Graphics_MacHeadDesc, 1, 4) = {__TDFLDS("MacHeadDesc", 36), {20, 24, 28, 32, -20}};
__TDESC(Graphics_LibraryDesc, 1, 2) = {__TDFLDS("LibraryDesc", 24), {16, 20, -12}};
__TDESC(Graphics_MacExtDesc, 1, 0) = {__TDFLDS("MacExtDesc", 1), {-4}};
__TDESC(Graphics_Context, 1, 14) = {__TDFLDS("Context", 104), {8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, -60}};
__TDESC(Graphics_MethodDesc, 1, 0) = {__TDFLDS("MethodDesc", 64), {-4}};
__TDESC(Graphics_LineDesc, 1, 3) = {__TDFLDS("LineDesc", 24), {12, 16, 20, -16}};
__TDESC(Graphics_CaptionDesc, 1, 3) = {__TDFLDS("CaptionDesc", 28), {12, 16, 20, -16}};
__TDESC(Graphics_MacroDesc, 1, 4) = {__TDFLDS("MacroDesc", 28), {12, 16, 20, 24, -20}};

export void *Graphics__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(Texts);
	__REGMOD(Graphics, EnumPtrs);
	__REGCMD("RemoveLibraries", Graphics_RemoveLibraries);
	__INITYP(Graphics_ObjectDesc, Graphics_ObjectDesc, 0);
	__INITYP(Graphics_Msg, Graphics_Msg, 0);
	__INITYP(Graphics_WidMsg, Graphics_Msg, 1);
	__INITYP(Graphics_ColorMsg, Graphics_Msg, 1);
	__INITYP(Graphics_FontMsg, Graphics_Msg, 1);
	__INITYP(Graphics_GraphDesc, Graphics_GraphDesc, 0);
	__INITYP(Graphics_MacHeadDesc, Graphics_MacHeadDesc, 0);
	__INITYP(Graphics_LibraryDesc, Graphics_LibraryDesc, 0);
	__INITYP(Graphics_MacExtDesc, Graphics_MacExtDesc, 0);
	__INITYP(Graphics_Context, Graphics_Context, 0);
	__INITYP(Graphics_MethodDesc, Graphics_MethodDesc, 0);
	__INITYP(Graphics_LineDesc, Graphics_ObjectDesc, 1);
	__INITYP(Graphics_CaptionDesc, Graphics_ObjectDesc, 1);
	__INITYP(Graphics_MacroDesc, Graphics_ObjectDesc, 1);
/* BEGIN */
	Texts_OpenWriter(&Graphics_W, Texts_Writer__typ);
	Texts_OpenWriter(&Graphics_TW, Texts_Writer__typ);
	Graphics_width = 1;
	__NEW(Graphics_T, Texts_TextDesc);
	Texts_Open(Graphics_T, (CHAR*)"", (LONGINT)1);
	Graphics_T->notify = Graphics_Notify;
	__NEW(Graphics_LineMethod, Graphics_MethodDesc);
	Graphics_LineMethod->new = Graphics_NewLine;
	Graphics_LineMethod->copy = Graphics_CopyLine;
	Graphics_LineMethod->selectable = Graphics_LineSelectable;
	Graphics_LineMethod->handle = Graphics_HandleLine;
	Graphics_LineMethod->read = Graphics_ReadLine;
	Graphics_LineMethod->write = Graphics_WriteLine;
	Graphics_LineMethod->print = Graphics_PrintLine;
	__NEW(Graphics_CapMethod, Graphics_MethodDesc);
	Graphics_CapMethod->new = Graphics_NewCaption;
	Graphics_CapMethod->copy = Graphics_CopyCaption;
	Graphics_CapMethod->selectable = Graphics_CaptionSelectable;
	Graphics_CapMethod->handle = Graphics_HandleCaption;
	Graphics_CapMethod->read = Graphics_ReadCaption;
	Graphics_CapMethod->write = Graphics_WriteCaption;
	Graphics_CapMethod->print = Graphics_PrintCaption;
	__NEW(Graphics_MacMethod, Graphics_MethodDesc);
	Graphics_MacMethod->new = Graphics_NewMacro;
	Graphics_MacMethod->copy = Graphics_CopyMacro;
	Graphics_MacMethod->selectable = Graphics_MacroSelectable;
	Graphics_MacMethod->handle = Graphics_HandleMacro;
	Graphics_MacMethod->read = Graphics_ReadMacro;
	Graphics_MacMethod->write = Graphics_WriteMacro;
	Graphics_MacMethod->print = Graphics_PrintMacro;
	__ENDMOD;
}
