/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"


export BOOLEAN In_Done;
static Texts_Scanner In_s;
static Texts_Text In_text;
static LONGINT In_startpos;


export void In_Char (CHAR *ch);
export void In_Int (INTEGER *n);
export void In_LongInt (LONGINT *n);
export void In_LongReal (LONGREAL *r);
export void In_Name (CHAR *name, LONGINT name__len);
export INTEGER In_Next (void);
export void In_Open (void);
export void In_OpenText (Texts_Text t, LONGINT pos);
export void In_Real (REAL *r);
export void In_String (CHAR *string, LONGINT string__len);


void In_OpenText (Texts_Text t, LONGINT pos)
{
	In_text = t;
	Texts_OpenScanner(&In_s, Texts_Scanner__typ, t, pos);
	In_startpos = pos;
	In_Done = 1;
}

void In_Open (void)
{
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Viewers_Viewer v = NIL;
	Display_Frame f = NIL;
	In_OpenText(Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&In_s, Texts_Scanner__typ);
	if (In_s.class == 6 && In_s.c == '^') {
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (time > 0) {
			In_OpenText(t, beg);
		} else {
			In_Done = 0;
		}
	} else if (In_s.class == 6 && In_s.c == '*') {
		v = Oberon_MarkedViewer();
		f = v->dsc;
		while (f != NIL && (Oberon_Pointer.Y < f->Y || Oberon_Pointer.Y >= f->Y + f->H)) {
			f = f->next;
		}
		if (f != NIL && __ISP(f, TextFrames_FrameDesc, 1)) {
			In_OpenText(__GUARDP(f, TextFrames_FrameDesc, 1)->text, 0);
		} else {
			In_Done = 0;
		}
	} else {
		In_OpenText(Oberon_Par->text, Oberon_Par->pos);
	}
}

INTEGER In_Next (void)
{
	Texts_Scanner s1 = {0};
	if (In_Done) {
		Texts_OpenScanner(&s1, Texts_Scanner__typ, In_text, Texts_Pos((void*)&In_s, Texts_Scanner__typ));
		Texts_Scan(&s1, Texts_Scanner__typ);
		In_Done = s1.class != 0;
		return s1.class;
	} else {
		return 0;
	}
	__RETCHK;
}

void In_Int (INTEGER *n)
{
	if (In_Done) {
		Texts_Scan(&In_s, Texts_Scanner__typ);
		if (In_s.class == 3) {
			*n = (int)In_s.i;
		} else {
			*n = 0;
			In_Done = 0;
		}
	}
}

void In_LongInt (LONGINT *n)
{
	if (In_Done) {
		Texts_Scan(&In_s, Texts_Scanner__typ);
		if (In_s.class == 3) {
			*n = In_s.i;
		} else {
			*n = 0;
			In_Done = 0;
		}
	}
}

void In_Real (REAL *r)
{
	if (In_Done) {
		Texts_Scan(&In_s, Texts_Scanner__typ);
		if (In_s.class == 4) {
			*r = In_s.x;
		} else {
			*r = (REAL)0;
			In_Done = 0;
		}
	}
}

void In_LongReal (LONGREAL *r)
{
	if (In_Done) {
		Texts_Scan(&In_s, Texts_Scanner__typ);
		if (In_s.class == 5) {
			*r = In_s.y;
		} else {
			*r = (LONGREAL)0;
			In_Done = 0;
		}
	}
}

void In_Char (CHAR *ch)
{
	if (In_Done) {
		if (In_startpos == Texts_Pos((void*)&In_s, Texts_Scanner__typ)) {
			Texts_Read((void*)&In_s, Texts_Scanner__typ, &In_s.nextCh);
		}
		*ch = In_s.nextCh;
		In_Done = !In_s.eot;
		Texts_Read((void*)&In_s, Texts_Scanner__typ, &In_s.nextCh);
	}
}

void In_Name (CHAR *name, LONGINT name__len)
{
	if (In_Done) {
		Texts_Scan(&In_s, Texts_Scanner__typ);
		if (In_s.class == 1) {
			__COPY(In_s.s, name, name__len);
		} else {
			__COPY("", name, name__len);
			In_Done = 0;
		}
	}
}

void In_String (CHAR *string, LONGINT string__len)
{
	if (In_Done) {
		Texts_Scan(&In_s, Texts_Scanner__typ);
		if (In_s.class == 2) {
			__COPY(In_s.s, string, string__len);
		} else {
			__COPY("", string, string__len);
			In_Done = 0;
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&In_s, Texts_Scanner__typ, 332, 1, P);
	P(In_text);
}


export void *In__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(In, EnumPtrs);
	__REGCMD("Open", In_Open);
/* BEGIN */
	In_Done = 0;
	__ENDMOD;
}
