/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Oberon.h"
#include "PopupElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct InfoElems_ElemDesc *InfoElems_Elem;

typedef
	struct InfoElems_ElemDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} InfoElems_ElemDesc;


static LONGINT InfoElems_icon;

export LONGINT *InfoElems_ElemDesc__typ;

export void InfoElems_Alloc (void);
export void InfoElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
static void InfoElems_InitIcon (void);
export void InfoElems_Insert (void);


void InfoElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	InfoElems_Elem e1 = NIL;
	if (__ISP(e, InfoElems_ElemDesc, 3)) {
		if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, InfoElems_ElemDesc);
				(*m__).e = (Texts_Elem)e1;
			}
			PopupElems_Handle((void*)(*(InfoElems_Elem*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("InfoElems", (*m__).mod, 10);
			__MOVE("Alloc", (*m__).proc, 6);
		} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			if ((*m__).prepare) {
				(*(InfoElems_Elem*)&e)->W = 13 * TextFrames_Unit;
				(*(InfoElems_Elem*)&e)->H = (LONGINT)(TextFrames_menuH - 1) * (LONGINT)TextFrames_Unit;
			} else {
				(*(InfoElems_Elem*)&e)->name[0] = 0x00;
				PopupElems_Handle((void*)(*(InfoElems_Elem*)&e), (void*)&*m__, m__typ);
				Display_CopyPattern(15, InfoElems_icon, (*m__).X0 + 2, (*m__).Y0 + 2, 1);
			}
		} else {
			PopupElems_Handle((void*)(*(InfoElems_Elem*)&e), &*m, m__typ);
		}
	} else __WITHCHK;
}

void InfoElems_Alloc (void)
{
	InfoElems_Elem e = NIL;
	__NEW(e, InfoElems_ElemDesc);
	e->handle = InfoElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void InfoElems_Insert (void)
{
	InfoElems_Elem e = NIL;
	TextFrames_InsertElemMsg insert = {0};
	Texts_Writer Wr = {0};
	LONGINT t = 0, d = 0;
	__NEW(e, InfoElems_ElemDesc);
	e->handle = InfoElems_Handle;
	e->name[0] = 0x00;
	e->small = 1;
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_OpenWriter(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Title\": no title", (LONGINT)18);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Author\": no name", (LONGINT)18);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Abstract\": no abstract", (LONGINT)24);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Keywords\": no keywords", (LONGINT)24);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Version\": no version", (LONGINT)22);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"From\": ", (LONGINT)9);
	Oberon_GetClock(&t, &d);
	Texts_WriteDate(&Wr, Texts_Writer__typ, t, d);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Until\": no date (use StampElems.Insert)", (LONGINT)41);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Changes\": no changes", (LONGINT)22);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_WriteString(&Wr, Texts_Writer__typ, (CHAR*)"\"Hints\": This text can again contain arbitrary text elements!", (LONGINT)62);
	Texts_WriteLn(&Wr, Texts_Writer__typ);
	Texts_Append(e->menu, Wr.buf);
	PopupElems_MeasureMenu((void*)e);
	insert.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insert, TextFrames_InsertElemMsg__typ);
}

static void InfoElems_InitIcon (void)
{
	SET line[11];
	line[10] = 0xfc;
	line[9] = 0x0102;
	line[8] = 0x0279;
	line[7] = 0x0285;
	line[6] = 0x0205;
	line[5] = 0x0205;
	line[4] = 0x0285;
	line[3] = 0x0279;
	line[2] = 0x0102;
	line[1] = 0xfc;
	InfoElems_icon = Display_NewPattern((void*)line, 11, 12, 10);
}

__TDESC(InfoElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 88), {0, 4, 12, 32, 68, -24}};

export void *InfoElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Oberon);
	__IMPORT(PopupElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(InfoElems, 0);
	__REGCMD("Alloc", InfoElems_Alloc);
	__REGCMD("Insert", InfoElems_Insert);
	__INITYP(InfoElems_ElemDesc, PopupElems_ElemDesc, 3);
/* BEGIN */
	InfoElems_InitIcon();
	__ENDMOD;
}
