/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "In.h"
#include "KeplerFrames.h"
#include "KeplerGraphs.h"
#include "KeplerPorts.h"
#include "Math.h"
#include "Oberon.h"
#include "Out.h"
#include "Texts.h"

typedef
	struct Kepler1_AttrDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		INTEGER width, a1, a2;
	} Kepler1_AttrDesc;

typedef
	Kepler1_AttrDesc *Kepler1_AttrLine;

export void Kepler1_AttrLine_Draw (Kepler1_AttrLine A, KeplerPorts_Port F);
export void Kepler1_AttrLine_Read (Kepler1_AttrLine A, Files_Rider *R, LONGINT *R__typ);
export void Kepler1_AttrLine_Write (Kepler1_AttrLine A, Files_Rider *R, LONGINT *R__typ);

typedef
	struct Kepler1_CircleDesc *Kepler1_Circle;

typedef
	struct Kepler1_CircleDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler1_CircleDesc;

export void Kepler1_Circle_Draw (Kepler1_Circle C, KeplerPorts_Port F);

typedef
	struct Kepler1_EllipseDesc *Kepler1_Ellipse;

typedef
	struct Kepler1_EllipseDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler1_EllipseDesc;

export void Kepler1_Ellipse_Draw (Kepler1_Ellipse E, KeplerPorts_Port F);

typedef
	struct Kepler1_H90ShapeDesc *Kepler1_H90Shape;

typedef
	struct Kepler1_H90ShapeDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler1_H90ShapeDesc;

export void Kepler1_H90Shape_Draw (Kepler1_H90Shape self, KeplerPorts_Port F);

typedef
	struct Kepler1_HShapeDesc *Kepler1_HShape;

typedef
	struct Kepler1_HShapeDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler1_HShapeDesc;

export void Kepler1_HShape_Draw (Kepler1_HShape self, KeplerPorts_Port F);

typedef
	struct Kepler1_LineDesc *Kepler1_Line;

typedef
	struct Kepler1_LineDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler1_LineDesc;

export void Kepler1_Line_Draw (Kepler1_Line L, KeplerPorts_Port F);

typedef
	struct Kepler1_RectangleDesc *Kepler1_Rectangle;

typedef
	struct Kepler1_RectangleDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler1_RectangleDesc;

export void Kepler1_Rectangle_Draw (Kepler1_Rectangle R, KeplerPorts_Port F);

typedef
	struct Kepler1_StringDesc *Kepler1_String;

typedef
	struct Kepler1_StringDesc { /* KeplerFrames_CaptionDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		CHAR s[128];
		Fonts_Font fnt;
		SHORTINT align;
	} Kepler1_StringDesc;

typedef
	struct Kepler1_TextureDesc *Kepler1_Texture;

typedef
	struct Kepler1_TextureDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		INTEGER pat;
	} Kepler1_TextureDesc;

export void Kepler1_Texture_Draw (Kepler1_Texture T, KeplerPorts_Port F);
export void Kepler1_Texture_Read (Kepler1_Texture T, Files_Rider *R, LONGINT *R__typ);
export void Kepler1_Texture_Write (Kepler1_Texture T, Files_Rider *R, LONGINT *R__typ);

typedef
	struct Kepler1_TriangleDesc *Kepler1_Triangle;

typedef
	struct Kepler1_TriangleDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		INTEGER pat;
	} Kepler1_TriangleDesc;

export void Kepler1_Triangle_Draw (Kepler1_Triangle T, KeplerPorts_Port F);
export void Kepler1_Triangle_Read (Kepler1_Triangle T, Files_Rider *R, LONGINT *R__typ);
export void Kepler1_Triangle_Write (Kepler1_Triangle T, Files_Rider *R, LONGINT *R__typ);



export LONGINT *Kepler1_RectangleDesc__typ;
export LONGINT *Kepler1_TextureDesc__typ;
export LONGINT *Kepler1_LineDesc__typ;
export LONGINT *Kepler1_CircleDesc__typ;
export LONGINT *Kepler1_EllipseDesc__typ;
export LONGINT *Kepler1_StringDesc__typ;
export LONGINT *Kepler1_HShapeDesc__typ;
export LONGINT *Kepler1_H90ShapeDesc__typ;
export LONGINT *Kepler1_AttrDesc__typ;
export LONGINT *Kepler1_TriangleDesc__typ;

export void Kepler1_ChangeAlign (void);
export void Kepler1_ChangeAttrLine (void);
export void Kepler1_ChangeFont (void);
static void Kepler1_DrawArrow (KeplerPorts_Port F, LONGINT x1, LONGINT y1, LONGINT x2, LONGINT y2, INTEGER ArrLen, REAL ArrAngle);
export void Kepler1_GetAttrLine (void);
static void Kepler1_GetPoint2 (LONGINT x, LONGINT y, LONGINT dx, LONGINT dy, REAL angle, INTEGER *aX, INTEGER *aY, INTEGER ArrLen);
export void Kepler1_Line2AttrLine (void);
static void Kepler1_MinMax (INTEGER x, INTEGER y, INTEGER *min, INTEGER *max);
export void Kepler1_NewAttrLine (void);
export void Kepler1_NewCircle (void);
export void Kepler1_NewEllipse (void);
export void Kepler1_NewH90Shape (void);
export void Kepler1_NewHShape (void);
export void Kepler1_NewLine (void);
export void Kepler1_NewRectangle (void);
export void Kepler1_NewString (void);
export void Kepler1_NewTexture (void);
export void Kepler1_NewTriangle (void);
static INTEGER Kepler1_Round (REAL x);
static INTEGER Kepler1_Sign (LONGINT x);


static void Kepler1_MinMax (INTEGER x, INTEGER y, INTEGER *min, INTEGER *max)
{
	if (x < y) {
		*min = x;
		*max = y;
	} else {
		*min = y;
		*max = x;
	}
}

void Kepler1_Rectangle_Draw (Kepler1_Rectangle R, KeplerPorts_Port F)
{
	INTEGER minx = 0, maxx = 0, miny = 0, maxy = 0;
	Kepler1_MinMax(R->p[0]->x, R->p[1]->x, &minx, &maxx);
	Kepler1_MinMax(R->p[0]->y, R->p[1]->y, &miny, &maxy);
	__KeplerPorts_Port_DrawRect(F, minx, miny, maxx - minx, maxy - miny, 15, 0);
}

void Kepler1_NewRectangle (void)
{
	Kepler1_Rectangle o = NIL;
	if (KeplerFrames_nofpts >= 2) {
		__NEW(o, Kepler1_RectangleDesc);
		o->nofpts = 2;
		KeplerFrames_ConsumePoint(&o->p[0]);
		KeplerFrames_ConsumePoint(&o->p[1]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler1_Texture_Draw (Kepler1_Texture T, KeplerPorts_Port F)
{
	INTEGER minx = 0, maxx = 0, miny = 0, maxy = 0;
	Kepler1_MinMax(T->p[0]->x, T->p[1]->x, &minx, &maxx);
	Kepler1_MinMax(T->p[0]->y, T->p[1]->y, &miny, &maxy);
	__KeplerPorts_Port_FillRect(F, minx, miny, maxx - minx, maxy - miny, 15, T->pat, 0);
}

void Kepler1_Texture_Write (Kepler1_Texture T, Files_Rider *R, LONGINT *R__typ)
{
	Files_WriteNum(&*R, R__typ, T->pat);
	KeplerGraphs_Constellation_Write((void*)T, &*R, R__typ);
}

void Kepler1_Texture_Read (Kepler1_Texture T, Files_Rider *R, LONGINT *R__typ)
{
	LONGINT i = 0;
	Files_ReadNum(&*R, R__typ, &i);
	T->pat = (int)i;
	KeplerGraphs_Constellation_Read((void*)T, &*R, R__typ);
}

void Kepler1_NewTexture (void)
{
	Kepler1_Texture o = NIL;
	INTEGER i = 0;
	In_Open();
	In_Int(&i);
	if (((KeplerFrames_nofpts >= 2 && In_Done) && i >= 0) && i < 10) {
		__NEW(o, Kepler1_TextureDesc);
		o->nofpts = 2;
		o->pat = i;
		KeplerFrames_ConsumePoint(&o->p[0]);
		KeplerFrames_ConsumePoint(&o->p[1]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler1_Line_Draw (Kepler1_Line L, KeplerPorts_Port F)
{
	__KeplerPorts_Port_DrawLine(F, L->p[0]->x, L->p[0]->y, L->p[1]->x, L->p[1]->y, 15, 0);
}

void Kepler1_NewLine (void)
{
	Kepler1_Line o = NIL;
	if (KeplerFrames_nofpts >= 2) {
		__NEW(o, Kepler1_LineDesc);
		o->nofpts = 2;
		KeplerFrames_ConsumePoint(&o->p[0]);
		KeplerFrames_ConsumePoint(&o->p[1]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler1_Circle_Draw (Kepler1_Circle C, KeplerPorts_Port F)
{
	LONGINT a = 0, b = 0;
	INTEGER r = 0;
	a = C->p[0]->x - C->p[1]->x;
	b = C->p[0]->y - C->p[1]->y;
	r = (int)__ENTIER(Math_sqrt(a * a + b * b));
	__KeplerPorts_Port_DrawCircle(F, C->p[0]->x, C->p[0]->y, r, 15, 0);
}

void Kepler1_NewCircle (void)
{
	Kepler1_Circle o = NIL;
	if (KeplerFrames_nofpts >= 2) {
		__NEW(o, Kepler1_CircleDesc);
		o->nofpts = 2;
		KeplerFrames_ConsumePoint(&o->p[0]);
		KeplerFrames_ConsumePoint(&o->p[1]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler1_Ellipse_Draw (Kepler1_Ellipse E, KeplerPorts_Port F)
{
	INTEGER a = 0, b = 0, tmpx = 0, tmpy = 0, temp = 0;
	tmpx = E->p[1]->x - E->p[0]->x;
	tmpy = E->p[2]->y - E->p[0]->y;
	Kepler1_MinMax(tmpx, -tmpx, &temp, &a);
	Kepler1_MinMax(tmpy, -tmpy, &temp, &b);
	__KeplerPorts_Port_DrawEllipse(F, E->p[0]->x, E->p[0]->y, a, b, 15, 0);
}

void Kepler1_NewEllipse (void)
{
	Kepler1_Ellipse o = NIL;
	if (KeplerFrames_nofpts >= 3) {
		__NEW(o, Kepler1_EllipseDesc);
		o->nofpts = 3;
		KeplerFrames_ConsumePoint(&o->p[0]);
		KeplerFrames_ConsumePoint(&o->p[1]);
		KeplerFrames_ConsumePoint(&o->p[2]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler1_NewString (void)
{
	KeplerFrames_Caption o = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader R = {0};
	Texts_Text T = NIL;
	INTEGER i = 0;
	CHAR ch = 0;
	if (KeplerFrames_nofpts >= 1) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time > 0) {
			__NEW(o, KeplerFrames_CaptionDesc);
			o->nofpts = 1;
			In_Open();
			In_Int(&i);
			if (!In_Done) {
				o->align = 0;
			} else {
				o->align = (int)i;
			}
			KeplerFrames_ConsumePoint(&o->p[0]);
			Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			o->fnt = R.fnt;
			i = 0;
			while ((ch >= ' ' && i < 128) && Texts_Pos(&R, Texts_Reader__typ) <= end) {
				o->s[__X(i, 128)] = ch;
				i += 1;
				Texts_Read(&R, Texts_Reader__typ, &ch);
			}
			o->s[__X(i, 128)] = 0x00;
			__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
		}
	}
}

void Kepler1_ChangeFont (void)
{
	KeplerGraphs_Graph G = NIL;
	KeplerGraphs_Constellation c = NIL;
	CHAR fntname[32];
	Fonts_Font fnt = NIL;
	KeplerPorts_BalloonPort F = NIL;
	In_Open();
	In_Name((void*)fntname, 32);
	KeplerFrames_GetSelection(&G);
	if (G != NIL && In_Done) {
		fnt = Fonts_This(fntname, 32);
		if (__STRCMP(fntname, fnt->name) == 0) {
			__NEW(F, KeplerPorts_BalloonPortDesc);
			KeplerPorts_InitBalloon(F);
			c = G->cons;
			while (c != NIL) {
				if (__ISP(c, KeplerFrames_CaptionDesc, 2)) {
					if (__KeplerGraphs_Constellation_State((void*)(*(KeplerFrames_Caption*)&c)) == 2) {
						__KeplerGraphs_Object_Draw((void*)(*(KeplerFrames_Caption*)&c), (void*)F);
						(*(KeplerFrames_Caption*)&c)->fnt = fnt;
						__KeplerGraphs_Object_Draw((void*)(*(KeplerFrames_Caption*)&c), (void*)F);
					}
				}
				c = c->next;
			}
			(*G->notify)(1, G, NIL, (void*)F);
		}
	}
}

void Kepler1_ChangeAlign (void)
{
	KeplerGraphs_Graph G = NIL;
	KeplerGraphs_Constellation c = NIL;
	INTEGER align = 0;
	KeplerPorts_BalloonPort F = NIL;
	In_Open();
	In_Int(&align);
	KeplerFrames_GetSelection(&G);
	if (G != NIL && In_Done) {
		if (0 <= align && align <= 6) {
			__NEW(F, KeplerPorts_BalloonPortDesc);
			KeplerPorts_InitBalloon(F);
			c = G->cons;
			while (c != NIL) {
				if (__ISP(c, KeplerFrames_CaptionDesc, 2)) {
					if (__KeplerGraphs_Constellation_State((void*)(*(KeplerFrames_Caption*)&c)) == 2) {
						__KeplerGraphs_Object_Draw((void*)(*(KeplerFrames_Caption*)&c), (void*)F);
						(*(KeplerFrames_Caption*)&c)->align = (int)align;
						__KeplerGraphs_Object_Draw((void*)(*(KeplerFrames_Caption*)&c), (void*)F);
					}
				}
				c = c->next;
			}
			(*G->notify)(1, G, NIL, (void*)F);
		}
	}
}

void Kepler1_HShape_Draw (Kepler1_HShape self, KeplerPorts_Port F)
{
	__KeplerPorts_Port_DrawLine(F, self->p[0]->x, self->p[1]->y, self->p[2]->x, self->p[1]->y, 15, 0);
}

void Kepler1_NewHShape (void)
{
	Kepler1_HShape h = NIL;
	if (KeplerFrames_nofpts >= 3) {
		__NEW(h, Kepler1_HShapeDesc);
		h->nofpts = 3;
		KeplerFrames_ConsumePoint(&h->p[0]);
		KeplerFrames_ConsumePoint(&h->p[1]);
		KeplerFrames_ConsumePoint(&h->p[2]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)h);
	}
}

void Kepler1_H90Shape_Draw (Kepler1_H90Shape self, KeplerPorts_Port F)
{
	__KeplerPorts_Port_DrawLine(F, self->p[1]->x, self->p[0]->y, self->p[1]->x, self->p[2]->y, 15, 0);
}

void Kepler1_NewH90Shape (void)
{
	Kepler1_H90Shape h = NIL;
	if (KeplerFrames_nofpts >= 3) {
		__NEW(h, Kepler1_H90ShapeDesc);
		h->nofpts = 3;
		KeplerFrames_ConsumePoint(&h->p[0]);
		KeplerFrames_ConsumePoint(&h->p[1]);
		KeplerFrames_ConsumePoint(&h->p[2]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)h);
	}
}

static INTEGER Kepler1_Sign (LONGINT x)
{
	if (x < 0) {
		return -1;
	} else {
		return 1;
	}
	__RETCHK;
}

static void Kepler1_GetPoint2 (LONGINT x, LONGINT y, LONGINT dx, LONGINT dy, REAL angle, INTEGER *aX, INTEGER *aY, INTEGER ArrLen)
{
	LONGINT h = 0, s = 0;
	REAL cos = 0, t = 0;
	*aX = (int)(x - __ENTIER(Math_cos(angle) * ArrLen +   5.0000000e-001) * (LONGINT)Kepler1_Sign(dx));
	*aY = (int)(y - __ENTIER(Math_sin(angle) * ArrLen +   5.0000000e-001) * (LONGINT)Kepler1_Sign(dx));
}

static void Kepler1_DrawArrow (KeplerPorts_Port F, LONGINT x1, LONGINT y1, LONGINT x2, LONGINT y2, INTEGER ArrLen, REAL ArrAngle)
{
	REAL angle = 0;
	LONGINT dx = 0, dy = 0;
	INTEGER ax1 = 0, ay1 = 0, ax2 = 0, ay2 = 0;
	if (ArrLen < 28) {
		ArrLen = 28;
	}
	dx = x2 - x1;
	dy = y2 - y1;
	if (dx != 0) {
		angle = Math_arctan(dy / (REAL)dx);
	} else {
		angle = Kepler1_Sign(dy) *   1.5707964e+000;
	}
	Kepler1_GetPoint2(x2, y2, dx, dy, angle - ArrAngle / (REAL)(REAL)2, &ax1, &ay1, ArrLen);
	Kepler1_GetPoint2(x2, y2, dx, dy, angle + ArrAngle / (REAL)(REAL)2, &ax2, &ay2, ArrLen);
	__KeplerPorts_Port_FillQuad(F, ax1, ay1, (int)x2, (int)y2, ax2, ay2, ax2, ay2, 15, 5, 0);
}

static INTEGER Kepler1_Round (REAL x)
{
	return (int)__ENTIER(x +   5.0000000e-001);
}

void Kepler1_AttrLine_Draw (Kepler1_AttrLine A, KeplerPorts_Port F)
{
	REAL a = 0, b = 0, h = 0, v1 = 0, v2 = 0;
	INTEGER x1 = 0, y1 = 0, x2 = 0, y2 = 0, ar = 0, br = 0;
	x1 = A->p[0]->x;
	y1 = A->p[0]->y;
	x2 = A->p[1]->x;
	y2 = A->p[1]->y;
	a = x2 - x1;
	b = y2 - y1;
	h = Math_sqrt(a * a + b * b);
	if (h != (REAL)0) {
		if (A->a1 == 1) {
			v1 = (44 * A->width) / (REAL)((REAL)12 * h);
			Kepler1_DrawArrow(F, A->p[0]->x, A->p[0]->y, A->p[1]->x, A->p[1]->y, __ASHR(44 * A->width, 2),   5.2359879e-001);
			x2 = x2 - Kepler1_Round(a * v1);
			y2 = y2 - Kepler1_Round(b * v1);
		} else if (A->a1 == 2) {
			v1 = (28 * A->width) / (REAL)((REAL)12 * h);
			Kepler1_DrawArrow(F, A->p[0]->x, A->p[0]->y, A->p[1]->x, A->p[1]->y, __DIV(28 * A->width, 6),   7.8539819e-001);
			x2 = x2 - Kepler1_Round(a * v1);
			y2 = y2 - Kepler1_Round(b * v1);
		}
		if (A->a2 == 1) {
			v1 = (44 * A->width) / (REAL)((REAL)12 * h);
			Kepler1_DrawArrow(F, A->p[1]->x, A->p[1]->y, A->p[0]->x, A->p[0]->y, __ASHR(44 * A->width, 2),   5.2359879e-001);
			x1 = x1 + Kepler1_Round(a * v1);
			y1 = y1 + Kepler1_Round(b * v1);
		} else if (A->a2 == 2) {
			v1 = (28 * A->width) / (REAL)((REAL)12 * h);
			Kepler1_DrawArrow(F, A->p[1]->x, A->p[1]->y, A->p[0]->x, A->p[0]->y, __DIV(28 * A->width, 6),   7.8539819e-001);
			x1 = x1 + Kepler1_Round(a * v1);
			y1 = y1 + Kepler1_Round(b * v1);
		}
		if (A->width <= F->scale) {
			__KeplerPorts_Port_DrawLine(F, x1, y1, x2, y2, 15, 0);
		} else if (x1 == x2) {
			if (y1 > y2) {
				__KeplerPorts_Port_FillRect(F, x1 - __ASHR(A->width, 1), y2, A->width, y1 - y2, 15, 5, 0);
			} else {
				__KeplerPorts_Port_FillRect(F, x1 - __ASHR(A->width, 1), y1, A->width, y2 - y1, 15, 5, 0);
			}
		} else if (y1 == y2) {
			if (x1 > x2) {
				__KeplerPorts_Port_FillRect(F, x2, y2 - __ASHR(A->width, 1), x1 - x2, A->width, 15, 5, 0);
			} else {
				__KeplerPorts_Port_FillRect(F, x1, y1 - __ASHR(A->width, 1), x2 - x1, A->width, 15, 5, 0);
			}
		} else {
			v2 = A->width / (REAL)((REAL)2 * h);
			ar = Kepler1_Round(a * v2);
			br = Kepler1_Round(b * v2);
			x1 = __DIV(x1, F->scale) * F->scale;
			y1 = __DIV(y1, F->scale) * F->scale;
			x2 = __DIV(x2, F->scale) * F->scale;
			y2 = __DIV(y2, F->scale) * F->scale;
			__KeplerPorts_Port_FillQuad(F, x1 - br, y1 + ar, x1 + br, y1 - ar, x2 + br, y2 - ar, x2 - br, y2 + ar, 15, 5, 0);
		}
	}
}

void Kepler1_AttrLine_Write (Kepler1_AttrLine A, Files_Rider *R, LONGINT *R__typ)
{
	Files_WriteNum(&*R, R__typ, A->width);
	Files_WriteNum(&*R, R__typ, A->a1);
	Files_WriteNum(&*R, R__typ, A->a2);
	KeplerGraphs_Constellation_Write((void*)A, &*R, R__typ);
}

void Kepler1_AttrLine_Read (Kepler1_AttrLine A, Files_Rider *R, LONGINT *R__typ)
{
	LONGINT i = 0;
	Files_ReadNum(&*R, R__typ, &i);
	A->width = (int)i;
	Files_ReadNum(&*R, R__typ, &i);
	A->a1 = (int)i;
	Files_ReadNum(&*R, R__typ, &i);
	A->a2 = (int)i;
	KeplerGraphs_Constellation_Read((void*)A, &*R, R__typ);
}

void Kepler1_NewAttrLine (void)
{
	Kepler1_AttrLine a = NIL;
	INTEGER w = 0, a1 = 0, a2 = 0;
	if (KeplerFrames_nofpts >= 2) {
		__NEW(a, Kepler1_AttrDesc);
		a->nofpts = 2;
		In_Open();
		In_Int(&w);
		In_Int(&a1);
		In_Int(&a2);
		if (In_Done) {
			a->width = w;
			a->a1 = a1;
			a->a2 = a2;
			KeplerFrames_ConsumePoint(&a->p[0]);
			KeplerFrames_ConsumePoint(&a->p[1]);
			__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)a);
		}
	}
}

void Kepler1_ChangeAttrLine (void)
{
	KeplerGraphs_Graph G = NIL;
	KeplerGraphs_Constellation c = NIL;
	INTEGER w = 0, a1 = 0, a2 = 0;
	KeplerPorts_BalloonPort F = NIL;
	In_Open();
	In_Int(&w);
	In_Int(&a1);
	In_Int(&a2);
	KeplerFrames_GetSelection(&G);
	if (G != NIL && In_Done) {
		__NEW(F, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(F);
		c = G->cons;
		while (c != NIL) {
			if (__ISP(c, Kepler1_AttrDesc, 2)) {
				if (__KeplerGraphs_Constellation_State((void*)(*(Kepler1_AttrLine*)&c)) == 2) {
					__KeplerGraphs_Object_Draw((void*)(*(Kepler1_AttrLine*)&c), (void*)F);
					(*(Kepler1_AttrLine*)&c)->width = w;
					(*(Kepler1_AttrLine*)&c)->a1 = a1;
					(*(Kepler1_AttrLine*)&c)->a2 = a2;
					__KeplerGraphs_Object_Draw((void*)(*(Kepler1_AttrLine*)&c), (void*)F);
				}
			}
			c = c->next;
		}
		(*G->notify)(1, G, NIL, (void*)F);
	}
}

void Kepler1_GetAttrLine (void)
{
	KeplerGraphs_Graph G = NIL;
	KeplerGraphs_Constellation c = NIL;
	KeplerFrames_GetSelection(&G);
	if (G != NIL) {
		c = G->cons;
		while (c != NIL) {
			if (__ISP(c, Kepler1_AttrDesc, 2)) {
				if (__KeplerGraphs_Constellation_State((void*)(*(Kepler1_AttrLine*)&c)) == 2) {
					Out_String((CHAR*)"Kepler1.ChangeAttrLine ", (LONGINT)24);
					Out_Int((*(Kepler1_AttrLine*)&c)->width, 5);
					Out_Int((*(Kepler1_AttrLine*)&c)->a1, 5);
					Out_Int((*(Kepler1_AttrLine*)&c)->a2, 5);
					Out_Ln();
				}
			}
			c = c->next;
		}
	}
}

void Kepler1_Line2AttrLine (void)
{
	KeplerGraphs_Graph G = NIL;
	KeplerGraphs_Constellation c = NIL, prev = NIL;
	Kepler1_AttrLine a = NIL;
	KeplerPorts_BalloonPort F = NIL;
	INTEGER n = 0, w = 0, a1 = 0, a2 = 0;
	KeplerFrames_GetSelection(&G);
	In_Open();
	In_Int(&w);
	In_Int(&a1);
	In_Int(&a2);
	if (G != NIL && In_Done) {
		__NEW(F, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(F);
		c = G->cons;
		prev = NIL;
		n = 0;
		while (c != NIL) {
			if (__ISP(c, Kepler1_LineDesc, 2)) {
				if (__KeplerGraphs_Constellation_State((void*)(*(Kepler1_Line*)&c)) == 2) {
					__NEW(a, Kepler1_AttrDesc);
					a->nofpts = 2;
					a->width = w;
					a->a1 = a1;
					a->a2 = a2;
					a->p[0] = (*(Kepler1_Line*)&c)->p[0];
					a->p[1] = (*(Kepler1_Line*)&c)->p[1];
					a->next = (*(Kepler1_Line*)&c)->next;
					if (prev == NIL) {
						G->cons = (KeplerGraphs_Constellation)a;
					} else {
						prev->next = (KeplerGraphs_Constellation)a;
					}
					prev = (KeplerGraphs_Constellation)a;
					__KeplerGraphs_Object_Draw((void*)a, (void*)F);
					n += 1;
				}
			} else {
				prev = c;
			}
			c = c->next;
		}
		(*G->notify)(1, G, NIL, (void*)F);
		Out_Int(n, 0);
		Out_String((CHAR*)" Lines replaced with AttrLine", (LONGINT)30);
		Out_Int(w, 5);
		Out_Int(a1, 5);
		Out_Int(a2, 5);
		Out_Ln();
	}
}

void Kepler1_Triangle_Draw (Kepler1_Triangle T, KeplerPorts_Port F)
{
	KeplerGraphs_Star p0 = NIL, p1 = NIL, p2 = NIL;
	p0 = T->p[0];
	p1 = T->p[1];
	p2 = T->p[2];
	__KeplerPorts_Port_FillQuad(F, p0->x, p0->y, p1->x, p1->y, p2->x, p2->y, p2->x, p2->y, 15, T->pat, 0);
}

void Kepler1_Triangle_Write (Kepler1_Triangle T, Files_Rider *R, LONGINT *R__typ)
{
	Files_WriteNum(&*R, R__typ, T->pat);
	KeplerGraphs_Constellation_Write((void*)T, &*R, R__typ);
}

void Kepler1_Triangle_Read (Kepler1_Triangle T, Files_Rider *R, LONGINT *R__typ)
{
	LONGINT i = 0;
	Files_ReadNum(&*R, R__typ, &i);
	T->pat = (int)i;
	KeplerGraphs_Constellation_Read((void*)T, &*R, R__typ);
}

void Kepler1_NewTriangle (void)
{
	Kepler1_Triangle o = NIL;
	INTEGER pat = 0;
	In_Open();
	In_Int(&pat);
	if (((In_Done && KeplerFrames_nofpts >= 3) && pat >= 0) && pat < 10) {
		__NEW(o, Kepler1_TriangleDesc);
		o->nofpts = 3;
		o->pat = pat;
		KeplerFrames_ConsumePoint(&o->p[0]);
		KeplerFrames_ConsumePoint(&o->p[1]);
		KeplerFrames_ConsumePoint(&o->p[2]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

__TDESC(Kepler1_RectangleDesc, 5, 5) = {__TDFLDS("RectangleDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_TextureDesc, 5, 5) = {__TDFLDS("TextureDesc", 28), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_LineDesc, 5, 5) = {__TDFLDS("LineDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_CircleDesc, 5, 5) = {__TDFLDS("CircleDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_EllipseDesc, 5, 5) = {__TDFLDS("EllipseDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_StringDesc, 5, 6) = {__TDFLDS("StringDesc", 160), {4, 8, 12, 16, 20, 152, -28}};
__TDESC(Kepler1_HShapeDesc, 5, 5) = {__TDFLDS("HShapeDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_H90ShapeDesc, 5, 5) = {__TDFLDS("H90ShapeDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_AttrDesc, 5, 5) = {__TDFLDS("AttrDesc", 32), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler1_TriangleDesc, 5, 5) = {__TDFLDS("TriangleDesc", 28), {4, 8, 12, 16, 20, -24}};

export void *Kepler1__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(In);
	__IMPORT(KeplerFrames);
	__IMPORT(KeplerGraphs);
	__IMPORT(KeplerPorts);
	__IMPORT(Math);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(Texts);
	__REGMOD(Kepler1, 0);
	__REGCMD("ChangeAlign", Kepler1_ChangeAlign);
	__REGCMD("ChangeAttrLine", Kepler1_ChangeAttrLine);
	__REGCMD("ChangeFont", Kepler1_ChangeFont);
	__REGCMD("GetAttrLine", Kepler1_GetAttrLine);
	__REGCMD("Line2AttrLine", Kepler1_Line2AttrLine);
	__REGCMD("NewAttrLine", Kepler1_NewAttrLine);
	__REGCMD("NewCircle", Kepler1_NewCircle);
	__REGCMD("NewEllipse", Kepler1_NewEllipse);
	__REGCMD("NewH90Shape", Kepler1_NewH90Shape);
	__REGCMD("NewHShape", Kepler1_NewHShape);
	__REGCMD("NewLine", Kepler1_NewLine);
	__REGCMD("NewRectangle", Kepler1_NewRectangle);
	__REGCMD("NewString", Kepler1_NewString);
	__REGCMD("NewTexture", Kepler1_NewTexture);
	__REGCMD("NewTriangle", Kepler1_NewTriangle);
	__INITYP(Kepler1_RectangleDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_RectangleDesc, Kepler1_Rectangle_Draw, 0);
	__INITYP(Kepler1_TextureDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_TextureDesc, Kepler1_Texture_Draw, 0);
	__INITBP(Kepler1_TextureDesc, Kepler1_Texture_Read, 1);
	__INITBP(Kepler1_TextureDesc, Kepler1_Texture_Write, 2);
	__INITYP(Kepler1_LineDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_LineDesc, Kepler1_Line_Draw, 0);
	__INITYP(Kepler1_CircleDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_CircleDesc, Kepler1_Circle_Draw, 0);
	__INITYP(Kepler1_EllipseDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_EllipseDesc, Kepler1_Ellipse_Draw, 0);
	__INITYP(Kepler1_StringDesc, KeplerFrames_CaptionDesc, 3);
	__INITYP(Kepler1_HShapeDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_HShapeDesc, Kepler1_HShape_Draw, 0);
	__INITYP(Kepler1_H90ShapeDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_H90ShapeDesc, Kepler1_H90Shape_Draw, 0);
	__INITYP(Kepler1_AttrDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_AttrDesc, Kepler1_AttrLine_Draw, 0);
	__INITBP(Kepler1_AttrDesc, Kepler1_AttrLine_Read, 1);
	__INITBP(Kepler1_AttrDesc, Kepler1_AttrLine_Write, 2);
	__INITYP(Kepler1_TriangleDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler1_TriangleDesc, Kepler1_Triangle_Draw, 0);
	__INITBP(Kepler1_TriangleDesc, Kepler1_Triangle_Read, 1);
	__INITBP(Kepler1_TriangleDesc, Kepler1_Triangle_Write, 2);
/* BEGIN */
	__ENDMOD;
}
