/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Kepler2.h"
#include "KeplerFrames.h"
#include "KeplerGraphs.h"
#include "KeplerPorts.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct Kepler4_GalaxyDesc *Kepler4_Galaxy;

typedef
	struct Kepler4_GalaxyDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		KeplerGraphs_Graph G;
	} Kepler4_GalaxyDesc;

export void Kepler4_Galaxy_Draw (Kepler4_Galaxy self, KeplerPorts_Port F);
export void Kepler4_Galaxy_Read (Kepler4_Galaxy self, Files_Rider *R, LONGINT *R__typ);
export void Kepler4_Galaxy_Write (Kepler4_Galaxy self, Files_Rider *R, LONGINT *R__typ);

typedef
	struct Kepler4_IconDesc *Kepler4_Icon;

typedef
	struct Kepler4_IconDesc { /* KeplerFrames_ButtonDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		CHAR cmd[32], par[32];
		Fonts_Font fnt;
		Viewers_Viewer V;
	} Kepler4_IconDesc;

export void Kepler4_Icon_Draw (Kepler4_Icon I, KeplerPorts_Port F);
export void Kepler4_Icon_Execute (Kepler4_Icon I, SET keys);
export void Kepler4_Icon_Read (Kepler4_Icon I, Files_Rider *R, LONGINT *R__typ);
export void Kepler4_Icon_Write (Kepler4_Icon I, Files_Rider *R, LONGINT *R__typ);



export LONGINT *Kepler4_IconDesc__typ;
export LONGINT *Kepler4_GalaxyDesc__typ;

static void Kepler4_Dummy (INTEGER op, KeplerGraphs_Graph g, KeplerGraphs_Object c);
export void Kepler4_NewButton (void);
export void Kepler4_NewGalaxy (void);
export void Kepler4_NewIcon (void);
export void Kepler4_UpdateButton (void);


void Kepler4_Icon_Execute (Kepler4_Icon I, SET keys)
{
	INTEGER X = 0, Y = 0;
	Viewers_Viewer V = NIL, V1 = NIL;
	Oberon_ControlMsg N = {0};
	Viewers_ViewerMsg msg = {0};
	if (keys == 0x02) {
		if (I->V == NIL) {
			if (!Oberon_Pointer.on) {
				Oberon_AllocateUserViewer(Oberon_Mouse.X, &X, &Y);
				N.id = 2;
				N.X = X;
				N.Y = Y;
				V = Viewers_This(X, Y - 1);
				(*V->handle)((void*)V, (void*)&N, Oberon_ControlMsg__typ);
			} else {
				V = Viewers_This(Oberon_Pointer.X, Oberon_Pointer.Y - 1);
			}
			KeplerFrames_Button_Execute((void*)I, 0x02);
			V1 = Viewers_This(Oberon_Pointer.X, Oberon_Pointer.Y - 1);
			if (V1 != V) {
				I->V = V1;
			}
		} else if (I->V->state == 0) {
			Viewers_Open(I->V, I->V->X, I->V->Y + I->V->H);
			msg.id = 0;
			(*I->V->handle)((void*)I->V, (void*)&msg, Viewers_ViewerMsg__typ);
		}
	} else if (keys == 0x06 && I->cmd[0] != 0x00) {
		if (!Oberon_Pointer.on) {
			Oberon_AllocateUserViewer(Oberon_Mouse.X, &X, &Y);
			N.id = 2;
			N.X = X;
			N.Y = Y;
			V = Viewers_This(X, Y - 1);
			(*V->handle)((void*)V, (void*)&N, Oberon_ControlMsg__typ);
		} else {
			V = Viewers_This(Oberon_Pointer.X, Oberon_Pointer.Y - 1);
		}
		KeplerFrames_Button_Execute((void*)I, 0x02);
		V1 = Viewers_This(Oberon_Pointer.X, Oberon_Pointer.Y - 1);
		if (V1 != V) {
			I->V = V1;
		}
	} else {
		KeplerFrames_Button_Execute((void*)I, keys);
	}
}

void Kepler4_Icon_Draw (Kepler4_Icon I, KeplerPorts_Port F)
{
	__KeplerPorts_Port_DrawRect(F, I->p[0]->x, I->p[0]->y, I->p[1]->x - I->p[0]->x, I->p[1]->y - I->p[0]->y, 15, 0);
	__KeplerPorts_Port_DrawString(F, I->p[0]->x + 12, (I->p[0]->y - __ASHL(I->fnt->minY, 2)) + 4, I->par, 32, I->fnt, 15, 0);
}

void Kepler4_Icon_Read (Kepler4_Icon I, Files_Rider *R, LONGINT *R__typ)
{
	CHAR fnt[32];
	KeplerFrames_Button_Read((void*)I, &*R, R__typ);
	Files_ReadString(&*R, R__typ, (void*)fnt, 32);
	I->fnt = Fonts_This(fnt, 32);
	I->V = NIL;
}

void Kepler4_Icon_Write (Kepler4_Icon I, Files_Rider *R, LONGINT *R__typ)
{
	KeplerFrames_Button_Write((void*)I, &*R, R__typ);
	Files_WriteString(&*R, R__typ, I->fnt->name, 32);
}

void Kepler4_NewIcon (void)
{
	Kepler4_Icon i = NIL;
	Kepler2_Offset o = NIL;
	KeplerGraphs_Constellation c = NIL;
	CHAR ch = 0;
	INTEGER k = 0, dx = 0, d0 = 0, d1 = 0, d2 = 0, d3 = 0;
	LONGINT d4 = 0, beg = 0, end = 0, time = 0;
	Texts_Reader R = {0};
	Texts_Scanner S = {0};
	Texts_Text T = NIL;
	if (KeplerFrames_nofpts >= 1) {
		__NEW(i, Kepler4_IconDesc);
		i->nofpts = 2;
		KeplerFrames_ConsumePoint(&i->p[0]);
		__NEW(o, Kepler2_OffsetDesc);
		i->p[1] = (KeplerGraphs_Star)o;
		o->refcnt = 1;
		__NEW(c, KeplerGraphs_ConsDesc);
		o->c = c;
		c->p[0] = i->p[0];
		c->nofpts = 1;
		c->p[0]->refcnt += 1;
		i->V = Oberon_MarkedViewer();
		Texts_OpenReader(&R, Texts_Reader__typ, __GUARDP(i->V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		i->fnt = R.fnt;
		k = 0;
		o->dx = 20;
		while (ch == ' ') {
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		while (ch > ' ') {
			i->par[__X(k, 32)] = ch;
			k += 1;
			Display_GetChar(i->fnt->raster, ch, &dx, &d0, &d1, &d2, &d3, &d4);
			o->dx += __ASHL(dx, 2);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		i->par[__X(k, 32)] = 0x00;
		o->dy = __ASHL(i->fnt->height + 4, 2);
		__KeplerGraphs_Planet_Calc((void*)o);
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time > 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
			if (S.class == 1) {
				__COPY(S.s, i->cmd, 32);
			}
		}
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)i);
	}
}

void Kepler4_Galaxy_Draw (Kepler4_Galaxy self, KeplerPorts_Port F)
{
	F->x0 += self->p[0]->x;
	F->y0 += self->p[0]->y;
	__KeplerGraphs_Object_Draw((void*)self->G, F);
	F->x0 -= self->p[0]->x;
	F->y0 -= self->p[0]->y;
}

static void Kepler4_Dummy (INTEGER op, KeplerGraphs_Graph g, KeplerGraphs_Object c)
{
}

void Kepler4_Galaxy_Read (Kepler4_Galaxy self, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Object o = NIL;
	KeplerGraphs_Constellation_Read((void*)self, &*R, R__typ);
	KeplerGraphs_ReadObj(&*R, R__typ, &o);
	self->G = __GUARDP(o, KeplerGraphs_GraphDesc, 1);
}

void Kepler4_Galaxy_Write (Kepler4_Galaxy self, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Constellation_Write((void*)self, &*R, R__typ);
	KeplerGraphs_WriteObj(&*R, R__typ, (void*)self->G);
}

void Kepler4_NewGalaxy (void)
{
	KeplerGraphs_Graph G = NIL;
	Kepler4_Galaxy Gx = NIL;
	KeplerFrames_SelMsg M = {0};
	Kepler2_Offset offset = NIL;
	KeplerGraphs_Star p0 = NIL;
	KeplerPorts_BalloonPort B = NIL;
	M.time = 0;
	Viewers_Broadcast((void*)&M, KeplerFrames_SelMsg__typ);
	if (M.time > 0 && KeplerFrames_nofpts > 0) {
		KeplerFrames_ConsumePoint(&p0);
		__NEW(G, KeplerGraphs_GraphDesc);
		G->notify = KeplerFrames_NotifyDisplay;
		__KeplerGraphs_Graph_CopySelection(G, M.G, 0, 0);
		__KeplerGraphs_Graph_All(G, 0);
		__NEW(B, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(B);
		__KeplerGraphs_Object_Draw((void*)G, (void*)B);
		__KeplerGraphs_Graph_All(G, 1);
		__KeplerGraphs_Graph_MoveSelection(G, -B->X, -B->Y);
		__KeplerGraphs_Graph_All(G, 0);
		__NEW(offset, Kepler2_OffsetDesc);
		__NEW(offset->c, KeplerGraphs_ConsDesc);
		offset->dx = B->W;
		offset->dy = B->H;
		offset->c->p[0] = p0;
		p0->refcnt += 1;
		offset->refcnt = 1;
		offset->c->nofpts = 1;
		__KeplerGraphs_Planet_Calc((void*)offset);
		__NEW(Gx, Kepler4_GalaxyDesc);
		Gx->G = G;
		G = KeplerFrames_Focus;
		Gx->p[0] = p0;
		Gx->p[1] = (KeplerGraphs_Star)offset;
		Gx->nofpts = 2;
		__KeplerGraphs_Graph_Append(G, (void*)p0);
		__KeplerGraphs_Graph_Append(G, (void*)offset);
		__KeplerGraphs_Graph_Append(G, (void*)Gx);
	}
}

void Kepler4_NewButton (void)
{
	KeplerFrames_Button o = NIL;
	LONGINT beg = 0, end = 0, time = 0, i = 0;
	Texts_Scanner S = {0};
	Texts_Text T = NIL;
	if (KeplerFrames_nofpts >= 2) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time > 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
			if (S.class == 1) {
				__NEW(o, KeplerFrames_ButtonDesc);
				o->nofpts = 2;
				KeplerFrames_ConsumePoint(&o->p[0]);
				KeplerFrames_ConsumePoint(&o->p[1]);
				__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
				__COPY(S.s, o->cmd, 32);
				i = 0;
				while (Texts_Pos((void*)&S, Texts_Scanner__typ) < end) {
					Texts_Read((void*)&S, Texts_Scanner__typ, &o->par[__X(i, 32)]);
					i += 1;
				}
			}
		}
	}
}

void Kepler4_UpdateButton (void)
{
	KeplerFrames_Button o = NIL;
	LONGINT beg = 0, end = 0, time = 0, i = 0;
	Texts_Scanner S = {0};
	Texts_Text T = NIL;
	o = KeplerFrames_MarkedButton();
	if (o != NIL) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time > 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
			if (S.class == 1) {
				__COPY(S.s, o->cmd, 32);
				i = 0;
				while (Texts_Pos((void*)&S, Texts_Scanner__typ) < end) {
					Texts_Read((void*)&S, Texts_Scanner__typ, &o->par[__X(i, 32)]);
					i += 1;
				}
			}
		}
	}
}

__TDESC(Kepler4_IconDesc, 7, 7) = {__TDFLDS("IconDesc", 96), {4, 8, 12, 16, 20, 88, 92, -32}};
__TDESC(Kepler4_GalaxyDesc, 5, 6) = {__TDFLDS("GalaxyDesc", 28), {4, 8, 12, 16, 20, 24, -28}};

export void *Kepler4__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Kepler2);
	__IMPORT(KeplerFrames);
	__IMPORT(KeplerGraphs);
	__IMPORT(KeplerPorts);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Kepler4, 0);
	__REGCMD("NewButton", Kepler4_NewButton);
	__REGCMD("NewGalaxy", Kepler4_NewGalaxy);
	__REGCMD("NewIcon", Kepler4_NewIcon);
	__REGCMD("UpdateButton", Kepler4_UpdateButton);
	__INITYP(Kepler4_IconDesc, KeplerFrames_ButtonDesc, 3);
	__INITBP(Kepler4_IconDesc, Kepler4_Icon_Draw, 0);
	__INITBP(Kepler4_IconDesc, Kepler4_Icon_Execute, 4);
	__INITBP(Kepler4_IconDesc, Kepler4_Icon_Read, 1);
	__INITBP(Kepler4_IconDesc, Kepler4_Icon_Write, 2);
	__INITYP(Kepler4_GalaxyDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler4_GalaxyDesc, Kepler4_Galaxy_Draw, 0);
	__INITBP(Kepler4_GalaxyDesc, Kepler4_Galaxy_Read, 1);
	__INITBP(Kepler4_GalaxyDesc, Kepler4_Galaxy_Write, 2);
/* BEGIN */
	__ENDMOD;
}
