/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "KeplerFrames.h"
#include "KeplerGraphs.h"
#include "KeplerPorts.h"
#include "Oberon.h"

typedef
	struct Kepler5_StarDesc *Kepler5_FocusStar;

typedef
	struct Kepler5_StarDesc2 *Kepler5_FocusStar2;

typedef
	struct Kepler5_PlanetDesc *Kepler5_Planet;

typedef
	struct Kepler5_PlanetDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler5_PlanetDesc;

export void Kepler5_Planet_Draw (Kepler5_Planet self, KeplerPorts_Port F);

typedef
	struct Kepler5_SelStarDesc *Kepler5_SelStar;

typedef
	struct Kepler5_SelStarDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler5_SelStarDesc;

export void Kepler5_SelStar_Draw (Kepler5_SelStar self, KeplerPorts_Port F);

typedef
	struct Kepler5_StarDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler5_StarDesc;

export void Kepler5_FocusStar_Draw (Kepler5_FocusStar self, KeplerPorts_Port F);

typedef
	struct Kepler5_StarDesc2 { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} Kepler5_StarDesc2;

export void Kepler5_FocusStar2_Draw (Kepler5_FocusStar2 self, KeplerPorts_Port F);



export LONGINT *Kepler5_StarDesc__typ;
export LONGINT *Kepler5_StarDesc2__typ;
export LONGINT *Kepler5_SelStarDesc__typ;
export LONGINT *Kepler5_PlanetDesc__typ;

export void Kepler5_NewFocusStar (void);
export void Kepler5_NewFocusStar2 (void);
export void Kepler5_NewPlanet (void);
export void Kepler5_NewSelStar (void);


void Kepler5_FocusStar_Draw (Kepler5_FocusStar self, KeplerPorts_Port F)
{
	INTEGER x = 0, y = 0;
	x = self->p[0]->x - 8;
	y = self->p[0]->y - 8;
	__KeplerPorts_Port_DrawLine(F, x, y, x + 16, y + 16, 15, 0);
	__KeplerPorts_Port_DrawLine(F, x, y + 16, x + 16, y, 15, 0);
}

void Kepler5_NewFocusStar (void)
{
	Kepler5_FocusStar o = NIL;
	if (KeplerFrames_nofpts > 0) {
		__NEW(o, Kepler5_StarDesc);
		o->nofpts = 1;
		KeplerFrames_ConsumePoint(&o->p[0]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler5_FocusStar2_Draw (Kepler5_FocusStar2 self, KeplerPorts_Port F)
{
	INTEGER x = 0, y = 0;
	x = self->p[0]->x;
	y = self->p[0]->y;
	__KeplerPorts_Port_DrawLine(F, x - 16, y, x + 16, y, 15, 0);
	__KeplerPorts_Port_DrawLine(F, x, y + 16, x, y - 16, 15, 0);
}

void Kepler5_NewFocusStar2 (void)
{
	Kepler5_FocusStar2 o = NIL;
	if (KeplerFrames_nofpts > 0) {
		__NEW(o, Kepler5_StarDesc2);
		o->nofpts = 1;
		KeplerFrames_ConsumePoint(&o->p[0]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler5_SelStar_Draw (Kepler5_SelStar self, KeplerPorts_Port F)
{
	__KeplerPorts_Port_FillRect(F, self->p[0]->x - 12, self->p[0]->y - 12, 28, 28, 15, 5, 0);
}

void Kepler5_NewSelStar (void)
{
	Kepler5_SelStar o = NIL;
	if (KeplerFrames_nofpts > 0) {
		__NEW(o, Kepler5_SelStarDesc);
		o->nofpts = 1;
		KeplerFrames_ConsumePoint(&o->p[0]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

void Kepler5_Planet_Draw (Kepler5_Planet self, KeplerPorts_Port F)
{
	__KeplerPorts_Port_DrawRect(F, self->p[0]->x - 12, self->p[0]->y - 12, 24, 24, 15, 0);
}

void Kepler5_NewPlanet (void)
{
	Kepler5_Planet o = NIL;
	if (KeplerFrames_nofpts > 0) {
		__NEW(o, Kepler5_PlanetDesc);
		o->nofpts = 1;
		KeplerFrames_ConsumePoint(&o->p[0]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
}

__TDESC(Kepler5_StarDesc, 5, 5) = {__TDFLDS("StarDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler5_StarDesc2, 5, 5) = {__TDFLDS("StarDesc2", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler5_SelStarDesc, 5, 5) = {__TDFLDS("SelStarDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(Kepler5_PlanetDesc, 5, 5) = {__TDFLDS("PlanetDesc", 24), {4, 8, 12, 16, 20, -24}};

export void *Kepler5__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(KeplerFrames);
	__IMPORT(KeplerGraphs);
	__IMPORT(KeplerPorts);
	__IMPORT(Oberon);
	__REGMOD(Kepler5, 0);
	__REGCMD("NewFocusStar", Kepler5_NewFocusStar);
	__REGCMD("NewFocusStar2", Kepler5_NewFocusStar2);
	__REGCMD("NewPlanet", Kepler5_NewPlanet);
	__REGCMD("NewSelStar", Kepler5_NewSelStar);
	__INITYP(Kepler5_StarDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler5_StarDesc, Kepler5_FocusStar_Draw, 0);
	__INITYP(Kepler5_StarDesc2, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler5_StarDesc2, Kepler5_FocusStar2_Draw, 0);
	__INITYP(Kepler5_SelStarDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler5_SelStarDesc, Kepler5_SelStar_Draw, 0);
	__INITYP(Kepler5_PlanetDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(Kepler5_PlanetDesc, Kepler5_Planet_Draw, 0);
/* BEGIN */
	__ENDMOD;
}
