/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Kepler2.h"
#include "KeplerFrames.h"
#include "KeplerGraphs.h"
#include "KeplerPorts.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"

typedef
	struct Kepler7_FrameDesc *Kepler7_Frame;

typedef
	struct Kepler7_TextDesc *Kepler7_Text;

typedef
	struct Kepler7_FrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		Kepler7_Text keplerText;
		KeplerGraphs_Graph graph;
	} Kepler7_FrameDesc;

typedef
	struct Kepler7_TextDesc { /* KeplerFrames_ButtonDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		CHAR cmd[32], par[32];
		Texts_Text text;
	} Kepler7_TextDesc;

export void Kepler7_Text_Draw (Kepler7_Text t, KeplerPorts_Port f);
export void Kepler7_Text_HandleMouse (Kepler7_Text t, KeplerFrames_Frame f, INTEGER x, INTEGER y, SET keys);
export void Kepler7_Text_Read (Kepler7_Text t, Files_Rider *r, LONGINT *r__typ);
export void Kepler7_Text_Write (Kepler7_Text t, Files_Rider *r, LONGINT *r__typ);



export LONGINT *Kepler7_TextDesc__typ;
export LONGINT *Kepler7_FrameDesc__typ;

static void Kepler7_CopyText (Texts_Text srcText, Texts_Text *dstText);
export void Kepler7_NewText (void);
export void Kepler7_Update (void);


static void Kepler7_CopyText (Texts_Text srcText, Texts_Text *dstText)
{
	Texts_Buffer b = NIL;
	__NEW(*dstText, Texts_TextDesc);
	Texts_Open(*dstText, (CHAR*)"", (LONGINT)1);
	(*dstText)->notify = srcText->notify;
	__NEW(b, Texts_BufDesc);
	Texts_OpenBuf(b);
	Texts_Save(srcText, 0, srcText->len, b);
	Texts_Append(*dstText, b);
}

void Kepler7_Text_HandleMouse (Kepler7_Text t, KeplerFrames_Frame f, INTEGER x, INTEGER y, SET keys)
{
	INTEGER X = 0, Y = 0;
	SET keySum = 0;
	Texts_Text newText = NIL;
	Kepler7_Frame tf = NIL;
	MenuViewers_Viewer v = NIL;
	if (keys == 0x02) {
		keySum = keys;
		do {
			__KeplerFrames_Frame_TrackMouse(f, x, y, keys);
			KeplerFrames_GetMouse(f, &x, &y, &keys);
			keySum = keySum | keys;
		} while (!(keys == 0x0));
		if (keySum == 0x02) {
			Kepler7_CopyText(t->text, &newText);
			__NEW(tf, Kepler7_FrameDesc);
			TextFrames_Open((void*)tf, newText, 0);
			tf->keplerText = t;
			tf->graph = f->G;
			Oberon_AllocateUserViewer(Oberon_Mouse.X, &X, &Y);
			v = MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"KeplerText", (LONGINT)11, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Search  Edit.Replace  Kepler7.Update ", (LONGINT)83), (void*)tf, TextFrames_menuH, X, Y);
		}
	}
}

void Kepler7_Text_Draw (Kepler7_Text t, KeplerPorts_Port f)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	CHAR line[256];
	INTEGER i = 0, xBase = 0, xOff = 0, y = 0, lineHeight = 0, oldNegOff = 0, negOff = 0;
	LONGINT lineBeg = 0;
	Fonts_Font curFont = NIL;
	SHORTINT curCol = 0, curVoff = 0;
	lineBeg = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t->text, lineBeg);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	xBase = t->p[0]->x;
	xOff = 0;
	y = t->p[0]->y;
	oldNegOff = 0;
	negOff = 0;
	while (!r.eot) {
		lineHeight = __ASHL(r.fnt->maxY, 2) + (int)r.voff;
		while (!r.eot && ch != 0x0d) {
			if (__ASHL(r.fnt->maxY, 2) + (int)r.voff > lineHeight) {
				lineHeight = __ASHL(r.fnt->maxY, 2) + (int)r.voff;
			}
			if ((int)r.voff + __ASHL(r.fnt->minY, 2) < negOff) {
				negOff = (int)r.voff + __ASHL(r.fnt->minY, 2);
			}
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		xOff = 0;
		Texts_OpenReader(&r, Texts_Reader__typ, t->text, lineBeg);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		if (ch == 0x0d && __ISP(f, KeplerPorts_BalloonPortDesc, 2)) {
			line[0] = 'l';
			line[1] = 0x00;
			__KeplerPorts_Port_DrawString(f, xBase, (y - lineHeight) + oldNegOff, line, 256, r.fnt, r.col, 0);
		}
		while (!r.eot && ch != 0x0d) {
			i = 0;
			curFont = r.fnt;
			curCol = r.col;
			curVoff = r.voff;
			while (((((!r.eot && ch != 0x0d) && curFont == r.fnt) && curCol == r.col) && curVoff == r.voff) && i < 255) {
				line[__X(i, 256)] = ch;
				i += 1;
				Texts_Read(&r, Texts_Reader__typ, &ch);
			}
			line[__X(i, 256)] = 0x00;
			__KeplerPorts_Port_DrawString(f, xBase + xOff, ((y + (int)curVoff) - lineHeight) + oldNegOff, line, 256, curFont, curCol, 0);
			xOff += KeplerPorts_StringWidth((void*)line, 256, curFont);
		}
		y -= lineHeight - oldNegOff;
		oldNegOff = negOff;
		negOff = 0;
		lineBeg = Texts_Pos(&r, Texts_Reader__typ);
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
}

void Kepler7_Text_Read (Kepler7_Text t, Files_Rider *r, LONGINT *r__typ)
{
	__NEW(t->text, Texts_TextDesc);
	Texts_Load(&*r, r__typ, t->text);
	t->text->notify = TextFrames_NotifyDisplay;
	KeplerFrames_Button_Read((void*)t, &*r, r__typ);
}

void Kepler7_Text_Write (Kepler7_Text t, Files_Rider *r, LONGINT *r__typ)
{
	Texts_Store(&*r, r__typ, t->text);
	KeplerFrames_Button_Write((void*)t, &*r, r__typ);
}

void Kepler7_Update (void)
{
	Kepler7_Frame f = NIL;
	KeplerPorts_BalloonPort balloon1 = NIL, balloon2 = NIL;
	Kepler2_Offset textCorner = NIL;
	INTEGER dx = 0, dy = 0;
	Texts_Text T = NIL;
	Texts_Reader R = {0};
	CHAR ch = 0;
	if (__ISP(Oberon_Par->vwr->dsc->next, Kepler7_FrameDesc, 2)) {
		f = __GUARDP(Oberon_Par->vwr->dsc->next, Kepler7_FrameDesc, 2);
		__NEW(balloon1, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(balloon1);
		__KeplerGraphs_Object_Draw((void*)f->keplerText, (void*)balloon1);
		Kepler7_CopyText(f->text, &f->keplerText->text);
		__NEW(balloon2, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(balloon2);
		__KeplerGraphs_Object_Draw((void*)f->keplerText, (void*)balloon2);
		textCorner = __GUARDP(f->keplerText->p[1], Kepler2_OffsetDesc, 3);
		if (balloon2->W <= 0 || balloon2->H <= 0) {
			dx = 100 - textCorner->dx;
			dy = -100 - textCorner->dy;
			textCorner->dx = 100;
			textCorner->dy = -100;
		} else {
			dx = balloon2->W - textCorner->dx;
			dy = -balloon2->H - textCorner->dy;
			textCorner->dx = balloon2->W;
			textCorner->dy = -balloon2->H;
		}
		__KeplerGraphs_Graph_Move(f->graph, (void*)textCorner, dx, dy);
		__KeplerGraphs_Planet_Calc((void*)textCorner);
		__KeplerGraphs_Object_Draw((void*)f->keplerText, (void*)balloon1);
		__KeplerGraphs_Object_Draw((void*)textCorner, (void*)balloon1);
		(*f->graph->notify)(1, f->graph, (void*)f->keplerText, (void*)balloon1);
		T = __GUARDP(Oberon_Par->vwr->dsc, TextFrames_FrameDesc, 1)->text;
		Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		if (ch == '!') {
			Texts_Delete(T, T->len - 1, T->len);
		}
	}
}

void Kepler7_NewText (void)
{
	Kepler7_Text t = NIL;
	Kepler2_Offset corner = NIL;
	Texts_Text sel = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Buffer b = NIL;
	KeplerPorts_BalloonPort balloon = NIL;
	Texts_Writer W = {0};
	if (KeplerFrames_nofpts >= 1) {
		__NEW(t, Kepler7_TextDesc);
		__NEW(corner, Kepler2_OffsetDesc);
		__NEW(corner->c, KeplerGraphs_ConsDesc);
		t->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
		t->nofpts = 2;
		t->cmd[0] = 0x00;
		t->par[0] = 0x00;
		KeplerFrames_ConsumePoint(&t->p[0]);
		corner->c->nofpts = 1;
		corner->c->p[0] = t->p[0];
		t->p[0]->refcnt += 1;
		t->p[1] = (KeplerGraphs_Star)corner;
		corner->refcnt = 1;
		Oberon_GetSelection(&sel, &beg, &end, &time);
		if (time < 0 || beg == end) {
			Texts_OpenWriter(&W, Texts_Writer__typ);
			Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"no selection", (LONGINT)13);
			Texts_Append(t->text, W.buf);
		} else {
			__NEW(b, Texts_BufDesc);
			Texts_OpenBuf(b);
			Texts_Save(sel, beg, end, b);
			Texts_Append(t->text, b);
		}
		__NEW(balloon, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(balloon);
		__KeplerGraphs_Object_Draw((void*)t, (void*)balloon);
		corner->dx = balloon->W;
		corner->dy = -balloon->H;
		__KeplerGraphs_Planet_Calc((void*)corner);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)corner);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)t);
	}
}

__TDESC(Kepler7_TextDesc, 7, 6) = {__TDFLDS("TextDesc", 92), {4, 8, 12, 16, 20, 88, -28}};
__TDESC(Kepler7_FrameDesc, 1, 10) = {__TDFLDS("FrameDesc", 128), {0, 4, 20, 68, 88, 108, 112, 116, 120, 124, -44}};

export void *Kepler7__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Kepler2);
	__IMPORT(KeplerFrames);
	__IMPORT(KeplerGraphs);
	__IMPORT(KeplerPorts);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__REGMOD(Kepler7, 0);
	__REGCMD("NewText", Kepler7_NewText);
	__REGCMD("Update", Kepler7_Update);
	__INITYP(Kepler7_TextDesc, KeplerFrames_ButtonDesc, 3);
	__INITBP(Kepler7_TextDesc, Kepler7_Text_Draw, 0);
	__INITBP(Kepler7_TextDesc, Kepler7_Text_HandleMouse, 5);
	__INITBP(Kepler7_TextDesc, Kepler7_Text_Read, 1);
	__INITBP(Kepler7_TextDesc, Kepler7_Text_Write, 2);
	__INITYP(Kepler7_FrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	__ENDMOD;
}
