/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Files.h"
#include "KeplerFrames.h"
#include "KeplerGraphs.h"
#include "Math.h"

typedef
	struct Kepler9_CircleIntersection *Kepler9_CircleInter;

typedef
	struct Kepler9_CircleIntersection { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
		SHORTINT sign;
	} Kepler9_CircleIntersection;

export void Kepler9_CircleInter_Calc (Kepler9_CircleInter self);
export void Kepler9_CircleInter_Read (Kepler9_CircleInter self, Files_Rider *r, LONGINT *r__typ);
export void Kepler9_CircleInter_Write (Kepler9_CircleInter self, Files_Rider *r, LONGINT *r__typ);

typedef
	struct Kepler9_CircleLineIntersection *Kepler9_CircleLineInter;

typedef
	struct Kepler9_CircleLineIntersection { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
		SHORTINT sign;
	} Kepler9_CircleLineIntersection;

export void Kepler9_CircleLineInter_Calc (Kepler9_CircleLineInter self);
export void Kepler9_CircleLineInter_Read (Kepler9_CircleLineInter self, Files_Rider *r, LONGINT *r__typ);
export void Kepler9_CircleLineInter_Write (Kepler9_CircleLineInter self, Files_Rider *r, LONGINT *r__typ);

typedef
	struct Kepler9_ExtensionDesc *Kepler9_Extension;

typedef
	struct Kepler9_ExtensionDesc { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
	} Kepler9_ExtensionDesc;

export void Kepler9_Extension_Calc (Kepler9_Extension self);

typedef
	struct Kepler9_IntersectionDesc *Kepler9_Intersection;

typedef
	struct Kepler9_IntersectionDesc { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
	} Kepler9_IntersectionDesc;

export void Kepler9_Intersection_Calc (Kepler9_Intersection self);

typedef
	struct Kepler9_ParallelDesc *Kepler9_Parallel;

typedef
	struct Kepler9_ParallelDesc { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
	} Kepler9_ParallelDesc;

export void Kepler9_Parallel_Calc (Kepler9_Parallel self);

typedef
	struct Kepler9_RightAngleDesc *Kepler9_RightAngle;

typedef
	struct Kepler9_RightAngleDesc { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
	} Kepler9_RightAngleDesc;

export void Kepler9_RightAngle_Calc (Kepler9_RightAngle self);

typedef
	struct Kepler9_TangentDesc *Kepler9_Tangent;

typedef
	struct Kepler9_TangentDesc { /* KeplerGraphs_PlanetDesc */
		INTEGER x, y, refcnt;
		char _prvt0[2];
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
		SHORTINT sign;
	} Kepler9_TangentDesc;

export void Kepler9_Tangent_Calc (Kepler9_Tangent self);
export void Kepler9_Tangent_Read (Kepler9_Tangent self, Files_Rider *r, LONGINT *r__typ);
export void Kepler9_Tangent_Write (Kepler9_Tangent self, Files_Rider *r, LONGINT *r__typ);



export LONGINT *Kepler9_ParallelDesc__typ;
export LONGINT *Kepler9_RightAngleDesc__typ;
export LONGINT *Kepler9_IntersectionDesc__typ;
export LONGINT *Kepler9_ExtensionDesc__typ;
export LONGINT *Kepler9_TangentDesc__typ;
export LONGINT *Kepler9_CircleIntersection__typ;
export LONGINT *Kepler9_CircleLineIntersection__typ;

export void Kepler9_NewCircleIntersection (void);
export void Kepler9_NewCircleLineIntersect (void);
export void Kepler9_NewExtension (void);
export void Kepler9_NewLineIntersection (void);
export void Kepler9_NewParallel (void);
export void Kepler9_NewRightAngle (void);
export void Kepler9_NewTangent (void);


void Kepler9_Parallel_Calc (Kepler9_Parallel self)
{
	self->x = (self->c->p[2]->x + self->c->p[1]->x) - self->c->p[0]->x;
	self->y = (self->c->p[2]->y + self->c->p[1]->y) - self->c->p[0]->y;
}

void Kepler9_NewParallel (void)
{
	Kepler9_Parallel new = NIL;
	if (KeplerFrames_nofpts >= 3) {
		__NEW(new, Kepler9_ParallelDesc);
		__NEW(new->c, KeplerGraphs_ConsDesc);
		new->c->nofpts = 3;
		KeplerFrames_ConsumePoint(&new->c->p[0]);
		KeplerFrames_ConsumePoint(&new->c->p[1]);
		KeplerFrames_ConsumePoint(&new->c->p[2]);
		__KeplerGraphs_Planet_Calc((void*)new);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new);
	}
}

void Kepler9_RightAngle_Calc (Kepler9_RightAngle self)
{
	LONGINT x0 = 0, y0 = 0, x1 = 0, y1 = 0, x2 = 0, y2 = 0;
	REAL f = 0;
	x0 = self->c->p[0]->x;
	y0 = self->c->p[0]->y;
	x1 = self->c->p[1]->x;
	y1 = self->c->p[1]->y;
	x2 = self->c->p[2]->x;
	y2 = self->c->p[2]->y;
	f = ((x1 - x0) * (x2 - x0) + (y1 - y0) * (y2 - y0)) / (REAL)((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0));
	self->x = (int)__ENTIER(x0 + (x1 - x0) * f);
	self->y = (int)__ENTIER(y0 + (y1 - y0) * f);
}

void Kepler9_NewRightAngle (void)
{
	Kepler9_RightAngle new = NIL;
	if (KeplerFrames_nofpts >= 3) {
		__NEW(new, Kepler9_RightAngleDesc);
		__NEW(new->c, KeplerGraphs_ConsDesc);
		new->c->nofpts = 3;
		KeplerFrames_ConsumePoint(&new->c->p[0]);
		KeplerFrames_ConsumePoint(&new->c->p[1]);
		KeplerFrames_ConsumePoint(&new->c->p[2]);
		__KeplerGraphs_Planet_Calc((void*)new);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new);
	}
}

void Kepler9_Intersection_Calc (Kepler9_Intersection self)
{
	LONGINT f = 0, x0 = 0, y0 = 0, x1 = 0, y1 = 0, x2 = 0, y2 = 0, x3 = 0, y3 = 0;
	x0 = self->c->p[0]->x;
	y0 = self->c->p[0]->y;
	x1 = self->c->p[1]->x;
	y1 = self->c->p[1]->y;
	x2 = self->c->p[2]->x;
	y2 = self->c->p[2]->y;
	x3 = self->c->p[3]->x;
	y3 = self->c->p[3]->y;
	f = (x3 - x2) * (y1 - y0) - (x1 - x0) * (y3 - y2);
	if (f != 0) {
		self->x = (int)__DIV((((x3 - x2) * (x1 - x0)) * (y2 - y0) + ((x3 - x2) * (y1 - y0)) * x0) - ((x1 - x0) * (y3 - y2)) * x2, f);
		self->y = (int)__DIV((((y3 - y2) * (y1 - y0)) * (x2 - x0) + ((y3 - y2) * (x1 - x0)) * y0) - ((y1 - y0) * (x3 - x2)) * y2, -f);
	}
}

void Kepler9_NewLineIntersection (void)
{
	Kepler9_Intersection new = NIL;
	if (KeplerFrames_nofpts >= 4) {
		__NEW(new, Kepler9_IntersectionDesc);
		__NEW(new->c, KeplerGraphs_ConsDesc);
		new->c->nofpts = 4;
		KeplerFrames_ConsumePoint(&new->c->p[0]);
		KeplerFrames_ConsumePoint(&new->c->p[1]);
		KeplerFrames_ConsumePoint(&new->c->p[2]);
		KeplerFrames_ConsumePoint(&new->c->p[3]);
		__KeplerGraphs_Planet_Calc((void*)new);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new);
	}
}

void Kepler9_CircleInter_Calc (Kepler9_CircleInter self)
{
	REAL M1x = 0, M2x = 0, M1y = 0, M2y = 0, R1x = 0, R2x = 0, R1y = 0, R2y = 0, mx = 0, my = 0, d = 0, c = 0, s = 0, r1 = 0, r2 = 0, qx = 0, qy = 0, h = 0;
	M1x = self->c->p[0]->x;
	M2x = self->c->p[2]->x;
	M1y = self->c->p[0]->y;
	M2y = self->c->p[2]->y;
	R1x = self->c->p[1]->x;
	R2x = self->c->p[3]->x;
	R1y = self->c->p[1]->y;
	R2y = self->c->p[3]->y;
	mx = M2x - M1x;
	my = M2y - M1y;
	d = Math_sqrt(mx * mx + my * my);
	if (d != (REAL)0) {
		c = my / d;
		s = -(mx / d);
		r1 = (M1x - R1x) * (M1x - R1x) + (M1y - R1y) * (M1y - R1y);
		r2 = (M2x - R2x) * (M2x - R2x) + (M2y - R2y) * (M2y - R2y);
		qy = (d + (r1 - r2) / d) / (REAL)(REAL)2;
		h = r1 - qy * qy;
		if (h >= (REAL)0) {
			qx = self->sign * Math_sqrt(h);
			self->x = (int)__ENTIER((c * qx - s * qy) + M1x);
			self->y = (int)__ENTIER((s * qx + c * qy) + M1y);
		}
	}
}

void Kepler9_CircleInter_Read (Kepler9_CircleInter self, Files_Rider *r, LONGINT *r__typ)
{
	Files_Read(&*r, r__typ, (void*)&self->sign);
	KeplerGraphs_Planet_Read((void*)self, &*r, r__typ);
}

void Kepler9_CircleInter_Write (Kepler9_CircleInter self, Files_Rider *r, LONGINT *r__typ)
{
	Files_Write(&*r, r__typ, self->sign);
	KeplerGraphs_Planet_Write((void*)self, &*r, r__typ);
}

void Kepler9_NewCircleIntersection (void)
{
	Kepler9_CircleInter new1 = NIL, new2 = NIL;
	if (KeplerFrames_nofpts >= 4) {
		__NEW(new1, Kepler9_CircleIntersection);
		new1->sign = 1;
		__NEW(new1->c, KeplerGraphs_ConsDesc);
		new1->c->nofpts = 4;
		__NEW(new2, Kepler9_CircleIntersection);
		new2->sign = -1;
		__NEW(new2->c, KeplerGraphs_ConsDesc);
		new2->c->nofpts = 4;
		KeplerFrames_ConsumePoint(&new1->c->p[0]);
		KeplerFrames_ConsumePoint(&new1->c->p[1]);
		KeplerFrames_ConsumePoint(&new1->c->p[2]);
		KeplerFrames_ConsumePoint(&new1->c->p[3]);
		new2->c->p[0] = new1->c->p[0];
		new1->c->p[0]->refcnt += 1;
		new2->c->p[1] = new1->c->p[1];
		new1->c->p[1]->refcnt += 1;
		new2->c->p[2] = new1->c->p[2];
		new1->c->p[2]->refcnt += 1;
		new2->c->p[3] = new1->c->p[3];
		new1->c->p[3]->refcnt += 1;
		__KeplerGraphs_Planet_Calc((void*)new1);
		__KeplerGraphs_Planet_Calc((void*)new2);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new1);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new2);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new1);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new2);
	}
}

void Kepler9_CircleLineInter_Calc (Kepler9_CircleLineInter self)
{
	REAL M1x = 0, L1x = 0, M1y = 0, L1y = 0, R1x = 0, L2x = 0, R1y = 0, L2y = 0, M2x = 0, M2y = 0, mx = 0, my = 0, d = 0, c = 0, s = 0, r1 = 0, qy = 0, h = 0;
	M1x = self->c->p[0]->x;
	L1x = self->c->p[2]->x;
	M1y = self->c->p[0]->y;
	L1y = self->c->p[2]->y;
	R1x = self->c->p[1]->x;
	L2x = self->c->p[3]->x;
	R1y = self->c->p[1]->y;
	L2y = self->c->p[3]->y;
	mx = L2x - L1x;
	my = L2y - L1y;
	d = Math_sqrt(mx * mx + my * my);
	if (d != (REAL)0) {
		c = my / d;
		s = -(mx / d);
		r1 = (M1x - R1x) * (M1x - R1x) + (M1y - R1y) * (M1y - R1y);
		M1x = M1x - L2x;
		M1y = M1y - L2y;
		M2x = c * M1x + s * M1y;
		M2y = c * M1y - s * M1x;
		h = r1 - M2x * M2x;
		if (h >= (REAL)0) {
			qy = self->sign * Math_sqrt(h) + M2y;
			self->x = (int)__ENTIER(-(s * qy) + L2x);
			self->y = (int)__ENTIER(c * qy + L2y);
		}
	}
}

void Kepler9_CircleLineInter_Read (Kepler9_CircleLineInter self, Files_Rider *r, LONGINT *r__typ)
{
	Files_Read(&*r, r__typ, (void*)&self->sign);
	KeplerGraphs_Planet_Read((void*)self, &*r, r__typ);
}

void Kepler9_CircleLineInter_Write (Kepler9_CircleLineInter self, Files_Rider *r, LONGINT *r__typ)
{
	Files_Write(&*r, r__typ, self->sign);
	KeplerGraphs_Planet_Write((void*)self, &*r, r__typ);
}

void Kepler9_NewCircleLineIntersect (void)
{
	Kepler9_CircleLineInter new1 = NIL, new2 = NIL;
	if (KeplerFrames_nofpts >= 4) {
		__NEW(new1, Kepler9_CircleLineIntersection);
		new1->sign = 1;
		__NEW(new1->c, KeplerGraphs_ConsDesc);
		new1->c->nofpts = 4;
		__NEW(new2, Kepler9_CircleLineIntersection);
		new2->sign = -1;
		__NEW(new2->c, KeplerGraphs_ConsDesc);
		new2->c->nofpts = 4;
		KeplerFrames_ConsumePoint(&new1->c->p[0]);
		KeplerFrames_ConsumePoint(&new1->c->p[1]);
		KeplerFrames_ConsumePoint(&new1->c->p[2]);
		KeplerFrames_ConsumePoint(&new1->c->p[3]);
		new2->c->p[0] = new1->c->p[0];
		new1->c->p[0]->refcnt += 1;
		new2->c->p[1] = new1->c->p[1];
		new1->c->p[1]->refcnt += 1;
		new2->c->p[2] = new1->c->p[2];
		new1->c->p[2]->refcnt += 1;
		new2->c->p[3] = new1->c->p[3];
		new1->c->p[3]->refcnt += 1;
		__KeplerGraphs_Planet_Calc((void*)new1);
		__KeplerGraphs_Planet_Calc((void*)new2);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new1);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new2);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new1);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new2);
	}
}

void Kepler9_Extension_Calc (Kepler9_Extension self)
{
	self->x = __ASHL(self->c->p[1]->x, 1) - self->c->p[0]->x;
	self->y = __ASHL(self->c->p[1]->y, 1) - self->c->p[0]->y;
}

void Kepler9_NewExtension (void)
{
	Kepler9_Extension new = NIL;
	if (KeplerFrames_nofpts >= 2) {
		__NEW(new, Kepler9_ExtensionDesc);
		__NEW(new->c, KeplerGraphs_ConsDesc);
		new->c->nofpts = 2;
		KeplerFrames_ConsumePoint(&new->c->p[0]);
		KeplerFrames_ConsumePoint(&new->c->p[1]);
		__KeplerGraphs_Planet_Calc((void*)new);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new);
		__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new);
	}
}

void Kepler9_Tangent_Calc (Kepler9_Tangent self)
{
	LONGINT x0 = 0, x1 = 0, x2 = 0, y0 = 0, y1 = 0, y2 = 0;
	REAL r2 = 0, d2 = 0, x3 = 0, y3 = 0, faktor = 0;
	x0 = self->c->p[0]->x;
	x1 = self->c->p[1]->x;
	x2 = self->c->p[2]->x;
	y0 = self->c->p[0]->y;
	y1 = self->c->p[1]->y;
	y2 = self->c->p[2]->y;
	r2 = (x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0);
	d2 = (x2 - x0) * (x2 - x0) + (y2 - y0) * (y2 - y0);
	if (r2 < d2) {
		x3 = x0 + ((x2 - x0) * r2) / d2;
		y3 = y0 + ((y2 - y0) * r2) / d2;
		faktor = Math_sqrt(r2 / d2 - ((r2 * r2) / d2) / d2);
		self->x = (int)__ENTIER(x3 + (self->sign * faktor) * (y2 - y0));
		self->y = (int)__ENTIER(y3 + (self->sign * faktor) * (x0 - x2));
	}
}

void Kepler9_Tangent_Read (Kepler9_Tangent self, Files_Rider *r, LONGINT *r__typ)
{
	Files_Read(&*r, r__typ, (void*)&self->sign);
	KeplerGraphs_Planet_Read((void*)self, &*r, r__typ);
}

void Kepler9_Tangent_Write (Kepler9_Tangent self, Files_Rider *r, LONGINT *r__typ)
{
	Files_Write(&*r, r__typ, self->sign);
	KeplerGraphs_Planet_Write((void*)self, &*r, r__typ);
}

void Kepler9_NewTangent (void)
{
	Kepler9_Tangent new = NIL;
	KeplerGraphs_Star p0 = NIL, p1 = NIL, p2 = NIL;
	SHORTINT i = 0;
	if (KeplerFrames_nofpts >= 3) {
		KeplerFrames_ConsumePoint(&p0);
		p0->refcnt += 1;
		KeplerFrames_ConsumePoint(&p1);
		p1->refcnt += 1;
		KeplerFrames_ConsumePoint(&p2);
		p2->refcnt += 1;
		i = 0;
		while (i <= 1) {
			__NEW(new, Kepler9_TangentDesc);
			new->sign = __ASHL(i, 1) - 1;
			__NEW(new->c, KeplerGraphs_ConsDesc);
			new->c->nofpts = 3;
			new->c->p[0] = p0;
			new->c->p[1] = p1;
			new->c->p[2] = p2;
			__KeplerGraphs_Planet_Calc((void*)new);
			__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)new);
			__KeplerGraphs_Graph_FlipSelection(KeplerFrames_Focus, (void*)new);
			i += 1;
		}
	}
}

__TDESC(Kepler9_ParallelDesc, 5, 2) = {__TDFLDS("ParallelDesc", 20), {12, 16, -12}};
__TDESC(Kepler9_RightAngleDesc, 5, 2) = {__TDFLDS("RightAngleDesc", 20), {12, 16, -12}};
__TDESC(Kepler9_IntersectionDesc, 5, 2) = {__TDFLDS("IntersectionDesc", 20), {12, 16, -12}};
__TDESC(Kepler9_ExtensionDesc, 5, 2) = {__TDFLDS("ExtensionDesc", 20), {12, 16, -12}};
__TDESC(Kepler9_TangentDesc, 5, 2) = {__TDFLDS("TangentDesc", 24), {12, 16, -12}};
__TDESC(Kepler9_CircleIntersection, 5, 2) = {__TDFLDS("CircleIntersection", 24), {12, 16, -12}};
__TDESC(Kepler9_CircleLineIntersection, 5, 2) = {__TDFLDS("CircleLineIntersection", 24), {12, 16, -12}};

export void *Kepler9__init(void)
{
	__DEFMOD;
	__IMPORT(Files);
	__IMPORT(KeplerFrames);
	__IMPORT(KeplerGraphs);
	__IMPORT(Math);
	__REGMOD(Kepler9, 0);
	__REGCMD("NewCircleIntersection", Kepler9_NewCircleIntersection);
	__REGCMD("NewCircleLineIntersect", Kepler9_NewCircleLineIntersect);
	__REGCMD("NewExtension", Kepler9_NewExtension);
	__REGCMD("NewLineIntersection", Kepler9_NewLineIntersection);
	__REGCMD("NewParallel", Kepler9_NewParallel);
	__REGCMD("NewRightAngle", Kepler9_NewRightAngle);
	__REGCMD("NewTangent", Kepler9_NewTangent);
	__INITYP(Kepler9_ParallelDesc, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_ParallelDesc, Kepler9_Parallel_Calc, 3);
	__INITYP(Kepler9_RightAngleDesc, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_RightAngleDesc, Kepler9_RightAngle_Calc, 3);
	__INITYP(Kepler9_IntersectionDesc, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_IntersectionDesc, Kepler9_Intersection_Calc, 3);
	__INITYP(Kepler9_ExtensionDesc, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_ExtensionDesc, Kepler9_Extension_Calc, 3);
	__INITYP(Kepler9_TangentDesc, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_TangentDesc, Kepler9_Tangent_Calc, 3);
	__INITBP(Kepler9_TangentDesc, Kepler9_Tangent_Read, 1);
	__INITBP(Kepler9_TangentDesc, Kepler9_Tangent_Write, 2);
	__INITYP(Kepler9_CircleIntersection, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_CircleIntersection, Kepler9_CircleInter_Calc, 3);
	__INITBP(Kepler9_CircleIntersection, Kepler9_CircleInter_Read, 1);
	__INITBP(Kepler9_CircleIntersection, Kepler9_CircleInter_Write, 2);
	__INITYP(Kepler9_CircleLineIntersection, KeplerGraphs_PlanetDesc, 3);
	__INITBP(Kepler9_CircleLineIntersection, Kepler9_CircleLineInter_Calc, 3);
	__INITBP(Kepler9_CircleLineIntersection, Kepler9_CircleLineInter_Read, 1);
	__INITBP(Kepler9_CircleLineIntersection, Kepler9_CircleLineInter_Write, 2);
/* BEGIN */
	__ENDMOD;
}
