/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "KeplerPorts.h"
#include "Modules.h"
#include "Oberon.h"
#include "Texts.h"
#include "Types.h"

typedef
	struct KeplerGraphs_ObjectDesc {
		char _prvt0[1];
	} KeplerGraphs_ObjectDesc;

typedef
	KeplerGraphs_ObjectDesc *KeplerGraphs_Object;

export void KeplerGraphs_Object_Draw (KeplerGraphs_Object self, KeplerPorts_Port P);
export void KeplerGraphs_Object_Read (KeplerGraphs_Object self, Files_Rider *R, LONGINT *R__typ);
export void KeplerGraphs_Object_Write (KeplerGraphs_Object self, Files_Rider *R, LONGINT *R__typ);
#define __KeplerGraphs_Object_Draw(self, P) __SEND(__TYPEOF(self), 0, void(*)(KeplerGraphs_Object, KeplerPorts_Port), (self, P))
#define __KeplerGraphs_Object_Read(self, R, R__typ) __SEND(__TYPEOF(self), 1, void(*)(KeplerGraphs_Object, Files_Rider*, LONGINT *), (self, R, R__typ))
#define __KeplerGraphs_Object_Write(self, R, R__typ) __SEND(__TYPEOF(self), 2, void(*)(KeplerGraphs_Object, Files_Rider*, LONGINT *), (self, R, R__typ))

typedef
	struct KeplerGraphs_StarDesc *KeplerGraphs_Star;

typedef
	struct KeplerGraphs_ConsDesc *KeplerGraphs_Constellation;

typedef
	struct KeplerGraphs_ConsDesc { /* KeplerGraphs_ObjectDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
	} KeplerGraphs_ConsDesc;

export void KeplerGraphs_Constellation_Read (KeplerGraphs_Constellation self, Files_Rider *R, LONGINT *R__typ);
export INTEGER KeplerGraphs_Constellation_State (KeplerGraphs_Constellation self);
export void KeplerGraphs_Constellation_Write (KeplerGraphs_Constellation self, Files_Rider *R, LONGINT *R__typ);
#define __KeplerGraphs_Constellation_State(self) __SEND(__TYPEOF(self), 3, INTEGER(*)(KeplerGraphs_Constellation), (self))

typedef
	struct KeplerGraphs_GraphDesc *KeplerGraphs_Graph;

typedef
	void (*KeplerGraphs_Notifier)(INTEGER, KeplerGraphs_Graph, KeplerGraphs_Object, KeplerPorts_Port);

typedef
	struct KeplerGraphs_GraphDesc { /* KeplerGraphs_ObjectDesc */
		KeplerGraphs_Constellation cons, lastcons;
		KeplerGraphs_Star stars, laststar;
		LONGINT seltime;
		KeplerGraphs_Notifier notify;
	} KeplerGraphs_GraphDesc;

export void KeplerGraphs_Graph_All (KeplerGraphs_Graph G, INTEGER op);
export void KeplerGraphs_Graph_Append (KeplerGraphs_Graph G, KeplerGraphs_Object o);
export void KeplerGraphs_Graph_CopySelection (KeplerGraphs_Graph G, KeplerGraphs_Graph from, INTEGER dx, INTEGER dy);
export void KeplerGraphs_Graph_Delete (KeplerGraphs_Graph G, KeplerGraphs_Object o);
export void KeplerGraphs_Graph_DeleteSelection (KeplerGraphs_Graph G, INTEGER minstate);
export void KeplerGraphs_Graph_Draw (KeplerGraphs_Graph G, KeplerPorts_Port P);
export void KeplerGraphs_Graph_FlipSelection (KeplerGraphs_Graph G, KeplerGraphs_Star p);
export void KeplerGraphs_Graph_Insert (KeplerGraphs_Graph G, KeplerGraphs_Constellation c, KeplerGraphs_Constellation before);
export void KeplerGraphs_Graph_Move (KeplerGraphs_Graph G, KeplerGraphs_Star s, INTEGER dx, INTEGER dy);
export void KeplerGraphs_Graph_MoveSelection (KeplerGraphs_Graph G, INTEGER dx, INTEGER dy);
export void KeplerGraphs_Graph_Read (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ);
export void KeplerGraphs_Graph_SendToBack (KeplerGraphs_Graph G, KeplerGraphs_Object obj);
export void KeplerGraphs_Graph_Write (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ);
export void KeplerGraphs_Graph_WriteSel (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ);
#define __KeplerGraphs_Graph_All(G, op) __SEND(__TYPEOF(G), 3, void(*)(KeplerGraphs_Graph, INTEGER), (G, op))
#define __KeplerGraphs_Graph_Append(G, o) __SEND(__TYPEOF(G), 4, void(*)(KeplerGraphs_Graph, KeplerGraphs_Object), (G, o))
#define __KeplerGraphs_Graph_CopySelection(G, from, dx, dy) __SEND(__TYPEOF(G), 5, void(*)(KeplerGraphs_Graph, KeplerGraphs_Graph, INTEGER, INTEGER), (G, from, dx, dy))
#define __KeplerGraphs_Graph_Delete(G, o) __SEND(__TYPEOF(G), 6, void(*)(KeplerGraphs_Graph, KeplerGraphs_Object), (G, o))
#define __KeplerGraphs_Graph_DeleteSelection(G, minstate) __SEND(__TYPEOF(G), 7, void(*)(KeplerGraphs_Graph, INTEGER), (G, minstate))
#define __KeplerGraphs_Graph_FlipSelection(G, p) __SEND(__TYPEOF(G), 8, void(*)(KeplerGraphs_Graph, KeplerGraphs_Star), (G, p))
#define __KeplerGraphs_Graph_Insert(G, c, before) __SEND(__TYPEOF(G), 9, void(*)(KeplerGraphs_Graph, KeplerGraphs_Constellation, KeplerGraphs_Constellation), (G, c, before))
#define __KeplerGraphs_Graph_Move(G, s, dx, dy) __SEND(__TYPEOF(G), 10, void(*)(KeplerGraphs_Graph, KeplerGraphs_Star, INTEGER, INTEGER), (G, s, dx, dy))
#define __KeplerGraphs_Graph_MoveSelection(G, dx, dy) __SEND(__TYPEOF(G), 11, void(*)(KeplerGraphs_Graph, INTEGER, INTEGER), (G, dx, dy))
#define __KeplerGraphs_Graph_SendToBack(G, obj) __SEND(__TYPEOF(G), 12, void(*)(KeplerGraphs_Graph, KeplerGraphs_Object), (G, obj))
#define __KeplerGraphs_Graph_WriteSel(G, R, R__typ) __SEND(__TYPEOF(G), 13, void(*)(KeplerGraphs_Graph, Files_Rider*, LONGINT *), (G, R, R__typ))

typedef
	struct KeplerGraphs_PlanetDesc *KeplerGraphs_Planet;

typedef
	struct KeplerGraphs_StarDesc { /* KeplerGraphs_ObjectDesc */
		INTEGER x, y, refcnt, ref;
		BOOLEAN sel;
		KeplerGraphs_Star next;
	} KeplerGraphs_StarDesc;

export void KeplerGraphs_Star_Draw (KeplerGraphs_Star self, KeplerPorts_Port P);
export void KeplerGraphs_Star_Read (KeplerGraphs_Star self, Files_Rider *R, LONGINT *R__typ);
export void KeplerGraphs_Star_Write (KeplerGraphs_Star self, Files_Rider *R, LONGINT *R__typ);

typedef
	struct KeplerGraphs_PlanetDesc { /* KeplerGraphs_StarDesc */
		INTEGER x, y, refcnt, ref;
		BOOLEAN sel;
		KeplerGraphs_Star next;
		KeplerGraphs_Constellation c;
	} KeplerGraphs_PlanetDesc;

export void KeplerGraphs_Planet_Calc (KeplerGraphs_Planet self);
export void KeplerGraphs_Planet_Draw (KeplerGraphs_Planet self, KeplerPorts_Port P);
export void KeplerGraphs_Planet_Read (KeplerGraphs_Planet self, Files_Rider *R, LONGINT *R__typ);
export void KeplerGraphs_Planet_Write (KeplerGraphs_Planet self, Files_Rider *R, LONGINT *R__typ);
#define __KeplerGraphs_Planet_Calc(self) __SEND(__TYPEOF(self), 3, void(*)(KeplerGraphs_Planet), (self))

typedef
	struct {
		LONGINT len[1];
		LONGINT data[1];
	} *KeplerGraphs_StarTab;


export KeplerGraphs_Graph KeplerGraphs_loading;
static KeplerPorts_BalloonPort KeplerGraphs_update;
static INTEGER KeplerGraphs_nofpt;
static KeplerGraphs_StarTab KeplerGraphs_starTab;
static LONGINT KeplerGraphs_noftypes;
static LONGINT KeplerGraphs_typTab[256];
static KeplerGraphs_Graph KeplerGraphs_del, KeplerGraphs_delG;

export LONGINT *KeplerGraphs_ObjectDesc__typ;
export LONGINT *KeplerGraphs_StarDesc__typ;
export LONGINT *KeplerGraphs_ConsDesc__typ;
export LONGINT *KeplerGraphs_PlanetDesc__typ;
export LONGINT *KeplerGraphs_GraphDesc__typ;

static void KeplerGraphs_CutCons (KeplerGraphs_Graph G, KeplerGraphs_Constellation prevc, KeplerGraphs_Constellation c);
static void KeplerGraphs_CutStar (KeplerGraphs_Graph G, KeplerGraphs_Star prevs, KeplerGraphs_Star s);
static void KeplerGraphs_DelStar (KeplerGraphs_Graph G, KeplerGraphs_Object o);
static BOOLEAN KeplerGraphs_DependsOn (KeplerGraphs_Constellation c, KeplerGraphs_Star s);
static void KeplerGraphs_DoubleStarTab (void);
static void KeplerGraphs_Dummy (INTEGER op, KeplerGraphs_Graph g, KeplerGraphs_Object c, KeplerPorts_Port f);
static KeplerGraphs_Star KeplerGraphs_GetStar (INTEGER n);
export void KeplerGraphs_GetType (KeplerGraphs_Object o, CHAR *module, LONGINT module__len, CHAR *type, LONGINT type__len);
export KeplerGraphs_Graph KeplerGraphs_Old (CHAR *name, LONGINT name__len);
export void KeplerGraphs_ReadObj (Files_Rider *R, LONGINT *R__typ, KeplerGraphs_Object *x);
export void KeplerGraphs_Recall (void);
static void KeplerGraphs_Release (KeplerGraphs_Constellation self);
export void KeplerGraphs_Reset (void);
static void KeplerGraphs_ReverseStars (KeplerGraphs_Graph G);
static void KeplerGraphs_Store (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ, BOOLEAN all);
static void KeplerGraphs_Unrelease (KeplerGraphs_Constellation c);
export void KeplerGraphs_WriteObj (Files_Rider *R, LONGINT *R__typ, KeplerGraphs_Object x);
static void KeplerGraphs_err (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len);
static void KeplerGraphs_err2 (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len);


void KeplerGraphs_Object_Draw (KeplerGraphs_Object self, KeplerPorts_Port P)
{
}

void KeplerGraphs_Object_Read (KeplerGraphs_Object self, Files_Rider *R, LONGINT *R__typ)
{
}

void KeplerGraphs_Object_Write (KeplerGraphs_Object self, Files_Rider *R, LONGINT *R__typ)
{
}

static void KeplerGraphs_err (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len)
{
	Texts_Writer W = {0};
	__DUP(s0, s0__len, CHAR);
	__DUP(s1, s1__len, CHAR);
	Texts_OpenWriter(&W, Texts_Writer__typ);
	Texts_WriteString(&W, Texts_Writer__typ, s0, s0__len);
	Texts_WriteString(&W, Texts_Writer__typ, s1, s1__len);
	Texts_WriteLn(&W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, W.buf);
	__DEL(s0);
	__DEL(s1);
}

static void KeplerGraphs_err2 (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len)
{
	Texts_Writer W = {0};
	__DUP(s0, s0__len, CHAR);
	__DUP(s1, s1__len, CHAR);
	Texts_OpenWriter(&W, Texts_Writer__typ);
	Texts_WriteString(&W, Texts_Writer__typ, s0, s0__len);
	Texts_WriteString(&W, Texts_Writer__typ, s1, s1__len);
	Texts_Append(Oberon_Log, W.buf);
	__DEL(s0);
	__DEL(s1);
}

void KeplerGraphs_ReadObj (Files_Rider *R, LONGINT *R__typ, KeplerGraphs_Object *x)
{
	LONGINT ref = 0;
	Modules_Module m = NIL;
	Types_Type t = NIL;
	CHAR module[32], type[32];
	*x = NIL;
	Files_ReadNum(&*R, R__typ, &ref);
	if (ref == KeplerGraphs_noftypes) {
		Files_ReadString(&*R, R__typ, (void*)module, 32);
		Files_ReadString(&*R, R__typ, (void*)type, 32);
		m = Modules_ThisMod(module, 32);
		if (m != NIL) {
			t = Types_This(m, type, 32);
			if (t != NIL) {
				KeplerGraphs_typTab[__X(ref, 256)] = (LONGINT)t;
				KeplerGraphs_noftypes += 1;
				Types_NewObj((void*)&*x, t);
				__KeplerGraphs_Object_Read(*x, &*R, R__typ);
			} else {
				KeplerGraphs_err((CHAR*)"-- type not found: ", (LONGINT)20, type, 32);
			}
		} else {
			KeplerGraphs_err2((CHAR*)"-- error: ", (LONGINT)11, Modules_importing, 20);
			if (Modules_res == 2) {
				KeplerGraphs_err((CHAR*)" not an obj-file", (LONGINT)17, (CHAR*)"", (LONGINT)1);
			} else if (Modules_res == 3) {
				KeplerGraphs_err2((CHAR*)" imports ", (LONGINT)10, Modules_imported, 20);
				KeplerGraphs_err((CHAR*)" with bad key", (LONGINT)14, (CHAR*)"", (LONGINT)1);
			} else if (Modules_res == 4) {
				KeplerGraphs_err((CHAR*)" corrupted obj file", (LONGINT)20, (CHAR*)"", (LONGINT)1);
			} else if (Modules_res == 7) {
				KeplerGraphs_err((CHAR*)" not enough space", (LONGINT)18, (CHAR*)"", (LONGINT)1);
			}
			Modules_res = 0;
		}
	} else if (ref != -1) {
		Types_NewObj((void*)&*x, (Types_Type)KeplerGraphs_typTab[__X(ref, 256)]);
		__KeplerGraphs_Object_Read(*x, &*R, R__typ);
	}
}

void KeplerGraphs_WriteObj (Files_Rider *R, LONGINT *R__typ, KeplerGraphs_Object x)
{
	Types_Type typ = NIL;
	LONGINT i = 0;
	if (x != NIL) {
		typ = Types_TypeOf((void*)x);
		i = 0;
		while (i < KeplerGraphs_noftypes && (LONGINT)typ != KeplerGraphs_typTab[__X(i, 256)]) {
			i += 1;
		}
		if (i == KeplerGraphs_noftypes) {
			Files_WriteNum(&*R, R__typ, i);
			KeplerGraphs_typTab[__X(i, 256)] = (LONGINT)typ;
			KeplerGraphs_noftypes += 1;
			Files_WriteString(&*R, R__typ, typ->module->name, 20);
			Files_WriteString(&*R, R__typ, typ->name, 24);
		} else {
			Files_WriteNum(&*R, R__typ, i);
		}
		__KeplerGraphs_Object_Write(x, &*R, R__typ);
	} else {
		Files_WriteNum(&*R, R__typ, -1);
	}
}

void KeplerGraphs_GetType (KeplerGraphs_Object o, CHAR *module, LONGINT module__len, CHAR *type, LONGINT type__len)
{
	Types_Type t = NIL;
	t = Types_TypeOf((void*)o);
	__COPY(t->module->name, module, module__len);
	__COPY(t->name, type, type__len);
}

void KeplerGraphs_Reset (void)
{
	KeplerGraphs_nofpt = 0;
	KeplerGraphs_noftypes = 0;
}

static KeplerGraphs_Star KeplerGraphs_GetStar (INTEGER n)
{
	KeplerGraphs_Star s = NIL;
	s = (KeplerGraphs_Star)(KeplerGraphs_starTab->data)[__X(n, KeplerGraphs_starTab->len[0])];
	s->refcnt += 1;
	return s;
}

void KeplerGraphs_Star_Draw (KeplerGraphs_Star self, KeplerPorts_Port P)
{
	if (self->sel) {
		__KeplerPorts_Port_FillRect(P, self->x - 12, self->y - 12, 24 + P->scale, 24 + P->scale, 15, 5, 2);
	}
}

void KeplerGraphs_Star_Read (KeplerGraphs_Star self, Files_Rider *R, LONGINT *R__typ)
{
	LONGINT h = 0;
	self->sel = 0;
	Files_ReadNum(&*R, R__typ, &h);
	self->x = (int)h;
	Files_ReadNum(&*R, R__typ, &h);
	self->y = (int)h;
}

void KeplerGraphs_Star_Write (KeplerGraphs_Star self, Files_Rider *R, LONGINT *R__typ)
{
	Files_WriteNum(&*R, R__typ, self->x);
	Files_WriteNum(&*R, R__typ, self->y);
}

INTEGER KeplerGraphs_Constellation_State (KeplerGraphs_Constellation self)
{
	INTEGER sum = 0, i = 0;
	sum = 0;
	i = 0;
	while (i < self->nofpts) {
		if (self->p[__X(i, 4)]->sel) {
			sum += 1;
		}
		i += 1;
	}
	if (sum == 0) {
		return 0;
	} else if (sum == self->nofpts) {
		return 2;
	} else {
		return 1;
	}
	__RETCHK;
}

void KeplerGraphs_Constellation_Read (KeplerGraphs_Constellation self, Files_Rider *R, LONGINT *R__typ)
{
	LONGINT ref = 0, i = 0;
	i = 0;
	Files_ReadNum(&*R, R__typ, &ref);
	self->nofpts = (int)ref;
	i = 0;
	while (i < (LONGINT)self->nofpts) {
		Files_ReadNum(&*R, R__typ, &ref);
		self->p[__X(i, 4)] = KeplerGraphs_GetStar((int)ref);
		i += 1;
	}
}

void KeplerGraphs_Constellation_Write (KeplerGraphs_Constellation self, Files_Rider *R, LONGINT *R__typ)
{
	INTEGER i = 0;
	i = 0;
	Files_WriteNum(&*R, R__typ, self->nofpts);
	while (i < self->nofpts) {
		Files_WriteNum(&*R, R__typ, self->p[__X(i, 4)]->ref);
		i += 1;
	}
}

void KeplerGraphs_Planet_Draw (KeplerGraphs_Planet self, KeplerPorts_Port P)
{
	if (self->sel) {
		__KeplerPorts_Port_DrawRect(P, self->x - 12, self->y - 12, 24, 24, 15, 2);
	}
}

void KeplerGraphs_Planet_Calc (KeplerGraphs_Planet self)
{
}

void KeplerGraphs_Planet_Read (KeplerGraphs_Planet self, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Object o = NIL;
	KeplerGraphs_Star_Read((void*)self, &*R, R__typ);
	KeplerGraphs_ReadObj(&*R, R__typ, &o);
	self->c = __GUARDP(o, KeplerGraphs_ConsDesc, 1);
}

void KeplerGraphs_Planet_Write (KeplerGraphs_Planet self, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Star_Write((void*)self, &*R, R__typ);
	KeplerGraphs_WriteObj(&*R, R__typ, (void*)self->c);
}

void KeplerGraphs_Graph_Append (KeplerGraphs_Graph G, KeplerGraphs_Object o)
{
	if (__ISP(o, KeplerGraphs_StarDesc, 1)) {
		if (__ISP(o, KeplerGraphs_StarDesc, 1)) {
			if (G->stars == NIL) {
				G->stars = (*(KeplerGraphs_Star*)&o);
			} else {
				G->laststar->next = (*(KeplerGraphs_Star*)&o);
			}
			G->laststar = (*(KeplerGraphs_Star*)&o);
			(*(KeplerGraphs_Star*)&o)->next = NIL;
		} else __WITHCHK;
	} else {
		if (__ISP(o, KeplerGraphs_ConsDesc, 1)) {
			if (G->cons == NIL) {
				G->cons = (*(KeplerGraphs_Constellation*)&o);
			} else {
				G->lastcons->next = (*(KeplerGraphs_Constellation*)&o);
			}
			G->lastcons = (*(KeplerGraphs_Constellation*)&o);
			(*(KeplerGraphs_Constellation*)&o)->next = NIL;
			(*G->notify)(0, G, (void*)(*(KeplerGraphs_Constellation*)&o), NIL);
		} else __WITHCHK;
	}
}

void KeplerGraphs_Graph_Insert (KeplerGraphs_Graph G, KeplerGraphs_Constellation c, KeplerGraphs_Constellation before)
{
	KeplerGraphs_Constellation prev = NIL;
	if (G->cons == before) {
		c->next = before;
		G->cons = c;
	} else {
		prev = G->cons;
		while (prev->next != before) {
			prev = prev->next;
		}
		c->next = prev->next;
		prev->next = c;
	}
	if (G->lastcons == NIL) {
		G->lastcons = c;
	}
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

void KeplerGraphs_Graph_FlipSelection (KeplerGraphs_Graph G, KeplerGraphs_Star p)
{
	if (p->sel) {
		(*G->notify)(0, G, (void*)p, NIL);
		p->sel = 0;
	} else {
		p->sel = 1;
		(*G->notify)(0, G, (void*)p, NIL);
		G->seltime = Oberon_Time();
	}
}

static BOOLEAN KeplerGraphs_DependsOn (KeplerGraphs_Constellation c, KeplerGraphs_Star s)
{
	INTEGER i = 0;
	KeplerGraphs_Star p = NIL;
	i = 0;
	while (i < c->nofpts) {
		p = c->p[__X(i, 4)];
		if (p == s) {
			return 1;
		} else if (__ISP(p, KeplerGraphs_PlanetDesc, 2) && KeplerGraphs_DependsOn(__GUARDP(p, KeplerGraphs_PlanetDesc, 2)->c, s)) {
			return 1;
		}
		i += 1;
	}
	return 0;
}

void KeplerGraphs_Graph_Move (KeplerGraphs_Graph G, KeplerGraphs_Star s, INTEGER dx, INTEGER dy)
{
	KeplerGraphs_Star p = NIL;
	KeplerGraphs_Constellation c = NIL;
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	c = G->cons;
	while (c != NIL) {
		if (KeplerGraphs_DependsOn(c, s)) {
			__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
		}
		c = c->next;
	}
	p = s->next;
	while (p != NIL) {
		if (__ISP(p, KeplerGraphs_PlanetDesc, 2) && KeplerGraphs_DependsOn(__GUARDP(p, KeplerGraphs_PlanetDesc, 2)->c, s)) {
			__KeplerGraphs_Object_Draw((void*)p, (void*)KeplerGraphs_update);
		}
		p = p->next;
	}
	__KeplerGraphs_Object_Draw((void*)s, (void*)KeplerGraphs_update);
	s->x += dx;
	s->y += dy;
	__KeplerGraphs_Object_Draw((void*)s, (void*)KeplerGraphs_update);
	p = s->next;
	while (p != NIL) {
		if (__ISP(p, KeplerGraphs_PlanetDesc, 2) && KeplerGraphs_DependsOn(__GUARDP(p, KeplerGraphs_PlanetDesc, 2)->c, s)) {
			__KeplerGraphs_Planet_Calc(__GUARDP(p, KeplerGraphs_PlanetDesc, 2));
			__KeplerGraphs_Object_Draw((void*)p, (void*)KeplerGraphs_update);
		}
		p = p->next;
	}
	c = G->cons;
	while (c != NIL) {
		if (KeplerGraphs_DependsOn(c, s)) {
			__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
		}
		c = c->next;
	}
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

void KeplerGraphs_Graph_MoveSelection (KeplerGraphs_Graph G, INTEGER dx, INTEGER dy)
{
	KeplerGraphs_Star p = NIL;
	KeplerGraphs_Constellation c = NIL;
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	p = G->stars;
	while (p != NIL) {
		if ((!p->sel && __ISP(p, KeplerGraphs_PlanetDesc, 2)) && __KeplerGraphs_Constellation_State(__GUARDP(p, KeplerGraphs_PlanetDesc, 2)->c) > 0) {
			p->sel = 1;
		}
		p = p->next;
	}
	c = G->cons;
	while (c != NIL) {
		if (__KeplerGraphs_Constellation_State(c) != 0) {
			__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
		}
		c = c->next;
	}
	p = G->stars;
	while (p != NIL) {
		if (p->sel) {
			__KeplerGraphs_Object_Draw((void*)p, (void*)KeplerGraphs_update);
			if (__ISP(p, KeplerGraphs_PlanetDesc, 2)) {
				__KeplerGraphs_Planet_Calc(__GUARDP(p, KeplerGraphs_PlanetDesc, 2));
			} else {
				p->x += dx;
				p->y += dy;
			}
			__KeplerGraphs_Object_Draw((void*)p, (void*)KeplerGraphs_update);
		}
		p = p->next;
	}
	c = G->cons;
	while (c != NIL) {
		if (__KeplerGraphs_Constellation_State(c) != 0) {
			__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
		}
		c = c->next;
	}
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

static void KeplerGraphs_ReverseStars (KeplerGraphs_Graph G)
{
	KeplerGraphs_Star p = NIL, first = NIL, next = NIL;
	p = G->stars;
	G->laststar = p;
	first = NIL;
	while (p != NIL) {
		next = p->next;
		p->next = first;
		first = p;
		p = next;
	}
	G->stars = first;
}

static void KeplerGraphs_Release (KeplerGraphs_Constellation self)
{
	INTEGER i = 0;
	KeplerGraphs_Star s = NIL;
	i = 0;
	while (i < self->nofpts) {
		s = self->p[__X(i, 4)];
		s->refcnt -= 1;
		i += 1;
	}
}

static void KeplerGraphs_CutCons (KeplerGraphs_Graph G, KeplerGraphs_Constellation prevc, KeplerGraphs_Constellation c)
{
	if (prevc == NIL) {
		G->cons = c->next;
	} else {
		prevc->next = c->next;
	}
	if (KeplerGraphs_del->cons == NIL) {
		KeplerGraphs_del->cons = c;
	} else {
		KeplerGraphs_del->lastcons->next = c;
	}
	KeplerGraphs_del->lastcons = c;
	if (G->lastcons == c) {
		G->lastcons = prevc;
	}
	KeplerGraphs_Release(c);
	__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
}

static void KeplerGraphs_CutStar (KeplerGraphs_Graph G, KeplerGraphs_Star prevs, KeplerGraphs_Star s)
{
	if (prevs == NIL) {
		G->stars = s->next;
	} else {
		prevs->next = s->next;
	}
	if (KeplerGraphs_del->stars == NIL) {
		KeplerGraphs_del->stars = s;
	} else {
		KeplerGraphs_del->laststar->next = s;
	}
	KeplerGraphs_del->laststar = s;
	if (G->laststar == s) {
		G->laststar = prevs;
	}
	if (__ISP(s, KeplerGraphs_PlanetDesc, 2)) {
		KeplerGraphs_Release(__GUARDP(s, KeplerGraphs_PlanetDesc, 2)->c);
	}
	s->ref = 0;
	__KeplerGraphs_Object_Draw((void*)s, (void*)KeplerGraphs_update);
}

static void KeplerGraphs_DelStar (KeplerGraphs_Graph G, KeplerGraphs_Object o)
{
	KeplerGraphs_Star s = NIL, prevs = NIL;
	s = G->stars;
	prevs = NIL;
	while (s != NIL && s != (void *) o) {
		prevs = s;
		s = s->next;
	}
	if (s != NIL) {
		KeplerGraphs_CutStar(G, prevs, s);
	}
}

void KeplerGraphs_Graph_Delete (KeplerGraphs_Graph G, KeplerGraphs_Object o)
{
	KeplerGraphs_Constellation c = NIL, prevc = NIL;
	INTEGER i = 0;
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	KeplerGraphs_delG = G;
	KeplerGraphs_del->cons = NIL;
	KeplerGraphs_del->stars = NIL;
	if (__ISP(o, KeplerGraphs_ConsDesc, 1)) {
		c = G->cons;
		prevc = NIL;
		while (c != NIL && c != (void *) o) {
			prevc = c;
			c = c->next;
		}
		if (c != NIL) {
			KeplerGraphs_CutCons(G, prevc, c);
			i = 0;
			while (i < c->nofpts) {
				if (c->p[__X(i, 4)]->refcnt == 0 && !__ISP(c->p[__X(i, 4)], KeplerGraphs_PlanetDesc, 2)) {
					KeplerGraphs_DelStar(G, (void*)c->p[__X(i, 4)]);
				}
				i += 1;
			}
		}
	} else {
		__ASSERT(__GUARDP(o, KeplerGraphs_StarDesc, 1)->refcnt == 0, 0);
		if (__ISP(o, KeplerGraphs_PlanetDesc, 2)) {
			c = __GUARDP(o, KeplerGraphs_PlanetDesc, 2)->c;
			KeplerGraphs_Release(c);
			i = 0;
			while (i < c->nofpts) {
				if (c->p[__X(i, 4)]->refcnt == 0 && !__ISP(c->p[__X(i, 4)], KeplerGraphs_PlanetDesc, 2)) {
					KeplerGraphs_DelStar(G, (void*)c->p[__X(i, 4)]);
				}
				i += 1;
			}
		}
		KeplerGraphs_DelStar(G, o);
	}
	if (KeplerGraphs_del->cons != NIL) {
		KeplerGraphs_del->lastcons->next = NIL;
	}
	if (KeplerGraphs_del->stars != NIL) {
		KeplerGraphs_del->laststar->next = NIL;
	}
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

void KeplerGraphs_Graph_DeleteSelection (KeplerGraphs_Graph G, INTEGER minstate)
{
	KeplerGraphs_Star s = NIL, prevs = NIL;
	KeplerGraphs_Constellation c = NIL, prevc = NIL;
	KeplerGraphs_delG = G;
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	c = G->cons;
	prevc = NIL;
	KeplerGraphs_del->cons = NIL;
	while (c != NIL) {
		if (__KeplerGraphs_Constellation_State(c) >= minstate) {
			KeplerGraphs_CutCons(G, prevc, c);
		} else {
			prevc = c;
		}
		c = c->next;
	}
	if (KeplerGraphs_del->cons != NIL) {
		KeplerGraphs_del->lastcons->next = NIL;
	}
	KeplerGraphs_ReverseStars(G);
	s = G->stars;
	prevs = NIL;
	KeplerGraphs_del->stars = NIL;
	while (s != NIL) {
		if (s->refcnt == 0 && ((!__ISP(s, KeplerGraphs_PlanetDesc, 2) || s->sel) || __KeplerGraphs_Constellation_State(__GUARDP(s, KeplerGraphs_PlanetDesc, 2)->c) >= minstate)) {
			KeplerGraphs_CutStar(G, prevs, s);
		} else {
			prevs = s;
		}
		s = s->next;
	}
	KeplerGraphs_ReverseStars(G);
	if (KeplerGraphs_del->stars != NIL) {
		KeplerGraphs_del->laststar->next = NIL;
		KeplerGraphs_ReverseStars(KeplerGraphs_del);
	}
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

void KeplerGraphs_Graph_All (KeplerGraphs_Graph G, INTEGER op)
{
	KeplerGraphs_Star p = NIL;
	p = G->stars;
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	while (p != NIL) {
		if ((op == 1) != p->sel) {
			if (p->sel) {
				__KeplerGraphs_Object_Draw((void*)p, (void*)KeplerGraphs_update);
				p->sel = 0;
			} else {
				p->sel = 1;
				__KeplerGraphs_Object_Draw((void*)p, (void*)KeplerGraphs_update);
				G->seltime = Oberon_Time();
			}
		}
		p = p->next;
	}
	if (op == 0) {
		G->seltime = -1;
	}
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

static void KeplerGraphs_Store (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ, BOOLEAN all)
{
	KeplerGraphs_Star p = NIL, dummy = NIL;
	KeplerGraphs_Constellation c = NIL;
	p = G->stars;
	__NEW(dummy, KeplerGraphs_StarDesc);
	while (p != NIL) {
		if (all || p->sel && !__ISP(p, KeplerGraphs_PlanetDesc, 2)) {
			KeplerGraphs_WriteObj(&*R, R__typ, (void*)p);
			p->ref = KeplerGraphs_nofpt;
			KeplerGraphs_nofpt += 1;
		} else if (p->sel && __KeplerGraphs_Constellation_State(__GUARDP(p, KeplerGraphs_PlanetDesc, 2)->c) == 2) {
			KeplerGraphs_WriteObj(&*R, R__typ, (void*)p);
			p->ref = KeplerGraphs_nofpt;
			KeplerGraphs_nofpt += 1;
		} else if (p->sel && __KeplerGraphs_Constellation_State(__GUARDP(p, KeplerGraphs_PlanetDesc, 2)->c) != 2) {
			__GUARDEQP(dummy, KeplerGraphs_StarDesc) = *p;
			KeplerGraphs_WriteObj(&*R, R__typ, (void*)dummy);
			p->ref = KeplerGraphs_nofpt;
			KeplerGraphs_nofpt += 1;
		}
		p = p->next;
	}
	c = G->cons;
	while (c != NIL) {
		if (all || __KeplerGraphs_Constellation_State(c) == 2) {
			KeplerGraphs_WriteObj(&*R, R__typ, (void*)c);
		}
		c = c->next;
	}
	Files_WriteNum(&*R, R__typ, -1);
}

void KeplerGraphs_Graph_Draw (KeplerGraphs_Graph G, KeplerPorts_Port P)
{
	KeplerGraphs_Star s = NIL;
	KeplerGraphs_Constellation c = NIL;
	c = G->cons;
	while (c != NIL) {
		__KeplerGraphs_Object_Draw((void*)c, P);
		c = c->next;
	}
	s = G->stars;
	while (s != NIL) {
		__KeplerGraphs_Object_Draw((void*)s, P);
		s = s->next;
	}
}

void KeplerGraphs_Graph_Write (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Store(G, &*R, R__typ, 1);
}

void KeplerGraphs_Graph_WriteSel (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Store(G, &*R, R__typ, 0);
}

static void KeplerGraphs_DoubleStarTab (void)
{
	KeplerGraphs_StarTab h = NIL;
	LONGINT i = 0;
	i = 0;
	h = __NEWARR(NIL, 4, 4, 1, 1, (LONGINT)(__ASHL(KeplerGraphs_starTab->len[0], 1)));
	while (i < KeplerGraphs_starTab->len[0]) {
		(h->data)[__X(i, h->len[0])] = (KeplerGraphs_starTab->data)[__X(i, KeplerGraphs_starTab->len[0])];
		i += 1;
	}
	KeplerGraphs_starTab = h;
}

void KeplerGraphs_Graph_Read (KeplerGraphs_Graph G, Files_Rider *R, LONGINT *R__typ)
{
	KeplerGraphs_Object o = NIL, o0 = NIL;
	KeplerGraphs_loading = G;
	G->stars = NIL;
	G->laststar = NIL;
	G->cons = NIL;
	G->lastcons = NIL;
	G->seltime = -1;
	KeplerGraphs_ReadObj(&*R, R__typ, &o0);
	o = o0;
	while (o != NIL) {
		if (__ISP(o, KeplerGraphs_StarDesc, 1)) {
			if (G->stars == NIL) {
				G->stars = (*(KeplerGraphs_Star*)&o);
			} else {
				G->laststar->next = (*(KeplerGraphs_Star*)&o);
			}
			G->laststar = (*(KeplerGraphs_Star*)&o);
			(*(KeplerGraphs_Star*)&o)->next = NIL;
			if ((LONGINT)KeplerGraphs_nofpt == KeplerGraphs_starTab->len[0]) {
				KeplerGraphs_DoubleStarTab();
			}
			(KeplerGraphs_starTab->data)[__X(KeplerGraphs_nofpt, KeplerGraphs_starTab->len[0])] = (LONGINT)(*(KeplerGraphs_Star*)&o);
			KeplerGraphs_nofpt += 1;
		} else if (__ISP(o, KeplerGraphs_ConsDesc, 1)) {
			if (G->cons == NIL) {
				G->cons = (*(KeplerGraphs_Constellation*)&o);
			} else {
				G->lastcons->next = (*(KeplerGraphs_Constellation*)&o);
			}
			G->lastcons = (*(KeplerGraphs_Constellation*)&o);
			(*(KeplerGraphs_Constellation*)&o)->next = NIL;
		} else __WITHCHK;
		KeplerGraphs_ReadObj(&*R, R__typ, &o);
	}
}

KeplerGraphs_Graph KeplerGraphs_Old (CHAR *name, LONGINT name__len)
{
	Files_File F = NIL;
	Files_Rider R = {0};
	KeplerGraphs_Object o = NIL;
	__DUP(name, name__len, CHAR);
	F = Files_Old(name, name__len);
	if (F != NIL) {
		Files_Set(&R, Files_Rider__typ, F, 0);
		KeplerGraphs_Reset();
		KeplerGraphs_ReadObj(&R, Files_Rider__typ, &o);
		if (R.res == 0) {
			__DEL(name);
			return __GUARDP(o, KeplerGraphs_GraphDesc, 1);
		} else {
			__DEL(name);
			return NIL;
		}
	} else {
		__DEL(name);
		return NIL;
	}
	__RETCHK;
}

static void KeplerGraphs_Dummy (INTEGER op, KeplerGraphs_Graph g, KeplerGraphs_Object c, KeplerPorts_Port f)
{
}

void KeplerGraphs_Graph_CopySelection (KeplerGraphs_Graph G, KeplerGraphs_Graph from, INTEGER dx, INTEGER dy)
{
	Files_File cpBuf = NIL;
	Files_Rider R = {0};
	KeplerGraphs_Constellation c = NIL, nextc = NIL;
	KeplerGraphs_Star p = NIL, nextp = NIL;
	KeplerGraphs_Graph buf = NIL;
	cpBuf = Files_New((CHAR*)"", (LONGINT)1);
	Files_Set(&R, Files_Rider__typ, cpBuf, 0);
	KeplerGraphs_Reset();
	__KeplerGraphs_Graph_WriteSel(from, &R, Files_Rider__typ);
	Files_Set(&R, Files_Rider__typ, cpBuf, 0);
	Types_NewObj((void*)&buf, Types_TypeOf((void*)from));
	buf->notify = KeplerGraphs_Dummy;
	KeplerGraphs_Reset();
	__KeplerGraphs_Object_Read((void*)buf, &R, Files_Rider__typ);
	p = buf->stars;
	while (p != NIL) {
		nextp = p->next;
		p->x += dx;
		p->y += dy;
		if (p->refcnt > 0 || __ISP(p, KeplerGraphs_PlanetDesc, 2)) {
			__KeplerGraphs_Graph_Append(G, (void*)p);
		}
		p = nextp;
	}
	c = buf->cons;
	KeplerPorts_InitBalloon(KeplerGraphs_update);
	while (c != NIL) {
		__KeplerGraphs_Object_Draw((void*)c, (void*)KeplerGraphs_update);
		nextc = c->next;
		if (G->cons == NIL) {
			G->cons = c;
		} else {
			G->lastcons->next = c;
		}
		G->lastcons = c;
		c->next = NIL;
		c = nextc;
	}
	(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
}

void KeplerGraphs_Graph_SendToBack (KeplerGraphs_Graph G, KeplerGraphs_Object obj)
{
	INTEGER i = 0;
	KeplerGraphs_Star s = NIL;
	KeplerGraphs_Constellation c = NIL;
	KeplerGraphs_Object o = NIL;
	INTEGER _for__19 = 0;
	o = obj;
	if (__ISP(o, KeplerGraphs_StarDesc, 1)) {
		s = G->stars;
		if ((*(KeplerGraphs_Star*)&o) != s) {
			while (s->next != (*(KeplerGraphs_Star*)&o)) {
				s = s->next;
			}
			s->next = (*(KeplerGraphs_Star*)&o)->next;
			(*(KeplerGraphs_Star*)&o)->next = G->stars;
			G->stars = (*(KeplerGraphs_Star*)&o);
			if (G->laststar == (*(KeplerGraphs_Star*)&o)) {
				G->laststar = s;
			}
			if (__ISP((*(KeplerGraphs_Star*)&o), KeplerGraphs_PlanetDesc, 2)) {
				c = __GUARDP((*(KeplerGraphs_Star*)&o), KeplerGraphs_PlanetDesc, 2)->c;
				_for__19 = c->nofpts - 1;
				i = 0;
				while (i <= _for__19) {
					__KeplerGraphs_Graph_SendToBack(G, (void*)c->p[__X(i, 4)]);
					i += 1;
				}
			}
		}
	} else if (__ISP(o, KeplerGraphs_ConsDesc, 1)) {
		KeplerPorts_InitBalloon(KeplerGraphs_update);
		c = G->cons;
		if ((*(KeplerGraphs_Constellation*)&o) != c) {
			while (c->next != (*(KeplerGraphs_Constellation*)&o)) {
				c = c->next;
			}
			c->next = (*(KeplerGraphs_Constellation*)&o)->next;
			(*(KeplerGraphs_Constellation*)&o)->next = G->cons;
			G->cons = (*(KeplerGraphs_Constellation*)&o);
			if (G->lastcons == (*(KeplerGraphs_Constellation*)&o)) {
				G->lastcons = c;
			}
			__KeplerGraphs_Object_Draw((void*)(*(KeplerGraphs_Constellation*)&o), (void*)KeplerGraphs_update);
			(*G->notify)(1, G, NIL, (void*)KeplerGraphs_update);
		}
	} else __WITHCHK;
}

static void KeplerGraphs_Unrelease (KeplerGraphs_Constellation c)
{
	INTEGER i = 0;
	i = 0;
	while (i < c->nofpts) {
		c->p[__X(i, 4)]->refcnt += 1;
		i += 1;
	}
}

void KeplerGraphs_Recall (void)
{
	KeplerGraphs_Star s = NIL, nexts = NIL;
	KeplerGraphs_Constellation c = NIL, nextc = NIL;
	if (KeplerGraphs_delG != NIL) {
		s = KeplerGraphs_del->stars;
		while (s != NIL) {
			nexts = s->next;
			s->sel = 0;
			__KeplerGraphs_Graph_Append(KeplerGraphs_delG, (void*)s);
			if (__ISP(s, KeplerGraphs_PlanetDesc, 2)) {
				KeplerGraphs_Unrelease(__GUARDP(s, KeplerGraphs_PlanetDesc, 2)->c);
			}
			s = nexts;
		}
		c = KeplerGraphs_del->cons;
		while (c != NIL) {
			nextc = c->next;
			__KeplerGraphs_Graph_Append(KeplerGraphs_delG, (void*)c);
			KeplerGraphs_Unrelease(c);
			c = nextc;
		}
		KeplerGraphs_delG = NIL;
		KeplerGraphs_del->cons = NIL;
		KeplerGraphs_del->lastcons = NIL;
		KeplerGraphs_del->stars = NIL;
		KeplerGraphs_del->laststar = NIL;
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(KeplerGraphs_loading);
	P(KeplerGraphs_update);
	P(KeplerGraphs_starTab);
	P(KeplerGraphs_del);
	P(KeplerGraphs_delG);
}

__TDESC(KeplerGraphs_ObjectDesc, 4, 0) = {__TDFLDS("ObjectDesc", 1), {-4}};
__TDESC(KeplerGraphs_StarDesc, 4, 1) = {__TDFLDS("StarDesc", 16), {12, -8}};
__TDESC(KeplerGraphs_ConsDesc, 5, 5) = {__TDFLDS("ConsDesc", 24), {4, 8, 12, 16, 20, -24}};
__TDESC(KeplerGraphs_PlanetDesc, 5, 2) = {__TDFLDS("PlanetDesc", 20), {12, 16, -12}};
__TDESC(KeplerGraphs_GraphDesc, 15, 4) = {__TDFLDS("GraphDesc", 24), {0, 4, 8, 12, -20}};

export void *KeplerGraphs__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(KeplerPorts);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(Texts);
	__IMPORT(Types);
	__REGMOD(KeplerGraphs, EnumPtrs);
	__REGCMD("Recall", KeplerGraphs_Recall);
	__REGCMD("Reset", KeplerGraphs_Reset);
	__INITYP(KeplerGraphs_ObjectDesc, KeplerGraphs_ObjectDesc, 0);
	__INITBP(KeplerGraphs_ObjectDesc, KeplerGraphs_Object_Draw, 0);
	__INITBP(KeplerGraphs_ObjectDesc, KeplerGraphs_Object_Read, 1);
	__INITBP(KeplerGraphs_ObjectDesc, KeplerGraphs_Object_Write, 2);
	__INITYP(KeplerGraphs_StarDesc, KeplerGraphs_ObjectDesc, 1);
	__INITBP(KeplerGraphs_StarDesc, KeplerGraphs_Star_Draw, 0);
	__INITBP(KeplerGraphs_StarDesc, KeplerGraphs_Star_Read, 1);
	__INITBP(KeplerGraphs_StarDesc, KeplerGraphs_Star_Write, 2);
	__INITYP(KeplerGraphs_ConsDesc, KeplerGraphs_ObjectDesc, 1);
	__INITBP(KeplerGraphs_ConsDesc, KeplerGraphs_Constellation_Read, 1);
	__INITBP(KeplerGraphs_ConsDesc, KeplerGraphs_Constellation_State, 3);
	__INITBP(KeplerGraphs_ConsDesc, KeplerGraphs_Constellation_Write, 2);
	__INITYP(KeplerGraphs_PlanetDesc, KeplerGraphs_StarDesc, 2);
	__INITBP(KeplerGraphs_PlanetDesc, KeplerGraphs_Planet_Calc, 3);
	__INITBP(KeplerGraphs_PlanetDesc, KeplerGraphs_Planet_Draw, 0);
	__INITBP(KeplerGraphs_PlanetDesc, KeplerGraphs_Planet_Read, 1);
	__INITBP(KeplerGraphs_PlanetDesc, KeplerGraphs_Planet_Write, 2);
	__INITYP(KeplerGraphs_GraphDesc, KeplerGraphs_ObjectDesc, 1);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_All, 3);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Append, 4);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_CopySelection, 5);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Delete, 6);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_DeleteSelection, 7);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Draw, 0);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_FlipSelection, 8);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Insert, 9);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Move, 10);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_MoveSelection, 11);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Read, 1);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_SendToBack, 12);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_Write, 2);
	__INITBP(KeplerGraphs_GraphDesc, KeplerGraphs_Graph_WriteSel, 13);
/* BEGIN */
	__NEW(KeplerGraphs_update, KeplerPorts_BalloonPortDesc);
	__NEW(KeplerGraphs_del, KeplerGraphs_GraphDesc);
	KeplerGraphs_starTab = __NEWARR(NIL, 4, 4, 1, 1, 1);
	__ENDMOD;
}
