/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct LineElems_ElemDesc *LineElems_Elem;

typedef
	struct LineElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		SET opts;
		LONGINT h;
	} LineElems_ElemDesc;


static INTEGER LineElems_unit, LineElems_MinW;

export LONGINT *LineElems_ElemDesc__typ;

export void LineElems_Alloc (void);
export void LineElems_Copy (LineElems_Elem SE, LineElems_Elem DE);
export void LineElems_Draw (LineElems_Elem E, INTEGER x0, INTEGER y0, SHORTINT col);
export void LineElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void LineElems_Insert (void);
export void LineElems_Load (LineElems_Elem E, Files_Rider *r, LONGINT *r__typ);
static LONGINT LineElems_Max (LONGINT x, LONGINT y);
export void LineElems_Prepare (LineElems_Elem E, LONGINT pos, LONGINT indent, BOOLEAN printing);
export void LineElems_Print (LineElems_Elem E, INTEGER x0, INTEGER y0, SHORTINT col);
static void LineElems_ReadSet (Files_Rider *r, LONGINT *r__typ, SET *s);
export void LineElems_Store (LineElems_Elem E, Files_Rider *r, LONGINT *r__typ);
static void LineElems_WriteSet (Files_Rider *r, LONGINT *r__typ, SET s);


static LONGINT LineElems_Max (LONGINT x, LONGINT y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void LineElems_WriteSet (Files_Rider *r, LONGINT *r__typ, SET s)
{
	Files_WriteNum(&*r, r__typ, (LONGINT)s);
}

static void LineElems_ReadSet (Files_Rider *r, LONGINT *r__typ, SET *s)
{
	Files_ReadNum(&*r, r__typ, (LONGINT*)&*s);
}

void LineElems_Prepare (LineElems_Elem E, LONGINT pos, LONGINT indent, BOOLEAN printing)
{
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	INTEGER i = 0;
	TextFrames_ParcBefore(Texts_ElemBase((void*)E), pos, &P, &pbeg);
	if (__IN(0, E->opts)) {
		E->W = LineElems_Max(P->width - indent, LineElems_MinW);
	} else if (__IN(1, E->opts)) {
		i = 0;
		while (i < P->nofTabs && P->tab[__X(i, 32)] - indent < 18000) {
			i += 1;
		}
		if (i < P->nofTabs) {
			E->W = P->tab[__X(i, 32)] - indent;
		} else {
			E->W = LineElems_MinW;
		}
	}
	if (__IN(2, E->opts)) {
		E->h = LineElems_Max(P->lsp, 3600);
	}
	if (printing) {
		E->H = E->h;
	} else {
		if (__IN(3, E->opts)) {
			E->H = LineElems_Max(E->h, 3 * LineElems_unit);
		} else {
			E->H = LineElems_Max(E->h, LineElems_unit);
		}
	}
}

void LineElems_Draw (LineElems_Elem E, INTEGER x0, INTEGER y0, SHORTINT col)
{
	INTEGER w = 0, h = 0;
	w = (int)__DIVF(LineElems_Max(E->W, LineElems_unit), (LONGINT)LineElems_unit);
	h = (int)__DIV(E->H, (LONGINT)LineElems_unit);
	if (__IN(3, E->opts)) {
		h = (int)LineElems_Max(1, __DIV(h, 3));
		Display_ReplConst(col, x0, y0 + __ASHL(h, 1), w, h, 0);
	}
	Display_ReplConst(col, x0, y0, w, h, 0);
}

void LineElems_Print (LineElems_Elem E, INTEGER x0, INTEGER y0, SHORTINT col)
{
	INTEGER w = 0, h = 0;
	w = (int)__DIV(E->W, 3048);
	h = (int)__DIV(E->H, 3048);
	if (__IN(3, E->opts)) {
		h = (int)LineElems_Max(1, __DIV(h, 3));
		Printer_ReplConst(x0, y0 + (int)LineElems_Max(4, 3 * h), w, h);
	}
	Printer_ReplConst(x0, y0, w, h);
}

void LineElems_Load (LineElems_Elem E, Files_Rider *r, LONGINT *r__typ)
{
	LineElems_ReadSet(&*r, r__typ, &E->opts);
	Files_ReadNum(&*r, r__typ, &E->h);
}

void LineElems_Store (LineElems_Elem E, Files_Rider *r, LONGINT *r__typ)
{
	LineElems_WriteSet(&*r, r__typ, E->opts);
	Files_WriteNum(&*r, r__typ, E->h);
}

void LineElems_Copy (LineElems_Elem SE, LineElems_Elem DE)
{
	Texts_CopyElem((void*)SE, (void*)DE);
	DE->opts = SE->opts;
	DE->h = SE->h;
}

void LineElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	LineElems_Elem e = NIL;
	if (__ISP(E, LineElems_ElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					LineElems_Prepare((*(LineElems_Elem*)&E), (*msg__).pos, (*msg__).indent, 0);
				} else {
					LineElems_Draw((*(LineElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, (*msg__).col);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					LineElems_Prepare((*(LineElems_Elem*)&E), (*msg__).pos, (*msg__).indent, 1);
				} else {
					LineElems_Print((*(LineElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, (*msg__).col);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("LineElems", (*msg__).mod, 10);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					LineElems_Load((*(LineElems_Elem*)&E), &(*msg__).r, Files_Rider__typ);
				} else if ((*msg__).id == 1) {
					LineElems_Store((*(LineElems_Elem*)&E), &(*msg__).r, Files_Rider__typ);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			__NEW(e, LineElems_ElemDesc);
			LineElems_Copy((*(LineElems_Elem*)&E), e);
			__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)e;
		}
	} else __WITHCHK;
}

void LineElems_Alloc (void)
{
	LineElems_Elem e = NIL;
	__NEW(e, LineElems_ElemDesc);
	e->handle = LineElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void LineElems_Insert (void)
{
	Texts_Scanner S = {0};
	LONGINT w = 0, h = 0;
	SET opts = 0;
	BOOLEAN ok = 0;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	LineElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.line == 0 && S.class == 6) && S.c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	opts = 0x0;
	ok = 1;
	if ((S.line == 0 && S.class == 1) && __STRCMP(S.s, "auto") == 0) {
		opts |= __SETOF(0);
		w = LineElems_MinW;
	} else if ((S.line == 0 && S.class == 1) && __STRCMP(S.s, "tab") == 0) {
		opts |= __SETOF(1);
		w = LineElems_MinW;
	} else if (((S.line == 0 && S.class == 3) && 1 <= S.i) && S.i <= 10000) {
		w = S.i * 3600;
	} else {
		ok = 0;
	}
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.line == 0 && S.class == 1) && __STRCMP(S.s, "auto") == 0) {
		opts |= __SETOF(2);
		h = 3600;
	} else if (((S.line == 0 && S.class == 3) && 1 <= S.i) && S.i <= 100) {
		h = S.i * 3600;
	} else {
		ok = 0;
	}
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.line == 0 && S.class == 1) && __STRCMP(S.s, "double") == 0) {
		opts |= __SETOF(3);
		h = 3 * h;
	}
	if (ok) {
		__NEW(e, LineElems_ElemDesc);
		e->W = w;
		e->H = h;
		e->handle = LineElems_Handle;
		e->opts = opts;
		e->h = h;
		m.e = (Texts_Elem)e;
		(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&m, TextFrames_InsertElemMsg__typ);
	}
}

__TDESC(LineElems_ElemDesc, 1, 4) = {__TDFLDS("ElemDesc", 44), {0, 4, 12, 32, -20}};

export void *LineElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(LineElems, 0);
	__REGCMD("Alloc", LineElems_Alloc);
	__REGCMD("Insert", LineElems_Insert);
	__INITYP(LineElems_ElemDesc, Texts_ElemDesc, 2);
/* BEGIN */
	LineElems_unit = TextFrames_Unit;
	LineElems_MinW = LineElems_unit;
	__ENDMOD;
}
