/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "FoldElems.h"
#include "Fonts.h"
#include "Input.h"
#include "MarkElems.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "PopupElems.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct LinkElems_ElemDesc *LinkElems_Elem;

typedef
	struct LinkElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR file[32];
		LONGINT key;
	} LinkElems_ElemDesc;

typedef
	struct LinkElems_FollowMsg { /* Texts_ElemMsg */
		Display_Frame f;
	} LinkElems_FollowMsg;

typedef
	struct LinkElems_FrameDesc *LinkElems_Frame;

typedef
	struct LinkElems_FrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		LinkElems_Elem e;
	} LinkElems_FrameDesc;

typedef
	struct LinkElems_MenuDesc *LinkElems_Menu;

typedef
	struct LinkElems_MenuDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} LinkElems_MenuDesc;


static LONGINT LinkElems_searchKey;
static TextFrames_Frame LinkElems_hint;
static LONGINT LinkElems_icon, LinkElems_invIcon;
static Texts_Writer LinkElems_w;

export LONGINT *LinkElems_ElemDesc__typ;
export LONGINT *LinkElems_FollowMsg__typ;
export LONGINT *LinkElems_MenuDesc__typ;
export LONGINT *LinkElems_FrameDesc__typ;

export void LinkElems_Alloc (void);
export void LinkElems_AllocMenu (void);
static BOOLEAN LinkElems_Check (Texts_Elem e);
static void LinkElems_CollectMarks (LinkElems_Menu pop, Display_Frame f0);
static void LinkElems_Edit (LinkElems_Elem e);
export void LinkElems_FollowLink (CHAR *file, LONGINT file__len, LONGINT key, Display_Frame backF, Texts_Elem backE);
static void LinkElems_GetDsr (Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER *dsr);
static void LinkElems_GetFileName (Texts_Text t, CHAR *name, LONGINT name__len);
static void LinkElems_GetFrame (CHAR *name, LONGINT name__len, TextFrames_Frame *f);
static void LinkElems_GetSelection (TextFrames_Frame *f);
export void LinkElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
export void LinkElems_HandleMenu (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
static void LinkElems_InitIcon (void);
export void LinkElems_Insert (void);
export void LinkElems_InsertMenu (void);
export LinkElems_Elem LinkElems_New (CHAR *file, LONGINT file__len, LONGINT key);
static void LinkElems_ShowPos (TextFrames_Frame f, LONGINT pos);
export void LinkElems_Update (void);


static void LinkElems_GetSelection (TextFrames_Frame *f)
{
	Viewers_Viewer v = NIL;
	Display_Frame f0 = NIL;
	LONGINT time = 0;
	INTEGER x = 0;
	x = 0;
	time = -1;
	*f = NIL;
	while (x < Display_Width) {
		v = Viewers_This(x, 0);
		while (v->state > 1) {
			f0 = v->dsc;
			while (f0 != NIL) {
				if (__ISP(f0, TextFrames_FrameDesc, 1)) {
					if ((*(TextFrames_Frame*)&f0)->hasSel && (*(TextFrames_Frame*)&f0)->time > time) {
						*f = (*(TextFrames_Frame*)&f0);
						time = (*f)->time;
					}
				}
				f0 = f0->next;
			}
			v = Viewers_Next(v);
		}
		x = x + v->W;
	}
}

static void LinkElems_GetFileName (Texts_Text t, CHAR *name, LONGINT name__len)
{
	Viewers_Viewer v = NIL, V = NIL;
	Display_Frame f = NIL;
	Texts_Scanner s = {0};
	INTEGER x = 0;
	V = NIL;
	x = 0;
	while (x < Display_Width) {
		v = Viewers_This(x, 0);
		while (v->state > 1) {
			f = v->dsc;
			while (f != NIL) {
				if (__ISP(f, TextFrames_FrameDesc, 1) && __GUARDP(f, TextFrames_FrameDesc, 1)->text == t) {
					V = v;
				}
				f = f->next;
			}
			v = Viewers_Next(v);
		}
		x = x + v->W;
	}
	if (V != NIL) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (__IN(s.class, 0x06)) {
			__COPY(s.s, name, name__len);
		} else {
			name[0] = 0x00;
		}
	}
}

static void LinkElems_GetFrame (CHAR *name, LONGINT name__len, TextFrames_Frame *f)
{
	INTEGER x = 0;
	Viewers_Viewer v = NIL;
	Texts_Scanner s = {0};
	__DUP(name, name__len, CHAR);
	if (LinkElems_hint != NIL) {
		*f = LinkElems_hint;
	} else {
		x = 0;
		*f = NIL;
		while (x < Display_Width) {
			v = Viewers_This(x, 0);
			while (v->state > 1) {
				if (v->dsc != NIL && __ISP(v->dsc, TextFrames_FrameDesc, 1)) {
					Texts_OpenScanner(&s, Texts_Scanner__typ, __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text, 0);
					Texts_Scan(&s, Texts_Scanner__typ);
					if (__STRCMP(s.s, name) == 0) {
						*f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
						__DEL(name);
						return;
					}
				}
				v = Viewers_Next(v);
			}
			x = x + v->W;
		}
	}
	__DEL(name);
}

static void LinkElems_GetDsr (Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER *dsr)
{
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	if (f == NIL) {
		if (fnt == NIL) {
			*dsr = 0;
		} else {
			*dsr = -fnt->minY;
		}
	} else {
		TextFrames_ParcBefore(__GUARDP(f, TextFrames_FrameDesc, 1)->text, pos, &p, &beg);
		*dsr = (int)__DIV(p->dsr, (LONGINT)TextFrames_Unit);
	}
}

static void LinkElems_CollectMarks (LinkElems_Menu pop, Display_Frame f0)
{
	Texts_Reader r = {0};
	Texts_Scanner s = {0};
	CHAR ch = 0;
	TextFrames_Frame f = NIL;
	MarkElems_Elem mark = NIL;
	LinkElems_Elem link = NIL;
	INTEGER n = 0;
	CHAR file[32];
	pop->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	if (f0->next == NIL || !__ISP(f0->next, TextFrames_FrameDesc, 1)) {
		Texts_WriteString(&LinkElems_w, Texts_Writer__typ, (CHAR*)"link menu not in menu bar of a text viewer", (LONGINT)43);
		Texts_WriteLn(&LinkElems_w, Texts_Writer__typ);
		Texts_WriteLn(&LinkElems_w, Texts_Writer__typ);
	} else {
		f = __GUARDP(f0->next, TextFrames_FrameDesc, 1);
		LinkElems_hint = f;
		LinkElems_GetFileName(f->text, (void*)file, 32);
		n = 0;
		Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
		Texts_ReadElem(&r, Texts_Reader__typ);
		while (!r.eot) {
			if (__ISP(r.elem, MarkElems_ElemDesc, 2)) {
				mark = __GUARDP(r.elem, MarkElems_ElemDesc, 2);
				link = LinkElems_New(file, 32, mark->key);
				Texts_WriteElem(&LinkElems_w, Texts_Writer__typ, (void*)link);
				Texts_Write(&LinkElems_w, Texts_Writer__typ, ' ');
				Texts_OpenScanner(&s, Texts_Scanner__typ, f->text, Texts_Pos(&r, Texts_Reader__typ));
				Texts_Scan(&s, Texts_Scanner__typ);
				while (!s.eot && s.class != 1) {
					Texts_Scan(&s, Texts_Scanner__typ);
				}
				if (!s.eot) {
					Texts_WriteString(&LinkElems_w, Texts_Writer__typ, s.s, 256);
					Texts_WriteLn(&LinkElems_w, Texts_Writer__typ);
					n += 1;
				}
			}
			Texts_ReadElem(&r, Texts_Reader__typ);
		}
		if (n == 0) {
			Texts_WriteString(&LinkElems_w, Texts_Writer__typ, (CHAR*)"no marks", (LONGINT)9);
			Texts_WriteLn(&LinkElems_w, Texts_Writer__typ);
		}
		if (n <= 1) {
			Texts_WriteLn(&LinkElems_w, Texts_Writer__typ);
		}
	}
	Texts_Append(pop->menu, LinkElems_w.buf);
}

static void LinkElems_ShowPos (TextFrames_Frame f, LONGINT pos)
{
	LONGINT beg = 0, end = 0, delta = 0;
	delta = 200;
	for (;;) {
		beg = f->org;
		end = TextFrames_Pos(f, f->X + f->W, f->Y);
		if (beg <= pos && pos < end || delta == 0) {
			break;
		}
		TextFrames_Show(f, pos - delta);
		delta = __ASHR(delta, 1);
	}
	TextFrames_SetSelection(f, pos, pos + 1);
}

static BOOLEAN LinkElems_Check (Texts_Elem e)
{
	return __ISP(e, MarkElems_ElemDesc, 2) && __GUARDP(e, MarkElems_ElemDesc, 2)->key == LinkElems_searchKey;
}

void LinkElems_FollowLink (CHAR *file, LONGINT file__len, LONGINT key, Display_Frame backF, Texts_Elem backE)
{
	Viewers_Viewer v = NIL;
	TextFrames_Frame menu = NIL;
	INTEGER x = 0, y = 0;
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	Texts_Elem mark = NIL;
	TextFrames_Frame f = NIL;
	__DUP(file, file__len, CHAR);
	if (__STRCMP(file, "*") == 0 && backF != NIL) {
		f = __GUARDP(backF, TextFrames_FrameDesc, 1);
	} else {
		LinkElems_GetFrame(file, file__len, &f);
	}
	if (f == NIL) {
		f = TextFrames_NewText(TextFrames_Text(file, file__len), 0);
		Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
		if (Files_Old((CHAR*)"Edit.Menu.Text", (LONGINT)15) == NIL) {
			menu = TextFrames_NewMenu(file, file__len, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Search  Edit.Replace  Edit.Store ", (LONGINT)79);
		} else {
			menu = TextFrames_NewMenu(file, file__len, (CHAR*)"", (LONGINT)1);
			__NEW(t, Texts_TextDesc);
			Texts_Open(t, (CHAR*)"Edit.Menu.Text", (LONGINT)15);
			__NEW(buf, Texts_BufDesc);
			Texts_OpenBuf(buf);
			Texts_Save(t, 0, t->len, buf);
			Texts_Append(menu->text, buf);
		}
		v = (Viewers_Viewer)MenuViewers_New((void*)menu, (void*)f, TextFrames_menuH, x, y);
	}
	LinkElems_searchKey = key;
	FoldElems_FindElem(f->text, 0, LinkElems_Check, &mark);
	if (mark != NIL) {
		LinkElems_ShowPos(f, Texts_ElemPos(mark));
		if (backF != NIL) {
			__GUARDP(mark, MarkElems_ElemDesc, 2)->back = backE;
		} else {
			__GUARDP(mark, MarkElems_ElemDesc, 2)->back = NIL;
		}
	}
	__DEL(file);
}

static void LinkElems_Edit (LinkElems_Elem e)
{
	Texts_Text t = NIL;
	MenuViewers_Viewer v = NIL;
	LinkElems_Frame f = NIL;
	INTEGER x = 0, y = 0;
	t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteString(&LinkElems_w, Texts_Writer__typ, e->file, 32);
	Texts_Write(&LinkElems_w, Texts_Writer__typ, ' ');
	Texts_WriteInt(&LinkElems_w, Texts_Writer__typ, e->key, 0);
	Texts_Append(t, LinkElems_w.buf);
	__NEW(f, LinkElems_FrameDesc);
	f->e = e;
	TextFrames_Open((void*)f, t, 0);
	Oberon_AllocateSystemViewer(0, &x, &y);
	v = MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"LinkElem", (LONGINT)9, (CHAR*)"System.Close  LinkElems.Update ", (LONGINT)32), (void*)f, TextFrames_menuH, x, y);
}

void LinkElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	LinkElems_Elem e1 = NIL;
	INTEGER x = 0, y = 0, dsr = 0, i = 0;
	SET keys = 0;
	CHAR ch = 0;
	LinkElems_FollowMsg follow = {0};
	if (__ISP(e, LinkElems_ElemDesc, 2)) {
		if (__IS(m__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *m__ = (void*)m;
			if ((*m__).id == 0) {
				i = 0;
				do {
					Files_Read(&(*m__).r, Files_Rider__typ, (void*)&ch);
					(*(LinkElems_Elem*)&e)->file[__X(i, 32)] = ch;
					i += 1;
				} while (!(ch == 0x00));
				Files_ReadLInt(&(*m__).r, Files_Rider__typ, &(*(LinkElems_Elem*)&e)->key);
			} else {
				i = 0;
				do {
					ch = (*(LinkElems_Elem*)&e)->file[__X(i, 32)];
					Files_Write(&(*m__).r, Files_Rider__typ, ch);
					i += 1;
				} while (!(ch == 0x00));
				Files_WriteLInt(&(*m__).r, Files_Rider__typ, (*(LinkElems_Elem*)&e)->key);
			}
		} else if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, LinkElems_ElemDesc);
				(*m__).e = (Texts_Elem)e1;
			} else {
				e1 = __GUARDP((*m__).e, LinkElems_ElemDesc, 2);
			}
			Texts_CopyElem((void*)(*(LinkElems_Elem*)&e), (void*)e1);
			__COPY((*(LinkElems_Elem*)&e)->file, e1->file, 32);
			e1->key = (*(LinkElems_Elem*)&e)->key;
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("LinkElems", (*m__).mod, 10);
			__MOVE("Alloc", (*m__).proc, 6);
		} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			(*(LinkElems_Elem*)&e)->W = 10 * TextFrames_Unit;
			if (!(*m__).prepare) {
				LinkElems_GetDsr((*m__).frame, (*m__).pos, (*m__).fnt, &dsr);
				Display_CopyPattern(15, LinkElems_icon, (*m__).X0, (*m__).Y0 + dsr, 1);
			}
		} else if (__IS(m__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *m__ = (void*)m;
			(*(LinkElems_Elem*)&e)->W = 1;
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if (__IN(1, (*m__).keys)) {
				if ((*m__).frame != NIL) {
					LinkElems_GetDsr((*m__).frame, (*m__).pos, (*m__).fnt, &dsr);
					Display_CopyPattern(15, LinkElems_icon, (*m__).X0, (*m__).Y0 + dsr, 2);
					Display_CopyPattern(15, LinkElems_invIcon, (*m__).X0, (*m__).Y0 + dsr, 2);
					do {
						Input_Mouse(&keys, &x, &y);
						(*m__).keys = (*m__).keys | keys;
						Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
					} while (!(keys == 0x0));
					Display_CopyPattern(15, LinkElems_invIcon, (*m__).X0, (*m__).Y0 + dsr, 2);
					Display_CopyPattern(15, LinkElems_icon, (*m__).X0, (*m__).Y0 + dsr, 2);
				}
				if ((*m__).keys == 0x02) {
					follow.f = (*m__).frame;
					(*(*(LinkElems_Elem*)&e)->handle)((void*)(*(LinkElems_Elem*)&e), (void*)&follow, LinkElems_FollowMsg__typ);
				} else if ((*m__).keys == 0x03) {
					LinkElems_Edit((*(LinkElems_Elem*)&e));
				}
			}
		} else if (__IS(m__typ, LinkElems_FollowMsg, 1)) {
			LinkElems_FollowMsg *m__ = (void*)m;
			LinkElems_FollowLink((*(LinkElems_Elem*)&e)->file, 32, (*(LinkElems_Elem*)&e)->key, (*m__).f, (void*)(*(LinkElems_Elem*)&e));
		}
	} else __WITHCHK;
}

void LinkElems_HandleMenu (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	LinkElems_Menu e1 = NIL;
	if (__ISP(e, LinkElems_MenuDesc, 3)) {
		if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("LinkElems", (*m__).mod, 10);
			__MOVE("AllocMenu", (*m__).proc, 10);
		} else if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			__NEW(e1, LinkElems_MenuDesc);
			(*m__).e = (Texts_Elem)e1;
			PopupElems_Handle((void*)(*(LinkElems_Menu*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			if ((*m__).prepare) {
				(*(LinkElems_Menu*)&e)->W = 13 * TextFrames_Unit;
				(*(LinkElems_Menu*)&e)->H = (LONGINT)(TextFrames_menuH - 1) * (LONGINT)TextFrames_Unit;
			} else {
				(*(LinkElems_Menu*)&e)->name[0] = 0x00;
				PopupElems_Handle((void*)(*(LinkElems_Menu*)&e), (void*)&*m__, m__typ);
				Display_CopyPattern(15, LinkElems_icon, (*m__).X0 + 2, (*m__).Y0 + 3, 1);
			}
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if (__IN(1, (*m__).keys)) {
				LinkElems_CollectMarks((*(LinkElems_Menu*)&e), (*m__).frame);
				PopupElems_Handle((void*)(*(LinkElems_Menu*)&e), (void*)&*m__, m__typ);
				LinkElems_hint = NIL;
			}
		} else {
			PopupElems_Handle((void*)(*(LinkElems_Menu*)&e), &*m, m__typ);
		}
	} else __WITHCHK;
}

void LinkElems_Alloc (void)
{
	LinkElems_Elem e = NIL;
	__NEW(e, LinkElems_ElemDesc);
	e->handle = LinkElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void LinkElems_AllocMenu (void)
{
	LinkElems_Menu e = NIL;
	__NEW(e, LinkElems_MenuDesc);
	e->handle = LinkElems_HandleMenu;
	Texts_new = (Texts_Elem)e;
}

LinkElems_Elem LinkElems_New (CHAR *file, LONGINT file__len, LONGINT key)
{
	LinkElems_Elem e = NIL;
	__DUP(file, file__len, CHAR);
	__NEW(e, LinkElems_ElemDesc);
	e->W = 10 * TextFrames_Unit;
	e->H = 11 * TextFrames_Unit;
	e->handle = LinkElems_Handle;
	__COPY(file, e->file, 32);
	e->key = key;
	__DEL(file);
	return e;
}

void LinkElems_Insert (void)
{
	LinkElems_Elem link = NIL;
	MarkElems_Elem mark = NIL;
	Texts_Text fromT = NIL, toT = NIL;
	LONGINT toPos = 0, end = 0, time = 0;
	Texts_Reader r = {0};
	CHAR ch = 0;
	TextFrames_InsertElemMsg m = {0};
	TextFrames_Frame f = NIL;
	f = __GUARDP(Oberon_FocusViewer->dsc, TextFrames_FrameDesc, 1);
	if (f->hasCar) {
		fromT = f->text;
	} else {
		fromT = __GUARDP(f->next, TextFrames_FrameDesc, 1)->text;
	}
	Oberon_GetSelection(&toT, &toPos, &end, &time);
	if (time >= 0) {
		link = LinkElems_New((CHAR*)"", (LONGINT)1, 0);
		if (fromT == toT) {
			__MOVE("*", link->file, 2);
		} else {
			LinkElems_GetFileName(toT, (void*)link->file, 32);
		}
		Texts_OpenReader(&r, Texts_Reader__typ, toT, toPos);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		m.e = (Texts_Elem)link;
		Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
		if (ch == 0x1c && __ISP(r.elem, MarkElems_ElemDesc, 2)) {
			link->key = __GUARDP(r.elem, MarkElems_ElemDesc, 2)->key;
		} else {
			if (fromT == toT && Texts_ElemPos((void*)link) <= toPos) {
				toPos += 1;
			}
			mark = MarkElems_New();
			link->key = mark->key;
			Texts_WriteElem(&LinkElems_w, Texts_Writer__typ, (void*)mark);
			Texts_Insert(toT, toPos, LinkElems_w.buf);
		}
	}
}

void LinkElems_InsertMenu (void)
{
	LinkElems_Menu e = NIL;
	TextFrames_InsertElemMsg insert = {0};
	__NEW(e, LinkElems_MenuDesc);
	e->handle = LinkElems_HandleMenu;
	e->name[0] = 0x00;
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	insert.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insert, TextFrames_InsertElemMsg__typ);
}

void LinkElems_Update (void)
{
	LinkElems_Frame f = NIL;
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	Texts_Reader r = {0};
	CHAR ch = 0;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc && __ISP(Oberon_Par->frame->next, LinkElems_FrameDesc, 2)) {
		f = __GUARDP(Oberon_Par->frame->next, LinkElems_FrameDesc, 2);
		Texts_OpenScanner(&s, Texts_Scanner__typ, f->text, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1) {
			__COPY(s.s, f->e->file, 32);
		} else if (s.class == 6 && s.c == '*') {
			__MOVE("*", f->e->file, 2);
		}
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 3) {
			f->e->key = s.i;
		}
		t = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
		Texts_OpenReader(&r, Texts_Reader__typ, t, t->len - 1);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		if (ch == '!') {
			Texts_Delete(t, t->len - 1, t->len);
		}
	}
}

static void LinkElems_InitIcon (void)
{
	SET line[9];
	line[8] = 0x10;
	line[7] = 0x28;
	line[6] = 0x44;
	line[5] = 0xee;
	line[4] = 0x28;
	line[3] = 0x28;
	line[2] = 0x28;
	line[1] = 0x38;
	LinkElems_icon = Display_NewPattern((void*)line, 9, 9, 8);
	line[8] = 0x10;
	line[7] = 0x38;
	line[6] = 0x7c;
	line[5] = 0xfe;
	line[4] = 0x38;
	line[3] = 0x38;
	line[2] = 0x38;
	line[1] = 0x38;
	LinkElems_invIcon = Display_NewPattern((void*)line, 9, 9, 8);
}

static void EnumPtrs(void (*P)(void*))
{
	P(LinkElems_hint);
	__ENUMR(&LinkElems_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(LinkElems_ElemDesc, 1, 4) = {__TDFLDS("ElemDesc", 72), {0, 4, 12, 32, -20}};
__TDESC(LinkElems_FollowMsg, 1, 1) = {__TDFLDS("FollowMsg", 4), {0, -8}};
__TDESC(LinkElems_MenuDesc, 1, 5) = {__TDFLDS("MenuDesc", 88), {0, 4, 12, 32, 68, -24}};
__TDESC(LinkElems_FrameDesc, 1, 9) = {__TDFLDS("FrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};

export void *LinkElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(FoldElems);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MarkElems);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(PopupElems);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(LinkElems, EnumPtrs);
	__REGCMD("Alloc", LinkElems_Alloc);
	__REGCMD("AllocMenu", LinkElems_AllocMenu);
	__REGCMD("Insert", LinkElems_Insert);
	__REGCMD("InsertMenu", LinkElems_InsertMenu);
	__REGCMD("Update", LinkElems_Update);
	__INITYP(LinkElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(LinkElems_FollowMsg, Texts_ElemMsg, 1);
	__INITYP(LinkElems_MenuDesc, PopupElems_ElemDesc, 3);
	__INITYP(LinkElems_FrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&LinkElems_w, Texts_Writer__typ);
	LinkElems_InitIcon();
	LinkElems_hint = NIL;
	__ENDMOD;
}
