/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Bitmaps.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "In.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Out.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct ListElems_EditFrameDesc *ListElems_EditFrame;

typedef
	struct ListElems_ElemDesc *ListElems_Elem;

typedef
	struct ListElems_EditFrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		ListElems_Elem e;
	} ListElems_EditFrameDesc;

typedef
	struct ListElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text comboTxt, txt;
		BOOLEAN scrbar, popup, combo, multi;
		INTEGER popupH;
		LONGINT pos, org;
	} ListElems_ElemDesc;

typedef
	struct ListElems_FrameDesc *ListElems_Frame;

typedef
	struct ListElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		ListElems_Elem e;
	} ListElems_FrameDesc;


static Texts_Writer ListElems_W;
static LONGINT ListElems_arrow;
static ListElems_Elem ListElems_curElem;
static INTEGER ListElems_ex, ListElems_ey;

export LONGINT *ListElems_FrameDesc__typ;
export LONGINT *ListElems_EditFrameDesc__typ;
export LONGINT *ListElems_ElemDesc__typ;

static void ListElems_CopyOver (Texts_Text t);
static void ListElems_Delay (void);
static void ListElems_Draw (ListElems_Elem e, INTEGER x, INTEGER y, Display_Frame f, Display_Frame *ef);
static void ListElems_Find (Texts_Text t, CHAR *s, LONGINT s__len, LONGINT *beg, LONGINT *end);
static void ListElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void ListElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void ListElems_HandleAttrMsg (ListElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
static void ListElems_HandleEdit (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void ListElems_Init (ListElems_Elem e);
static void ListElems_InitMod (void);
export void ListElems_Insert (void);
static void ListElems_InvertSelection (TextFrames_Frame f, LONGINT pos, BOOLEAN multi);
static void ListElems_LineOfPos (Texts_Text t, LONGINT pos, LONGINT *line);
static void ListElems_MeasureLine (Texts_Reader *r, LONGINT *r__typ, INTEGER *lw, INTEGER *lh);
static void ListElems_MeasureList (Texts_Text t, INTEGER maxH, INTEGER *w, INTEGER *h);
export void ListElems_MoveLine (void);
export void ListElems_New (void);
static void ListElems_OpenEditor (ListElems_Elem e);
static Display_Frame ListElems_OpenFrame (ListElems_Elem e, Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static TextFrames_Frame ListElems_OpenTextFrame (ListElems_Elem e, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER type, LONGINT pos);
static void ListElems_PosOfLine (Texts_Text t, LONGINT line, LONGINT *pos);
static LONGINT ListElems_PrevSelPos (Texts_Text t, LONGINT pos);
static void ListElems_RemoveSelection (Texts_Text t);
static Texts_Text ListElems_SelToText (Texts_Text t);
static void ListElems_SelectArea (Texts_Text t, LONGINT from, LONGINT to);
static void ListElems_SetComboText (ListElems_Elem e);
static void ListElems_SetFrameCoords (ListElems_Frame src, TextFrames_Frame dest);
static void ListElems_SetPos (ListElems_Elem e, CHAR *s, LONGINT s__len);
export void ListElems_TextComboHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static void ListElems_TextLineToString (Texts_Text t, LONGINT pos, CHAR *s, LONGINT s__len);
export void ListElems_TextListHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static void ListElems_TrackSelection (SET *keysum, INTEGER *x, INTEGER *y, BOOLEAN multi, TextFrames_Frame f);
static void ListElems_TrackText (SET *keysum, INTEGER *x, INTEGER *y, TextFrames_Frame f, BOOLEAN *done);
export void ListElems_Update (void);


static void ListElems_Delay (void)
{
	LONGINT t = 0;
	t = Oberon_Time() + 70;
	while (t > Oberon_Time()) {
	}
}

static void ListElems_SetComboText (ListElems_Elem e)
{
	Texts_Buffer buf = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, e->txt, e->pos);
	do {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	} while (!(ch == 0x0d || r.eot));
	__NEW(buf, Texts_BufDesc);
	Texts_OpenBuf(buf);
	Texts_Save(e->txt, e->pos, Texts_Pos(&r, Texts_Reader__typ) - 1, buf);
	Texts_Delete(e->comboTxt, 0, e->comboTxt->len);
	Texts_Append(e->comboTxt, buf);
	Texts_ChangeLooks(e->comboTxt, 0, e->comboTxt->len, 0x02, Fonts_Default, 15, 0);
}

static void ListElems_LineOfPos (Texts_Text t, LONGINT pos, LONGINT *line)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	*line = 1;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && Texts_Pos(&r, Texts_Reader__typ) <= pos) {
		if (ch == 0x0d) {
			*line += 1;
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
}

static void ListElems_PosOfLine (Texts_Text t, LONGINT line, LONGINT *pos)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && line > 0) {
		if (ch == 0x0d) {
			line -= 1;
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	*pos = Texts_Pos(&r, Texts_Reader__typ) - 2;
}

static void ListElems_Find (Texts_Text t, CHAR *s, LONGINT s__len, LONGINT *beg, LONGINT *end)
{
	Texts_Reader r = {0};
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && s[__X(i, s__len)] != 0x00) {
		if (ch == s[0]) {
			i = 0;
			*beg = Texts_Pos(&r, Texts_Reader__typ) - 1;
			while ((!r.eot && s[__X(i, s__len)] != 0x00) && s[__X(i, s__len)] == ch) {
				Texts_Read(&r, Texts_Reader__typ, &ch);
				i += 1;
			}
			if (ch != 0x0d || s[__X(i, s__len)] != 0x00) {
				i = 0;
				while (ch != 0x0d) {
					Texts_Read(&r, Texts_Reader__typ, &ch);
				}
			}
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (s[__X(i, s__len)] != 0x00) {
		*beg = -1;
		*end = -1;
	} else {
		*end = Texts_Pos(&r, Texts_Reader__typ) - 1;
	}
	__DEL(s);
}

static void ListElems_SetPos (ListElems_Elem e, CHAR *s, LONGINT s__len)
{
	LONGINT beg = 0, end = 0;
	__DUP(s, s__len, CHAR);
	ListElems_Find(e->txt, s, s__len, &beg, &end);
	if (beg == -1) {
		e->pos = 0;
	} else {
		e->pos = beg;
	}
	__DEL(s);
}

static void ListElems_TextLineToString (Texts_Text t, LONGINT pos, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	Texts_Reader r = {0};
	CHAR ch = 0;
	LONGINT len = 0;
	i = 0;
	len = s__len;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while ((!r.eot && (LONGINT)i < len - 1) && ch != 0x0d) {
		if (ch != 0x1c) {
			s[__X(i, s__len)] = ch;
			i += 1;
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	s[__X(i, s__len)] = 0x00;
}

static Texts_Text ListElems_SelToText (Texts_Text t)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	Texts_Text res = NIL;
	Texts_CopyMsg copy = {0};
	res = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot) {
		if (r.col == 0) {
			while (!r.eot && ch != 0x0d) {
				if (ch == 0x1c) {
					copy.e = NIL;
					(*r.elem->handle)(r.elem, (void*)&copy, Texts_CopyMsg__typ);
					Texts_WriteElem(&ListElems_W, Texts_Writer__typ, copy.e);
				} else {
					Texts_Write(&ListElems_W, Texts_Writer__typ, ch);
				}
				Texts_Read(&r, Texts_Reader__typ, &ch);
			}
			Texts_WriteLn(&ListElems_W, Texts_Writer__typ);
		} else {
			while (!r.eot && ch != 0x0d) {
				Texts_Read(&r, Texts_Reader__typ, &ch);
			}
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	Texts_Append(res, ListElems_W.buf);
	return res;
}

static void ListElems_RemoveSelection (Texts_Text t)
{
	Texts_ChangeLooks(t, 0, t->len, 0x02, Fonts_Default, 15, 0);
}

static void ListElems_InvertSelection (TextFrames_Frame f, LONGINT pos, BOOLEAN multi)
{
	Texts_Reader r = {0};
	SHORTINT col = 0;
	CHAR ch = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, f->text, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	if (r.col == 0) {
		col = 15;
	} else {
		col = 0;
	}
	while (!r.eot && ch != 0x0d) {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (!multi && col == 0) {
		ListElems_RemoveSelection(f->text);
	}
	Texts_ChangeLooks(f->text, pos, Texts_Pos(&r, Texts_Reader__typ), 0x02, Fonts_Default, col, 0);
}

static void ListElems_CopyOver (Texts_Text t)
{
	Oberon_CopyOverMsg msg = {0};
	Texts_Text selT = NIL;
	selT = ListElems_SelToText(t);
	if (selT->len > 0) {
		msg.text = selT;
		msg.beg = 0;
		msg.end = msg.text->len;
		Viewers_Broadcast((void*)&msg, Oberon_CopyOverMsg__typ);
	}
}

static void ListElems_SetFrameCoords (ListElems_Frame src, TextFrames_Frame dest)
{
	dest->X = src->X + 2;
	dest->Y = src->Y + 2;
	dest->H = src->H - 4;
	dest->W = src->W - 4;
}

static void ListElems_TrackText (SET *keysum, INTEGER *x, INTEGER *y, TextFrames_Frame f, BOOLEAN *done)
{
	SET keys = 0;
	INTEGER ox = 0, oy = 0;
	Texts_Reader R = {0};
	TextFrames_Location oldloc = {0}, sloc = {0}, loc = {0};
	LONGINT oend = 0, end = 0;
	CHAR ch = 0;
	Oberon_ControlMsg N = {0};
	BOOLEAN wasin = 0;
	wasin = 0;
	N.id = 1;
	Input_Mouse(&keys, &*x, &*y);
	*keysum = 0x0;
	TextFrames_LocateLine(f, *y, &loc, TextFrames_Location__typ);
	end = TextFrames_Pos(f, f->X + f->W, loc.y);
	if (!ListElems_curElem->popup) {
		TextFrames_SetSelection(f, loc.org, end + 1);
	}
	oldloc = loc;
	oend = -1;
	ox = *x;
	oy = *y;
	while (keys != 0x0 && (*y < f->Y || *y > f->Y + f->H)) {
		Input_Mouse(&keys, &*x, &*y);
		*keysum = *keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
	}
	while (keys != 0x0) {
		Input_Mouse(&keys, &*x, &*y);
		*keysum = *keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
		if (ox != *x || oy != *y) {
			while (((wasin && *y > f->Y + f->H) && f->org > 0) && keys == 0x02) {
				ListElems_Delay();
				TextFrames_Show(f, f->org - 1);
				Input_Mouse(&keys, &*x, &*y);
				*keysum = *keysum | keys;
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
			}
			while (((wasin && *y < f->Y) && oend < f->text->len - 1) && keys == 0x02) {
				ListElems_Delay();
				Texts_OpenReader(&R, Texts_Reader__typ, f->text, f->org);
				Texts_Read(&R, Texts_Reader__typ, &ch);
				while (ch != 0x0d) {
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
				TextFrames_Show(f, Texts_Pos(&R, Texts_Reader__typ) + 1);
				TextFrames_LocateLine(f, f->Y, &sloc, TextFrames_Location__typ);
				oend = TextFrames_Pos(f, f->X + f->W, sloc.y);
				Input_Mouse(&keys, &*x, &*y);
				*keysum = *keysum | keys;
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
			}
			if (((*x < f->X + f->left || *x > f->X + f->W) || *y < f->Y) || *y > f->Y + f->H) {
				(*f->handle)((void*)f, (void*)&N, Oberon_ControlMsg__typ);
				while ((((*x < f->X + f->left || *x > f->X + f->W) || *y < f->Y) || *y > f->Y + f->H) && keys != 0x0) {
					Input_Mouse(&keys, &*x, &*y);
					*keysum = *keysum | keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
				}
				oend = -1;
			}
			TextFrames_LocateLine(f, *y, &loc, TextFrames_Location__typ);
			end = TextFrames_Pos(f, f->X + f->W, loc.y);
			if (oend != end || loc.org != oldloc.org) {
				(*f->handle)((void*)f, (void*)&N, Oberon_ControlMsg__typ);
				oldloc = loc;
				oend = end;
				TextFrames_SetSelection(f, loc.org, end + 1);
				wasin = 1;
			}
			ox = *x;
			oy = *y;
		}
	}
	(*f->handle)((void*)f, (void*)&N, Oberon_ControlMsg__typ);
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
	if (((((!__IN(0, *keysum) && loc.org != f->text->len) && *x > f->X + f->left) && *x < f->X + f->W) && *y > f->Y) && *y < f->Y + f->H) {
		ListElems_curElem->pos = loc.org;
		*done = 1;
	}
}

static LONGINT ListElems_PrevSelPos (Texts_Text t, LONGINT pos)
{
	LONGINT lastPos = 0;
	Texts_Reader r = {0};
	CHAR ch = 0;
	lastPos = -1;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && Texts_Pos(&r, Texts_Reader__typ) - 1 != pos) {
		if (r.col == 0) {
			lastPos = Texts_Pos(&r, Texts_Reader__typ) - 1;
		}
		while (!r.eot && ch != 0x0d) {
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	return lastPos;
}

static void ListElems_SelectArea (Texts_Text t, LONGINT from, LONGINT to)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, to);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && ch != 0x0d) {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	Texts_ChangeLooks(t, from, Texts_Pos(&r, Texts_Reader__typ) - 1, 0x02, NIL, 0, 0);
}

static void ListElems_TrackSelection (SET *keysum, INTEGER *x, INTEGER *y, BOOLEAN multi, TextFrames_Frame f)
{
	SET keys = 0;
	INTEGER ox = 0, oy = 0;
	Texts_Reader R = {0};
	TextFrames_Location oldloc = {0}, sloc = {0}, loc = {0};
	LONGINT oend = 0, end = 0;
	CHAR ch = 0;
	Input_Mouse(&keys, &*x, &*y);
	*keysum = 0x0;
	TextFrames_LocateLine(f, *y, &loc, TextFrames_Location__typ);
	end = TextFrames_Pos(f, f->X + f->W, loc.y);
	ListElems_InvertSelection(f, loc.org, multi);
	oldloc = loc;
	oend = end;
	ox = *x;
	oy = *y;
	while (keys != 0x0) {
		Input_Mouse(&keys, &*x, &*y);
		*keysum = *keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
		if (ox != *x || oy != *y) {
			while ((*y > f->Y + f->H && f->org > 0) && (keys == 0x01 || keys == 0x04)) {
				ListElems_Delay();
				TextFrames_Show(f, f->org - 1);
				ListElems_InvertSelection(f, f->org, multi);
				Input_Mouse(&keys, &*x, &*y);
				*keysum = *keysum | keys;
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
			}
			while ((*y < f->Y && oend < f->text->len - 1) && (keys == 0x01 || keys == 0x04)) {
				ListElems_Delay();
				Texts_OpenReader(&R, Texts_Reader__typ, f->text, f->org);
				Texts_Read(&R, Texts_Reader__typ, &ch);
				while (ch != 0x0d) {
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
				TextFrames_Show(f, Texts_Pos(&R, Texts_Reader__typ) + 1);
				TextFrames_LocateLine(f, f->Y, &sloc, TextFrames_Location__typ);
				oend = TextFrames_Pos(f, f->X + f->W, sloc.y);
				ListElems_InvertSelection(f, sloc.org, multi);
				Input_Mouse(&keys, &*x, &*y);
				*keysum = *keysum | keys;
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
			}
			if (*x < f->X + f->left || *x > f->X + f->W) {
				while ((*x < f->X + f->left || *x > f->X + f->W) && (keys == 0x01 || keys == 0x04)) {
					Input_Mouse(&keys, &*x, &*y);
					*keysum = *keysum | keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
				}
				oend = -1;
			}
			TextFrames_LocateLine(f, *y, &loc, TextFrames_Location__typ);
			end = TextFrames_Pos(f, f->X + f->W, loc.y);
			if ((oend != end || loc.org != oldloc.org) && end < f->text->len) {
				oldloc = loc;
				oend = end;
				ListElems_InvertSelection(f, loc.org, multi);
			}
			ox = *x;
			oy = *y;
		}
	}
	if (*keysum == 0x05) {
		end = ListElems_PrevSelPos(f->text, loc.org);
		if (end != -1) {
			ListElems_SelectArea(f->text, end, loc.org);
		}
	} else if (*keysum == 0x03) {
		ListElems_CopyOver(f->text);
	}
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
}

static void ListElems_HandleEdit (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	ListElems_EditFrame f1 = NIL;
	TextFrames_Handle(f, &*msg, msg__typ);
	if (__ISP(f, ListElems_EditFrameDesc, 2)) {
		if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
			__NEW(f1, ListElems_EditFrameDesc);
			TextFrames_Open((void*)f1, (*(ListElems_EditFrame*)&f)->text, (*(ListElems_EditFrame*)&f)->org);
			f1->handle = (*(ListElems_EditFrame*)&f)->handle;
			f1->e = (*(ListElems_EditFrame*)&f)->e;
			__GUARDR(msg, Oberon_CopyMsg, 1).F = (Display_Frame)f1;
		}
	} else __WITHCHK;
}

static void ListElems_OpenEditor (ListElems_Elem e)
{
	Viewers_Viewer v = NIL;
	ListElems_EditFrame f = NIL;
	INTEGER x = 0, y = 0;
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	__NEW(f, ListElems_EditFrameDesc);
	f->e = e;
	TextFrames_Open((void*)f, Elems_CopyText(e->txt), 0);
	f->handle = ListElems_HandleEdit;
	v = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"ListElems", (LONGINT)10, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Parcs ListElems.Update ", (LONGINT)69), (void*)f, TextFrames_menuH, x, y);
}

static void ListElems_MeasureLine (Texts_Reader *r, LONGINT *r__typ, INTEGER *lw, INTEGER *lh)
{
	CHAR ch = 0;
	INTEGER x = 0, y = 0, w = 0, h = 0, dx = 0, dsr = 0;
	LONGINT p = 0, pH = 0;
	Texts_Read(&*r, r__typ, &ch);
	*lw = 0;
	*lh = 0;
	dsr = 0;
	y = 0;
	while (!(*r).eot && ch != 0x0d) {
		if ((*r).elem != NIL) {
			h = (int)__DIV((*r).elem->H, (LONGINT)TextFrames_Unit);
			dx = (int)__DIV((*r).elem->W, (LONGINT)TextFrames_Unit);
			y = (*r).fnt->minY;
		} else {
			Display_GetChar((*r).fnt->raster, ch, &dx, &x, &y, &w, &h, &p);
			y += __ASHR((*r).fnt->height * (int)(*r).voff, 6);
		}
		if (y < dsr) {
			dsr = y;
		}
		if (y + h > *lh) {
			*lh = y + h;
		}
		*lw = *lw + dx;
		Texts_Read(&*r, r__typ, &ch);
	}
	if (!(*r).eot) {
		dsr = -dsr;
		if ((LONGINT)dsr < __DIV(TextFrames_defParc->dsr, (LONGINT)TextFrames_Unit)) {
			dsr = (int)__DIV(TextFrames_defParc->dsr, (LONGINT)TextFrames_Unit);
		}
		__ASSERT(dsr >= 0, 0);
		*lh = *lh + dsr;
		if ((LONGINT)*lh < __DIV(TextFrames_defParc->lsp, (LONGINT)TextFrames_Unit)) {
			*lh = (int)__DIV(TextFrames_defParc->lsp, (LONGINT)TextFrames_Unit);
		}
	} else {
		*lh = 0;
	}
}

static void ListElems_MeasureList (Texts_Text t, INTEGER maxH, INTEGER *w, INTEGER *h)
{
	Texts_Reader r = {0};
	INTEGER lw = 0, lh = 0;
	if (t->len == 0) {
		*w = -1;
		*h = -1;
		return;
	}
	*w = 0;
	*h = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	while (!r.eot) {
		ListElems_MeasureLine(&r, Texts_Reader__typ, &lw, &lh);
		if (lw > *w) {
			*w = lw;
		}
		if ((*h + lh) + 6 <= maxH) {
			*h = *h + lh;
		}
	}
	*w = *w + 8;
	*h = *h + 6;
	if (*w > Display_Width) {
		Out_String((CHAR*)"toomuch", (LONGINT)8);
		Out_Ln();
		*w = Display_Width;
	}
}

void ListElems_TextListHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	SET keysum = 0;
	INTEGER x = 0, y = 0, w = 0, h = 0, py = 0, px = 0;
	Bitmaps_Bitmap bmp = NIL;
	TextFrames_Frame lf = NIL;
	Elems_ExecMsg exec = {0};
	MenuViewers_ModifyMsg modify = {0};
	Texts_Text t = NIL;
	BOOLEAN done = 0;
	if (__ISP(f, TextFrames_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 1) {
				if ((*msg__).X >= (*(TextFrames_Frame*)&f)->X && (*msg__).X < (*(TextFrames_Frame*)&f)->X + (*(TextFrames_Frame*)&f)->barW) {
					TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
					ListElems_curElem->org = (*(TextFrames_Frame*)&f)->org;
				} else if ((*msg__).keys == 0x02) {
					if (ListElems_curElem->popup) {
						ListElems_MeasureList(ListElems_curElem->txt, ListElems_curElem->popupH, &w, &h);
						if ((LONGINT)h < __DIV(ListElems_curElem->H, (LONGINT)TextFrames_Unit)) {
							h = (int)__DIV(ListElems_curElem->H, (LONGINT)TextFrames_Unit);
						}
						if ((LONGINT)w < __DIV(ListElems_curElem->W, (LONGINT)TextFrames_Unit)) {
							w = (int)__DIV(ListElems_curElem->W, (LONGINT)TextFrames_Unit);
						}
						if (ListElems_ey - h < 0) {
							py = ListElems_ey + (int)__DIV(ListElems_curElem->H, (LONGINT)TextFrames_Unit);
						} else {
							py = ListElems_ey - h;
						}
						if (ListElems_ex + w > Display_Width) {
							px = Display_Width - w;
						} else {
							px = ListElems_ex;
						}
						bmp = Bitmaps_New(w, h);
						Bitmaps_CopyBlock(Bitmaps_Disp, bmp, px, py, w, h, 0, 0, 0);
						GUtils_Frame(NIL, 15, px, py, w, h, 1, 1);
						lf = ListElems_OpenTextFrame(ListElems_curElem, px + 1, py + 1, w - 2, h - 2, 1, 0);
						modify.id = 1;
						modify.Y = lf->Y;
						modify.H = lf->H;
						(*lf->handle)((void*)lf, (void*)&modify, MenuViewers_ModifyMsg__typ);
					} else {
						lf = (*(TextFrames_Frame*)&f);
					}
					ListElems_TrackText(&keysum, &x, &y, lf, &done);
					if (ListElems_curElem->popup) {
						Bitmaps_CopyBlock(bmp, Bitmaps_Disp, 0, 0, w, h, px, py, 0);
						if (done) {
							if (ListElems_curElem->combo) {
								ListElems_SetComboText(ListElems_curElem);
							} else {
								TextFrames_Show((*(TextFrames_Frame*)&f), ListElems_curElem->pos);
							}
						}
					}
					if (keysum == 0x03) {
						if (!ListElems_curElem->locked) {
							ListElems_OpenEditor(ListElems_curElem);
						}
					} else if (((((done && keysum != 0x07) && x >= lf->X + lf->left) && x < lf->X + lf->W) && y > lf->Y) && y < lf->Y + lf->H) {
						exec.e = (Elems_Elem)ListElems_curElem;
						exec.x = (*(TextFrames_Frame*)&f)->X;
						exec.y = (*(TextFrames_Frame*)&f)->Y;
						exec.f = (Display_Frame)(*(TextFrames_Frame*)&f);
						exec.unload = __IN(2, keysum);
						(*ListElems_curElem->handle)((void*)ListElems_curElem, (void*)&exec, Elems_ExecMsg__typ);
					}
				} else if ((*msg__).keys == 0x01) {
					if (ListElems_curElem->popup && ListElems_curElem->combo) {
					} else if (!ListElems_curElem->popup) {
						(*(TextFrames_Frame*)&f)->time = Oberon_Time();
						ListElems_TrackSelection(&keysum, &x, &y, ListElems_curElem->multi, (*(TextFrames_Frame*)&f));
					}
				} else if ((*msg__).keys == 0x04) {
					if (ListElems_curElem->popup && ListElems_curElem->combo) {
					} else if (!ListElems_curElem->popup) {
						(*(TextFrames_Frame*)&f)->time = Oberon_Time();
						ListElems_TrackSelection(&keysum, &x, &y, 0, (*(TextFrames_Frame*)&f));
					}
				} else {
					TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
					ListElems_curElem->org = (*(TextFrames_Frame*)&f)->org;
				}
			}
		} else if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
			Oberon_SelectionMsg *msg__ = (void*)msg;
			if ((*(TextFrames_Frame*)&f)->time > (*msg__).time) {
				t = ListElems_SelToText((*(TextFrames_Frame*)&f)->text);
				if (t->len > 0) {
					(*msg__).text = t;
					(*msg__).beg = 0;
					(*msg__).end = (*msg__).text->len;
					(*msg__).time = (*(TextFrames_Frame*)&f)->time;
				}
			}
		} else {
			TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void ListElems_TextComboHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Elems_ExecMsg exec = {0};
	if (__ISP(f, TextFrames_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 1) {
				if ((*msg__).keys == 0x02) {
					ListElems_TextListHandle((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
				} else {
					TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
				}
			} else if ((*msg__).id == 0 && (*(TextFrames_Frame*)&f)->hasCar) {
				if ((*msg__).ch == 0x0d) {
					exec.e = (Elems_Elem)ListElems_curElem;
					exec.x = (*(TextFrames_Frame*)&f)->X;
					exec.y = (*(TextFrames_Frame*)&f)->Y;
					exec.f = (Display_Frame)(*(TextFrames_Frame*)&f);
					exec.unload = 0;
					(*ListElems_curElem->handle)((void*)ListElems_curElem, (void*)&exec, Elems_ExecMsg__typ);
				} else {
					TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
				}
			} else {
				TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else {
			TextFrames_Handle((void*)(*(TextFrames_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

static void ListElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
		MenuViewers_ModifyMsg *msg__ = (void*)msg;
		ListElems_SetFrameCoords(__GUARDP(f, ListElems_FrameDesc, 1), __GUARDP(f->dsc, TextFrames_FrameDesc, 1));
	} else if (__IS(msg__typ, Elems_GetFrameMsg, 1)) {
		Elems_GetFrameMsg *msg__ = (void*)msg;
		if ((*msg__).e == (void *) __GUARDP(f, ListElems_FrameDesc, 1)->e) {
			(*msg__).f = f->dsc;
		}
	} else if (__IS(msg__typ, Elems_GetContextMsg, 1)) {
		Elems_GetContextMsg *msg__ = (void*)msg;
		if ((*msg__).p == (void *) __GUARDP(f, ListElems_FrameDesc, 1)->e && ((((*msg__).fx >= f->X && (*msg__).fx <= f->X + f->W) && (*msg__).fy >= f->Y) && (*msg__).fy <= f->Y + f->H || (*msg__).fx < 0 && (*msg__).fy < 0)) {
			(*msg__).context = f;
			(*msg__).p = NIL;
		}
	} else if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
		TextFrames_UpdateMsg *msg__ = (void*)msg;
		if ((*msg__).text == __GUARDP(f, ListElems_FrameDesc, 1)->e->txt) {
			__GUARDP(f, ListElems_FrameDesc, 1)->e->pos = 0;
			__GUARDP(f, ListElems_FrameDesc, 1)->e->org = 0;
		}
		(*f->dsc->handle)(f->dsc, (void*)&*msg__, msg__typ);
	} else {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			ListElems_curElem = __GUARDP(f, ListElems_FrameDesc, 1)->e;
			ListElems_ex = f->X;
			ListElems_ey = f->Y;
		}
		(*f->dsc->handle)(f->dsc, &*msg, msg__typ);
	}
}

static TextFrames_Frame ListElems_OpenTextFrame (ListElems_Elem e, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER type, LONGINT pos)
{
	TextFrames_Frame new = NIL;
	if (type == 3) {
		new = TextFrames_NewText(e->comboTxt, 0);
	} else {
		new = TextFrames_NewText(e->txt, pos);
	}
	new->X = x;
	new->Y = y;
	new->W = w;
	new->H = h;
	new->right = 2;
	new->top = 2;
	new->bot = 0;
	new->showsParcs = 0;
	new->left = 2;
	new->barW = 0;
	new->col = 12;
	if (type == 1) {
		new->handle = ListElems_TextListHandle;
		if (!e->popup && e->scrbar) {
			new->barW = TextFrames_barW;
			new->left = new->barW + 2;
		}
	} else if (type == 3) {
		new->handle = ListElems_TextComboHandle;
		new->col = 0;
	} else if (type == 2) {
		new->handle = ListElems_TextListHandle;
	}
	return new;
}

static Display_Frame ListElems_OpenFrame (ListElems_Elem e, Display_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	ListElems_Frame new = NIL;
	INTEGER type = 0;
	MenuViewers_ModifyMsg m = {0};
	__NEW(new, ListElems_FrameDesc);
	new->handle = ListElems_FrameHandle;
	new->e = e;
	new->X = x;
	new->Y = y;
	new->W = w;
	new->H = h;
	if (!e->popup) {
		type = 1;
	} else if (e->combo) {
		type = 3;
	} else {
		type = 2;
	}
	if (type == 1) {
		new->dsc = (Display_Frame)ListElems_OpenTextFrame(e, x + 2, y + 2, w - 4, h - 4, type, e->org);
	} else {
		new->dsc = (Display_Frame)ListElems_OpenTextFrame(e, x + 2, y + 2, (w - 4) - 15, h - 4, type, e->pos);
	}
	Elems_AdjustSubFrame(f, (void*)new);
	Elems_AdjustSubFrame((void*)new, new->dsc);
	m.id = 1;
	m.Y = new->dsc->Y;
	m.H = new->dsc->H;
	(*new->dsc->handle)(new->dsc, (void*)&m, MenuViewers_ModifyMsg__typ);
	return (void*)new;
}

static void ListElems_HandleAttrMsg (ListElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 2;
			if (e->popup && e->combo) {
				ListElems_TextLineToString(e->comboTxt, 0, (void*)(*msg).s, 256);
			} else {
				ListElems_TextLineToString(e->txt, e->pos, (void*)(*msg).s, 256);
			}
		} else if (__STRCMP((*msg).name, "ValueT") == 0) {
			(*msg).class = 9;
			(*msg).t = e->txt;
		} else if (__STRCMP((*msg).name, "Line") == 0) {
			(*msg).class = 3;
			ListElems_LineOfPos(e->txt, e->pos, &(*msg).i);
		} else if (__STRCMP((*msg).name, "ComboV") == 0) {
			(*msg).class = 2;
			ListElems_TextLineToString(e->comboTxt, 0, (void*)(*msg).s, 256);
		} else if (__STRCMP((*msg).name, "ComboVT") == 0) {
			(*msg).class = 9;
			(*msg).t = e->comboTxt;
		} else if (__STRCMP((*msg).name, "Sel") == 0) {
			(*msg).class = 2;
			ListElems_TextLineToString(ListElems_SelToText(e->txt), 0, (void*)(*msg).s, 256);
		} else if (__STRCMP((*msg).name, "SelT") == 0) {
			(*msg).class = 9;
			(*msg).t = ListElems_SelToText(e->txt);
		} else if (__STRCMP((*msg).name, "Scrollbar") == 0) {
			(*msg).class = 7;
			(*msg).b = e->scrbar;
		} else if (__STRCMP((*msg).name, "Popup") == 0) {
			(*msg).class = 7;
			(*msg).b = e->popup;
		} else if (__STRCMP((*msg).name, "Combo") == 0) {
			(*msg).class = 7;
			(*msg).b = e->combo;
		} else if (__STRCMP((*msg).name, "Multi") == 0) {
			(*msg).class = 7;
			(*msg).b = e->multi;
		} else if (__STRCMP((*msg).name, "PopupH") == 0) {
			(*msg).class = 3;
			(*msg).i = e->popupH;
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			if ((*msg).class == 2) {
				ListElems_SetPos(e, (*msg).s, 256);
			}
		} else if (__STRCMP((*msg).name, "ValueT") == 0) {
			if ((*msg).class == 9) {
				e->txt = (*msg).t;
			}
		} else if (__STRCMP((*msg).name, "Line") == 0) {
			if ((*msg).class == 3) {
				ListElems_PosOfLine(e->txt, (*msg).i, &e->pos);
			}
		} else if (__STRCMP((*msg).name, "ComboV") == 0) {
			if ((*msg).class == 2) {
				Texts_Delete(e->comboTxt, 0, e->comboTxt->len);
				Texts_WriteString(&ListElems_W, Texts_Writer__typ, (*msg).s, 256);
				Texts_Append(e->comboTxt, ListElems_W.buf);
			}
		} else if (__STRCMP((*msg).name, "ComboVT") == 0) {
			if ((*msg).class == 9) {
				e->comboTxt = (*msg).t;
			}
		} else if (__STRCMP((*msg).name, "Sel") == 0) {
		} else if (__STRCMP((*msg).name, "SelT") == 0) {
		} else if (__STRCMP((*msg).name, "Scrollbar") == 0) {
			if ((*msg).class == 7) {
				e->scrbar = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Popup") == 0) {
			if ((*msg).class == 7) {
				if (!e->popup && (*msg).b) {
					e->H = (LONGINT)((Fonts_Default->maxY - Fonts_Default->minY) + 7) * (LONGINT)TextFrames_Unit;
				}
				e->popup = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Combo") == 0) {
			if ((*msg).class == 7) {
				e->combo = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Multi") == 0) {
			if ((*msg).class == 7) {
				e->multi = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "PopupH") == 0) {
			if ((*msg).class == 3) {
				e->popupH = (int)(*msg).i;
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Scrollbar", (LONGINT)10, 7);
		(*(*msg).enum_)((CHAR*)"Popup", (LONGINT)6, 7);
		(*(*msg).enum_)((CHAR*)"Combo", (LONGINT)6, 7);
		(*(*msg).enum_)((CHAR*)"Multi", (LONGINT)6, 7);
		(*(*msg).enum_)((CHAR*)"Value", (LONGINT)6, 2);
		(*(*msg).enum_)((CHAR*)"ValueT", (LONGINT)7, 9);
		(*(*msg).enum_)((CHAR*)"PopupH", (LONGINT)7, 3);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

static void ListElems_Draw (ListElems_Elem e, INTEGER x, INTEGER y, Display_Frame f, Display_Frame *ef)
{
	INTEGER h = 0, w = 0, one = 0, bw = 0, arrw = 0, arrh = 0, dx = 0;
	LONGINT pos = 0;
	Texts_Text t = NIL;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	one = GUtils_Unit(1, 0);
	bw = GUtils_Unit(15, 0);
	arrw = GUtils_Unit(9, 0);
	arrh = GUtils_Unit(5, 0);
	if (GUtils_device == 2) {
		*ef = ListElems_OpenFrame(e, f, x, y, w, h);
	}
	GUtils_Area(f, 0, 0, x, y, w, h, __ASHL(one, 1), 0, 1);
	if (e->popup) {
		GUtils_ReplConst(f, 12, x + __ASHL(one, 1), y + __ASHL(one, 1), (w - __ASHL(one, 2)) - bw, one, 1);
		GUtils_Area(f, 13, 0, ((x + w) - bw) - __ASHL(one, 1), y + __ASHL(one, 1), bw, h - __ASHL(one, 2), one, 1, 0);
		if (h - __ASHL(one, 2) > arrh && w - __ASHL(one, 2) > arrw) {
			GUtils_CopyPattern(f, 15, ListElems_arrow, (((x + w) - arrw) - __ASHL(one, 1)) - __ASHR(bw - arrw, 1), (y + 1) + __ASHR(h - arrh, 1), 1);
		}
	}
	if (GUtils_device == 1) {
		pos = 0;
		if (e->popup) {
			if (e->combo) {
				t = e->comboTxt;
				pos = e->pos;
			} else {
				t = e->txt;
			}
			TextPrinter_PlaceBody(x + GUtils_Unit(2, 0), y, w - GUtils_Unit(17, 0), h, e->txt, &pos, 0, 1);
		} else {
			dx = 0;
			if (e->scrbar) {
				dx = GUtils_Unit(TextFrames_barW, 0);
				GUtils_ReplConst(f, 0, x + dx, y, GUtils_Unit(1, 0), GUtils_Unit(e->H, 1), 1);
			}
			TextPrinter_PlaceBody((x + dx) + GUtils_Unit(2, 0), y, w, h, e->txt, &pos, 0, 1);
		}
	}
}

void ListElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	ListElems_Elem copy = NIL;
	CHAR ch = 0;
	Display_Frame f = NIL;
	if (__ISP(e, ListElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				ListElems_Draw((*(ListElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).frame, &(*msg__).elemFrame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				ListElems_Draw((*(ListElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, NIL, &f);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ListElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				Elems_ToFrame((void*)(*(ListElems_Elem*)&e), *msg__);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			__NEW(copy, ListElems_ElemDesc);
			Elems_CopyElem((void*)(*(ListElems_Elem*)&e), (void*)copy);
			copy->txt = Elems_CopyText((*(ListElems_Elem*)&e)->txt);
			copy->comboTxt = Elems_CopyText((*(ListElems_Elem*)&e)->comboTxt);
			copy->scrbar = (*(ListElems_Elem*)&e)->scrbar;
			copy->popup = (*(ListElems_Elem*)&e)->popup;
			copy->combo = (*(ListElems_Elem*)&e)->combo;
			copy->multi = (*(ListElems_Elem*)&e)->multi;
			copy->popupH = (*(ListElems_Elem*)&e)->popupH;
			copy->pos = (*(ListElems_Elem*)&e)->pos;
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("ListElems", (*msg__).mod, 10);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			ListElems_HandleAttrMsg((*(ListElems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ListElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Texts_Load(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->txt);
				Texts_Load(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->comboTxt);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(ListElems_Elem*)&e)->scrbar);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(ListElems_Elem*)&e)->popup);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(ListElems_Elem*)&e)->combo);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(ListElems_Elem*)&e)->multi);
				Files_ReadInt(&(*msg__).r, Files_Rider__typ, &(*(ListElems_Elem*)&e)->popupH);
				Files_ReadLInt(&(*msg__).r, Files_Rider__typ, &(*(ListElems_Elem*)&e)->pos);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Texts_Store(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->txt);
				Texts_Store(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->comboTxt);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->scrbar);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->popup);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->combo);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->multi);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->popupH);
				if ((*(ListElems_Elem*)&e)->popup) {
					Files_WriteLInt(&(*msg__).r, Files_Rider__typ, (*(ListElems_Elem*)&e)->pos);
				} else {
					Files_WriteLInt(&(*msg__).r, Files_Rider__typ, 0);
				}
			}
		} else {
			Elems_Handle((void*)(*(ListElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void ListElems_Init (ListElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = ListElems_Handle;
	e->txt = TextFrames_Text((CHAR*)"", (LONGINT)1);
	e->comboTxt = TextFrames_Text((CHAR*)"", (LONGINT)1);
	e->scrbar = 1;
	e->popup = 0;
	e->combo = 0;
	e->popupH = 90;
	e->pos = 0;
	e->H = 50 * TextFrames_Unit;
	e->W = 90 * TextFrames_Unit;
}

void ListElems_New (void)
{
	ListElems_Elem e = NIL;
	__NEW(e, ListElems_ElemDesc);
	ListElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void ListElems_Insert (void)
{
	ListElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, ListElems_ElemDesc);
	ListElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

void ListElems_Update (void)
{
	ListElems_EditFrame F = NIL;
	Texts_Scanner S = {0};
	Texts_Text menuText = NIL;
	ListElems_Elem E = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		F = __GUARDP(Oberon_Par->frame->next, ListElems_EditFrameDesc, 2);
		E = F->e;
		menuText = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
		E->txt = Elems_CopyText(F->text);
		E->pos = 0;
		ListElems_RemoveSelection(E->txt);
		Elems_UpdateElem((void*)E);
		Texts_OpenReader((void*)&S, Texts_Scanner__typ, menuText, menuText->len - 1);
		Texts_Read((void*)&S, Texts_Scanner__typ, &S.c);
		if (S.c == '!') {
			Texts_Delete(menuText, menuText->len - 1, menuText->len);
		}
	}
}

void ListElems_MoveLine (void)
{
	Elems_Elem e = NIL;
	CHAR fromName[256], toName[256], str[256];
	LONGINT beg = 0, end = 0;
	In_Open();
	In_String((void*)fromName, 256);
	In_String((void*)toName, 256);
	In_String((void*)str, 256);
	if (!In_Done) {
		Out_String((CHAR*)"-- ListElems.MoveLine fromName toName line", (LONGINT)43);
		Out_Ln();
		return;
	}
	if (str[0] == 0x00) {
		return;
	}
	if (fromName[0] != 0x00) {
		e = Elems_NamedElem(fromName, 256, Elems_CmdContext);
		if (e == NIL) {
			Out_String((CHAR*)"-- elem not found: ", (LONGINT)20);
			Out_String(fromName, 256);
			Out_Ln();
		} else {
			if (__ISP(e, ListElems_ElemDesc, 3)) {
				ListElems_Find((*(ListElems_Elem*)&e)->txt, str, 256, &beg, &end);
				if (beg >= 0) {
					Texts_Delete((*(ListElems_Elem*)&e)->txt, beg, end);
				}
			} else __WITHCHK;
		}
	}
	if (toName[0] != 0x00) {
		e = Elems_NamedElem(toName, 256, Elems_CmdContext);
		if (e == NIL) {
			Out_String((CHAR*)"-- elem not found: ", (LONGINT)20);
			Out_String(toName, 256);
			Out_Ln();
		} else {
			if (__ISP(e, ListElems_ElemDesc, 3)) {
				Texts_WriteString(&ListElems_W, Texts_Writer__typ, str, 256);
				Texts_WriteLn(&ListElems_W, Texts_Writer__typ);
				Texts_Append((*(ListElems_Elem*)&e)->txt, ListElems_W.buf);
			} else __WITHCHK;
		}
	}
}

static void ListElems_InitMod (void)
{
	SET arr[10];
	arr[9] = 0x0;
	arr[8] = 0x0;
	arr[7] = 0x0;
	arr[6] = 0x0;
	arr[5] = 0x01ff;
	arr[4] = 0xfe;
	arr[3] = 0x7c;
	arr[2] = 0x38;
	arr[1] = 0x10;
	ListElems_arrow = Display_NewPattern((void*)arr, 10, 9, 5);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&ListElems_W, Texts_Writer__typ, 36, 1, P);
	P(ListElems_curElem);
}

__TDESC(ListElems_FrameDesc, 1, 3) = {__TDFLDS("FrameDesc", 24), {0, 4, 20, -16}};
__TDESC(ListElems_EditFrameDesc, 1, 9) = {__TDFLDS("EditFrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};
__TDESC(ListElems_ElemDesc, 1, 7) = {__TDFLDS("ElemDesc", 68), {0, 4, 12, 32, 36, 44, 48, -32}};

export void *ListElems__init(void)
{
	__DEFMOD;
	__IMPORT(Bitmaps);
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(ListElems, EnumPtrs);
	__REGCMD("Insert", ListElems_Insert);
	__REGCMD("MoveLine", ListElems_MoveLine);
	__REGCMD("New", ListElems_New);
	__REGCMD("Update", ListElems_Update);
	__INITYP(ListElems_FrameDesc, Display_FrameDesc, 1);
	__INITYP(ListElems_EditFrameDesc, TextFrames_FrameDesc, 2);
	__INITYP(ListElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	Texts_OpenWriter(&ListElems_W, Texts_Writer__typ);
	ListElems_InitMod();
	__ENDMOD;
}
