/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct MarkElems_ElemDesc *MarkElems_Elem;

typedef
	struct MarkElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT key;
		Texts_Elem back;
	} MarkElems_ElemDesc;

typedef
	struct MarkElems_FrameDesc *MarkElems_Frame;

typedef
	struct MarkElems_FrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		MarkElems_Elem e;
	} MarkElems_FrameDesc;


static LONGINT MarkElems_icon, MarkElems_invIcon;
static Texts_Writer MarkElems_w;

export LONGINT *MarkElems_ElemDesc__typ;
export LONGINT *MarkElems_FrameDesc__typ;

export void MarkElems_Alloc (void);
static void MarkElems_GetDsr (Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER *dsr);
static void MarkElems_GoBack (Texts_Elem e);
export void MarkElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
static void MarkElems_InitIcon (void);
export void MarkElems_Insert (void);
export void MarkElems_MarkProcs (void);
export MarkElems_Elem MarkElems_New (void);
static void MarkElems_ShowKey (MarkElems_Elem e);
export void MarkElems_ShowNext (void);
static void MarkElems_ShowPos (TextFrames_Frame f, LONGINT pos);
export void MarkElems_Update (void);


static void MarkElems_ShowKey (MarkElems_Elem e)
{
	Texts_Text t = NIL;
	MenuViewers_Viewer v = NIL;
	MarkElems_Frame f = NIL;
	INTEGER x = 0, y = 0;
	t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteInt(&MarkElems_w, Texts_Writer__typ, e->key, 0);
	Texts_Append(t, MarkElems_w.buf);
	__NEW(f, MarkElems_FrameDesc);
	f->e = e;
	TextFrames_Open((void*)f, t, 0);
	Oberon_AllocateSystemViewer(0, &x, &y);
	v = MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"MarkElem", (LONGINT)9, (CHAR*)"System.Close  MarkElems.Update ", (LONGINT)32), (void*)f, TextFrames_menuH, x, y);
}

static void MarkElems_ShowPos (TextFrames_Frame f, LONGINT pos)
{
	LONGINT beg = 0, end = 0, delta = 0;
	delta = 200;
	for (;;) {
		beg = f->org;
		end = TextFrames_Pos(f, f->X + f->W, f->Y);
		if (beg <= pos && pos < end || delta == 0) {
			break;
		}
		TextFrames_Show(f, pos - delta);
		delta = __ASHR(delta, 1);
	}
}

static void MarkElems_GoBack (Texts_Elem e)
{
	Viewers_Viewer v = NIL;
	INTEGER x = 0;
	Texts_Reader r = {0};
	TextFrames_Frame f = NIL;
	LONGINT pos = 0;
	if (e != NIL) {
		x = 0;
		while (x < Display_Width) {
			v = Viewers_This(x, 0);
			while (v->state > 1) {
				if (__ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
					f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
					Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
					for (;;) {
						Texts_ReadElem(&r, Texts_Reader__typ);
						if (r.eot) {
							break;
						}
						if (r.elem == e) {
							pos = Texts_Pos(&r, Texts_Reader__typ);
							MarkElems_ShowPos(f, pos);
							TextFrames_SetSelection(f, pos - 1, pos);
							break;
						}
					}
				}
				v = Viewers_Next(v);
			}
			x = x + v->W;
		}
	}
}

static void MarkElems_GetDsr (Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER *dsr)
{
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	if (f == NIL) {
		if (fnt == NIL) {
			*dsr = 0;
		} else {
			*dsr = -fnt->minY;
		}
	} else {
		TextFrames_ParcBefore(__GUARDP(f, TextFrames_FrameDesc, 1)->text, pos, &p, &beg);
		*dsr = (int)__DIV(p->dsr, (LONGINT)TextFrames_Unit);
	}
}

void MarkElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	MarkElems_Elem e1 = NIL;
	INTEGER x = 0, y = 0, dsr = 0;
	SET keys = 0;
	if (__ISP(e, MarkElems_ElemDesc, 2)) {
		if (__IS(m__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *m__ = (void*)m;
			if ((*m__).id == 0) {
				Files_ReadLInt(&(*m__).r, Files_Rider__typ, &(*(MarkElems_Elem*)&e)->key);
			} else {
				Files_WriteLInt(&(*m__).r, Files_Rider__typ, (*(MarkElems_Elem*)&e)->key);
			}
		} else if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, MarkElems_ElemDesc);
				(*m__).e = (Texts_Elem)e1;
			} else {
				e1 = __GUARDP((*m__).e, MarkElems_ElemDesc, 2);
			}
			e1->key = (*(MarkElems_Elem*)&e)->key;
			e1->back = (*(MarkElems_Elem*)&e)->back;
			Texts_CopyElem((void*)(*(MarkElems_Elem*)&e), (void*)e1);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("MarkElems", (*m__).mod, 10);
			__MOVE("Alloc", (*m__).proc, 6);
		} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			(*(MarkElems_Elem*)&e)->W = 120000;
			if (!(*m__).prepare) {
				MarkElems_GetDsr((*m__).frame, (*m__).pos, (*m__).fnt, &dsr);
				Display_CopyPattern(15, MarkElems_icon, (*m__).X0, (*m__).Y0 + dsr, 1);
			}
		} else if (__IS(m__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *m__ = (void*)m;
			(*(MarkElems_Elem*)&e)->W = 1;
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if (__IN(1, (*m__).keys)) {
				MarkElems_GetDsr((*m__).frame, (*m__).pos, (*m__).fnt, &dsr);
				Display_CopyPattern(15, MarkElems_icon, (*m__).X0, (*m__).Y0 + dsr, 2);
				Display_CopyPattern(15, MarkElems_invIcon, (*m__).X0, (*m__).Y0 + dsr, 2);
				do {
					Input_Mouse(&keys, &x, &y);
					(*m__).keys = (*m__).keys | keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
				} while (!(keys == 0x0));
				Display_CopyPattern(15, MarkElems_invIcon, (*m__).X0, (*m__).Y0 + dsr, 2);
				Display_CopyPattern(15, MarkElems_icon, (*m__).X0, (*m__).Y0 + dsr, 2);
				if ((*m__).keys == 0x02) {
					MarkElems_GoBack((*(MarkElems_Elem*)&e)->back);
				} else if ((*m__).keys == 0x03) {
					MarkElems_ShowKey((*(MarkElems_Elem*)&e));
				}
			}
		}
	} else __WITHCHK;
}

MarkElems_Elem MarkElems_New (void)
{
	MarkElems_Elem e = NIL;
	__NEW(e, MarkElems_ElemDesc);
	e->W = 120000;
	e->H = 110000;
	e->handle = MarkElems_Handle;
	e->key = Oberon_Time();
	return e;
}

void MarkElems_MarkProcs (void)
{
	Viewers_Viewer v = NIL;
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	LONGINT pos = 0;
	CHAR ch = 0;
	LONGINT key = 0;
	MarkElems_Elem mark = NIL;
	v = Oberon_MarkedViewer();
	if (__ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		t = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1)->text;
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		key = Oberon_Time();
		while (!s.eot) {
			if (s.class == 1 && __STRCMP(s.s, "PROCEDURE") == 0) {
				pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
				Texts_Scan(&s, Texts_Scanner__typ);
				if (s.class == 6) {
					if ((s.c == '^' || s.c == '*') || s.c == '-') {
						pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
						Texts_Scan(&s, Texts_Scanner__typ);
					} else if (s.c == '(') {
						do {
							Texts_Scan(&s, Texts_Scanner__typ);
						} while (!(s.class == 6 && s.c == ')' || s.eot));
						pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
						Texts_Scan(&s, Texts_Scanner__typ);
					}
				}
				if (s.class == 1) {
					Texts_OpenReader((void*)&s, Texts_Scanner__typ, t, pos);
					Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
					if (s.elem == NIL || !__ISP(s.elem, MarkElems_ElemDesc, 2)) {
						mark = MarkElems_New();
						mark->key = key;
						key += 1;
						Texts_WriteElem(&MarkElems_w, Texts_Writer__typ, (void*)mark);
						Texts_Insert(t, pos, MarkElems_w.buf);
					}
					Texts_OpenScanner(&s, Texts_Scanner__typ, t, pos + 1);
				}
			}
			Texts_Scan(&s, Texts_Scanner__typ);
		}
	}
}

void MarkElems_ShowNext (void)
{
	Display_Frame f = NIL;
	TextFrames_Frame tf = NIL;
	LONGINT pos = 0;
	Texts_Reader r = {0};
	if (Oberon_FocusViewer != NIL) {
		f = Oberon_FocusViewer->dsc->next;
		if (f != NIL && __ISP(f, TextFrames_FrameDesc, 1)) {
			tf = __GUARDP(f, TextFrames_FrameDesc, 1);
			if (tf->hasCar) {
				pos = tf->carloc.pos;
			} else {
				pos = 0;
			}
			Texts_OpenReader(&r, Texts_Reader__typ, tf->text, pos);
			Texts_ReadElem(&r, Texts_Reader__typ);
			while (!r.eot && !__ISP(r.elem, MarkElems_ElemDesc, 2)) {
				Texts_ReadElem(&r, Texts_Reader__typ);
			}
			if (r.eot) {
				TextFrames_RemoveCaret(tf);
			} else {
				pos = Texts_Pos(&r, Texts_Reader__typ);
				MarkElems_ShowPos(tf, pos);
				TextFrames_SetCaret(tf, pos);
			}
		}
	}
}

void MarkElems_Alloc (void)
{
	MarkElems_Elem e = NIL;
	__NEW(e, MarkElems_ElemDesc);
	e->handle = MarkElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void MarkElems_Update (void)
{
	MarkElems_Frame f = NIL;
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	Texts_Reader r = {0};
	CHAR ch = 0;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc && __ISP(Oberon_Par->frame->next, MarkElems_FrameDesc, 2)) {
		f = __GUARDP(Oberon_Par->frame->next, MarkElems_FrameDesc, 2);
		Texts_OpenScanner(&s, Texts_Scanner__typ, f->text, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 3) {
			f->e->key = s.i;
			t = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
			Texts_OpenReader(&r, Texts_Reader__typ, t, t->len - 1);
			Texts_Read(&r, Texts_Reader__typ, &ch);
			if (ch == '!') {
				Texts_Delete(t, t->len - 1, t->len);
			}
		}
	}
}

void MarkElems_Insert (void)
{
	TextFrames_InsertElemMsg m = {0};
	m.e = (Texts_Elem)MarkElems_New();
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

static void MarkElems_InitIcon (void)
{
	SET line[9];
	line[1] = 0xf0;
	line[2] = 0x0108;
	line[3] = 0x0204;
	line[4] = 0x0264;
	line[5] = 0x0264;
	line[6] = 0x0204;
	line[7] = 0x0108;
	line[8] = 0xf0;
	MarkElems_icon = Display_NewPattern((void*)line, 9, 12, 8);
	line[1] = 0x0;
	line[2] = 0xf0;
	line[3] = 0x01f8;
	line[4] = 0x0198;
	line[5] = 0x0198;
	line[6] = 0x01f8;
	line[7] = 0xf0;
	line[8] = 0x0;
	MarkElems_invIcon = Display_NewPattern((void*)line, 9, 12, 8);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&MarkElems_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(MarkElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 44), {0, 4, 12, 32, 40, -24}};
__TDESC(MarkElems_FrameDesc, 1, 9) = {__TDFLDS("FrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};

export void *MarkElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(MarkElems, EnumPtrs);
	__REGCMD("Alloc", MarkElems_Alloc);
	__REGCMD("Insert", MarkElems_Insert);
	__REGCMD("MarkProcs", MarkElems_MarkProcs);
	__REGCMD("ShowNext", MarkElems_ShowNext);
	__REGCMD("Update", MarkElems_Update);
	__INITYP(MarkElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(MarkElems_FrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&MarkElems_w, Texts_Writer__typ);
	MarkElems_InitIcon();
	__ENDMOD;
}
