/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Args.h"
#include "Console.h"
#include "Kernel.h"
#include "Unix.h"

typedef
	struct Modules_CmdDesc *Modules_Cmd;

typedef
	void (*Modules_Command)(void);

typedef
	struct Modules_CmdDesc {
		Modules_Cmd next;
		CHAR name[24];
		Modules_Command cmd;
	} Modules_CmdDesc;

typedef
	struct Modules_Dlinfo {
		LONGINT fname, fbase, sname, saddr;
	} Modules_Dlinfo;

typedef
	struct Modules_ModuleDesc *Modules_Module;

typedef
	Modules_Module (*Modules_ModuleBody)(void);

typedef
	CHAR Modules_ModuleName[20];

typedef
	struct Modules_ModuleDesc {
		Modules_Module next;
		Modules_ModuleName name;
		LONGINT refcnt;
		Modules_Cmd cmds;
		LONGINT types;
		void (*enumPtrs)(void(*)(LONGINT));
		LONGINT reserved1, reserved2;
	} Modules_ModuleDesc;


export INTEGER Modules_res;
export CHAR Modules_resMsg[256];
export Modules_ModuleName Modules_imported, Modules_importing;
export CHAR Modules_libPrefix[20];
static BOOLEAN Modules_trace;

export LONGINT *Modules_ModuleDesc__typ;
export LONGINT *Modules_CmdDesc__typ;
export LONGINT *Modules_Dlinfo__typ;

static void Modules_Append (CHAR *a, LONGINT a__len, CHAR *b, LONGINT b__len);
static void Modules_CloseLib (LONGINT libHandle);
export void Modules_Free (CHAR *name, LONGINT name__len, BOOLEAN all);
static BOOLEAN Modules_FullName (CHAR *n, LONGINT n__len);
static void Modules_GetSubsys1 (CHAR *n, LONGINT n__len, CHAR *s, LONGINT s__len);
static void Modules_GetSubsys2 (CHAR *n, LONGINT n__len, CHAR *s, LONGINT s__len);
static BOOLEAN Modules_IsSingletonLib (LONGINT libHandle);
static void Modules_Load (CHAR *name, LONGINT name__len, CHAR *bodyname, LONGINT bodyname__len, LONGINT *lib, Modules_ModuleBody *body);
static LONGINT Modules_RefLibHandle (LONGINT body);
export Modules_Command Modules_ThisCommand (Modules_Module mod, CHAR *name, LONGINT name__len);
export Modules_Module Modules_ThisMod (CHAR *name, LONGINT name__len);
export void Modules_TraceOff (void);
export void Modules_TraceOn (void);
static void Modules_err (void);

#define __USE_GNU 1
#define Modules_dladdr(addr, info, info__typ)	(LONGINT)dladdr((void*)addr, (Dl_info*)info)
#define Modules_dlclose(handle)	dlclose((void*)handle)
#define Modules_dlerror(s, s__len)	__COPY(dlerror(), s, s__len)
#define Modules_dlopen(path, path__len)	(long)dlopen((const char*)path, RTLD_NOW + RTLD_GLOBAL)
#define Modules_dlopenRef(pathAdr)	(long)dlopen((const char*)pathAdr, RTLD_NOW + RTLD_GLOBAL)
#define Modules_dlsym(handle, name, name__len)	(Modules_ModuleBody)dlsym((void*)handle, name)
#define Modules_dlsymDefault(name, name__len)	(Modules_ModuleBody)dlsym(RTLD_DEFAULT, name)
extern LONGINT (*SYSTEM_refLibHandle)(LONGINT);
extern void free(void*);
#define Modules_free(ptr)	free((void*)ptr)
#include <dlfcn.h>
#define Modules_installRefLibHandle()	SYSTEM_refLibHandle = &Modules_RefLibHandle
#define Modules_modules()	(Modules_Module)SYSTEM_modules
#define Modules_setmodules(m)	SYSTEM_modules = m

static void Modules_Append (CHAR *a, LONGINT a__len, CHAR *b, LONGINT b__len)
{
	INTEGER i = 0, j = 0;
	__DUP(b, b__len, CHAR);
	i = 0;
	while (a[__X(i, a__len)] != 0x00) {
		i += 1;
	}
	j = 0;
	while (b[__X(j, b__len)] != 0x00) {
		a[__X(i, a__len)] = b[__X(j, b__len)];
		i += 1;
		j += 1;
	}
	a[__X(i, a__len)] = 0x00;
	__DEL(b);
}

static void Modules_GetSubsys1 (CHAR *n, LONGINT n__len, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(n, n__len, CHAR);
	ch = n[0];
	i = 0;
	while (ch != 0x00 && (ch < 'a' || ch > 'z')) {
		s[__X(i, s__len)] = ch;
		i += 1;
		ch = n[__X(i, n__len)];
	}
	while (ch >= 'a' && ch <= 'z') {
		s[__X(i, s__len)] = ch;
		i += 1;
		ch = n[__X(i, n__len)];
	}
	if (ch == 0x00) {
		s[0] = 0x00;
	} else {
		s[__X(i, s__len)] = 0x00;
	}
	__DEL(n);
}

static void Modules_GetSubsys2 (CHAR *n, LONGINT n__len, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(n, n__len, CHAR);
	ch = n[0];
	i = 0;
	while (ch >= 'A' && ch <= 'Z') {
		s[__X(i, s__len)] = ch;
		i += 1;
		ch = n[__X(i, n__len)];
	}
	while (ch != 0x00 && (ch < 'A' || ch > 'Z')) {
		s[__X(i, s__len)] = ch;
		i += 1;
		ch = n[__X(i, n__len)];
	}
	if (ch == 0x00) {
		s[0] = 0x00;
	} else {
		s[__X(i, s__len)] = 0x00;
	}
	__DEL(n);
}

static BOOLEAN Modules_FullName (CHAR *n, LONGINT n__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	i = 0;
	ch = n[0];
	while (ch != 0x00) {
		if (ch == '.') {
			return 1;
		}
		i += 1;
		ch = n[__X(i, n__len)];
	}
	return 0;
}

static void Modules_err (void)
{
	CHAR s[1024];
	Modules_dlerror((void*)s, 1024);
	if (Modules_trace) {
		Console_String((CHAR*)"  dlerror: ", (LONGINT)12);
		Console_String(s, 1024);
		Console_Ln();
	}
}

static void Modules_Load (CHAR *name, LONGINT name__len, CHAR *bodyname, LONGINT bodyname__len, LONGINT *lib, Modules_ModuleBody *body)
{
	CHAR libname[256];
	LONGINT rc = 0;
	__DUP(name, name__len, CHAR);
	__DUP(bodyname, bodyname__len, CHAR);
	__MOVE("lib", libname, 4);
	Modules_Append((void*)libname, 256, Modules_libPrefix, 20);
	Modules_Append((void*)libname, 256, name, name__len);
	Modules_Append((void*)libname, 256, (CHAR*)".so", (LONGINT)4);
	if (Modules_trace) {
		Console_String((CHAR*)"  Modules.Load(libname=", (LONGINT)24);
		Console_String(libname, 256);
		Console_String((CHAR*)", entry=", (LONGINT)9);
		Console_String(bodyname, bodyname__len);
		Console_String((CHAR*)")", (LONGINT)2);
		Console_Ln();
	}
	*lib = Modules_dlopen(libname, 256);
	if (*lib != 0) {
		*body = Modules_dlsym(*lib, bodyname, bodyname__len);
		if (*body == NIL) {
			Modules_err();
			rc = Modules_dlclose(*lib);
		}
	} else {
		Modules_err();
	}
	__DEL(name);
	__DEL(bodyname);
}

static void Modules_CloseLib (LONGINT libHandle)
{
	libHandle = Modules_dlclose(libHandle);
}

Modules_Module Modules_ThisMod (CHAR *name, LONGINT name__len)
{
	Modules_Module m = NIL;
	CHAR bodyname[128], libname1[128], libname2[128];
	Modules_ModuleBody body = NIL;
	LONGINT lib = 0, rc = 0;
	__DUP(name, name__len, CHAR);
	m = Modules_modules();
	while (m != NIL && __STRCMP(m->name, name) != 0) {
		m = m->next;
	}
	if (m == NIL) {
		if (Modules_trace) {
			Console_String((CHAR*)"Modules.ThisMod(name=", (LONGINT)22);
			Console_String(name, name__len);
			Console_String((CHAR*)")", (LONGINT)2);
			Console_Ln();
		}
		body = NIL;
		__COPY(name, bodyname, 128);
		Modules_Append((void*)bodyname, 128, (CHAR*)"__init", (LONGINT)7);
		body = Modules_dlsymDefault(bodyname, 128);
		if (body != NIL) {
			m = (*body)();
		} else {
			Modules_Load(name, name__len, bodyname, 128, &lib, &body);
			if (body != NIL) {
				Kernel_PushTrapCleaner(Modules_CloseLib, lib);
				m = (*body)();
				Kernel_PopTrapCleaner();
				Modules_CloseLib(lib);
			}
		}
	}
	if (m != NIL) {
		Modules_res = 0;
		Modules_resMsg[0] = 0x00;
	} else {
		Modules_res = 1;
		__COPY(name, Modules_importing, 20);
		__MOVE(" module \"", Modules_resMsg, 10);
		Modules_Append((void*)Modules_resMsg, 256, name, name__len);
		Modules_Append((void*)Modules_resMsg, 256, (CHAR*)"\" not found or library not loadable", (LONGINT)36);
	}
	__DEL(name);
	return m;
}

Modules_Command Modules_ThisCommand (Modules_Module mod, CHAR *name, LONGINT name__len)
{
	Modules_Cmd c = NIL;
	__DUP(name, name__len, CHAR);
	c = mod->cmds;
	while (c != NIL && __STRCMP(c->name, name) != 0) {
		c = c->next;
	}
	if (c != NIL) {
		Modules_res = 0;
		Modules_resMsg[0] = 0x00;
		__DEL(name);
		return c->cmd;
	} else {
		Modules_res = 2;
		__MOVE(" command \"", Modules_resMsg, 11);
		__COPY(name, Modules_importing, 20);
		Modules_Append((void*)Modules_resMsg, 256, mod->name, 20);
		Modules_Append((void*)Modules_resMsg, 256, (CHAR*)".", (LONGINT)2);
		Modules_Append((void*)Modules_resMsg, 256, name, name__len);
		Modules_Append((void*)Modules_resMsg, 256, (CHAR*)"\" not found", (LONGINT)12);
		__DEL(name);
		return NIL;
	}
	__RETCHK;
}

static BOOLEAN Modules_IsSingletonLib (LONGINT libHandle)
{
	Modules_Module m = NIL;
	INTEGER cnt = 0;
	m = Modules_modules();
	cnt = 0;
	while (m != NIL && cnt < 2) {
		if (m->reserved1 == libHandle) {
			cnt += 1;
		}
		m = m->next;
	}
	return cnt < 2;
}

void Modules_Free (CHAR *name, LONGINT name__len, BOOLEAN all)
{
	Modules_Module m = NIL, p = NIL, im = NIL;
	LONGINT imps = 0, ptr = 0;
	__DUP(name, name__len, CHAR);
	m = Modules_modules();
	while (m != NIL && __STRCMP(m->name, name) != 0) {
		p = m;
		m = m->next;
	}
	if (m != NIL && m->refcnt == 0) {
		if (m->reserved1 != 0 && Modules_IsSingletonLib(m->reserved1)) {
			if (Modules_dlclose(m->reserved1) != 0) {
				Modules_res = 1;
				Modules_dlerror((void*)Modules_resMsg, 256);
			} else {
				if (m == Modules_modules()) {
					Modules_setmodules(m->next);
				} else {
					p->next = m->next;
				}
				imps = m->reserved2;
				while (imps != 0) {
					__GET(imps + 4, im, Modules_Module);
					im->refcnt -= 1;
					if ((all && im->refcnt == 0) && im->reserved1 != 0) {
						Modules_Free(im->name, 20, all);
					}
					ptr = imps;
					__GET(imps, imps, LONGINT);
					Modules_free(ptr);
				}
				Modules_res = 0;
				m->reserved1 = 0;
				m->reserved2 = 0;
			}
		} else {
			Modules_res = 1;
			__MOVE("module not loaded in separate library", Modules_resMsg, 38);
		}
	} else {
		Modules_res = 1;
		if (m == NIL) {
			__MOVE("module not found", Modules_resMsg, 17);
		} else {
			__MOVE("clients of this module exist", Modules_resMsg, 29);
		}
	}
	__DEL(name);
}

static LONGINT Modules_RefLibHandle (LONGINT body)
{
	Modules_Dlinfo info = {0};
	LONGINT res = 0, libHandle = 0;
	res = Modules_dladdr(body, &info, Modules_Dlinfo__typ);
	if (res != 0 && info.sname != 0) {
		libHandle = Modules_dlopenRef(info.fname);
		if (libHandle != 0) {
			return libHandle;
		}
	}
	return 0;
}

void Modules_TraceOn (void)
{
	Modules_trace = 1;
	Console_String((CHAR*)"Modules.TraceOn", (LONGINT)16);
	Console_Ln();
}

void Modules_TraceOff (void)
{
	Modules_trace = 0;
	Console_String((CHAR*)"Modules.TraceOff", (LONGINT)17);
	Console_Ln();
}

__TDESC(Modules_ModuleDesc, 1, 2) = {__TDFLDS("ModuleDesc", 48), {0, 28, -12}};
__TDESC(Modules_CmdDesc, 1, 1) = {__TDFLDS("CmdDesc", 32), {0, -8}};
__TDESC(Modules_Dlinfo, 1, 0) = {__TDFLDS("Dlinfo", 16), {-4}};

export void *Modules__init(void)
{
	__DEFMOD;
	__IMPORT(Args);
	__IMPORT(Console);
	__IMPORT(Kernel);
	__IMPORT(Unix);
	__REGMOD(Modules, 0);
	__REGCMD("TraceOff", Modules_TraceOff);
	__REGCMD("TraceOn", Modules_TraceOn);
	__INITYP(Modules_ModuleDesc, Modules_ModuleDesc, 0);
	__INITYP(Modules_CmdDesc, Modules_CmdDesc, 0);
	__INITYP(Modules_Dlinfo, Modules_Dlinfo, 0);
/* BEGIN */
	__MOVE("_V4_", Modules_libPrefix, 5);
	Args_GetEnv((CHAR*)"OBERON_LIBPREFIX", (LONGINT)17, (void*)Modules_libPrefix, 20);
	Modules_installRefLibHandle();
	__ENDMOD;
}
