/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "MathL.h"




export LONGREAL MoreMathL_arccos (LONGREAL x);
export LONGREAL MoreMathL_arccot (LONGREAL x);
export LONGREAL MoreMathL_arcosh (LONGREAL x);
export LONGREAL MoreMathL_arcoth (LONGREAL x);
export LONGREAL MoreMathL_arcsin (LONGREAL x);
export LONGREAL MoreMathL_arcsinh (LONGREAL x);
export LONGREAL MoreMathL_arctanh (LONGREAL x);
export LONGREAL MoreMathL_cosh (LONGREAL x);
export LONGREAL MoreMathL_cot (LONGREAL x);
export LONGREAL MoreMathL_coth (LONGREAL x);
export LONGREAL MoreMathL_sinh (LONGREAL x);
export LONGREAL MoreMathL_tan (LONGREAL x);
export LONGREAL MoreMathL_tanh (LONGREAL x);


LONGREAL MoreMathL_tan (LONGREAL x)
{
	BOOLEAN neg = 0;
	LONGREAL y = 0, s1 = 0;
	y = x - (__ENTIER(x /   3.14159265358979e+000)) *   3.14159265358979e+000;
	if (y >   1.57079632679490e+000) {
		neg = 1;
	} else {
		neg = 0;
	}
	s1 = MathL_sin(y);
	if (neg) {
		return -(s1 / MathL_sqrt((LONGREAL)1 - s1 * s1));
	} else {
		return s1 / MathL_sqrt((LONGREAL)1 - s1 * s1);
	}
	__RETCHK;
}

LONGREAL MoreMathL_cot (LONGREAL x)
{
	return (LONGREAL)1 / MoreMathL_tan(x);
}

LONGREAL MoreMathL_arcsin (LONGREAL x)
{
	return MathL_arctan(x / MathL_sqrt((LONGREAL)1 - x * x));
}

LONGREAL MoreMathL_arccot (LONGREAL x)
{
	return   1.57079632679490e+000 - MathL_arctan(x);
}

LONGREAL MoreMathL_arccos (LONGREAL x)
{
	return   1.57079632679490e+000 - MoreMathL_arcsin(x);
}

LONGREAL MoreMathL_tanh (LONGREAL x)
{
	LONGREAL e1 = 0, e2 = 0, e3 = 0, e4 = 0, e5 = 0, e6 = 0, t1 = 0, t2 = 0;
	if (__ABS(x) <   3.70000000000000e-009) {
		return x;
	} else if (x >=   2.01009998321533e+001) {
		return (LONGREAL)1;
	} else if (x <=  -5.49310000000000e-001) {
		return -MoreMathL_tanh(-x);
	} else if (x >=   5.49310028553009e-001) {
		return (LONGREAL)1 - (LONGREAL)2 / (LONGREAL)(MathL_exp((LONGREAL)2 * x) + (LONGREAL)1);
	} else {
		e1 =  -2.50000000000000e-001 + x;
		e2 = e1 * ( -2.50000000000000e-001 + x);
		e3 = e2 * ( -2.50000000000000e-001 + x);
		e4 = e3 * ( -2.50000000000000e-001 + x);
		e5 = e4 * ( -2.50000000000000e-001 + x);
		e6 = e5 * ( -2.50000000000000e-001 + x);
		t1 = (((((  2.35611987591255e-005 * e6 +   2.02314811758697e-003 * e5) +   4.95868502184749e-003 * e4) +   1.21521875262260e-001 * e3) +   1.11630171537399e-001 * e2) +   1.00278842449188e+000 * e1) +   2.45601594448090e-001;
		t2 = (((((  9.62000995059498e-005 * e6 +   4.95506741572171e-004 * e5) +   2.02462524175644e-002 * e4) +   2.97629758715630e-002 * e3) +   4.55784678459168e-001 * e2) +   2.45601594448090e-001 * e1) +   1.00278842449188e+000;
		return t1 / t2;
	}
	__RETCHK;
}

LONGREAL MoreMathL_sinh (LONGREAL x)
{
	LONGREAL t1 = 0;
	t1 = MoreMathL_tanh(x);
	return t1 / MathL_sqrt((LONGREAL)1 - t1 * t1);
}

LONGREAL MoreMathL_cosh (LONGREAL x)
{
	LONGREAL t1 = 0;
	t1 = MoreMathL_tanh(x);
	return (LONGREAL)1 / MathL_sqrt((LONGREAL)1 - t1 * t1);
}

LONGREAL MoreMathL_coth (LONGREAL x)
{
	LONGREAL e1 = 0, e2 = 0;
	e1 = MathL_exp(x);
	e2 = (LONGREAL)1 / e1;
	return (e1 + e2) / (LONGREAL)(e1 - e2);
}

LONGREAL MoreMathL_arctanh (LONGREAL x)
{
	return   5.00000000000000e-001 * MathL_ln(((LONGREAL)1 + x) / (LONGREAL)((LONGREAL)1 - x));
}

LONGREAL MoreMathL_arcsinh (LONGREAL x)
{
	return MoreMathL_arctanh(x / MathL_sqrt((LONGREAL)1 + x * x));
}

LONGREAL MoreMathL_arcosh (LONGREAL x)
{
	return MoreMathL_arctanh(MathL_sqrt(x * x - (LONGREAL)1) / x);
}

LONGREAL MoreMathL_arcoth (LONGREAL x)
{
	return MoreMathL_arctanh((LONGREAL)1 / x);
}


export void *MoreMathL__init(void)
{
	__DEFMOD;
	__IMPORT(MathL);
	__REGMOD(MoreMathL, 0);
/* BEGIN */
	__ENDMOD;
}
