/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Fonts.h"
#include "Input.h"
#include "Kernel.h"
#include "Modules.h"
#include "Texts.h"
#include "Unix.h"
#include "Viewers.h"
#include "X11.h"

typedef
	struct Oberon_ControlMsg { /* Display_FrameMsg */
		INTEGER id, X, Y;
	} Oberon_ControlMsg;

typedef
	struct Oberon_CopyMsg { /* Display_FrameMsg */
		Display_Frame F;
	} Oberon_CopyMsg;

typedef
	struct Oberon_CopyOverMsg { /* Display_FrameMsg */
		Texts_Text text;
		LONGINT beg, end;
	} Oberon_CopyOverMsg;

typedef
	void (*Oberon_Painter)(INTEGER, INTEGER);

typedef
	struct Oberon_Marker {
		Oberon_Painter Fade, Draw;
	} Oberon_Marker;

typedef
	struct Oberon_Cursor {
		Oberon_Marker marker;
		BOOLEAN on;
		INTEGER X, Y;
	} Oberon_Cursor;

typedef
	void (*Oberon_Handler)(void);

typedef
	struct Oberon_InputMsg { /* Display_FrameMsg */
		INTEGER id;
		SET keys;
		INTEGER X, Y;
		CHAR ch;
		Fonts_Font fnt;
		SHORTINT col, voff;
	} Oberon_InputMsg;

typedef
	struct Oberon_ParRec *Oberon_ParList;

typedef
	struct Oberon_ParRec {
		Viewers_Viewer vwr;
		Display_Frame frame;
		Texts_Text text;
		LONGINT pos;
	} Oberon_ParRec;

typedef
	struct Oberon_SelectionMsg { /* Display_FrameMsg */
		LONGINT time;
		Texts_Text text;
		LONGINT beg, end;
	} Oberon_SelectionMsg;

typedef
	struct Oberon_TaskDesc *Oberon_Task;

typedef
	struct Oberon_TaskDesc {
		Oberon_Task next;
		BOOLEAN safe;
		LONGINT time;
		Oberon_Handler handle;
	} Oberon_TaskDesc;


export CHAR Oberon_User[12];
export Oberon_Marker Oberon_Arrow, Oberon_Star;
export Oberon_Cursor Oberon_Mouse, Oberon_Pointer;
export Viewers_Viewer Oberon_FocusViewer;
export Texts_Text Oberon_Log;
export Oberon_ParList Oberon_Par;
export Oberon_Task Oberon_CurTask;
static Oberon_Task Oberon_PrevTask;
export Fonts_Font Oberon_CurFnt;
export SHORTINT Oberon_CurCol, Oberon_CurOff;
export LONGINT Oberon_Password;
export BOOLEAN Oberon_LoopStarted;
static INTEGER Oberon_DW, Oberon_DH, Oberon_CL, Oberon_H0, Oberon_H1, Oberon_H2, Oberon_H3, Oberon_unitW, Oberon_ActCnt;
static Modules_Module Oberon_Mod;
static Oberon_Painter Oberon_ArrowFade;

export LONGINT *Oberon_Marker__typ;
export LONGINT *Oberon_Cursor__typ;
export LONGINT *Oberon_ParRec__typ;
export LONGINT *Oberon_InputMsg__typ;
export LONGINT *Oberon_SelectionMsg__typ;
export LONGINT *Oberon_ControlMsg__typ;
export LONGINT *Oberon_CopyOverMsg__typ;
export LONGINT *Oberon_CopyMsg__typ;
export LONGINT *Oberon_TaskDesc__typ;

export void Oberon_AllocateSystemViewer (INTEGER DX, INTEGER *X, INTEGER *Y);
export void Oberon_AllocateUserViewer (INTEGER DX, INTEGER *X, INTEGER *Y);
export void Oberon_Call (CHAR *name, LONGINT name__len, Oberon_ParList par, BOOLEAN new, INTEGER *res);
static LONGINT Oberon_Code (CHAR *s, LONGINT s__len);
export void Oberon_Collect (INTEGER count);
export INTEGER Oberon_DisplayHeight (INTEGER X);
export INTEGER Oberon_DisplayWidth (INTEGER X);
export void Oberon_DrawCursor (Oberon_Cursor *c, LONGINT *c__typ, Oberon_Marker *m, LONGINT *m__typ, INTEGER X, INTEGER Y);
export void Oberon_ExecShell (CHAR *cmd, LONGINT cmd__len, LONGINT *status, Texts_Buffer *out);
export void Oberon_FadeCursor (Oberon_Cursor *c, LONGINT *c__typ);
static void Oberon_FlipArrow (INTEGER X, INTEGER Y);
static void Oberon_FlipStar (INTEGER X, INTEGER Y);
static void Oberon_GC (void);
export void Oberon_GetClock (LONGINT *t, LONGINT *d);
export void Oberon_GetSelection (Texts_Text *text, LONGINT *beg, LONGINT *end, LONGINT *time);
static void Oberon_HandleFiller (Display_Frame V, Display_FrameMsg *M, LONGINT *M__typ);
export void Oberon_Install (Oberon_Task T);
export void Oberon_Loop (void);
export Viewers_Viewer Oberon_MarkedViewer (void);
static LONGINT Oberon_MinTime (void);
static void Oberon_NotifyTasks (void);
export void Oberon_OpenCursor (Oberon_Cursor *c, LONGINT *c__typ);
export void Oberon_OpenDisplay (INTEGER UW, INTEGER SW, INTEGER H);
export void Oberon_OpenTrack (INTEGER X, INTEGER W);
export void Oberon_PassFocus (Viewers_Viewer V);
export void Oberon_Remove (Oberon_Task T);
export void Oberon_RemoveMarks (INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
static INTEGER Oberon_SY (INTEGER X);
export void Oberon_SetClock (LONGINT t, LONGINT d);
export void Oberon_SetColor (SHORTINT col);
export void Oberon_SetFont (Fonts_Font fnt);
export void Oberon_SetOffset (SHORTINT voff);
export void Oberon_SetUser (CHAR *user, LONGINT user__len, CHAR *password, LONGINT password__len);
export INTEGER Oberon_SystemTrack (INTEGER X);
export LONGINT Oberon_Time (void);
static INTEGER Oberon_UY (INTEGER X);
export CHAR Oberon_UnicodeToOberon (LONGINT val);
export INTEGER Oberon_UserTrack (INTEGER X);

#define Oberon_system(cmd, cmd__len)	(LONGINT)system(cmd)

static LONGINT Oberon_Code (CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	LONGINT a = 0, b = 0, c = 0;
	a = 0;
	b = 0;
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		c = b;
		b = a;
		a = (__MOD(c, 509) + 1) * 127 + (LONGINT)s[__X(i, s__len)];
		i += 1;
	}
	if (b >= 32768) {
		b = b - 65536;
	}
	return __ASHL(b, 16) + a;
}

void Oberon_SetUser (CHAR *user, LONGINT user__len, CHAR *password, LONGINT password__len)
{
	__COPY(user, Oberon_User, 12);
	Oberon_Password = Oberon_Code((void*)password, password__len);
}

void Oberon_GetClock (LONGINT *t, LONGINT *d)
{
	Kernel_GetClock(&*t, &*d);
}

void Oberon_SetClock (LONGINT t, LONGINT d)
{
	Kernel_SetClock(t, d);
}

LONGINT Oberon_Time (void)
{
	return Input_Time();
}

static void Oberon_FlipArrow (INTEGER X, INTEGER Y)
{
}

static void Oberon_FlipStar (INTEGER X, INTEGER Y)
{
	if (X < Oberon_CL) {
		if (X < 7) {
			X = 7;
		} else if (X > Oberon_DW - 8) {
			X = Oberon_DW - 8;
		}
	} else {
		if (X < Oberon_CL + 7) {
			X = Oberon_CL + 7;
		} else if (X > (Oberon_CL + Oberon_DW) - 8) {
			X = (Oberon_CL + Oberon_DW) - 8;
		}
	}
	if (Y < 7) {
		Y = 7;
	} else if (Y > Oberon_DH - 8) {
		Y = Oberon_DH - 8;
	}
	Display_CopyPattern(15, Display_star, X - 7, Y - 7, 2);
}

void Oberon_OpenCursor (Oberon_Cursor *c, LONGINT *c__typ)
{
	(*c).on = 0;
	(*c).X = 0;
	(*c).Y = 0;
}

void Oberon_FadeCursor (Oberon_Cursor *c, LONGINT *c__typ)
{
	if ((*c).on) {
		(*(*c).marker.Fade)((*c).X, (*c).Y);
		(*c).on = 0;
	}
}

void Oberon_DrawCursor (Oberon_Cursor *c, LONGINT *c__typ, Oberon_Marker *m, LONGINT *m__typ, INTEGER X, INTEGER Y)
{
	if ((*c).on && ((X != (*c).X || Y != (*c).Y) || (*m).Draw != (*c).marker.Draw)) {
		(*(*c).marker.Fade)((*c).X, (*c).Y);
		(*c).on = 0;
	}
	if ((*c).marker.Fade == Oberon_ArrowFade) {
		if ((*m).Fade != Oberon_ArrowFade) {
			X11_DefineCursor(X11_display, X11_primary, X11_noCursor);
		}
	} else {
		if ((*m).Fade == Oberon_ArrowFade) {
			X11_DefineCursor(X11_display, X11_primary, X11_arrow);
		}
	}
	if (!(*c).on) {
		(*(*m).Draw)(X, Y);
		(*c).marker = *m;
		(*c).X = X;
		(*c).Y = Y;
		(*c).on = 1;
	}
}

void Oberon_RemoveMarks (INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	if (((Oberon_Mouse.X > X - 16 && Oberon_Mouse.X < (X + W) + 16) && Oberon_Mouse.Y > Y - 16) && Oberon_Mouse.Y < (Y + H) + 16) {
		Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
	}
	if (((Oberon_Pointer.X > X - 8 && Oberon_Pointer.X < (X + W) + 8) && Oberon_Pointer.Y > Y - 8) && Oberon_Pointer.Y < (Y + H) + 8) {
		Oberon_FadeCursor(&Oberon_Pointer, Oberon_Cursor__typ);
	}
}

static void Oberon_HandleFiller (Display_Frame V, Display_FrameMsg *M, LONGINT *M__typ)
{
	if (__ISP(V, Viewers_ViewerDesc, 1)) {
		if (__IS(M__typ, Oberon_InputMsg, 1)) {
			if (__IS(M__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *M__ = (void*)M;
				if ((*M__).id == 1) {
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*M__).X, (*M__).Y);
				}
			} else __WITHCHK;
		} else if (__IS(M__typ, Oberon_ControlMsg, 1)) {
			if (__IS(M__typ, Oberon_ControlMsg, 1)) {
				Oberon_ControlMsg *M__ = (void*)M;
				if ((*M__).id == 2) {
					Oberon_DrawCursor(&Oberon_Pointer, Oberon_Cursor__typ, &Oberon_Star, Oberon_Marker__typ, (*M__).X, (*M__).Y);
				}
			} else __WITHCHK;
		} else if (__IS(M__typ, Viewers_ViewerMsg, 1)) {
			if (__IS(M__typ, Viewers_ViewerMsg, 1)) {
				Viewers_ViewerMsg *M__ = (void*)M;
				if (((*M__).id == 0 && (*(Viewers_Viewer*)&V)->W > 0) && (*(Viewers_Viewer*)&V)->H > 0) {
					Oberon_RemoveMarks((*(Viewers_Viewer*)&V)->X, (*(Viewers_Viewer*)&V)->Y, (*(Viewers_Viewer*)&V)->W, (*(Viewers_Viewer*)&V)->H);
					Display_ReplConst(0, (*(Viewers_Viewer*)&V)->X, (*(Viewers_Viewer*)&V)->Y, (*(Viewers_Viewer*)&V)->W, (*(Viewers_Viewer*)&V)->H, 0);
				} else if ((*M__).id == 1 && (*M__).Y < (*(Viewers_Viewer*)&V)->Y) {
					Oberon_RemoveMarks((*(Viewers_Viewer*)&V)->X, (*M__).Y, (*(Viewers_Viewer*)&V)->W, (*(Viewers_Viewer*)&V)->Y - (*M__).Y);
					Display_ReplConst(0, (*(Viewers_Viewer*)&V)->X, (*M__).Y, (*(Viewers_Viewer*)&V)->W, (*(Viewers_Viewer*)&V)->Y - (*M__).Y, 0);
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void Oberon_OpenDisplay (INTEGER UW, INTEGER SW, INTEGER H)
{
	Viewers_Viewer Filler = NIL;
	Input_SetMouseLimits((Viewers_curW + UW) + SW, H);
	Display_ReplConst(0, Viewers_curW, 0, UW + SW, H, 0);
	__NEW(Filler, Viewers_ViewerDesc);
	Filler->handle = Oberon_HandleFiller;
	Viewers_InitTrack(UW, H, Filler);
	__NEW(Filler, Viewers_ViewerDesc);
	Filler->handle = Oberon_HandleFiller;
	Viewers_InitTrack(SW, H, Filler);
}

INTEGER Oberon_DisplayWidth (INTEGER X)
{
	return Oberon_DW;
}

INTEGER Oberon_DisplayHeight (INTEGER X)
{
	return Oberon_DH;
}

void Oberon_OpenTrack (INTEGER X, INTEGER W)
{
	Viewers_Viewer Filler = NIL;
	__NEW(Filler, Viewers_ViewerDesc);
	Filler->handle = Oberon_HandleFiller;
	Viewers_OpenTrack(X, W, Filler);
}

INTEGER Oberon_UserTrack (INTEGER X)
{
	return __DIV(X, Oberon_DW) * Oberon_DW;
}

INTEGER Oberon_SystemTrack (INTEGER X)
{
	return __DIV(X, Oberon_DW) * Oberon_DW + __ASHR(Oberon_DW, 3) * 5;
}

static INTEGER Oberon_UY (INTEGER X)
{
	Display_Frame fil = NIL, bot = NIL, alt = NIL, max = NIL;
	Viewers_Locate(X, 0, &fil, &bot, &alt, &max);
	if (fil->H >= __ASHR(Oberon_DH, 3)) {
		return Oberon_DH;
	}
	return max->Y + __ASHR(max->H, 1);
}

void Oberon_AllocateUserViewer (INTEGER DX, INTEGER *X, INTEGER *Y)
{
	if (Oberon_Pointer.on) {
		*X = Oberon_Pointer.X;
		*Y = Oberon_Pointer.Y;
	} else {
		*X = __DIV(DX, Oberon_DW) * Oberon_DW;
		*Y = Oberon_UY(*X);
	}
}

static INTEGER Oberon_SY (INTEGER X)
{
	Display_Frame fil = NIL, bot = NIL, alt = NIL, max = NIL;
	Viewers_Locate(X, Oberon_DH, &fil, &bot, &alt, &max);
	if (fil->H >= __ASHR(Oberon_DH, 3)) {
		return Oberon_DH;
	}
	if (max->H >= Oberon_DH - Oberon_H0) {
		return max->Y + Oberon_H3;
	}
	if (max->H >= Oberon_H3 - Oberon_H0) {
		return max->Y + Oberon_H2;
	}
	if (max->H >= Oberon_H2 - Oberon_H0) {
		return max->Y + Oberon_H1;
	}
	if (max != bot) {
		return max->Y + __ASHR(max->H, 1);
	}
	if (bot->H >= Oberon_H1) {
		return __ASHR(bot->H, 1);
	}
	return alt->Y + __ASHR(alt->H, 1);
}

void Oberon_AllocateSystemViewer (INTEGER DX, INTEGER *X, INTEGER *Y)
{
	if (Oberon_Pointer.on) {
		*X = Oberon_Pointer.X;
		*Y = Oberon_Pointer.Y;
	} else {
		*X = __DIV(DX, Oberon_DW) * Oberon_DW + __ASHR(Oberon_DW, 3) * 5;
		*Y = Oberon_SY(*X);
	}
}

Viewers_Viewer Oberon_MarkedViewer (void)
{
	return Viewers_This(Oberon_Pointer.X, Oberon_Pointer.Y);
}

void Oberon_PassFocus (Viewers_Viewer V)
{
	Oberon_ControlMsg M = {0};
	M.id = 0;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&M, Oberon_ControlMsg__typ);
	Oberon_FocusViewer = V;
}

void Oberon_Call (CHAR *name, LONGINT name__len, Oberon_ParList par, BOOLEAN new, INTEGER *res)
{
	Modules_Module Mod = NIL;
	Modules_Command P = NIL;
	INTEGER i = 0, j = 0;
	__DUP(name, name__len, CHAR);
	*res = 1;
	i = 0;
	j = 0;
	while (name[__X(j, name__len)] != 0x00) {
		if (name[__X(j, name__len)] == '.') {
			i = j;
		}
		j += 1;
	}
	if (i > 0) {
		name[__X(i, name__len)] = 0x00;
		Mod = Modules_ThisMod(name, name__len);
		if (Modules_res == 0) {
			i += 1;
			j = i;
			while (name[__X(j, name__len)] != 0x00) {
				name[__X(j - i, name__len)] = name[__X(j, name__len)];
				j += 1;
			}
			name[__X(j - i, name__len)] = 0x00;
			P = Modules_ThisCommand(Mod, name, name__len);
			if (Modules_res == 0) {
				Oberon_Par = par;
				Oberon_Par->vwr = Viewers_This(par->frame->X, par->frame->Y);
				(*P)();
				*res = 0;
			} else {
				*res = -1;
			}
		} else {
			*res = Modules_res;
		}
	} else {
		*res = -1;
	}
	__DEL(name);
}

CHAR Oberon_UnicodeToOberon (LONGINT val)
{
	CHAR ch = 0;
	if (val < 128) {
		ch = (CHAR)val;
	} else if (val < 256) {
		switch (val) {
			case 196: 
				ch = 0x80;
				break;
			case 214: 
				ch = 0x81;
				break;
			case 220: 
				ch = 0x82;
				break;
			case 228: 
				ch = 0x83;
				break;
			case 246: 
				ch = 0x84;
				break;
			case 252: 
				ch = 0x85;
				break;
			case 223: 
				ch = 0xab;
				break;
			case 171: 
				ch = 0x91;
				break;
			case 175: 
				ch = 0x92;
				break;
			case 167: 
				ch = 0x93;
				break;
			case 177: 
				ch = 0x95;
				break;
			case 225: 
				ch = 0x94;
				break;
			case 233: 
				ch = 0x90;
				break;
			case 224: 
				ch = 0x8b;
				break;
			case 232: 
				ch = 0x8c;
				break;
			case 236: 
				ch = 0x8d;
				break;
			case 242: 
				ch = 0x8e;
				break;
			case 249: 
				ch = 0x8f;
				break;
			case 226: 
				ch = 0x86;
				break;
			case 234: 
				ch = 0x87;
				break;
			case 238: 
				ch = 0x88;
				break;
			case 244: 
				ch = 0x89;
				break;
			case 251: 
				ch = 0x8a;
				break;
			default: 
				ch = '\?';
				break;
		}
	} else if (val < 9472) {
		switch (val) {
			case 8208: case 8209: case 8211: case 8212: 
				ch = '-';
				break;
			case 8216: case 8217: 
				ch = '\'';
				break;
			case 8220: case 8221: 
				ch = '\"';
				break;
			case 8249: 
				ch = '<';
				break;
			case 8250: 
				ch = '>';
				break;
			default: 
				ch = '\?';
				__HALT(88);
				break;
		}
	} else if (val == 9472) {
		ch = '-';
	} else {
		ch = '\?';
	}
	return ch;
}

static struct ExecShell__9 {
	LONGINT *bufsize;
	CHAR (*buf)[32000];
	Texts_Writer *W;
	struct ExecShell__9 *lnk;
} *ExecShell__9_s;

static void CloseDup__10 (LONGINT fd);
static void MapChar__12 (CHAR ch, LONGINT *i);
static LONGINT TryDup__14 (LONGINT fd);

static void MapChar__12 (CHAR ch, LONGINT *i)
{
	INTEGER val = 0;
	CHAR buf1[1];
	LONGINT buf1len = 0;
	if (ch < 0xe0) {
		if (*i + 2 >= *ExecShell__9_s->bufsize) {
			Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
			return;
		}
		val = (int)ch - 192;
		if (val < 0) {
			Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
			return;
		}
		ch = (*ExecShell__9_s->buf)[__X(*i + 1, 32000)];
		val = (__ASHL(val, 6) + (int)ch) - 128;
		if (ch < 0x80 || ch >= 0xe0) {
			Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
			return;
		}
		Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, Oberon_UnicodeToOberon(val));
		*i += 1;
	} else if (ch < 0xf0) {
		if (*i + 3 >= *ExecShell__9_s->bufsize) {
			Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
			return;
		}
		val = (int)ch - 224;
		ch = (*ExecShell__9_s->buf)[__X(*i + 1, 32000)];
		val = (__ASHL(val, 6) + (int)ch) - 128;
		if (ch < 0x80 || ch >= 0xe0) {
			Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
			return;
		}
		ch = (*ExecShell__9_s->buf)[__X(*i + 2, 32000)];
		val = (__ASHL(val, 6) + (int)ch) - 128;
		if (ch < 0x80 || ch >= 0xe0) {
			Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
			return;
		}
		Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, Oberon_UnicodeToOberon(val));
		*i += 2;
	} else {
		Texts_Write(&*ExecShell__9_s->W, Texts_Writer__typ, '\?');
		return;
	}
}

static LONGINT TryDup__14 (LONGINT fd)
{
	LONGINT dupFd = 0;
	dupFd = Unix_Dup(fd);
	if (dupFd == -1) {
		Kernel_GC(1);
		Kernel_GC(1);
		dupFd = Unix_Dup(fd);
	}
	return dupFd;
}

static void CloseDup__10 (LONGINT fd)
{
	if (fd >= 0) {
		fd = Unix_Close(fd);
	}
}

void Oberon_ExecShell (CHAR *cmd, LONGINT cmd__len, LONGINT *status, Texts_Buffer *out)
{
	LONGINT i = 0, bufsize = 0, stdin = 0, stdout = 0, stderr = 0, fd = 0, res = 0;
	CHAR buf[32000];
	CHAR ch = 0;
	Texts_Writer W = {0};
	struct ExecShell__9 _s;
	__DUP(cmd, cmd__len, CHAR);
	_s.bufsize = &bufsize;
	_s.buf = (void*)buf;
	_s.W = &W;
	_s.lnk = ExecShell__9_s;
	ExecShell__9_s = &_s;
	Texts_OpenWriter(&W, Texts_Writer__typ);
	stdin = TryDup__14(0);
	stdout = TryDup__14(1);
	stderr = TryDup__14(2);
	if ((stdin == -1 || stdout == -1) || stderr == -1) {
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"too many open files", (LONGINT)20);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, W.buf);
		CloseDup__10(stdin);
		CloseDup__10(stdout);
		CloseDup__10(stderr);
		ExecShell__9_s = _s.lnk;
		__DEL(cmd);
		return;
	}
	res = Unix_Close(0);
	res = Unix_Close(1);
	res = Unix_Close(2);
	fd = Unix_Open((CHAR*)"/dev/null", (LONGINT)10, 0x02, 0xffffffff);
	__ASSERT(fd == 0, 70);
	fd = Unix_Open((CHAR*)"/tmp/System.Execute", (LONGINT)20, 0x0242, 0xffffffff);
	res = Unix_Unlink((CHAR*)"/tmp/System.Execute", (LONGINT)20);
	__ASSERT(fd == 1, 71);
	fd = Unix_Dup(fd);
	__ASSERT(fd == 2, 72);
	*status = Oberon_system(cmd, cmd__len);
	res = Unix_Lseek(1, 0, 0);
	bufsize = Unix_ReadBlk(1, (void*)buf, 32000);
	if (bufsize > 0) {
		do {
			i = 0;
			while (i < bufsize) {
				ch = buf[__X(i, 32000)];
				if (ch == 0x0d || ch == 0x0a) {
					Texts_WriteLn(&W, Texts_Writer__typ);
				} else if ((ch >= ' ' && ch < 0x80 || ch == 0x0d) || ch == 0x09) {
					Texts_Write(&W, Texts_Writer__typ, ch);
				} else if (ch == 0x1b) {
					Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"ESC", (LONGINT)4);
				} else {
					MapChar__12(ch, &i);
				}
				i += 1;
			}
			bufsize = Unix_ReadBlk(1, (void*)buf, 32000);
		} while (!(bufsize == 0));
		res = Unix_Ftruncate(1, 0);
		res = Unix_Lseek(1, 0, 0);
	}
	res = Unix_Close(0);
	res = Unix_Close(1);
	res = Unix_Close(2);
	fd = Unix_Dup(stdin);
	fd = Unix_Dup(stdout);
	fd = Unix_Dup(stderr);
	res = Unix_Close(stdin);
	res = Unix_Close(stdout);
	res = Unix_Close(stderr);
	*out = W.buf;
	ExecShell__9_s = _s.lnk;
	__DEL(cmd);
}

void Oberon_GetSelection (Texts_Text *text, LONGINT *beg, LONGINT *end, LONGINT *time)
{
	Oberon_SelectionMsg M = {0};
	M.time = -1;
	Viewers_Broadcast((void*)&M, Oberon_SelectionMsg__typ);
	*time = M.time;
	if (*time >= 0) {
		*text = M.text;
		*beg = M.beg;
		*end = M.end;
	}
}

static void Oberon_GC (void)
{
	if (Oberon_ActCnt <= 0) {
		Kernel_GC(0);
		Oberon_ActCnt = 20;
	}
}

void Oberon_Install (Oberon_Task T)
{
	Oberon_Task t = NIL;
	t = Oberon_PrevTask;
	while (t->next != Oberon_PrevTask && t->next != T) {
		t = t->next;
	}
	if (t->next != T && Oberon_CurTask != T) {
		if (Oberon_CurTask != NIL) {
			T->next = Oberon_CurTask->next;
			Oberon_CurTask->next = T;
		} else {
			T->next = Oberon_PrevTask->next;
			Oberon_PrevTask->next = T;
		}
	}
}

void Oberon_Remove (Oberon_Task T)
{
	Oberon_Task t = NIL;
	t = Oberon_PrevTask;
	while (t->next != T && t->next != Oberon_PrevTask) {
		t = t->next;
	}
	if (t->next == T) {
		t->next = t->next->next;
		Oberon_PrevTask = t->next;
	}
	if (Oberon_CurTask == T) {
		Oberon_CurTask = Oberon_PrevTask->next;
	}
}

void Oberon_Collect (INTEGER count)
{
	Oberon_ActCnt = count;
}

void Oberon_SetFont (Fonts_Font fnt)
{
	Oberon_CurFnt = fnt;
}

void Oberon_SetColor (SHORTINT col)
{
	Oberon_CurCol = col;
}

void Oberon_SetOffset (SHORTINT voff)
{
	Oberon_CurOff = voff;
}

static LONGINT Oberon_MinTime (void)
{
	LONGINT minTime = 0;
	Oberon_Task t = NIL;
	minTime = 2147483647;
	t = Oberon_PrevTask;
	do {
		if (t->time != -1 && t->time < minTime) {
			minTime = t->time;
		}
		t = t->next;
	} while (!(t == Oberon_PrevTask));
	return minTime;
}

static void Oberon_NotifyTasks (void)
{
	Oberon_Task t0 = NIL, p = NIL;
	t0 = Oberon_PrevTask;
	do {
		Oberon_CurTask = Oberon_PrevTask->next;
		if (Oberon_CurTask->time == -1) {
			if (!Oberon_CurTask->safe) {
				Oberon_PrevTask->next = Oberon_CurTask->next;
			}
			p = Oberon_CurTask;
			(*Oberon_CurTask->handle)();
			Oberon_PrevTask->next = Oberon_CurTask;
			if (Oberon_CurTask != p) {
				return;
			}
		}
		Oberon_PrevTask = Oberon_CurTask;
	} while (!(Oberon_CurTask == t0));
}

void Oberon_Loop (void)
{
	Viewers_Viewer V = NIL;
	Oberon_InputMsg M = {0};
	Oberon_ControlMsg N = {0};
	INTEGER prevX = 0, prevY = 0, X = 0, Y = 0;
	SET keys = 0;
	CHAR ch = 0;
	Viewers_ViewerMsg VM = {0};
	INTEGER i = 0;
	LONGINT res = 0;
	res = Kernel_sigsetjmp(&Kernel_trapEnv, Unix_JmpBuf__typ, 1);
	Oberon_LoopStarted = 1;
	for (;;) {
		Oberon_CurTask = NIL;
		Input_Mouse(&keys, &X, &Y);
		if (Input_Available() > 0) {
			Input_Read(&ch);
			if (ch < 0xf0) {
				if (ch == 0x1b) {
					N.id = 1;
					Viewers_Broadcast((void*)&N, Oberon_ControlMsg__typ);
					Oberon_FadeCursor(&Oberon_Pointer, Oberon_Cursor__typ);
				} else if (ch == 0xa4) {
					N.id = 2;
					N.X = X;
					N.Y = Y;
					V = Viewers_This(X, Y);
					(*V->handle)((void*)V, (void*)&N, Oberon_ControlMsg__typ);
				} else if (ch == 0x0c) {
					N.id = 1;
					Viewers_Broadcast((void*)&N, Oberon_ControlMsg__typ);
					Oberon_FadeCursor(&Oberon_Pointer, Oberon_Cursor__typ);
					VM.id = 2;
					Viewers_Broadcast((void*)&VM, Viewers_ViewerMsg__typ);
					VM.id = 0;
					Viewers_Broadcast((void*)&VM, Viewers_ViewerMsg__typ);
				} else {
					M.id = 0;
					M.ch = ch;
					M.fnt = Oberon_CurFnt;
					M.col = Oberon_CurCol;
					M.voff = Oberon_CurOff;
					(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&M, Oberon_InputMsg__typ);
					Oberon_ActCnt -= 1;
					Oberon_NotifyTasks();
				}
			} else if (ch == 0xf1) {
				Display_SetMode(0, 0x0);
			} else if (ch == 0xf2) {
				Display_SetMode(0, 0x01);
			} else if (ch == 0xf3) {
				Display_SetMode(0, 0x04);
			} else if (ch == 0xf4) {
				X11_InitColors();
			} else if (Kernel_FKey[__X((int)ch - 240, 16)] != NIL) {
				(*Kernel_FKey[__X((int)ch - 240, 16)])();
			}
		} else if (keys != 0x0) {
			M.id = 1;
			M.X = X;
			M.Y = Y;
			M.keys = keys;
			do {
				V = Viewers_This(M.X, M.Y);
				(*V->handle)((void*)V, (void*)&M, Oberon_InputMsg__typ);
				Input_Mouse(&M.keys, &M.X, &M.Y);
			} while (!(M.keys == 0x0));
			Oberon_ActCnt -= 1;
			Oberon_NotifyTasks();
		} else {
			if ((X != prevX || Y != prevY) || !Oberon_Mouse.on) {
				M.id = 1;
				M.X = X;
				M.Y = Y;
				M.keys = keys;
				V = Viewers_This(X, Y);
				(*V->handle)((void*)V, (void*)&M, Oberon_InputMsg__typ);
				prevX = X;
				prevY = Y;
			}
			X11_DoSync();
			if (X11_EventsQueued(X11_display, 1) == 0) {
				Kernel_Select(Oberon_MinTime() - Input_Time());
				Oberon_NotifyTasks();
				i = 0;
				while (i <= 7) {
					Kernel_readySet[__X(i, 8)] = 0x0;
					i += 1;
				}
			}
			Oberon_CurTask = Oberon_PrevTask->next;
			if (Oberon_CurTask->time <= Input_Time() && Oberon_CurTask->time != -1) {
				if (!Oberon_CurTask->safe) {
					Oberon_PrevTask->next = Oberon_CurTask->next;
				}
				(*Oberon_CurTask->handle)();
				Oberon_PrevTask->next = Oberon_CurTask;
			}
			Oberon_PrevTask = Oberon_CurTask;
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(Oberon_FocusViewer);
	P(Oberon_Log);
	P(Oberon_Par);
	P(Oberon_CurTask);
	P(Oberon_PrevTask);
	P(Oberon_CurFnt);
	P(Oberon_Mod);
}

__TDESC(Oberon_Marker, 1, 0) = {__TDFLDS("Marker", 8), {-4}};
__TDESC(Oberon_Cursor, 1, 0) = {__TDFLDS("Cursor", 16), {-4}};
__TDESC(Oberon_ParRec, 1, 3) = {__TDFLDS("ParRec", 16), {0, 4, 8, -16}};
__TDESC(Oberon_InputMsg, 1, 1) = {__TDFLDS("InputMsg", 24), {16, -8}};
__TDESC(Oberon_SelectionMsg, 1, 1) = {__TDFLDS("SelectionMsg", 16), {4, -8}};
__TDESC(Oberon_ControlMsg, 1, 0) = {__TDFLDS("ControlMsg", 6), {-4}};
__TDESC(Oberon_CopyOverMsg, 1, 1) = {__TDFLDS("CopyOverMsg", 12), {0, -8}};
__TDESC(Oberon_CopyMsg, 1, 1) = {__TDFLDS("CopyMsg", 4), {0, -8}};
__TDESC(Oberon_TaskDesc, 1, 1) = {__TDFLDS("TaskDesc", 16), {0, -8}};

export void *Oberon__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(Kernel);
	__IMPORT(Modules);
	__IMPORT(Texts);
	__IMPORT(Unix);
	__IMPORT(Viewers);
	__IMPORT(X11);
	__REGMOD(Oberon, EnumPtrs);
	__REGCMD("Loop", Oberon_Loop);
	__INITYP(Oberon_Marker, Oberon_Marker, 0);
	__INITYP(Oberon_Cursor, Oberon_Cursor, 0);
	__INITYP(Oberon_ParRec, Oberon_ParRec, 0);
	__INITYP(Oberon_InputMsg, Display_FrameMsg, 1);
	__INITYP(Oberon_SelectionMsg, Display_FrameMsg, 1);
	__INITYP(Oberon_ControlMsg, Display_FrameMsg, 1);
	__INITYP(Oberon_CopyOverMsg, Display_FrameMsg, 1);
	__INITYP(Oberon_CopyMsg, Display_FrameMsg, 1);
	__INITYP(Oberon_TaskDesc, Oberon_TaskDesc, 0);
/* BEGIN */
	Oberon_User[0] = 0x00;
	Oberon_Arrow.Fade = Oberon_FlipArrow;
	Oberon_Arrow.Draw = Oberon_FlipArrow;
	Oberon_ArrowFade = Oberon_FlipArrow;
	Oberon_Star.Fade = Oberon_FlipStar;
	Oberon_Star.Draw = Oberon_FlipStar;
	Oberon_OpenCursor(&Oberon_Mouse, Oberon_Cursor__typ);
	Oberon_OpenCursor(&Oberon_Pointer, Oberon_Cursor__typ);
	Oberon_DW = Display_Width;
	Oberon_DH = Display_Height;
	Oberon_CL = Display_ColLeft;
	Oberon_H3 = Oberon_DH - __DIV(Oberon_DH, 3);
	Oberon_H2 = Oberon_H3 - __ASHR(Oberon_H3, 1);
	Oberon_H1 = __DIV(Oberon_DH, 5);
	Oberon_H0 = __DIV(Oberon_DH, 10);
	Oberon_CurFnt = Fonts_Default;
	Oberon_CurCol = 15;
	Oberon_CurOff = 0;
	Oberon_Collect(20);
	__NEW(Oberon_PrevTask, Oberon_TaskDesc);
	Oberon_PrevTask->handle = Oberon_GC;
	Oberon_PrevTask->safe = 1;
	Oberon_PrevTask->time = -1;
	Oberon_PrevTask->next = Oberon_PrevTask;
	Oberon_CurTask = NIL;
	Display_SetMode(0, 0x0);
	__ENDMOD;
}
