/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct PopupElems_EditFrameDesc *PopupElems_EditFrame;

typedef
	struct PopupElems_ElemDesc *PopupElems_Elem;

typedef
	struct PopupElems_EditFrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		PopupElems_Elem elem;
	} PopupElems_EditFrameDesc;

typedef
	struct PopupElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_, width, lsp, dsc;
		SET options;
	} PopupElems_ElemDesc;

typedef
	struct PopupElems_ExecMsg { /* Texts_ElemMsg */
		Display_Frame frame;
		LONGINT pos;
		SET keys;
	} PopupElems_ExecMsg;


static INTEGER PopupElems_DUnit;
static Texts_Writer PopupElems_wr;
static Texts_Buffer PopupElems_buf;

export LONGINT *PopupElems_ElemDesc__typ;
export LONGINT *PopupElems_EditFrameDesc__typ;
export LONGINT *PopupElems_ExecMsg__typ;

export void PopupElems_Alloc (void);
static void PopupElems_Box (INTEGER col, INTEGER bkgnd, INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
static Texts_Text PopupElems_CopyText (Texts_Text from);
static void PopupElems_DefaultMenu (PopupElems_Elem e);
static void PopupElems_DispStr (Fonts_Font fnt, CHAR *s, LONGINT s__len, INTEGER col, INTEGER x0, INTEGER y0);
static void PopupElems_DrawElem (PopupElems_Elem e, Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER col, INTEGER X, INTEGER Y);
static void PopupElems_DrawMenu (PopupElems_Elem e, INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
static void PopupElems_ErrorMsg (CHAR *name, LONGINT name__len, INTEGER res);
static void PopupElems_ExecCmd (PopupElems_Elem E, Display_Frame F, LONGINT pos, SET keys);
static void PopupElems_GetName (PopupElems_Elem e, Texts_Text t, LONGINT pos);
export void PopupElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void PopupElems_HandleEdit (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void PopupElems_Insert (void);
export void PopupElems_InsertMenu (void);
static void PopupElems_Ln (void);
static void PopupElems_Load (Files_Rider *r, LONGINT *r__typ, PopupElems_Elem e);
static INTEGER PopupElems_Max (INTEGER x, INTEGER y);
export void PopupElems_MeasureMenu (PopupElems_Elem E);
static INTEGER PopupElems_Min (INTEGER x, INTEGER y);
static void PopupElems_OpenEditor (PopupElems_Elem e);
static void PopupElems_Popup (PopupElems_Elem e, TextFrames_TrackMsg msg);
static void PopupElems_PrepareDraw (PopupElems_Elem e, Fonts_Font fnt, INTEGER *dy);
static void PopupElems_PrepareMenu (PopupElems_Elem e);
static void PopupElems_PrintElem (PopupElems_Elem e, Fonts_Font fnt, INTEGER X, INTEGER Y);
static void PopupElems_Restore (INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
static void PopupElems_Save (INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
static void PopupElems_Show (Display_Frame f, PopupElems_Elem e, LONGINT pos, INTEGER X, INTEGER Y, INTEGER *cmd, SET *keySum);
static void PopupElems_Store (Files_Rider *r, LONGINT *r__typ, PopupElems_Elem e);
static void PopupElems_Str (CHAR *s, LONGINT s__len);
static LONGINT PopupElems_StrDispWidth (Fonts_Font fnt, CHAR *s, LONGINT s__len);
export void PopupElems_Toggle (void);
static void PopupElems_Underline (Display_Frame f, INTEGER col, INTEGER X, INTEGER Y, INTEGER W);
export void PopupElems_Update (void);
static void PopupElems_insert (SET options);


static void PopupElems_Str (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, s, s__len);
	__DEL(s);
}

static void PopupElems_Ln (void)
{
	Texts_WriteLn(&PopupElems_wr, Texts_Writer__typ);
}

static void PopupElems_ErrorMsg (CHAR *name, LONGINT name__len, INTEGER res)
{
	__DUP(name, name__len, CHAR);
	if (res > 0) {
		PopupElems_Str((CHAR*)"Call error: ", (LONGINT)13);
		PopupElems_Str(Modules_importing, 20);
		if (res == 1) {
			PopupElems_Str((CHAR*)" not found", (LONGINT)11);
		} else if (res == 2) {
			PopupElems_Str((CHAR*)" not an obj-file", (LONGINT)17);
		} else if (res == 3) {
			PopupElems_Str((CHAR*)" imports ", (LONGINT)10);
			PopupElems_Str(Modules_imported, 20);
			PopupElems_Str((CHAR*)" with bad key", (LONGINT)14);
		} else if (res == 4) {
			PopupElems_Str((CHAR*)" corrupted obj file", (LONGINT)20);
		} else if (res == 6) {
			PopupElems_Str((CHAR*)" has too many imports", (LONGINT)22);
		} else if (res == 7) {
			PopupElems_Str((CHAR*)" not enough space", (LONGINT)18);
		}
	} else if (res < 0) {
		PopupElems_Str(name, name__len);
		PopupElems_Str((CHAR*)" not found", (LONGINT)11);
	}
	if (res != 0) {
		PopupElems_Ln();
		Texts_Append(Oberon_Log, PopupElems_wr.buf);
	}
	__DEL(name);
}

static void PopupElems_Save (INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	Display_CopyBlock(X, Y, W, H, X, -H, 0);
}

static void PopupElems_Restore (INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	Display_CopyBlock(X, -H, W, H, X, Y, 0);
}

static INTEGER PopupElems_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER PopupElems_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static Texts_Text PopupElems_CopyText (Texts_Text from)
{
	Texts_Text to = NIL;
	Texts_Save(from, 0, from->len, PopupElems_buf);
	to = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Append(to, PopupElems_buf);
	return to;
}

static void PopupElems_DefaultMenu (PopupElems_Elem e)
{
	if (e->menu->len > 0) {
		Texts_Delete(e->menu, 0, e->menu->len);
	}
	PopupElems_Str((CHAR*)"right interclick to edit menu", (LONGINT)30);
	PopupElems_Ln();
	Texts_Append(e->menu, PopupElems_wr.buf);
}

static void PopupElems_GetName (PopupElems_Elem e, Texts_Text t, LONGINT pos)
{
	Texts_Scanner s = {0};
	Texts_OpenScanner(&s, Texts_Scanner__typ, t, pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (!__IN(s.class, 0x06) || s.s[0] == 0x00) {
		__MOVE("Popup", e->name, 6);
	} else {
		__COPY(s.s, e->name, 32);
	}
}

static LONGINT PopupElems_StrDispWidth (Fonts_Font fnt, CHAR *s, LONGINT s__len)
{
	LONGINT pat = 0;
	INTEGER width = 0, i = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	__DUP(s, s__len, CHAR);
	width = 0;
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		Display_GetChar(fnt->raster, s[__X(i, s__len)], &dx, &x, &y, &w, &h, &pat);
		width += dx;
		i += 1;
	}
	__DEL(s);
	return (LONGINT)width * (LONGINT)PopupElems_DUnit;
}

static void PopupElems_DispStr (Fonts_Font fnt, CHAR *s, LONGINT s__len, INTEGER col, INTEGER x0, INTEGER y0)
{
	LONGINT pat = 0;
	INTEGER i = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		Display_GetChar(fnt->raster, s[__X(i, s__len)], &dx, &x, &y, &w, &h, &pat);
		Display_CopyPattern(col, pat, x0 + x, y0 + y, 1);
		i += 1;
		x0 += dx;
	}
	__DEL(s);
}

static void PopupElems_PrepareDraw (PopupElems_Elem e, Fonts_Font fnt, INTEGER *dy)
{
	INTEGER width = 0, dh = 0;
	if (__IN(0, e->options)) {
		width = 0;
		dh = 0;
		*dy = fnt->minY;
		if (*dy > -2) {
			*dy = -2;
		}
	} else {
		width = 12;
		dh = (-fnt->minY + 4) + 2;
	}
	e->W = ((LONGINT)width * (LONGINT)PopupElems_DUnit + PopupElems_StrDispWidth(fnt, e->name, 32)) + (LONGINT)PopupElems_DUnit;
	e->H = (LONGINT)((fnt->maxY - fnt->minY) + dh) * (LONGINT)PopupElems_DUnit;
}

static void PopupElems_PrepareMenu (PopupElems_Elem e)
{
	Texts_Reader r = {0};
	CHAR ch = 0, oldCh = 0;
	INTEGER width = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	LONGINT p = 0;
	e->width = 0;
	e->n = 1;
	e->lsp = 0;
	width = 0;
	oldCh = 0x00;
	Texts_OpenReader(&r, Texts_Reader__typ, e->menu, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot) {
		if (ch == 0x0d) {
			e->width = PopupElems_Max(e->width, width);
			width = 0;
			e->n += 1;
		} else {
			e->lsp = PopupElems_Max(e->lsp, r.fnt->height);
			e->dsc = PopupElems_Min(e->dsc, r.fnt->minY);
			Display_GetChar(r.fnt->raster, ch, &dx, &x, &y, &w, &h, &p);
			width += dx;
		}
		oldCh = ch;
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (oldCh == 0x0d) {
		e->n -= 1;
	}
	if ((oldCh == 0x00 || e->n == 0) || e->width + width == 0) {
		PopupElems_DefaultMenu(e);
		PopupElems_PrepareMenu(e);
	} else {
		e->width = PopupElems_Max(e->width, width);
		e->default_ = PopupElems_Min(e->default_, e->n - 1);
	}
}

static void PopupElems_HandleEdit (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	PopupElems_EditFrame f1 = NIL;
	TextFrames_Handle(f, &*msg, msg__typ);
	if (__ISP(f, PopupElems_EditFrameDesc, 2)) {
		if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
			__NEW(f1, PopupElems_EditFrameDesc);
			TextFrames_Open((void*)f1, (*(PopupElems_EditFrame*)&f)->text, (*(PopupElems_EditFrame*)&f)->org);
			f1->handle = (*(PopupElems_EditFrame*)&f)->handle;
			f1->elem = (*(PopupElems_EditFrame*)&f)->elem;
			__GUARDR(msg, Oberon_CopyMsg, 1).F = (Display_Frame)f1;
		}
	} else __WITHCHK;
}

static void PopupElems_OpenEditor (PopupElems_Elem e)
{
	MenuViewers_Viewer v = NIL;
	PopupElems_EditFrame f = NIL;
	INTEGER x = 0, y = 0, i = 0;
	CHAR name[34];
	name[0] = '\"';
	i = 0;
	while (e->name[__X(i, 32)] != 0x00) {
		name[__X(i + 1, 34)] = e->name[__X(i, 32)];
		i += 1;
	}
	name[__X(i + 1, 34)] = '\"';
	name[__X(i + 2, 34)] = 0x00;
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	__NEW(f, PopupElems_EditFrameDesc);
	f->elem = e;
	TextFrames_Open((void*)f, PopupElems_CopyText(e->menu), 0);
	f->handle = PopupElems_HandleEdit;
	v = MenuViewers_New((void*)TextFrames_NewMenu(name, 34, (CHAR*)"System.Close  Edit.Search  Edit.Replace  PopupElems.Toggle  PopupElems.Update ", (LONGINT)79), (void*)f, TextFrames_menuH, x, y);
}

static void PopupElems_Load (Files_Rider *r, LONGINT *r__typ, PopupElems_Elem e)
{
	CHAR ch = 0;
	LONGINT val = 0;
	Files_Read(&*r, r__typ, (void*)&ch);
	if (ch == 0x01) {
		Files_ReadString(&*r, r__typ, (void*)e->name, 32);
		Files_ReadNum(&*r, r__typ, &val);
		e->default_ = 0;
		Files_ReadSet(&*r, r__typ, &e->options);
		e->options = e->options & 0x03;
		e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Load(&*r, r__typ, e->menu);
	} else {
		Files_Set(&*r, r__typ, Files_Base(&*r, r__typ), Files_Pos(&*r, r__typ) - 1);
		Files_ReadString(&*r, r__typ, (void*)e->name, 32);
		Files_Read(&*r, r__typ, (void*)&ch);
		if (ch >= 0x80) {
			e->options = 0x03;
		} else {
			e->options = 0x0;
		}
		e->default_ = 0;
		e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Load(&*r, r__typ, e->menu);
	}
}

static void PopupElems_Store (Files_Rider *r, LONGINT *r__typ, PopupElems_Elem e)
{
	Files_Write(&*r, r__typ, 0x01);
	Files_WriteString(&*r, r__typ, e->name, 32);
	Files_WriteNum(&*r, r__typ, 0);
	Files_WriteSet(&*r, r__typ, e->options);
	Texts_Store(&*r, r__typ, e->menu);
}

static void PopupElems_Box (INTEGER col, INTEGER bkgnd, INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	Display_ReplConst(col, X + 1, Y + 1, W - 2, 1, 0);
	Display_ReplConst(col, X + 1, (Y + H) - 2, W - 2, 1, 0);
	Display_ReplConst(col, X + 1, Y + 2, 1, H - 4, 0);
	Display_ReplConst(col, (X + W) - 2, Y + 2, 1, H - 4, 0);
	Display_ReplConst(col, X + 4, Y, W - 4, 1, 0);
	Display_ReplConst(col, (X + W) - 1, Y + 1, 1, H - 4, 0);
	Display_ReplConst(bkgnd, X + 2, Y + 2, W - 4, H - 4, 0);
}

static void PopupElems_Underline (Display_Frame f, INTEGER col, INTEGER X, INTEGER Y, INTEGER W)
{
	Display_ReplPatternC(f, 15, Display_grey1, X, Y, W, 1, X, Y, 2);
}

static void PopupElems_DrawElem (PopupElems_Elem e, Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER col, INTEGER X, INTEGER Y)
{
	LONGINT beg = 0;
	TextFrames_Parc parc = NIL;
	INTEGER bkgndCol = 0;
	if (__ISP(f, TextFrames_FrameDesc, 1)) {
		bkgndCol = __GUARDP(f, TextFrames_FrameDesc, 1)->col;
	} else {
		bkgndCol = 0;
	}
	if (__IN(0, e->options)) {
		TextFrames_ParcBefore(Texts_ElemBase((void*)e), pos, &parc, &beg);
		Y += (int)__DIV(parc->dsr, (LONGINT)PopupElems_DUnit);
		if (bkgndCol == col) {
			col = __ABS(15 - col);
		}
	} else {
		PopupElems_Box(col, bkgndCol, X, Y, (int)__DIV(e->W - 1, (LONGINT)PopupElems_DUnit), (int)__DIV(e->H, (LONGINT)PopupElems_DUnit));
		X += 6;
		Y += 4 - fnt->minY;
	}
	PopupElems_DispStr(fnt, e->name, 32, col, X, Y);
	if ((e->options & 0x03) == 0x03) {
		PopupElems_Underline(f, col, X, Y - 2, (int)__DIV(e->W, (LONGINT)PopupElems_DUnit));
	}
}

static void PopupElems_PrintElem (PopupElems_Elem e, Fonts_Font fnt, INTEGER X, INTEGER Y)
{
	INTEGER W = 0, H = 0;
	W = (int)__DIV(e->W - 1, 3048);
	H = (int)__DIV(e->H, 3048);
	if (__IN(0, e->options)) {
		Printer_String(X, Y, (void*)e->name, 32, (void*)fnt->name, 32);
		if (__IN(1, e->options)) {
			Printer_ReplConst(X, Y - 2, W, 1);
		}
	} else {
		Printer_ReplConst(X + 1, Y + 1, W - 2, 1);
		Printer_ReplConst(X + 1, (Y + H) - 2, W - 2, 1);
		Printer_ReplConst(X + 1, Y + 2, 1, H - 4);
		Printer_ReplConst((X + W) - 2, Y + 2, 1, H - 4);
		Printer_ReplConst(X + 4, Y, W - 4, 1);
		Printer_ReplConst((X + W) - 1, Y + 1, 1, H - 4);
		Printer_String(X + __DIV(6 * PopupElems_DUnit, 3048), Y + (int)__DIV((LONGINT)(4 - fnt->minY) * (LONGINT)PopupElems_DUnit, 3048), (void*)e->name, 32, (void*)fnt->name, 32);
	}
}

static void PopupElems_DrawMenu (PopupElems_Elem e, INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	INTEGER X0 = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	LONGINT p = 0;
	PopupElems_Box(15, 0, X, Y, W, H);
	X0 = (X + 3) + 2;
	X = X0;
	Y = ((((Y + H) - e->lsp) - e->dsc) - 1) - 2;
	Texts_OpenReader(&r, Texts_Reader__typ, e->menu, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot) {
		if (ch == 0x0d) {
			Y = Y - e->lsp;
			X = X0;
		} else {
			Display_GetChar(r.fnt->raster, ch, &dx, &x, &y, &w, &h, &p);
			Display_CopyPattern(r.col, p, X + x, Y + y, 1);
			X += dx;
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
}

static struct Show__27 {
	PopupElems_Elem *e;
	INTEGER *eX, *eY, *eW, *top, *left, *right;
	struct Show__27 *lnk;
} *Show__27_s;

static void Flip__28 (INTEGER cmd);
static void FlipLine__30 (void);

static void FlipLine__30 (void)
{
	Display_ReplConst(15, *Show__27_s->eX, *Show__27_s->eY, *Show__27_s->eW, 2, 2);
}

static void Flip__28 (INTEGER cmd)
{
	if (cmd >= 0) {
		Display_ReplConst(15, *Show__27_s->left, *Show__27_s->top - (cmd + 1) * (*Show__27_s->e)->lsp, *Show__27_s->right - *Show__27_s->left, (*Show__27_s->e)->lsp, 2);
	}
}

static void PopupElems_Show (Display_Frame f, PopupElems_Elem e, LONGINT pos, INTEGER X, INTEGER Y, INTEGER *cmd, SET *keySum)
{
	INTEGER eX = 0, eY = 0, eW = 0, eH = 0, W = 0, H = 0, w = 0, newY = 0, mx = 0, my = 0, top = 0, bot = 0, left = 0, right = 0, newCmd = 0;
	SET keys = 0;
	TextFrames_Parc parc = NIL;
	LONGINT beg = 0;
	BOOLEAN default_ = 0;
	struct Show__27 _s;
	_s.e = &e;
	_s.eX = &eX;
	_s.eY = &eY;
	_s.eW = &eW;
	_s.top = &top;
	_s.left = &left;
	_s.right = &right;
	_s.lnk = Show__27_s;
	Show__27_s = &_s;
	eX = X;
	eY = Y;
	eW = (int)__DIV(e->W, (LONGINT)PopupElems_DUnit);
	eH = (int)__DIV(e->H, (LONGINT)PopupElems_DUnit);
	if (__IN(0, e->options) && e->n == 1) {
		TextFrames_ParcBefore(Texts_ElemBase((void*)e), pos, &parc, &beg);
		newY = eY + (int)__DIV(parc->dsr, (LONGINT)PopupElems_DUnit);
		if (__IN(1, e->options)) {
			PopupElems_Underline(f, 15, eX, newY - 2, eW);
		}
		FlipLine__30();
		newCmd = *cmd;
		do {
			Input_Mouse(&keys, &mx, &my);
			*keySum = *keySum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
			if ((((*keySum == 0x07 || mx < eX) || mx >= eX + eW) || my < eY) || my >= eY + eH) {
				newCmd = -1;
			} else if ((((*cmd == -1 && eX <= mx) && mx < eX + eW) && eY <= my) && my < eY + eH) {
				newCmd = e->default_;
			}
			if (newCmd != *cmd) {
				FlipLine__30();
				*cmd = newCmd;
			}
		} while (!(keys == 0x0));
		if (*cmd != -1) {
			FlipLine__30();
		}
		if (__IN(1, e->options)) {
			PopupElems_Underline(f, 15, eX, newY - 2, eW);
		}
	} else {
		Input_Mouse(&keys, &mx, &my);
		W = (e->width + 6) + 4;
		H = (e->n * e->lsp + 2) + 4;
		if (W > Oberon_DisplayWidth(X) || H > Oberon_DisplayHeight(X)) {
			PopupElems_Str((CHAR*)"PopupElem too big!", (LONGINT)19);
			PopupElems_Ln();
			Texts_Append(Oberon_Log, PopupElems_wr.buf);
			do {
				Input_Mouse(&keys, &mx, &my);
				*keySum = *keySum | keys;
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
			} while (!(keys == 0x0));
			if (*keySum == 0x03) {
				keys = *keySum;
			} else {
				keys = 0x07;
			}
			*cmd = -1;
		} else {
			w = Oberon_DisplayWidth(X);
			left = Display_Left;
			X = PopupElems_Min(w - W, PopupElems_Max(mx - __ASHR(W, 1), left));
			newY = my - ((e->n - *cmd) * e->lsp - __ASHR(e->lsp, 1));
			if (newY >= Display_Bottom && newY + H <= Oberon_DisplayHeight(X)) {
				Y = newY;
				default_ = 0;
			} else {
				if (Y - H > Display_Bottom) {
					Y = Y - H;
				} else {
					Y = Y + eH;
				}
				if (Y + H > Oberon_DisplayHeight(X)) {
					Y = Display_Bottom;
				}
				default_ = 1;
			}
			left = X + 3;
			right = (X + W) - 3;
			bot = (Y + 1) + 3;
			top = ((Y + H) - 1) - 2;
			Oberon_RemoveMarks(X, Y, W, H);
			Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
			PopupElems_Save(X, Y, W, H);
			PopupElems_DrawMenu(e, X, Y, W, H);
			Flip__28(*cmd);
			*keySum = 0x0;
			do {
				Input_Mouse(&keys, &mx, &my);
				*keySum = *keySum | keys;
				Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
				if (*keySum == 0x07) {
					*cmd = -1;
				} else if (((mx >= left && mx <= right) && my >= bot) && my <= top) {
					newCmd = __DIV(top - my, e->lsp);
					if (newCmd != *cmd) {
						default_ = 0;
						Flip__28(*cmd);
						Flip__28(newCmd);
						*cmd = newCmd;
					}
				} else if (default_) {
					if (((eX <= mx && mx < eX + eW) && eY <= my) && my < eY + eH) {
						if (*cmd != e->default_) {
							*cmd = e->default_;
							Flip__28(*cmd);
						}
					} else {
						Flip__28(*cmd);
						*cmd = -1;
					}
				} else if (!default_) {
					Flip__28(*cmd);
					*cmd = -1;
				}
			} while (!(keys == 0x0));
			Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
			PopupElems_Restore(X, Y, W, H);
		}
	}
	Show__27_s = _s.lnk;
}

static void PopupElems_Popup (PopupElems_Elem e, TextFrames_TrackMsg msg)
{
	INTEGER cmd = 0, res = 0;
	Texts_Scanner s = {0};
	Texts_Reader r = {0};
	CHAR ch = 0;
	SET keys = 0;
	Oberon_ParList par = NIL;
	keys = msg.keys;
	cmd = e->default_;
	PopupElems_Show(msg.frame, e, msg.pos, msg.X0, msg.Y0, &cmd, &keys);
	if (keys == 0x03) {
		PopupElems_OpenEditor(e);
	} else if (keys != 0x07 && cmd > -1) {
		e->default_ = cmd;
		Texts_OpenReader(&r, Texts_Reader__typ, e->menu, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		while (cmd > 0) {
			if (ch == 0x0d) {
				cmd -= 1;
			}
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		Texts_OpenScanner(&s, Texts_Scanner__typ, e->menu, Texts_Pos(&r, Texts_Reader__typ) - 1);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1 && s.line == 0) {
			__NEW(par, Oberon_ParRec);
			par->frame = msg.frame;
			if ((__IN(0, e->options) && e->n == 1) && s.eot) {
				par->text = Texts_ElemBase((void*)e);
				par->pos = msg.pos + 1;
			} else {
				par->text = e->menu;
				par->pos = Texts_Pos((void*)&s, Texts_Scanner__typ) - 1;
			}
			Oberon_Call(s.s, 256, par, __IN(2, keys), &res);
			if (res != 0) {
				PopupElems_ErrorMsg(s.s, 256, res);
			}
		}
	}
}

static void PopupElems_ExecCmd (PopupElems_Elem E, Display_Frame F, LONGINT pos, SET keys)
{
	Texts_Scanner s = {0};
	Oberon_ParList par = NIL;
	INTEGER res = 0, i = 0, j = 0;
	CHAR ch = 0;
	TextFrames_TrackMsg m = {0};
	Texts_OpenReader((void*)&s, Texts_Scanner__typ, E->menu, pos);
	Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
	while ((!s.eot && ch != 0x0d) && s.elem == NIL) {
		Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
	}
	Texts_OpenScanner(&s, Texts_Scanner__typ, E->menu, pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 1 && s.line == 0) {
		i = 0;
		while (i < s.len && s.s[__X(i, 256)] != '.') {
			i += 1;
		}
		j = i + 1;
		while (j < s.len && s.s[__X(j, 256)] != '.') {
			j += 1;
		}
		if (j >= s.len && s.s[__X(i, 256)] == '.') {
			__NEW(par, Oberon_ParRec);
			par->frame = F;
			par->vwr = Viewers_This(F->X, F->Y);
			par->text = E->menu;
			par->pos = Texts_Pos((void*)&s, Texts_Scanner__typ) - 1;
			Oberon_Call(s.s, 256, par, __IN(2, keys), &res);
			if (res > 0) {
				Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)"Call error: ", (LONGINT)13);
				Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, Modules_importing, 20);
				if (res == 1 || res == 5) {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
				} else if (res == 2) {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" not an obj-file", (LONGINT)17);
				} else if (res == 3) {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" imports ", (LONGINT)10);
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, Modules_imported, 20);
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" with bad key", (LONGINT)14);
				} else if (res == 4) {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" not enough memory", (LONGINT)19);
				} else if (res == 5) {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" module not found", (LONGINT)18);
				} else if (res == 6) {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" command not found", (LONGINT)19);
				} else {
					Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" res = ", (LONGINT)8);
					Texts_WriteInt(&PopupElems_wr, Texts_Writer__typ, res, 0);
				}
			} else if (res < 0) {
				i += 1;
				while (i < s.len) {
					Texts_Write(&PopupElems_wr, Texts_Writer__typ, s.s[__X(i, 256)]);
					i += 1;
				}
				Texts_WriteString(&PopupElems_wr, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
			}
			if (res != 0) {
				Texts_WriteLn(&PopupElems_wr, Texts_Writer__typ);
				Texts_Append(Oberon_Log, PopupElems_wr.buf);
			}
		}
	} else if ((s.class == 6 && s.c == 0x1c) && s.line == 0) {
		Texts_OpenReader((void*)&s, Texts_Scanner__typ, E->menu, pos);
		Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
		if (!__ISP(s.elem, PopupElems_ElemDesc, 2)) {
			m.frame = NIL;
			m.keys = 0x02;
			(*s.elem->handle)(s.elem, (void*)&m, TextFrames_TrackMsg__typ);
		}
	}
}

void PopupElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	PopupElems_Elem copy = NIL;
	if (__ISP(e, PopupElems_ElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					PopupElems_PrepareDraw((*(PopupElems_Elem*)&e), (*msg__).fnt, &(*msg__).Y0);
				} else {
					PopupElems_DrawElem((*(PopupElems_Elem*)&e), (*msg__).frame, (*msg__).pos, (*msg__).fnt, (*msg__).col, (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				if (!(*msg__).prepare) {
					PopupElems_PrintElem((*(PopupElems_Elem*)&e), (*msg__).fnt, (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			if (__IS(msg__typ, Texts_CopyMsg, 1)) {
				Texts_CopyMsg *msg__ = (void*)msg;
				__NEW(copy, PopupElems_ElemDesc);
				Texts_CopyElem((void*)(*(PopupElems_Elem*)&e), (void*)copy);
				__MOVE((*(PopupElems_Elem*)&e)->name, copy->name, 32);
				copy->menu = PopupElems_CopyText((*(PopupElems_Elem*)&e)->menu);
				copy->n = (*(PopupElems_Elem*)&e)->n;
				copy->default_ = (*(PopupElems_Elem*)&e)->default_;
				copy->width = (*(PopupElems_Elem*)&e)->width;
				copy->lsp = (*(PopupElems_Elem*)&e)->lsp;
				copy->dsc = (*(PopupElems_Elem*)&e)->dsc;
				copy->options = (*(PopupElems_Elem*)&e)->options;
				(*msg__).e = (Texts_Elem)copy;
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("PopupElems", (*msg__).mod, 11);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					PopupElems_Load(&(*msg__).r, Files_Rider__typ, (*(PopupElems_Elem*)&e));
					PopupElems_PrepareMenu((*(PopupElems_Elem*)&e));
				} else if ((*msg__).id == 1) {
					PopupElems_Store(&(*msg__).r, Files_Rider__typ, (*(PopupElems_Elem*)&e));
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				PopupElems_Popup((*(PopupElems_Elem*)&e), *msg__);
			} else __WITHCHK;
		} else if (__IS(msg__typ, PopupElems_ExecMsg, 1)) {
			if (__IS(msg__typ, PopupElems_ExecMsg, 1)) {
				PopupElems_ExecMsg *msg__ = (void*)msg;
				PopupElems_ExecCmd((*(PopupElems_Elem*)&e), (*msg__).frame, (*msg__).pos, (*msg__).keys);
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void PopupElems_Alloc (void)
{
	PopupElems_Elem e = NIL;
	__NEW(e, PopupElems_ElemDesc);
	e->handle = PopupElems_Handle;
	Texts_new = (Texts_Elem)e;
}

static void PopupElems_insert (SET options)
{
	PopupElems_Elem e = NIL;
	TextFrames_InsertElemMsg ins = {0};
	__NEW(e, PopupElems_ElemDesc);
	PopupElems_GetName(e, Oberon_Par->text, Oberon_Par->pos);
	e->options = options;
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	PopupElems_DefaultMenu(e);
	PopupElems_PrepareMenu(e);
	e->handle = PopupElems_Handle;
	ins.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&ins, TextFrames_InsertElemMsg__typ);
}

void PopupElems_Insert (void)
{
	PopupElems_insert(0x02);
}

void PopupElems_InsertMenu (void)
{
	PopupElems_insert(0x03);
}

static struct Toggle__35 {
	struct Toggle__35 *lnk;
} *Toggle__35_s;

static void Change__36 (PopupElems_Elem e, INTEGER opt);
static void Translate__38 (CHAR *str, LONGINT str__len, INTEGER *val);

static void Translate__38 (CHAR *str, LONGINT str__len, INTEGER *val)
{
	__DUP(str, str__len, CHAR);
	if (__STRCMP(str, "Menu") == 0) {
		*val = 0;
	} else if (__STRCMP(str, "Line") == 0) {
		*val = 1;
	} else {
		*val = -1;
	}
	__DEL(str);
}

static void Change__36 (PopupElems_Elem e, INTEGER opt)
{
	Texts_Text text = NIL;
	e->options = e->options ^ __SETOF(opt);
	text = Texts_ElemBase((void*)e);
	if (text != NIL) {
		(*text->notify)(text, 0, Texts_ElemPos((void*)e), Texts_ElemPos((void*)e) + 1);
	}
}

void PopupElems_Toggle (void)
{
	TextFrames_Frame f = NIL;
	Texts_Scanner s = {0};
	Texts_Reader r = {0};
	Texts_Text t = NIL;
	INTEGER flag = 0;
	LONGINT beg = 0, end = 0, time = 0;
	struct Toggle__35 _s;
	_s.lnk = Toggle__35_s;
	Toggle__35_s = &_s;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		f = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1);
		if (f->hasSel) {
			Texts_OpenScanner(&s, Texts_Scanner__typ, f->text, f->selbeg.pos);
		} else {
			Texts_OpenScanner(&s, Texts_Scanner__typ, f->text, Oberon_Par->pos);
		}
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1) {
			Translate__38(s.s, 256, &flag);
			if (flag != -1) {
				Change__36(__GUARDP(f->next, PopupElems_EditFrameDesc, 2)->elem, flag);
			}
		}
	} else {
		Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 1) {
			Oberon_GetSelection(&t, &beg, &end, &time);
			if (time >= 0) {
				Translate__38(s.s, 256, &flag);
				if (flag != -1) {
					Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
					Texts_ReadElem(&r, Texts_Reader__typ);
					while (Texts_Pos(&r, Texts_Reader__typ) <= end && r.elem != NIL) {
						if (__ISP(r.elem, PopupElems_ElemDesc, 2)) {
							Change__36(__GUARDP(r.elem, PopupElems_ElemDesc, 2), flag);
						}
						Texts_ReadElem(&r, Texts_Reader__typ);
					}
				}
			}
		}
	}
	Toggle__35_s = _s.lnk;
}

void PopupElems_Update (void)
{
	PopupElems_EditFrame f = NIL;
	PopupElems_Elem e = NIL;
	Texts_Scanner s = {0};
	Texts_Text menuText = NIL, text = NIL;
	LONGINT pos = 0;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		f = __GUARDP(Oberon_Par->frame->next, PopupElems_EditFrameDesc, 2);
		e = f->elem;
		menuText = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
		PopupElems_GetName(e, menuText, 0);
		Texts_OpenScanner(&s, Texts_Scanner__typ, menuText, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (!__IN(s.class, 0x06) || s.s[0] == 0x00) {
			__MOVE("Popup", s.s, 6);
		}
		__COPY(s.s, e->name, 32);
		e->menu = PopupElems_CopyText(f->text);
		PopupElems_PrepareMenu(e);
		text = Texts_ElemBase((void*)e);
		if (text != NIL) {
			pos = Texts_ElemPos((void*)e);
			(*text->notify)(text, 0, pos, pos + 1);
			Texts_OpenReader((void*)&s, Texts_Scanner__typ, menuText, menuText->len - 1);
			Texts_Read((void*)&s, Texts_Scanner__typ, &s.c);
			if (s.c == '!') {
				Texts_Delete(menuText, menuText->len - 1, menuText->len);
			}
		}
	}
}

void PopupElems_MeasureMenu (PopupElems_Elem E)
{
	PopupElems_PrepareMenu(E);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&PopupElems_wr, Texts_Writer__typ, 36, 1, P);
	P(PopupElems_buf);
}

__TDESC(PopupElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 88), {0, 4, 12, 32, 68, -24}};
__TDESC(PopupElems_EditFrameDesc, 1, 9) = {__TDFLDS("EditFrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};
__TDESC(PopupElems_ExecMsg, 1, 1) = {__TDFLDS("ExecMsg", 12), {0, -8}};

export void *PopupElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(PopupElems, EnumPtrs);
	__REGCMD("Alloc", PopupElems_Alloc);
	__REGCMD("Insert", PopupElems_Insert);
	__REGCMD("InsertMenu", PopupElems_InsertMenu);
	__REGCMD("Toggle", PopupElems_Toggle);
	__REGCMD("Update", PopupElems_Update);
	__INITYP(PopupElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(PopupElems_EditFrameDesc, TextFrames_FrameDesc, 2);
	__INITYP(PopupElems_ExecMsg, Texts_ElemMsg, 1);
/* BEGIN */
	PopupElems_DUnit = TextFrames_Unit;
	__NEW(PopupElems_buf, Texts_BufDesc);
	Texts_OpenBuf(PopupElems_buf);
	Texts_OpenWriter(&PopupElems_wr, Texts_Writer__typ);
	__ENDMOD;
}
