/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Files.h"
#include "Kernel.h"
#include "Unix.h"

typedef
	CHAR Printer_Name[32];

typedef
	struct Printer_FontDesc {
		Printer_Name name;
		SET used[8];
	} Printer_FontDesc;

typedef
	struct Printer_Poly {
		REAL a, b, c, d, t;
	} Printer_Poly;

typedef
	Printer_Poly Printer_PolyVector[20];

typedef
	REAL Printer_RealVector[20];


export INTEGER Printer_res, Printer_PageWidth, Printer_PageHeight;
static Printer_FontDesc Printer_fontTable[64];
static INTEGER Printer_fontIndex, Printer_curFont;
static Printer_Name Printer_PrinterName, Printer_listFont;
static Files_File Printer_headerF, Printer_bodyF;
static Files_Rider Printer_bodyR;
static LONGINT Printer_pno, Printer_ppos;
static CHAR Printer_hexArray[17];
static INTEGER Printer_curR, Printer_curG, Printer_curB;
static CHAR Printer_PrintMode[3];
static INTEGER Printer_PrintCopies;

export LONGINT *Printer_FontDesc__typ;
export LONGINT *Printer_Poly__typ;
static LONGINT *RunRec__30__typ;
static LONGINT *Metrics__27__typ;

static void Printer_Append (CHAR *s1, LONGINT s1__len, CHAR *s2, LONGINT s2__len);
static void Printer_Ch (Files_Rider *R, LONGINT *R__typ, CHAR ch);
export void Printer_Circle (INTEGER x0, INTEGER y0, INTEGER r);
export void Printer_Close (void);
static void Printer_ClosedSpline (Printer_RealVector x, Printer_RealVector y, Printer_RealVector d, INTEGER n);
export void Printer_ContString (CHAR *s, LONGINT s__len, CHAR *fname, LONGINT fname__len);
static void Printer_DefineFont (Files_Rider *fontR, LONGINT *fontR__typ, Printer_FontDesc fd);
export void Printer_Ellipse (INTEGER x0, INTEGER y0, INTEGER a, INTEGER b);
static void Printer_Error (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len);
static void Printer_Hex (Files_Rider *R, LONGINT *R__typ, INTEGER i);
static void Printer_Hex2 (Files_Rider *R, LONGINT *R__typ, CHAR ch);
static void Printer_Int (Files_Rider *R, LONGINT *R__typ, LONGINT i);
export void Printer_Line (INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1);
static void Printer_Ln (Files_Rider *R, LONGINT *R__typ);
export void Printer_Open (CHAR *name, LONGINT name__len, CHAR *user, LONGINT user__len, LONGINT password);
static void Printer_OpenSpline (Printer_RealVector x, Printer_RealVector y, Printer_RealVector d, INTEGER n);
export void Printer_Page (INTEGER nofcopies);
export void Printer_Picture (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode, LONGINT adr);
static void Printer_PrintPoly (Printer_Poly *p, LONGINT *p__typ, Printer_Poly *q, LONGINT *q__typ, REAL lim);
export void Printer_ReplConst (INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void Printer_ReplPattern (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col);
static void Printer_SetBitmapFont (Files_Rider *fontR, LONGINT *fontR__typ, Files_Rider *R, LONGINT *R__typ, Printer_FontDesc fd, INTEGER pRes);
static void Printer_SetMappedFont (Files_Rider *fontR, LONGINT *fontR__typ, CHAR *fname, LONGINT fname__len);
static void Printer_SolveTriDiag (Printer_RealVector a, Printer_RealVector b, Printer_RealVector c, Printer_RealVector y, INTEGER n);
export void Printer_Spline (INTEGER x0, INTEGER y0, INTEGER n, INTEGER open, INTEGER *X, LONGINT X__len, INTEGER *Y, LONGINT Y__len);
static void Printer_Str (Files_Rider *R, LONGINT *R__typ, CHAR *s, LONGINT s__len);
export void Printer_String (INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, CHAR *fname, LONGINT fname__len);
export void Printer_UseColor (INTEGER red, INTEGER green, INTEGER blue);
export void Printer_UseListFont (CHAR *name, LONGINT name__len);

#define Printer_system(cmd, cmd__len)	system(cmd)

static void Printer_Ch (Files_Rider *R, LONGINT *R__typ, CHAR ch)
{
	Files_Write(&*R, R__typ, ch);
}

static void Printer_Str (Files_Rider *R, LONGINT *R__typ, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		Printer_Ch(&*R, R__typ, s[__X(i, s__len)]);
		i += 1;
	}
	__DEL(s);
}

static void Printer_Int (Files_Rider *R, LONGINT *R__typ, LONGINT i)
{
	LONGINT j = 0;
	if (i == 0) {
		Printer_Ch(&*R, R__typ, '0');
	} else if (i < 0) {
		i = -i;
		Printer_Ch(&*R, R__typ, '-');
	}
	j = 1;
	while (__DIV(i, j) != 0) {
		j = j * 10;
	}
	while (j >= 10) {
		j = __DIV(j, 10);
		Printer_Ch(&*R, R__typ, (CHAR)(48 + __MOD(__DIV(i, j), 10)));
	}
}

static void Printer_Hex (Files_Rider *R, LONGINT *R__typ, INTEGER i)
{
	if (i < 10) {
		Printer_Ch(&*R, R__typ, (CHAR)(i + 48));
	} else {
		Printer_Ch(&*R, R__typ, (CHAR)(i + 87));
	}
}

static void Printer_Hex2 (Files_Rider *R, LONGINT *R__typ, CHAR ch)
{
	Printer_Ch(&*R, R__typ, Printer_hexArray[__X(__ASHR((int)ch, 4), 17)]);
	Printer_Ch(&*R, R__typ, Printer_hexArray[__X(__MASK((int)ch, -16), 17)]);
}

static void Printer_Ln (Files_Rider *R, LONGINT *R__typ)
{
	Printer_Ch(&*R, R__typ, 0x0a);
}

static void Printer_Error (CHAR *s0, LONGINT s0__len, CHAR *s1, LONGINT s1__len)
{
	CHAR error[32], f[32];
	__DUP(s0, s0__len, CHAR);
	__DUP(s1, s1__len, CHAR);
	__COPY(s0, error, 32);
	__COPY(s1, f, 32);
	__HALT(99);
	__DEL(s0);
	__DEL(s1);
}

static void Printer_SetMappedFont (Files_Rider *fontR, LONGINT *fontR__typ, CHAR *fname, LONGINT fname__len)
{
	CHAR family[7];
	__DUP(fname, fname__len, CHAR);
	__COPY(fname, family, 7);
	Printer_Ch(&*fontR, fontR__typ, '/');
	Printer_Str(&*fontR, fontR__typ, fname, fname__len);
	if (__STRCMP(family, "Syntax") == 0) {
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" DefineSMapFont", (LONGINT)16);
	} else {
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" DefineMapFont", (LONGINT)15);
	}
	Printer_Ln(&*fontR, fontR__typ);
	Printer_Ln(&*fontR, fontR__typ);
	__DEL(fname);
}

typedef
	struct Metrics__27 {
		INTEGER dx, x, y, w, h;
	} Metrics__27;

typedef
	struct RunRec__30 {
		INTEGER beg, end;
	} RunRec__30;

static struct SetBitmapFont__24 {
	Files_Rider *fontR;
	LONGINT *fontR__typ;
	struct SetBitmapFont__24 *lnk;
} *SetBitmapFont__24_s;

static CHAR Flip__25 (CHAR ch);
static void Name__28 (INTEGER m);

static CHAR Flip__25 (CHAR ch)
{
	INTEGER i = 0, s = 0, d = 0;
	i = 0;
	s = (int)ch;
	d = 0;
	while (i < 8) {
		if (__MASK(s, -2) == 1) {
			d = __ASHL(d, 1) + 1;
		} else {
			d = __ASHL(d, 1);
		}
		s = __ASHR(s, 1);
		i += 1;
	}
	return (CHAR)d;
}

static void Name__28 (INTEGER m)
{
	switch (m) {
		case 9: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"tab", (LONGINT)4);
			break;
		case 32: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"space", (LONGINT)6);
			break;
		case 33: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"exclam", (LONGINT)7);
			break;
		case 34: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"quotedbl", (LONGINT)9);
			break;
		case 35: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"numbersign", (LONGINT)11);
			break;
		case 36: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"dollar", (LONGINT)7);
			break;
		case 37: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"percent", (LONGINT)8);
			break;
		case 38: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ampersand", (LONGINT)10);
			break;
		case 39: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"quotesingle", (LONGINT)12);
			break;
		case 40: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"parenleft", (LONGINT)10);
			break;
		case 41: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"parenright", (LONGINT)11);
			break;
		case 42: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"asterisk", (LONGINT)9);
			break;
		case 43: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"plus", (LONGINT)5);
			break;
		case 44: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"comma", (LONGINT)6);
			break;
		case 45: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"minus", (LONGINT)6);
			break;
		case 46: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"period", (LONGINT)7);
			break;
		case 47: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"slash", (LONGINT)6);
			break;
		case 48: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"zero", (LONGINT)5);
			break;
		case 49: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"one", (LONGINT)4);
			break;
		case 50: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"two", (LONGINT)4);
			break;
		case 51: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"three", (LONGINT)6);
			break;
		case 52: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"four", (LONGINT)5);
			break;
		case 53: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"five", (LONGINT)5);
			break;
		case 54: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"six", (LONGINT)4);
			break;
		case 55: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"seven", (LONGINT)6);
			break;
		case 56: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"eight", (LONGINT)6);
			break;
		case 57: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"nine", (LONGINT)5);
			break;
		case 58: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"colon", (LONGINT)6);
			break;
		case 59: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"semicolon", (LONGINT)10);
			break;
		case 60: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"less", (LONGINT)5);
			break;
		case 61: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"equal", (LONGINT)6);
			break;
		case 62: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"greater", (LONGINT)8);
			break;
		case 63: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"question", (LONGINT)9);
			break;
		case 64: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"at", (LONGINT)3);
			break;
		case 65: case 66: case 67: case 68: case 69: 
		case 70: case 71: case 72: case 73: case 74: 
		case 75: case 76: case 77: case 78: case 79: 
		case 80: case 81: case 82: case 83: case 84: 
		case 85: case 86: case 87: case 88: case 89: 
		case 90: 
			Printer_Ch(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR)m);
			break;
		case 91: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"bracketleft", (LONGINT)12);
			break;
		case 92: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"backslash", (LONGINT)10);
			break;
		case 93: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"bracketright", (LONGINT)13);
			break;
		case 94: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"arrowup", (LONGINT)8);
			break;
		case 95: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"underscore", (LONGINT)11);
			break;
		case 96: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"grave", (LONGINT)6);
			break;
		case 97: case 98: case 99: case 100: case 101: 
		case 102: case 103: case 104: case 105: case 106: 
		case 107: case 108: case 109: case 110: case 111: 
		case 112: case 113: case 114: case 115: case 116: 
		case 117: case 118: case 119: case 120: case 121: 
		case 122: 
			Printer_Ch(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR)m);
			break;
		case 123: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"braceleft", (LONGINT)10);
			break;
		case 124: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"bar", (LONGINT)4);
			break;
		case 125: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"braceright", (LONGINT)11);
			break;
		case 126: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"tilde", (LONGINT)6);
			break;
		case 128: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"Adieresis", (LONGINT)10);
			break;
		case 129: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"Odieresis", (LONGINT)10);
			break;
		case 130: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"Udieresis", (LONGINT)10);
			break;
		case 131: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"adieresis", (LONGINT)10);
			break;
		case 132: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"odieresis", (LONGINT)10);
			break;
		case 133: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"udieresis", (LONGINT)10);
			break;
		case 134: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"acircumflex", (LONGINT)12);
			break;
		case 135: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ecircumflex", (LONGINT)12);
			break;
		case 136: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"icircumflex", (LONGINT)12);
			break;
		case 137: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"oicircumflex", (LONGINT)13);
			break;
		case 138: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"uicircumflex", (LONGINT)13);
			break;
		case 139: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"agrave", (LONGINT)7);
			break;
		case 140: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"egrave", (LONGINT)7);
			break;
		case 141: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"igrave", (LONGINT)7);
			break;
		case 142: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ograve", (LONGINT)7);
			break;
		case 143: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ugrave", (LONGINT)7);
			break;
		case 144: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"eacute", (LONGINT)7);
			break;
		case 145: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"edieresis", (LONGINT)10);
			break;
		case 146: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"idieresis", (LONGINT)10);
			break;
		case 147: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ccedilla", (LONGINT)9);
			break;
		case 148: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"aacute", (LONGINT)7);
			break;
		case 149: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ntilde", (LONGINT)7);
			break;
		case 155: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"endash", (LONGINT)7);
			break;
		case 159: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"hyphen", (LONGINT)7);
			break;
		case 171: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"germandbls", (LONGINT)11);
			break;
		default: 
			Printer_Str(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR*)"ascii", (LONGINT)6);
			Printer_Ch(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR)(48 + (int)__MOD(__DIV(m, 100), 10)));
			Printer_Ch(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR)(48 + (int)__MOD(__DIV(m, 10), 10)));
			Printer_Ch(&*SetBitmapFont__24_s->fontR, SetBitmapFont__24_s->fontR__typ, (CHAR)(48 + (int)__MOD(m, 10)));
			break;
	}
}

static void Printer_SetBitmapFont (Files_Rider *fontR, LONGINT *fontR__typ, Files_Rider *R, LONGINT *R__typ, Printer_FontDesc fd, INTEGER pRes)
{
	CHAR ch = 0;
	LONGINT pixmapDX = 0, n = 0, b = 0;
	INTEGER k = 0, m = 0, height = 0, minX = 0, maxX = 0, minY = 0, maxY = 0, nOfBoxes = 0, nOfRuns = 0;
	RunRec__30 run[16];
	Metrics__27 metrics[256];
	struct SetBitmapFont__24 _s;
	_s.fontR = fontR; _s.fontR__typ = fontR__typ;
	_s.lnk = SetBitmapFont__24_s;
	SetBitmapFont__24_s = &_s;
	Printer_Str(&*fontR, fontR__typ, (CHAR*)"% Conversion of the Oberon font ", (LONGINT)33);
	Printer_Str(&*fontR, fontR__typ, fd.name, 32);
	Printer_Ln(&*fontR, fontR__typ);
	Files_Read(&*R, R__typ, (void*)&ch);
	if (ch == 0xdb) {
		Files_Read(&*R, R__typ, (void*)&ch);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"% abstraction: ", (LONGINT)16);
		Printer_Int(&*fontR, fontR__typ, (int)ch);
		Files_Read(&*R, R__typ, (void*)&ch);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)", family: ", (LONGINT)11);
		Printer_Ch(&*fontR, fontR__typ, ch);
		Files_Read(&*R, R__typ, (void*)&ch);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)", variant: ", (LONGINT)12);
		Printer_Int(&*fontR, fontR__typ, (int)ch);
		Printer_Ln(&*fontR, fontR__typ);
		Files_ReadInt(&*R, R__typ, &height);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"% height: ", (LONGINT)11);
		Printer_Int(&*fontR, fontR__typ, height);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Files_ReadInt(&*R, R__typ, &minX);
		Files_ReadInt(&*R, R__typ, &maxX);
		Files_ReadInt(&*R, R__typ, &minY);
		Files_ReadInt(&*R, R__typ, &maxY);
		Files_ReadInt(&*R, R__typ, &nOfRuns);
		nOfBoxes = 0;
		k = 0;
		while (k != nOfRuns) {
			Files_ReadInt(&*R, R__typ, &run[__X(k, 16)].beg);
			Files_ReadInt(&*R, R__typ, &run[__X(k, 16)].end);
			nOfBoxes += run[__X(k, 16)].end - run[__X(k, 16)].beg;
			k += 1;
		}
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"9 dict begin", (LONGINT)13);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/FontType 3 def", (LONGINT)16);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/FontMatrix [ 72 ", (LONGINT)18);
		Printer_Int(&*fontR, fontR__typ, pRes);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" div ", (LONGINT)6);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" .24 div 0 0 ", (LONGINT)14);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"72 ", (LONGINT)4);
		Printer_Int(&*fontR, fontR__typ, pRes);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" div ", (LONGINT)6);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" .24 div 0 0", (LONGINT)13);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"] def", (LONGINT)6);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/FontBBox [", (LONGINT)12);
		Printer_Int(&*fontR, fontR__typ, minX);
		Printer_Ch(&*fontR, fontR__typ, ' ');
		Printer_Int(&*fontR, fontR__typ, minY);
		Printer_Ch(&*fontR, fontR__typ, ' ');
		Printer_Int(&*fontR, fontR__typ, maxX);
		Printer_Ch(&*fontR, fontR__typ, ' ');
		Printer_Int(&*fontR, fontR__typ, maxY);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"] def", (LONGINT)6);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/Encoding 256 array def", (LONGINT)24);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"0 1 255 {Encoding exch /.notdef put} for", (LONGINT)41);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"Encoding OberonEncoding /Encoding exch def", (LONGINT)43);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/CharData ", (LONGINT)11);
		Printer_Int(&*fontR, fontR__typ, nOfBoxes + 1);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" dict def", (LONGINT)10);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"CharData begin", (LONGINT)15);
		Printer_Ln(&*fontR, fontR__typ);
		k = 0;
		m = 0;
		while (k < nOfRuns) {
			m = run[__X(k, 16)].beg;
			while (m < run[__X(k, 16)].end) {
				Files_ReadInt(&*R, R__typ, &metrics[__X(m, 256)].dx);
				Files_ReadInt(&*R, R__typ, &metrics[__X(m, 256)].x);
				Files_ReadInt(&*R, R__typ, &metrics[__X(m, 256)].y);
				Files_ReadInt(&*R, R__typ, &metrics[__X(m, 256)].w);
				Files_ReadInt(&*R, R__typ, &metrics[__X(m, 256)].h);
				m += 1;
			}
			k += 1;
		}
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/.notdef", (LONGINT)9);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" [", (LONGINT)3);
		Printer_Int(&*fontR, fontR__typ, metrics[32].w);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" 0 0 0 0 1 1 0 0", (LONGINT)17);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"<>] bdef", (LONGINT)9);
		Printer_Ln(&*fontR, fontR__typ);
		k = 0;
		m = 0;
		while (k < nOfRuns) {
			m = run[__X(k, 16)].beg;
			while (m < run[__X(k, 16)].end) {
				if (__IN(__MASK(m, -32), fd.used[__X(__ASHR(m, 5), 8)])) {
					Printer_Str(&*fontR, fontR__typ, (CHAR*)"/", (LONGINT)2);
					Name__28(m);
					Printer_Str(&*fontR, fontR__typ, (CHAR*)" [", (LONGINT)3);
					if (m == 32) {
						Printer_Str(&*fontR, fontR__typ, (CHAR*)"11 0 0 1 1 1 1 0 0 <00", (LONGINT)23);
					} else {
						Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].dx);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].x);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].y);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].x + metrics[__X(m, 256)].w);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].y + metrics[__X(m, 256)].h);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						if (metrics[__X(m, 256)].w > 0) {
							Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].w);
						} else {
							Printer_Int(&*fontR, fontR__typ, 1);
						}
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						if (metrics[__X(m, 256)].h > 0) {
							Printer_Int(&*fontR, fontR__typ, metrics[__X(m, 256)].h);
						} else {
							Printer_Int(&*fontR, fontR__typ, 1);
						}
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						Printer_Int(&*fontR, fontR__typ, -metrics[__X(m, 256)].x);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
						Printer_Int(&*fontR, fontR__typ, -metrics[__X(m, 256)].y);
						Printer_Ln(&*fontR, fontR__typ);
						Printer_Str(&*fontR, fontR__typ, (CHAR*)"<", (LONGINT)2);
						pixmapDX = __ASHR(metrics[__X(m, 256)].w + 7, 3);
						n = pixmapDX * (LONGINT)metrics[__X(m, 256)].h;
						b = 0;
						while (b < n) {
							Files_Read(&*R, R__typ, (void*)&ch);
							Printer_Hex2(&*fontR, fontR__typ, Flip__25(ch));
							b += 1;
							if (__MASK(b, -32) == 0) {
								Printer_Ln(&*fontR, fontR__typ);
								Printer_Str(&*fontR, fontR__typ, (CHAR*)" ", (LONGINT)2);
							}
						}
					}
					Printer_Str(&*fontR, fontR__typ, (CHAR*)">] bdef", (LONGINT)8);
					Printer_Ln(&*fontR, fontR__typ);
				} else {
					n = __ASHR(metrics[__X(m, 256)].w + 7, 3) * metrics[__X(m, 256)].h;
					b = 0;
					while (b < n) {
						Files_Read(&*R, R__typ, (void*)&ch);
						b += 1;
					}
				}
				m += 1;
			}
			k += 1;
		}
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"  end", (LONGINT)6);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/BuildGlyph {GlobalBuildGlyph} bdef", (LONGINT)36);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/BuildChar {GlobalBuildChar} bdef", (LONGINT)34);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"/imageMaskMatrix [1 0 0 1 0 0] bdef", (LONGINT)36);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"currentdict", (LONGINT)12);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)"end", (LONGINT)4);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ch(&*fontR, fontR__typ, '/');
		Printer_Str(&*fontR, fontR__typ, fd.name, 32);
		Printer_Str(&*fontR, fontR__typ, (CHAR*)" exch definefont pop", (LONGINT)21);
		Printer_Ln(&*fontR, fontR__typ);
		Printer_Ln(&*fontR, fontR__typ);
	}
	SetBitmapFont__24_s = _s.lnk;
}

static void Printer_DefineFont (Files_Rider *fontR, LONGINT *fontR__typ, Printer_FontDesc fd)
{
	CHAR name[32];
	INTEGER i = 0, size = 0;
	Files_File f = NIL;
	Files_Rider R = {0};
	__COPY(fd.name, name, 32);
	i = 0;
	size = 0;
	while ((name[__X(i, 32)] != 0x00 && name[__X(i, 32)] != '.') && (name[__X(i, 32)] < '0' || name[__X(i, 32)] > '9')) {
		i += 1;
	}
	while (name[__X(i, 32)] >= '0' && name[__X(i, 32)] <= '9') {
		size = (size * 10 + (int)name[__X(i, 32)]) - 48;
		i += 1;
	}
	while (name[__X(i, 32)] != 0x00 && name[__X(i, 32)] != '.') {
		i += 1;
	}
	if (((name[__X(i, 32)] != '.' || name[__X(i + 1, 32)] != 'S') || name[__X(i + 2, 32)] != 'c') || name[__X(i + 3, 32)] != 'n') {
		Printer_SetMappedFont(&*fontR, fontR__typ, fd.name, 32);
	} else {
		name[__X(i + 1, 32)] = 'P';
		name[__X(i + 2, 32)] = 'r';
		name[__X(i + 3, 32)] = '3';
		f = Files_Old(name, 32);
		if (f == NIL) {
			Printer_SetMappedFont(&*fontR, fontR__typ, fd.name, 32);
		} else {
			Files_Set(&R, Files_Rider__typ, f, 0);
			Printer_SetBitmapFont(&*fontR, fontR__typ, &R, Files_Rider__typ, fd, 300);
		}
	}
}

void Printer_Open (CHAR *name, LONGINT name__len, CHAR *user, LONGINT user__len, LONGINT password)
{
	INTEGER i = 0;
	Printer_curR = 0;
	Printer_curG = 0;
	Printer_curB = 0;
	Printer_res = 1;
	__COPY(name, Printer_PrinterName, 32);
	__COPY(name, Printer_PrintMode, 3);
	if (Printer_PrintMode[1] == ':') {
		i = 2;
		do {
			Printer_PrinterName[__X(i - 2, 32)] = Printer_PrinterName[__X(i, 32)];
			i += 1;
		} while (!(Printer_PrinterName[__X(i - 1, 32)] == 0x00));
	}
	Printer_headerF = Files_Old((CHAR*)"Oberon.Header.ps", (LONGINT)17);
	if (Printer_headerF != NIL) {
		Printer_bodyF = Files_New((CHAR*)"", (LONGINT)1);
		Files_Set(&Printer_bodyR, Files_Rider__typ, Printer_bodyF, 0);
		Printer_fontIndex = -1;
		Printer_curFont = -1;
		Printer_listFont[0] = 0x00;
		Printer_ppos = 0;
		Printer_pno = 1;
		Printer_res = 0;
	} else {
		Printer_Error((CHAR*)"file not found", (LONGINT)15, (CHAR*)"Oberon.Header.ps", (LONGINT)17);
	}
}

void Printer_UseListFont (CHAR *name, LONGINT name__len)
{
	__COPY(name, Printer_listFont, 32);
	Printer_curFont = -1;
}

void Printer_ReplConst (INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (w > 0 && h > 0) {
		Printer_Int(&Printer_bodyR, Files_Rider__typ, x);
		Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
		Printer_Int(&Printer_bodyR, Files_Rider__typ, y);
		Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
		Printer_Int(&Printer_bodyR, Files_Rider__typ, w);
		Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
		Printer_Int(&Printer_bodyR, Files_Rider__typ, h);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" l", (LONGINT)3);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	}
}

static struct ContString__6 {
	struct ContString__6 *lnk;
} *ContString__6_s;

static void Use__7 (CHAR ch);

static void Use__7 (CHAR ch)
{
	Printer_fontTable[__X(Printer_curFont, 64)].used[__X(__ASHR((int)ch, 5), 8)] |= __SETOF(__MASK((int)ch, -32));
}

void Printer_ContString (CHAR *s, LONGINT s__len, CHAR *fname, LONGINT fname__len)
{
	INTEGER fNo = 0, i = 0, n = 0;
	CHAR ch = 0;
	CHAR family[7];
	CHAR fontname[32];
	struct ContString__6 _s;
	_s.lnk = ContString__6_s;
	ContString__6_s = &_s;
	if (__STRCMP(fname, Printer_listFont) == 0) {
		__MOVE("Courier8.Scn.Fnt", fontname, 17);
	} else {
		__COPY(fname, fontname, 32);
	}
	if (Printer_curFont < 0 || __STRCMP(Printer_fontTable[__X(Printer_curFont, 64)].name, fontname) != 0) {
		__COPY(fontname, Printer_fontTable[__X(Printer_fontIndex + 1, 64)].name, 32);
		i = 0;
		while (i < 8) {
			Printer_fontTable[__X(Printer_fontIndex + 1, 64)].used[__X(i, 8)] = 0x0;
			i += 1;
		}
		fNo = 0;
		while (__STRCMP(Printer_fontTable[__X(fNo, 64)].name, fontname) != 0) {
			fNo += 1;
		}
		if (fNo > Printer_fontIndex) {
			Printer_fontIndex = fNo;
		}
		Printer_curFont = fNo;
		Printer_Ch(&Printer_bodyR, Files_Rider__typ, '(');
		Printer_Str(&Printer_bodyR, Files_Rider__typ, Printer_fontTable[__X(Printer_curFont, 64)].name, 32);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)") f ", (LONGINT)5);
	}
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, '(');
	i = 0;
	ch = s[0];
	while (ch != 0x00) {
		switch (ch) {
			case '(': case ')': case '\\': 
				Printer_Ch(&Printer_bodyR, Files_Rider__typ, '\\');
				Printer_Ch(&Printer_bodyR, Files_Rider__typ, ch);
				Use__7(ch);
				break;
			case 0x09: 
				Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"  ", (LONGINT)3);
				Use__7(' ');
				break;
			case 0x80: case 0x81: case 0x82: case 0x83: case 0x84: 
			case 0x85: case 0x86: case 0x87: case 0x88: case 0x89: 
			case 0x8a: case 0x8b: case 0x8c: case 0x8d: case 0x8e: 
			case 0x8f: case 0x90: case 0x91: case 0x92: case 0x93: 
			case 0x94: case 0x95: case 0xab: 
				Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"\\2", (LONGINT)3);
				n = (int)ch - 128;
				Printer_Ch(&Printer_bodyR, Files_Rider__typ, (CHAR)(__ASHR(n, 3) + 48));
				Printer_Ch(&Printer_bodyR, Files_Rider__typ, (CHAR)(__MASK(n, -8) + 48));
				Use__7(ch);
				break;
			case 0x9f: 
				__COPY(Printer_fontTable[__X(Printer_curFont, 64)].name, family, 7);
				if (__STRCMP(family, "Courie") == 0) {
					Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
				} else {
					Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"  ", (LONGINT)3);
				}
				Use__7(' ');
				break;
			default: 
				Printer_Ch(&Printer_bodyR, Files_Rider__typ, ch);
				Use__7(ch);
				break;
		}
		i += 1;
		ch = s[__X(i, s__len)];
	}
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)") s", (LONGINT)4);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	ContString__6_s = _s.lnk;
}

void Printer_String (INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, CHAR *fname, LONGINT fname__len)
{
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" m ", (LONGINT)4);
	Printer_ContString((void*)s, s__len, (void*)fname, fname__len);
}

void Printer_ReplPattern (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col)
{
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, w);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, h);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, col);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" b", (LONGINT)3);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
}

void Printer_Picture (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode, LONGINT adr)
{
	INTEGER n = 0, i = 0, v = 0;
	CHAR ch = 0;
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, w);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, h);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, mode);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" i", (LONGINT)3);
	n = __ASHR(w + 7, 3) * h;
	i = 0;
	while (i < n) {
		__GET(adr + (LONGINT)i, ch, CHAR);
		if ((int)__MOD(i, 40) == 0) {
			Printer_Ln(&Printer_bodyR, Files_Rider__typ);
		}
		v = __MASK(-((int)ch) - 1, -256);
		Printer_Hex(&Printer_bodyR, Files_Rider__typ, __ASHR(v, 4));
		Printer_Hex(&Printer_bodyR, Files_Rider__typ, __MASK(v, -16));
		i += 1;
	}
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
}

void Printer_Circle (INTEGER x0, INTEGER y0, INTEGER r)
{
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, r);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, r);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" c", (LONGINT)3);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
}

void Printer_Ellipse (INTEGER x0, INTEGER y0, INTEGER a, INTEGER b)
{
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, a);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, b);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" c", (LONGINT)3);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
}

void Printer_Line (INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1)
{
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, x1 - x0);
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, y1 - y0);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" x", (LONGINT)3);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
}

void Printer_UseColor (INTEGER red, INTEGER green, INTEGER blue)
{
	if ((red != Printer_curR || green != Printer_curG) || blue != Printer_curB) {
		Printer_curR = red;
		Printer_curG = green;
		Printer_curB = blue;
		Printer_Int(&Printer_bodyR, Files_Rider__typ, Printer_curR);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" 255 div ", (LONGINT)10);
		Printer_Int(&Printer_bodyR, Files_Rider__typ, Printer_curG);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" 255 div ", (LONGINT)10);
		Printer_Int(&Printer_bodyR, Files_Rider__typ, Printer_curB);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" 255 div u", (LONGINT)11);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	}
}

static void Printer_SolveTriDiag (Printer_RealVector a, Printer_RealVector b, Printer_RealVector c, Printer_RealVector y, INTEGER n)
{
	INTEGER i = 0;
	i = 1;
	while (i < n) {
		y[__X(i, 20)] = y[__X(i, 20)] - c[__X(i - 1, 20)] * y[__X(i - 1, 20)];
		i += 1;
	}
	i = n - 1;
	y[__X(i, 20)] = y[__X(i, 20)] / (REAL)a[__X(i, 20)];
	while (i > 0) {
		i -= 1;
		y[__X(i, 20)] = (y[__X(i, 20)] - b[__X(i, 20)] * y[__X(i + 1, 20)]) / (REAL)a[__X(i, 20)];
	}
}

static void Printer_OpenSpline (Printer_RealVector x, Printer_RealVector y, Printer_RealVector d, INTEGER n)
{
	INTEGER i = 0;
	REAL d1 = 0, d2 = 0;
	Printer_RealVector a, b, c;
	b[0] = (REAL)1 / (REAL)(x[1] - x[0]);
	a[0] = (REAL)2 * b[0];
	c[0] = b[0];
	d1 = (((y[1] - y[0]) * (REAL)3) * b[0]) * b[0];
	d[0] = d1;
	i = 1;
	while (i < n - 1) {
		b[__X(i, 20)] = (REAL)1 / (REAL)(x[__X(i + 1, 20)] - x[__X(i, 20)]);
		a[__X(i, 20)] = (REAL)2 * (c[__X(i - 1, 20)] + b[__X(i, 20)]);
		c[__X(i, 20)] = b[__X(i, 20)];
		d2 = (((y[__X(i + 1, 20)] - y[__X(i, 20)]) * (REAL)3) * b[__X(i, 20)]) * b[__X(i, 20)];
		d[__X(i, 20)] = d1 + d2;
		d1 = d2;
		i += 1;
	}
	a[__X(i, 20)] = (REAL)2 * b[__X(i - 1, 20)];
	d[__X(i, 20)] = d1;
	i = 0;
	while (i < n - 1) {
		c[__X(i, 20)] = c[__X(i, 20)] / (REAL)a[__X(i, 20)];
		a[__X(i + 1, 20)] = a[__X(i + 1, 20)] - c[__X(i, 20)] * b[__X(i, 20)];
		i += 1;
	}
	Printer_SolveTriDiag(a, b, c, d, n);
}

static void Printer_ClosedSpline (Printer_RealVector x, Printer_RealVector y, Printer_RealVector d, INTEGER n)
{
	INTEGER i = 0;
	REAL d1 = 0, d2 = 0, hn = 0, dn = 0;
	Printer_RealVector a, b, c, w;
	hn = (REAL)1 / (REAL)(x[__X(n - 1, 20)] - x[__X(n - 2, 20)]);
	dn = (((y[__X(n - 1, 20)] - y[__X(n - 2, 20)]) * (REAL)3) * hn) * hn;
	b[0] = (REAL)1 / (REAL)(x[1] - x[0]);
	a[0] = (REAL)2 * b[0] + hn;
	c[0] = b[0];
	d1 = (((y[1] - y[0]) * (REAL)3) * b[0]) * b[0];
	d[0] = dn + d1;
	w[0] = (REAL)1;
	i = 1;
	while (i < n - 2) {
		b[__X(i, 20)] = (REAL)1 / (REAL)(x[__X(i + 1, 20)] - x[__X(i, 20)]);
		a[__X(i, 20)] = (REAL)2 * (c[__X(i - 1, 20)] + b[__X(i, 20)]);
		c[__X(i, 20)] = b[__X(i, 20)];
		d2 = (((y[__X(i + 1, 20)] - y[__X(i, 20)]) * (REAL)3) * b[__X(i, 20)]) * b[__X(i, 20)];
		d[__X(i, 20)] = d1 + d2;
		d1 = d2;
		w[__X(i, 20)] = (REAL)0;
		i += 1;
	}
	a[__X(i, 20)] = (REAL)2 * b[__X(i - 1, 20)] + hn;
	d[__X(i, 20)] = d1 + dn;
	w[__X(i, 20)] = (REAL)1;
	i = 0;
	while (i < n - 2) {
		c[__X(i, 20)] = c[__X(i, 20)] / (REAL)a[__X(i, 20)];
		a[__X(i + 1, 20)] = a[__X(i + 1, 20)] - c[__X(i, 20)] * b[__X(i, 20)];
		i += 1;
	}
	Printer_SolveTriDiag(a, b, c, d, n - 1);
	Printer_SolveTriDiag(a, b, c, w, n - 1);
	d1 = (d[0] + d[__X(i, 20)]) / (REAL)(((w[0] + w[__X(i, 20)]) + x[__X(i + 1, 20)]) - x[__X(i, 20)]);
	i = 0;
	while (i < n - 1) {
		d[__X(i, 20)] = d[__X(i, 20)] - d1 * w[__X(i, 20)];
		i += 1;
	}
	d[__X(i, 20)] = d[0];
}

static void Printer_PrintPoly (Printer_Poly *p, LONGINT *p__typ, Printer_Poly *q, LONGINT *q__typ, REAL lim)
{
	REAL x0 = 0, y0 = 0, x1 = 0, y1 = 0, x2 = 0, y2 = 0, x3 = 0, y3 = 0;
	x0 = (*p).d;
	y0 = (*q).d;
	x1 = x0 + ((*p).c * lim) / (REAL)(REAL)3;
	y1 = y0 + ((*q).c * lim) / (REAL)(REAL)3;
	x2 = x1 + (((*p).c + (*p).b * lim) * lim) / (REAL)(REAL)3;
	y2 = y1 + (((*q).c + (*q).b * lim) * lim) / (REAL)(REAL)3;
	x3 = x0 + ((*p).c + ((*p).b + (*p).a * lim) * lim) * lim;
	y3 = y0 + ((*q).c + ((*q).b + (*q).a * lim) * lim) * lim;
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(x1));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(y1));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(x2));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(y2));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(x3));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(y3));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(x0));
	Printer_Ch(&Printer_bodyR, Files_Rider__typ, ' ');
	Printer_Int(&Printer_bodyR, Files_Rider__typ, __ENTIER(y0));
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" z", (LONGINT)3);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
}

void Printer_Spline (INTEGER x0, INTEGER y0, INTEGER n, INTEGER open, INTEGER *X, LONGINT X__len, INTEGER *Y, LONGINT Y__len)
{
	INTEGER i = 0;
	REAL dx = 0, dy = 0, ds = 0;
	Printer_RealVector x, xd, y, yd, s;
	Printer_PolyVector p, q;
	x[0] = X[0] + x0;
	y[0] = Y[0] + y0;
	s[0] = (REAL)0;
	i = 1;
	while (i < n) {
		x[__X(i, 20)] = X[__X(i, X__len)] + x0;
		dx = x[__X(i, 20)] - x[__X(i - 1, 20)];
		y[__X(i, 20)] = Y[__X(i, Y__len)] + y0;
		dy = y[__X(i, 20)] - y[__X(i - 1, 20)];
		s[__X(i, 20)] = (__ABS(dx) + __ABS(dy)) + s[__X(i - 1, 20)];
		i += 1;
	}
	if (open == 1) {
		Printer_OpenSpline(s, x, xd, n);
		Printer_OpenSpline(s, y, yd, n);
	} else {
		Printer_ClosedSpline(s, x, xd, n);
		Printer_ClosedSpline(s, y, yd, n);
	}
	i = 0;
	while (i < n - 1) {
		ds = (REAL)1 / (REAL)(s[__X(i + 1, 20)] - s[__X(i, 20)]);
		dx = (x[__X(i + 1, 20)] - x[__X(i, 20)]) * ds;
		p[__X(i, 20)].a = (ds * ds) * ((xd[__X(i, 20)] + xd[__X(i + 1, 20)]) - (REAL)2 * dx);
		p[__X(i, 20)].b = ds * (((REAL)3 * dx - (REAL)2 * xd[__X(i, 20)]) - xd[__X(i + 1, 20)]);
		p[__X(i, 20)].c = xd[__X(i, 20)];
		p[__X(i, 20)].d = x[__X(i, 20)];
		p[__X(i, 20)].t = s[__X(i, 20)];
		dy = ds * (y[__X(i + 1, 20)] - y[__X(i, 20)]);
		q[__X(i, 20)].a = (ds * ds) * ((yd[__X(i, 20)] + yd[__X(i + 1, 20)]) - (REAL)2 * dy);
		q[__X(i, 20)].b = ds * (((REAL)3 * dy - (REAL)2 * yd[__X(i, 20)]) - yd[__X(i + 1, 20)]);
		q[__X(i, 20)].c = yd[__X(i, 20)];
		q[__X(i, 20)].d = y[__X(i, 20)];
		q[__X(i, 20)].t = s[__X(i, 20)];
		i += 1;
	}
	p[__X(i, 20)].t = s[__X(i, 20)];
	q[__X(i, 20)].t = s[__X(i, 20)];
	i = 0;
	while (i < n - 1) {
		Printer_PrintPoly(&p[__X(i, 20)], Printer_Poly__typ, &q[__X(i, 20)], Printer_Poly__typ, p[__X(i + 1, 20)].t - p[__X(i, 20)].t);
		i += 1;
	}
}

void Printer_Page (INTEGER nofcopies)
{
	Printer_curR = 0;
	Printer_curG = 0;
	Printer_curB = 0;
	Printer_curFont = -1;
	Printer_pno += 1;
	Printer_ppos = Files_Pos(&Printer_bodyR, Files_Rider__typ);
	Printer_PrintCopies = nofcopies;
	if (Printer_PrintMode[1] != ':') {
		Printer_Int(&Printer_bodyR, Files_Rider__typ, nofcopies);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" p", (LONGINT)3);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"%%Page: 0 ", (LONGINT)11);
		Printer_Int(&Printer_bodyR, Files_Rider__typ, Printer_pno);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	} else if (__ODD(Printer_pno)) {
		Printer_Int(&Printer_bodyR, Files_Rider__typ, nofcopies);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" p", (LONGINT)3);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"%%Page: 0 ", (LONGINT)11);
		Printer_Int(&Printer_bodyR, Files_Rider__typ, __ASHR(Printer_pno, 1) + 1);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
		if (__STRCMP(Printer_PrintMode, "1:") == 0) {
			Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"2480 0 translate", (LONGINT)17);
			Printer_Ln(&Printer_bodyR, Files_Rider__typ);
		}
	} else if (__STRCMP(Printer_PrintMode, "1:") == 0) {
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"-2480 0 translate", (LONGINT)18);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	} else {
		Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"2480 0 translate", (LONGINT)17);
		Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	}
}

static void Printer_Append (CHAR *s1, LONGINT s1__len, CHAR *s2, LONGINT s2__len)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	__DUP(s2, s2__len, CHAR);
	i = 0;
	j = 0;
	while (s1[__X(i, s1__len)] != 0x00) {
		i += 1;
	}
	do {
		ch = s2[__X(j, s2__len)];
		s1[__X(i, s1__len)] = ch;
		i += 1;
		j += 1;
	} while (!(ch == 0x00));
	__DEL(s2);
}

void Printer_Close (void)
{
	CHAR cmd[256];
	INTEGER i = 0;
	Files_File printF = NIL;
	Files_Rider printR = {0}, srcR = {0};
	CHAR ch = 0;
	SYSTEM_BYTE buffer[4096];
	Files_Set(&Printer_bodyR, Files_Rider__typ, Printer_bodyF, Printer_ppos);
	Printer_Int(&Printer_bodyR, Files_Rider__typ, Printer_PrintCopies);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)" p", (LONGINT)3);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	Printer_Str(&Printer_bodyR, Files_Rider__typ, (CHAR*)"%%Trailer         ", (LONGINT)19);
	Printer_Ln(&Printer_bodyR, Files_Rider__typ);
	printF = Files_New((CHAR*)"Oberon.Printfile.ps", (LONGINT)20);
	Files_Set(&printR, Files_Rider__typ, printF, 0);
	if (__STRCMP(Printer_PrinterName, "none") != 0) {
		Files_Write(&printR, Files_Rider__typ, 0x04);
	}
	Files_Set(&srcR, Files_Rider__typ, Printer_headerF, 0);
	do {
		Files_ReadBytes(&srcR, Files_Rider__typ, (void*)buffer, 4096, 4096);
		Files_WriteBytes(&printR, Files_Rider__typ, (void*)buffer, 4096, 4096 - srcR.res);
	} while (!srcR.eof);
	i = 0;
	while (i <= Printer_fontIndex) {
		Printer_DefineFont(&printR, Files_Rider__typ, Printer_fontTable[__X(i, 64)]);
		i += 1;
	}
	Printer_Ln(&printR, Files_Rider__typ);
	if (Printer_PrintMode[1] != ':') {
		Printer_Str(&printR, Files_Rider__typ, (CHAR*)"OberonInit", (LONGINT)11);
		Printer_Ln(&printR, Files_Rider__typ);
		Printer_Ln(&printR, Files_Rider__typ);
	} else {
		Printer_Str(&printR, Files_Rider__typ, (CHAR*)"OberonInit2", (LONGINT)12);
		Printer_Ln(&printR, Files_Rider__typ);
		Printer_Ln(&printR, Files_Rider__typ);
	}
	Printer_Str(&printR, Files_Rider__typ, (CHAR*)"%%EndProlog", (LONGINT)12);
	Printer_Ln(&printR, Files_Rider__typ);
	Printer_Str(&printR, Files_Rider__typ, (CHAR*)"%%Page: 0 1", (LONGINT)12);
	Printer_Ln(&printR, Files_Rider__typ);
	Printer_Str(&printR, Files_Rider__typ, (CHAR*)"save", (LONGINT)5);
	Printer_Ln(&printR, Files_Rider__typ);
	Printer_Ln(&printR, Files_Rider__typ);
	if (__STRCMP(Printer_PrintMode, "1:") == 0) {
		Printer_Str(&printR, Files_Rider__typ, (CHAR*)"2480 0 translate", (LONGINT)17);
		Printer_Ln(&printR, Files_Rider__typ);
	}
	Files_Set(&srcR, Files_Rider__typ, Printer_bodyF, 0);
	do {
		Files_ReadBytes(&srcR, Files_Rider__typ, (void*)buffer, 4096, 4096);
		Files_WriteBytes(&printR, Files_Rider__typ, (void*)buffer, 4096, 4096 - srcR.res);
	} while (!srcR.eof);
	if (__STRCMP(Printer_PrinterName, "none") != 0) {
		Files_Write(&printR, Files_Rider__typ, 0x04);
	}
	Files_Register(printF);
	if (__STRCMP(Printer_PrinterName, "none") != 0) {
		__MOVE("lp -c -s ", cmd, 10);
		if (__STRCMP(Printer_PrinterName, "Pluto") != 0) {
			Printer_Append((void*)cmd, 256, (CHAR*)"-d ", (LONGINT)4);
			Printer_Append((void*)cmd, 256, Printer_PrinterName, 32);
		}
		Printer_Append((void*)cmd, 256, (CHAR*)" ", (LONGINT)2);
		Printer_Append((void*)cmd, 256, (CHAR*)"Oberon.Printfile.ps", (LONGINT)20);
		Printer_system(cmd, 256);
		Files_Delete((CHAR*)"Oberon.Printfile.ps", (LONGINT)20, &Printer_res);
	}
	Files_Set(&Printer_bodyR, Files_Rider__typ, NIL, 0);
	Printer_headerF = NIL;
	Printer_bodyF = NIL;
	printF = NIL;
}

static void EnumPtrs(void (*P)(void*))
{
	P(Printer_headerF);
	P(Printer_bodyF);
	__ENUMR(&Printer_bodyR, Files_Rider__typ, 20, 1, P);
}

__TDESC(Printer_FontDesc, 1, 0) = {__TDFLDS("FontDesc", 64), {-4}};
__TDESC(Printer_Poly, 1, 0) = {__TDFLDS("Poly", 20), {-4}};
__TDESC(RunRec__30, 1, 0) = {__TDFLDS("RunRec__30", 4), {-4}};
__TDESC(Metrics__27, 1, 0) = {__TDFLDS("Metrics__27", 10), {-4}};

export void *Printer__init(void)
{
	__DEFMOD;
	__IMPORT(Files);
	__IMPORT(Kernel);
	__IMPORT(Unix);
	__REGMOD(Printer, EnumPtrs);
	__REGCMD("Close", Printer_Close);
	__INITYP(Printer_FontDesc, Printer_FontDesc, 0);
	__INITYP(Printer_Poly, Printer_Poly, 0);
	__INITYP(RunRec__30, RunRec__30, 0);
	__INITYP(Metrics__27, Metrics__27, 0);
/* BEGIN */
	__MOVE("0123456789ABCDEF", Printer_hexArray, 17);
	Printer_PageWidth = 2336;
	Printer_PageHeight = 3425;
	__ENDMOD;
}
