/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "GraphicFrames.h"
#include "Graphics.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "Texts.h"

typedef
	struct Rectangles_RectDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
		INTEGER lw, vers;
	} Rectangles_RectDesc;

typedef
	Rectangles_RectDesc *Rectangles_Rectangle;


export Graphics_Method Rectangles_method;
static INTEGER Rectangles_shade;

export LONGINT *Rectangles_RectDesc__typ;

static void Rectangles_Copy (Graphics_Object src, Graphics_Object dst);
static void Rectangles_Draw (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
static void Rectangles_Handle (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
export void Rectangles_Make (void);
export void Rectangles_New (void);
static void Rectangles_Print (Graphics_Object obj, INTEGER x, INTEGER y);
static void Rectangles_Read (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
static BOOLEAN Rectangles_Selectable (Graphics_Object obj, INTEGER x, INTEGER y);
export void Rectangles_SetShade (void);
static void Rectangles_Write (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ);
static void Rectangles_mark (GraphicFrames_Frame f, INTEGER col, INTEGER x, INTEGER y);


void Rectangles_New (void)
{
	Rectangles_Rectangle r = NIL;
	__NEW(r, Rectangles_RectDesc);
	r->do_ = Rectangles_method;
	Graphics_new = (Graphics_Object)r;
}

static void Rectangles_Copy (Graphics_Object src, Graphics_Object dst)
{
	dst->x = src->x;
	dst->y = src->y;
	dst->w = src->w;
	dst->h = src->h;
	dst->col = src->col;
	__GUARDP(dst, Rectangles_RectDesc, 1)->lw = __GUARDP(src, Rectangles_RectDesc, 1)->lw;
	__GUARDP(dst, Rectangles_RectDesc, 1)->vers = __GUARDP(src, Rectangles_RectDesc, 1)->vers;
}

static void Rectangles_mark (GraphicFrames_Frame f, INTEGER col, INTEGER x, INTEGER y)
{
	Display_ReplConstC((void*)f, col, x - 4, y, 4, 4, 0);
}

static struct Draw__2 {
	INTEGER *x, *y, *w, *h, *lw;
	GraphicFrames_Frame *f;
	struct Draw__2 *lnk;
} *Draw__2_s;

static void draw__3 (INTEGER col);

static void draw__3 (INTEGER col)
{
	Display_ReplConstC((void*)*Draw__2_s->f, col, *Draw__2_s->x, *Draw__2_s->y, *Draw__2_s->w, *Draw__2_s->lw, 0);
	Display_ReplConstC((void*)*Draw__2_s->f, col, (*Draw__2_s->x + *Draw__2_s->w) - *Draw__2_s->lw, *Draw__2_s->y, *Draw__2_s->lw, *Draw__2_s->h, 0);
	Display_ReplConstC((void*)*Draw__2_s->f, col, *Draw__2_s->x, (*Draw__2_s->y + *Draw__2_s->h) - *Draw__2_s->lw, *Draw__2_s->w, *Draw__2_s->lw, 0);
	Display_ReplConstC((void*)*Draw__2_s->f, col, *Draw__2_s->x, *Draw__2_s->y, *Draw__2_s->lw, *Draw__2_s->h, 0);
}

static void Rectangles_Draw (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, lw = 0, col = 0;
	GraphicFrames_Frame f = NIL;
	struct Draw__2 _s;
	_s.x = &x;
	_s.y = &y;
	_s.w = &w;
	_s.h = &h;
	_s.lw = &lw;
	_s.f = &f;
	_s.lnk = Draw__2_s;
	Draw__2_s = &_s;
	if (__IS(M__typ, GraphicFrames_DrawMsg, 1)) {
		GraphicFrames_DrawMsg *M__ = (void*)M;
		x = obj->x + (*M__).x;
		y = obj->y + (*M__).y;
		w = obj->w;
		h = obj->h;
		f = (*M__).f;
		lw = __GUARDP(obj, Rectangles_RectDesc, 1)->lw;
		if (((x < f->X1 && x + w > f->X) && y < f->Y1) && y + h > f->Y) {
			if ((*M__).col == 0) {
				col = obj->col;
			} else {
				col = (*M__).col;
			}
			if ((*M__).mode == 0) {
				draw__3(col);
				if (obj->selected) {
					Rectangles_mark(f, 15, (x + w) - lw, y + lw);
				}
				if (__GUARDP(obj, Rectangles_RectDesc, 1)->vers != 0) {
					Display_ReplPatternC((void*)f, col, Display_grey0, x, y, w, h, x, y, 1);
				}
			} else if ((*M__).mode == 1) {
				Rectangles_mark(f, 15, (x + w) - lw, y + lw);
			} else if ((*M__).mode == 2) {
				Rectangles_mark(f, 0, (x + w) - lw, y + lw);
			} else if (__GUARDP(obj, Rectangles_RectDesc, 1)->vers == 0) {
				draw__3(f->col);
				Rectangles_mark(f, f->col, (x + w) - lw, y + lw);
			} else {
				Display_ReplConstC((void*)f, f->col, x, y, w, h, 0);
			}
		}
	} else __WITHCHK;
	Draw__2_s = _s.lnk;
}

static BOOLEAN Rectangles_Selectable (Graphics_Object obj, INTEGER x, INTEGER y)
{
	return (((obj->x + obj->w) - 4 <= x && x <= obj->x + obj->w) && obj->y <= y) && y <= obj->y + 4;
}

static void Rectangles_Handle (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	INTEGER x0 = 0, y0 = 0, x1 = 0, y1 = 0, dx = 0, dy = 0;
	SET k = 0;
	if (__IS(M__typ, Graphics_WidMsg, 1)) {
		__GUARDP(obj, Rectangles_RectDesc, 1)->lw = __GUARDR(M, Graphics_WidMsg, 1).w;
	} else if (__IS(M__typ, Graphics_ColorMsg, 1)) {
		obj->col = __GUARDR(M, Graphics_ColorMsg, 1).col;
	} else if (__IS(M__typ, GraphicFrames_CtrlMsg, 1)) {
		if (__IS(M__typ, GraphicFrames_CtrlMsg, 1)) {
			GraphicFrames_CtrlMsg *M__ = (void*)M;
			if (__ISP(obj, Rectangles_RectDesc, 1)) {
				(*M__).res = 1;
				x0 = ((*(Rectangles_Rectangle*)&obj)->x + (*(Rectangles_Rectangle*)&obj)->w) + (*M__).f->x;
				y0 = (*(Rectangles_Rectangle*)&obj)->y + (*M__).f->y;
				Rectangles_mark((*M__).f, 15, x0 - (*(Rectangles_Rectangle*)&obj)->lw, y0 + (*(Rectangles_Rectangle*)&obj)->lw);
				do {
					Input_Mouse(&k, &x1, &y1);
					x1 -= __MASK(x1 - (*M__).f->x, -4);
					y1 -= __MASK(y1 - (*M__).f->y, -4);
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x1, y1);
				} while (!(k == 0x0));
				Rectangles_mark((*M__).f, 0, x0 - (*(Rectangles_Rectangle*)&obj)->lw, y0 + (*(Rectangles_Rectangle*)&obj)->lw);
				if (x0 - (*(Rectangles_Rectangle*)&obj)->w < x1 && y1 < y0 + (*(Rectangles_Rectangle*)&obj)->h) {
					GraphicFrames_EraseObj((*M__).f, (void*)(*(Rectangles_Rectangle*)&obj));
					dx = x1 - x0;
					dy = y1 - y0;
					(*(Rectangles_Rectangle*)&obj)->y += dy;
					(*(Rectangles_Rectangle*)&obj)->w += dx;
					(*(Rectangles_Rectangle*)&obj)->h -= dy;
					GraphicFrames_DrawObj((*M__).f, (void*)(*(Rectangles_Rectangle*)&obj));
				}
			} else __WITHCHK;
		} else __WITHCHK;
	}
}

static void Rectangles_Read (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
	SHORTINT w = 0, v = 0;
	INTEGER len = 0;
	Files_ReadInt(&*R, R__typ, &len);
	Files_Read(&*R, R__typ, (void*)&w);
	Files_Read(&*R, R__typ, (void*)&v);
	__GUARDP(obj, Rectangles_RectDesc, 1)->lw = w;
	__GUARDP(obj, Rectangles_RectDesc, 1)->vers = v;
}

static void Rectangles_Write (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ)
{
	Graphics_WriteObj(&*W, W__typ, cno, obj);
	Files_WriteInt(&*W, W__typ, 2);
	Files_Write(&*W, W__typ, (int)__GUARDP(obj, Rectangles_RectDesc, 1)->lw);
	Files_Write(&*W, W__typ, (int)__GUARDP(obj, Rectangles_RectDesc, 1)->vers);
}

static void Rectangles_Print (Graphics_Object obj, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, lw = 0, s = 0;
	x += __ASHL(obj->x, 2);
	y += __ASHL(obj->y, 2);
	w = __ASHL(obj->w, 2);
	h = __ASHL(obj->h, 2);
	lw = __ASHL(__GUARDP(obj, Rectangles_RectDesc, 1)->lw, 1);
	s = __GUARDP(obj, Rectangles_RectDesc, 1)->vers;
	Printer_ReplConst(x, y, w, lw);
	Printer_ReplConst((x + w) - lw, y, lw, h);
	Printer_ReplConst(x, (y + h) - lw, w, lw);
	Printer_ReplConst(x, y, lw, h);
	if (s > 0) {
		Printer_ReplPattern(x, y, w, h, s);
	}
}

void Rectangles_Make (void)
{
	INTEGER x0 = 0, x1 = 0, y0 = 0, y1 = 0;
	Rectangles_Rectangle R = NIL;
	GraphicFrames_Frame G = NIL;
	G = GraphicFrames_Focus();
	if (G != NIL && G->mark.next != NIL) {
		GraphicFrames_Deselect(G);
		x0 = G->mark.x;
		y0 = G->mark.y;
		x1 = G->mark.next->x;
		y1 = G->mark.next->y;
		__NEW(R, Rectangles_RectDesc);
		R->col = Oberon_CurCol;
		R->w = __ABS(x1 - x0);
		R->h = __ABS(y1 - y0);
		if (x1 < x0) {
			x0 = x1;
		}
		if (y1 < y0) {
			y0 = y1;
		}
		R->x = x0 - G->x;
		R->y = y0 - G->y;
		R->lw = Graphics_width;
		R->vers = Rectangles_shade;
		R->do_ = Rectangles_method;
		Graphics_Add(G->graph, (void*)R);
		GraphicFrames_Defocus(G);
		GraphicFrames_DrawObj(G, (void*)R);
	}
}

void Rectangles_SetShade (void)
{
	Texts_Scanner S = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 3) {
		Rectangles_shade = (int)S.i;
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(Rectangles_method);
}

__TDESC(Rectangles_RectDesc, 1, 3) = {__TDFLDS("RectDesc", 28), {12, 16, 20, -16}};

export void *Rectangles__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(GraphicFrames);
	__IMPORT(Graphics);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(Texts);
	__REGMOD(Rectangles, EnumPtrs);
	__REGCMD("Make", Rectangles_Make);
	__REGCMD("New", Rectangles_New);
	__REGCMD("SetShade", Rectangles_SetShade);
	__INITYP(Rectangles_RectDesc, Graphics_ObjectDesc, 1);
/* BEGIN */
	Rectangles_shade = 0;
	__NEW(Rectangles_method, Graphics_MethodDesc);
	__MOVE("Rectangles", Rectangles_method->module, 11);
	__MOVE("New", Rectangles_method->allocator, 4);
	Rectangles_method->new = Rectangles_New;
	Rectangles_method->copy = Rectangles_Copy;
	Rectangles_method->draw = Rectangles_Draw;
	Rectangles_method->selectable = Rectangles_Selectable;
	Rectangles_method->handle = Rectangles_Handle;
	Rectangles_method->read = Rectangles_Read;
	Rectangles_method->write = Rectangles_Write;
	Rectangles_method->print = Rectangles_Print;
	__ENDMOD;
}
