/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "GraphicFrames.h"
#include "Graphics.h"
#include "Oberon.h"
#include "Printer.h"

typedef
	struct Splines_Poly {
		REAL a, b, c, d, t;
	} Splines_Poly;

typedef
	Splines_Poly Splines_PolyVector[20];

typedef
	REAL Splines_RealVector[20];

typedef
	struct Splines_SplineDesc *Splines_Spline;

typedef
	struct Splines_SplineDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
		INTEGER n;
		BOOLEAN open;
		INTEGER u[20], v[20];
	} Splines_SplineDesc;


export Graphics_Method Splines_method;

export LONGINT *Splines_SplineDesc__typ;
export LONGINT *Splines_Poly__typ;

static void Splines_ClosedSpline (Splines_RealVector x, Splines_RealVector y, Splines_RealVector d, INTEGER n);
static void Splines_CompSpline (GraphicFrames_Frame f, INTEGER col, INTEGER x0, INTEGER y0, Splines_Spline sp);
static void Splines_Copy (Graphics_Object src, Graphics_Object dst);
static void Splines_Draw (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
static void Splines_Handle (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
export void Splines_MakeClosed (void);
export void Splines_MakeOpen (void);
static void Splines_MakeSpline (BOOLEAN open);
export void Splines_New (void);
static void Splines_OpenSpline (Splines_RealVector x, Splines_RealVector y, Splines_RealVector d, INTEGER n);
static void Splines_Print (Graphics_Object obj, INTEGER x, INTEGER y);
static void Splines_Read (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
static BOOLEAN Splines_Selectable (Graphics_Object obj, INTEGER x, INTEGER y);
static void Splines_ShowPoly (GraphicFrames_Frame f, INTEGER col, Splines_Poly *p, LONGINT *p__typ, Splines_Poly *q, LONGINT *q__typ, REAL lim);
static void Splines_SolveTriDiag (Splines_RealVector a, Splines_RealVector b, Splines_RealVector c, Splines_RealVector y, INTEGER n);
static void Splines_Write (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ);
static void Splines_mark (GraphicFrames_Frame f, INTEGER col, INTEGER x0, INTEGER y0, Splines_Spline sp);
static void Splines_markOrg (GraphicFrames_Frame f, INTEGER col, INTEGER x, INTEGER y, Splines_Spline sp);


static void Splines_mark (GraphicFrames_Frame f, INTEGER col, INTEGER x0, INTEGER y0, Splines_Spline sp)
{
	INTEGER i = 0, n = 0, x = 0, y = 0;
	i = 1;
	if (sp->open) {
		n = sp->n;
	} else {
		n = sp->n - 1;
	}
	while (i < n) {
		i += 1;
		Display_ReplConstC((void*)f, col, sp->u[__X(i, 20)] + x0, sp->v[__X(i, 20)] + y0, 4, 4, 0);
	}
}

static void Splines_markOrg (GraphicFrames_Frame f, INTEGER col, INTEGER x, INTEGER y, Splines_Spline sp)
{
	x += sp->u[0];
	y += sp->v[0];
	Display_ReplConstC((void*)f, col, x, y, 4, 4, 0);
}

static void Splines_ShowPoly (GraphicFrames_Frame f, INTEGER col, Splines_Poly *p, LONGINT *p__typ, Splines_Poly *q, LONGINT *q__typ, REAL lim)
{
	REAL t = 0;
	LONGINT x = 0, y = 0;
	t = (REAL)0;
	do {
		Display_DotC((void*)f, col, (int)__ENTIER((((*p).a * t + (*p).b) * t + (*p).c) * t + (*p).d), (int)__ENTIER((((*q).a * t + (*q).b) * t + (*q).c) * t + (*q).d), 0);
		t = t + (REAL)1;
	} while (!(t >= lim));
}

static void Splines_SolveTriDiag (Splines_RealVector a, Splines_RealVector b, Splines_RealVector c, Splines_RealVector y, INTEGER n)
{
	INTEGER i = 0;
	REAL r = 0;
	i = 1;
	while (i < n) {
		r = y[__X(i, 20)] - c[__X(i - 1, 20)] * y[__X(i - 1, 20)];
		y[__X(i, 20)] = r;
		i += 1;
	}
	i = n - 1;
	y[__X(i, 20)] = y[__X(i, 20)] / (REAL)a[__X(i, 20)];
	while (i > 0) {
		i -= 1;
		r = y[__X(i, 20)] - b[__X(i, 20)] * y[__X(i + 1, 20)];
		y[__X(i, 20)] = r / (REAL)a[__X(i, 20)];
	}
}

static void Splines_OpenSpline (Splines_RealVector x, Splines_RealVector y, Splines_RealVector d, INTEGER n)
{
	INTEGER i = 0;
	REAL d1 = 0, d2 = 0;
	Splines_RealVector a, b, c;
	b[0] = (REAL)1 / (REAL)(x[1] - x[0]);
	a[0] = (REAL)2 * b[0];
	c[0] = b[0];
	d1 = (((y[1] - y[0]) * (REAL)3) * b[0]) * b[0];
	d[0] = d1;
	i = 1;
	while (i < n - 1) {
		b[__X(i, 20)] = (REAL)1 / (REAL)(x[__X(i + 1, 20)] - x[__X(i, 20)]);
		a[__X(i, 20)] = (REAL)2 * (c[__X(i - 1, 20)] + b[__X(i, 20)]);
		c[__X(i, 20)] = b[__X(i, 20)];
		d2 = (((y[__X(i + 1, 20)] - y[__X(i, 20)]) * (REAL)3) * b[__X(i, 20)]) * b[__X(i, 20)];
		d[__X(i, 20)] = d1 + d2;
		d1 = d2;
		i += 1;
	}
	a[__X(i, 20)] = (REAL)2 * b[__X(i - 1, 20)];
	d[__X(i, 20)] = d1;
	i = 0;
	while (i < n - 1) {
		c[__X(i, 20)] = c[__X(i, 20)] / (REAL)a[__X(i, 20)];
		a[__X(i + 1, 20)] = a[__X(i + 1, 20)] - c[__X(i, 20)] * b[__X(i, 20)];
		i += 1;
	}
	Splines_SolveTriDiag(a, b, c, d, n);
}

static void Splines_ClosedSpline (Splines_RealVector x, Splines_RealVector y, Splines_RealVector d, INTEGER n)
{
	INTEGER i = 0;
	REAL d1 = 0, d2 = 0, hn = 0, dn = 0;
	Splines_RealVector a, b, c, w;
	hn = (REAL)1 / (REAL)(x[__X(n - 1, 20)] - x[__X(n - 2, 20)]);
	dn = (((y[__X(n - 1, 20)] - y[__X(n - 2, 20)]) * (REAL)3) * hn) * hn;
	b[0] = (REAL)1 / (REAL)(x[1] - x[0]);
	a[0] = (REAL)2 * b[0] + hn;
	c[0] = b[0];
	d1 = (((y[1] - y[0]) * (REAL)3) * b[0]) * b[0];
	d[0] = dn + d1;
	w[0] = (REAL)1;
	i = 1;
	while (i < n - 2) {
		b[__X(i, 20)] = (REAL)1 / (REAL)(x[__X(i + 1, 20)] - x[__X(i, 20)]);
		a[__X(i, 20)] = (REAL)2 * (c[__X(i - 1, 20)] + b[__X(i, 20)]);
		c[__X(i, 20)] = b[__X(i, 20)];
		d2 = (((y[__X(i + 1, 20)] - y[__X(i, 20)]) * (REAL)3) * b[__X(i, 20)]) * b[__X(i, 20)];
		d[__X(i, 20)] = d1 + d2;
		d1 = d2;
		w[__X(i, 20)] = (REAL)0;
		i += 1;
	}
	a[__X(i, 20)] = (REAL)2 * b[__X(i - 1, 20)] + hn;
	d[__X(i, 20)] = d1 + dn;
	w[__X(i, 20)] = (REAL)1;
	i = 0;
	while (i < n - 2) {
		c[__X(i, 20)] = c[__X(i, 20)] / (REAL)a[__X(i, 20)];
		a[__X(i + 1, 20)] = a[__X(i + 1, 20)] - c[__X(i, 20)] * b[__X(i, 20)];
		i += 1;
	}
	Splines_SolveTriDiag(a, b, c, d, n - 1);
	Splines_SolveTriDiag(a, b, c, w, n - 1);
	d1 = (d[0] + d[__X(i, 20)]) / (REAL)(((w[0] + w[__X(i, 20)]) + x[__X(i + 1, 20)]) - x[__X(i, 20)]);
	i = 0;
	while (i < n - 1) {
		d[__X(i, 20)] = d[__X(i, 20)] - d1 * w[__X(i, 20)];
		i += 1;
	}
	d[__X(i, 20)] = d[0];
}

static void Splines_CompSpline (GraphicFrames_Frame f, INTEGER col, INTEGER x0, INTEGER y0, Splines_Spline sp)
{
	INTEGER i = 0, n = 0;
	REAL dx = 0, dy = 0, ds = 0;
	Splines_RealVector x, xd, y, yd, s;
	Splines_PolyVector p, q;
	x[0] = sp->u[0] + x0;
	y[0] = sp->v[0] + y0;
	s[0] = (REAL)0;
	n = sp->n;
	i = 1;
	while (i < n) {
		x[__X(i, 20)] = sp->u[__X(i, 20)] + x0;
		dx = x[__X(i, 20)] - x[__X(i - 1, 20)];
		y[__X(i, 20)] = sp->v[__X(i, 20)] + y0;
		dy = y[__X(i, 20)] - y[__X(i - 1, 20)];
		s[__X(i, 20)] = (__ABS(dx) + __ABS(dy)) + s[__X(i - 1, 20)];
		i += 1;
	}
	if (sp->open) {
		Splines_OpenSpline(s, x, xd, n);
		Splines_OpenSpline(s, y, yd, n);
	} else {
		Splines_ClosedSpline(s, x, xd, n);
		Splines_ClosedSpline(s, y, yd, n);
	}
	i = 0;
	while (i < n - 1) {
		ds = (REAL)1 / (REAL)(s[__X(i + 1, 20)] - s[__X(i, 20)]);
		dx = (x[__X(i + 1, 20)] - x[__X(i, 20)]) * ds;
		p[__X(i, 20)].a = (ds * ds) * ((xd[__X(i, 20)] + xd[__X(i + 1, 20)]) - (REAL)2 * dx);
		p[__X(i, 20)].b = ds * (((REAL)3 * dx - (REAL)2 * xd[__X(i, 20)]) - xd[__X(i + 1, 20)]);
		p[__X(i, 20)].c = xd[__X(i, 20)];
		p[__X(i, 20)].d = x[__X(i, 20)];
		p[__X(i, 20)].t = s[__X(i, 20)];
		dy = ds * (y[__X(i + 1, 20)] - y[__X(i, 20)]);
		q[__X(i, 20)].a = (ds * ds) * ((yd[__X(i, 20)] + yd[__X(i + 1, 20)]) - (REAL)2 * dy);
		q[__X(i, 20)].b = ds * (((REAL)3 * dy - (REAL)2 * yd[__X(i, 20)]) - yd[__X(i + 1, 20)]);
		q[__X(i, 20)].c = yd[__X(i, 20)];
		q[__X(i, 20)].d = y[__X(i, 20)];
		q[__X(i, 20)].t = s[__X(i, 20)];
		i += 1;
	}
	p[__X(i, 20)].t = s[__X(i, 20)];
	q[__X(i, 20)].t = s[__X(i, 20)];
	i = 0;
	while (i < n - 1) {
		Splines_ShowPoly(f, col, &p[__X(i, 20)], Splines_Poly__typ, &q[__X(i, 20)], Splines_Poly__typ, p[__X(i + 1, 20)].t - p[__X(i, 20)].t);
		i += 1;
	}
}

void Splines_New (void)
{
	Splines_Spline sp = NIL;
	__NEW(sp, Splines_SplineDesc);
	sp->do_ = Splines_method;
	Graphics_new = (Graphics_Object)sp;
}

static void Splines_Copy (Graphics_Object src, Graphics_Object dst)
{
	__GUARDEQP(dst, Splines_SplineDesc) = *__GUARDP(src, Splines_SplineDesc, 1);
}

static void Splines_Draw (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, col = 0;
	GraphicFrames_Frame f = NIL;
	if (__IS(M__typ, GraphicFrames_DrawMsg, 1)) {
		GraphicFrames_DrawMsg *M__ = (void*)M;
		x = obj->x + (*M__).x;
		y = obj->y + (*M__).y;
		w = obj->w;
		h = obj->h;
		f = (*M__).f;
		if (((x < f->X1 && f->X <= x + w) && y < f->Y1) && f->Y <= y + h) {
			if ((*M__).col == 0) {
				col = obj->col;
			} else {
				col = (*M__).col;
			}
			if (__ISP(obj, Splines_SplineDesc, 1)) {
				if ((*M__).mode == 0) {
					if ((*(Splines_Spline*)&obj)->selected) {
						Splines_mark(f, 15, x, y, (*(Splines_Spline*)&obj));
					}
					Splines_CompSpline(f, col, x, y, (*(Splines_Spline*)&obj));
					Splines_markOrg(f, 15, x, y, (*(Splines_Spline*)&obj));
				} else if ((*M__).mode == 1) {
					Splines_mark(f, 15, x, y, (*(Splines_Spline*)&obj));
				} else if ((*M__).mode == 2) {
					Splines_mark(f, f->col, x, y, (*(Splines_Spline*)&obj));
					Splines_markOrg(f, 15, x, y, (*(Splines_Spline*)&obj));
				} else {
					Splines_mark(f, f->col, x, y, (*(Splines_Spline*)&obj));
					Splines_CompSpline(f, f->col, x, y, (*(Splines_Spline*)&obj));
					Splines_markOrg(f, f->col, x, y, (*(Splines_Spline*)&obj));
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

static BOOLEAN Splines_Selectable (Graphics_Object obj, INTEGER x, INTEGER y)
{
	INTEGER x0 = 0, y0 = 0;
	x0 = obj->x + __GUARDP(obj, Splines_SplineDesc, 1)->u[0];
	y0 = obj->y + __GUARDP(obj, Splines_SplineDesc, 1)->v[0];
	return ((x0 - 4 <= x && x <= x0 + 4) && y0 - 4 <= y) && y <= y0 + 4;
}

static void Splines_Handle (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	if (__IS(M__typ, Graphics_ColorMsg, 1)) {
		obj->col = __GUARDR(M, Graphics_ColorMsg, 1).col;
	}
}

static void Splines_Read (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
	INTEGER i = 0, j = 0, len = 0;
	SHORTINT s = 0;
	i = 0;
	j = 0;
	Files_ReadInt(&*R, R__typ, &len);
	if (__ISP(obj, Splines_SplineDesc, 1)) {
		(*(Splines_Spline*)&obj)->n = __ASHR(len - 1, 2);
		Files_Read(&*R, R__typ, (void*)&s);
		(*(Splines_Spline*)&obj)->open = s == 1;
		while (i < (*(Splines_Spline*)&obj)->n) {
			Files_ReadInt(&*R, R__typ, &(*(Splines_Spline*)&obj)->u[__X(i, 20)]);
			i += 1;
		}
		while (j < (*(Splines_Spline*)&obj)->n) {
			Files_ReadInt(&*R, R__typ, &(*(Splines_Spline*)&obj)->v[__X(j, 20)]);
			j += 1;
		}
	} else __WITHCHK;
}

static void Splines_Write (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ)
{
	INTEGER i = 0, j = 0;
	i = 0;
	j = 0;
	if (__ISP(obj, Splines_SplineDesc, 1)) {
		Graphics_WriteObj(&*W, W__typ, cno, (void*)(*(Splines_Spline*)&obj));
		Files_WriteInt(&*W, W__typ, __ASHL((*(Splines_Spline*)&obj)->n, 2) + 1);
		if ((*(Splines_Spline*)&obj)->open) {
			Files_Write(&*W, W__typ, 1);
		} else {
			Files_Write(&*W, W__typ, 0);
		}
		while (i < (*(Splines_Spline*)&obj)->n) {
			Files_WriteInt(&*W, W__typ, (*(Splines_Spline*)&obj)->u[__X(i, 20)]);
			i += 1;
		}
		while (j < (*(Splines_Spline*)&obj)->n) {
			Files_WriteInt(&*W, W__typ, (*(Splines_Spline*)&obj)->v[__X(j, 20)]);
			j += 1;
		}
	} else __WITHCHK;
}

static void Splines_Print (Graphics_Object obj, INTEGER x, INTEGER y)
{
	INTEGER i = 0, j = 0, n = 0, open = 0;
	INTEGER u[20], v[20];
	if (__ISP(obj, Splines_SplineDesc, 1)) {
		if ((*(Splines_Spline*)&obj)->open) {
			open = 1;
		} else {
			open = 0;
		}
		n = (*(Splines_Spline*)&obj)->n;
		i = 0;
		while (i < n) {
			u[__X(i, 20)] = __ASHL((*(Splines_Spline*)&obj)->u[__X(i, 20)], 2);
			v[__X(i, 20)] = __ASHL((*(Splines_Spline*)&obj)->v[__X(i, 20)], 2);
			i += 1;
		}
		Printer_Spline(__ASHL((*(Splines_Spline*)&obj)->x, 2) + x, __ASHL((*(Splines_Spline*)&obj)->y, 2) + y, n, open, (void*)u, 20, (void*)v, 20);
	} else __WITHCHK;
}

static void Splines_MakeSpline (BOOLEAN open)
{
	INTEGER x0 = 0, x1 = 0, x2 = 0, y0 = 0, y1 = 0, y2 = 0, i = 0, n = 0;
	Splines_Spline spl = NIL;
	GraphicFrames_Frame G = NIL;
	GraphicFrames_Location L = NIL;
	G = GraphicFrames_Focus();
	if (G != NIL && G->mark.next != NIL) {
		GraphicFrames_Deselect(G);
		__NEW(spl, Splines_SplineDesc);
		x0 = G->mark.x;
		y0 = G->mark.y;
		x1 = x0;
		y1 = y0;
		spl->u[0] = x0;
		spl->v[0] = y0;
		L = G->mark.next;
		i = 0;
		n = 1;
		while (L != NIL && n < 19) {
			x2 = L->x;
			spl->u[__X(n, 20)] = x2;
			y2 = L->y;
			spl->v[__X(n, 20)] = y2;
			if (x2 < x0) {
				x0 = x2;
			}
			if (x1 < x2) {
				x1 = x2;
			}
			if (y2 < y0) {
				y0 = y2;
			}
			if (y1 < y2) {
				y1 = y2;
			}
			n += 1;
			L = L->next;
		}
		while (i < n) {
			spl->u[__X(i, 20)] -= x0;
			spl->v[__X(i, 20)] -= y0;
			i += 1;
		}
		if (!open) {
			spl->u[__X(n, 20)] = spl->u[0];
			spl->v[__X(n, 20)] = spl->v[0];
			n += 1;
		}
		spl->x = x0 - G->x;
		spl->y = y0 - G->y;
		spl->w = (x1 - x0) + 1;
		spl->h = (y1 - y0) + 1;
		spl->open = open;
		spl->n = n;
		spl->col = Oberon_CurCol;
		spl->do_ = Splines_method;
		Graphics_Add(G->graph, (void*)spl);
		GraphicFrames_Defocus(G);
		GraphicFrames_DrawObj(G, (void*)spl);
	}
}

void Splines_MakeOpen (void)
{
	Splines_MakeSpline(1);
}

void Splines_MakeClosed (void)
{
	Splines_MakeSpline(0);
}

static void EnumPtrs(void (*P)(void*))
{
	P(Splines_method);
}

__TDESC(Splines_SplineDesc, 1, 3) = {__TDFLDS("SplineDesc", 108), {12, 16, 20, -16}};
__TDESC(Splines_Poly, 1, 0) = {__TDFLDS("Poly", 20), {-4}};

export void *Splines__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(GraphicFrames);
	__IMPORT(Graphics);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__REGMOD(Splines, EnumPtrs);
	__REGCMD("MakeClosed", Splines_MakeClosed);
	__REGCMD("MakeOpen", Splines_MakeOpen);
	__REGCMD("New", Splines_New);
	__INITYP(Splines_SplineDesc, Graphics_ObjectDesc, 1);
	__INITYP(Splines_Poly, Splines_Poly, 0);
/* BEGIN */
	__NEW(Splines_method, Graphics_MethodDesc);
	__MOVE("Splines", Splines_method->module, 8);
	__MOVE("New", Splines_method->allocator, 4);
	Splines_method->new = Splines_New;
	Splines_method->copy = Splines_Copy;
	Splines_method->draw = Splines_Draw;
	Splines_method->selectable = Splines_Selectable;
	Splines_method->handle = Splines_Handle;
	Splines_method->read = Splines_Read;
	Splines_method->write = Splines_Write;
	Splines_method->print = Splines_Print;
	__ENDMOD;
}
