/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct StaticTextElems_ElemDesc *StaticTextElems_Elem;

typedef
	struct StaticTextElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		CHAR value[128];
		BOOLEAN x3D, border, transparent;
		SHORTINT align;
	} StaticTextElems_ElemDesc;



export LONGINT *StaticTextElems_ElemDesc__typ;

static void StaticTextElems_Draw (StaticTextElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Fonts_Font fnt, Display_Frame f);
export void StaticTextElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void StaticTextElems_HandleAttrMsg (StaticTextElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void StaticTextElems_Init (StaticTextElems_Elem e);
export void StaticTextElems_Insert (void);
export void StaticTextElems_New (void);
static void StaticTextElems_Track (StaticTextElems_Elem e, TextFrames_TrackMsg msg);


static void StaticTextElems_Draw (StaticTextElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Fonts_Font fnt, Display_Frame f)
{
	INTEGER h = 0, w = 0, diy = 0;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	if (!e->transparent && GUtils_device == 2) {
		GUtils_ReplConst(f, 13, x, y, w, h, 1);
	}
	if (e->border) {
		if (e->x3D) {
			GUtils_Area(f, 13, 0, x, y, w, h, GUtils_Unit(1, 0), 0, 1);
		} else {
			GUtils_Frame(f, color, x, y, w, h, GUtils_Unit(1, 0), 1);
		}
	}
	if (h > GUtils_Unit(fnt->maxY - fnt->minY, 0)) {
		diy = __ASHR(h, 1) - __ASHR(GUtils_Unit(fnt->minY + fnt->maxY, 0), 1);
		GUtils_String(f, e->value, 128, x + GUtils_Unit(2, 0), y + diy, w - GUtils_Unit(4, 0), fnt, color, 1, e->align);
	}
}

static void StaticTextElems_HandleAttrMsg (StaticTextElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 2;
			__COPY(e->value, (*msg).s, 256);
		} else if (__STRCMP((*msg).name, "Border") == 0) {
			(*msg).class = 7;
			(*msg).b = e->border;
		} else if (__STRCMP((*msg).name, "3D") == 0) {
			(*msg).class = 7;
			(*msg).b = e->x3D;
		} else if (__STRCMP((*msg).name, "Transparent") == 0) {
			(*msg).class = 7;
			(*msg).b = e->transparent;
		} else if (__STRCMP((*msg).name, "Align") == 0) {
			(*msg).class = 2;
			(*msg).hasProps = 1;
			if (e->align == 1) {
				__COPY("Center", (*msg).s, 256);
			} else if (e->align == 2) {
				__COPY("Right", (*msg).s, 256);
			} else {
				__COPY("Left", (*msg).s, 256);
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			if ((*msg).class == 2) {
				__COPY((*msg).s, e->value, 128);
			}
		} else if (__STRCMP((*msg).name, "Border") == 0) {
			if ((*msg).class == 7) {
				e->border = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "3D") == 0) {
			if ((*msg).class == 7) {
				e->x3D = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Transparent") == 0) {
			if ((*msg).class == 7) {
				e->transparent = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Align") == 0) {
			if ((*msg).class == 3) {
				e->align = (int)(*msg).i;
			} else if ((*msg).class == 2) {
				if (__CAP((*msg).s[0]) == 'L') {
					e->align = 0;
				} else if (__CAP((*msg).s[0]) == 'C') {
					e->align = 1;
				} else if (__CAP((*msg).s[0]) == 'R') {
					e->align = 2;
				}
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Border", (LONGINT)7, 7);
		(*(*msg).enum_)((CHAR*)"3D", (LONGINT)3, 7);
		(*(*msg).enum_)((CHAR*)"Transparent", (LONGINT)12, 7);
		(*(*msg).enum_)((CHAR*)"Value", (LONGINT)6, 2);
		(*(*msg).enum_)((CHAR*)"Align", (LONGINT)6, 2);
	} else if ((*msg).id == 4 && __STRCMP((*msg).name, "Align") == 0) {
		(*(*msg).enum_)((CHAR*)"Left", (LONGINT)5, 2);
		(*(*msg).enum_)((CHAR*)"Center", (LONGINT)7, 2);
		(*(*msg).enum_)((CHAR*)"Right", (LONGINT)6, 2);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

static void StaticTextElems_Track (StaticTextElems_Elem e, TextFrames_TrackMsg msg)
{
	INTEGER X = 0, Y = 0, w = 0, h = 0;
	SET keysum = 0;
	Elems_ExecMsg exec = {0};
	BOOLEAN pressed = 0;
	keysum = msg.keys;
	do {
		Input_Mouse(&msg.keys, &X, &Y);
		keysum = keysum | msg.keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
	} while (!(msg.keys == 0x0));
	if ((((X > msg.X0 && X < msg.X0 + (int)__DIV(e->W, (LONGINT)TextFrames_Unit)) && Y > msg.Y0) && Y < msg.Y0 + (int)__DIV(e->H, (LONGINT)TextFrames_Unit)) && keysum == 0x02) {
		exec.e = (Elems_Elem)e;
		exec.x = msg.X0;
		exec.y = msg.Y0;
		exec.f = msg.frame;
		exec.unload = __IN(2, keysum);
		(*e->handle)((void*)e, (void*)&exec, Elems_ExecMsg__typ);
	}
}

void StaticTextElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	StaticTextElems_Elem copy = NIL;
	CHAR ch = 0;
	INTEGER a = 0;
	if (__ISP(e, StaticTextElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				StaticTextElems_Draw((*(StaticTextElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).fnt, (*msg__).frame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				StaticTextElems_Draw((*(StaticTextElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).fnt, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, StaticTextElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, StaticTextElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(StaticTextElems_Elem*)&e), (void*)copy);
			__COPY((*(StaticTextElems_Elem*)&e)->value, copy->value, 128);
			copy->align = (*(StaticTextElems_Elem*)&e)->align;
			copy->border = (*(StaticTextElems_Elem*)&e)->border;
			copy->x3D = (*(StaticTextElems_Elem*)&e)->x3D;
			copy->transparent = (*(StaticTextElems_Elem*)&e)->transparent;
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("StaticTextElems", (*msg__).mod, 16);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(StaticTextElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadString(&(*msg__).r, Files_Rider__typ, (void*)(*(StaticTextElems_Elem*)&e)->value, 128);
				Files_ReadInt(&(*msg__).r, Files_Rider__typ, &a);
				(*(StaticTextElems_Elem*)&e)->align = (int)a;
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(StaticTextElems_Elem*)&e)->border);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(StaticTextElems_Elem*)&e)->x3D);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(StaticTextElems_Elem*)&e)->transparent);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteString(&(*msg__).r, Files_Rider__typ, (*(StaticTextElems_Elem*)&e)->value, 128);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, (*(StaticTextElems_Elem*)&e)->align);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(StaticTextElems_Elem*)&e)->border);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(StaticTextElems_Elem*)&e)->x3D);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(StaticTextElems_Elem*)&e)->transparent);
			}
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(StaticTextElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				StaticTextElems_Track((*(StaticTextElems_Elem*)&e), *msg__);
			}
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			StaticTextElems_HandleAttrMsg((*(StaticTextElems_Elem*)&e), &*msg__, msg__typ);
		} else {
			Elems_Handle((void*)(*(StaticTextElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void StaticTextElems_Init (StaticTextElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = StaticTextElems_Handle;
	__MOVE("StaticText", e->value, 11);
	e->border = 0;
	e->x3D = 0;
	e->transparent = 0;
	e->align = 0;
	e->H = (LONGINT)((Fonts_Default->maxY - Fonts_Default->minY) + 5) * (LONGINT)TextFrames_Unit;
	e->W = 100 * TextFrames_Unit;
}

void StaticTextElems_New (void)
{
	StaticTextElems_Elem e = NIL;
	__NEW(e, StaticTextElems_ElemDesc);
	StaticTextElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void StaticTextElems_Insert (void)
{
	StaticTextElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, StaticTextElems_ElemDesc);
	StaticTextElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		__COPY(s.s, e->value, 128);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (!s.eot && __IN(s.class, 0x46)) {
			if (s.class == 6) {
				s.s[0] = s.c;
			}
			if (__CAP(s.s[0]) == 'R') {
				e->align = 2;
			} else if (__CAP(s.s[0]) == 'C') {
				e->align = 1;
			}
			Texts_Scan(&s, Texts_Scanner__typ);
			if (!s.eot && __IN(s.class, 0x06)) {
				e->x3D = __STRCMP(s.s, "3D") == 0;
				e->border = __STRCMP(s.s, "3D") == 0 || s.s[0] == 'B';
				Texts_Scan(&s, Texts_Scanner__typ);
				if (!s.eot && __IN(s.class, 0x06)) {
					e->transparent = s.s[0] == 'Y';
				}
			}
		}
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

__TDESC(StaticTextElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 176), {0, 4, 12, 32, 36, -24}};

export void *StaticTextElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(StaticTextElems, 0);
	__REGCMD("Insert", StaticTextElems_Insert);
	__REGCMD("New", StaticTextElems_New);
	__INITYP(StaticTextElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	__ENDMOD;
}
