/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "ParcElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	CHAR StyleElems_Name[32];

typedef
	struct StyleElems_ParcDesc *StyleElems_Parc;

typedef
	struct StyleElems_ParcDesc { /* TextFrames_ParcDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT left, first, width, lead, lsp, dsr;
		SET opts;
		INTEGER nofTabs;
		LONGINT tab[32];
		StyleElems_Name name;
		Texts_Text home;
	} StyleElems_ParcDesc;

typedef
	struct StyleElems_UpdateMsg { /* Texts_ElemMsg */
		INTEGER id;
		LONGINT pos;
		StyleElems_Name name, newName;
		StyleElems_Parc parc;
	} StyleElems_UpdateMsg;


export Fonts_Font StyleElems_font;

export LONGINT *StyleElems_ParcDesc__typ;
export LONGINT *StyleElems_UpdateMsg__typ;

export void StyleElems_Alloc (void);
export void StyleElems_Broadcast (Texts_Text T, StyleElems_UpdateMsg *msg, LONGINT *msg__typ);
export void StyleElems_ChangeName (StyleElems_Parc P, CHAR *name, LONGINT name__len, BOOLEAN *synched);
export void StyleElems_ChangeSetting (StyleElems_Parc P);
export void StyleElems_Copy (StyleElems_Parc SP, StyleElems_Parc DP);
export void StyleElems_Draw (StyleElems_Parc P, Display_Frame F, SHORTINT col, INTEGER x0, INTEGER y0);
static void StyleElems_DrawString (StyleElems_Parc P, SHORTINT col, INTEGER x0, INTEGER y0, INTEGER bw);
export void StyleElems_Edit (StyleElems_Parc P, TextFrames_Frame F, LONGINT pos, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, SET keysum);
static TextFrames_Frame StyleElems_FocusFrame (void);
static void StyleElems_GetMainArg (Texts_Scanner *S, LONGINT *S__typ);
export void StyleElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void StyleElems_Insert (void);
export void StyleElems_Load (StyleElems_Parc P, Files_Rider *r, LONGINT *r__typ);
static TextFrames_Frame StyleElems_MarkedFrame (void);
export void StyleElems_Prepare (StyleElems_Parc P, LONGINT indent, LONGINT unit);
static void StyleElems_ReadString (Files_Rider *r, LONGINT *r__typ, CHAR *s, LONGINT s__len);
export void StyleElems_Rename (void);
export void StyleElems_RenameAll (void);
export void StyleElems_Search (Texts_Text T, StyleElems_Name name, StyleElems_Parc *P);
export void StyleElems_SetAttr (StyleElems_Parc P, TextFrames_Frame F, Texts_Scanner *S, LONGINT *S__typ, Texts_Text log);
export void StyleElems_Store (StyleElems_Parc P, Files_Rider *r, LONGINT *r__typ);
export void StyleElems_Synch (StyleElems_Parc P, BOOLEAN *synched);
static INTEGER StyleElems_Width (StyleElems_Parc P);
static void StyleElems_WriteString (Files_Rider *r, LONGINT *r__typ, CHAR *s, LONGINT s__len);


static TextFrames_Frame StyleElems_MarkedFrame (void)
{
	Viewers_Viewer v = NIL;
	v = Oberon_MarkedViewer();
	if (__ISP(v, MenuViewers_ViewerDesc, 2) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		return __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static TextFrames_Frame StyleElems_FocusFrame (void)
{
	Viewers_Viewer v = NIL;
	TextFrames_Frame f = NIL;
	v = Oberon_FocusViewer;
	if (__ISP(v, MenuViewers_ViewerDesc, 2) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
		if (f->hasCar) {
			return f;
		} else {
			return NIL;
		}
	} else {
		return NIL;
	}
	__RETCHK;
}

static void StyleElems_GetMainArg (Texts_Scanner *S, LONGINT *S__typ)
{
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, text, beg);
			Texts_Scan(&*S, S__typ);
		}
	}
	if ((*S).line != 0) {
		(*S).class = 0;
	}
}

static void StyleElems_WriteString (Files_Rider *r, LONGINT *r__typ, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		i += 1;
	}
	Files_WriteBytes(&*r, r__typ, (void*)s, s__len * 1, i + 1);
	__DEL(s);
}

static void StyleElems_ReadString (Files_Rider *r, LONGINT *r__typ, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	i = 0;
	do {
		Files_Read(&*r, r__typ, (void*)&ch);
		s[__X(i, s__len)] = ch;
		i += 1;
	} while (!(ch == 0x00 || (LONGINT)i == s__len));
	if (ch != 0x00) {
		s[0] = 0x00;
	}
}

void StyleElems_Broadcast (Texts_Text T, StyleElems_UpdateMsg *msg, LONGINT *msg__typ)
{
	Texts_Reader R = {0};
	Texts_Elem e = NIL;
	Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
	Texts_ReadElem(&R, Texts_Reader__typ);
	while (!R.eot) {
		e = R.elem;
		(*msg).pos = Texts_Pos(&R, Texts_Reader__typ) - 1;
		Texts_ReadElem(&R, Texts_Reader__typ);
		(*e->handle)(e, (void*)&*msg, msg__typ);
	}
}

void StyleElems_Search (Texts_Text T, StyleElems_Name name, StyleElems_Parc *P)
{
	StyleElems_UpdateMsg update = {0};
	update.id = 0;
	__MOVE(name, update.name, 32);
	update.parc = NIL;
	StyleElems_Broadcast(T, &update, StyleElems_UpdateMsg__typ);
	*P = update.parc;
}

void StyleElems_Synch (StyleElems_Parc P, BOOLEAN *synched)
{
	Texts_Text T = NIL;
	StyleElems_Parc Q = NIL;
	T = Texts_ElemBase((void*)P);
	*synched = 0;
	if (T != NIL && P->home != T) {
		StyleElems_Search(T, P->name, &Q);
		if (Q != NIL) {
			ParcElems_CopyParc((void*)Q, (void*)P);
			P->opts &= ~__SETOF(3);
			*synched = 1;
		}
		P->home = T;
	}
}

void StyleElems_ChangeSetting (StyleElems_Parc P)
{
	Texts_Text T = NIL;
	StyleElems_UpdateMsg update = {0};
	T = Texts_ElemBase((void*)P);
	update.id = 1;
	__MOVE(P->name, update.name, 32);
	update.parc = P;
	StyleElems_Broadcast(T, &update, StyleElems_UpdateMsg__typ);
}

void StyleElems_ChangeName (StyleElems_Parc P, CHAR *name, LONGINT name__len, BOOLEAN *synched)
{
	__DUP(name, name__len, CHAR);
	*synched = 0;
	if (__STRCMP(P->name, name) != 0) {
		__COPY(name, P->name, 32);
		P->home = NIL;
		StyleElems_Synch(P, &*synched);
	}
	__DEL(name);
}

void StyleElems_Load (StyleElems_Parc P, Files_Rider *r, LONGINT *r__typ)
{
	ParcElems_LoadParc((void*)P, &*r, r__typ);
	StyleElems_ReadString(&*r, r__typ, (void*)P->name, 32);
	P->home = Texts_ElemBase((void*)P);
}

void StyleElems_Store (StyleElems_Parc P, Files_Rider *r, LONGINT *r__typ)
{
	BOOLEAN synched = 0;
	StyleElems_Synch(P, &synched);
	ParcElems_StoreParc((void*)P, &*r, r__typ);
	StyleElems_WriteString(&*r, r__typ, P->name, 32);
}

void StyleElems_Copy (StyleElems_Parc SP, StyleElems_Parc DP)
{
	ParcElems_CopyParc((void*)SP, (void*)DP);
	__MOVE(SP->name, DP->name, 32);
	DP->home = SP->home;
}

void StyleElems_Prepare (StyleElems_Parc P, LONGINT indent, LONGINT unit)
{
	BOOLEAN synched = 0;
	StyleElems_Synch(P, &synched);
	ParcElems_Prepare((void*)P, indent, unit);
	if ((LONGINT)(StyleElems_font->height + 4) * unit > P->H) {
		P->H = (LONGINT)(StyleElems_font->height + 4) * unit;
	}
}

static INTEGER StyleElems_Width (StyleElems_Parc P)
{
	LONGINT pat = 0;
	INTEGER i = 0, px = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	i = 0;
	px = 0;
	while (P->name[__X(i, 32)] != 0x00) {
		Display_GetChar(StyleElems_font->raster, P->name[__X(i, 32)], &dx, &x, &y, &w, &h, &pat);
		px += dx;
		i += 1;
	}
	return px;
}

static void StyleElems_DrawString (StyleElems_Parc P, SHORTINT col, INTEGER x0, INTEGER y0, INTEGER bw)
{
	LONGINT pat = 0;
	INTEGER i = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	i = 0;
	Display_ReplConst(0, x0, y0, bw + 4, StyleElems_font->height, 0);
	x0 += 2;
	y0 -= StyleElems_font->minY;
	while (P->name[__X(i, 32)] != 0x00) {
		Display_GetChar(StyleElems_font->raster, P->name[__X(i, 32)], &dx, &x, &y, &w, &h, &pat);
		i += 1;
		Display_CopyPattern(col, pat, x0 + x, y0 + y, 0);
		x0 += dx;
	}
}

void StyleElems_Draw (StyleElems_Parc P, Display_Frame F, SHORTINT col, INTEGER x0, INTEGER y0)
{
	INTEGER bw = 0;
	ParcElems_Draw((void*)P, F, col, x0, y0);
	bw = StyleElems_Width(P);
	StyleElems_DrawString(P, col, ((x0 + (int)__DIV(P->W, (LONGINT)TextFrames_Unit)) - bw) - 20, y0 + 4, bw);
}

void StyleElems_Edit (StyleElems_Parc P, TextFrames_Frame F, LONGINT pos, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, SET keysum)
{
	if (F->showsParcs) {
		ParcElems_Edit((void*)P, F, pos, x0, y0, x, y, keysum);
		if (__IN(1, keysum) && keysum != 0x07) {
			StyleElems_ChangeSetting(P);
		}
	}
}

void StyleElems_SetAttr (StyleElems_Parc P, TextFrames_Frame F, Texts_Scanner *S, LONGINT *S__typ, Texts_Text log)
{
	ParcElems_SetAttr((void*)P, F, TextFrames_Unit, &*S, S__typ, log);
	StyleElems_ChangeSetting(P);
}

void StyleElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	StyleElems_Parc e = NIL;
	SET opts = 0;
	BOOLEAN synched = 0;
	if (__ISP(E, StyleElems_ParcDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					StyleElems_Prepare((*(StyleElems_Parc*)&E), (*msg__).indent, TextFrames_Unit);
				} else {
					StyleElems_Draw((*(StyleElems_Parc*)&E), (*msg__).frame, (*msg__).col, (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("StyleElems", (*msg__).mod, 11);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					StyleElems_Load((*(StyleElems_Parc*)&E), &(*msg__).r, Files_Rider__typ);
				} else if ((*msg__).id == 1) {
					StyleElems_Store((*(StyleElems_Parc*)&E), &(*msg__).r, Files_Rider__typ);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			__NEW(e, StyleElems_ParcDesc);
			StyleElems_Copy((*(StyleElems_Parc*)&E), e);
			__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)e;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				StyleElems_Edit((*(StyleElems_Parc*)&E), __GUARDP((*msg__).frame, TextFrames_FrameDesc, 1), (*msg__).pos, (*msg__).X0, (*msg__).Y0, (*msg__).X, (*msg__).Y, (*msg__).keys);
			} else __WITHCHK;
		} else if (__IS(msg__typ, ParcElems_StateMsg, 1)) {
			if (__IS(msg__typ, ParcElems_StateMsg, 1)) {
				ParcElems_StateMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					StyleElems_SetAttr((*(StyleElems_Parc*)&E), (*msg__).frame, &(*msg__).par, Texts_Scanner__typ, (*msg__).log);
				} else {
					ParcElems_Handle((void*)(*(StyleElems_Parc*)&E), (void*)&*msg__, msg__typ);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, StyleElems_UpdateMsg, 1)) {
			if (__IS(msg__typ, StyleElems_UpdateMsg, 1)) {
				StyleElems_UpdateMsg *msg__ = (void*)msg;
				if ((((*msg__).id == 0 && (*msg__).parc == NIL) && __STRCMP((*(StyleElems_Parc*)&E)->name, (*msg__).name) == 0) && (*(StyleElems_Parc*)&E)->home == Texts_ElemBase((void*)(*(StyleElems_Parc*)&E))) {
					(*msg__).parc = (*(StyleElems_Parc*)&E);
				} else if ((*msg__).id == 1 && __STRCMP((*(StyleElems_Parc*)&E)->name, (*msg__).name) == 0) {
					if ((*(StyleElems_Parc*)&E) != (*msg__).parc) {
						opts = (*(StyleElems_Parc*)&E)->opts;
						ParcElems_CopyParc((void*)(*msg__).parc, (void*)(*(StyleElems_Parc*)&E));
						(*(StyleElems_Parc*)&E)->opts = (*(StyleElems_Parc*)&E)->opts & ~0x08 | opts & 0x08;
					}
					ParcElems_ChangedParc((void*)(*(StyleElems_Parc*)&E), (*msg__).pos);
				} else if ((*msg__).id == 2 && __STRCMP((*(StyleElems_Parc*)&E)->name, (*msg__).name) == 0) {
					StyleElems_ChangeName((*(StyleElems_Parc*)&E), (*msg__).newName, 32, &synched);
					if (synched) {
						ParcElems_ChangedParc((void*)(*(StyleElems_Parc*)&E), (*msg__).pos);
					} else {
						Texts_ChangeLooks(Texts_ElemBase((void*)(*(StyleElems_Parc*)&E)), (*msg__).pos, (*msg__).pos + 1, 0x0, NIL, 0, 0);
					}
				}
			} else __WITHCHK;
		} else {
			ParcElems_Handle((void*)(*(StyleElems_Parc*)&E), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void StyleElems_Alloc (void)
{
	StyleElems_Parc p = NIL;
	__NEW(p, StyleElems_ParcDesc);
	p->handle = StyleElems_Handle;
	Texts_new = (Texts_Elem)p;
}

void StyleElems_Insert (void)
{
	TextFrames_Frame F = NIL;
	TextFrames_Parc P = NIL;
	StyleElems_Parc p = NIL;
	Texts_Scanner S = {0};
	LONGINT pbeg = 0;
	TextFrames_InsertElemMsg m = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	StyleElems_GetMainArg(&S, Texts_Scanner__typ);
	if (S.class == 1 || S.class == 2) {
		F = StyleElems_FocusFrame();
		if (F != NIL) {
			TextFrames_ParcBefore(F->text, F->carloc.pos, &P, &pbeg);
		} else {
			P = TextFrames_defParc;
		}
		__NEW(p, StyleElems_ParcDesc);
		ParcElems_CopyParc(P, (void*)p);
		p->handle = StyleElems_Handle;
		__COPY(S.s, p->name, 32);
		p->home = NIL;
		m.e = (Texts_Elem)p;
		(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&m, TextFrames_InsertElemMsg__typ);
	}
}

void StyleElems_Rename (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame F = NIL;
	TextFrames_Parc P = NIL;
	StyleElems_Parc p = NIL;
	LONGINT pbeg = 0;
	BOOLEAN synch = 0, synched = 0;
	StyleElems_Name name;
	F = StyleElems_MarkedFrame();
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	StyleElems_GetMainArg(&S, Texts_Scanner__typ);
	if (((F != NIL && F->hasSel) && F->selbeg.pos + 1 == F->selend.pos) && (S.class == 1 || S.class == 2)) {
		TextFrames_ParcBefore(F->text, F->selbeg.pos, &P, &pbeg);
		if ((__ISP(P, StyleElems_ParcDesc, 3) && pbeg == F->selbeg.pos) && __STRCMP(__GUARDP(P, StyleElems_ParcDesc, 3)->name, S.s) != 0) {
			__COPY(S.s, name, 32);
			Texts_Scan(&S, Texts_Scanner__typ);
			if ((S.class == 6 && S.c == '\\') && __CAP(S.nextCh) == 'S') {
				synch = 1;
			} else {
				StyleElems_Search(F->text, name, &p);
				synch = p == NIL;
			}
			StyleElems_ChangeName(__GUARDP(P, StyleElems_ParcDesc, 3), name, 32, &synched);
			if (synched) {
				ParcElems_ChangedParc(P, pbeg);
			} else {
				Texts_ChangeLooks(F->text, pbeg, pbeg + 1, 0x0, NIL, 0, 0);
			}
		}
	}
}

void StyleElems_RenameAll (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame F = NIL;
	TextFrames_Parc P = NIL;
	StyleElems_Parc p = NIL;
	LONGINT pbeg = 0;
	BOOLEAN synch = 0;
	StyleElems_UpdateMsg msg = {0};
	StyleElems_Name name;
	F = StyleElems_MarkedFrame();
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	StyleElems_GetMainArg(&S, Texts_Scanner__typ);
	if (((F != NIL && F->hasSel) && F->selbeg.pos + 1 == F->selend.pos) && (S.class == 1 || S.class == 2)) {
		TextFrames_ParcBefore(F->text, F->selbeg.pos, &P, &pbeg);
		if ((__ISP(P, StyleElems_ParcDesc, 3) && pbeg == F->selbeg.pos) && __STRCMP(__GUARDP(P, StyleElems_ParcDesc, 3)->name, S.s) != 0) {
			__COPY(S.s, name, 32);
			Texts_Scan(&S, Texts_Scanner__typ);
			if ((S.class == 6 && S.c == '\\') && __CAP(S.nextCh) == 'S') {
				synch = 1;
			} else {
				StyleElems_Search(F->text, name, &p);
				synch = p == NIL;
			}
			if (synch) {
				msg.id = 2;
				__MOVE(__GUARDP(P, StyleElems_ParcDesc, 3)->name, msg.name, 32);
				__MOVE(name, msg.newName, 32);
				StyleElems_Broadcast(F->text, &msg, StyleElems_UpdateMsg__typ);
			}
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(StyleElems_font);
}

__TDESC(StyleElems_ParcDesc, 1, 5) = {__TDFLDS("ParcDesc", 232), {0, 4, 12, 32, 228, -24}};
__TDESC(StyleElems_UpdateMsg, 1, 1) = {__TDFLDS("UpdateMsg", 76), {72, -8}};

export void *StyleElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(ParcElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(StyleElems, EnumPtrs);
	__REGCMD("Alloc", StyleElems_Alloc);
	__REGCMD("Insert", StyleElems_Insert);
	__REGCMD("Rename", StyleElems_Rename);
	__REGCMD("RenameAll", StyleElems_RenameAll);
	__INITYP(StyleElems_ParcDesc, TextFrames_ParcDesc, 3);
	__INITYP(StyleElems_UpdateMsg, Texts_ElemMsg, 1);
/* BEGIN */
	StyleElems_font = Fonts_This((CHAR*)"Syntax8.Scn.Fnt", (LONGINT)16);
	__ENDMOD;
}
