/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct TableElems_ElemDesc *TableElems_Elem;

typedef
	struct TableElems_RowDesc *TableElems_Row;

typedef
	struct TableElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		Texts_Text def;
		TextFrames_Parc parc;
		SET opts;
		INTEGER nofCols, nofRows;
		LONGINT lw;
		LONGINT width[32];
		TableElems_Row row;
	} TableElems_ElemDesc;

typedef
	struct TableElems_RowDesc {
		TableElems_Row next;
		LONGINT lsp, dsr;
		LONGINT pos[32];
		LONGINT x[32], y[32];
	} TableElems_RowDesc;

typedef
	struct TableElems_ViewerDesc *TableElems_Viewer;

typedef
	struct TableElems_ViewerDesc { /* MenuViewers_ViewerDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER state;
		INTEGER menuH;
		TableElems_Elem elem;
	} TableElems_ViewerDesc;


static INTEGER TableElems_unit, TableElems_Unit;
static Texts_Writer TableElems_W;

export LONGINT *TableElems_RowDesc__typ;
export LONGINT *TableElems_ElemDesc__typ;
export LONGINT *TableElems_ViewerDesc__typ;

export void TableElems_Alloc (void);
export void TableElems_Changed (TableElems_Elem E);
static void TableElems_ColOpts (CHAR *cm, LONGINT cm__len, CHAR *s, LONGINT s__len);
export Texts_Text TableElems_CopyText (Texts_Text T);
static void TableElems_DispPrepElem (TableElems_Elem E, Texts_Elem e, Fonts_Font fnt, SHORTINT col, LONGINT pos);
export void TableElems_Draw (TableElems_Elem E, Display_Frame F, INTEGER x0, INTEGER y0);
static void TableElems_DrawString (TableElems_Elem E, Display_Frame F, LONGINT pos, INTEGER x0, INTEGER y0);
static void TableElems_GetElem (TableElems_Elem E, Texts_Elem e, Fonts_Font fnt, SHORTINT col, LONGINT pos, LONGINT *dx, LONGINT *x, LONGINT *y, LONGINT *w, LONGINT *h);
export void TableElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void TableElems_Insert (void);
static void TableElems_Line (INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static SET TableElems_LineOpts (CHAR *s, LONGINT s__len);
export void TableElems_Load (TableElems_Elem E, Files_Rider *r, LONGINT *r__typ);
static BOOLEAN TableElems_Matches (Texts_Scanner *S, LONGINT *S__typ, CHAR *key, LONGINT key__len);
static LONGINT TableElems_Max (LONGINT x, LONGINT y);
static LONGINT TableElems_Min (LONGINT x, LONGINT y);
static LONGINT TableElems_Offset (Texts_Reader *R, LONGINT *R__typ);
export void TableElems_Open (TableElems_Elem E, Texts_Text def);
export void TableElems_OpenViewer (TableElems_Elem E);
static SET TableElems_Opts (CHAR *s, LONGINT s__len);
static LONGINT TableElems_Parse (TableElems_Elem E);
export void TableElems_Print (TableElems_Elem E, INTEGER pno, INTEGER x0, INTEGER y0);
static void TableElems_PrintPrepElem (TableElems_Elem E, Texts_Elem e, Fonts_Font fnt, SHORTINT col, INTEGER pno, LONGINT pos);
static void TableElems_PrintString (TableElems_Elem E, LONGINT pos, INTEGER pno, INTEGER x0, INTEGER y0);
static void TableElems_RowOpts (CHAR *rm, LONGINT rm__len, CHAR *s, LONGINT s__len);
export void TableElems_Store (TableElems_Elem E, Files_Rider *r, LONGINT *r__typ);
export void TableElems_Track (TableElems_Elem E, LONGINT pos, SET keys, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0);
static void TableElems_UnmarkMenu (Viewers_Viewer V);
export void TableElems_Update (void);


static LONGINT TableElems_Min (LONGINT x, LONGINT y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static LONGINT TableElems_Max (LONGINT x, LONGINT y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void TableElems_UnmarkMenu (Viewers_Viewer V)
{
	Texts_Reader R = {0};
	Texts_Text T = NIL;
	CHAR ch = 0;
	T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
	Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	if (ch == '!') {
		Texts_Delete(T, T->len - 1, T->len);
	}
}

static BOOLEAN TableElems_Matches (Texts_Scanner *S, LONGINT *S__typ, CHAR *key, LONGINT key__len)
{
	INTEGER i = 0;
	__DUP(key, key__len, CHAR);
	i = 0;
	while ((*S).s[__X(i, 256)] != 0x00 && __CAP((*S).s[__X(i, 256)]) == key[__X(i, key__len)]) {
		i += 1;
	}
	__DEL(key);
	return ((*S).class == 1 && (key[__X(i, key__len)] == 0x00 || i >= 3)) && (*S).s[__X(i, 256)] == 0x00;
}

static SET TableElems_Opts (CHAR *s, LONGINT s__len)
{
	SET opts = 0;
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	opts = 0x0;
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		ch = __CAP(s[__X(i, s__len)]);
		if (ch == 'H') {
			opts |= __SETOF(1);
		} else if (ch == 'V') {
			opts |= __SETOF(0);
		} else if (s[__X(i, s__len)] == '*') {
			opts = 0x03;
		}
		i += 1;
	}
	__DEL(s);
	return opts;
}

static SET TableElems_LineOpts (CHAR *s, LONGINT s__len)
{
	SET opts = 0;
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	opts = 0x0;
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		ch = __CAP(s[__X(i, s__len)]);
		if (ch == 'H') {
			opts |= __SETOF(3);
		} else if (ch == 'V') {
			opts |= __SETOF(2);
		} else if (ch == 'L') {
			opts |= __SETOF(4);
		} else if (ch == 'R') {
			opts |= __SETOF(5);
		} else if (ch == 'T') {
			opts |= __SETOF(6);
		} else if (ch == 'B') {
			opts |= __SETOF(7);
		} else if (s[__X(i, s__len)] == '*') {
			opts = 0xfc;
		}
		i += 1;
	}
	__DEL(s);
	return opts;
}

static void TableElems_ColOpts (CHAR *cm, LONGINT cm__len, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (s[__X(i, s__len)] != 0x00 && (LONGINT)i < cm__len) {
		ch = __CAP(s[__X(i, s__len)]);
		if (((ch == 'C' || ch == 'L') || ch == 'N') || ch == 'R') {
			cm[__X(i, cm__len)] = ch;
		}
		i += 1;
	}
	__DEL(s);
}

static void TableElems_RowOpts (CHAR *rm, LONGINT rm__len, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (s[__X(i, s__len)] != 0x00 && (LONGINT)i < rm__len) {
		ch = __CAP(s[__X(i, s__len)]);
		if (((ch == 'B' || ch == 'C') || ch == 'L') || ch == 'T') {
			rm[__X(i, rm__len)] = ch;
		}
		i += 1;
	}
	__DEL(s);
}

static LONGINT TableElems_Offset (Texts_Reader *R, LONGINT *R__typ)
{
	if ((*R).voff == 0) {
		return 0;
	} else {
		return __ASHR(((LONGINT)(*R).fnt->height * (LONGINT)TableElems_unit) * (LONGINT)(*R).voff, 6);
	}
	__RETCHK;
}

static void TableElems_DispPrepElem (TableElems_Elem E, Texts_Elem e, Fonts_Font fnt, SHORTINT col, LONGINT pos)
{
	TextFrames_DisplayMsg disp = {0};
	disp.prepare = 1;
	disp.fnt = fnt;
	disp.col = col;
	disp.pos = pos;
	disp.indent = 0;
	(*e->handle)(e, (void*)&disp, TextFrames_DisplayMsg__typ);
}

static void TableElems_PrintPrepElem (TableElems_Elem E, Texts_Elem e, Fonts_Font fnt, SHORTINT col, INTEGER pno, LONGINT pos)
{
	TextPrinter_PrintMsg print = {0};
	print.prepare = 1;
	print.fnt = fnt;
	print.col = col;
	print.pos = pos;
	print.indent = 0;
	print.pno = pno;
	(*e->handle)(e, (void*)&print, TextPrinter_PrintMsg__typ);
}

static void TableElems_GetElem (TableElems_Elem E, Texts_Elem e, Fonts_Font fnt, SHORTINT col, LONGINT pos, LONGINT *dx, LONGINT *x, LONGINT *y, LONGINT *w, LONGINT *h)
{
	*x = 0;
	*y = -E->parc->dsr;
	TableElems_DispPrepElem(E, e, fnt, col, pos);
	*dx = e->W;
	*h = e->H;
	TableElems_PrintPrepElem(E, e, fnt, col, -1, pos);
	*dx = TableElems_Max(*dx, e->W);
	*h = TableElems_Max(*h, e->H);
	*w = *dx;
}

static struct Parse__23 {
	TableElems_Elem *E;
	Texts_Scanner *S;
	TableElems_Row *row;
	LONGINT *pos;
	INTEGER *state, *r, *c;
	CHAR *period;
	LONGINT *margL, *margR, *margB, *margT, *gridW, *min, *max, *cmin, *cmax, *cw, *wl;
	CHAR (*cm)[32];
	CHAR (*rm)[32];
	LONGINT (*h1)[32][32], (*h2)[32][32], (*w1)[32][32], (*w2)[32][32];
	struct Parse__23 *lnk;
} *Parse__23_s;

static void AcceptCell__24 (void);
static void Options__26 (void);
static void Scan__28 (Texts_Scanner *S, LONGINT *S__typ);
static void Setup__30 (void);

static void Setup__30 (void)
{
	(*Parse__23_s->E)->opts = 0xff;
	(*Parse__23_s->E)->lw = 7200;
	*Parse__23_s->period = '.';
	*Parse__23_s->r = 0;
	while (*Parse__23_s->r < 32) {
		(*Parse__23_s->rm)[__X(*Parse__23_s->r, 32)] = 'L';
		*Parse__23_s->r += 1;
	}
	(*Parse__23_s->cm)[0] = 'L';
	*Parse__23_s->c = 1;
	while (*Parse__23_s->c < 32) {
		(*Parse__23_s->cm)[__X(*Parse__23_s->c, 32)] = 'N';
		*Parse__23_s->c += 1;
	}
	*Parse__23_s->margL = 36000;
	*Parse__23_s->margR = *Parse__23_s->margL;
	*Parse__23_s->margB = 10800;
	*Parse__23_s->margT = *Parse__23_s->margB;
	*Parse__23_s->gridW = 180000;
}

static void Scan__28 (Texts_Scanner *S, LONGINT *S__typ)
{
	SHORTINT i = 0;
	CHAR ch = 0;
	ch = (*S).nextCh;
	i = 0;
	for (;;) {
		if (ch == 0x0d) {
			(*S).line += 1;
		} else if (ch != ' ' && ch != 0x09) {
			break;
		}
		Texts_Read((void*)&*S, S__typ, &ch);
	}
	if ('A' <= __CAP(ch) && __CAP(ch) <= 'Z') {
		do {
			(*S).s[__X(i, 256)] = ch;
			i += 1;
			Texts_Read((void*)&*S, S__typ, &ch);
		} while (!(((__CAP(ch) > 'Z' || 'A' > __CAP(ch) && ch > '9') || '0' > ch && ch != '.') || (int)i == 255));
		(*S).s[__X(i, 256)] = 0x00;
		(*S).len = i;
		(*S).class = 1;
		(*S).nextCh = ch;
	} else if (ch == '/') {
		(*S).class = 6;
		(*S).c = ch;
		Texts_Read((void*)&*S, S__typ, &(*S).nextCh);
	} else {
		(*S).nextCh = ch;
		Texts_Scan(&*S, S__typ);
	}
}

static void Options__26 (void)
{
	Texts_OpenScanner(&*Parse__23_s->S, Texts_Scanner__typ, (*Parse__23_s->E)->def, 0);
	Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
	for (;;) {
		if ((*Parse__23_s->S).eot) {
			return;
		} else if ((*Parse__23_s->S).class == 6 && (*Parse__23_s->S).c == '/') {
			Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
			if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"TABLE", (LONGINT)6)) {
				return;
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"BOTTOM", (LONGINT)7)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (((*Parse__23_s->S).class == 3 && 0 <= (*Parse__23_s->S).i) && (*Parse__23_s->S).i <= 100) {
					*Parse__23_s->margB = (*Parse__23_s->S).i * 3600;
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"COLUMNS", (LONGINT)8)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					TableElems_ColOpts((void*)*Parse__23_s->cm, 32, (*Parse__23_s->S).s, 256);
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"GRID", (LONGINT)5)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (((*Parse__23_s->S).class == 3 && 0 <= (*Parse__23_s->S).i) && (*Parse__23_s->S).i <= 100) {
					*Parse__23_s->gridW = (*Parse__23_s->S).i * 3600;
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"HEADS", (LONGINT)6)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					(*Parse__23_s->E)->opts = (*Parse__23_s->E)->opts | TableElems_Opts((*Parse__23_s->S).s, 256);
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"LEFT", (LONGINT)5)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (((*Parse__23_s->S).class == 3 && 0 <= (*Parse__23_s->S).i) && (*Parse__23_s->S).i <= 100) {
					*Parse__23_s->margL = (*Parse__23_s->S).i * 3600;
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"LINES", (LONGINT)6)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					(*Parse__23_s->E)->opts = (*Parse__23_s->E)->opts | TableElems_LineOpts((*Parse__23_s->S).s, 256);
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"NOHEADS", (LONGINT)8)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					(*Parse__23_s->E)->opts = (*Parse__23_s->E)->opts & ~TableElems_Opts((*Parse__23_s->S).s, 256);
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"NOLINES", (LONGINT)8)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					(*Parse__23_s->E)->opts = (*Parse__23_s->E)->opts & ~TableElems_LineOpts((*Parse__23_s->S).s, 256);
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"PERIOD", (LONGINT)7)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					*Parse__23_s->period = (*Parse__23_s->S).s[0];
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"RIGHT", (LONGINT)6)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (((*Parse__23_s->S).class == 3 && 0 <= (*Parse__23_s->S).i) && (*Parse__23_s->S).i <= 100) {
					*Parse__23_s->margR = (*Parse__23_s->S).i * 3600;
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"ROWS", (LONGINT)5)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (__IN((*Parse__23_s->S).class, 0x06)) {
					TableElems_RowOpts((void*)*Parse__23_s->rm, 32, (*Parse__23_s->S).s, 256);
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"TOP", (LONGINT)4)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (((*Parse__23_s->S).class == 3 && 0 <= (*Parse__23_s->S).i) && (*Parse__23_s->S).i <= 100) {
					*Parse__23_s->margT = (*Parse__23_s->S).i * 3600;
				}
			} else if (TableElems_Matches(&*Parse__23_s->S, Texts_Scanner__typ, (CHAR*)"WIDTHS", (LONGINT)7)) {
				Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
				if (((*Parse__23_s->S).class == 3 && 1 <= (*Parse__23_s->S).i) && (*Parse__23_s->S).i <= 10) {
					(*Parse__23_s->E)->lw = (*Parse__23_s->S).i * 3600;
				}
			}
			Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
		} else {
			Scan__28(&*Parse__23_s->S, Texts_Scanner__typ);
		}
	}
}

static void AcceptCell__24 (void)
{
	(*Parse__23_s->row)->pos[__X(*Parse__23_s->c, 32)] = *Parse__23_s->pos;
	(*Parse__23_s->w1)[__X(*Parse__23_s->r, 32)][__X(*Parse__23_s->c, 32)] = *Parse__23_s->cw;
	(*Parse__23_s->h1)[__X(*Parse__23_s->r, 32)][__X(*Parse__23_s->c, 32)] = *Parse__23_s->cmax - *Parse__23_s->cmin;
	(*Parse__23_s->h2)[__X(*Parse__23_s->r, 32)][__X(*Parse__23_s->c, 32)] = -*Parse__23_s->cmin;
	*Parse__23_s->min = TableElems_Min(*Parse__23_s->min, *Parse__23_s->cmin);
	*Parse__23_s->max = TableElems_Max(*Parse__23_s->max, *Parse__23_s->cmax);
	switch (*Parse__23_s->state) {
		case 0: case 1: 
			(*Parse__23_s->w2)[__X(*Parse__23_s->r, 32)][__X(*Parse__23_s->c, 32)] = *Parse__23_s->cw;
			break;
		case 2: 
			(*Parse__23_s->w2)[__X(*Parse__23_s->r, 32)][__X(*Parse__23_s->c, 32)] = *Parse__23_s->wl;
			break;
		case 3: 
			(*Parse__23_s->w2)[__X(*Parse__23_s->r, 32)][__X(*Parse__23_s->c, 32)] = -1;
			break;
		default: __CASECHK;
	}
	*Parse__23_s->pos = Texts_Pos((void*)&*Parse__23_s->S, Texts_Scanner__typ);
	*Parse__23_s->c += 1;
	*Parse__23_s->cmin = -(*Parse__23_s->E)->parc->dsr;
	*Parse__23_s->cmax = 0;
	*Parse__23_s->cw = 0;
	*Parse__23_s->state = 0;
	if (*Parse__23_s->c > (*Parse__23_s->E)->nofCols) {
		if (*Parse__23_s->c < 32) {
			(*Parse__23_s->E)->nofCols += 1;
		} else {
			*Parse__23_s->c -= 1;
		}
	}
}

static LONGINT TableElems_Parse (TableElems_Elem E)
{
	Texts_Scanner S = {0};
	TableElems_Row row = NIL;
	LONGINT pbeg = 0, beg = 0, pos = 0;
	INTEGER state = 0, st = 0, r = 0, c = 0;
	CHAR ch = 0, period = 0;
	LONGINT margL = 0, margR = 0, margB = 0, margT = 0, gridW = 0, lsp = 0, dsr = 0, min = 0, max = 0, cmin = 0, cmax = 0, cw = 0, wl = 0, wr = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR cm[32];
	CHAR rm[32];
	LONGINT h1[32][32], h2[32][32], w1[32][32], w2[32][32];
	struct Parse__23 _s;
	LONGINT __retval;
	_s.E = &E;
	_s.S = &S;
	_s.row = &row;
	_s.pos = &pos;
	_s.state = &state;
	_s.r = &r;
	_s.c = &c;
	_s.period = &period;
	_s.margL = &margL;
	_s.margR = &margR;
	_s.margB = &margB;
	_s.margT = &margT;
	_s.gridW = &gridW;
	_s.min = &min;
	_s.max = &max;
	_s.cmin = &cmin;
	_s.cmax = &cmax;
	_s.cw = &cw;
	_s.wl = &wl;
	_s.cm = (void*)cm;
	_s.rm = (void*)rm;
	_s.h1 = (void*)h1;
	_s.h2 = (void*)h2;
	_s.w1 = (void*)w1;
	_s.w2 = (void*)w2;
	_s.lnk = Parse__23_s;
	Parse__23_s = &_s;
	Setup__30();
	Options__26();
	margL += E->lw;
	margR += E->lw;
	margB += E->lw;
	margT += E->lw;
	E->nofCols = 0;
	E->nofRows = 0;
	ch = S.nextCh;
	while (!S.eot && ch != 0x0d) {
		Texts_Read((void*)&S, Texts_Scanner__typ, &ch);
	}
	beg = Texts_Pos((void*)&S, Texts_Scanner__typ);
	TextFrames_ParcBefore(E->def, beg, &E->parc, &pbeg);
	pos = beg;
	E->row = NIL;
	if (!S.eot) {
		__NEW(row, TableElems_RowDesc);
		r = 0;
		min = 0;
		max = 0;
		c = 0;
		cmin = -E->parc->dsr;
		cmax = 0;
		cw = 0;
		state = 0;
		for (;;) {
			Texts_Read((void*)&S, Texts_Scanner__typ, &ch);
			if (S.eot) {
				break;
			} else if (ch == 0x0d) {
				AcceptCell__24();
				if (__IN(0, E->parc->opts)) {
					dsr = E->parc->dsr;
					while (dsr < -min) {
						dsr += E->parc->lsp;
					}
					lsp = TableElems_Max(E->parc->lsp, dsr + max);
					lsp += __MOD(-lsp, E->parc->lsp);
				} else {
					dsr = TableElems_Max(E->parc->dsr, -min);
					lsp = TableElems_Max(E->parc->lsp, dsr + max);
				}
				row->dsr = dsr + margB;
				row->lsp = (lsp + margB) + margT;
				while (c < 32) {
					row->pos[__X(c, 32)] = E->def->len;
					h1[__X(r, 32)][__X(c, 32)] = 0;
					h2[__X(r, 32)][__X(c, 32)] = 0;
					w1[__X(r, 32)][__X(c, 32)] = 0;
					w2[__X(r, 32)][__X(c, 32)] = -1;
					c += 1;
				}
				row->next = E->row;
				E->row = row;
				r += 1;
				if (r == 32) {
					break;
				}
				__NEW(row, TableElems_RowDesc);
				min = 0;
				max = 0;
				c = 0;
			} else if (ch == 0x09) {
				AcceptCell__24();
			} else {
				st = state;
				if (state < 2 && ch == period) {
					wl = cw;
					state = 2;
				} else if (state == 0 && (((ch >= '0' && ch <= '9' || ch == '+') || ch == '-') || ch == '#')) {
					state = 1;
				} else if (state == 0) {
					state = 3;
				}
				if (st != 0 || ch != '#' && ch != '&') {
					if (S.elem != NIL && !__ISP(S.elem, TextFrames_ParcDesc, 2)) {
						TableElems_GetElem(E, S.elem, S.fnt, S.col, Texts_Pos((void*)&S, Texts_Scanner__typ) - 1, &dx, &x, &y, &w, &h);
					} else {
						TextPrinter_Get(TextPrinter_FontNo(S.fnt), ch, &dx, &x, &y, &w, &h);
					}
					y += TableElems_Offset((void*)&S, Texts_Scanner__typ);
					cmin = TableElems_Min(cmin, y);
					cmax = TableElems_Max(cmax, y + h);
					cw += dx;
				}
			}
		}
		E->nofRows = r;
	}
	if (E->nofRows < 2) {
		E->opts &= ~__SETOF(1);
	}
	if (E->nofCols < 2) {
		E->opts &= ~__SETOF(0);
	}
	c = 0;
	while (c < E->nofCols) {
		if (cm[__X(c, 32)] == 'N') {
			wl = 0;
			wr = 0;
			r = 0;
			while (r < E->nofRows) {
				if (w2[__X(r, 32)][__X(c, 32)] > wl) {
					wl = w2[__X(r, 32)][__X(c, 32)];
				}
				if (w2[__X(r, 32)][__X(c, 32)] >= 0 && w1[__X(r, 32)][__X(c, 32)] - w2[__X(r, 32)][__X(c, 32)] > wr) {
					wr = w1[__X(r, 32)][__X(c, 32)] - w2[__X(r, 32)][__X(c, 32)];
				}
				r += 1;
			}
			cw = wl + wr;
		} else {
			cw = 0;
		}
		r = 0;
		while (r < E->nofRows) {
			if (w1[__X(r, 32)][__X(c, 32)] > cw) {
				cw = w1[__X(r, 32)][__X(c, 32)];
			}
			r += 1;
		}
		cw += margL + margR;
		if (gridW > 0) {
			cw += __MOD(-cw, gridW);
		}
		r = E->nofRows;
		row = E->row;
		while (r > 0) {
			r -= 1;
			if (cm[__X(c, 32)] == 'L') {
				row->x[__X(c, 32)] = margL;
			} else if (cm[__X(c, 32)] == 'R') {
				row->x[__X(c, 32)] = (cw - margR) - w1[__X(r, 32)][__X(c, 32)];
			} else if (cm[__X(c, 32)] == 'C' || w2[__X(r, 32)][__X(c, 32)] == -1) {
				row->x[__X(c, 32)] = __ASHR(cw - w1[__X(r, 32)][__X(c, 32)], 1);
			} else if (cm[__X(c, 32)] == 'N') {
				row->x[__X(c, 32)] = (__ASHR((cw - wl) - wr, 1) + wl) - w2[__X(r, 32)][__X(c, 32)];
			}
			if (rm[__X(r, 32)] == 'B') {
				row->y[__X(c, 32)] = margB + h2[__X(r, 32)][__X(c, 32)];
			} else if (rm[__X(r, 32)] == 'T') {
				row->y[__X(c, 32)] = ((row->lsp - h1[__X(r, 32)][__X(c, 32)]) - margB) + h2[__X(r, 32)][__X(c, 32)];
			} else if (rm[__X(r, 32)] == 'C') {
				row->y[__X(c, 32)] = __ASHR(row->lsp - h1[__X(r, 32)][__X(c, 32)], 1) + h2[__X(r, 32)][__X(c, 32)];
			} else if (rm[__X(r, 32)] == 'L') {
				row->y[__X(c, 32)] = row->dsr;
			}
			row = row->next;
		}
		E->width[__X(c, 32)] = cw;
		c += 1;
	}
	__retval = beg;
	Parse__23_s = _s.lnk;
	;
	return __retval;
}

Texts_Text TableElems_CopyText (Texts_Text T)
{
	Texts_Buffer B = NIL;
	Texts_Text t = NIL;
	__NEW(B, Texts_BufDesc);
	Texts_OpenBuf(B);
	Texts_Save(T, 0, T->len, B);
	__NEW(t, Texts_TextDesc);
	Texts_Open(t, (CHAR*)"", (LONGINT)1);
	t->notify = T->notify;
	Texts_Append(t, B);
	return t;
}

void TableElems_Open (TableElems_Elem E, Texts_Text def)
{
	TableElems_Row row = NIL;
	LONGINT beg = 0;
	INTEGER i = 0;
	E->def = def;
	beg = TableElems_Parse(E);
	E->W = 0;
	i = 0;
	while (i < E->nofCols) {
		E->W += E->width[__X(i, 32)];
		i += 1;
	}
	E->H = 0;
	row = E->row;
	while (row != NIL) {
		E->H += row->lsp;
		row = row->next;
	}
	if (__IN(1, E->opts) && __IN(3, E->opts)) {
		E->H += __ASHL(E->lw, 1);
	}
	if (__IN(0, E->opts) && __IN(2, E->opts)) {
		E->W += __ASHL(E->lw, 1);
	}
	if (E->W < 108000) {
		E->W = 108000;
	}
	if (E->H < 108000) {
		E->H = 108000;
	}
}

void TableElems_Load (TableElems_Elem E, Files_Rider *r, LONGINT *r__typ)
{
	Texts_Text text = NIL;
	Files_File f = NIL;
	LONGINT pos = 0, len = 0;
	CHAR version = 0, tag = 0;
	Files_Read(&*r, r__typ, (void*)&version);
	__NEW(text, Texts_TextDesc);
	Texts_Load(&*r, r__typ, text);
	text->notify = TextFrames_NotifyDisplay;
	TableElems_Open(E, text);
}

void TableElems_Store (TableElems_Elem E, Files_Rider *r, LONGINT *r__typ)
{
	Files_File f = NIL;
	LONGINT pos = 0, len = 0;
	Files_Write(&*r, r__typ, 0x01);
	Texts_Store(&*r, r__typ, E->def);
}

void TableElems_Changed (TableElems_Elem E)
{
	Texts_Reader R = {0};
	Texts_Text T = NIL;
	T = Texts_ElemBase((void*)E);
	if (T != NIL) {
		Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
		do {
			Texts_ReadElem(&R, Texts_Reader__typ);
		} while (!(R.elem == (void *) E));
		(*T->notify)(T, 0, Texts_Pos(&R, Texts_Reader__typ) - 1, Texts_Pos(&R, Texts_Reader__typ));
	}
}

static void TableElems_Line (INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_ReplConst(15, x, y, w, h, 0);
}

static void TableElems_DrawString (TableElems_Elem E, Display_Frame F, LONGINT pos, INTEGER x0, INTEGER y0)
{
	Texts_Reader R = {0};
	Texts_Elem e = NIL;
	LONGINT pat = 0, px = 0, pdx = 0;
	INTEGER dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR ch = 0;
	TextFrames_DisplayMsg disp = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, E->def, pos);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	px = (LONGINT)x0 * (LONGINT)TableElems_unit;
	if (ch == '#' || ch == '&') {
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
	while ((!R.eot && ch != 0x09) && ch != 0x0d) {
		if (R.elem != NIL) {
			if (__ISP(R.elem, TextFrames_ParcDesc, 2)) {
				pdx = 0;
			} else {
				e = R.elem;
				TableElems_DispPrepElem(E, e, R.fnt, R.col, Texts_Pos(&R, Texts_Reader__typ) - 1);
				pdx = e->W;
				disp.prepare = 0;
				disp.fnt = R.fnt;
				disp.col = R.col;
				disp.pos = Texts_Pos(&R, Texts_Reader__typ) - 1;
				disp.frame = F;
				disp.X0 = (int)__DIV(px, (LONGINT)TableElems_unit);
				disp.Y0 = y0 + (int)__DIVF(TableElems_Offset(&R, Texts_Reader__typ) - E->parc->dsr, (LONGINT)TableElems_unit);
				disp.indent = 0;
				(*e->handle)(e, (void*)&disp, TextFrames_DisplayMsg__typ);
			}
		} else {
			TextPrinter_GetChar(TextPrinter_FontNo(R.fnt), TableElems_unit, ch, &pdx, &dx, &x, &y, &w, &h, &pat);
			Display_CopyPattern(R.col, pat, (int)__DIV(px, (LONGINT)TableElems_unit) + x, (y0 + (int)__DIVF(TableElems_Offset(&R, Texts_Reader__typ), (LONGINT)TableElems_unit)) + y, 0);
		}
		px += pdx;
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
}

static struct Draw__6 {
	struct Draw__6 *lnk;
} *Draw__6_s;

static LONGINT Align__7 (LONGINT x);

static LONGINT Align__7 (LONGINT x)
{
	return x + __MOD(-x, (LONGINT)TableElems_unit);
}

void TableElems_Draw (TableElems_Elem E, Display_Frame F, INTEGER x0, INTEGER y0)
{
	TableElems_Row row = NIL;
	INTEGER r = 0, c = 0, x = 0, y = 0, w = 0, h = 0, h1 = 0, lw = 0, d = 0;
	struct Draw__6 _s;
	_s.lnk = Draw__6_s;
	Draw__6_s = &_s;
	if (E->nofRows == 0 || E->nofCols == 0) {
		w = (int)__DIV(E->W, (LONGINT)TableElems_unit);
		h = (int)__DIV(E->H, (LONGINT)TableElems_unit);
		Display_ReplPattern(15, Display_grey1, x0, y0, w, h, 0);
	} else {
		r = E->nofRows;
		row = E->row;
		y = y0;
		lw = (int)__DIVF(Align__7(E->lw), (LONGINT)TableElems_unit);
		d = (int)__DIV(__ASHL(E->lw, 1), (LONGINT)TableElems_unit);
		while (r > 0) {
			r -= 1;
			x = x0;
			c = 0;
			h = (int)__DIV(row->lsp, (LONGINT)TableElems_unit);
			h1 = h;
			if ((r == 1 && __IN(1, E->opts)) && __IN(3, E->opts)) {
				h1 += d;
			}
			while (c < E->nofCols) {
				w = (int)__DIV(E->width[__X(c, 32)], (LONGINT)TableElems_unit);
				if (c == 0) {
					if (__IN(0, E->opts)) {
						TableElems_Line((x + w) - lw, y, lw, h);
						if (__IN(2, E->opts)) {
							w += d;
						}
					}
					if (__IN(4, E->opts)) {
						TableElems_Line(x, y, lw, h1);
					}
				} else if (__IN(2, E->opts)) {
					TableElems_Line(x, y, lw, h);
				}
				if (c == E->nofCols - 1 && __IN(5, E->opts)) {
					TableElems_Line((x + w) - lw, y, lw, h1);
				}
				if (r == 0 && __IN(6, E->opts) || r == 1 && __IN(1, E->opts)) {
					TableElems_Line(x, (y + h) - lw, w, lw);
				}
				if (r == E->nofRows - 1 && __IN(7, E->opts) || r < E->nofRows - 1 && __IN(3, E->opts)) {
					TableElems_Line(x, y, w, lw);
				}
				TableElems_DrawString(E, F, row->pos[__X(c, 32)], x + (int)__DIV(row->x[__X(c, 32)], (LONGINT)TableElems_unit), y + (int)__DIV(row->y[__X(c, 32)], (LONGINT)TableElems_unit));
				x += w;
				c += 1;
			}
			y += h1;
			row = row->next;
		}
	}
	Draw__6_s = _s.lnk;
}

static void TableElems_PrintString (TableElems_Elem E, LONGINT pos, INTEGER pno, INTEGER x0, INTEGER y0)
{
	Texts_Reader R = {0};
	Texts_Elem e = NIL;
	Fonts_Font fnt = NIL;
	INTEGER i = 0, w = 0, dy = 0;
	SHORTINT voff = 0, fno = 0;
	CHAR ch = 0;
	BOOLEAN first = 0;
	TextPrinter_PrintMsg print = {0};
	CHAR s[256];
	Texts_OpenReader(&R, Texts_Reader__typ, E->def, pos);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	first = 1;
	if (ch == '#' || ch == '&') {
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
	while ((!R.eot && ch != 0x09) && ch != 0x0d) {
		while (!R.eot && R.elem != NIL) {
			if (!__ISP(R.elem, TextFrames_ParcDesc, 2)) {
				e = R.elem;
				TableElems_PrintPrepElem(E, e, R.fnt, R.col, pno, Texts_Pos(&R, Texts_Reader__typ) - 1);
				print.prepare = 0;
				print.indent = 0;
				print.fnt = R.fnt;
				print.col = R.col;
				print.pos = Texts_Pos(&R, Texts_Reader__typ) - 1;
				print.X0 = x0;
				print.Y0 = y0 + (int)__DIVF(TableElems_Offset(&R, Texts_Reader__typ) - E->parc->dsr, (LONGINT)TableElems_Unit);
				print.pno = pno;
				(*e->handle)(e, (void*)&print, TextPrinter_PrintMsg__typ);
				x0 += (int)__DIV(e->W, (LONGINT)TableElems_Unit);
				first = 1;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		if ((!R.eot && ch != 0x09) && ch != 0x0d) {
			fnt = R.fnt;
			fno = TextPrinter_FontNo(fnt);
			voff = R.voff;
			dy = (int)__DIVF(TableElems_Offset(&R, Texts_Reader__typ), (LONGINT)TableElems_Unit);
			i = 0;
			w = 0;
			do {
				s[__X(i, 256)] = ch;
				i += 1;
				w += (int)__DIVF(TextPrinter_DX(fno, ch), (LONGINT)TableElems_Unit);
				Texts_Read(&R, Texts_Reader__typ, &ch);
			} while (!((((((R.eot || R.elem != NIL) || ch == 0x09) || ch == 0x0d) || fno != TextPrinter_FontNo(R.fnt)) || voff != R.voff) || i == 255));
			s[__X(i, 256)] = 0x00;
			if (voff != 0) {
				Printer_String(x0, y0 + dy, (void*)s, 256, (void*)fnt->name, 32);
				first = 1;
			} else if (first) {
				Printer_String(x0, y0 + dy, (void*)s, 256, (void*)fnt->name, 32);
				first = 0;
			} else {
				Printer_ContString((void*)s, 256, (void*)fnt->name, 32);
			}
			x0 += w;
		}
	}
}

void TableElems_Print (TableElems_Elem E, INTEGER pno, INTEGER x0, INTEGER y0)
{
	TableElems_Row row = NIL;
	INTEGER r = 0, c = 0, x = 0, y = 0, w = 0, h = 0, h1 = 0, lw = 0, d = 0;
	r = E->nofRows;
	row = E->row;
	y = y0;
	lw = (int)__DIV(E->lw, (LONGINT)TableElems_Unit);
	d = (int)__DIV(__ASHL(E->lw, 1), (LONGINT)TableElems_Unit);
	while (r > 0) {
		r -= 1;
		x = x0;
		c = 0;
		h = (int)__DIV(row->lsp, (LONGINT)TableElems_Unit);
		h1 = h;
		if ((r == 1 && __IN(1, E->opts)) && __IN(3, E->opts)) {
			h1 += d;
		}
		while (c < E->nofCols) {
			w = (int)__DIV(E->width[__X(c, 32)], (LONGINT)TableElems_Unit);
			if (c == 0) {
				if (__IN(0, E->opts)) {
					Printer_ReplConst((x + w) - lw, y, lw, h);
					if (__IN(2, E->opts)) {
						w += d;
					}
				}
				if (__IN(4, E->opts)) {
					Printer_ReplConst(x, y, lw, h1);
				}
			} else if (__IN(2, E->opts)) {
				Printer_ReplConst(x, y, lw, h);
			}
			if (c == E->nofCols - 1 && __IN(5, E->opts)) {
				Printer_ReplConst((x + w) - lw, y, lw, h1);
			}
			if (r == 0 && __IN(6, E->opts) || r == 1 && __IN(1, E->opts)) {
				Printer_ReplConst(x, (y + h) - lw, w, lw);
			}
			if (r == E->nofRows - 1 && __IN(7, E->opts) || r < E->nofRows - 1 && __IN(3, E->opts)) {
				Printer_ReplConst(x, y, w, lw);
			}
			TableElems_PrintString(E, row->pos[__X(c, 32)], pno, x + (int)__DIV(row->x[__X(c, 32)], (LONGINT)TableElems_Unit), y + (int)__DIV(row->y[__X(c, 32)], (LONGINT)TableElems_Unit));
			x += w;
			c += 1;
		}
		y += h1;
		row = row->next;
	}
}

void TableElems_OpenViewer (TableElems_Elem E)
{
	TableElems_Viewer V = NIL;
	TextFrames_Frame menu = NIL, body = NIL;
	INTEGER x = 0, y = 0;
	Viewers_ViewerMsg restore = {0};
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	menu = TextFrames_NewMenu((CHAR*)"TableElems.Text", (LONGINT)16, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Search  Edit.Replace  Edit.Parcs  TableElems.Update ", (LONGINT)98);
	body = TextFrames_NewText(TableElems_CopyText(E->def), 0);
	__NEW(V, TableElems_ViewerDesc);
	V->handle = MenuViewers_Handle;
	V->dsc = (Display_Frame)menu;
	V->dsc->next = (Display_Frame)body;
	V->menuH = TextFrames_menuH;
	V->elem = E;
	Viewers_Open((void*)V, x, y);
	restore.id = 0;
	(*V->handle)((void*)V, (void*)&restore, Viewers_ViewerMsg__typ);
}

void TableElems_Track (TableElems_Elem E, LONGINT pos, SET keys, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0)
{
	SET keysum = 0;
	if (__IN(1, keys)) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
			keysum = keysum | keys;
		} while (!(keys == 0x0));
		if (keysum == 0x02) {
			TableElems_OpenViewer(E);
		}
	}
}

void TableElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	TableElems_Elem e = NIL;
	if (__ISP(E, TableElems_ElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				TableElems_Draw((*(TableElems_Elem*)&E), (*msg__).frame, (*msg__).X0, (*msg__).Y0);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				TableElems_Print((*(TableElems_Elem*)&E), (*msg__).pno, (*msg__).X0, (*msg__).Y0);
			}
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("TableElems", (*msg__).mod, 11);
			__MOVE("Alloc", (*msg__).proc, 6);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				TableElems_Load((*(TableElems_Elem*)&E), &(*msg__).r, Files_Rider__typ);
			} else if ((*msg__).id == 1) {
				TableElems_Store((*(TableElems_Elem*)&E), &(*msg__).r, Files_Rider__typ);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			__NEW(e, TableElems_ElemDesc);
			Texts_CopyElem((void*)(*(TableElems_Elem*)&E), (void*)e);
			TableElems_Open(e, TableElems_CopyText((*(TableElems_Elem*)&E)->def));
			(*msg__).e = (Texts_Elem)e;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			TableElems_Track((*(TableElems_Elem*)&E), (*msg__).pos, (*msg__).keys, (*msg__).X, (*msg__).Y, (*msg__).X0, (*msg__).Y0);
		}
	} else __WITHCHK;
}

void TableElems_Alloc (void)
{
	TableElems_Elem e = NIL;
	__NEW(e, TableElems_ElemDesc);
	e->handle = TableElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void TableElems_Insert (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	TableElems_Elem e = NIL;
	Texts_Text t = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (S.class == 1 && S.line == 0) {
		t = TextFrames_Text(S.s, 256);
	} else {
		t = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_WriteString(&TableElems_W, Texts_Writer__typ, (CHAR*)"/table", (LONGINT)7);
		Texts_WriteLn(&TableElems_W, Texts_Writer__typ);
		Texts_Append(t, TableElems_W.buf);
	}
	__NEW(e, TableElems_ElemDesc);
	e->handle = TableElems_Handle;
	TableElems_Open(e, t);
	m.e = (Texts_Elem)e;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&m, TextFrames_InsertElemMsg__typ);
}

void TableElems_Update (void)
{
	TableElems_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	V = __GUARDP(Oberon_Par->vwr, TableElems_ViewerDesc, 3);
	F = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
	TableElems_Open(V->elem, TableElems_CopyText(F->text));
	TableElems_Changed(V->elem);
	TableElems_UnmarkMenu((void*)V);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&TableElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(TableElems_RowDesc, 1, 1) = {__TDFLDS("RowDesc", 396), {0, -8}};
__TDESC(TableElems_ElemDesc, 1, 7) = {__TDFLDS("ElemDesc", 188), {0, 4, 12, 32, 36, 40, 184, -32}};
__TDESC(TableElems_ViewerDesc, 1, 3) = {__TDFLDS("ViewerDesc", 28), {0, 4, 24, -16}};

export void *TableElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(TableElems, EnumPtrs);
	__REGCMD("Alloc", TableElems_Alloc);
	__REGCMD("Insert", TableElems_Insert);
	__REGCMD("Update", TableElems_Update);
	__INITYP(TableElems_RowDesc, TableElems_RowDesc, 0);
	__INITYP(TableElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(TableElems_ViewerDesc, MenuViewers_ViewerDesc, 3);
/* BEGIN */
	TableElems_unit = TextFrames_Unit;
	TableElems_Unit = 3048;
	Texts_OpenWriter(&TableElems_W, Texts_Writer__typ);
	__ENDMOD;
}
