/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "HandlerElems.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "ParcElems.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct TextAreaElems_ElemDesc *TextAreaElems_Elem;

typedef
	struct TextAreaElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text txt;
		BOOLEAN readOnly, scrBar;
	} TextAreaElems_ElemDesc;

typedef
	struct TextAreaElems_FrameDesc *TextAreaElems_Frame;

typedef
	struct TextAreaElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		TextAreaElems_Elem e;
	} TextAreaElems_FrameDesc;


static Texts_Writer TextAreaElems_W;
static TextAreaElems_Elem TextAreaElems_curElem;

export LONGINT *TextAreaElems_FrameDesc__typ;
export LONGINT *TextAreaElems_ElemDesc__typ;

export void TextAreaElems_Draw (TextAreaElems_Elem e, INTEGER x, INTEGER y, Display_Frame f);
export void TextAreaElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void TextAreaElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void TextAreaElems_HandleAttrMsg (TextAreaElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void TextAreaElems_Init (TextAreaElems_Elem e);
export void TextAreaElems_Insert (void);
export void TextAreaElems_InsertParc (TextAreaElems_Elem e, TextFrames_Frame f);
export void TextAreaElems_New (void);
export Display_Frame TextAreaElems_OpenFrame (TextAreaElems_Elem e, Display_Frame f, Display_Handler textHandler, Display_Handler frameHandler, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextAreaElems_SetFrameCoords (TextAreaElems_Frame src, TextFrames_Frame dest);
export void TextAreaElems_TextHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void TextAreaElems_TextToString (Texts_Text t, LONGINT pos, CHAR *str, LONGINT str__len);


void TextAreaElems_TextToString (Texts_Text t, LONGINT pos, CHAR *str, LONGINT str__len)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	INTEGER i = 0, len = 0;
	len = (int)str__len;
	i = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while ((!r.eot && ch != 0x0d) && i < len - 1) {
		while (!r.eot && ch == 0x1c) {
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		if (!r.eot && ch != 0x0d) {
			str[__X(i, str__len)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
	}
	str[__X(i, str__len)] = 0x00;
}

static void TextAreaElems_SetFrameCoords (TextAreaElems_Frame src, TextFrames_Frame dest)
{
	dest->X = src->X + 2;
	dest->Y = src->Y + 2;
	dest->H = src->H - 4;
	dest->W = src->W - 4;
}

void TextAreaElems_InsertParc (TextAreaElems_Elem e, TextFrames_Frame f)
{
	TextFrames_Parc p = NIL;
	Texts_Reader r = {0};
	BOOLEAN insert = 0;
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	CHAR ch = 0;
	if (f->text->len == 0) {
		__NEW(p, TextFrames_ParcDesc);
		insert = 1;
	} else {
		Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.elem != NIL && Texts_Pos(&r, Texts_Reader__typ) == 1) {
			if (__ISP(r.elem, TextFrames_ParcDesc, 2)) {
				insert = 0;
				p = __GUARDP(r.elem, TextFrames_ParcDesc, 2);
			} else {
				__NEW(p, TextFrames_ParcDesc);
				insert = 1;
			}
		} else {
			__NEW(p, TextFrames_ParcDesc);
			insert = 1;
		}
	}
	Elems_GetLook((void*)e, &fnt, &col);
	if (insert) {
		ParcElems_CopyParc(TextFrames_defParc, p);
		p->width = (LONGINT)((f->W - f->left) - f->right) * (LONGINT)TextFrames_Unit;
		Texts_SetFont(&TextAreaElems_W, Texts_Writer__typ, fnt);
		Texts_SetColor(&TextAreaElems_W, Texts_Writer__typ, col);
		Texts_WriteElem(&TextAreaElems_W, Texts_Writer__typ, (void*)p);
		if (f->text->len == 0) {
			Texts_WriteLn(&TextAreaElems_W, Texts_Writer__typ);
		}
		Texts_Insert(f->text, 0, TextAreaElems_W.buf);
	} else {
		Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		if (ch == 0x1c && __ISP(r.elem, TextFrames_ParcDesc, 2)) {
			__GUARDP(r.elem, TextFrames_ParcDesc, 2)->width = (LONGINT)((f->W - f->left) - f->right) * (LONGINT)TextFrames_Unit;
			r.elem->W = __GUARDP(r.elem, TextFrames_ParcDesc, 2)->width;
		}
		Texts_ChangeLooks(f->text, 0, 1, 0x03, fnt, col, 0);
	}
}

void TextAreaElems_TextHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	TextFrames_TrackMsg track = {0};
	BOOLEAN done = 0;
	if (__ISP(f, TextFrames_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 1) {
				track.X0 = (*(TextFrames_Frame*)&f)->X;
				track.Y0 = (*(TextFrames_Frame*)&f)->Y;
				track.X = (*msg__).X;
				track.Y = (*msg__).Y;
				track.keys = (*msg__).keys;
				track.frame = (Display_Frame)(*(TextFrames_Frame*)&f);
				done = 0;
				Elems_Track((void*)TextAreaElems_curElem, (void*)&track, TextFrames_TrackMsg__typ, &done);
				if (!done && TextAreaElems_curElem->readOnly) {
					if ((*msg__).X >= (*(TextFrames_Frame*)&f)->X && (*msg__).X < (*(TextFrames_Frame*)&f)->X + (*(TextFrames_Frame*)&f)->barW) {
						(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
					} else if ((*msg__).keys != 0x04) {
						(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
					}
				} else if (!done) {
					(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
				} else {
					Elems_UpdateElem((void*)TextAreaElems_curElem);
				}
			} else if ((*msg__).id == 0 && !TextAreaElems_curElem->readOnly) {
				(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else {
			(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void TextAreaElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
		MenuViewers_ModifyMsg *msg__ = (void*)msg;
		TextAreaElems_SetFrameCoords(__GUARDP(f, TextAreaElems_FrameDesc, 1), __GUARDP(f->dsc, TextFrames_FrameDesc, 1));
	} else if (__IS(msg__typ, Elems_GetFrameMsg, 1)) {
		Elems_GetFrameMsg *msg__ = (void*)msg;
		if ((*msg__).e == (void *) __GUARDP(f, TextAreaElems_FrameDesc, 1)->e) {
			(*msg__).f = f->dsc;
		}
	} else if (__IS(msg__typ, Elems_GetContextMsg, 1)) {
		Elems_GetContextMsg *msg__ = (void*)msg;
		if ((*msg__).p == (void *) __GUARDP(f, TextAreaElems_FrameDesc, 1)->e && ((((*msg__).fx >= f->X && (*msg__).fx <= f->X + f->W) && (*msg__).fy >= f->Y) && (*msg__).fy <= f->Y + f->H || (*msg__).fx < 0 && (*msg__).fy < 0)) {
			(*msg__).context = f;
			(*msg__).p = NIL;
		}
	} else {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			TextAreaElems_curElem = __GUARDP(f, TextAreaElems_FrameDesc, 1)->e;
		}
		(*f->dsc->handle)(f->dsc, &*msg, msg__typ);
	}
}

Display_Frame TextAreaElems_OpenFrame (TextAreaElems_Elem e, Display_Frame f, Display_Handler textHandler, Display_Handler frameHandler, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	TextAreaElems_Frame new = NIL;
	MenuViewers_ModifyMsg m = {0};
	TextFrames_Frame tf = NIL;
	__NEW(new, TextAreaElems_FrameDesc);
	new->handle = frameHandler;
	new->e = e;
	new->X = x;
	new->Y = y;
	new->W = w;
	new->H = h;
	tf = TextFrames_NewText(e->txt, 0);
	tf->handle = textHandler;
	e->txt->notify = NIL;
	tf->right = 2;
	tf->top = 2;
	tf->bot = 0;
	if (e->scrBar) {
		tf->barW = TextFrames_barW;
	} else {
		tf->barW = 0;
	}
	tf->left = tf->barW + 5;
	tf->showsParcs = 0;
	Elems_AdjustSubFrame(f, (void*)new);
	TextAreaElems_SetFrameCoords(new, tf);
	TextAreaElems_InsertParc(e, tf);
	e->txt->notify = TextFrames_NotifyDisplay;
	new->dsc = (Display_Frame)tf;
	m.id = 1;
	m.Y = new->dsc->Y;
	m.H = new->dsc->H;
	(*new->dsc->handle)(new->dsc, (void*)&m, MenuViewers_ModifyMsg__typ);
	return (void*)new;
}

static void TextAreaElems_HandleAttrMsg (TextAreaElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 2;
			TextAreaElems_TextToString(e->txt, 0, (void*)(*msg).s, 256);
		} else if (__STRCMP((*msg).name, "ValueT") == 0) {
			(*msg).class = 9;
			(*msg).t = e->txt;
		} else if (__STRCMP((*msg).name, "ReadOnly") == 0) {
			(*msg).class = 7;
			(*msg).b = e->readOnly;
		} else if (__STRCMP((*msg).name, "Scrollbar") == 0) {
			(*msg).class = 7;
			(*msg).b = e->scrBar;
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			if ((*msg).class == 2) {
				Texts_Delete(e->txt, 0, e->txt->len);
				Texts_WriteString(&TextAreaElems_W, Texts_Writer__typ, (*msg).s, 256);
				Texts_Append(e->txt, TextAreaElems_W.buf);
			}
		} else if (__STRCMP((*msg).name, "ValueT") == 0) {
			if ((*msg).class == 9) {
				e->txt = (*msg).t;
			}
		} else if (__STRCMP((*msg).name, "ReadOnly") == 0) {
			if ((*msg).class == 7) {
				e->readOnly = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Scrollbar") == 0) {
			if ((*msg).class == 7) {
				e->scrBar = (*msg).b;
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"ValueT", (LONGINT)7, 9);
		(*(*msg).enum_)((CHAR*)"Scrollbar", (LONGINT)10, 7);
		(*(*msg).enum_)((CHAR*)"ReadOnly", (LONGINT)9, 7);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

void TextAreaElems_Draw (TextAreaElems_Elem e, INTEGER x, INTEGER y, Display_Frame f)
{
	LONGINT pos = 0;
	INTEGER dx = 0, w = 0, h = 0;
	GUtils_Area(f, 0, 12, x, y, GUtils_Unit(e->W, 1), GUtils_Unit(e->H, 1), GUtils_Unit(2, 0), 0, 1);
	if (GUtils_device == 1) {
		dx = 0;
		pos = 0;
		if (e->scrBar) {
			dx = GUtils_Unit(TextFrames_barW, 0);
			GUtils_ReplConst(f, 0, x + dx, y, GUtils_Unit(1, 0), GUtils_Unit(e->H, 1), 1);
		}
		w = (GUtils_Unit(e->W, 1) - dx) - GUtils_Unit(2, 0);
		h = GUtils_Unit(e->H, 1) - GUtils_Unit(2, 0);
		TextPrinter_PlaceBody((x + dx) + GUtils_Unit(2, 0), y, w, h, e->txt, &pos, 0, 1);
	}
}

void TextAreaElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	TextAreaElems_Elem copy = NIL;
	CHAR ch = 0;
	if (__ISP(E, TextAreaElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				(*msg__).elemFrame = TextAreaElems_OpenFrame((*(TextAreaElems_Elem*)&E), (*msg__).frame, TextAreaElems_TextHandle, TextAreaElems_FrameHandle, (*msg__).X0, (*msg__).Y0, (int)__DIV((*(TextAreaElems_Elem*)&E)->W, (LONGINT)TextFrames_Unit), (int)__DIV((*(TextAreaElems_Elem*)&E)->H, (LONGINT)TextFrames_Unit));
				TextAreaElems_Draw((*(TextAreaElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, (*msg__).elemFrame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				TextAreaElems_Draw((*(TextAreaElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(TextAreaElems_Elem*)&E), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				Elems_ToFrame((void*)(*(TextAreaElems_Elem*)&E), *msg__);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, TextAreaElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, TextAreaElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(TextAreaElems_Elem*)&E), (void*)copy);
			copy->txt = Elems_CopyText((*(TextAreaElems_Elem*)&E)->txt);
			copy->locked = (*(TextAreaElems_Elem*)&E)->locked;
			copy->scrBar = (*(TextAreaElems_Elem*)&E)->scrBar;
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("TextAreaElems", (*msg__).mod, 14);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			TextAreaElems_HandleAttrMsg((*(TextAreaElems_Elem*)&E), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(TextAreaElems_Elem*)&E), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(TextAreaElems_Elem*)&E)->locked);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(TextAreaElems_Elem*)&E)->scrBar);
				Texts_Load(&(*msg__).r, Files_Rider__typ, (*(TextAreaElems_Elem*)&E)->txt);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(TextAreaElems_Elem*)&E)->locked);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(TextAreaElems_Elem*)&E)->scrBar);
				Texts_Store(&(*msg__).r, Files_Rider__typ, (*(TextAreaElems_Elem*)&E)->txt);
			}
		} else if (__IS(msg__typ, TextFrames_FocusMsg, 1)) {
			TextFrames_FocusMsg *msg__ = (void*)msg;
			TextAreaElems_curElem = (*(TextAreaElems_Elem*)&E);
			(*msg__).elemFrame = (*msg__).elemFrame->dsc;
			Elems_Focusing(*msg__);
		} else {
			Elems_Handle((void*)(*(TextAreaElems_Elem*)&E), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void TextAreaElems_Init (TextAreaElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = TextAreaElems_Handle;
	e->txt = TextFrames_Text((CHAR*)"", (LONGINT)1);
	e->readOnly = 0;
	e->scrBar = 1;
	e->H = 50 * TextFrames_Unit;
	e->W = 70 * TextFrames_Unit;
}

void TextAreaElems_New (void)
{
	TextAreaElems_Elem e = NIL;
	__NEW(e, TextAreaElems_ElemDesc);
	TextAreaElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void TextAreaElems_Insert (void)
{
	TextAreaElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, TextAreaElems_ElemDesc);
	TextAreaElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&TextAreaElems_W, Texts_Writer__typ, 36, 1, P);
	P(TextAreaElems_curElem);
}

__TDESC(TextAreaElems_FrameDesc, 1, 3) = {__TDFLDS("FrameDesc", 24), {0, 4, 20, -16}};
__TDESC(TextAreaElems_ElemDesc, 1, 6) = {__TDFLDS("ElemDesc", 52), {0, 4, 12, 32, 36, 44, -28}};

export void *TextAreaElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(HandlerElems);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(ParcElems);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(TextAreaElems, EnumPtrs);
	__REGCMD("Insert", TextAreaElems_Insert);
	__REGCMD("New", TextAreaElems_New);
	__INITYP(TextAreaElems_FrameDesc, Display_FrameDesc, 1);
	__INITYP(TextAreaElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	Texts_OpenWriter(&TextAreaElems_W, Texts_Writer__typ);
	__ENDMOD;
}
