/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "HandlerElems.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct TextFieldElems_ElemDesc *TextFieldElems_Elem;

typedef
	struct TextFieldElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text txt;
		SHORTINT maxLen;
	} TextFieldElems_ElemDesc;

typedef
	struct TextFieldElems_FrameDesc *TextFieldElems_Frame;

typedef
	struct TextFieldElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		TextFieldElems_Elem e;
	} TextFieldElems_FrameDesc;

typedef
	struct TextFieldElems_PWElemDesc *TextFieldElems_PWElem;

typedef
	struct TextFieldElems_PWElemDesc { /* TextFieldElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text txt;
		SHORTINT maxLen;
	} TextFieldElems_PWElemDesc;

typedef
	struct TextFieldElems_PWTextDesc *TextFieldElems_PWText;

typedef
	struct TextFieldElems_PWTextDesc { /* Texts_TextDesc */
		LONGINT len;
		Texts_Notifier notify;
		char _prvt0[12];
		Texts_Text hidden;
	} TextFieldElems_PWTextDesc;


export TextFieldElems_Elem TextFieldElems_curElem;
static Texts_Writer TextFieldElems_W;

export LONGINT *TextFieldElems_ElemDesc__typ;
export LONGINT *TextFieldElems_PWElemDesc__typ;
export LONGINT *TextFieldElems_PWTextDesc__typ;
export LONGINT *TextFieldElems_FrameDesc__typ;

export TextFieldElems_PWText TextFieldElems_CopyPWText (TextFieldElems_PWText T);
export void TextFieldElems_Draw (TextFieldElems_Elem e, INTEGER x, INTEGER y, Display_Frame f);
export void TextFieldElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void TextFieldElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void TextFieldElems_HandleAttrMsg (TextFieldElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void TextFieldElems_HandlePW (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void TextFieldElems_HandlePWAttrMsg (TextFieldElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void TextFieldElems_Init (TextFieldElems_Elem e);
export void TextFieldElems_InitPW (TextFieldElems_PWElem e);
export void TextFieldElems_Insert (void);
export void TextFieldElems_InsertPW (void);
export void TextFieldElems_New (void);
export void TextFieldElems_NewPW (void);
static void TextFieldElems_NoNotify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
export Display_Frame TextFieldElems_OpenFrame (TextFieldElems_Elem e, Display_Frame f, Display_Handler textHandler, Display_Handler frameHandler, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextFieldElems_PWNotifier (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
static void TextFieldElems_SetFrameCoords (TextFieldElems_Frame src, TextFrames_Frame dest);
export void TextFieldElems_TextHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void TextFieldElems_TextToString (Texts_Text t, CHAR *str, LONGINT str__len);


void TextFieldElems_TextToString (Texts_Text t, CHAR *str, LONGINT str__len)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	INTEGER i = 0, len = 0;
	len = (int)str__len;
	i = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while (!r.eot && i < len - 1) {
		str[__X(i, str__len)] = ch;
		i += 1;
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	str[__X(i, str__len)] = 0x00;
}

void TextFieldElems_TextHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	BOOLEAN isempty = 0, done = 0;
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	LONGINT pos = 0;
	TextFrames_TrackMsg track = {0};
	Elems_ExecMsg exec = {0};
	if (__ISP(f, TextFrames_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0 && (*(TextFrames_Frame*)&f)->hasCar) {
				if ((*msg__).ch == 0x0d || (*msg__).ch == 0xa4) {
					exec.e = (Elems_Elem)TextFieldElems_curElem;
					exec.x = (*(TextFrames_Frame*)&f)->X;
					exec.y = (*(TextFrames_Frame*)&f)->Y;
					exec.f = (Display_Frame)(*(TextFrames_Frame*)&f);
					exec.unload = 0;
					(*TextFieldElems_curElem->handle)((void*)TextFieldElems_curElem, (void*)&exec, Elems_ExecMsg__typ);
				} else if ((*msg__).ch == 0x09) {
					(*msg__).id = -1;
					Elems_TabStop((void*)TextFieldElems_curElem, (void*)(*(TextFrames_Frame*)&f));
				} else if (TextFieldElems_curElem->maxLen > 0 && (int)(*(TextFrames_Frame*)&f)->text->len >= (int)TextFieldElems_curElem->maxLen) {
					if ((((((*msg__).ch == 0x7f || (*msg__).ch == 0x08) || (*msg__).ch == 0xc4) || (*msg__).ch == 0xc3) || (*msg__).ch == 0x91) || (*msg__).ch == 0x93) {
						(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
					}
				} else {
					isempty = (*(TextFrames_Frame*)&f)->text->len == 0;
					(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
					if (isempty && (*(TextFrames_Frame*)&f)->text->len > 0) {
						pos = (*(TextFrames_Frame*)&f)->carloc.pos;
						Elems_GetLook((void*)TextFieldElems_curElem, &fnt, &col);
						Texts_ChangeLooks((*(TextFrames_Frame*)&f)->text, 0, (*(TextFrames_Frame*)&f)->text->len, 0x03, fnt, col, 0);
						TextFrames_SetCaret((*(TextFrames_Frame*)&f), pos);
					}
				}
			} else if ((*msg__).id == 1 && (*msg__).keys == 0x02) {
				track.X0 = (*(TextFrames_Frame*)&f)->X;
				track.Y0 = (*(TextFrames_Frame*)&f)->Y;
				track.X = (*msg__).X;
				track.Y = (*msg__).Y;
				track.keys = (*msg__).keys;
				track.frame = (Display_Frame)(*(TextFrames_Frame*)&f);
				Elems_Track((void*)TextFieldElems_curElem, (void*)&track, TextFrames_TrackMsg__typ, &done);
				if (done) {
					Elems_UpdateElem((void*)TextFieldElems_curElem);
				} else {
					(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
				}
			} else {
				(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else {
			(*HandlerElems_curHandle)((void*)(*(TextFrames_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

static void TextFieldElems_SetFrameCoords (TextFieldElems_Frame src, TextFrames_Frame dest)
{
	dest->X = src->X + Elems_Scale(2);
	dest->Y = src->Y + Elems_Scale(2);
	dest->H = src->H - Elems_Scale(4);
	dest->W = src->W - Elems_Scale(4);
}

void TextFieldElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
		MenuViewers_ModifyMsg *msg__ = (void*)msg;
		TextFieldElems_SetFrameCoords(__GUARDP(f, TextFieldElems_FrameDesc, 1), __GUARDP(f->dsc, TextFrames_FrameDesc, 1));
	} else if (__IS(msg__typ, Elems_GetFrameMsg, 1)) {
		Elems_GetFrameMsg *msg__ = (void*)msg;
		if ((*msg__).e == (void *) __GUARDP(f, TextFieldElems_FrameDesc, 1)->e) {
			(*msg__).f = f->dsc;
		}
	} else if (__IS(msg__typ, Oberon_InputMsg, 1)) {
		Oberon_InputMsg *msg__ = (void*)msg;
		TextFieldElems_curElem = __GUARDP(f, TextFieldElems_FrameDesc, 1)->e;
		(*f->dsc->handle)(f->dsc, (void*)&*msg__, msg__typ);
	} else {
		(*f->dsc->handle)(f->dsc, &*msg, msg__typ);
	}
}

Display_Frame TextFieldElems_OpenFrame (TextFieldElems_Elem e, Display_Frame f, Display_Handler textHandler, Display_Handler frameHandler, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	TextFieldElems_Frame new = NIL;
	MenuViewers_ModifyMsg m = {0};
	TextFrames_Frame tf = NIL;
	__NEW(new, TextFieldElems_FrameDesc);
	new->handle = frameHandler;
	new->e = e;
	new->X = x;
	new->Y = y;
	new->W = w;
	new->H = h;
	tf = TextFrames_NewText(e->txt, 0);
	tf->left = Elems_Scale(2);
	tf->right = Elems_Scale(2);
	tf->top = Elems_Scale(1);
	tf->bot = 0;
	tf->barW = 0;
	tf->showsParcs = 0;
	tf->handle = textHandler;
	Elems_AdjustSubFrame(f, (void*)new);
	TextFieldElems_SetFrameCoords(new, tf);
	m.id = 1;
	m.Y = tf->Y;
	m.H = tf->H;
	new->dsc = (Display_Frame)tf;
	(*new->dsc->handle)(new->dsc, (void*)&m, MenuViewers_ModifyMsg__typ);
	return (void*)new;
}

static void TextFieldElems_HandleAttrMsg (TextFieldElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 2;
			TextFieldElems_TextToString(e->txt, (void*)(*msg).s, 256);
		} else if (__STRCMP((*msg).name, "ValueT") == 0) {
			(*msg).class = 9;
			(*msg).t = e->txt;
		} else if (__STRCMP((*msg).name, "MaxLen") == 0) {
			(*msg).class = 3;
			(*msg).i = e->maxLen;
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			Texts_Delete(e->txt, 0, e->txt->len);
			if (Texts_ElemBase((void*)e) != NIL) {
				Elems_GetLook((void*)e, &fnt, &col);
				Texts_SetFont(&TextFieldElems_W, Texts_Writer__typ, fnt);
				Texts_SetColor(&TextFieldElems_W, Texts_Writer__typ, col);
			}
			Elems_WriteAttr(&TextFieldElems_W, Texts_Writer__typ, *msg);
			Texts_Append(e->txt, TextFieldElems_W.buf);
		} else if (__STRCMP((*msg).name, "ValueT") == 0) {
			if ((*msg).class == 9) {
				e->txt = (*msg).t;
			}
		} else if (__STRCMP((*msg).name, "MaxLen") == 0) {
			if ((*msg).class == 3) {
				e->maxLen = (int)(*msg).i;
			}
			if (e->maxLen < 0) {
				e->maxLen = 0;
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Value", (LONGINT)6, 2);
		(*(*msg).enum_)((CHAR*)"MaxLen", (LONGINT)7, 3);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

void TextFieldElems_Draw (TextFieldElems_Elem e, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER h = 0, w = 0;
	LONGINT pos = 0;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	GUtils_Area(f, 0, 12, x, y, w, h, GUtils_Unit(2, 0), 0, 1);
	if (GUtils_device == 1) {
		pos = 0;
		h = h - GUtils_Unit(4, 0);
		w = w - GUtils_Unit(4, 0);
		TextPrinter_PlaceBody(x + GUtils_Unit(2, 0), y + GUtils_Unit(2, 0), w, h, e->txt, &pos, 0, 1);
	}
}

void TextFieldElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	TextFieldElems_Elem copy = NIL;
	CHAR ch = 0;
	INTEGER int_ = 0;
	if (__ISP(e, TextFieldElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				(*msg__).elemFrame = TextFieldElems_OpenFrame((*(TextFieldElems_Elem*)&e), (*msg__).frame, TextFieldElems_TextHandle, TextFieldElems_FrameHandle, (*msg__).X0, (*msg__).Y0, (int)__DIV((*(TextFieldElems_Elem*)&e)->W, (LONGINT)TextFrames_Unit), (int)__DIV((*(TextFieldElems_Elem*)&e)->H, (LONGINT)TextFrames_Unit));
				TextFieldElems_Draw((*(TextFieldElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).elemFrame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				TextFieldElems_Draw((*(TextFieldElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, TextFieldElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, TextFieldElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(TextFieldElems_Elem*)&e), (void*)copy);
			copy->txt = Elems_CopyText((*(TextFieldElems_Elem*)&e)->txt);
			copy->maxLen = (*(TextFieldElems_Elem*)&e)->maxLen;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("TextFieldElems", (*msg__).mod, 15);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			TextFieldElems_HandleAttrMsg((*(TextFieldElems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(TextFieldElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadInt(&(*msg__).r, Files_Rider__typ, &int_);
				(*(TextFieldElems_Elem*)&e)->maxLen = (int)int_;
				Texts_Load(&(*msg__).r, Files_Rider__typ, (*(TextFieldElems_Elem*)&e)->txt);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, (*(TextFieldElems_Elem*)&e)->maxLen);
				Texts_Store(&(*msg__).r, Files_Rider__typ, (*(TextFieldElems_Elem*)&e)->txt);
			}
		} else if (__IS(msg__typ, TextFrames_FocusMsg, 1)) {
			TextFrames_FocusMsg *msg__ = (void*)msg;
			if ((*msg__).focus) {
				(*msg__).elemFrame = (*msg__).elemFrame->dsc;
				Elems_Focusing(*msg__);
			}
		} else if (__IS(msg__typ, Elems_TabStopMsg, 1)) {
			Elems_TabStopMsg *msg__ = (void*)msg;
			(*msg__).accepted = 1;
		} else {
			Elems_Handle((void*)(*(TextFieldElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void TextFieldElems_Init (TextFieldElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = TextFieldElems_Handle;
	e->txt = TextFrames_Text((CHAR*)"", (LONGINT)1);
	e->maxLen = 0;
	if (Fonts_Default->height > Fonts_Default->maxY - Fonts_Default->minY) {
		e->H = (LONGINT)(Fonts_Default->height + Elems_Scale(5)) * (LONGINT)TextFrames_Unit;
	} else {
		e->H = (LONGINT)((Fonts_Default->maxY - Fonts_Default->minY) + Elems_Scale(5)) * (LONGINT)TextFrames_Unit;
	}
	e->H += (LONGINT)TextFrames_Unit - 1;
	e->W = Elems_Scale(120) * TextFrames_Unit;
}

void TextFieldElems_New (void)
{
	TextFieldElems_Elem e = NIL;
	__NEW(e, TextFieldElems_ElemDesc);
	TextFieldElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void TextFieldElems_Insert (void)
{
	TextFieldElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, TextFieldElems_ElemDesc);
	TextFieldElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		Texts_Delete(e->txt, 0, e->txt->len);
		Texts_WriteString(&TextFieldElems_W, Texts_Writer__typ, s.s, 256);
		Texts_Append(e->txt, TextFieldElems_W.buf);
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

static void TextFieldElems_NoNotify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void TextFieldElems_PWNotifier (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
	LONGINT i = 0;
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	LONGINT _for__17 = 0;
	T->notify = TextFieldElems_NoNotify;
	if (__ISP(T, TextFieldElems_PWTextDesc, 1)) {
		if (op == 1) {
			Texts_Save((void*)(*(TextFieldElems_PWText*)&T), beg, end, TextFieldElems_W.buf);
			Texts_Insert((*(TextFieldElems_PWText*)&T)->hidden, beg, TextFieldElems_W.buf);
			Texts_Delete((void*)(*(TextFieldElems_PWText*)&T), beg, end);
			if (TextFieldElems_curElem != NIL && Texts_ElemBase((void*)TextFieldElems_curElem) != NIL) {
				Elems_GetLook((void*)TextFieldElems_curElem, &fnt, &col);
				Texts_SetFont(&TextFieldElems_W, Texts_Writer__typ, fnt);
				Texts_SetColor(&TextFieldElems_W, Texts_Writer__typ, col);
			}
			_for__17 = end - 1;
			i = beg;
			while (i <= _for__17) {
				Texts_Write(&TextFieldElems_W, Texts_Writer__typ, '*');
				i += 1;
			}
			Texts_Insert((void*)(*(TextFieldElems_PWText*)&T), beg, TextFieldElems_W.buf);
		} else if (op == 2) {
			Texts_Delete((*(TextFieldElems_PWText*)&T)->hidden, beg, end);
		}
	}
	T->notify = TextFieldElems_PWNotifier;
	TextFrames_NotifyDisplay(T, op, beg, end);
}

TextFieldElems_PWText TextFieldElems_CopyPWText (TextFieldElems_PWText T)
{
	TextFieldElems_PWText txt = NIL;
	Texts_Save(T->hidden, 0, T->hidden->len, TextFieldElems_W.buf);
	__NEW(txt, TextFieldElems_PWTextDesc);
	Texts_Open((void*)txt, (CHAR*)"", (LONGINT)1);
	txt->notify = TextFieldElems_PWNotifier;
	txt->hidden = TextFrames_Text((CHAR*)"", (LONGINT)1);
	txt->hidden->notify = TextFieldElems_NoNotify;
	Texts_Append((void*)txt, TextFieldElems_W.buf);
	return txt;
}

static void TextFieldElems_HandlePWAttrMsg (TextFieldElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "ValueT") == 0) {
			(*msg).class = 9;
			(*msg).t = __GUARDP(e->txt, TextFieldElems_PWTextDesc, 1)->hidden;
		} else if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 2;
			(*msg).s[0] = 0x00;
		} else if (__STRCMP((*msg).name, "PValue") == 0) {
			(*msg).class = 2;
			TextFieldElems_TextToString(__GUARDP(e->txt, TextFieldElems_PWTextDesc, 1)->hidden, (void*)(*msg).s, 256);
		} else {
			TextFieldElems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "ValueT") == 0) {
			if ((*msg).class == 9) {
				__GUARDP(e->txt, TextFieldElems_PWTextDesc, 1)->hidden = (*msg).t;
			}
		} else {
			TextFieldElems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else {
		TextFieldElems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

void TextFieldElems_HandlePW (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	TextFieldElems_PWElem copy = NIL;
	if (__ISP(e, TextFieldElems_PWElemDesc, 4)) {
		if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, TextFieldElems_PWElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, TextFieldElems_PWElemDesc, 4);
			}
			TextFieldElems_Handle((void*)(*(TextFieldElems_PWElem*)&e), (void*)&*msg__, msg__typ);
			copy->txt = (Texts_Text)TextFieldElems_CopyPWText(__GUARDP((*(TextFieldElems_PWElem*)&e)->txt, TextFieldElems_PWTextDesc, 1));
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("TextFieldElems", (*msg__).mod, 15);
			__MOVE("NewPW", (*msg__).proc, 6);
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			TextFieldElems_HandlePWAttrMsg((void*)(*(TextFieldElems_PWElem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			TextFieldElems_Handle((void*)(*(TextFieldElems_PWElem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Texts_Delete((*(TextFieldElems_PWElem*)&e)->txt, 0, (*(TextFieldElems_PWElem*)&e)->txt->len);
			}
		} else {
			TextFieldElems_Handle((void*)(*(TextFieldElems_PWElem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void TextFieldElems_InitPW (TextFieldElems_PWElem e)
{
	TextFieldElems_PWText txt = NIL;
	TextFieldElems_Init((void*)e);
	e->handle = TextFieldElems_HandlePW;
	__NEW(txt, TextFieldElems_PWTextDesc);
	Texts_Open((void*)txt, (CHAR*)"", (LONGINT)1);
	txt->notify = TextFieldElems_PWNotifier;
	txt->hidden = TextFrames_Text((CHAR*)"", (LONGINT)1);
	txt->hidden->notify = TextFieldElems_NoNotify;
	e->txt = (Texts_Text)txt;
}

void TextFieldElems_NewPW (void)
{
	TextFieldElems_PWElem e = NIL;
	__NEW(e, TextFieldElems_PWElemDesc);
	TextFieldElems_InitPW(e);
	Texts_new = (Texts_Elem)e;
}

void TextFieldElems_InsertPW (void)
{
	TextFieldElems_PWElem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, TextFieldElems_PWElemDesc);
	TextFieldElems_InitPW(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		Texts_Delete(e->txt, 0, e->txt->len);
		Texts_WriteString(&TextFieldElems_W, Texts_Writer__typ, s.s, 256);
		Texts_Append(e->txt, TextFieldElems_W.buf);
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

static void EnumPtrs(void (*P)(void*))
{
	P(TextFieldElems_curElem);
	__ENUMR(&TextFieldElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(TextFieldElems_ElemDesc, 1, 6) = {__TDFLDS("ElemDesc", 52), {0, 4, 12, 32, 36, 44, -28}};
__TDESC(TextFieldElems_PWElemDesc, 1, 6) = {__TDFLDS("PWElemDesc", 52), {0, 4, 12, 32, 36, 44, -28}};
__TDESC(TextFieldElems_PWTextDesc, 1, 3) = {__TDFLDS("PWTextDesc", 24), {8, 12, 20, -16}};
__TDESC(TextFieldElems_FrameDesc, 1, 3) = {__TDFLDS("FrameDesc", 24), {0, 4, 20, -16}};

export void *TextFieldElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(HandlerElems);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(TextFieldElems, EnumPtrs);
	__REGCMD("Insert", TextFieldElems_Insert);
	__REGCMD("InsertPW", TextFieldElems_InsertPW);
	__REGCMD("New", TextFieldElems_New);
	__REGCMD("NewPW", TextFieldElems_NewPW);
	__INITYP(TextFieldElems_ElemDesc, Elems_ElemDesc, 3);
	__INITYP(TextFieldElems_PWElemDesc, TextFieldElems_ElemDesc, 4);
	__INITYP(TextFieldElems_PWTextDesc, Texts_TextDesc, 1);
	__INITYP(TextFieldElems_FrameDesc, Display_FrameDesc, 1);
/* BEGIN */
	Texts_OpenWriter(&TextFieldElems_W, Texts_Writer__typ);
	__ENDMOD;
}
