/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct TextPFrames_FrameDesc *TextPFrames_Frame;

typedef
	struct TextPFrames_TextLineDesc *TextPFrames_TextLine;

typedef
	struct TextPFrames_Location {
		LONGINT org, pos;
		INTEGER x, y, dx, dy;
		TextPFrames_TextLine line;
		BOOLEAN trunc;
	} TextPFrames_Location;

typedef
	struct TextPFrames_FrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		TextPFrames_Location CarLoc, SelBeg, SelEnd;
		TextPFrames_TextLine trailer;
		INTEGER pages, first, width;
		LONGINT porg[1024];
	} TextPFrames_FrameDesc;

typedef
	struct TextPFrames_SelectMsg { /* Display_FrameMsg */
		Texts_Text text;
		LONGINT beg, end, time;
	} TextPFrames_SelectMsg;

typedef
	struct TextPFrames_TextLineDesc {
		TextPFrames_TextLine next;
		BOOLEAN eot;
		LONGINT indent;
		INTEGER pno, w, h, dsr, nob;
		LONGINT org, len, span;
		TextFrames_Parc P;
		LONGINT pbeg;
	} TextPFrames_TextLineDesc;


static INTEGER TextPFrames_unit;
static Fonts_Font TextPFrames_pfnt;
static Texts_Writer TextPFrames_W, TextPFrames_WL;
static Texts_Buffer TextPFrames_PB, TextPFrames_B;
static TextFrames_Parc TextPFrames_P;
static LONGINT TextPFrames_pbeg;
static Texts_Reader TextPFrames_R;
static CHAR TextPFrames_nextCh;

export LONGINT *TextPFrames_Location__typ;
export LONGINT *TextPFrames_TextLineDesc__typ;
export LONGINT *TextPFrames_FrameDesc__typ;
export LONGINT *TextPFrames_SelectMsg__typ;

static void TextPFrames_AdjustMetrics (TextPFrames_Frame F, TextPFrames_TextLine t, INTEGER *pw, INTEGER *tw, INTEGER *ddx, INTEGER *cn);
export void TextPFrames_BegOfLine (Texts_Text T, LONGINT *pos, BOOLEAN adjust);
export void TextPFrames_Call (TextPFrames_Frame F, LONGINT pos, BOOLEAN new);
static void TextPFrames_Complete (TextPFrames_Frame F, TextPFrames_TextLine trailer, TextPFrames_TextLine *s, LONGINT *org, INTEGER *ph);
static LONGINT TextPFrames_CoordToPos (TextPFrames_Frame F, INTEGER mh);
export void TextPFrames_Copy (TextPFrames_Frame SF, TextPFrames_Frame DF);
static void TextPFrames_DrawBanner (TextPFrames_Frame F, INTEGER pno, INTEGER bw, INTEGER px, INTEGER py, INTEGER th, INTEGER mw);
static void TextPFrames_DrawCursor (INTEGER x, INTEGER y);
static void TextPFrames_DrawSpecial (TextPFrames_Frame F, INTEGER px, INTEGER py, INTEGER x, INTEGER y);
export void TextPFrames_Edit (TextPFrames_Frame F, INTEGER x, INTEGER y, SET keysum);
static void TextPFrames_Erase (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextPFrames_EraseRect (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextPFrames_GetChar (Fonts_Font fnt, CHAR ch, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *pat);
export void TextPFrames_GetPagination (TextPFrames_Frame F, INTEGER *pages, INTEGER *first, INTEGER *width, LONGINT *porg, LONGINT porg__len);
static void TextPFrames_GetSpecial (TextPFrames_Frame F, INTEGER *n, INTEGER cn, INTEGER ddx, INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, BOOLEAN *trunc);
export void TextPFrames_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static void TextPFrames_InvalSubFrames (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextPFrames_InvertBorder (Display_Frame F);
static void TextPFrames_InvertCaret (TextPFrames_Frame F);
static void TextPFrames_InvertRect (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextPFrames_InvertSelection (TextPFrames_Frame F, TextPFrames_Location beg, TextPFrames_Location end);
export void TextPFrames_LocateChar (TextPFrames_Frame F, INTEGER x, INTEGER y, TextPFrames_Location *loc, LONGINT *loc__typ);
export void TextPFrames_LocateLine (TextPFrames_Frame F, INTEGER y, TextPFrames_Location *loc, LONGINT *loc__typ);
static void TextPFrames_LocateLineTop (TextPFrames_Frame F, TextPFrames_TextLine trailer, LONGINT org, TextPFrames_Location *loc, LONGINT *loc__typ);
export void TextPFrames_LocatePage (TextPFrames_Frame F, LONGINT org, LONGINT *porg, INTEGER *pno);
export void TextPFrames_LocatePos (TextPFrames_Frame F, LONGINT pos, TextPFrames_Location *loc, LONGINT *loc__typ);
export void TextPFrames_LocateWord (TextPFrames_Frame F, INTEGER x, INTEGER y, TextPFrames_Location *loc, LONGINT *loc__typ);
static void TextPFrames_MarkMenu (TextPFrames_Frame F);
static INTEGER TextPFrames_Max (INTEGER x, INTEGER y);
static void TextPFrames_MeasureLine (TextPFrames_Frame F, INTEGER maxW, TextPFrames_TextLine t);
static void TextPFrames_MeasureLines (TextPFrames_Frame F, LONGINT org, TextPFrames_TextLine *trailer);
static void TextPFrames_MeasureSpecial (INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, BOOLEAN *trunc);
static INTEGER TextPFrames_Min (INTEGER x, INTEGER y);
export void TextPFrames_Neutralize (TextPFrames_Frame F);
export TextPFrames_Frame TextPFrames_NewText (Texts_Text T, LONGINT pos);
static void TextPFrames_NextLine (Texts_Text T, LONGINT *org);
export void TextPFrames_NotifyElems (TextPFrames_Frame F, Display_FrameMsg *msg, LONGINT *msg__typ);
export void TextPFrames_Open (TextPFrames_Frame F, Texts_Text T, LONGINT pos);
static INTEGER TextPFrames_PU (INTEGER x);
export void TextPFrames_PassSubFocus (TextPFrames_Frame F, Display_Frame f);
export LONGINT TextPFrames_Pos (TextPFrames_Frame F, INTEGER x, INTEGER y);
export void TextPFrames_RemoveCaret (TextPFrames_Frame F);
export void TextPFrames_RemoveSelection (TextPFrames_Frame F);
export void TextPFrames_Resize (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static INTEGER TextPFrames_SU (INTEGER x);
export void TextPFrames_SetCaret (TextPFrames_Frame F, LONGINT pos);
export void TextPFrames_SetPagination (TextPFrames_Frame F, INTEGER pages, INTEGER first, INTEGER width, LONGINT *porg, LONGINT porg__len);
export void TextPFrames_SetSelection (TextPFrames_Frame F, LONGINT beg, LONGINT end);
static void TextPFrames_Shift (TextPFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h);
static void TextPFrames_ShiftBlock (TextPFrames_Frame F, INTEGER delta);
static void TextPFrames_ShiftSubFrames (TextPFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h);
export void TextPFrames_Show (TextPFrames_Frame F, LONGINT pos);
static void TextPFrames_ShowBar (TextPFrames_Frame F, INTEGER botH, INTEGER topH);
static void TextPFrames_ShowFrom (TextPFrames_Frame F, LONGINT pos);
static void TextPFrames_ShowLine (TextPFrames_Frame F, TextPFrames_TextLine t, INTEGER left, INTEGER right, INTEGER py);
static void TextPFrames_ShowLines (TextPFrames_Frame F, INTEGER botH, INTEGER topH);
static void TextPFrames_ShowLinesErasing (TextPFrames_Frame F, INTEGER botH, INTEGER topH);
static void TextPFrames_ShowTick (TextPFrames_Frame F);
static void TextPFrames_Tab (INTEGER dw, INTEGER *dx);
export Display_Frame TextPFrames_ThisSubFrame (TextPFrames_Frame F, INTEGER x, INTEGER y);
static void TextPFrames_Tick (TextPFrames_Frame F);
export void TextPFrames_TouchElem (TextPFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum);
export void TextPFrames_TrackCaret (TextPFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum);
export void TextPFrames_TrackLine (TextPFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *org, SET *keysum);
static void TextPFrames_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum);
export void TextPFrames_TrackSelection (TextPFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum);
export void TextPFrames_TrackWord (TextPFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *pos, SET *keysum);
export void TextPFrames_Update (TextPFrames_Frame F, TextFrames_UpdateMsg *msg, LONGINT *msg__typ);
static void TextPFrames_Width (TextPFrames_Frame F, TextPFrames_TextLine t, LONGINT pos, INTEGER *pw, INTEGER *dx, INTEGER *dy);
export void TextPFrames_Write (TextPFrames_Frame F, CHAR ch, Fonts_Font fnt, SHORTINT col, SHORTINT voff);


static INTEGER TextPFrames_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER TextPFrames_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER TextPFrames_PU (INTEGER x)
{
	return (int)__DIV((LONGINT)x * (LONGINT)TextPFrames_unit + 1524, 3048);
}

static INTEGER TextPFrames_SU (INTEGER x)
{
	return (int)__DIV((LONGINT)x * 3048 + (LONGINT)__ASHR(TextPFrames_unit, 1), (LONGINT)TextPFrames_unit);
}

static void TextPFrames_MarkMenu (TextPFrames_Frame F)
{
	Texts_Reader R = {0};
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	CHAR ch = 0;
	V = Viewers_This(F->X, F->Y);
	if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc, TextFrames_FrameDesc, 1)) {
		T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
		if (T->len > 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		} else {
			ch = 0x00;
		}
		if (ch != '!') {
			Texts_Write(&TextPFrames_WL, Texts_Writer__typ, '!');
			Texts_Append(T, TextPFrames_WL.buf);
		}
	}
}

static void TextPFrames_InvertBorder (Display_Frame F)
{
	Display_ReplPattern(15, Display_grey1, F->X - 1, F->Y - 1, F->W + 2, 1, 2);
	Display_ReplPattern(15, Display_grey1, F->X - 1, F->Y + F->H, F->W + 2, 1, 2);
	Display_ReplPattern(15, Display_grey1, F->X - 1, F->Y, 1, F->H, 2);
	Display_ReplPattern(15, Display_grey1, F->X + F->W, F->Y, 1, F->H, 2);
}

static void TextPFrames_InvalSubFrames (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_Frame p = NIL, f = NIL;
	MenuViewers_ModifyMsg msg = {0};
	if (w > 0 && h > 0) {
		f = F->dsc;
		if (f != NIL) {
			p = f;
			f = p->next;
		}
		while (f != NIL) {
			if (((f->X < x + w && f->X + f->W > x) && f->Y < y + h) && f->Y + f->H > y) {
				p->next = f->next;
				msg.id = 1;
				msg.dY = 0;
				msg.Y = f->Y;
				msg.H = 0;
				(*f->handle)(f, (void*)&msg, MenuViewers_ModifyMsg__typ);
			} else {
				p = f;
			}
			f = p->next;
		}
		f = F->dsc;
		if ((((f != NIL && f->X < x + w) && f->X + f->W > x) && f->Y < y + h) && f->Y + f->H > y) {
			F->dsc = F->dsc->next;
			msg.id = 1;
			msg.dY = 0;
			msg.Y = f->Y;
			msg.H = 0;
			(*f->handle)(f, (void*)&msg, MenuViewers_ModifyMsg__typ);
		}
	}
}

static void TextPFrames_ShiftSubFrames (TextPFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h)
{
	Display_Frame f = NIL;
	MenuViewers_ModifyMsg msg = {0};
	if (oldY > newY) {
		TextPFrames_InvalSubFrames(F, F->X, newY, F->W, oldY - newY);
	} else {
		TextPFrames_InvalSubFrames(F, F->X, oldY + h, F->W, newY - oldY);
	}
	f = F->dsc;
	while (f != NIL) {
		if (f->Y < oldY + h && f->Y + f->H > oldY) {
			f->Y += newY - oldY;
			msg.id = 1;
			msg.dY = 0;
			msg.Y = f->Y;
			msg.H = f->H;
			(*f->handle)(f, (void*)&msg, MenuViewers_ModifyMsg__typ);
		}
		f = f->next;
	}
}

static void TextPFrames_DrawCursor (INTEGER x, INTEGER y)
{
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
}

static void TextPFrames_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum)
{
	Input_Mouse(&*keys, &*x, &*y);
	*keysum = *keysum | *keys;
	TextPFrames_DrawCursor(*x, *y);
}

static void TextPFrames_EraseRect (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_ReplConst(0, x, y, w, h, 0);
	TextPFrames_InvalSubFrames(F, x, y, w, h);
}

static void TextPFrames_Erase (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (h > 0) {
		Oberon_RemoveMarks(x, y, w, h);
		TextPFrames_EraseRect(F, x, y, w, h);
	}
}

static void TextPFrames_Shift (TextPFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h)
{
	if (oldY != newY && h > 0) {
		Oberon_RemoveMarks(F->X + F->left, TextPFrames_Min(oldY, newY), F->W - F->left, TextPFrames_Max(oldY, newY) + h);
		Display_CopyBlock(F->X + F->left, oldY, F->W - F->left, h, F->X + F->left, newY, 0);
		TextPFrames_ShiftSubFrames(F, oldY, newY, h);
	}
}

static void TextPFrames_InvertCaret (TextPFrames_Frame F)
{
	TextPFrames_Location loc = {0};
	loc = F->CarLoc;
	Display_CopyPattern(15, Display_hook, loc.x, (loc.y + loc.line->dsr) - 6, 2);
}

static void TextPFrames_InvertRect (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (x + w > (F->X + F->W) - F->right) {
		w = ((F->X + F->W) - F->right) - x;
	}
	if (y >= F->Y + F->bot) {
		Display_ReplConst(15, x, y, w, h, 2);
	}
}

static void TextPFrames_InvertSelection (TextPFrames_Frame F, TextPFrames_Location beg, TextPFrames_Location end)
{
	TextPFrames_TextLine t = NIL;
	INTEGER ex = 0, rx = 0, w = 0, py = 0;
	rx = (F->X + F->W) - F->right;
	t = end.line;
	if (t->eot || end.pos <= t->org + t->len) {
		ex = end.x;
	} else {
		ex = rx;
	}
	if (beg.line == end.line) {
		TextPFrames_InvertRect(F, beg.x, beg.y, ex - beg.x, beg.line->h);
	} else {
		t = beg.line;
		py = beg.y;
		w = (F->W - F->left) - F->right;
		TextPFrames_InvertRect(F, beg.x, py, rx - beg.x, t->h);
		t = t->next;
		py -= t->h;
		while (t != end.line) {
			TextPFrames_InvertRect(F, F->X + F->left, py, w, t->h);
			t = t->next;
			py -= t->h;
		}
		if (end.line->eot) {
			TextPFrames_InvertRect(F, F->X + F->left, py, end.x - (F->X + F->left), t->h);
		} else {
			TextPFrames_InvertRect(F, F->X + F->left, py, ex - (F->X + F->left), t->h);
		}
	}
}

static LONGINT TextPFrames_CoordToPos (TextPFrames_Frame F, INTEGER mh)
{
	INTEGER h = 0;
	h = F->H - 1;
	if (h > 0) {
		return __DIV((LONGINT)(h - mh) * F->text->len + (LONGINT)__ASHR(h, 1), (LONGINT)h);
	} else {
		return 0;
	}
	__RETCHK;
}

static void TextPFrames_ShowBar (TextPFrames_Frame F, INTEGER botH, INTEGER topH)
{
	if (F->left > F->barW && F->barW > 0) {
		Display_ReplConst(15, (F->X + F->barW) - 1, F->Y + botH, 1, topH - botH, 0);
	}
}

static void TextPFrames_Tick (TextPFrames_Frame F)
{
	if ((((0 <= F->markH && F->markH < F->H) && F->left > F->barW) && F->barW > 6) && F->H > 1) {
		Display_ReplConst(15, F->X + 1, F->Y + F->markH, F->barW - 6, 1, 2);
	}
}

static void TextPFrames_ShowTick (TextPFrames_Frame F)
{
	INTEGER h = 0, mh = 0;
	LONGINT len = 0;
	h = F->H - 1;
	len = F->text->len;
	if (len > 0) {
		mh = (int)((LONGINT)h - __DIV((LONGINT)h * F->org, len));
	} else {
		mh = h;
	}
	if (F->markH != mh) {
		Oberon_RemoveMarks(F->X, F->Y, F->barW, F->H);
		TextPFrames_Tick(F);
		F->markH = mh;
		TextPFrames_Tick(F);
	}
}

void TextPFrames_LocatePage (TextPFrames_Frame F, LONGINT org, LONGINT *porg, INTEGER *pno)
{
	INTEGER i = 0;
	i = 0;
	while (i < F->pages && F->porg[__X(i, 1024)] < org) {
		i += 1;
	}
	if (i < F->pages) {
		*porg = F->porg[__X(i, 1024)];
		*pno = F->first + i;
	} else {
		*porg = F->text->len;
		*pno = 1024;
	}
}

void TextPFrames_GetPagination (TextPFrames_Frame F, INTEGER *pages, INTEGER *first, INTEGER *width, LONGINT *porg, LONGINT porg__len)
{
	INTEGER i = 0;
	*pages = TextPFrames_Min(F->pages, (int)porg__len);
	*first = F->first;
	*width = F->width;
	i = *pages;
	while (i > 0) {
		i -= 1;
		F->porg[__X(i, 1024)] = porg[__X(i, porg__len)];
	}
}

void TextPFrames_SetPagination (TextPFrames_Frame F, INTEGER pages, INTEGER first, INTEGER width, LONGINT *porg, LONGINT porg__len)
{
	pages = TextPFrames_Min(pages, 1024);
	F->pages = pages;
	F->first = first;
	F->width = width;
	while (pages > 0) {
		pages -= 1;
		F->porg[__X(pages, 1024)] = porg[__X(pages, porg__len)];
	}
}

static void TextPFrames_GetChar (Fonts_Font fnt, CHAR ch, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *pat)
{
	Display_GetChar(fnt->raster, ch, &*dx, &*x, &*y, &*w, &*h, &*pat);
	*dx = (int)__DIVF(TextPrinter_DX(TextPrinter_FontNo(fnt), ch), 3048);
	*x = TextPFrames_PU(*x);
	*w = TextPFrames_PU(*w);
}

static void TextPFrames_Tab (INTEGER dw, INTEGER *dx)
{
	INTEGER i = 0, n = 0;
	LONGINT w = 0;
	i = 0;
	n = TextPFrames_P->nofTabs;
	w = (LONGINT)dw * 3048 + 3600;
	if (dw < 0) {
		*dx = -dw;
	} else {
		while (i < n && TextPFrames_P->tab[__X(i, 32)] < w) {
			i += 1;
		}
		if (i < n) {
			*dx = (int)__DIV(TextPFrames_P->tab[__X(i, 32)] - (LONGINT)dw * 3048, 3048);
		} else {
			*dx = 47;
		}
	}
}

static void TextPFrames_MeasureSpecial (INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, BOOLEAN *trunc)
{
	Texts_Elem e = NIL;
	LONGINT pat = 0, pw = 0, ph = 0;
	TextFrames_DisplayMsg msg = {0};
	TextPrinter_PrintMsg pmsg = {0};
	if (TextPFrames_nextCh == ' ') {
		TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
		*trunc = 0;
	} else if (TextPFrames_nextCh == 0x09) {
		TextPFrames_Tab(dw, &*dx);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
		*trunc = 0;
	} else if (TextPFrames_R.elem != NIL) {
		e = TextPFrames_R.elem;
		pmsg.prepare = 1;
		pmsg.indent = (LONGINT)dw * 3048;
		pmsg.fnt = TextPFrames_R.fnt;
		pmsg.col = TextPFrames_R.col;
		pmsg.pos = Texts_Pos(&TextPFrames_R, Texts_Reader__typ) - 1;
		pmsg.Y0 = -((int)__DIV(TextPFrames_P->dsr, 3048));
		(*e->handle)(e, (void*)&pmsg, TextPrinter_PrintMsg__typ);
		pw = e->W;
		ph = e->H;
		msg.prepare = 1;
		msg.indent = (LONGINT)dw * 3048;
		msg.fnt = TextPFrames_R.fnt;
		msg.col = TextPFrames_R.col;
		msg.pos = Texts_Pos(&TextPFrames_R, Texts_Reader__typ) - 1;
		msg.Y0 = -((int)__DIV(TextPFrames_P->dsr, (LONGINT)TextPFrames_unit));
		(*e->handle)(e, (void*)&msg, TextFrames_DisplayMsg__typ);
		*w = (int)__DIV(pw, 3048);
		*h = (int)__DIV(ph, (LONGINT)TextPFrames_unit);
		*dx = *w;
		*x = 0;
		*y = msg.Y0;
		*trunc = !__ISP(e, TextFrames_ParcDesc, 2) && (pw < e->W || ph < e->H);
	} else {
		TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
		*trunc = 0;
	}
}

static void TextPFrames_GetSpecial (TextPFrames_Frame F, INTEGER *n, INTEGER cn, INTEGER ddx, INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, BOOLEAN *trunc)
{
	Texts_Elem e = NIL;
	LONGINT pat = 0;
	if (TextPFrames_nextCh == ' ') {
		TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
		*x = 0;
		*y = 0;
		*dx += ddx;
		*n += 1;
		if (*n <= cn) {
			*dx += 1;
		}
		*w = *dx;
		*h = 0;
		*trunc = 0;
	} else if (TextPFrames_nextCh == 0x09) {
		TextPFrames_Tab(dw, &*dx);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
		*trunc = 0;
	} else if (TextPFrames_R.elem != NIL) {
		e = TextPFrames_R.elem;
		if (__ISP(e, TextFrames_ParcDesc, 2) && TextPFrames_P->W == 30476952) {
			*w = TextPFrames_Min((int)__DIV(TextPFrames_P->width + TextPFrames_P->left, 3048), TextPFrames_PU((F->W - F->right) - F->left));
			e->W = (LONGINT)*w * 3048;
			*h = (int)__DIV(e->H, (LONGINT)TextPFrames_unit);
			*trunc = 0;
		} else {
			TextPFrames_MeasureSpecial(dw, &*dx, &*x, &*y, &*w, &*h, &*trunc);
		}
		*dx = *w;
		*x = 0;
		*y = -((int)__DIV(TextPFrames_P->dsr, (LONGINT)TextPFrames_unit));
	} else {
		TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
		*trunc = 0;
	}
}

static void TextPFrames_NextLine (Texts_Text T, LONGINT *org)
{
	LONGINT pat = 0, pos = 0, bk = 0, d = 0;
	INTEGER width = 0, tw = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	BOOLEAN trunc = 0;
	Texts_Reader R1 = {0};
	CHAR peekCh = 0;
	LONGINT indent = 0;
	tw = 0;
	dx = 0;
	w = 0;
	bk = -999;
	pos = *org;
	TextFrames_ParcBefore(T, pos, &TextPFrames_P, &TextPFrames_pbeg);
	width = (int)__DIV(TextPFrames_P->width, 3048);
	indent = 0;
	if (*org > 0) {
		Texts_OpenReader(&R1, Texts_Reader__typ, T, *org - 1);
		Texts_Read(&R1, Texts_Reader__typ, &peekCh);
		if (peekCh == 0x0d || R1.elem != NIL && __ISP(R1.elem, TextFrames_ParcDesc, 2)) {
			indent = TextPFrames_P->first;
		}
	}
	width -= (int)__DIV(indent, 3048);
	for (;;) {
		pos += 1;
		if (TextPFrames_R.eot || TextPFrames_nextCh == 0x0d) {
			break;
		}
		tw += dx;
		if (TextPFrames_nextCh <= ' ') {
			TextPFrames_MeasureSpecial(tw + (int)__DIV(indent, 3048), &dx, &x, &y, &w, &h, &trunc);
		} else {
			TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &dx, &x, &y, &w, &h, &pat);
		}
		if ((tw + x) + dx > width) {
			d = pos - bk;
			if ((0 <= d && d < 30) && TextPFrames_nextCh > ' ') {
				pos = bk;
			} else if ((TextPFrames_nextCh > ' ' || TextPFrames_nextCh == 0x1c) && pos > *org + 1) {
				pos -= 1;
			}
			Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, T, pos);
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
			break;
		}
		if (TextPFrames_nextCh <= ' ' && TextPFrames_nextCh != 0x1c) {
			bk = pos;
		}
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
	}
	*org = pos;
}

void TextPFrames_BegOfLine (Texts_Text T, LONGINT *pos, BOOLEAN adjust)
{
	LONGINT p = 0, org = 0;
	if (*pos <= 0) {
		*pos = 0;
	} else {
		if (*pos <= T->len) {
			org = *pos;
		} else {
			org = T->len;
		}
		for (;;) {
			if (org == 0) {
				break;
			}
			Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, T, org - 1);
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
			if (TextPFrames_nextCh == 0x0d) {
				break;
			}
			org -= 1;
		}
		if (adjust) {
			Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, T, org);
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
			p = org;
			do {
				org = p;
				TextPFrames_NextLine(T, &p);
			} while (!(p > *pos || TextPFrames_R.eot));
		}
		*pos = org;
	}
}

static void TextPFrames_AdjustMetrics (TextPFrames_Frame F, TextPFrames_TextLine t, INTEGER *pw, INTEGER *tw, INTEGER *ddx, INTEGER *cn)
{
	INTEGER w = 0;
	TextPFrames_P = t->P;
	TextPFrames_pbeg = t->pbeg;
	*pw = TextPFrames_PU(F->left);
	*tw = TextPFrames_PU(t->w);
	*ddx = 0;
	*cn = 0;
	if (t->pbeg != t->org) {
		*pw += (int)__DIV(TextPFrames_P->left + t->indent, 3048);
		*tw -= (int)__DIV(t->indent, 3048);
		if (__IN(1, TextPFrames_P->opts)) {
			if (__IN(2, TextPFrames_P->opts) && t->nob > 0) {
				w = *tw;
				*tw = (int)__DIV(TextPFrames_P->width - t->indent, 3048);
				*ddx = __DIV(*tw - w, t->nob);
				*cn = (int)__MOD(*tw - w, t->nob);
			}
		} else if (__IN(2, TextPFrames_P->opts)) {
			*pw += (int)__DIV(TextPFrames_P->width, 3048) - *tw;
		} else {
			*pw += __ASHR((int)__DIV(TextPFrames_P->width, 3048) - *tw, 1);
		}
	}
}

static void TextPFrames_DrawSpecial (TextPFrames_Frame F, INTEGER px, INTEGER py, INTEGER x, INTEGER y)
{
	Texts_Elem e = NIL;
	LONGINT pat = 0;
	INTEGER dx = 0, w = 0, h = 0;
	TextFrames_DisplayMsg msg = {0};
	if ((TextPFrames_nextCh == ' ' || TextPFrames_nextCh == 0x0d) || TextPFrames_nextCh == 0x09) {
	} else if (TextPFrames_R.elem != NIL) {
		e = TextPFrames_R.elem;
		if (!__ISP(e, TextFrames_ParcDesc, 2) || F->showsParcs) {
			msg.prepare = 0;
			msg.fnt = TextPFrames_R.fnt;
			msg.col = TextPFrames_R.col;
			msg.pos = Texts_Pos(&TextPFrames_R, Texts_Reader__typ) - 1;
			msg.frame = (Display_Frame)F;
			msg.X0 = TextPFrames_SU(px + x);
			msg.Y0 = py + y;
			msg.elemFrame = NIL;
			(*e->handle)(e, (void*)&msg, TextFrames_DisplayMsg__typ);
			if (msg.elemFrame != NIL) {
				msg.elemFrame->next = F->dsc;
				F->dsc = msg.elemFrame;
			}
		} else if ((__ISP(e, TextFrames_ParcDesc, 2) && !F->showsParcs) && __IN(3, __GUARDP(e, TextFrames_ParcDesc, 2)->opts)) {
			Display_ReplPattern(15, Display_grey1, TextPFrames_SU(px + x), py, (int)__DIV(e->W, 3048), 1, 0);
		}
	} else {
		TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &dx, &x, &y, &w, &h, &pat);
		Display_CopyPattern(TextPFrames_R.col, pat, TextPFrames_SU(px + x), py + y, 0);
	}
}

static void TextPFrames_DrawBanner (TextPFrames_Frame F, INTEGER pno, INTEGER bw, INTEGER px, INTEGER py, INTEGER th, INTEGER mw)
{
	LONGINT pat = 0;
	INTEGER i = 0, j = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR pstr[5];
	if (bw <= mw) {
		Display_ReplPattern(15, Display_grey1, px + bw, py, 1, th, 0);
		bw -= 2;
	} else {
		bw = mw;
	}
	py += th - 18;
	i = 0;
	j = pno;
	do {
		pstr[__X(i, 5)] = (CHAR)(48 + (int)__MOD(j, 10));
		j = __DIV(j, 10);
		i += 1;
	} while (!(j == 0));
	while (j < i) {
		Display_GetChar(TextPFrames_pfnt->raster, pstr[__X(j, 5)], &dx, &x, &y, &w, &h, &pat);
		bw -= dx;
		j += 1;
	}
	Display_ReplConst(15, px, py, bw - 2, 1, 0);
	Display_ReplConst(15, px, py + 2, bw - 2, 1, 0);
	px += bw;
	while (i > 0) {
		i -= 1;
		Display_GetChar(TextPFrames_pfnt->raster, pstr[__X(i, 5)], &dx, &x, &y, &w, &h, &pat);
		Display_CopyPattern(15, pat, px + x, py + y, 0);
		px += dx;
	}
}

static void TextPFrames_ShowLine (TextPFrames_Frame F, TextPFrames_TextLine t, INTEGER left, INTEGER right, INTEGER py)
{
	LONGINT pat = 0, i = 0;
	BOOLEAN trunc = 0;
	INTEGER n = 0, cn = 0, lm = 0, px = 0, pw = 0, tw = 0, ddx = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, t->org);
	TextPFrames_AdjustMetrics(F, t, &pw, &tw, &ddx, &cn);
	if (F->pages > 0) {
		if (TextPFrames_SU(F->width) < (F->W - F->left) - F->right) {
			Display_ReplPattern(15, Display_grey1, (F->X + F->left) + TextPFrames_SU(F->width), py, 1, t->h, 0);
		}
		if (t->pno >= 0) {
			TextPFrames_DrawBanner(F, t->pno, TextPFrames_SU(F->width), F->X + F->left, py, t->h, (F->W - F->left) - F->right);
		}
	}
	lm = TextPFrames_PU(F->X + F->left) + (int)__DIV(TextPFrames_P->left, 3048);
	px = TextPFrames_PU(F->X) + pw;
	py += t->dsr;
	i = 0;
	n = 0;
	px = ((px + TextPFrames_PU(F->X + F->left)) - TextPFrames_PU(F->X)) - TextPFrames_PU(F->left);
	while (i < t->len) {
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
		if (TextPFrames_nextCh <= ' ') {
			TextPFrames_GetSpecial(F, &n, cn, ddx, px - lm, &dx, &x, &y, &w, &h, &trunc);
		} else {
			TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &dx, &x, &y, &w, &h, &pat);
		}
		y += __ASHR(TextPFrames_R.fnt->height * (int)TextPFrames_R.voff, 6);
		if ((px + x) + w <= right) {
			if (px + x >= left) {
				if (TextPFrames_nextCh <= ' ') {
					if (trunc) {
						Display_ReplPattern(TextPFrames_R.col, Display_grey0, TextPFrames_SU(px + x), py + y, TextPFrames_SU(w), h, 0);
					} else {
						TextPFrames_DrawSpecial(F, px, py, x, y);
					}
				} else {
					Display_CopyPattern(TextPFrames_R.col, pat, TextPFrames_SU(px + x), py + y, 0);
				}
			}
			px += dx;
			i += 1;
		} else {
			i = t->len;
		}
	}
}

static void TextPFrames_ShowLines (TextPFrames_Frame F, INTEGER botH, INTEGER topH)
{
	TextPFrames_TextLine t = NIL;
	INTEGER ph = 0;
	t = F->trailer->next;
	ph = F->H - F->top;
	while (t != F->trailer && ph - t->h >= topH) {
		ph -= t->h;
		t = t->next;
	}
	while (t != F->trailer && ph - t->h >= botH) {
		ph -= t->h;
		TextPFrames_ShowLine(F, t, TextPFrames_PU(F->X + F->left), TextPFrames_PU((F->X + F->W) - F->right), F->Y + ph);
		t = t->next;
	}
}

static void TextPFrames_ShowLinesErasing (TextPFrames_Frame F, INTEGER botH, INTEGER topH)
{
	TextPFrames_TextLine t = NIL;
	INTEGER ph = 0;
	t = F->trailer->next;
	ph = F->H - F->top;
	while (t != F->trailer && ph - t->h >= topH) {
		ph -= t->h;
		t = t->next;
	}
	while (t != F->trailer && ph - t->h >= botH) {
		ph -= t->h;
		TextPFrames_Erase(F, F->X + F->left, F->Y + ph, (F->W - F->right) - F->left, t->h);
		TextPFrames_ShowLine(F, t, TextPFrames_PU(F->X + F->left), TextPFrames_PU((F->X + F->W) - F->right), F->Y + ph);
		t = t->next;
	}
}

static void TextPFrames_MeasureLine (TextPFrames_Frame F, INTEGER maxW, TextPFrames_TextLine t)
{
	LONGINT pat = 0, porg = 0, len = 0, bklen = 0, d = 0;
	BOOLEAN eol = 0, trunc = 0;
	INTEGER nob = 0, bknob = 0, width = 0, minY = 0, bkminY = 0, maxY = 0, bkmaxY = 0, tw = 0, bktw = 0, lsp = 0, dsr = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_Reader R1 = {0};
	CHAR peekCh = 0;
	len = 0;
	nob = 0;
	bklen = -999;
	tw = 0;
	dx = 0;
	minY = 0;
	maxY = 0;
	TextFrames_ParcBefore(F->text, t->org, &TextPFrames_P, &TextPFrames_pbeg);
	lsp = (int)__DIV(TextPFrames_P->lsp, (LONGINT)TextPFrames_unit);
	dsr = (int)__DIV(TextPFrames_P->dsr, (LONGINT)TextPFrames_unit);
	width = (int)__DIV(TextPFrames_P->width, 3048);
	t->indent = 0;
	if (t->org > 0) {
		Texts_OpenReader(&R1, Texts_Reader__typ, F->text, t->org - 1);
		Texts_Read(&R1, Texts_Reader__typ, &peekCh);
		if (peekCh == 0x0d || R1.elem != NIL && __ISP(R1.elem, TextFrames_ParcDesc, 2)) {
			t->indent = TextPFrames_P->first;
		}
	}
	tw += (int)__DIV(t->indent, 3048);
	for (;;) {
		if (TextPFrames_R.eot || TextPFrames_nextCh == 0x0d) {
			nob = 0;
			eol = !TextPFrames_R.eot;
			break;
		}
		if (TextPFrames_nextCh <= ' ') {
			TextPFrames_MeasureSpecial(tw, &dx, &x, &y, &w, &h, &trunc);
		} else {
			TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &dx, &x, &y, &w, &h, &pat);
		}
		if (tw + dx > width) {
			d = len - bklen;
			if (d < 30 && TextPFrames_nextCh > ' ') {
				eol = 1;
				Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, Texts_Pos(&TextPFrames_R, Texts_Reader__typ) - d);
				nob = bknob;
				len = bklen;
				tw = bktw;
				minY = bkminY;
				maxY = bkmaxY;
			} else if (len == 0) {
				len += 1;
				y += __ASHR(TextPFrames_R.fnt->height * (int)TextPFrames_R.voff, 6);
				minY = TextPFrames_Min(minY, y);
				maxY = TextPFrames_Max(maxY, y + h);
				Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
				eol = 0;
				tw = maxW;
			} else {
				eol = TextPFrames_nextCh <= ' ' && TextPFrames_nextCh != 0x1c;
			}
			break;
		}
		if (TextPFrames_nextCh <= ' ' && TextPFrames_nextCh != 0x1c) {
			bknob = nob;
			bklen = len;
			bktw = tw;
			bkminY = minY;
			bkmaxY = maxY;
			if (TextPFrames_nextCh == ' ') {
				nob += 1;
			}
		}
		len += 1;
		tw += dx;
		y += __ASHR(TextPFrames_R.fnt->height * (int)TextPFrames_R.voff, 6);
		if (y < minY) {
			minY = y;
		}
		if (y + h > maxY) {
			maxY = y + h;
		}
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
	}
	if (!F->showsParcs && TextPFrames_pbeg == t->org) {
		dsr = 0;
		t->h = (int)__DIV(TextPFrames_P->lead, (LONGINT)TextPFrames_unit) + 1;
	} else if (__IN(0, TextPFrames_P->opts)) {
		while (dsr < -minY) {
			dsr += lsp;
		}
		t->h = TextPFrames_Max(lsp, dsr + maxY);
		t->h += (int)__MOD(-t->h, lsp);
	} else {
		dsr = TextPFrames_Max(dsr, -minY);
		t->h = TextPFrames_Max(lsp, dsr + maxY);
	}
	TextPFrames_LocatePage(F, t->org, &porg, &t->pno);
	if (t->org == porg) {
		t->h += 20;
	} else {
		t->pno = -1;
	}
	t->len = len;
	t->w = TextPFrames_Min(TextPFrames_SU(tw), maxW);
	t->dsr = dsr;
	t->nob = nob;
	t->eot = TextPFrames_R.eot;
	t->P = TextPFrames_P;
	t->pbeg = TextPFrames_pbeg;
	if (eol) {
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
		t->span = len + 1;
	} else {
		t->span = len;
	}
}

static void TextPFrames_MeasureLines (TextPFrames_Frame F, LONGINT org, TextPFrames_TextLine *trailer)
{
	TextPFrames_TextLine s = NIL, t = NIL;
	INTEGER ph = 0;
	__NEW(*trailer, TextPFrames_TextLineDesc);
	s = *trailer;
	Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, org);
	Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
	ph = F->H - F->top;
	for (;;) {
		__NEW(t, TextPFrames_TextLineDesc);
		t->org = org;
		TextPFrames_MeasureLine(F, (F->W - F->left) - F->right, t);
		if (ph - t->h < F->bot) {
			break;
		}
		s->next = t;
		s = t;
		org += s->span;
		ph -= s->h;
		if (TextPFrames_R.eot) {
			break;
		}
	}
	s->next = *trailer;
	(*trailer)->eot = 1;
	(*trailer)->org = org;
	(*trailer)->len = 0;
	(*trailer)->w = 0;
	(*trailer)->h = (int)__DIV(TextFrames_defParc->lsp, (LONGINT)TextPFrames_unit);
	(*trailer)->P = TextPFrames_P;
	(*trailer)->pbeg = TextPFrames_pbeg;
}

static void TextPFrames_LocateLineTop (TextPFrames_Frame F, TextPFrames_TextLine trailer, LONGINT org, TextPFrames_Location *loc, LONGINT *loc__typ)
{
	TextPFrames_TextLine t = NIL;
	INTEGER ph = 0;
	ph = F->H - F->top;
	t = trailer->next;
	while (t != trailer && t->org != org) {
		ph -= t->h;
		t = t->next;
	}
	(*loc).org = org;
	(*loc).line = t;
	(*loc).y = F->Y + ph;
}

static void TextPFrames_Width (TextPFrames_Frame F, TextPFrames_TextLine t, LONGINT pos, INTEGER *pw, INTEGER *dx, INTEGER *dy)
{
	LONGINT pat = 0, i = 0;
	INTEGER n = 0, mw = 0, lm = 0, tw = 0, ddx = 0, cn = 0, x = 0, y = 0, w = 0, h = 0;
	BOOLEAN trunc = 0;
	TextPFrames_AdjustMetrics(F, t, &*pw, &tw, &ddx, &cn);
	*dy = 0;
	lm = TextPFrames_PU(F->left) + (int)__DIV(TextPFrames_P->left, 3048);
	if (t != F->trailer) {
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, t->org);
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
		i = 0;
		n = 0;
		pos -= t->org;
		*dx = 0;
		mw = TextPFrames_PU(F->W - F->right);
		while (((!TextPFrames_R.eot && i < t->len) && i <= pos) && *pw + *dx <= mw) {
			i += 1;
			*pw += *dx;
			if (TextPFrames_nextCh <= ' ') {
				TextPFrames_GetSpecial(F, &n, cn, ddx, *pw - lm, &*dx, &x, &y, &w, &h, &trunc);
			} else {
				TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &*dx, &x, &y, &w, &h, &pat);
			}
			*dy = __ASHR(TextPFrames_R.fnt->height * (int)TextPFrames_R.voff, 6);
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
		}
		if (i <= pos && *pw + *dx <= mw) {
			i += 1;
			*pw += *dx;
		}
	} else {
		*dx = TextPFrames_PU(4);
	}
}

void TextPFrames_LocatePos (TextPFrames_Frame F, LONGINT pos, TextPFrames_Location *loc, LONGINT *loc__typ)
{
	TextPFrames_TextLine t = NIL;
	INTEGER pw = 0, dx = 0, dy = 0;
	if (pos < F->org) {
		pos = F->org;
		t = F->trailer->next;
	} else if (pos < F->trailer->org) {
		t = F->trailer;
		while (t->next != F->trailer && t->next->org <= pos) {
			t = t->next;
		}
	} else {
		pos = F->trailer->org;
		t = F->trailer->next;
		while (!t->eot) {
			t = t->next;
		}
	}
	TextPFrames_Width(F, t, pos, &pw, &dx, &dy);
	TextPFrames_LocateLineTop(F, F->trailer, t->org, &*loc, loc__typ);
	(*loc).y -= (*loc).line->h;
	(*loc).org = t->org;
	(*loc).pos = pos;
	(*loc).x = F->X + TextPFrames_SU(pw);
	(*loc).dx = TextPFrames_SU(dx);
	(*loc).dy = dy;
	(*loc).line = t;
	(*loc).trunc = 0;
}

void TextPFrames_LocateLine (TextPFrames_Frame F, INTEGER y, TextPFrames_Location *loc, LONGINT *loc__typ)
{
	TextPFrames_TextLine t = NIL;
	INTEGER h = 0, ph = 0, pw = 0, tw = 0, ddx = 0, cn = 0;
	t = F->trailer->next;
	h = y - F->Y;
	ph = (F->H - F->top) - t->h;
	while ((!t->eot && ph - t->next->h >= F->bot) && ph > h) {
		t = t->next;
		ph -= t->h;
	}
	TextPFrames_AdjustMetrics(F, t, &pw, &tw, &ddx, &cn);
	if (pw >= TextPFrames_PU((F->X + F->W) - F->right)) {
		pw = TextPFrames_PU(((F->X + F->W) - F->right) - 4);
	}
	(*loc).org = t->org;
	(*loc).pos = (*loc).org;
	(*loc).x = F->X + TextPFrames_SU(pw);
	(*loc).y = F->Y + ph;
	(*loc).dx = TextPFrames_SU(tw);
	(*loc).dy = 0;
	(*loc).line = t;
	(*loc).trunc = 0;
}

void TextPFrames_LocateChar (TextPFrames_Frame F, INTEGER x, INTEGER y, TextPFrames_Location *loc, LONGINT *loc__typ)
{
	TextPFrames_TextLine t = NIL;
	LONGINT pat = 0, i = 0;
	BOOLEAN trunc = 0;
	INTEGER n = 0, w = 0, lm = 0, pw = 0, tw = 0, ddx = 0, cn = 0, dx = 0, xc = 0, yc = 0, wc = 0, hc = 0;
	TextPFrames_LocateLine(F, y, &*loc, loc__typ);
	t = (*loc).line;
	w = TextPFrames_PU(x - F->X);
	TextPFrames_AdjustMetrics(F, t, &pw, &tw, &ddx, &cn);
	lm = TextPFrames_PU(F->left) + (int)__DIV(TextPFrames_P->left, 3048);
	if (t != F->trailer && w > pw) {
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, t->org);
		i = 0;
		n = 0;
		dx = 0;
		TextPFrames_nextCh = 0x00;
		while (i < t->len && pw + dx < w) {
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
			i += 1;
			pw += dx;
			if (TextPFrames_nextCh <= ' ') {
				TextPFrames_GetSpecial(F, &n, cn, ddx, pw - lm, &dx, &xc, &yc, &wc, &hc, &trunc);
			} else {
				TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &dx, &xc, &yc, &wc, &hc, &pat);
				trunc = 0;
			}
		}
		if (pw + dx < w) {
			i += 1;
			pw += dx;
			TextPFrames_R.elem = NIL;
		}
		(*loc).pos += i - 1;
		(*loc).x = F->X + TextPFrames_SU(pw);
		(*loc).trunc = trunc;
		if (i < t->len) {
			(*loc).dx = TextPFrames_SU(dx);
			(*loc).dy = __ASHR(TextPFrames_R.fnt->height * (int)TextPFrames_R.voff, 6);
		} else {
			(*loc).dx = 4;
		}
	} else {
		(*loc).dx = 4;
	}
}

void TextPFrames_LocateWord (TextPFrames_Frame F, INTEGER x, INTEGER y, TextPFrames_Location *loc, LONGINT *loc__typ)
{
	TextPFrames_TextLine t = NIL;
	LONGINT pos = 0, i = 0;
	INTEGER px = 0, rx = 0;
	LONGINT pat = 0;
	INTEGER dx = 0, xc = 0, yc = 0, wc = 0, hc = 0;
	TextPFrames_LocateChar(F, x, y, &*loc, loc__typ);
	pos = (*loc).pos + 1;
	do {
		pos -= 1;
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, pos);
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
	} while (!(pos < (*loc).org || TextPFrames_nextCh > ' '));
	pos += 1;
	do {
		pos -= 1;
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, pos);
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
	} while (!(pos < (*loc).org || TextPFrames_nextCh <= ' '));
	TextPFrames_LocatePos(F, pos + 1, &*loc, loc__typ);
	t = (*loc).line;
	i = (*loc).pos - (*loc).org;
	if (i < t->len) {
		px = TextPFrames_PU((*loc).x);
		rx = TextPFrames_PU((F->X + F->W) - F->right);
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, (*loc).pos);
		dx = 0;
		wc = 0;
		TextPFrames_nextCh = 'x';
		while ((i < t->len && TextPFrames_nextCh > ' ') && px + dx < rx) {
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
			i += 1;
			px += dx;
			TextPFrames_GetChar(TextPFrames_R.fnt, TextPFrames_nextCh, &dx, &xc, &yc, &wc, &hc, &pat);
		}
		if (TextPFrames_nextCh > ' ' && px + dx < rx) {
			i += 1;
			px += dx;
		}
		(*loc).dx = TextPFrames_SU(px) - (*loc).x;
	} else {
		(*loc).dx = 0;
	}
}

LONGINT TextPFrames_Pos (TextPFrames_Frame F, INTEGER x, INTEGER y)
{
	TextPFrames_Location loc = {0};
	TextPFrames_LocateChar(F, x, y, &loc, TextPFrames_Location__typ);
	return loc.pos;
}

Display_Frame TextPFrames_ThisSubFrame (TextPFrames_Frame F, INTEGER x, INTEGER y)
{
	Display_Frame f = NIL;
	f = F->dsc;
	while (f != NIL && (((x < f->X || x >= f->X + f->W) || y < f->Y) || y >= f->Y + f->H)) {
		f = f->next;
	}
	return f;
}

void TextPFrames_PassSubFocus (TextPFrames_Frame F, Display_Frame f)
{
	TextPFrames_Location loc = {0};
	Display_Frame f1 = NIL;
	Oberon_ControlMsg ctrl = {0};
	TextFrames_FocusMsg focus = {0};
	if (F->focus != NIL) {
		f1 = F->focus;
		ctrl.id = 0;
		(*f1->handle)(f1, (void*)&ctrl, Oberon_ControlMsg__typ);
		TextPFrames_LocateChar(F, f1->X + 1, f1->Y + 1, &loc, TextPFrames_Location__typ);
		focus.focus = 0;
		focus.elemFrame = f1;
		focus.frame = (Display_Frame)F;
		(*TextPFrames_R.elem->handle)(TextPFrames_R.elem, (void*)&focus, TextFrames_FocusMsg__typ);
		TextPFrames_InvertBorder(f1);
	}
	if (f != NIL) {
		TextPFrames_LocateChar(F, f->X + 1, f->Y + 1, &loc, TextPFrames_Location__typ);
		focus.focus = 1;
		focus.elemFrame = f;
		focus.frame = (Display_Frame)F;
		(*TextPFrames_R.elem->handle)(TextPFrames_R.elem, (void*)&focus, TextFrames_FocusMsg__typ);
		TextPFrames_InvertBorder(f);
	}
	F->focus = f;
}

void TextPFrames_RemoveSelection (TextPFrames_Frame F)
{
	if (F->hasSel) {
		TextPFrames_InvertSelection(F, F->SelBeg, F->SelEnd);
		F->hasSel = 0;
	}
}

void TextPFrames_SetSelection (TextPFrames_Frame F, LONGINT beg, LONGINT end)
{
	TextPFrames_Location loc = {0};
	if (end > F->text->len) {
		end = F->text->len;
	}
	if (end > beg) {
		if (F->hasSel && F->SelBeg.pos == beg) {
			if (F->SelEnd.pos < end && F->SelEnd.pos < F->trailer->org) {
				TextPFrames_LocatePos(F, F->SelEnd.pos, &loc, TextPFrames_Location__typ);
				TextPFrames_LocatePos(F, end, &F->SelEnd, TextPFrames_Location__typ);
				TextPFrames_InvertSelection(F, loc, F->SelEnd);
			} else if (end < F->SelEnd.pos) {
				TextPFrames_LocatePos(F, end, &loc, TextPFrames_Location__typ);
				TextPFrames_InvertSelection(F, loc, F->SelEnd);
				TextPFrames_LocatePos(F, end, &F->SelEnd, TextPFrames_Location__typ);
			}
		} else if ((!F->hasSel || F->SelBeg.pos != beg) || F->SelEnd.pos != end) {
			TextPFrames_RemoveSelection(F);
			TextPFrames_PassSubFocus(F, NIL);
			TextPFrames_LocatePos(F, beg, &F->SelBeg, TextPFrames_Location__typ);
			TextPFrames_LocatePos(F, end, &F->SelEnd, TextPFrames_Location__typ);
			TextPFrames_InvertSelection(F, F->SelBeg, F->SelEnd);
		}
		F->hasSel = 1;
		F->time = Oberon_Time();
	}
}

void TextPFrames_RemoveCaret (TextPFrames_Frame F)
{
	Oberon_ControlMsg msg = {0};
	if (F->focus != NIL) {
		msg.id = 0;
		(*F->focus->handle)(F->focus, (void*)&msg, Oberon_ControlMsg__typ);
	}
	if (F->hasCar) {
		TextPFrames_InvertCaret(F);
		F->hasCar = 0;
	}
}

void TextPFrames_SetCaret (TextPFrames_Frame F, LONGINT pos)
{
	if (!F->hasCar || F->CarLoc.pos != pos) {
		TextPFrames_RemoveCaret(F);
		TextPFrames_PassSubFocus(F, NIL);
		TextPFrames_LocatePos(F, pos, &F->CarLoc, TextPFrames_Location__typ);
		if ((F->H - F->top) - F->bot >= F->CarLoc.line->h && F->CarLoc.x <= (F->X + F->W) - F->right) {
			TextPFrames_LocateChar(F, F->CarLoc.x + 1, F->CarLoc.y, &F->CarLoc, TextPFrames_Location__typ);
			if (F->CarLoc.pos == pos) {
				TextPFrames_InvertCaret(F);
				F->hasCar = 1;
			}
		}
	}
}

void TextPFrames_Neutralize (TextPFrames_Frame F)
{
	Display_Frame f = NIL;
	Oberon_ControlMsg msg = {0};
	TextPFrames_RemoveCaret(F);
	TextPFrames_RemoveSelection(F);
	f = F->dsc;
	msg.id = 1;
	while (f != NIL) {
		(*f->handle)(f, (void*)&msg, Oberon_ControlMsg__typ);
		if (f == F->focus) {
			TextPFrames_PassSubFocus(F, NIL);
		}
		f = f->next;
	}
}

static void TextPFrames_Complete (TextPFrames_Frame F, TextPFrames_TextLine trailer, TextPFrames_TextLine *s, LONGINT *org, INTEGER *ph)
{
	TextPFrames_TextLine u = NIL;
	if (*ph > F->bot) {
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, *org);
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
		for (;;) {
			if (TextPFrames_R.eot) {
				break;
			}
			__NEW(u, TextPFrames_TextLineDesc);
			u->org = *org;
			TextPFrames_MeasureLine(F, (F->W - F->left) - F->right, u);
			if (*ph - u->h < F->bot) {
				break;
			}
			(*s)->next = u;
			*s = (*s)->next;
			*ph -= (*s)->h;
			*org += (*s)->span;
		}
	}
	(*s)->next = trailer;
	trailer->eot = 1;
	trailer->org = *org;
	trailer->len = 0;
	trailer->w = 0;
	trailer->h = (int)__DIV(TextFrames_defParc->lsp, (LONGINT)TextPFrames_unit);
	trailer->P = TextPFrames_P;
	trailer->pbeg = TextPFrames_pbeg;
}

static void TextPFrames_ShowFrom (TextPFrames_Frame F, LONGINT pos)
{
	TextPFrames_TextLine new = NIL, s = NIL;
	TextPFrames_Location beg = {0}, end = {0};
	LONGINT org = 0;
	INTEGER ph = 0, y0 = 0, dy = 0;
	TextPFrames_Neutralize(F);
	if ((F->trailer != NIL && F->org < pos) && pos < F->trailer->org) {
		TextPFrames_LocateLineTop(F, F->trailer, pos, &beg, TextPFrames_Location__typ);
		TextPFrames_LocateLineTop(F, F->trailer, F->trailer->org, &end, TextPFrames_Location__typ);
		dy = ((F->Y + F->H) - F->top) - beg.y;
		TextPFrames_Shift(F, end.y, end.y + dy, beg.y - end.y);
		TextPFrames_Erase(F, F->X + F->left, end.y, F->W - F->left, dy);
		s = F->trailer->next;
		while (s->org != pos) {
			s = s->next;
		}
		F->trailer->next = s;
		org = s->org + s->span;
		ph = (F->H - F->top) - s->h;
		TextPFrames_Complete(F, F->trailer, &s, &org, &ph);
		F->org = pos;
		TextPFrames_ShowLines(F, F->bot, (end.y + dy) - F->Y);
	} else if (F->trailer == NIL || pos != F->org) {
		TextPFrames_MeasureLines(F, pos, &new);
		if ((F->trailer != NIL && pos < F->org) && F->org <= new->org) {
			TextPFrames_LocateLineTop(F, new, F->org, &beg, TextPFrames_Location__typ);
			TextPFrames_LocateLineTop(F, new, new->org, &end, TextPFrames_Location__typ);
			y0 = (F->Y + F->H) - F->top;
			TextPFrames_Shift(F, y0 - (beg.y - end.y), end.y, beg.y - end.y);
			TextPFrames_Erase(F, F->X + F->left, beg.y, F->W - F->left, y0 - beg.y);
			TextPFrames_Erase(F, F->X + F->left, F->Y + F->bot, F->W - F->left, end.y - (F->Y + F->bot));
			F->org = pos;
			F->trailer = new;
			TextPFrames_ShowLines(F, beg.y - F->Y, F->H - F->top);
		} else {
			if (F->trailer == NIL) {
				TextPFrames_Erase(F, F->X, F->Y, F->W, F->H);
				TextPFrames_ShowBar(F, 0, F->H);
				F->markH = -1;
			} else {
				TextPFrames_Erase(F, F->X + F->left, F->Y + F->bot, F->W - F->left, (F->H - F->bot) - F->top);
			}
			F->org = pos;
			F->trailer = new;
			TextPFrames_ShowLines(F, F->bot, F->H - F->top);
		}
	}
	TextPFrames_ShowTick(F);
}

void TextPFrames_Show (TextPFrames_Frame F, LONGINT pos)
{
	TextPFrames_BegOfLine(F->text, &pos, 1);
	TextPFrames_ShowFrom(F, pos);
}

void TextPFrames_Resize (TextPFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	TextPFrames_Location loc = {0};
	INTEGER oldY = 0, oldH = 0, dh = 0;
	if (w == 0 || h == 0) {
		TextPFrames_InvalSubFrames(F, F->X, F->Y, F->W, F->H);
		F->X = x;
		F->Y = y;
		F->W = w;
		F->H = h;
		F->trailer = NIL;
	} else if ((F->trailer != NIL && x == F->X) && w == F->W) {
		oldY = F->Y;
		oldH = F->H;
		TextPFrames_Tick(F);
		F->markH = -1;
		F->Y = y;
		F->H = h;
		if (h > oldH) {
			dh = h - oldH;
			Display_CopyBlock(x, oldY, w, oldH, x, y + dh, 0);
			TextPFrames_ShiftSubFrames(F, oldY, y + dh, oldH);
			TextPFrames_EraseRect(F, x, y, w, dh);
			TextPFrames_ShowBar(F, 0, dh);
			TextPFrames_LocateLineTop(F, F->trailer, F->trailer->org, &loc, TextPFrames_Location__typ);
			TextPFrames_MeasureLines(F, F->org, &F->trailer);
			TextPFrames_ShowLines(F, F->bot, loc.y - F->Y);
		} else {
			dh = oldH - h;
			TextPFrames_MeasureLines(F, F->org, &F->trailer);
			TextPFrames_LocateLineTop(F, F->trailer, F->trailer->org, &loc, TextPFrames_Location__typ);
			Display_CopyBlock(x, oldY + dh, w, h, x, y, 0);
			TextPFrames_ShiftSubFrames(F, oldY + dh, y, h);
			TextPFrames_EraseRect(F, x + F->left, y, w - F->left, loc.y - F->Y);
			TextPFrames_InvalSubFrames(F, x, oldY, w, y - oldY);
			TextPFrames_InvalSubFrames(F, x, y + h, w, dh - (y - oldY));
		}
		TextPFrames_ShowTick(F);
	} else {
		F->X = x;
		F->Y = y;
		F->W = w;
		F->H = h;
		F->trailer = NIL;
		TextPFrames_Show(F, F->org);
	}
}

static struct Update__68 {
	TextPFrames_Frame *F;
	TextFrames_UpdateMsg *msg;
	LONGINT *msg__typ;
	struct Update__68 *lnk;
} *Update__68_s;

static void Adjust__69 (LONGINT end, LONGINT delta);
static void Begin__71 (LONGINT *beg, LONGINT *org0, TextPFrames_TextLine *q);

static void Begin__71 (LONGINT *beg, LONGINT *org0, TextPFrames_TextLine *q)
{
	TextPFrames_TextLine trailer = NIL, t = NIL;
	LONGINT p = 0;
	trailer = (*Update__68_s->F)->trailer;
	t = trailer;
	*q = NIL;
	while ((t->next != trailer && t->next->org + t->next->span <= *beg) && !t->next->eot) {
		t = t->next;
	}
	if ((t != trailer && t->next != trailer) && *beg <= t->next->org + t->next->span) {
		Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, (*Update__68_s->F)->text, t->org);
		Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
		p = t->org;
		TextPFrames_NextLine((*Update__68_s->F)->text, &p);
		if (p == t->next->org) {
			*q = t->next;
			*org0 = (*q)->org;
		} else {
			*org0 = t->org;
			*beg = *org0;
		}
	} else {
		TextPFrames_BegOfLine((*Update__68_s->F)->text, &*beg, 1);
		if ((*Update__68_s->msg).beg < *beg + 30 && (*Update__68_s->F)->org < *beg) {
			*beg -= 1;
			TextPFrames_BegOfLine((*Update__68_s->F)->text, &*beg, 1);
		}
		*org0 = *beg;
	}
}

static void Adjust__69 (LONGINT end, LONGINT delta)
{
	TextPFrames_TextLine new = NIL, old = NIL, s = NIL, t = NIL, u = NIL, p = NIL, q = NIL;
	TextPFrames_Location bot = {0};
	LONGINT org = 0, org0 = 0, beg = 0;
	INTEGER ph = 0, h0 = 0, h1 = 0, H1 = 0, h2 = 0, lm = 0, dx = 0, dy = 0;
	q = NIL;
	TextPFrames_LocateLineTop(*Update__68_s->F, (*Update__68_s->F)->trailer, (*Update__68_s->F)->trailer->org, &bot, TextPFrames_Location__typ);
	if ((*Update__68_s->msg).beg < (*Update__68_s->F)->org) {
		org0 = (*Update__68_s->F)->org;
		beg = org0;
	} else {
		beg = (*Update__68_s->msg).beg;
		Begin__71(&beg, &org0, &q);
	}
	__NEW(new, TextPFrames_TextLineDesc);
	s = new;
	old = (*Update__68_s->F)->trailer;
	t = old;
	org = (*Update__68_s->F)->org;
	ph = (*Update__68_s->F)->H - (*Update__68_s->F)->top;
	while (t->next != old && t->next->org != org0) {
		t = t->next;
		s->next = t;
		s = t;
		ph -= s->h;
		org += s->span;
	}
	h0 = ph;
	H1 = h0;
	t = t->next;
	p = s;
	Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, (*Update__68_s->F)->text, org);
	Texts_Read(&TextPFrames_R, Texts_Reader__typ, &TextPFrames_nextCh);
	for (;;) {
		__NEW(u, TextPFrames_TextLineDesc);
		u->org = org;
		TextPFrames_MeasureLine(*Update__68_s->F, ((*Update__68_s->F)->W - (*Update__68_s->F)->left) - (*Update__68_s->F)->right, u);
		if (ph - u->h < (*Update__68_s->F)->bot) {
			h1 = ph;
			h2 = h1;
			break;
		}
		s->next = u;
		s = s->next;
		ph -= s->h;
		org += s->span;
		if (TextPFrames_R.eot) {
			h1 = ph;
			h2 = h1;
			break;
		}
		if (org > end) {
			while (t != old && org > t->org + delta) {
				H1 -= t->h;
				t = t->next;
			}
			if (org == t->org + delta && TextPFrames_P == t->P) {
				h1 = ph;
				while (t != old && ph - t->h >= (*Update__68_s->F)->bot) {
					s->next = t;
					s = t;
					s->org = org;
					TextFrames_ParcBefore((*Update__68_s->F)->text, s->org, &s->P, &s->pbeg);
					ph -= s->h;
					org += s->span;
					t = t->next;
				}
				h2 = ph;
				break;
			}
		}
	}
	TextPFrames_Shift(*Update__68_s->F, ((*Update__68_s->F)->Y + h2) + (H1 - h1), (*Update__68_s->F)->Y + h2, h1 - h2);
	TextPFrames_Complete(*Update__68_s->F, new, &s, &org, &ph);
	(*Update__68_s->F)->trailer = new;
	t = p->next;
	if (((((q != NIL && q->h == t->h) && q->dsr == t->dsr) && q->org == t->org) && q->P == t->P) && end <= t->org + t->len) {
		TextPFrames_P = t->P;
		TextPFrames_pbeg = t->pbeg;
		if ((TextPFrames_P->opts & 0x06) == 0x02 || ((TextPFrames_P->opts & 0x06) == 0x06 && q->nob == 0) && t->nob == 0) {
			TextPFrames_Width(*Update__68_s->F, t, beg, &lm, &dx, &dy);
			h0 -= t->h;
			TextPFrames_Erase(*Update__68_s->F, (*Update__68_s->F)->X + TextPFrames_SU(lm), (*Update__68_s->F)->Y + h0, (*Update__68_s->F)->W - TextPFrames_SU(lm), t->h);
			TextPFrames_ShowLine(*Update__68_s->F, t, TextPFrames_PU((*Update__68_s->F)->X) + lm, TextPFrames_PU(((*Update__68_s->F)->X + (*Update__68_s->F)->W) - (*Update__68_s->F)->right), (*Update__68_s->F)->Y + h0);
		}
	}
	TextPFrames_ShowLinesErasing(*Update__68_s->F, h1, h0);
	TextPFrames_Erase(*Update__68_s->F, (*Update__68_s->F)->X + (*Update__68_s->F)->left, bot.y, (*Update__68_s->F)->W - (*Update__68_s->F)->left, h2 - (bot.y - (*Update__68_s->F)->Y));
	TextPFrames_ShowLines(*Update__68_s->F, (*Update__68_s->F)->bot, h2);
}

void TextPFrames_Update (TextPFrames_Frame F, TextFrames_UpdateMsg *msg, LONGINT *msg__typ)
{
	TextPFrames_TextLine t = NIL;
	LONGINT org = 0, d = 0;
	struct Update__68 _s;
	_s.F = &F;
	_s.msg = msg; _s.msg__typ = msg__typ;
	_s.lnk = Update__68_s;
	Update__68_s = &_s;
	if ((*msg).id == 1 && (*msg).beg < F->org) {
		t = F->trailer;
		d = (*msg).end - (*msg).beg;
		F->org += d;
		do {
			t->org += d;
			t = t->next;
		} while (!(t == F->trailer));
	} else if ((*msg).id == 2 && (*msg).end <= F->org) {
		t = F->trailer;
		d = (*msg).end - (*msg).beg;
		F->org -= d;
		do {
			t->org -= d;
			t = t->next;
		} while (!(t == F->trailer));
	}
	org = F->org;
	if ((*msg).beg <= F->org + 30) {
		TextPFrames_BegOfLine(F->text, &org, 1);
	}
	TextFrames_ParcBefore(F->text, org, &TextPFrames_P, &d);
	if ((org != F->org || TextPFrames_P != F->trailer->next->P) || F->pages != 0) {
		F->trailer = NIL;
		F->pages = 0;
		TextPFrames_Show(F, F->org);
	} else if ((*msg).end > org && (*msg).beg < F->trailer->org + 30) {
		if ((*msg).id == 0) {
			Adjust__69((*msg).end, 0);
		} else if ((*msg).id == 1) {
			Adjust__69((*msg).end, (*msg).end - (*msg).beg);
		} else if ((*msg).id == 2) {
			Adjust__69((*msg).beg, (*msg).beg - (*msg).end);
		}
	}
	TextPFrames_ShowTick(F);
	Update__68_s = _s.lnk;
}

void TextPFrames_TrackLine (TextPFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *org, SET *keysum)
{
	SET keys = 0;
	TextPFrames_Location new = {0}, old = {0};
	TextPFrames_LocateLine(F, *y, &old, TextPFrames_Location__typ);
	TextPFrames_InvertRect(F, old.x, old.y, old.dx + 4, 2);
	do {
		TextPFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		TextPFrames_LocateLine(F, *y, &new, TextPFrames_Location__typ);
		if (new.org != old.org) {
			TextPFrames_InvertRect(F, new.x, new.y, new.dx + 4, 2);
			TextPFrames_InvertRect(F, old.x, old.y, old.dx + 4, 2);
			old = new;
		}
	} while (!(keys == 0x0));
	TextPFrames_InvertRect(F, new.x, new.y, new.dx + 4, 2);
	*org = new.org;
}

void TextPFrames_TrackWord (TextPFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *pos, SET *keysum)
{
	SET keys = 0;
	TextPFrames_Location new = {0}, old = {0};
	TextPFrames_LocateWord(F, *x, *y, &old, TextPFrames_Location__typ);
	TextPFrames_InvertRect(F, old.x, old.y, old.dx, 2);
	do {
		TextPFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		TextPFrames_LocateWord(F, *x, *y, &new, TextPFrames_Location__typ);
		if (new.pos != old.pos) {
			TextPFrames_InvertRect(F, new.x, new.y, new.dx, 2);
			TextPFrames_InvertRect(F, old.x, old.y, old.dx, 2);
			old = new;
		}
	} while (!(keys == 0x0));
	TextPFrames_InvertRect(F, new.x, new.y, new.dx, 2);
	*pos = new.pos;
}

void TextPFrames_TrackCaret (TextPFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum)
{
	SET keys = 0;
	do {
		TextPFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		TextPFrames_SetCaret(F, TextPFrames_Pos(F, *x, *y));
	} while (!(keys == 0x0));
}

void TextPFrames_TrackSelection (TextPFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum)
{
	SET keys = 0;
	LONGINT pos = 0;
	Viewers_Viewer V = NIL;
	TextPFrames_Frame f = NIL;
	V = Viewers_This(F->X, F->Y);
	V = __GUARDP(V->next, Viewers_ViewerDesc, 1);
	if ((V->dsc != NIL && V->dsc->next != NIL) && __ISP(V->dsc->next, TextPFrames_FrameDesc, 2)) {
		f = __GUARDP(V->dsc->next, TextPFrames_FrameDesc, 2);
		if (f->hasSel && f->text == F->text) {
			if ((f->SelBeg.pos < f->trailer->org && f->org < f->SelEnd.pos) && f->SelBeg.pos <= TextPFrames_Pos(F, *x, *y)) {
				TextPFrames_SetSelection(F, f->SelBeg.pos, TextPFrames_Pos(F, *x, *y) + 1);
			} else {
				TextPFrames_RemoveSelection(f);
				f = NIL;
			}
		} else {
			f = NIL;
		}
	} else {
		f = NIL;
	}
	if (f == NIL) {
		if ((F->hasSel && F->SelBeg.pos + 1 == F->SelEnd.pos) && TextPFrames_Pos(F, *x, *y) == F->SelBeg.pos) {
			TextPFrames_SetSelection(F, F->SelBeg.org, TextPFrames_Pos(F, *x, *y) + 1);
		} else {
			TextPFrames_SetSelection(F, TextPFrames_Pos(F, *x, *y), TextPFrames_Pos(F, *x, *y) + 1);
		}
	}
	do {
		TextPFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		pos = TextPFrames_Pos(F, *x, *y) + 1;
		if (F->hasSel) {
			if (pos > F->SelBeg.pos) {
				TextPFrames_SetSelection(F, F->SelBeg.pos, pos);
				if (f != NIL) {
					TextPFrames_SetSelection(f, f->SelBeg.pos, pos);
					f->SelEnd.pos = F->SelEnd.pos;
				}
			}
		} else {
			TextPFrames_SetSelection(F, TextPFrames_Pos(F, *x, *y), TextPFrames_Pos(F, *x, *y) + 1);
		}
	} while (!(keys == 0x0));
	if (f != NIL) {
		F->SelBeg.pos = f->SelBeg.pos;
	}
}

void TextPFrames_Call (TextPFrames_Frame F, LONGINT pos, BOOLEAN new)
{
	Texts_Scanner S = {0};
	Oberon_ParList par = NIL;
	INTEGER res = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, F->text, pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.line == 0 && S.class == 1) {
		__NEW(par, Oberon_ParRec);
		par->frame = (Display_Frame)F;
		par->text = F->text;
		par->pos = Texts_Pos((void*)&S, Texts_Scanner__typ) - 1;
		Oberon_Call(S.s, 256, par, new, &res);
		if (res > 1) {
			Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)"Call error: ", (LONGINT)13);
			Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, Modules_importing, 20);
			if (res == 2) {
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)" not an obj-file", (LONGINT)17);
			} else if (res == 3) {
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)" imports ", (LONGINT)10);
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, Modules_imported, 20);
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)" with bad key", (LONGINT)14);
			} else if (res == 4) {
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)" corrupted obj file", (LONGINT)20);
			} else if (res == 6) {
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)" has too many imports", (LONGINT)22);
			} else if (res == 7) {
				Texts_WriteString(&TextPFrames_WL, Texts_Writer__typ, (CHAR*)" not enough space", (LONGINT)18);
			}
			Texts_WriteLn(&TextPFrames_WL, Texts_Writer__typ);
			Texts_Append(Oberon_Log, TextPFrames_WL.buf);
		}
	}
}

static void TextPFrames_ShiftBlock (TextPFrames_Frame F, INTEGER delta)
{
	Texts_Text text = NIL;
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	TextPFrames_SelectMsg select = {0};
	CHAR ch = 0;
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= 0 && text == F->text) {
		TextPFrames_BegOfLine(F->text, &beg, 0);
		pos = beg;
		while (pos < end) {
			Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, pos);
			Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch);
			while ((TextPFrames_R.elem != NIL && __ISP(TextPFrames_R.elem, TextFrames_ParcDesc, 2)) && pos < end) {
				Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch);
				pos += 1;
			}
			if (pos < end) {
				if (delta < 0) {
					if ((ch <= ' ' && ch != 0x0d) && ch != 0x1c) {
						Texts_Delete(F->text, pos, pos + 1);
						end -= 1;
					}
				} else {
					if ((ch <= ' ' && ch != 0x0d) && ch != 0x1c) {
						Texts_Write(&TextPFrames_W, Texts_Writer__typ, ch);
					} else {
						Texts_Write(&TextPFrames_W, Texts_Writer__typ, 0x09);
					}
					Texts_Insert(F->text, pos, TextPFrames_W.buf);
					end += 1;
					pos += 1;
				}
				Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, pos);
				do {
					Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch);
				} while (!(TextPFrames_R.eot || ch == 0x0d));
				pos = Texts_Pos(&TextPFrames_R, Texts_Reader__typ);
			}
		}
		select.text = F->text;
		select.beg = beg;
		select.end = pos;
		select.time = Oberon_Time();
		Viewers_Broadcast((void*)&select, TextPFrames_SelectMsg__typ);
	}
}

static struct Write__74 {
	TextPFrames_Frame *F;
	LONGINT *pos;
	CHAR (*buf)[32];
	struct Write__74 *lnk;
} *Write__74_s;

static void Flush__75 (void);
static void InsertBuffer__77 (void);
static BOOLEAN Visible__79 (CHAR ch);

static BOOLEAN Visible__79 (CHAR ch)
{
	LONGINT pat = 0;
	INTEGER dx = 0, x = 0, y = 0, w = 0, h = 0;
	TextPFrames_GetChar(TextPFrames_W.fnt, ch, &dx, &x, &y, &w, &h, &pat);
	return dx > 0;
}

static void InsertBuffer__77 (void)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	i = 0;
	j = 0;
	ch = (*Write__74_s->buf)[__X(i, 32)];
	while (ch != 0x00) {
		if (((ch == 0x09 || ch == 0x0d) || ch == ' ') || Visible__79(ch)) {
			Texts_Write(&TextPFrames_W, Texts_Writer__typ, ch);
			j += 1;
		}
		i += 1;
		ch = (*Write__74_s->buf)[__X(i, 32)];
	}
	if (j > 0) {
		Texts_Insert((*Write__74_s->F)->text, *Write__74_s->pos, TextPFrames_W.buf);
		*Write__74_s->pos += (LONGINT)j;
	}
}

static void Flush__75 (void)
{
	CHAR ch = 0;
	while (Input_Available() > 0) {
		Input_Read(&ch);
	}
}

void TextPFrames_Write (TextPFrames_Frame F, CHAR ch, Fonts_Font fnt, SHORTINT col, SHORTINT voff)
{
	TextPFrames_Location loc = {0};
	TextFrames_Parc parc = NIL;
	LONGINT org = 0, pos = 0, pbeg = 0;
	INTEGER i = 0;
	CHAR ch0 = 0;
	CHAR buf[32];
	Texts_CopyMsg copy = {0};
	Oberon_InputMsg input = {0};
	struct Write__74 _s;
	_s.F = &F;
	_s.pos = &pos;
	_s.buf = (void*)buf;
	_s.lnk = Write__74_s;
	Write__74_s = &_s;
	if (F->hasCar) {
		pos = F->CarLoc.pos;
		if (ch == 0x7f && pos > F->org) {
			pos -= 1;
			Texts_Delete(F->text, pos, pos + 1);
			Flush__75();
		} else if (ch == 0xc4 && pos > 0) {
			pos -= 1;
		} else if (ch == 0xc3 && pos < F->text->len) {
			pos += 1;
		} else if (ch == 0xac || ch == 0xad) {
			TextFrames_ParcBefore(F->text, pos, &TextPFrames_P, &pbeg);
			(*TextPFrames_P->handle)((void*)TextPFrames_P, (void*)&copy, Texts_CopyMsg__typ);
			parc = __GUARDP(copy.e, TextFrames_ParcDesc, 2);
			if (ch == 0xac) {
				parc->opts &= ~__SETOF(3);
			} else {
				parc->opts |= __SETOF(3);
			}
			Texts_SetFont(&TextPFrames_W, Texts_Writer__typ, fnt);
			Texts_SetColor(&TextPFrames_W, Texts_Writer__typ, col);
			Texts_SetOffset(&TextPFrames_W, Texts_Writer__typ, voff);
			Texts_WriteElem(&TextPFrames_W, Texts_Writer__typ, (void*)parc);
			Texts_Insert(F->text, pos, TextPFrames_W.buf);
			pos += 1;
		} else if (((ch == 0x09 || ch == 0x0a) || ch == 0x0d) || ch >= ' ') {
			if (F->text->len > 0) {
				if (pos < F->text->len) {
					Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, pos);
					Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch0);
				}
				if (pos > 0 && (pos == F->text->len || ch0 <= ' ')) {
					Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, pos - 1);
					Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch0);
				}
				Texts_SetFont(&TextPFrames_W, Texts_Writer__typ, TextPFrames_R.fnt);
				Texts_SetColor(&TextPFrames_W, Texts_Writer__typ, TextPFrames_R.col);
				if ((ch == 0x0d || ch == 0x09) || ch == 0x0a) {
					Texts_SetOffset(&TextPFrames_W, Texts_Writer__typ, voff);
				} else {
					Texts_SetOffset(&TextPFrames_W, Texts_Writer__typ, TextPFrames_R.voff);
				}
			} else {
				Texts_SetFont(&TextPFrames_W, Texts_Writer__typ, fnt);
				Texts_SetColor(&TextPFrames_W, Texts_Writer__typ, col);
				Texts_SetOffset(&TextPFrames_W, Texts_Writer__typ, voff);
			}
			if (ch == 0x0a) {
				buf[0] = 0x0d;
				i = 1;
				org = F->CarLoc.org;
				TextPFrames_BegOfLine(F->text, &org, 0);
				Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, org);
				do {
					Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch);
				} while (!(TextPFrames_R.elem == NIL || !__ISP(TextPFrames_R.elem, TextFrames_ParcDesc, 2)));
				while (((Texts_Pos(&TextPFrames_R, Texts_Reader__typ) <= pos && ch <= ' ') && ch != 0x1c) && i < 31) {
					buf[__X(i, 32)] = ch;
					i += 1;
					Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch);
				}
			} else {
				buf[0] = ch;
				i = 1;
			}
			while (((Input_Available() > 0 && i < 31) && ch >= ' ') && ch < 0x7f) {
				Input_Read(&buf[__X(i, 32)]);
				i += 1;
			}
			buf[__X(i, 32)] = 0x00;
			InsertBuffer__77();
		}
		if (pos < F->org) {
			TextPFrames_Show(F, F->org - 1);
		} else if (pos < F->text->len) {
			org = -1;
			while (pos >= F->trailer->org && F->org != org) {
				TextPFrames_Show(F, F->trailer->next->next->org);
				Flush__75();
				org = F->org;
			}
		} else {
			TextPFrames_LocatePos(F, pos, &loc, TextPFrames_Location__typ);
			TextPFrames_LocateChar(F, loc.x + 1, loc.y, &loc, TextPFrames_Location__typ);
			if (pos != loc.pos) {
				TextPFrames_Show(F, F->trailer->next->next->org);
				Flush__75();
			}
		}
		TextPFrames_SetCaret(F, pos);
	} else if (F->focus != NIL) {
		input.id = 0;
		input.ch = ch;
		input.fnt = fnt;
		input.col = col;
		input.voff = voff;
		(*F->focus->handle)(F->focus, (void*)&input, Oberon_InputMsg__typ);
	} else if (F->hasSel) {
		if (ch == 0xc4) {
			TextPFrames_ShiftBlock(F, -1);
			Flush__75();
		} else if (ch == 0xc3) {
			TextPFrames_ShiftBlock(F, 1);
			Flush__75();
		}
	}
	Write__74_s = _s.lnk;
}

void TextPFrames_TouchElem (TextPFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum)
{
	TextPFrames_Location loc = {0};
	Texts_Elem e = NIL;
	LONGINT pbeg = 0;
	INTEGER y0 = 0;
	TextFrames_TrackMsg track = {0};
	TextPFrames_LocateChar(F, *x, *y, &loc, TextPFrames_Location__typ);
	e = TextPFrames_R.elem;
	if (e != NIL && (LONGINT)loc.x + __DIV(e->W, (LONGINT)TextPFrames_unit) <= (LONGINT)((F->X + F->W) - F->right)) {
		TextFrames_ParcBefore(F->text, loc.pos, &TextPFrames_P, &pbeg);
		y0 = ((loc.y + loc.line->dsr) - (int)__DIV(TextPFrames_P->dsr, (LONGINT)TextPFrames_unit)) + loc.dy;
		if ((loc.x <= *x && (LONGINT)*x < (LONGINT)loc.x + __DIV(e->W, (LONGINT)TextPFrames_unit)) && !loc.trunc) {
			track.X = *x;
			track.Y = *y;
			track.keys = *keysum;
			track.fnt = TextPFrames_R.fnt;
			track.col = TextPFrames_R.col;
			track.pos = Texts_Pos(&TextPFrames_R, Texts_Reader__typ) - 1;
			track.frame = (Display_Frame)F;
			track.X0 = loc.x;
			track.Y0 = y0;
			(*e->handle)(e, (void*)&track, TextFrames_TrackMsg__typ);
			Input_Mouse(&*keysum, &*x, &*y);
		}
	}
}

void TextPFrames_Edit (TextPFrames_Frame F, INTEGER x, INTEGER y, SET keysum)
{
	Display_Frame ef = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0, pos = 0;
	SET keys = 0;
	CHAR ch = 0;
	Oberon_CopyOverMsg copyover = {0};
	Oberon_InputMsg input = {0};
	if (x < F->X + F->barW) {
		if (__IN(2, keysum)) {
			TextPFrames_TrackLine(F, &x, &y, &pos, &keysum);
		} else if (__IN(1, keysum)) {
			do {
				TextPFrames_TrackMouse(&x, &y, &keys, &keysum);
			} while (!(keys == 0x0));
			if (keysum == 0x06) {
				pos = F->text->len;
				TextPFrames_BegOfLine(F->text, &pos, 1);
			} else if (keysum == 0x03) {
				pos = 0;
			} else if (F->Y <= y && y <= F->Y + F->H) {
				pos = TextPFrames_CoordToPos(F, y - F->Y);
				TextPFrames_BegOfLine(F->text, &pos, 1);
			} else {
				pos = F->org;
			}
		} else if (__IN(0, keysum)) {
			do {
				TextPFrames_TrackMouse(&x, &y, &keys, &keysum);
			} while (!(keys == 0x0));
			pos = 0;
		} else {
			TextPFrames_DrawCursor(x, y);
		}
		if (keysum != 0x0 && keysum != 0x07) {
			TextPFrames_ShowFrom(F, pos);
		}
	} else {
		ef = TextPFrames_ThisSubFrame(F, x, y);
		if (ef != NIL) {
			if (F->focus != ef && keysum == 0x04) {
				do {
					TextPFrames_TrackMouse(&x, &y, &keys, &keysum);
				} while (!(keys == 0x0));
				if (keysum == 0x04) {
					TextPFrames_RemoveSelection(F);
					TextPFrames_RemoveCaret(F);
					TextPFrames_PassSubFocus(F, ef);
					return;
				}
			} else if (F->focus == ef) {
				input.id = 1;
				input.keys = keysum;
				input.X = x;
				input.Y = y;
				(*ef->handle)(ef, (void*)&input, Oberon_InputMsg__typ);
				return;
			}
		}
		if (keysum != 0x0) {
			TextPFrames_TouchElem(F, &x, &y, &keysum);
		}
		if (__IN(2, keysum)) {
			Oberon_PassFocus(Viewers_This(F->X, F->Y));
			TextPFrames_TrackCaret(F, &x, &y, &keysum);
			if (keysum == 0x06 && F->hasCar) {
				Oberon_GetSelection(&text, &beg, &end, &time);
				if (time >= 0) {
					Texts_Save(text, beg, end, TextPFrames_B);
					Texts_Insert(F->text, F->CarLoc.pos, TextPFrames_B);
					TextPFrames_SetCaret(F, F->CarLoc.pos + (end - beg));
				}
			} else if ((keysum == 0x05 && F->hasCar) && F->CarLoc.pos < F->text->len) {
				Oberon_GetSelection(&text, &beg, &end, &time);
				if (time >= 0) {
					Texts_OpenReader(&TextPFrames_R, Texts_Reader__typ, F->text, F->CarLoc.pos);
					Texts_Read(&TextPFrames_R, Texts_Reader__typ, &ch);
					Texts_ChangeLooks(text, beg, end, 0x07, TextPFrames_R.fnt, TextPFrames_R.col, TextPFrames_R.voff);
				}
			}
		} else if (__IN(1, keysum)) {
			TextPFrames_TrackWord(F, &x, &y, &pos, &keysum);
			if (keysum != 0x07) {
				TextPFrames_Call(F, pos, keysum == 0x06);
			}
		} else if (__IN(0, keysum)) {
			TextPFrames_TrackSelection(F, &x, &y, &keysum);
			if (keysum == 0x03) {
				copyover.text = F->text;
				copyover.beg = F->SelBeg.pos;
				copyover.end = F->SelEnd.pos;
				(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&copyover, Oberon_CopyOverMsg__typ);
			} else if (keysum == 0x05 && F->hasSel) {
				Oberon_PassFocus(Viewers_This(F->X, F->Y));
				Texts_Delete(F->text, F->SelBeg.pos, F->SelEnd.pos);
				TextPFrames_SetCaret(F, F->SelBeg.pos);
			}
		} else {
			TextPFrames_DrawCursor(x, y);
		}
	}
}

void TextPFrames_NotifyElems (TextPFrames_Frame F, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Display_Frame p = NIL, f = NIL;
	f = F->dsc;
	if (__IS(msg__typ, TextFrames_NotifyMsg, 1)) {
		__GUARDR(msg, TextFrames_NotifyMsg, 1).frame = (Display_Frame)F;
	}
	while (f != NIL) {
		p = f;
		f = f->next;
		(*p->handle)(p, &*msg, msg__typ);
	}
}

void TextPFrames_Copy (TextPFrames_Frame SF, TextPFrames_Frame DF)
{
	INTEGER i = 0;
	DF->handle = SF->handle;
	DF->text = SF->text;
	DF->org = SF->org;
	DF->left = SF->left;
	DF->right = SF->right;
	DF->top = SF->top;
	DF->bot = SF->bot;
	DF->barW = SF->barW;
	DF->hasCar = 0;
	DF->hasSel = 0;
	DF->trailer = NIL;
	DF->pages = SF->pages;
	DF->first = SF->first;
	DF->width = SF->width;
	i = SF->pages;
	while (i > 0) {
		i -= 1;
		DF->porg[__X(i, 1024)] = SF->porg[__X(i, 1024)];
	}
}

void TextPFrames_Open (TextPFrames_Frame F, Texts_Text T, LONGINT pos)
{
	TextFrames_Open((void*)F, T, pos);
	F->trailer = NIL;
	F->pages = 0;
}

void TextPFrames_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	TextPFrames_Frame F = NIL, F1 = NIL;
	F = __GUARDP(f, TextPFrames_FrameDesc, 2);
	if (__IS(msg__typ, Oberon_InputMsg, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				TextPFrames_Write(F, (*msg__).ch, (*msg__).fnt, (*msg__).col, (*msg__).voff);
			} else if ((*msg__).id == 1) {
				TextPFrames_Edit(F, (*msg__).X, (*msg__).Y, (*msg__).keys);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
		TextPFrames_NotifyElems(F, &*msg, msg__typ);
		if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
			Oberon_ControlMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				TextPFrames_RemoveCaret(F);
			} else if ((*msg__).id == 1) {
				TextPFrames_Neutralize(F);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
		__NEW(F1, TextPFrames_FrameDesc);
		TextPFrames_Copy(F, F1);
		__GUARDR(msg, Oberon_CopyMsg, 1).F = (Display_Frame)F1;
	} else if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
		TextPFrames_NotifyElems(F, &*msg, msg__typ);
		if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
			TextFrames_UpdateMsg *msg__ = (void*)msg;
			if ((*msg__).text == F->text) {
				TextPFrames_MarkMenu(F);
				TextPFrames_Neutralize(F);
				TextPFrames_Update(F, &*msg__, msg__typ);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
		TextPFrames_NotifyElems(F, &*msg, msg__typ);
		if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
			Oberon_SelectionMsg *msg__ = (void*)msg;
			if (F->hasSel && F->time > (*msg__).time) {
				(*msg__).text = F->text;
				(*msg__).beg = F->SelBeg.pos;
				(*msg__).end = F->SelEnd.pos;
				(*msg__).time = F->time;
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_CopyOverMsg, 1)) {
		TextPFrames_NotifyElems(F, &*msg, msg__typ);
		if (__IS(msg__typ, Oberon_CopyOverMsg, 1)) {
			Oberon_CopyOverMsg *msg__ = (void*)msg;
			if (F->hasCar) {
				Texts_Save((*msg__).text, (*msg__).beg, (*msg__).end, TextPFrames_B);
				Texts_Insert(F->text, F->CarLoc.pos, TextPFrames_B);
				TextPFrames_SetCaret(F, F->CarLoc.pos + ((*msg__).end - (*msg__).beg));
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
		if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
			MenuViewers_ModifyMsg *msg__ = (void*)msg;
			TextPFrames_Neutralize(F);
			TextPFrames_Resize(F, F->X, (*msg__).Y, F->W, (*msg__).H);
		} else __WITHCHK;
	} else if (__IS(msg__typ, TextPFrames_SelectMsg, 1)) {
		TextPFrames_NotifyElems(F, &*msg, msg__typ);
		if (__IS(msg__typ, TextPFrames_SelectMsg, 1)) {
			TextPFrames_SelectMsg *msg__ = (void*)msg;
			if ((*msg__).text == F->text && !F->hasSel) {
				Oberon_RemoveMarks(F->X, F->Y, F->W, F->H);
				TextPFrames_Neutralize(F);
				TextPFrames_SetSelection(F, (*msg__).beg, (*msg__).end);
				F->time = (*msg__).time;
				if (F->hasSel) {
					F->SelBeg.pos = (*msg__).beg;
					F->SelEnd.pos = (*msg__).end;
				}
			}
		} else __WITHCHK;
	} else {
		TextPFrames_NotifyElems(F, &*msg, msg__typ);
	}
}

TextPFrames_Frame TextPFrames_NewText (Texts_Text T, LONGINT pos)
{
	TextPFrames_Frame frame = NIL;
	__NEW(frame, TextPFrames_FrameDesc);
	TextFrames_Open((void*)frame, T, pos);
	frame->handle = TextPFrames_Handle;
	return frame;
}

static void EnumPtrs(void (*P)(void*))
{
	P(TextPFrames_pfnt);
	__ENUMR(&TextPFrames_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&TextPFrames_WL, Texts_Writer__typ, 36, 1, P);
	P(TextPFrames_PB);
	P(TextPFrames_B);
	P(TextPFrames_P);
	__ENUMR(&TextPFrames_R, Texts_Reader__typ, 48, 1, P);
}

__TDESC(TextPFrames_Location, 1, 1) = {__TDFLDS("Location", 24), {16, -8}};
__TDESC(TextPFrames_TextLineDesc, 1, 2) = {__TDFLDS("TextLineDesc", 44), {0, 36, -12}};
__TDESC(TextPFrames_FrameDesc, 1, 12) = {__TDFLDS("FrameDesc", 4300), {0, 4, 20, 68, 88, 108, 112, 116, 136, 160, 184, 192, -52}};
__TDESC(TextPFrames_SelectMsg, 1, 1) = {__TDFLDS("SelectMsg", 16), {0, -8}};

export void *TextPFrames__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(TextPFrames, EnumPtrs);
	__INITYP(TextPFrames_Location, TextPFrames_Location, 0);
	__INITYP(TextPFrames_TextLineDesc, TextPFrames_TextLineDesc, 0);
	__INITYP(TextPFrames_FrameDesc, TextFrames_FrameDesc, 2);
	__INITYP(TextPFrames_SelectMsg, Display_FrameMsg, 1);
/* BEGIN */
	TextPFrames_unit = TextFrames_Unit;
	Texts_OpenWriter(&TextPFrames_W, Texts_Writer__typ);
	Texts_OpenWriter(&TextPFrames_WL, Texts_Writer__typ);
	__NEW(TextPFrames_PB, Texts_BufDesc);
	Texts_OpenBuf(TextPFrames_PB);
	__NEW(TextPFrames_B, Texts_BufDesc);
	Texts_OpenBuf(TextPFrames_B);
	TextPFrames_pfnt = Fonts_This((CHAR*)"Syntax8.Scn.Fnt", (LONGINT)16);
	TextPrinter_InitFonts();
	__ENDMOD;
}
