/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"


static Texts_Writer TextPreview_W;


static void TextPreview_Ch (CHAR ch);
static void TextPreview_CountPages (Texts_Text text, INTEGER pno, INTEGER first, INTEGER last, INTEGER bx, INTEGER by, INTEGER bw, INTEGER bh, INTEGER *pages);
static void TextPreview_GetMainArg (Texts_Scanner *S, LONGINT *S__typ, Texts_Text text, LONGINT org, LONGINT *beg, LONGINT *end);
static void TextPreview_Int (LONGINT n);
static void TextPreview_Ln (void);
static void TextPreview_LocatePageBreaks (Texts_Text text, INTEGER pno, INTEGER first, INTEGER last, INTEGER bx, INTEGER by, INTEGER bw, INTEGER bh, INTEGER *pages, LONGINT *porg, LONGINT porg__len);
static void TextPreview_OpenDmyPrinter (void);
export void TextPreview_PageCount (void);
export void TextPreview_Paginate (void);
static void TextPreview_ScanArgs (Texts_Scanner *S, LONGINT *S__typ, INTEGER *pno, INTEGER *first, INTEGER *last, INTEGER *bx, INTEGER *by, INTEGER *bw, INTEGER *bh);
static void TextPreview_Str (CHAR *s, LONGINT s__len);
export void TextPreview_Synch (void);
export void TextPreview_This (void);


static void TextPreview_Ch (CHAR ch)
{
	Texts_Write(&TextPreview_W, Texts_Writer__typ, ch);
	Texts_Append(Oberon_Log, TextPreview_W.buf);
}

static void TextPreview_Str (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&TextPreview_W, Texts_Writer__typ, s, s__len);
	Texts_Append(Oberon_Log, TextPreview_W.buf);
	__DEL(s);
}

static void TextPreview_Int (LONGINT n)
{
	Texts_Write(&TextPreview_W, Texts_Writer__typ, ' ');
	Texts_WriteInt(&TextPreview_W, Texts_Writer__typ, n, 0);
	Texts_Append(Oberon_Log, TextPreview_W.buf);
}

static void TextPreview_Ln (void)
{
	Texts_WriteLn(&TextPreview_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, TextPreview_W.buf);
}

static void TextPreview_GetMainArg (Texts_Scanner *S, LONGINT *S__typ, Texts_Text text, LONGINT org, LONGINT *beg, LONGINT *end)
{
	LONGINT time = 0;
	Texts_OpenScanner(&*S, S__typ, text, org);
	Texts_Scan(&*S, S__typ);
	*beg = org;
	*end = text->len;
	if ((*S).class == 6 && (*S).c == '^') {
		Oberon_GetSelection(&text, &*beg, &*end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, text, *beg);
			Texts_Scan(&*S, S__typ);
		} else {
			*end = 0;
		}
	}
	if ((*S).line != 0) {
		(*S).class = 0;
	}
}

static void TextPreview_ScanArgs (Texts_Scanner *S, LONGINT *S__typ, INTEGER *pno, INTEGER *first, INTEGER *last, INTEGER *bx, INTEGER *by, INTEGER *bw, INTEGER *bh)
{
	INTEGER i = 0, k = 0;
	CHAR ch = 0;
	*bx = 236;
	*by = 236;
	*bw = 1948;
	*bh = (int)__DIV((LONGINT)Printer_PageHeight * 3048 - 1332000, 3048);
	*pno = 0;
	*first = 0;
	*last = 10000;
	while ((*S).class == 6 && (*S).c == '\\') {
		Texts_Scan(&*S, S__typ);
		if ((*S).class == 1) {
			ch = __CAP((*S).s[0]);
			Texts_Scan(&*S, S__typ);
			if (ch == 'A') {
			} else if (((ch == 'C' && (*S).class == 3) && 1 <= (*S).i) && (*S).i < 10) {
				Texts_Scan(&*S, S__typ);
			} else if (ch == 'F' && (*S).class == 1) {
				Texts_Scan(&*S, S__typ);
			} else if (ch == 'H') {
				if ((*S).class == 1 || (*S).class == 2) {
					Texts_Scan(&*S, S__typ);
				}
			} else if (ch == 'M') {
				if ((*S).class == 1) {
					ch = __CAP((*S).s[0]);
					Texts_Scan(&*S, S__typ);
					i = 0;
					while ((*S).class == 3 && 0 <= (*S).i) {
						k = (int)__DIV((*S).i * 3600, 3048);
						i += 1;
						Texts_Scan(&*S, S__typ);
						if (ch == 'H') {
						} else if (ch == 'B') {
							if (i == 1) {
								*bx = k;
							} else if (i == 2) {
								*by = k;
							} else if (i == 3) {
								*bw = k;
							} else if (i == 4) {
								*bh = k;
							}
						}
					}
				}
			} else if (ch == 'P') {
				if ((*S).class == 3) {
					*pno = (int)(*S).i;
					*first = *pno;
					Texts_Scan(&*S, S__typ);
				} else if ((*S).class == 1) {
					ch = __CAP((*S).s[0]);
					Texts_Scan(&*S, S__typ);
				}
			} else if (ch == 'S' && (*S).class == 3) {
				*first = (int)(*S).i;
				Texts_Scan(&*S, S__typ);
				if ((*S).class == 3) {
					*last = (int)(*S).i;
					Texts_Scan(&*S, S__typ);
				} else {
					*last = *first;
				}
			}
		}
	}
}

static void TextPreview_OpenDmyPrinter (void)
{
	CHAR name[32];
	__MOVE("Out.Prt", name, 8);
	Printer_Open((void*)name, 32, (void*)Oberon_User, 12, Oberon_Password);
	if (Printer_res != 0) {
		__HALT(99);
	}
}

static void TextPreview_LocatePageBreaks (Texts_Text text, INTEGER pno, INTEGER first, INTEGER last, INTEGER bx, INTEGER by, INTEGER bw, INTEGER bh, INTEGER *pages, LONGINT *porg, LONGINT porg__len)
{
	LONGINT org = 0;
	org = 0;
	*pages = 0;
	while (org < text->len && Printer_res == 0) {
		if ((LONGINT)*pages < porg__len) {
			porg[__X(*pages, porg__len)] = org;
		}
		if (first <= pno && pno <= last) {
			*pages += 1;
		}
		TextPrinter_PlaceBody(bx, by, bw, bh, text, &org, pno, 0);
		TextPreview_Ch('.');
		pno += 1;
	}
}

static void TextPreview_CountPages (Texts_Text text, INTEGER pno, INTEGER first, INTEGER last, INTEGER bx, INTEGER by, INTEGER bw, INTEGER bh, INTEGER *pages)
{
	LONGINT porg[1000];
	TextPreview_LocatePageBreaks(text, pno, first, last, bx, by, bw, bh, &*pages, (void*)porg, 1000);
}

void TextPreview_Synch (void)
{
	Viewers_Viewer V = NIL;
	TextPFrames_Frame F = NIL;
	F = __GUARDP(Oberon_Par->vwr->dsc->next, TextPFrames_FrameDesc, 2);
	V = Oberon_MarkedViewer();
	if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		if (__ISP(V->dsc->next, TextPFrames_FrameDesc, 2)) {
			TextPFrames_Show(__GUARDP(V->dsc->next, TextPFrames_FrameDesc, 2), F->org);
		} else if (__ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
			TextFrames_Show(__GUARDP(V->dsc->next, TextFrames_FrameDesc, 1), F->org);
		} else {
			TextFrames_Show(__GUARDP(V->dsc->next, TextFrames_FrameDesc, 1), F->org);
		}
	}
}

void TextPreview_This (void)
{
	Texts_Scanner S = {0};
	Viewers_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	LONGINT beg = 0, end = 0;
	INTEGER x = 0, y = 0;
	TextPreview_GetMainArg(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos, &beg, &end);
	if (S.class == 6 && S.c == '*') {
		V = Oberon_MarkedViewer();
		if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
			if (__ISP(V->dsc, TextFrames_FrameDesc, 1)) {
				Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
				Texts_Scan(&S, Texts_Scanner__typ);
			} else {
				__MOVE("TextPreview.Text", S.s, 17);
			}
			F = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
			Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
			V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu(S.s, 256, (CHAR*)"System.Close  System.Copy  System.Grow  TextPreview.Synch  Edit.Store ", (LONGINT)71), (void*)TextPFrames_NewText(F->text, F->org), TextFrames_menuH, x, y);
		}
	}
}

void TextPreview_Paginate (void)
{
	Texts_Scanner S = {0};
	Viewers_Viewer V = NIL;
	TextPFrames_Frame F = NIL;
	LONGINT beg = 0, end = 0;
	INTEGER pages = 0, h = 0, pno = 0, first = 0, last = 0, bx = 0, by = 0, bw = 0, bh = 0;
	LONGINT porg[1000];
	TextPreview_GetMainArg(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos, &beg, &end);
	if (S.class == 6 && S.c == '*') {
		TextPreview_Str((CHAR*)"TextPreview.Paginate * ", (LONGINT)24);
		Texts_Scan(&S, Texts_Scanner__typ);
		V = Oberon_MarkedViewer();
		if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc->next, TextPFrames_FrameDesc, 2)) {
			TextPreview_ScanArgs(&S, Texts_Scanner__typ, &pno, &first, &last, &bx, &by, &bw, &bh);
			F = __GUARDP(V->dsc->next, TextPFrames_FrameDesc, 2);
			TextPreview_OpenDmyPrinter();
			TextPreview_LocatePageBreaks(F->text, pno, first, last, bx, by, bw, bh, &pages, (void*)porg, 1000);
			TextPFrames_SetPagination(F, pages, pno, bw, (void*)porg, 1000);
			TextPreview_Int(pages);
			h = F->H;
			TextPFrames_Resize(F, F->X, F->Y, F->W, 0);
			TextPFrames_Resize(F, F->X, F->Y, F->W, h);
		} else {
			TextPreview_Str((CHAR*)"failed (* not a preview)", (LONGINT)25);
		}
		TextPreview_Ln();
	}
}

void TextPreview_PageCount (void)
{
	Texts_Scanner S = {0};
	Viewers_Viewer V = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0;
	INTEGER pages = 0, total = 0, pno = 0, first = 0, last = 0, bx = 0, by = 0, bw = 0, bh = 0;
	TextPreview_Str((CHAR*)"TextPreview.PageCount", (LONGINT)22);
	TextPreview_Ln();
	TextPreview_GetMainArg(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos, &beg, &end);
	TextPreview_OpenDmyPrinter();
	if (S.class == 6 && S.c == '*') {
		Texts_Scan(&S, Texts_Scanner__typ);
		V = Oberon_MarkedViewer();
		if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
			TextPreview_ScanArgs(&S, Texts_Scanner__typ, &pno, &first, &last, &bx, &by, &bw, &bh);
			text = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text;
			if (__ISP(V->dsc, TextFrames_FrameDesc, 1)) {
				Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
				Texts_Scan(&S, Texts_Scanner__typ);
				if (S.class != 1) {
					S.s[0] = '*';
					S.s[1] = 0x00;
				}
			} else {
				S.s[0] = '*';
				S.s[1] = 0x00;
			}
			TextPreview_Str((CHAR*)"  ", (LONGINT)3);
			TextPreview_Str(S.s, 256);
			TextPreview_Str((CHAR*)" counting ", (LONGINT)11);
			TextPreview_CountPages(text, pno, first, last, bx, by, bw, bh, &pages);
			TextPreview_Int(pages);
			TextPreview_Ln();
		} else {
			TextPreview_Str((CHAR*)" failed (bad * marker)", (LONGINT)23);
			TextPreview_Ln();
		}
	} else if (S.class == 1) {
		text = TextFrames_Text(S.s, 256);
		TextPreview_Str((CHAR*)"  ", (LONGINT)3);
		TextPreview_Str(S.s, 256);
		TextPreview_Str((CHAR*)" counting ", (LONGINT)11);
		Texts_Scan(&S, Texts_Scanner__typ);
		TextPreview_ScanArgs(&S, Texts_Scanner__typ, &pno, &first, &last, &bx, &by, &bw, &bh);
		TextPreview_CountPages(text, pno, first, last, bx, by, bw, bh, &pages);
		TextPreview_Int(pages);
		TextPreview_Ln();
	} else {
		total = 0;
		TextPreview_ScanArgs(&S, Texts_Scanner__typ, &pno, &first, &last, &bx, &by, &bw, &bh);
		while (S.class == 1 && beg < end) {
			TextPreview_Str((CHAR*)"  ", (LONGINT)3);
			TextPreview_Str(S.s, 256);
			TextPreview_Str((CHAR*)" counting ", (LONGINT)11);
			text = TextFrames_Text(S.s, 256);
			beg = Texts_Pos((void*)&S, Texts_Scanner__typ);
			Texts_Scan(&S, Texts_Scanner__typ);
			TextPreview_CountPages(text, pno, first, last, bx, by, bw, bh, &pages);
			total += pages;
			TextPreview_Int(pages);
			TextPreview_Ln();
		}
		TextPreview_Str((CHAR*)"  total", (LONGINT)8);
		TextPreview_Int(total);
		TextPreview_Ln();
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&TextPreview_W, Texts_Writer__typ, 36, 1, P);
}


export void *TextPreview__init(void)
{
	__DEFMOD;
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(TextPreview, EnumPtrs);
	__REGCMD("PageCount", TextPreview_PageCount);
	__REGCMD("Paginate", TextPreview_Paginate);
	__REGCMD("Synch", TextPreview_Synch);
	__REGCMD("This", TextPreview_This);
/* BEGIN */
	Texts_OpenWriter(&TextPreview_W, Texts_Writer__typ);
	__ENDMOD;
}
