/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"

struct TextPrinter__1 {
	SHORTINT num;
	Fonts_Font dict[32];
	SHORTINT dx[32][256];
};

struct TextPrinter__2 {
	BOOLEAN first;
	SHORTINT fno;
	INTEGER px, x, y, len;
	CHAR buf[512];
};

typedef
	struct TextPrinter_PrintLine {
		BOOLEAN eot;
		LONGINT indent;
		INTEGER w, h, dsr, nob;
		LONGINT org, len, span, pbeg;
	} TextPrinter_PrintLine;

typedef
	struct TextPrinter_PrintMsg { /* Texts_ElemMsg */
		BOOLEAN prepare;
		LONGINT indent;
		Fonts_Font fnt;
		SHORTINT col;
		LONGINT pos;
		INTEGER X0, Y0, pno;
	} TextPrinter_PrintMsg;


static TextFrames_Parc TextPrinter_P;
static LONGINT TextPrinter_pbeg;
static Texts_Reader TextPrinter_R;
static CHAR TextPrinter_nextCh;
static CHAR TextPrinter_fname[32];
static INTEGER TextPrinter_unit;
static struct TextPrinter__1 TextPrinter_fonts;
static struct TextPrinter__2 TextPrinter_line;

export LONGINT *TextPrinter_PrintMsg__typ;
export LONGINT *TextPrinter_PrintLine__typ;
export LONGINT *TextPrinter__1__typ;
export LONGINT *TextPrinter__2__typ;

static void TextPrinter_AdjustMetrics (Texts_Text T, TextPrinter_PrintLine *t, LONGINT *t__typ, INTEGER left, INTEGER *pw, INTEGER *tw, INTEGER *ddx, INTEGER *cn);
static void TextPrinter_Append (CHAR *s1, LONGINT s1__len, INTEGER i, CHAR *s2, LONGINT s2__len);
static void TextPrinter_ClaimPrinter (void);
export LONGINT TextPrinter_DX (SHORTINT fno, CHAR ch);
static void TextPrinter_FlushLine (void);
export Fonts_Font TextPrinter_Font (SHORTINT fno);
export SHORTINT TextPrinter_FontNo (Fonts_Font fnt);
export void TextPrinter_Get (SHORTINT fno, CHAR ch, LONGINT *dx, LONGINT *x, LONGINT *y, LONGINT *w, LONGINT *h);
export void TextPrinter_GetChar (SHORTINT fno, LONGINT targetUnit, CHAR ch, LONGINT *pdx, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *pat);
static void TextPrinter_GetPrintChar (Fonts_Font fnt, CHAR ch, SHORTINT *fno, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
static void TextPrinter_GetSpecial (INTEGER *n, INTEGER maxW, INTEGER cn, INTEGER ddx, INTEGER dw, SHORTINT *fno, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
export void TextPrinter_InitFonts (void);
static INTEGER TextPrinter_Max (INTEGER x, INTEGER y);
static void TextPrinter_MeasureColumns (INTEGER pno, INTEGER py, INTEGER y0, INTEGER w0, Texts_Text T, LONGINT *pos, TextPrinter_PrintLine *t, LONGINT t__len, INTEGER *nl, INTEGER *nr, INTEGER *bh, BOOLEAN *eofPage);
static void TextPrinter_MeasureLine (Texts_Text T, INTEGER pno, INTEGER maxW, TextPrinter_PrintLine *t, LONGINT *t__typ);
static void TextPrinter_MeasureSpecial (INTEGER pno, INTEGER dw, SHORTINT *fno, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
static LONGINT TextPrinter_Min (LONGINT x, LONGINT y);
static INTEGER TextPrinter_Offset (void);
export void TextPrinter_PlaceBody (INTEGER bodyX, INTEGER bodyY, INTEGER bodyW, INTEGER bodyH, Texts_Text T, LONGINT *pos, INTEGER pno, BOOLEAN place);
static void TextPrinter_PlaceChar (CHAR ch, SHORTINT fno, INTEGER x, INTEGER y, INTEGER dx);
static void TextPrinter_PlaceColumns (Texts_Text T, TextPrinter_PrintLine *t, LONGINT t__len, INTEGER pno, INTEGER px, INTEGER py, INTEGER w0, INTEGER nl, INTEGER nr);
export void TextPrinter_PlaceHeader (INTEGER headerX, INTEGER headerY, INTEGER headerW, INTEGER pno, Fonts_Font fnt, CHAR *header, LONGINT header__len, BOOLEAN alt);
static void TextPrinter_PlaceLine (Texts_Text T, INTEGER pno, TextPrinter_PrintLine *t, LONGINT *t__typ, INTEGER left, INTEGER width, INTEGER py);
static void TextPrinter_PlaceSpecial (SHORTINT fno, INTEGER pno, INTEGER nob, INTEGER px, INTEGER py, INTEGER x, INTEGER y, INTEGER dx);
export void TextPrinter_PrintDraft (Texts_Text t, CHAR *header, LONGINT header__len, INTEGER copies);
static void TextPrinter_SetMetrics (SHORTINT fno, Fonts_Font fnt);
static void TextPrinter_Tab (INTEGER dw, INTEGER *dx);
static INTEGER TextPrinter_Width (SHORTINT fno, CHAR *s, LONGINT s__len);


static LONGINT TextPrinter_Min (LONGINT x, LONGINT y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER TextPrinter_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void TextPrinter_Append (CHAR *s1, LONGINT s1__len, INTEGER i, CHAR *s2, LONGINT s2__len)
{
	INTEGER j = 0;
	__DUP(s2, s2__len, CHAR);
	j = 0;
	while (s2[__X(j, s2__len)] != 0x00) {
		s1[__X(i, s1__len)] = s2[__X(j, s2__len)];
		i += 1;
		j += 1;
	}
	s1[__X(i, s1__len)] = 0x00;
	__DEL(s2);
}

static void TextPrinter_SetMetrics (SHORTINT fno, Fonts_Font fnt)
{
	Files_File f = NIL;
	Files_Rider r = {0};
	LONGINT pat = 0;
	INTEGER off = 0, i = 0, j = 0, k = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	SHORTINT size = 0, s = 0;
	CHAR mod = 0, m = 0;
	CHAR name[32];
	__COPY(fnt->name, name, 32);
	i = 0;
	while (name[__X(i, 32)] > '9') {
		i += 1;
	}
	j = i;
	while ('0' <= name[__X(j, 32)] && name[__X(j, 32)] < '9') {
		j += 1;
	}
	k = j;
	while (name[__X(k, 32)] != '.' && name[__X(k, 32)] != 0x00) {
		k += 1;
	}
	if (k > j) {
		mod = name[__X(k - 1, 32)];
	} else {
		mod = ' ';
	}
	size = 0;
	k = i;
	while (i < j) {
		size = 10 * size + (int)((int)name[__X(i, 32)] - 48);
		i += 1;
	}
	TextPrinter_Append((void*)name, 32, k, (CHAR*)".Lm3.Fnt", (LONGINT)9);
	f = Files_Old(name, 32);
	if (f != NIL) {
		Files_Set(&r, Files_Rider__typ, f, 2);
		Files_ReadInt(&r, Files_Rider__typ, &off);
		Files_Set(&r, Files_Rider__typ, f, 6);
		i = -1;
		do {
			i += 1;
			Files_Read(&r, Files_Rider__typ, (void*)&s);
			Files_Read(&r, Files_Rider__typ, (void*)&m);
		} while (!(s == size && m == mod || Files_Pos(&r, Files_Rider__typ) >= (LONGINT)off));
		if (s == size && m == mod) {
			Files_Set(&r, Files_Rider__typ, f, (off + i * 260) + 4);
			Files_ReadBytes(&r, Files_Rider__typ, (void*)TextPrinter_fonts.dx[__X(fno, 32)], 256, 256);
		} else {
			f = NIL;
		}
	}
	if (f == NIL) {
		i = 0;
		while (i < 256) {
			Display_GetChar(fnt->raster, (CHAR)i, &dx, &x, &y, &w, &h, &pat);
			TextPrinter_fonts.dx[__X(fno, 32)][__X(i, 256)] = (int)__DIV(__DIV(((LONGINT)dx * (LONGINT)TextPrinter_unit) * 12, 10), 3048);
			i += 1;
		}
	}
}

SHORTINT TextPrinter_FontNo (Fonts_Font fnt)
{
	SHORTINT fno = 0;
	fno = 0;
	TextPrinter_fonts.dict[__X(TextPrinter_fonts.num, 32)] = fnt;
	while (TextPrinter_fonts.dict[__X(fno, 32)] != fnt) {
		fno += 1;
	}
	if (fno == TextPrinter_fonts.num) {
		TextPrinter_SetMetrics(fno, fnt);
		TextPrinter_fonts.num += 1;
	}
	return fno;
}

Fonts_Font TextPrinter_Font (SHORTINT fno)
{
	return TextPrinter_fonts.dict[__X(fno, 32)];
}

LONGINT TextPrinter_DX (SHORTINT fno, CHAR ch)
{
	return (LONGINT)TextPrinter_fonts.dx[__X(fno, 32)][__X((int)ch, 256)] * 3048;
}

void TextPrinter_Get (SHORTINT fno, CHAR ch, LONGINT *dx, LONGINT *x, LONGINT *y, LONGINT *w, LONGINT *h)
{
	LONGINT pat = 0;
	INTEGER dx0 = 0, x0 = 0, y0 = 0, w0 = 0, h0 = 0;
	Display_GetChar(TextPrinter_fonts.dict[__X(fno, 32)]->raster, ch, &dx0, &x0, &y0, &w0, &h0, &pat);
	*x = (LONGINT)x0 * (LONGINT)TextPrinter_unit;
	*y = (LONGINT)y0 * (LONGINT)TextPrinter_unit;
	*h = (LONGINT)h0 * (LONGINT)TextPrinter_unit;
	*dx = (LONGINT)TextPrinter_fonts.dx[__X(fno, 32)][__X((int)ch, 256)] * 3048;
	*w = *dx;
}

void TextPrinter_GetChar (SHORTINT fno, LONGINT targetUnit, CHAR ch, LONGINT *pdx, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *pat)
{
	Display_GetChar(TextPrinter_fonts.dict[__X(fno, 32)]->raster, ch, &*dx, &*x, &*y, &*w, &*h, &*pat);
	*x = (int)__DIV((LONGINT)*x * (LONGINT)TextPrinter_unit, targetUnit);
	*y = (int)__DIV((LONGINT)*y * (LONGINT)TextPrinter_unit, targetUnit);
	*h = (int)__DIV((LONGINT)*h * (LONGINT)TextPrinter_unit, targetUnit);
	*pdx = (LONGINT)TextPrinter_fonts.dx[__X(fno, 32)][__X((int)ch, 256)] * 3048;
	*dx = (int)__DIV(*pdx, targetUnit);
	*w = *dx;
}

void TextPrinter_InitFonts (void)
{
	SHORTINT fno = 0;
	TextPrinter_fonts.num = 0;
	fno = TextPrinter_FontNo(Fonts_Default);
}

static INTEGER TextPrinter_Width (SHORTINT fno, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0, w = 0;
	i = 0;
	w = 0;
	while (s[__X(i, s__len)] != 0x00) {
		w += (int)TextPrinter_fonts.dx[__X(fno, 32)][__X((int)s[__X(i, s__len)], 256)];
		i += 1;
	}
	return w;
}

static void TextPrinter_GetPrintChar (Fonts_Font fnt, CHAR ch, SHORTINT *fno, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	LONGINT pat = 0;
	Display_GetChar(fnt->raster, ch, &*dx, &*x, &*y, &*w, &*h, &pat);
	*x = (int)__DIV((LONGINT)*x * (LONGINT)TextPrinter_unit, 3048);
	*y = -((int)__DIV((LONGINT)(-*y) * (LONGINT)TextPrinter_unit, 3048));
	*h = (int)__DIV((LONGINT)*h * (LONGINT)TextPrinter_unit, 3048);
	*fno = TextPrinter_FontNo(fnt);
	*dx = TextPrinter_fonts.dx[__X(*fno, 32)][__X((int)ch, 256)];
	*w = *dx;
}

static void TextPrinter_Tab (INTEGER dw, INTEGER *dx)
{
	INTEGER i = 0, n = 0;
	LONGINT w = 0;
	i = 0;
	n = TextPrinter_P->nofTabs;
	w = (LONGINT)dw * 3048 + 3600;
	if (dw < 0) {
		*dx = -dw;
	} else {
		while (i < n && TextPrinter_P->tab[__X(i, 32)] < w) {
			i += 1;
		}
		if (i < n) {
			*dx = (int)__DIV(TextPrinter_P->tab[__X(i, 32)] - (LONGINT)dw * 3048, 3048);
		} else {
			*dx = 47;
		}
	}
}

static INTEGER TextPrinter_Offset (void)
{
	if (TextPrinter_R.voff == 0) {
		return 0;
	} else {
		return (int)__DIV(__ASHR((LONGINT)(TextPrinter_R.fnt->height * (int)TextPrinter_R.voff) * (LONGINT)TextPrinter_unit, 6), 3048);
	}
	__RETCHK;
}

static void TextPrinter_MeasureSpecial (INTEGER pno, INTEGER dw, SHORTINT *fno, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	Texts_Elem e = NIL;
	INTEGER i = 0;
	TextPrinter_PrintMsg msg = {0};
	if (TextPrinter_nextCh == ' ') {
		TextPrinter_GetPrintChar(TextPrinter_R.fnt, TextPrinter_nextCh, &*fno, &*dx, &*x, &*y, &*w, &*h);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
	} else if (TextPrinter_nextCh == 0x09) {
		TextPrinter_Tab(dw, &*dx);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
	} else if (TextPrinter_R.elem != NIL) {
		e = TextPrinter_R.elem;
		msg.prepare = 1;
		msg.indent = (LONGINT)dw * 3048;
		msg.fnt = TextPrinter_R.fnt;
		msg.col = TextPrinter_R.col;
		msg.pos = Texts_Pos(&TextPrinter_R, Texts_Reader__typ) - 1;
		msg.pno = pno;
		msg.Y0 = -((int)__DIV(TextPrinter_P->dsr, 3048));
		(*e->handle)(e, (void*)&msg, TextPrinter_PrintMsg__typ);
		*w = (int)__DIV(e->W, 3048);
		*dx = *w;
		*h = (int)__DIV(e->H, 3048);
		*x = 0;
		*y = msg.Y0;
	} else {
		TextPrinter_GetPrintChar(TextPrinter_R.fnt, TextPrinter_nextCh, &*fno, &*dx, &*x, &*y, &*w, &*h);
	}
}

static void TextPrinter_GetSpecial (INTEGER *n, INTEGER maxW, INTEGER cn, INTEGER ddx, INTEGER dw, SHORTINT *fno, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	Texts_Elem e = NIL;
	if (TextPrinter_nextCh == ' ') {
		TextPrinter_GetPrintChar(TextPrinter_R.fnt, TextPrinter_nextCh, &*fno, &*dx, &*x, &*y, &*w, &*h);
		*x = 0;
		*y = 0;
		*dx += ddx;
		*n += 1;
		if (*n <= cn) {
			*dx += 1;
		}
		*w = *dx;
		*h = 0;
	} else if (TextPrinter_nextCh == 0x09) {
		TextPrinter_Tab(dw, &*dx);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
	} else if (TextPrinter_R.elem != NIL) {
		e = TextPrinter_R.elem;
		if (__ISP(e, TextFrames_ParcDesc, 2)) {
			*w = (int)TextPrinter_Min(__DIV(TextPrinter_P->width, 3048), maxW);
			e->W = (LONGINT)*w * 3048;
		} else {
			*w = (int)__DIV(e->W, 3048);
		}
		*dx = *w;
		*x = 0;
		*y = -((int)__DIV(TextPrinter_P->dsr, 3048));
		*h = (int)__DIV(e->H, 3048);
	} else {
		TextPrinter_GetPrintChar(TextPrinter_R.fnt, TextPrinter_nextCh, &*fno, &*dx, &*x, &*y, &*w, &*h);
	}
}

static void TextPrinter_AdjustMetrics (Texts_Text T, TextPrinter_PrintLine *t, LONGINT *t__typ, INTEGER left, INTEGER *pw, INTEGER *tw, INTEGER *ddx, INTEGER *cn)
{
	*pw = left;
	*tw = (*t).w;
	*ddx = 0;
	*cn = 0;
	TextFrames_ParcBefore(T, (*t).org, &TextPrinter_P, &TextPrinter_pbeg);
	if (TextPrinter_pbeg != (*t).org) {
		*pw += (int)__DIV(TextPrinter_P->left + (*t).indent, 3048);
		*tw -= (int)__DIV((*t).indent, 3048);
		if (__IN(1, TextPrinter_P->opts)) {
			if (__IN(2, TextPrinter_P->opts) && (*t).nob > 0) {
				*tw = (int)__DIV(TextPrinter_P->width - (*t).indent, 3048);
				*ddx = __DIV(*tw - (*t).w, (*t).nob);
				*cn = (int)__MOD(*tw - (*t).w, (*t).nob);
			}
		} else if (__IN(2, TextPrinter_P->opts)) {
			*pw += (int)__DIV(TextPrinter_P->width, 3048) - (*t).w;
		} else {
			*pw += __ASHR((int)__DIV(TextPrinter_P->width, 3048) - (*t).w, 1);
		}
	}
}

static void TextPrinter_MeasureLine (Texts_Text T, INTEGER pno, INTEGER maxW, TextPrinter_PrintLine *t, LONGINT *t__typ)
{
	LONGINT len = 0, bklen = 0, d = 0;
	BOOLEAN eol = 0;
	SHORTINT fno = 0;
	INTEGER nob = 0, bknob = 0, width = 0, minY = 0, bkminY = 0, maxY = 0, bkmaxY = 0, tw = 0, bktw = 0, lsp = 0, dsr = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_Reader R1 = {0};
	CHAR peekCh = 0;
	len = 0;
	nob = 0;
	bklen = -999;
	tw = 0;
	dx = 0;
	minY = 0;
	maxY = 0;
	TextFrames_ParcBefore(T, (*t).org, &TextPrinter_P, &TextPrinter_pbeg);
	lsp = (int)__DIV(TextPrinter_P->lsp, 3048);
	dsr = (int)__DIV(TextPrinter_P->dsr, 3048);
	width = (int)__DIV(TextPrinter_P->width, 3048);
	(*t).indent = 0;
	if ((*t).org > 0) {
		Texts_OpenReader(&R1, Texts_Reader__typ, T, (*t).org - 1);
		Texts_Read(&R1, Texts_Reader__typ, &peekCh);
		if (peekCh == 0x0d || R1.elem != NIL && __ISP(R1.elem, TextFrames_ParcDesc, 2)) {
			(*t).indent = TextPrinter_P->first;
		}
	}
	width -= (int)__DIV((*t).indent, 3048);
	for (;;) {
		tw += dx;
		if (TextPrinter_R.eot || TextPrinter_nextCh == 0x0d) {
			nob = 0;
			eol = !TextPrinter_R.eot;
			break;
		}
		if (TextPrinter_nextCh <= ' ') {
			TextPrinter_MeasureSpecial(pno, tw + (int)__DIV((*t).indent, 3048), &fno, &dx, &x, &y, &w, &h);
		} else {
			TextPrinter_GetPrintChar(TextPrinter_R.fnt, TextPrinter_nextCh, &fno, &dx, &x, &y, &w, &h);
		}
		if (tw + dx > width) {
			d = len - bklen;
			if ((0 <= d && d < 30) && TextPrinter_nextCh > ' ') {
				eol = 1;
				Texts_OpenReader(&TextPrinter_R, Texts_Reader__typ, T, Texts_Pos(&TextPrinter_R, Texts_Reader__typ) - d);
				nob = bknob;
				len = bklen;
				tw = bktw;
				minY = bkminY;
				maxY = bkmaxY;
			} else if (len == 0) {
				len += 1;
				y += TextPrinter_Offset();
				minY = (int)TextPrinter_Min(minY, y);
				maxY = TextPrinter_Max(maxY, y + h);
				Texts_Read(&TextPrinter_R, Texts_Reader__typ, &TextPrinter_nextCh);
				eol = 0;
			} else {
				eol = TextPrinter_nextCh <= ' ' && TextPrinter_nextCh != 0x1c;
			}
			break;
		}
		if (TextPrinter_nextCh <= ' ' && TextPrinter_nextCh != 0x1c) {
			bknob = nob;
			bklen = len;
			bktw = tw;
			bkminY = minY;
			bkmaxY = maxY;
			if (TextPrinter_nextCh == ' ') {
				nob += 1;
			}
		}
		len += 1;
		y += TextPrinter_Offset();
		minY = (int)TextPrinter_Min(minY, y);
		maxY = TextPrinter_Max(maxY, y + h);
		Texts_Read(&TextPrinter_R, Texts_Reader__typ, &TextPrinter_nextCh);
	}
	if (__IN(0, TextPrinter_P->opts)) {
		while (dsr < -minY) {
			dsr += lsp;
		}
		(*t).h = TextPrinter_Max(lsp, dsr + maxY);
		(*t).h += (int)__MOD(-(*t).h, lsp);
	} else {
		dsr = TextPrinter_Max(dsr, -minY);
		(*t).h = TextPrinter_Max(lsp, dsr + maxY);
	}
	(*t).len = len;
	(*t).w = (int)TextPrinter_Min(tw, maxW);
	(*t).dsr = dsr;
	(*t).nob = nob;
	(*t).eot = TextPrinter_R.eot;
	(*t).pbeg = TextPrinter_pbeg;
	if (eol) {
		Texts_Read(&TextPrinter_R, Texts_Reader__typ, &TextPrinter_nextCh);
		(*t).span = len + 1;
	} else {
		(*t).span = len;
	}
}

static void TextPrinter_FlushLine (void)
{
	if (TextPrinter_line.len > 0) {
		TextPrinter_line.buf[__X(TextPrinter_line.len, 512)] = 0x00;
		TextPrinter_line.len = 0;
		if (TextPrinter_line.first) {
			Printer_String(TextPrinter_line.px, TextPrinter_line.y, (void*)TextPrinter_line.buf, 512, (void*)TextPrinter_fonts.dict[__X(TextPrinter_line.fno, 32)]->name, 32);
			TextPrinter_line.first = 0;
		} else {
			Printer_ContString((void*)TextPrinter_line.buf, 512, (void*)TextPrinter_fonts.dict[__X(TextPrinter_line.fno, 32)]->name, 32);
		}
	}
}

static void TextPrinter_PlaceChar (CHAR ch, SHORTINT fno, INTEGER x, INTEGER y, INTEGER dx)
{
	if (TextPrinter_line.len > 0) {
		if (x != TextPrinter_line.x || y != TextPrinter_line.y) {
			TextPrinter_FlushLine();
			TextPrinter_line.first = 1;
			TextPrinter_line.px = x;
		} else if (fno != TextPrinter_line.fno) {
			TextPrinter_FlushLine();
		}
	} else {
		TextPrinter_line.px = x;
	}
	TextPrinter_line.fno = fno;
	TextPrinter_line.x = x + dx;
	TextPrinter_line.y = y;
	TextPrinter_line.buf[__X(TextPrinter_line.len, 512)] = ch;
	TextPrinter_line.len += 1;
}

static void TextPrinter_PlaceSpecial (SHORTINT fno, INTEGER pno, INTEGER nob, INTEGER px, INTEGER py, INTEGER x, INTEGER y, INTEGER dx)
{
	Texts_Elem e = NIL;
	TextPrinter_PrintMsg msg = {0};
	if ((TextPrinter_nextCh == ' ' && (TextPrinter_P->opts & 0x06) == 0x06) && nob > 0 || TextPrinter_nextCh == 0x09) {
	} else if (TextPrinter_R.elem != NIL) {
		e = TextPrinter_R.elem;
		TextPrinter_FlushLine();
		TextPrinter_line.first = 1;
		msg.prepare = 0;
		msg.fnt = TextPrinter_R.fnt;
		msg.col = TextPrinter_R.col;
		msg.pos = Texts_Pos(&TextPrinter_R, Texts_Reader__typ) - 1;
		msg.X0 = px + x;
		msg.Y0 = py + y;
		msg.pno = pno;
		(*e->handle)(e, (void*)&msg, TextPrinter_PrintMsg__typ);
	} else {
		TextPrinter_PlaceChar(TextPrinter_nextCh, fno, px, py, dx);
	}
}

static void TextPrinter_PlaceLine (Texts_Text T, INTEGER pno, TextPrinter_PrintLine *t, LONGINT *t__typ, INTEGER left, INTEGER width, INTEGER py)
{
	LONGINT i = 0;
	INTEGER n = 0, cn = 0, lm = 0, rm = 0, px = 0, pw = 0, tw = 0, ddx = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	SHORTINT fno = 0;
	Texts_OpenReader(&TextPrinter_R, Texts_Reader__typ, T, (*t).org);
	TextPrinter_AdjustMetrics(T, &*t, t__typ, left, &pw, &tw, &ddx, &cn);
	lm = left + (int)__DIV(TextPrinter_P->left, 3048);
	rm = left + width;
	px = pw;
	py += (*t).dsr;
	i = 0;
	n = 0;
	TextPrinter_line.first = 1;
	TextPrinter_line.len = 0;
	while (i < (*t).len) {
		Texts_Read(&TextPrinter_R, Texts_Reader__typ, &TextPrinter_nextCh);
		if (TextPrinter_nextCh <= ' ') {
			TextPrinter_GetSpecial(&n, width, cn, ddx, px - lm, &fno, &dx, &x, &y, &w, &h);
		} else {
			TextPrinter_GetPrintChar(TextPrinter_R.fnt, TextPrinter_nextCh, &fno, &dx, &x, &y, &w, &h);
		}
		if ((px + x) + w <= rm) {
			if (TextPrinter_nextCh <= ' ') {
				TextPrinter_PlaceSpecial(fno, pno, (*t).nob, px, py, x, y + TextPrinter_Offset(), dx);
			} else {
				TextPrinter_PlaceChar(TextPrinter_nextCh, fno, px, py + TextPrinter_Offset(), dx);
			}
			px += dx;
			i += 1;
		} else {
			i = (*t).len;
		}
	}
	TextPrinter_FlushLine();
}

void TextPrinter_PlaceHeader (INTEGER headerX, INTEGER headerY, INTEGER headerW, INTEGER pno, Fonts_Font fnt, CHAR *header, LONGINT header__len, BOOLEAN alt)
{
	INTEGER i = 0, j = 0;
	SHORTINT fno = 0;
	CHAR digits[16], pageno[16];
	alt = alt && !__ODD(pno);
	fno = TextPrinter_FontNo(fnt);
	if (pno >= 0 || pno < -30) {
		pno = __ABS(pno);
		i = 0;
		j = 0;
		do {
			digits[__X(i, 16)] = (CHAR)((int)__MOD(pno, 10) + 48);
			i += 1;
			pno = __DIV(pno, 10);
		} while (!(pno == 0));
		do {
			i -= 1;
			pageno[__X(j, 16)] = digits[__X(i, 16)];
			j += 1;
		} while (!(i == 0));
		pageno[__X(j, 16)] = 0x00;
	} else {
		pno = __ABS(pno);
		i = 0;
		while (pno >= 10) {
			pno -= 10;
			pageno[__X(i, 16)] = 'x';
			i += 1;
		}
		switch (pno) {
			case 0: 
				break;
			case 1: case 2: case 3: 
				while (pno > 0) {
					pno -= 1;
					pageno[__X(i, 16)] = 'i';
					i += 1;
				}
				break;
			case 4: 
				pageno[__X(i, 16)] = 'i';
				i += 1;
				pageno[__X(i, 16)] = 'v';
				i += 1;
				break;
			case 5: case 6: case 7: case 8: 
				pno -= 5;
				pageno[__X(i, 16)] = 'v';
				i += 1;
				while (pno > 0) {
					pno -= 1;
					pageno[__X(i, 16)] = 'i';
					i += 1;
				}
				break;
			case 9: 
				pageno[__X(i, 16)] = 'i';
				i += 1;
				pageno[__X(i, 16)] = 'x';
				i += 1;
				break;
			default: __CASECHK;
		}
		pageno[__X(i, 16)] = 0x00;
	}
	if (alt) {
		Printer_String(headerX, headerY, (void*)pageno, 16, (void*)TextPrinter_fonts.dict[__X(fno, 32)]->name, 32);
		if (header[0] != 0x00) {
			Printer_String((headerX + headerW) - TextPrinter_Width(fno, (void*)header, header__len), headerY, (void*)header, header__len, (void*)TextPrinter_fonts.dict[__X(fno, 32)]->name, 32);
		}
	} else {
		Printer_String((headerX + headerW) - TextPrinter_Width(fno, (void*)pageno, 16), headerY, (void*)pageno, 16, (void*)TextPrinter_fonts.dict[__X(fno, 32)]->name, 32);
		if (header[0] != 0x00) {
			Printer_String(headerX, headerY, (void*)header, header__len, (void*)TextPrinter_fonts.dict[__X(fno, 32)]->name, 32);
		}
	}
}

static void TextPrinter_ClaimPrinter (void)
{
}

static struct PrintDraft__27 {
	CHAR *header;
	LONGINT header__len;
	INTEGER *pno;
	CHAR (*s)[121];
	struct PrintDraft__27 *lnk;
} *PrintDraft__27_s;

static void PrintHeader__28 (void);

static void PrintHeader__28 (void)
{
	Printer_String(160, Printer_PageHeight - 125, (void*)PrintDraft__27_s->header, PrintDraft__27_s->header__len, (void*)Fonts_Default->name, 32);
	if (*PrintDraft__27_s->pno < 10) {
		(*PrintDraft__27_s->s)[0] = ' ';
	} else {
		(*PrintDraft__27_s->s)[0] = (CHAR)(48 + __DIV((int)__MOD(*PrintDraft__27_s->pno, 100), 10));
	}
	(*PrintDraft__27_s->s)[1] = (CHAR)(48 + (int)__MOD(*PrintDraft__27_s->pno, 10));
	(*PrintDraft__27_s->s)[2] = 0x00;
	Printer_String(Printer_PageWidth - 236, Printer_PageHeight - 125, (void*)*PrintDraft__27_s->s, 121, (void*)Fonts_Default->name, 32);
}

void TextPrinter_PrintDraft (Texts_Text t, CHAR *header, LONGINT header__len, INTEGER copies)
{
	INTEGER top = 0, y = 0, pno = 0, i = 0, b = 0;
	LONGINT org = 0;
	Texts_Reader r = {0};
	CHAR ch = 0;
	CHAR s[121];
	struct PrintDraft__27 _s;
	__DUP(header, header__len, CHAR);
	_s.header = (void*)header; _s.header__len = header__len;
	_s.pno = &pno;
	_s.s = (void*)s;
	_s.lnk = PrintDraft__27_s;
	PrintDraft__27_s = &_s;
	pno = 0;
	top = Printer_PageHeight - 225;
	y = top;
	Printer_UseListFont((void*)Fonts_Default->name, 32);
	PrintHeader__28();
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	do {
		org = Texts_Pos(&r, Texts_Reader__typ);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		i = 0;
		b = 0;
		while ((!r.eot && ch != 0x0d) && i < 120) {
			if (ch == ' ') {
				b = i;
			}
			s[__X(i, 121)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		if ((i == 120 && ch != 0x0d) && !r.eot) {
			if (b > 0) {
				i = b;
				org = (org + (LONGINT)i) + 1;
			} else {
				org = org + (LONGINT)i;
			}
			Texts_OpenReader(&r, Texts_Reader__typ, t, org);
		}
		s[__X(i, 121)] = 0x00;
		Printer_String(160, y, (void*)s, 121, (void*)Fonts_Default->name, 32);
		y = y - 32;
		if (y < 100) {
			Printer_Page(copies);
			pno += 1;
			PrintHeader__28();
			y = top;
		}
	} while (!r.eot);
	if (y < top) {
		Printer_Page(copies);
	}
	PrintDraft__27_s = _s.lnk;
	__DEL(header);
}

static struct MeasureColumns__14 {
	INTEGER *pno, *y0, *w0;
	Texts_Text *T;
	LONGINT *pos;
	TextPrinter_PrintLine *t;
	LONGINT t__len;
	BOOLEAN *eofPage;
	struct MeasureColumns__14 *lnk;
} *MeasureColumns__14_s;

static void MeasureColumn__15 (BOOLEAN *inCol, BOOLEAN *break_, BOOLEAN lastCol, INTEGER *py, INTEGER *n);

static void MeasureColumn__15 (BOOLEAN *inCol, BOOLEAN *break_, BOOLEAN lastCol, INTEGER *py, INTEGER *n)
{
	LONGINT org = 0;
	BOOLEAN eot = 0;
	for (;;) {
		org = *MeasureColumns__14_s->pos;
		Texts_OpenReader(&TextPrinter_R, Texts_Reader__typ, *MeasureColumns__14_s->T, org);
		Texts_Read(&TextPrinter_R, Texts_Reader__typ, &TextPrinter_nextCh);
		MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].org = org;
		TextPrinter_MeasureLine(*MeasureColumns__14_s->T, *MeasureColumns__14_s->pno, *MeasureColumns__14_s->w0, &MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)], TextPrinter_PrintLine__typ);
		eot = MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].eot;
		if (!__IN(4, TextPrinter_P->opts) || (LONGINT)*n == MeasureColumns__14_s->t__len) {
			break;
		}
		if (TextPrinter_pbeg == org) {
			if (*inCol && __IN(3, TextPrinter_P->opts)) {
				*break_ = 1;
				break;
			} else if (lastCol && *py - *MeasureColumns__14_s->y0 < (int)__DIV(3 * TextPrinter_P->lsp + TextPrinter_P->lead, 3048)) {
				MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].h = (int)__DIV(TextPrinter_P->lead, 3048);
				*MeasureColumns__14_s->pos += MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].span;
				*MeasureColumns__14_s->eofPage = 1;
				break;
			} else if (*inCol || __IN(3, TextPrinter_P->opts)) {
				*inCol = 1;
				MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].h = (int)__DIV(TextPrinter_P->lead, 3048);
				*py -= MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].h;
			}
			*MeasureColumns__14_s->pos += MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].span;
			*n += 1;
		} else if (*inCol || MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].len > 0) {
			*inCol = 1;
			if (*py - MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].h >= *MeasureColumns__14_s->y0) {
				*py -= MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].h;
				*MeasureColumns__14_s->pos += MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].span;
				*n += 1;
			} else {
				*MeasureColumns__14_s->eofPage = 1;
				break;
			}
		} else {
			*MeasureColumns__14_s->pos += MeasureColumns__14_s->t[__X(*n, MeasureColumns__14_s->t__len)].span;
		}
		TextPrinter_ClaimPrinter();
		if (eot) {
			break;
		}
	}
}

static void TextPrinter_MeasureColumns (INTEGER pno, INTEGER py, INTEGER y0, INTEGER w0, Texts_Text T, LONGINT *pos, TextPrinter_PrintLine *t, LONGINT t__len, INTEGER *nl, INTEGER *nr, INTEGER *bh, BOOLEAN *eofPage)
{
	INTEGER yl = 0, yr = 0, hl = 0, hr = 0, dh = 0;
	BOOLEAN inColumn = 0, break_ = 0;
	struct MeasureColumns__14 _s;
	_s.pno = &pno;
	_s.y0 = &y0;
	_s.w0 = &w0;
	_s.T = &T;
	_s.pos = pos;
	_s.t = (void*)t; _s.t__len = t__len;
	_s.eofPage = eofPage;
	_s.lnk = MeasureColumns__14_s;
	MeasureColumns__14_s = &_s;
	inColumn = 0;
	break_ = 0;
	dh = 0;
	yl = py;
	*nl = 0;
	MeasureColumn__15(&inColumn, &break_, 0, &yl, &*nl);
	hl = py - yl;
	yr = py;
	*nr = *nl;
	if (!break_) {
		MeasureColumn__15(&inColumn, &break_, 1, &yr, &*nr);
	}
	hr = py - yr;
	for (;;) {
		if (*nl == 0) {
			break;
		} else if (t[__X(*nl - 1, t__len)].len == 0) {
			*nl -= 1;
			dh = t[__X(*nl, t__len)].h;
		} else if (hl - t[__X(*nl - 1, t__len)].h > hr && yr - t[__X(*nl - 1, t__len)].h >= y0) {
			*nl -= 1;
			hl -= t[__X(*nl, t__len)].h;
			yl += t[__X(*nl, t__len)].h;
			hr += t[__X(*nl, t__len)].h + dh;
			yr -= t[__X(*nl, t__len)].h + dh;
			dh = 0;
		} else {
			break;
		}
	}
	*bh = TextPrinter_Max(hl, hr);
	MeasureColumns__14_s = _s.lnk;
}

static void TextPrinter_PlaceColumns (Texts_Text T, TextPrinter_PrintLine *t, LONGINT t__len, INTEGER pno, INTEGER px, INTEGER py, INTEGER w0, INTEGER nl, INTEGER nr)
{
	INTEGER i = 0, x = 0, y = 0, w = 0;
	i = 0;
	x = px;
	y = py;
	w = w0 + 59;
	while (i < nl) {
		y -= t[__X(i, t__len)].h;
		TextPrinter_PlaceLine(T, pno, &t[__X(i, t__len)], TextPrinter_PrintLine__typ, x, w, y);
		i += 1;
	}
	x = px + __ASHR(w0 + 82, 1);
	y = py;
	w = __ASHR(w0, 1) + 59;
	while (i < nr && (t[__X(i, t__len)].len == 0 || t[__X(i, t__len)].pbeg == t[__X(i, t__len)].org)) {
		i += 1;
	}
	while (i < nr) {
		y -= t[__X(i, t__len)].h;
		TextPrinter_PlaceLine(T, pno, &t[__X(i, t__len)], TextPrinter_PrintLine__typ, x, w, y);
		i += 1;
	}
}

void TextPrinter_PlaceBody (INTEGER bodyX, INTEGER bodyY, INTEGER bodyW, INTEGER bodyH, Texts_Text T, LONGINT *pos, INTEGER pno, BOOLEAN place)
{
	TextPrinter_PrintLine t = {0};
	LONGINT org = 0;
	INTEGER py = 0, bh = 0, nl = 0, nr = 0;
	BOOLEAN inPage = 0, eofPage = 0;
	TextPrinter_PrintLine bt[254];
	py = bodyY + bodyH;
	inPage = 0;
	for (;;) {
		org = *pos;
		Texts_OpenReader(&TextPrinter_R, Texts_Reader__typ, T, org);
		Texts_Read(&TextPrinter_R, Texts_Reader__typ, &TextPrinter_nextCh);
		t.org = org;
		TextPrinter_MeasureLine(T, pno, bodyW, &t, TextPrinter_PrintLine__typ);
		if (TextPrinter_pbeg == org) {
			if (inPage && __IN(3, TextPrinter_P->opts)) {
				break;
			} else if (py - bodyY < (int)__DIV(__ASHL(TextPrinter_P->lsp, 1) + TextPrinter_P->lead, 3048)) {
				*pos += t.span;
				break;
			} else if (inPage || __IN(3, TextPrinter_P->opts)) {
				py -= (int)__DIV(TextPrinter_P->lead, 3048);
				inPage = 1;
			}
			*pos += t.span;
		} else if (__IN(4, TextPrinter_P->opts)) {
			eofPage = 0;
			TextPrinter_MeasureColumns(pno, py, bodyY, bodyW, T, &*pos, (void*)bt, 254, &nl, &nr, &bh, &eofPage);
			if (nl == 0 || bh == 0) {
				break;
			}
			if (place) {
				TextPrinter_PlaceColumns(T, (void*)bt, 254, pno, bodyX, py, bodyW, nl, nr);
			}
			py -= bh;
			inPage = 1;
			if (eofPage) {
				break;
			}
		} else {
			inPage = inPage || t.len > 0;
			if (inPage) {
				py -= t.h;
			}
			if (py < bodyY) {
				if (t.h > bodyH) {
					*pos += t.span;
				}
				break;
			}
			if (place) {
				TextPrinter_PlaceLine(T, pno, &t, TextPrinter_PrintLine__typ, bodyX, bodyW + 59, py);
			} else {
				TextPrinter_ClaimPrinter();
			}
			*pos += t.span;
		}
		if (t.eot) {
			break;
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(TextPrinter_P);
	__ENUMR(&TextPrinter_R, Texts_Reader__typ, 48, 1, P);
	__ENUMR(&TextPrinter_fonts, TextPrinter__1__typ, 8324, 1, P);
}

__TDESC(TextPrinter_PrintMsg, 1, 1) = {__TDFLDS("PrintMsg", 28), {8, -8}};
__TDESC(TextPrinter_PrintLine, 1, 0) = {__TDFLDS("PrintLine", 32), {-4}};
__TDESC(TextPrinter__1, 1, 32) = {__TDFLDS("", 8324), {4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64, 
	68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120, 124, 128, 
	-132}};
__TDESC(TextPrinter__2, 1, 0) = {__TDFLDS("", 522), {-4}};

export void *TextPrinter__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__REGMOD(TextPrinter, EnumPtrs);
	__REGCMD("InitFonts", TextPrinter_InitFonts);
	__INITYP(TextPrinter_PrintMsg, Texts_ElemMsg, 1);
	__INITYP(TextPrinter_PrintLine, TextPrinter_PrintLine, 0);
	__INITYP(TextPrinter__1, TextPrinter__1, 0);
	__INITYP(TextPrinter__2, TextPrinter__2, 0);
/* BEGIN */
	TextPrinter_unit = TextFrames_Unit;
	__MOVE("Syntax10.Scn.Fnt", TextPrinter_fname, 17);
	__ENDMOD;
}
