/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "X11.h"

typedef
	struct Viewers_TrackDesc *Viewers_Track;

typedef
	struct Viewers_ViewerDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER state;
	} Viewers_ViewerDesc;

typedef
	struct Viewers_TrackDesc { /* Viewers_ViewerDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER state;
		Display_Frame under;
	} Viewers_TrackDesc;

typedef
	Viewers_ViewerDesc *Viewers_Viewer;

typedef
	struct Viewers_ViewerMsg { /* Display_FrameMsg */
		INTEGER id, X, Y, W, H, state;
	} Viewers_ViewerMsg;


export INTEGER Viewers_curW, Viewers_minH;
static INTEGER Viewers_DW, Viewers_DH;
static Viewers_Track Viewers_FillerTrack;
static Viewers_Viewer Viewers_FillerViewer, Viewers_buf;

export LONGINT *Viewers_ViewerDesc__typ;
export LONGINT *Viewers_ViewerMsg__typ;
export LONGINT *Viewers_TrackDesc__typ;

export void Viewers_Broadcast (Display_FrameMsg *M, LONGINT *M__typ);
export void Viewers_Change (Viewers_Viewer V, INTEGER Y);
export void Viewers_CheckUnload (Display_Handler handle);
export void Viewers_Close (Viewers_Viewer V);
export void Viewers_CloseTrack (INTEGER X);
static void Viewers_HandleUnloaded (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void Viewers_InitTrack (INTEGER W, INTEGER H, Viewers_Viewer Filler);
export void Viewers_Locate (INTEGER X, INTEGER H, Display_Frame *fil, Display_Frame *bot, Display_Frame *alt, Display_Frame *max);
export Viewers_Viewer Viewers_Next (Viewers_Viewer V);
export void Viewers_Open (Viewers_Viewer V, INTEGER X, INTEGER Y);
export void Viewers_OpenTrack (INTEGER X, INTEGER W, Viewers_Viewer Filler);
export void Viewers_Recall (Viewers_Viewer *V);
static void Viewers_RestoreTrack (Display_Frame S);
export Viewers_Viewer Viewers_This (INTEGER X, INTEGER Y);


void Viewers_Open (Viewers_Viewer V, INTEGER X, INTEGER Y)
{
	Display_Frame T = NIL, u = NIL, v = NIL;
	Viewers_ViewerMsg M = {0};
	if (V->state == 0 && X < 32767) {
		if (Y > Viewers_DH) {
			Y = Viewers_DH;
		}
		T = Viewers_FillerTrack->next;
		while (X >= T->X + T->W) {
			T = T->next;
		}
		u = T->dsc;
		v = u->next;
		while (Y > v->Y + v->H) {
			u = v;
			v = u->next;
		}
		if (Y < v->Y + Viewers_minH) {
			Y = v->Y + Viewers_minH;
		}
		if (v->next->Y != 0 && Y > (v->Y + v->H) - Viewers_minH) {
			if (__ISP(v, Viewers_ViewerDesc, 1)) {
				V->X = T->X;
				V->W = T->W;
				V->Y = (*(Viewers_Viewer*)&v)->Y;
				V->H = (*(Viewers_Viewer*)&v)->H;
				M.id = 2;
				M.state = 0;
				(*(*(Viewers_Viewer*)&v)->handle)((void*)(*(Viewers_Viewer*)&v), (void*)&M, Viewers_ViewerMsg__typ);
				(*(Viewers_Viewer*)&v)->state = 0;
				Viewers_buf = (*(Viewers_Viewer*)&v);
				V->next = (*(Viewers_Viewer*)&v)->next;
				u->next = (Display_Frame)V;
				V->state = 2;
			} else __WITHCHK;
		} else {
			V->X = T->X;
			V->W = T->W;
			V->Y = v->Y;
			V->H = Y - v->Y;
			M.id = 1;
			M.Y = Y;
			M.H = (v->Y + v->H) - Y;
			(*v->handle)(v, (void*)&M, Viewers_ViewerMsg__typ);
			v->Y = M.Y;
			v->H = M.H;
			V->next = v;
			u->next = (Display_Frame)V;
			V->state = 2;
		}
	}
}

void Viewers_Change (Viewers_Viewer V, INTEGER Y)
{
	Display_Frame v = NIL;
	Viewers_ViewerMsg M = {0};
	if (V->state > 1) {
		if (Y > Viewers_DH) {
			Y = Viewers_DH;
		}
		v = V->next;
		if (v->next->Y != 0 && Y > (v->Y + v->H) - Viewers_minH) {
			Y = (v->Y + v->H) - Viewers_minH;
		}
		if (Y >= V->Y + Viewers_minH) {
			M.id = 1;
			M.Y = Y;
			M.H = (v->Y + v->H) - Y;
			(*v->handle)(v, (void*)&M, Viewers_ViewerMsg__typ);
			v->Y = M.Y;
			v->H = M.H;
			V->H = Y - V->Y;
		}
	}
}

static void Viewers_RestoreTrack (Display_Frame S)
{
	Display_Frame T = NIL, t = NIL, v = NIL;
	Viewers_ViewerMsg M = {0};
	if (__ISP(S, Viewers_TrackDesc, 2)) {
		t = (*(Viewers_Track*)&S)->next;
		while (t->next->X != (*(Viewers_Track*)&S)->X) {
			t = t->next;
		}
		T = (*(Viewers_Track*)&S)->under;
		while (T->next != NIL) {
			T = T->next;
		}
		t->next = (*(Viewers_Track*)&S)->under;
		T->next = (*(Viewers_Track*)&S)->next;
		M.id = 0;
		do {
			t = t->next;
			v = t->dsc;
			do {
				v = v->next;
				(*v->handle)(v, (void*)&M, Viewers_ViewerMsg__typ);
				if (__ISP(v, Viewers_ViewerDesc, 1)) {
					(*(Viewers_Viewer*)&v)->state = -(*(Viewers_Viewer*)&v)->state;
				} else __WITHCHK;
			} while (!(v == t->dsc));
		} while (!(t == T));
	} else __WITHCHK;
}

void Viewers_Close (Viewers_Viewer V)
{
	Display_Frame T = NIL, U = NIL;
	Viewers_ViewerMsg M = {0};
	if (V->state > 1) {
		U = V->next;
		T = (Display_Frame)Viewers_FillerTrack;
		do {
			T = T->next;
		} while (!(V->X < T->X + T->W));
		if (__GUARDP(T, Viewers_TrackDesc, 2)->under == NIL || U->next != (void *) V) {
			M.id = 2;
			M.state = 0;
			(*V->handle)((void*)V, (void*)&M, Viewers_ViewerMsg__typ);
			V->state = 0;
			Viewers_buf = V;
			M.id = 1;
			M.Y = V->Y;
			M.H = V->H + U->H;
			(*U->handle)(U, (void*)&M, Viewers_ViewerMsg__typ);
			U->Y = M.Y;
			U->H = M.H;
			while (U->next != (void *) V) {
				U = U->next;
			}
			U->next = V->next;
		} else {
			M.id = 2;
			M.state = 0;
			(*V->handle)((void*)V, (void*)&M, Viewers_ViewerMsg__typ);
			V->state = 0;
			Viewers_buf = V;
			(*U->handle)(U, (void*)&M, Viewers_ViewerMsg__typ);
			__GUARDP(U, Viewers_ViewerDesc, 1)->state = 0;
			Viewers_RestoreTrack(T);
		}
	}
}

void Viewers_Recall (Viewers_Viewer *V)
{
	*V = Viewers_buf;
}

Viewers_Viewer Viewers_This (INTEGER X, INTEGER Y)
{
	Display_Frame T = NIL, V = NIL;
	if (X < 32767 && Y < Viewers_DH) {
		T = (Display_Frame)Viewers_FillerTrack;
		do {
			T = T->next;
		} while (!(X < T->X + T->W));
		V = T->dsc;
		do {
			V = V->next;
		} while (!(Y < V->Y + V->H));
		return __GUARDP(V, Viewers_ViewerDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

Viewers_Viewer Viewers_Next (Viewers_Viewer V)
{
	return __GUARDP(V->next, Viewers_ViewerDesc, 1);
}

void Viewers_Locate (INTEGER X, INTEGER H, Display_Frame *fil, Display_Frame *bot, Display_Frame *alt, Display_Frame *max)
{
	Display_Frame T = NIL, V = NIL;
	if (X < 32767) {
		T = (Display_Frame)Viewers_FillerTrack;
		do {
			T = T->next;
		} while (!(X < T->X + T->W));
		*fil = T->dsc;
		*bot = (*fil)->next;
		if ((*bot)->next != *fil) {
			*alt = (*bot)->next;
			V = (*alt)->next;
			while (V != *fil && (*alt)->H < H) {
				if (V->H > (*alt)->H) {
					*alt = V;
				}
				V = V->next;
			}
		} else {
			*alt = *bot;
		}
		*max = T->dsc;
		V = (*max)->next;
		while (V != *fil) {
			if (V->H > (*max)->H) {
				*max = V;
			}
			V = V->next;
		}
	}
}

void Viewers_InitTrack (INTEGER W, INTEGER H, Viewers_Viewer Filler)
{
	Display_Frame S = NIL;
	Viewers_Track T = NIL;
	if (Filler->state == 0) {
		Filler->X = Viewers_curW;
		Filler->W = W;
		Filler->Y = 0;
		Filler->H = H;
		Filler->state = 1;
		Filler->next = (Display_Frame)Filler;
		__NEW(T, Viewers_TrackDesc);
		T->X = Viewers_curW;
		T->W = W;
		T->Y = 0;
		T->H = H;
		T->dsc = (Display_Frame)Filler;
		T->under = NIL;
		Viewers_FillerViewer->X = Viewers_curW + W;
		Viewers_FillerViewer->W = 32767 - Viewers_FillerViewer->X;
		Viewers_FillerTrack->X = Viewers_FillerViewer->X;
		Viewers_FillerTrack->W = Viewers_FillerViewer->W;
		S = (Display_Frame)Viewers_FillerTrack;
		while (S->next != (void *) Viewers_FillerTrack) {
			S = S->next;
		}
		S->next = (Display_Frame)T;
		T->next = (Display_Frame)Viewers_FillerTrack;
		Viewers_curW = Viewers_curW + W;
	}
}

void Viewers_OpenTrack (INTEGER X, INTEGER W, Viewers_Viewer Filler)
{
	Viewers_Track newT = NIL;
	Display_Frame S = NIL, T = NIL, t = NIL, v = NIL;
	Viewers_ViewerMsg M = {0};
	if (X < 32767 && Filler->state == 0) {
		S = (Display_Frame)Viewers_FillerTrack;
		T = S->next;
		while (X >= T->X + T->W) {
			S = T;
			T = S->next;
		}
		while (X + W > T->X + T->W) {
			T = T->next;
		}
		M.id = 2;
		t = S;
		do {
			t = t->next;
			v = t->dsc;
			do {
				v = v->next;
				if (__ISP(v, Viewers_ViewerDesc, 1)) {
					M.state = -(*(Viewers_Viewer*)&v)->state;
					(*(*(Viewers_Viewer*)&v)->handle)((void*)(*(Viewers_Viewer*)&v), (void*)&M, Viewers_ViewerMsg__typ);
					(*(Viewers_Viewer*)&v)->state = M.state;
				} else __WITHCHK;
			} while (!(v == t->dsc));
		} while (!(t == T));
		Filler->X = S->next->X;
		Filler->W = (T->X + T->W) - S->next->X;
		Filler->Y = 0;
		Filler->H = Viewers_DH;
		Filler->state = 1;
		Filler->next = (Display_Frame)Filler;
		__NEW(newT, Viewers_TrackDesc);
		newT->X = Filler->X;
		newT->W = Filler->W;
		newT->Y = 0;
		newT->H = Viewers_DH;
		newT->dsc = (Display_Frame)Filler;
		newT->under = S->next;
		S->next = (Display_Frame)newT;
		newT->next = T->next;
		T->next = NIL;
	}
}

void Viewers_CloseTrack (INTEGER X)
{
	Display_Frame T = NIL, V = NIL;
	Viewers_ViewerMsg M = {0};
	if (X < 32767) {
		T = (Display_Frame)Viewers_FillerTrack;
		do {
			T = T->next;
		} while (!(X < T->X + T->W));
		if (__GUARDP(T, Viewers_TrackDesc, 2)->under != NIL) {
			M.id = 2;
			M.state = 0;
			V = T->dsc;
			do {
				V = V->next;
				(*V->handle)(V, (void*)&M, Viewers_ViewerMsg__typ);
				__GUARDP(V, Viewers_ViewerDesc, 1)->state = 0;
			} while (!(V == T->dsc));
			Viewers_RestoreTrack(T);
		}
	}
}

void Viewers_Broadcast (Display_FrameMsg *M, LONGINT *M__typ)
{
	Display_Frame T = NIL, V = NIL;
	T = Viewers_FillerTrack->next;
	while (T != (void *) Viewers_FillerTrack) {
		V = T->dsc;
		do {
			V = V->next;
			(*V->handle)(V, &*M, M__typ);
		} while (!(V == T->dsc));
		T = T->next;
	}
	X11_DoFlush();
}

static void Viewers_HandleUnloaded (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
}

static struct CheckUnload__3 {
	Display_Handler *handle;
	struct CheckUnload__3 *lnk;
} *CheckUnload__3_s;

static void Check__4 (Display_Frame F);

static void Check__4 (Display_Frame F)
{
	Display_Frame f = NIL;
	if (F->handle == *CheckUnload__3_s->handle) {
		F->handle = Viewers_HandleUnloaded;
	}
	F = F->dsc;
	f = F;
	if (f != NIL) {
		do {
			Check__4(f);
			f = f->next;
		} while (!(f == NIL || f == F));
	}
}

void Viewers_CheckUnload (Display_Handler handle)
{
	Display_Frame T = NIL;
	struct CheckUnload__3 _s;
	_s.handle = &handle;
	_s.lnk = CheckUnload__3_s;
	CheckUnload__3_s = &_s;
	T = Viewers_FillerTrack->next;
	while (T != (void *) Viewers_FillerTrack) {
		Check__4(T);
		T = T->next;
	}
	CheckUnload__3_s = _s.lnk;
}

static void EnumPtrs(void (*P)(void*))
{
	P(Viewers_FillerTrack);
	P(Viewers_FillerViewer);
	P(Viewers_buf);
}

__TDESC(Viewers_ViewerDesc, 1, 2) = {__TDFLDS("ViewerDesc", 24), {0, 4, -12}};
__TDESC(Viewers_ViewerMsg, 1, 0) = {__TDFLDS("ViewerMsg", 12), {-4}};
__TDESC(Viewers_TrackDesc, 1, 3) = {__TDFLDS("TrackDesc", 28), {0, 4, 24, -16}};

export void *Viewers__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(X11);
	__REGMOD(Viewers, EnumPtrs);
	__INITYP(Viewers_ViewerDesc, Display_FrameDesc, 1);
	__INITYP(Viewers_ViewerMsg, Display_FrameMsg, 1);
	__INITYP(Viewers_TrackDesc, Viewers_ViewerDesc, 2);
/* BEGIN */
	Viewers_buf = NIL;
	__NEW(Viewers_FillerViewer, Viewers_ViewerDesc);
	Viewers_FillerViewer->X = 0;
	Viewers_FillerViewer->W = 32767;
	Viewers_FillerViewer->Y = 0;
	Viewers_FillerViewer->H = Viewers_DH;
	Viewers_FillerViewer->next = (Display_Frame)Viewers_FillerViewer;
	__NEW(Viewers_FillerTrack, Viewers_TrackDesc);
	Viewers_FillerTrack->X = 0;
	Viewers_FillerTrack->W = 32767;
	Viewers_FillerTrack->Y = 0;
	Viewers_FillerTrack->H = Viewers_DH;
	Viewers_FillerTrack->dsc = (Display_Frame)Viewers_FillerViewer;
	Viewers_FillerTrack->next = (Display_Frame)Viewers_FillerTrack;
	Viewers_curW = 0;
	Viewers_minH = 1;
	Viewers_DW = Display_Width;
	Viewers_DH = Display_Height;
	__ENDMOD;
}
