/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Args.h"
#include "Console.h"
#include "Kernel.h"

struct X11__1 {
	INTEGER r, g, b;
};

typedef
	struct X11_PatternDesc {
		LONGINT x, y;
		INTEGER w, h;
		LONGINT pixmap;
	} X11_PatternDesc;

typedef
	struct X11_MetricDesc {
		INTEGER dx, x, y, filler;
		X11_PatternDesc p;
	} X11_MetricDesc;

typedef
	struct X11_Bytes {
		X11_MetricDesc metrics[256];
		LONGINT xid;
	} X11_Bytes;

typedef
	struct X11_Color {
		LONGINT pixel;
		INTEGER red, green, blue;
		CHAR flags, pad;
	} X11_Color;

typedef
	struct X11_ErrorEvent {
		LONGINT type, display, resourceid, serial;
		CHAR errorCode, requestCode, minorCode;
	} X11_ErrorEvent;

typedef
	X11_ErrorEvent *X11_ErrorEventPtr;

typedef
	LONGINT (*X11_ErrorHandler)(LONGINT, X11_ErrorEventPtr);

typedef
	struct X11_Event {
		LONGINT type, serial, sendEvent, display, window, root, subwindow, time, x, y, xRoot, yRoot, state, button, sameScreen, focus, state2;
		LONGINT pad[32];
	} X11_Event;

typedef
	X11_Bytes *X11_Font;

typedef
	LONGINT (*X11_IOErrorHandler)(LONGINT);

typedef
	struct X11_ImageDesc {
		LONGINT width, height, xoffset, format, data, byteOrder, bitmapUnit, bitmapBitOrder, bitmapPad, depth, bytesPerLine, bitsPerPixel, redmask, greenmask, bluemask, obdata, createImage, destroyImage, getPixel, putPixel, subImage, addPixel;
	} X11_ImageDesc;

typedef
	X11_ImageDesc *X11_ImagePtr;

typedef
	CHAR X11_Modlist[8][32];

typedef
	X11_PatternDesc *X11_PatternPtr;

typedef
	struct X11_Point {
		INTEGER x, y;
	} X11_Point;

typedef
	struct X11_Rectangle {
		INTEGER x, y, w, h;
	} X11_Rectangle;

typedef
	struct X11_SelectionEvent {
		LONGINT type, serial, sendEvent, display, requestor, selection, target, property, time;
	} X11_SelectionEvent;

typedef
	struct X11_SelectionRequestEvent {
		LONGINT type, serial, sendEvent, display, owner, requestor, selection, target, property, time;
	} X11_SelectionRequestEvent;

typedef
	struct X11_Visual {
		LONGINT extData, visualid, class, redMask, greenMask, blueMask, bitsPerRgb, mapEntries;
	} X11_Visual;

typedef
	struct X11_VisualInfo {
		LONGINT visual, visualID, screen, depth, class, redmask, greenmask, bluemask, colomapsize, bitsperrgb;
	} X11_VisualInfo;

typedef
	X11_Visual *X11_VisualPtr;


export CHAR X11_WinName[128], X11_IconName[128], X11_Copyright[128], X11_WinNameCopyright[128];
export LONGINT X11_display, X11_primary, X11_secondary, X11_root, X11_basePixel, X11_foreground, X11_background;
export INTEGER X11_backgroundCol, X11_foregroundCol;
export LONGINT X11_screen, X11_screenw, X11_screenh, X11_screenhmm, X11_cells, X11_planes, X11_visualptr, X11_defvisualptr, X11_cmap, X11_defcmap;
export INTEGER X11_Width, X11_Height, X11_Bottom, X11_UBottom, X11_ColLeft, X11_depth;
export LONGINT X11_pixelValues[256];
export LONGINT X11_function[3];
export LONGINT X11_planesMask;
export SHORTINT X11_colorClass;
export LONGINT X11_nofcol, X11_arrow, X11_noCursor;
export CHAR X11_ErrorText[80];
export BOOLEAN X11_ErrorFlag;
export LONGINT X11_lastEventTime, X11_ccp;
export X11_Font X11_ccf;
export CHAR X11_ccch;
export INTEGER X11_ccdx, X11_ccx, X11_ccy;
export CHAR X11_lcache[256];
export X11_Font X11_lcf;
export INTEGER X11_lcx0, X11_lcy0, X11_lcx, X11_lccol, X11_lcmode, X11_lclen;
export void (*X11_SendSelection)(X11_SelectionRequestEvent*, LONGINT *);
export void (*X11_ReceiveSelection)(X11_SelectionEvent*, LONGINT *);
export void (*X11_ClearSelection)(void);
static LONGINT X11_arrowSource, X11_arrowMask, X11_noCursorSource, X11_noCursorMask;
static struct X11__1 X11_RGB[257];
static LONGINT X11_Gc;
static INTEGER X11_lastcol, X11_lastmode;
static X11_Font X11_lastfont;

export LONGINT *X11_PatternDesc__typ;
export LONGINT *X11_MetricDesc__typ;
export LONGINT *X11_Bytes__typ;
export LONGINT *X11_Visual__typ;
export LONGINT *X11_VisualInfo__typ;
export LONGINT *X11_Color__typ;
export LONGINT *X11_Point__typ;
export LONGINT *X11_Rectangle__typ;
export LONGINT *X11_Event__typ;
export LONGINT *X11_SelectionEvent__typ;
export LONGINT *X11_SelectionRequestEvent__typ;
export LONGINT *X11_ImageDesc__typ;
export LONGINT *X11_ErrorEvent__typ;
export LONGINT *X11__1__typ;

static void X11_CreateColors (void);
static void X11_CreateGc (void);
static void X11_CreatePatterns (void);
export void X11_DoFlush (void);
export void X11_DoSync (void);
export void X11_FlushLCache (void);
export void X11_GetColor (INTEGER col, INTEGER *red, INTEGER *green, INTEGER *blue);
export void X11_InitColors (void);
static void X11_InitCursors (void);
static void X11_InitNames (void);
export LONGINT X11_MyErrorHandler (LONGINT display, X11_ErrorEventPtr err);
static LONGINT X11_MyIOErrorHandler (LONGINT display);
export LONGINT X11_NewPattern (SET *image, LONGINT image__len, LONGINT class, INTEGER width, INTEGER height);
static void X11_OpenDisp (void);
export LONGINT X11_RasterToPixmap (LONGINT base, LONGINT width, LONGINT height);
export void X11_Rebind (CHAR *keyString, LONGINT keyString__len, X11_Modlist modifierStrings, LONGINT nofmod, CHAR *to, LONGINT to__len, LONGINT nofchar);
export void X11_SetColor (INTEGER col, INTEGER red, INTEGER green, INTEGER blue);

#define X11_AddPixel(image, value)	XAddPixel(image, value)
#define X11_AllocColorCells(display, cmap, contig, planeMasks, nplanes, pixels, ncolors)	(long)XAllocColorCells(display, cmap, contig, planeMasks, nplanes, pixels, ncolors)
#define X11_Bell(display, percent)	XBell(display, percent)
#define X11_BlackPixel(display, screen)	(long)XBlackPixel(display, screen)
#define X11_ChangeProperty(display, window, property, type, format, mode, data, nelements)	XChangeProperty(display, window, property, type, format, mode, data, nelements)
#define X11_ClearWindow(display, window)	XClearWindow(display, window)
#define X11_ConvertSelection(display, selection, target, property, requestor, timestamp)	XConvertSelection(display, selection, target, property, requestor, timestamp)
#define X11_CopyArea(display, src, dest, gc, srcX, srcY, width, height, destX, destY)	XCopyArea(display, src, dest, gc, srcX, srcY, width, height, destX, destY)
#define X11_CopyColormapAndFree(display, cmap)	(long)XCopyColormapAndFree(display, cmap)
#define X11_CopyPlane(display, src, dest, gc, srcX, srcY, width, height, destX, destY, plane)	XCopyPlane(display, src, dest, gc, srcX, srcY, width, height, destX, destY, plane)
#define X11_CreateBitmapFromData(display, drawable, data, width, height)	(long)XCreateBitmapFromData(display, drawable, data, width, height)
#define X11_CreateColormap(display, window, vis, alloc)	(long)XCreateColormap(display, window, vis, alloc)
#define X11_CreateFontCursor(display, shape)	(long)XCreateFontCursor(display, shape)
#define X11_CreateGC(display, drawable, valueMask, values)	(long)XCreateGC(display, drawable, valueMask, values)
#define X11_CreateImage(display, visual, depth, format, offset, data, width, height, bitmapPad, bytesPerLine)	(long)XCreateImage(display, visual, depth, format, offset, data, width, height, bitmapPad, bytesPerLine)
#define X11_CreatePixmap(display, drawable, width, height, depth)	(long)XCreatePixmap(display,drawable, width, height, depth)
#define X11_CreatePixmapCursor(display, csource, cmask, cfore, cback, xhot, yhot)	(long)XCreatePixmapCursor(display, csource, cmask, cfore, cback, xhot, yhot)
#define X11_CreateSimpleWindow(display, parent, x, y, width, height, borderWidth, border, background)	(long)XCreateSimpleWindow(display, parent, x, y, width, height, borderWidth, border, background)
#define X11_DefaultColormap(display, screen)	(long)XDefaultColormap(display, screen)
#define X11_DefaultDepth(display, screen)	(long)XDefaultDepth(display, screen)
#define X11_DefaultRootWindow(display)	(long)XDefaultRootWindow(display)
#define X11_DefaultScreen(display)	(long)XDefaultScreen(display)
#define X11_DefaultVisual(display, screen)	(long)XDefaultVisual(display, screen)
#define X11_DefineCursor(display, window, curs)	XDefineCursor(display, window, curs)
#define X11_DeleteProperty(display, window, property)	XDeleteProperty(display, window, property)
#define X11_DestroyImage(image)	XDestroyImage(image)
#define X11_DisplayCells(display, screen)	(long)XDisplayCells(display, screen)
#define X11_DisplayHeight(display, screen)	(long)XDisplayHeight(display, screen)
#define X11_DisplayHeightMM(display, screen)	(long)XDisplayHeightMM(display, screen)
#define X11_DisplayPlanes(display, screen)	(long)XDisplayPlanes(display, screen)
#define X11_DisplayWidth(display, screen)	(long)XDisplayWidth(display, screen)
#define X11_DrawArc(display, window, gc, x, y, width, height, angle1, angle2)	XDrawArc(display, window, gc, x, y, width, height, angle1, angle2)
#define X11_DrawLine(display, window, gc, x1, y1, x2, y2)	XDrawLine(display, window, gc, x1, y1, x2, y2)
#define X11_DrawPoint(display, window, gc, x, y)	XDrawPoint(display, window, gc, x, y)
#define X11_DrawString(display, window, gc, x, y, width, height)	XDrawString(display, window, gc, x, y, width, height)
#define X11_EventsQueued(display, mode)	(long)XEventsQueued(display, mode)
#define X11_FetchBytes(display, nbytes)	(long)XFetchBytes(display, nbytes)
#define X11_FillArc(display, window, gc, x, y, width, height, angle1, angle2)	XFillArc(display, window, gc, x, y, width, height, angle1, angle2)
#define X11_FillPolygon(display, window, gc, points, npoints, shape, mode)	XFillPolygon(display, window, gc, points, npoints, shape, mode)
#define X11_FillRectangle(display, window, gc, x, y, width, height)	XFillRectangle(display, window, gc, x, y, width, height)
#define X11_Flush(display)	XFlush(display)
#define X11_Free(data)	XFree(data)
#define X11_FreeFontNames(list)	XFreeFontNames(list)
#define X11_FreePixmap(display, pixmap)	XFreePixmap(display, pixmap)
#define X11_Geometry(display, screen, user, user__len, default, default___len, bwidth, fw, fh, xpad, ypad, x, y, w, h)	(long)XGeometry(display, screen, user, default, bwidth, fw, fh, xpad, ypad, x, y, w, h)
#define X11_GetErrorText(display, code, buffer, length)	XGetErrorText(display, code, buffer, length)
#define X11_GetGeometry(display, drawable, root, x, y, width, height, orderWidth, Depth)	XGetGeometry(display, drawable, root, x, y, width, height, orderWidth, Depth)
#define X11_GetImage(display, drawable, x, y, width, height, planeMask, format)	(long)XGetImage(display, drawable, x, y, width, height, planeMask, format)
#define X11_GetPixel(image, x, y)	(long)XGetPixel(image, x, y)
#define X11_GetSelectionOwner(display, selection)	(long)XGetSelectionOwner(display, selection)
#define X11_GetSubImage(display, drawable, x, y, width, height, planeMask, format, dstImage, dstX, dstY)	(long)XGetSubImage(display, drawable, x, y, width, height, planeMask, format, dstImage, dstX, dstY)
#define X11_GetWindowProperty(display, window, property, offset, length, delete, reqtype, type, format, nitems, bytesafter, prop)	XGetWindowProperty(display, window, property, offset, length, delete, reqtype, type, format, nitems, bytesafter, prop)
#define X11_InstallColormap(display, cmap)	XInstallColormap(display, cmap)
#define X11_InternAtom(display, name, onlyifexists)	(long)XInternAtom(display, name, onlyifexists)
#define X11_ListFonts(display, pattern, maxnames, count)	(long)XListFonts(display, pattern, maxnames, count)
#define X11_LoadFont(display, name)	(long)XLoadFont(display, name)
#define X11_LookupString(event, buffer, bufsize, keysym, compstatus)	(long)XLookupString(event, buffer, bufsize, keysym, compstatus)
#define X11_LowerWindow(display, window)	XLowerWindow(display, window)
#define X11_MapRaised(display, window)	XMapRaised(display, window)
#define X11_MatchVisualInfo(display, screen, depth, class, vinforet)	(long)XMatchVisualInfo(display, screen, depth, class, vinforet)
#define X11_MoveResizeWindow(display, window, x, y, width, height)	XMoveResizeWindow(display, window, x, y, width, height)
#define X11_NextEvent(display, event)	XNextEvent(display, event)
#define X11_OpenDisplay(name, name__len)	(long)XOpenDisplay(name)
#define X11_PutImage(display, drawable, gc, image, srcX, srcY, dstX, dstY, width, height)	XPutImage(display, drawable, gc, image, srcX, srcY, dstX, dstY, width, height)
#define X11_PutPixel(image, x, y, pixel)	(long)XPutPixel(image, x, y, pixel)
#define X11_QueryBestSize(display, class, screen, width, height, w, h)	XQueryBestSize(display, class, screen, width, height, w, h)
#define X11_QueryPointer(display, window, rw, cw, xr, yr, xw, yw, keysButtons)	XQueryPointer(display, window, rw, cw, xr, yr, xw, yw, keysButtons)
#define X11_RebindKeysym(display, reboundsym, modlist, modlength, newstring, newlength)	XRebindKeysym(display, reboundsym, modlist, modlength, newstring, newlength)
#define X11_RecolorCursor(display, curs, cfore, cback)	XRecolorCursor(display, curs, cfore, cback)
#define X11_RefreshKeyboardMapping(event)	XRefreshKeyboardMapping(event)
#define X11_ResizeWindow(display, window, x, y)	XResizeWindow(display, window, x, y)
#define X11_SelectInput(display, window, eventMask)	XSelectInput(display, window, eventMask)
#define X11_SendEvent(display, window, propagate, eventmask, event)	XSendEvent(display, window, propagate, eventmask, event)
#define X11_SetArcMode(display, gc, arcmode)	XSetArcMode(display, gc, arcmode)
#define X11_SetBackground(display, gc, arg)	XSetBackground(display, gc, arg)
#define X11_SetClipMask(display, gc, clipMask)	XSetClipMask(display, gc, clipMask)
#define X11_SetClipRectangles(display, gc, clipxorigin, clipyorigin, rectangles, n, ordering)	XSetClipRectangles(display, gc, clipxorigin, clipyorigin, rectangles, n, ordering)
#define X11_SetCommand(display, window, argv, argc)	XSetCommand(display, window, argv, argc)
#define X11_SetErrorHandler(handler)	XSetErrorHandler(handler)
#define X11_SetFillStyle(display, gc, arg)	XSetFillStyle(display, gc, arg)
#define X11_SetFont(display, gc, arg)	XSetFont(display, gc, arg)
#define X11_SetForeground(display, gc, arg)	XSetForeground(display, gc, arg)
#define X11_SetFunction(display, gc, arg)	XSetFunction(display, gc, arg)
#define X11_SetGraphicsExposures(display, gc, graphicsExposures)	XSetGraphicsExposures(display,gc, graphicsExposures )
#define X11_SetIOErrorHandler(handler)	XSetIOErrorHandler(handler)
#define X11_SetIconName(display, window, name)	XSetIconName(display, window, name)
#define X11_SetInputFocus(display, focus, revertTo, time)	XSetInputFocus(display, focus, revertTo, time)
#define X11_SetLineAttributes(display, gc, lineWidth, lineStyle, capStyle, joinStyle)	XSetLineAttributes(display, gc, lineWidth, lineStyle, capStyle, joinStyle)
#define X11_SetPlaneMask(display, gc, mask)	XSetPlaneMask(display, gc, mask)
#define X11_SetSelectionOwner(display, selection, owner, time)	XSetSelectionOwner(display, selection, owner, time)
#define X11_SetStipple(display, gc, stipple)	XSetStipple(display, gc, stipple)
#define X11_SetTSOrigin(display, gc, tsxorigin, tsyorigin)	XSetTSOrigin(display, gc, tsxorigin, tsyorigin)
#define X11_SetWindowBackground(display, window, pixel)	XSetWindowBackground(display, window, pixel)
#define X11_SetWindowColormap(display, window, cmap)	XSetWindowColormap(display, window, cmap)
#define X11_StoreBytes(display, bytes, nbytes)	XStoreBytes(display, bytes, nbytes)
#define X11_StoreColor(display, cmap, color)	XStoreColor(display, cmap, color)
#define X11_StoreName(display, window, name)	XStoreName(display, window, name)
#define X11_StringToKeysym(string)	(long)XStringToKeysym(string)
#define X11_SubImage(image, x, y, width, height)	(long)XSubImage(image, x, y, width, height)
#define X11_Sync(display, discard)	XSync(display, discard)
#define X11_TranslateCoordinates(display, sw, dw, srcx, srcy, dstx, dsty, child)	XTranslateCoordinates(display, sw, dw, srcx, srcy, dstx, dsty, child)
#define X11_WarpPointer(display, srcwin, dstwin, srcx, srcy, srcw, srch, dstx, dsty)	XWarpPointer(display, srcwin, dstwin, srcx, srcy, srcw, srch, dstx, dsty)
#define X11_WhitePixel(display, screen)	(long)XWhitePixel(display, screen)

LONGINT X11_NewPattern (SET *image, LONGINT image__len, LONGINT class, INTEGER width, INTEGER height)
{
	LONGINT pixmap = 0;
	X11_PatternPtr pat = NIL;
	LONGINT w = 0, h = 0, i = 0, j = 0, b = 0, dest = 0, srcw = 0, destb = 0, srci = 0, desti = 0;
	CHAR data[8192];
	i = 0;
	while (i < 8192) {
		data[__X(i, 8192)] = 0x00;
		i += 1;
	}
	w = width;
	h = height;
	srcw = __ASHR(width + 31, 5);
	destb = __ASHR(w + 7, 3);
	srci = (LONGINT)(height - 1) * srcw;
	desti = 0;
	while (srci >= 0) {
		i = 0;
		j = 0;
		b = 0;
		dest = 0;
		for (;;) {
			dest = __ASHR(dest, 1);
			if (__IN(b, image[__X((srci + j) + 1, image__len)])) {
				dest += 128;
			}
			b += 1;
			if (__MASK(b, -8) == 0) {
				data[__X(desti + i, 8192)] = (CHAR)dest;
				i += 1;
				dest = 0;
				if (i >= destb) {
					break;
				}
			}
			if (b == 32) {
				b = 0;
				j += 1;
				if (j >= srcw) {
					while (i < destb) {
						data[__X(desti + i, 8192)] = 0x00;
						i += 1;
					}
					break;
				}
			}
		}
		desti += destb;
		srci -= srcw;
	}
	Kernel_Lock();
	pixmap = X11_CreateBitmapFromData(X11_display, X11_primary, (LONGINT)&data[0], w, h);
	Kernel_Unlock();
	if (pixmap == 0) {
		__HALT(99);
	}
	pat = (X11_PatternPtr)Kernel_malloc(16);
	pat->x = 0;
	pat->y = 0;
	pat->w = width;
	pat->h = height;
	pat->pixmap = pixmap;
	return (LONGINT)pat;
}

LONGINT X11_RasterToPixmap (LONGINT base, LONGINT width, LONGINT height)
{
	LONGINT pixmap = 0;
	Kernel_Lock();
	pixmap = X11_CreateBitmapFromData(X11_display, X11_primary, base, width, height);
	Kernel_Unlock();
	if (pixmap == 0) {
		__HALT(99);
	}
	return pixmap;
}

void X11_SetColor (INTEGER col, INTEGER red, INTEGER green, INTEGER blue)
{
	X11_Color xcol = {0}, cfore = {0}, cback = {0};
	CHAR error[15];
	Kernel_Lock();
	if (X11_depth == 24) {
		X11_pixelValues[__X(col, 256)] = (__ASHL((LONGINT)red, 16) + __ASHL((LONGINT)green, 8)) + __ASHL((LONGINT)blue, 0);
	} else if (X11_depth == 16) {
		X11_pixelValues[__X(col, 256)] = (__ASHL(__ASHR((LONGINT)red, 3), 11) + __ASHL(__ASHR((LONGINT)green, 2), 5)) + __ASHL(__ASHR((LONGINT)blue, 3), 0);
	}
	if (X11_colorClass == 1) {
		green = red;
		blue = red;
	}
	X11_RGB[__X(col + 1, 257)].r = red;
	X11_RGB[__X(col + 1, 257)].g = green;
	X11_RGB[__X(col + 1, 257)].b = blue;
	if (X11_colorClass != 0 && col >= 0) {
		xcol.red = __ASHL(red, 8);
		xcol.green = __ASHL(green, 8);
		xcol.blue = __ASHL(blue, 8);
		xcol.flags = 0x07;
		xcol.pixel = X11_pixelValues[__X(col, 256)];
		if ((LONGINT)col < X11_nofcol) {
			X11_StoreColor(X11_display, X11_cmap, (LONGINT)&xcol);
		} else {
			Console_String((CHAR*)"out of colors; try option -c", (LONGINT)29);
			Console_Ln();
		}
		if ((col == 0 || col == 15) && X11_arrow != 0) {
			cfore.red = __ASHL(X11_RGB[16].r, 8);
			cfore.green = __ASHL(X11_RGB[16].g, 8);
			cfore.blue = __ASHL(X11_RGB[16].b, 8);
			cback.red = __ASHL(X11_RGB[1].r, 8);
			cback.green = __ASHL(X11_RGB[1].g, 8);
			cback.blue = __ASHL(X11_RGB[1].b, 8);
			X11_RecolorCursor(X11_display, X11_arrow, (LONGINT)&cfore, (LONGINT)&cback);
		}
	}
	Kernel_Unlock();
}

void X11_GetColor (INTEGER col, INTEGER *red, INTEGER *green, INTEGER *blue)
{
	*red = X11_RGB[__X(col + 1, 257)].r;
	*green = X11_RGB[__X(col + 1, 257)].g;
	*blue = X11_RGB[__X(col + 1, 257)].b;
}

void X11_FlushLCache (void)
{
	LONGINT gc = 0, window = 0;
	Kernel_Lock();
	gc = X11_Gc;
	if (X11_lcmode == 1) {
		X11_lcmode = 0;
	}
	if (X11_lcmode != X11_lastmode) {
		X11_SetFunction(X11_display, gc, X11_function[__X(X11_lcmode, 3)]);
		X11_lastmode = X11_lcmode;
	}
	if (X11_lccol != X11_lastcol) {
		X11_SetForeground(X11_display, gc, X11_pixelValues[__X(X11_lccol, 256)]);
		X11_lastcol = X11_lccol;
	}
	if (X11_lcf != X11_lastfont) {
		X11_SetFont(X11_display, gc, X11_lcf->xid);
		X11_lastfont = X11_lcf;
	}
	if (X11_lcy0 >= 0) {
		window = X11_primary;
	} else {
		window = X11_secondary;
		X11_lcy0 -= X11_UBottom;
	}
	X11_DrawString(X11_display, window, gc, X11_lcx0, X11_Height - X11_lcy0, (LONGINT)X11_lcache, X11_lclen);
	X11_lclen = 0;
	Kernel_Unlock();
}

void X11_DoSync (void)
{
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	Kernel_Lock();
	X11_Sync(X11_display, 0);
	Kernel_Unlock();
}

void X11_DoFlush (void)
{
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	Kernel_Lock();
	X11_Flush(X11_display);
	Kernel_Unlock();
}

void X11_Rebind (CHAR *keyString, LONGINT keyString__len, X11_Modlist modifierStrings, LONGINT nofmod, CHAR *to, LONGINT to__len, LONGINT nofchar)
{
	LONGINT modlist[8];
	LONGINT i = 0;
	__DUP(keyString, keyString__len, CHAR);
	__DUP(to, to__len, CHAR);
	i = 0;
	while (i < nofmod) {
		modlist[__X(i, 8)] = X11_StringToKeysym((LONGINT)modifierStrings[__X(i, 8)]);
		i += 1;
	}
	X11_RebindKeysym(X11_display, X11_StringToKeysym((LONGINT)keyString), (LONGINT)modlist, nofmod, (LONGINT)to, nofchar);
	__DEL(keyString);
	__DEL(to);
}

static void X11_InitNames (void)
{
	INTEGER i = 0, j = 0;
	__MOVE("ETH-Oberon (TM)", X11_WinName, 16);
	Args_Get(Args_Pos((CHAR*)"-title", (LONGINT)7) + 1, (void*)X11_WinName, 128);
	__MOVE("oberon", X11_IconName, 7);
	Args_Get(Args_Pos((CHAR*)"-title", (LONGINT)7) + 1, (void*)X11_IconName, 128);
	__MOVE("  -  Copyright (c) 1991-95, ETH Zurich.", X11_Copyright, 40);
	__MOVE("ETH-Oberon (TM)", X11_WinNameCopyright, 16);
	i = 0;
	while (X11_WinNameCopyright[__X(i, 128)] != 0x00) {
		i += 1;
	}
	j = 0;
	do {
		X11_WinNameCopyright[__X(i, 128)] = X11_Copyright[__X(j, 128)];
		i += 1;
		j += 1;
	} while (!(X11_Copyright[__X(j - 1, 128)] == 0x00));
}

static struct OpenDisp__76 {
	CHAR (*defgeo)[64];
	INTEGER *i;
	struct OpenDisp__76 *lnk;
} *OpenDisp__76_s;

static void Int__77 (LONGINT n);

static void Int__77 (LONGINT n)
{
	INTEGER j = 0;
	j = 64;
	while (n > 0) {
		j -= 1;
		(*OpenDisp__76_s->defgeo)[__X(j, 64)] = (CHAR)(__MOD(n, 10) + 48);
		n = __DIV(n, 10);
	}
	while (j < 64) {
		(*OpenDisp__76_s->defgeo)[__X(*OpenDisp__76_s->i, 64)] = (*OpenDisp__76_s->defgeo)[__X(j, 64)];
		*OpenDisp__76_s->i += 1;
		j += 1;
	}
}

static void X11_OpenDisp (void)
{
	LONGINT child = 0, flagmask = 0, fd = 0;
	X11_Event event = {0};
	LONGINT gRoot = 0, gX = 0, gY = 0, gW = 0, gH = 0, gBW = 0, gD = 0, offset = 0;
	CHAR defgeo[64];
	INTEGER i = 0;
	CHAR displayArg[256], geometryArg[256];
	BOOLEAN coption = 0;
	struct OpenDisp__76 _s;
	_s.defgeo = (void*)defgeo;
	_s.i = &i;
	_s.lnk = OpenDisp__76_s;
	OpenDisp__76_s = &_s;
	displayArg[0] = 0x00;
	geometryArg[0] = 0x00;
	Args_Get(Args_Pos((CHAR*)"-d", (LONGINT)3) + 1, (void*)displayArg, 256);
	Args_Get(Args_Pos((CHAR*)"-g", (LONGINT)3) + 1, (void*)geometryArg, 256);
	X11_display = X11_OpenDisplay(displayArg, 256);
	if (X11_display == 0) {
		Console_String((CHAR*)"Cannot open display", (LONGINT)20);
		Console_Ln();
		Kernel_Exit(1);
	}
	__GET(X11_display + 8, fd, LONGINT);
	Kernel_readSet[0] |= __SETOF(fd);
	X11_screen = X11_DefaultScreen(X11_display);
	X11_screenw = X11_DisplayWidth(X11_display, X11_screen);
	X11_screenh = X11_DisplayHeight(X11_display, X11_screen);
	X11_screenhmm = X11_DisplayHeightMM(X11_display, X11_screen);
	X11_depth = (int)X11_DefaultDepth(X11_display, X11_screen);
	X11_visualptr = X11_DefaultVisual(X11_display, X11_screen);
	X11_defvisualptr = X11_visualptr;
	X11_cmap = X11_DefaultColormap(X11_display, X11_screen);
	X11_defcmap = X11_cmap;
	X11_cells = X11_DisplayCells(X11_display, X11_screen);
	X11_planes = X11_DisplayPlanes(X11_display, X11_screen);
	X11_foreground = X11_BlackPixel(X11_display, X11_screen);
	X11_background = X11_WhitePixel(X11_display, X11_screen);
	X11_root = X11_DefaultRootWindow(X11_display);
	i = 0;
	Int__77(X11_screenw - 8);
	defgeo[__X(i, 64)] = 'x';
	i += 1;
	Int__77((X11_screenh - 23) - 4);
	defgeo[__X(i, 64)] = '+';
	i += 1;
	Int__77(4);
	defgeo[__X(i, 64)] = '+';
	i += 1;
	Int__77(23);
	defgeo[__X(i, 64)] = 0x00;
	flagmask = X11_Geometry(X11_display, X11_screen, geometryArg, 256, defgeo, 64, 0, 1, 1, 0, 0, &gX, &gY, &gW, &gH);
	X11_primary = X11_CreateSimpleWindow(X11_display, X11_root, gX, gY, gW, gH, 0, X11_foreground, X11_background);
	X11_StoreName(X11_display, X11_primary, (LONGINT)X11_WinNameCopyright);
	X11_SetIconName(X11_display, X11_primary, (LONGINT)X11_IconName);
	X11_SetCommand(X11_display, X11_primary, Args_argv, Args_argc);
	X11_SelectInput(X11_display, X11_primary, 32768);
	X11_MapRaised(X11_display, X11_primary);
	do {
		X11_NextEvent(X11_display, (LONGINT)&event);
	} while (!(event.type == 12 && event.window == X11_primary));
	X11_GetGeometry(X11_display, X11_primary, &gRoot, &gX, &gY, &gW, &gH, &gBW, &gD);
	if (__MASK(gW, -8) != 0) {
		gW -= __MASK(gW, -8);
		X11_ResizeWindow(X11_display, X11_primary, gW, gH);
	}
	X11_Width = (int)gW;
	X11_Height = (int)gH;
	X11_Bottom = 0;
	X11_UBottom = -X11_Height;
	if (gW > X11_screenw) {
		gW = (int)X11_screenw;
	}
	if (gH > X11_screenh) {
		gH = (int)X11_screenh;
	}
	X11_secondary = X11_CreatePixmap(X11_display, X11_primary, gW, gH, X11_depth);
	OpenDisp__76_s = _s.lnk;
}

static void X11_CreateColors (void)
{
	INTEGER col = 0;
	LONGINT planeMasks[8];
	X11_VisualInfo visualInfo = {0};
	X11_VisualPtr vis = NIL;
	BOOLEAN coption = 0;
	coption = (LONGINT)Args_Pos((CHAR*)"-c", (LONGINT)3) < Args_argc;
	col = 0;
	while (col < 256) {
		X11_pixelValues[__X(col, 256)] = col;
		col += 1;
	}
	if (!coption && X11_depth <= 4) {
		X11_colorClass = 0;
	} else if (X11_MatchVisualInfo(X11_display, X11_screen, X11_depth, 3, (LONGINT)&visualInfo) == 1) {
		X11_colorClass = 2;
		X11_visualptr = visualInfo.visual;
	} else if (X11_MatchVisualInfo(X11_display, X11_screen, X11_depth, 1, (LONGINT)&visualInfo) == 1) {
		X11_colorClass = 1;
		X11_visualptr = visualInfo.visual;
	} else {
		X11_colorClass = 0;
	}
	if (X11_colorClass == 0) {
		X11_ColLeft = X11_Width;
		X11_nofcol = 2;
		X11_basePixel = (LONGINT)((SET)X11_foreground & (SET)X11_background);
		X11_planesMask = (LONGINT)((SET)X11_foreground ^ (SET)X11_background);
		X11_colorClass = 0;
		X11_pixelValues[0] = X11_background;
		X11_pixelValues[15] = X11_foreground;
		col = 1;
		while (col <= 14) {
			X11_pixelValues[__X(col, 256)] = X11_foreground;
			col += 1;
		}
	} else {
		X11_ColLeft = 0;
		vis = (X11_VisualPtr)X11_visualptr;
		if (coption) {
			X11_nofcol = vis->mapEntries;
			X11_cmap = X11_CreateColormap(X11_display, X11_primary, X11_visualptr, 1);
			X11_SetWindowColormap(X11_display, X11_primary, X11_cmap);
			X11_basePixel = 0;
			X11_planesMask = __ASH(1, X11_depth) - 1;
		} else {
			X11_nofcol = 16;
			if (X11_AllocColorCells(X11_display, X11_cmap, 0, (LONGINT)planeMasks, 4, (LONGINT)&X11_basePixel, 1) == 0) {
				Console_String((CHAR*)"Not enough color cells", (LONGINT)23);
				Console_Ln();
				Console_String((CHAR*)"Try option -c to allocate a private colormap", (LONGINT)45);
				Console_Ln();
				Kernel_Exit(1);
			}
			col = 0;
			X11_planesMask = 0;
			while (col < 4) {
				X11_planesMask = X11_planesMask + planeMasks[__X(col, 8)];
				col += 1;
			}
			col = 0;
			while (col < 16) {
				X11_pixelValues[__X(col, 256)] = (((X11_basePixel + (LONGINT)__MASK(col, -2) * planeMasks[0]) + (LONGINT)__MASK(__ASHR(col, 1), -2) * planeMasks[1]) + (LONGINT)__MASK(__ASHR(col, 2), -2) * planeMasks[2]) + (LONGINT)__MASK(__ASHR(col, 3), -2) * planeMasks[3];
				col += 1;
			}
		}
		X11_foreground = X11_pixelValues[15];
		X11_background = X11_pixelValues[0];
		X11_SetWindowBackground(X11_display, X11_primary, X11_background);
		X11_ClearWindow(X11_display, X11_primary);
	}
}

static void X11_CreateGc (void)
{
	X11_function[0] = 3;
	X11_function[1] = 7;
	if (((SET)X11_background & (SET)X11_planesMask) != 0x0) {
		X11_function[2] = 9;
	} else {
		X11_function[2] = 6;
	}
	X11_Gc = X11_CreateGC(X11_display, X11_primary, 0, 0);
	if (X11_Gc == 0) {
		Console_String((CHAR*)"Cannot create X graphic context", (LONGINT)32);
		Console_Ln();
		Kernel_Exit(1);
	}
	X11_SetPlaneMask(X11_display, X11_Gc, X11_planesMask);
	X11_SetGraphicsExposures(X11_display, X11_Gc, 1);
	X11_SetBackground(X11_display, X11_Gc, X11_background);
	X11_lastcol = -1;
	X11_lastmode = -1;
	X11_lastfont = NIL;
}

void X11_InitColors (void)
{
	INTEGER col = 0, colScale = 0;
	if (X11_colorClass == 1) {
		col = 0;
		while (col <= 15) {
			X11_SetColor(col, 255 - 17 * col, 0, 0);
			col += 1;
		}
	} else {
		colScale = 1;
		X11_SetColor(15, 0, 0, 0);
		X11_SetColor(0, 255, 255, 255);
		X11_SetColor(1, __DIV(255, colScale), __DIV(0, colScale), __DIV(0, colScale));
		X11_SetColor(2, __DIV(0, colScale), __DIV(255, colScale), __DIV(0, colScale));
		X11_SetColor(3, __DIV(0, colScale), __DIV(0, colScale), __DIV(255, colScale));
		X11_SetColor(4, __DIV(255, colScale), __DIV(0, colScale), __DIV(255, colScale));
		X11_SetColor(5, __DIV(255, colScale), __DIV(255, colScale), __DIV(0, colScale));
		X11_SetColor(6, __DIV(0, colScale), __DIV(255, colScale), __DIV(255, colScale));
		X11_SetColor(7, __DIV(128, colScale), __DIV(0, colScale), __DIV(0, colScale));
		X11_SetColor(8, __DIV(0, colScale), __DIV(128, colScale), __DIV(0, colScale));
		X11_SetColor(9, __DIV(0, colScale), __DIV(0, colScale), __DIV(128, colScale));
		X11_SetColor(10, __DIV(166, colScale), __DIV(202, colScale), __DIV(240, colScale));
		X11_SetColor(11, __DIV(0, colScale), __DIV(128, colScale), __DIV(128, colScale));
		X11_SetColor(12, __DIV(192, colScale), __DIV(192, colScale), __DIV(192, colScale));
		X11_SetColor(13, __DIV(160, colScale), __DIV(160, colScale), __DIV(160, colScale));
		X11_SetColor(14, __DIV(128, colScale), __DIV(128, colScale), __DIV(128, colScale));
	}
}

static void X11_CreatePatterns (void)
{
	SET image[17];
	INTEGER i = 0;
	image[1] = 0x0;
	image[2] = 0x2000;
	image[3] = 0x7000;
	image[4] = 0x3800;
	image[5] = 0x1c00;
	image[6] = 0x0e00;
	image[7] = 0x0700;
	image[8] = 0x0382;
	image[9] = 0x01c6;
	image[10] = 0xee;
	image[11] = 0x7e;
	image[12] = 0x3e;
	image[13] = 0x7e;
	image[14] = 0xfe;
	image[15] = 0x01fe;
	image[16] = 0x0;
	X11_arrowSource = X11_NewPattern((void*)image, 17, 0, 16, 16);
	image[1] = 0x2000;
	image[2] = 0x7000;
	image[3] = 0xf800;
	image[4] = 0x7c00;
	image[5] = 0x3e00;
	image[6] = 0x1f00;
	image[7] = 0x0f83;
	image[8] = 0x07c7;
	image[9] = 0x03ef;
	image[10] = 0x01ff;
	image[11] = 0xff;
	image[12] = 0x7f;
	image[13] = 0xff;
	image[14] = 0x01ff;
	image[15] = 0x03ff;
	image[16] = 0x03ff;
	X11_arrowMask = X11_NewPattern((void*)image, 17, 0, 16, 16);
	i = 1;
	while (i < 17) {
		image[__X(i, 17)] = 0x0;
		i += 1;
	}
	X11_noCursorSource = X11_NewPattern((void*)image, 17, 0, 16, 16);
	X11_noCursorMask = X11_NewPattern((void*)image, 17, 0, 16, 16);
}

static void X11_InitCursors (void)
{
	X11_Color cfore = {0}, cback = {0};
	X11_PatternPtr csource = NIL, cmask = NIL;
	cfore.red = __ASHL(X11_RGB[16].r, 8);
	cfore.green = __ASHL(X11_RGB[16].g, 8);
	cfore.blue = __ASHL(X11_RGB[16].b, 8);
	cback.red = __ASHL(X11_RGB[1].r, 8);
	cback.green = __ASHL(X11_RGB[1].g, 8);
	cback.blue = __ASHL(X11_RGB[1].b, 8);
	csource = (X11_PatternPtr)X11_arrowSource;
	cmask = (X11_PatternPtr)X11_arrowMask;
	X11_arrow = X11_CreatePixmapCursor(X11_display, csource->pixmap, cmask->pixmap, (LONGINT)&cfore, (LONGINT)&cback, 1, 1);
	csource = (X11_PatternPtr)X11_noCursorSource;
	cmask = (X11_PatternPtr)X11_noCursorMask;
	X11_noCursor = X11_CreatePixmapCursor(X11_display, csource->pixmap, cmask->pixmap, (LONGINT)&cfore, (LONGINT)&cback, 1, 1);
}

LONGINT X11_MyErrorHandler (LONGINT display, X11_ErrorEventPtr err)
{
	X11_ErrorFlag = 1;
	X11_GetErrorText(display, (int)err->errorCode, (LONGINT)X11_ErrorText, 80);
	return 0;
}

static LONGINT X11_MyIOErrorHandler (LONGINT display)
{
	X11_ErrorFlag = 1;
	Kernel_Exit(0);
	__RETCHK;
}

static void EnumPtrs(void (*P)(void*))
{
	P(X11_ccf);
	P(X11_lcf);
	P(X11_lastfont);
}

__TDESC(X11_PatternDesc, 1, 0) = {__TDFLDS("PatternDesc", 16), {-4}};
__TDESC(X11_MetricDesc, 1, 0) = {__TDFLDS("MetricDesc", 24), {-4}};
__TDESC(X11_Bytes, 1, 0) = {__TDFLDS("Bytes", 6148), {-4}};
__TDESC(X11_Visual, 1, 0) = {__TDFLDS("Visual", 32), {-4}};
__TDESC(X11_VisualInfo, 1, 0) = {__TDFLDS("VisualInfo", 40), {-4}};
__TDESC(X11_Color, 1, 0) = {__TDFLDS("Color", 12), {-4}};
__TDESC(X11_Point, 1, 0) = {__TDFLDS("Point", 4), {-4}};
__TDESC(X11_Rectangle, 1, 0) = {__TDFLDS("Rectangle", 8), {-4}};
__TDESC(X11_Event, 1, 0) = {__TDFLDS("Event", 196), {-4}};
__TDESC(X11_SelectionEvent, 1, 0) = {__TDFLDS("SelectionEvent", 36), {-4}};
__TDESC(X11_SelectionRequestEvent, 1, 0) = {__TDFLDS("SelectionRequestEvent", 40), {-4}};
__TDESC(X11_ImageDesc, 1, 0) = {__TDFLDS("ImageDesc", 88), {-4}};
__TDESC(X11_ErrorEvent, 1, 0) = {__TDFLDS("ErrorEvent", 20), {-4}};
__TDESC(X11__1, 1, 0) = {__TDFLDS("", 6), {-4}};

export void *X11__init(void)
{
	__DEFMOD;
	__IMPORT(Args);
	__IMPORT(Console);
	__IMPORT(Kernel);
	__REGMOD(X11, EnumPtrs);
	__REGCMD("DoFlush", X11_DoFlush);
	__REGCMD("DoSync", X11_DoSync);
	__REGCMD("FlushLCache", X11_FlushLCache);
	__REGCMD("InitColors", X11_InitColors);
	__INITYP(X11_PatternDesc, X11_PatternDesc, 0);
	__INITYP(X11_MetricDesc, X11_MetricDesc, 0);
	__INITYP(X11_Bytes, X11_Bytes, 0);
	__INITYP(X11_Visual, X11_Visual, 0);
	__INITYP(X11_VisualInfo, X11_VisualInfo, 0);
	__INITYP(X11_Color, X11_Color, 0);
	__INITYP(X11_Point, X11_Point, 0);
	__INITYP(X11_Rectangle, X11_Rectangle, 0);
	__INITYP(X11_Event, X11_Event, 0);
	__INITYP(X11_SelectionEvent, X11_SelectionEvent, 0);
	__INITYP(X11_SelectionRequestEvent, X11_SelectionRequestEvent, 0);
	__INITYP(X11_ImageDesc, X11_ImageDesc, 0);
	__INITYP(X11_ErrorEvent, X11_ErrorEvent, 0);
	__INITYP(X11__1, X11__1, 0);
/* BEGIN */
	X11_backgroundCol = 0;
	X11_foregroundCol = 15;
	X11_InitNames();
	X11_OpenDisp();
	X11_CreateColors();
	X11_CreateGc();
	X11_InitColors();
	X11_CreatePatterns();
	X11_InitCursors();
	X11_DefineCursor(X11_display, X11_primary, X11_arrow);
	X11_lclen = 0;
	X11_ErrorFlag = 0;
	X11_SetIOErrorHandler(X11_MyIOErrorHandler);
	__ENDMOD;
}
