/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"




export TextFrames_Frame XIn_FocusFrame (BOOLEAN needsCaret);
export void XIn_GetArg (Texts_Scanner *S, LONGINT *S__typ);
export void XIn_GetMainArg (Texts_Scanner *S, LONGINT *S__typ);
export void XIn_GetSelectionViewer (Viewers_Viewer *vwr, Texts_Text *text, LONGINT *time, LONGINT *beg, LONGINT *end);
export TextFrames_Frame XIn_MarkedFrame (void);
export void XIn_OpenTempViewer (Texts_Text t, MenuViewers_Viewer *v);
export TextFrames_Frame XIn_TargetFrame (BOOLEAN needsCaret);
export void XIn_UnmarkMenu (Viewers_Viewer V);


TextFrames_Frame XIn_MarkedFrame (void)
{
	Viewers_Viewer v = NIL;
	v = Oberon_MarkedViewer();
	if ((v != NIL && __ISP(v, MenuViewers_ViewerDesc, 2)) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		return __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

TextFrames_Frame XIn_FocusFrame (BOOLEAN needsCaret)
{
	Viewers_Viewer v = NIL;
	TextFrames_Frame f = NIL;
	v = Oberon_FocusViewer;
	if ((((v != NIL && __ISP(v, MenuViewers_ViewerDesc, 2)) && v->dsc != NIL) && v->dsc->next != NIL) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
		if (needsCaret) {
			if (f->hasCar) {
				return f;
			} else {
				return NIL;
			}
		} else {
			return f;
		}
	} else {
		return NIL;
	}
	__RETCHK;
}

TextFrames_Frame XIn_TargetFrame (BOOLEAN needsCaret)
{
	Display_Frame f = NIL;
	if (Oberon_Par->vwr->dsc == Oberon_Par->frame) {
		f = Oberon_Par->frame->next;
		if (f != NIL && __ISP(f, TextFrames_FrameDesc, 1)) {
			return __GUARDP(f, TextFrames_FrameDesc, 1);
		} else {
			return NIL;
		}
	} else {
		return XIn_FocusFrame(needsCaret);
	}
	__RETCHK;
}

void XIn_GetMainArg (Texts_Scanner *S, LONGINT *S__typ)
{
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, text, beg);
			Texts_Scan(&*S, S__typ);
		}
	}
	if ((*S).line != 0) {
		(*S).class = 0;
	}
}

void XIn_GetArg (Texts_Scanner *S, LONGINT *S__typ)
{
	TextFrames_Frame F = NIL;
	Texts_OpenScanner(&*S, S__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '^') {
		F = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1);
		if (F->hasSel) {
			Texts_OpenScanner(&*S, S__typ, F->text, F->selbeg.pos);
			Texts_Scan(&*S, S__typ);
			F->time = 0;
		}
	}
}

void XIn_OpenTempViewer (Texts_Text t, MenuViewers_Viewer *v)
{
	INTEGER x = 0, y = 0, h = 0;
	y = Display_Bottom;
	x = Display_Width - 1;
	h = Viewers_minH;
	Viewers_minH = 1;
	*v = MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"", (LONGINT)1, (CHAR*)"", (LONGINT)1), (void*)TextFrames_NewText(t, 0), TextFrames_menuH, x, y);
	Oberon_Pointer.X = x;
	Oberon_Pointer.Y = y;
	Viewers_minH = h;
}

void XIn_UnmarkMenu (Viewers_Viewer V)
{
	Texts_Reader R = {0};
	Texts_Text T = NIL;
	CHAR ch = 0;
	T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
	Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	if (ch == '!') {
		Texts_Delete(T, T->len - 1, T->len);
	}
}

void XIn_GetSelectionViewer (Viewers_Viewer *vwr, Texts_Text *text, LONGINT *time, LONGINT *beg, LONGINT *end)
{
	Texts_Text selText = NIL, t2 = NIL;
	LONGINT selBeg = 0, selEnd = 0, selTime = 0, beg2 = 0, end2 = 0, time2 = 0;
	INTEGER left = 0;
	Viewers_Viewer cur = NIL;
	Oberon_SelectionMsg m = {0};
	Oberon_GetSelection(&selText, &selBeg, &selEnd, &selTime);
	m.time = -1;
	m.text = NIL;
	if (selTime >= 0) {
		left = 0;
		while (left < Display_Width) {
			cur = Viewers_This(left, 0);
			while (cur->state != 1) {
				(*cur->handle)((void*)cur, (void*)&m, Oberon_SelectionMsg__typ);
				if (((m.time == selTime && m.text == selText) && m.beg == selBeg) && m.end == selEnd) {
					*text = selText;
					*time = selTime;
					*beg = selBeg;
					*end = selEnd;
					*vwr = cur;
					return;
				}
				cur = Viewers_Next(cur);
			}
			left = left + cur->W;
		}
	}
	*vwr = NIL;
	*text = NIL;
	*time = -1;
	*beg = 0;
	*end = 0;
}


export void *XIn__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(XIn, 0);
/* BEGIN */
	__ENDMOD;
}
